package com.xrefactory.jedit;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

class MoveDialog extends JDialog {

	public static class MovePanel extends JPanel implements KeyListener,FocusListener {

		String		continuationOption;
		String		contTestOption;

		String 		stext=""; // just to verify if is not modified

		String 		sfile;
		int			sline;
		int			scaret;

		JTextField 	ssfile;
		JTextField	ssline;

		JTextField 	tfile;
		JTextField	tline;

		class ButtonImport extends JButton implements ActionListener {
			ButtonImport() {super("Import position from jEdit"); addActionListener(this);}
			public void actionPerformed( ActionEvent e) {
				actionImport();
			}
		}
		class ButtonCancel extends JButton implements ActionListener {
			ButtonCancel() {super("Cancel"); addActionListener(this);}
			public void actionPerformed( ActionEvent e) {
				actionCancel();
			}
		}
		class ButtonContinue extends JButton implements ActionListener {
			ButtonContinue() {super("Continue"); addActionListener(this);}
			public void actionPerformed( ActionEvent e) {
				actionContinue();
			}
		}

		void actionContinue() {
			int line = s.getTextArea().getCaretLine();
			int lboffset = s.getTextArea().getLineStartOffset(line);
			if (lboffset != s.getTextArea().getCaretPosition()) {
				JOptionPane.showMessageDialog(s.view, "Target position has to be at the begining of line, moving it.", "Xrefactory Warning", JOptionPane.WARNING_MESSAGE);				
				s.getTextArea().setCaretPosition(s.getTextArea().getLineStartOffset(line));
			}
			// check target position
			DispatchData ndata = new DispatchData(s.xbTask, this);			
			XrefCharBuffer receipt = ndata.xTask.callProcessOnFileSingleOpt(contTestOption, ndata);
			Dispatch.dispatch(receipt, ndata);
			if (! s.panic) {
				s.getParentDialog(this).setVisible(false);
				s.targetFile = tfile.getText();
				s.targetLine = Integer.parseInt(tline.getText());
				s.moveToPosition(s.view, sfile, scaret);
				if (stext.equals(s.getTextArea().getText())) {
					stext = "";	// free memory
					if (s.targetLine>0 && !s.targetFile.equals("")) {
						XrefStringArray xroption = new XrefStringArray();
						xroption.add(continuationOption);
						xroption.add("-movetargetfile="+s.targetFile);
						xroption.add("-rfct-param1="+s.targetLine);
						Refactorings.mainRefactorerInvocation(xroption,false);
					}
				} else {
					JOptionPane.showMessageDialog(s.view, "Source file was modified during target selection, please retry.", "Xrefactory Error", JOptionPane.ERROR_MESSAGE);
				}
			}
		}

		void actionCancel() {
			s.getParentDialog(this).setVisible(false);
			tfile.setText("");
			tline.setText("0");
		}
		void actionImport() {
			tfile.setText(s.getBuffer().getFile().getAbsolutePath());
			tline.setText(""+(s.getTextArea().getCaretLine()+1));
			//repaint();
		}

		public void keyTyped(KeyEvent e) {}
		public void keyReleased(KeyEvent e) {}
		public void keyPressed(KeyEvent e) {
			int code = e.getKeyCode();
			if (code == KeyEvent.VK_ESCAPE) {
				e.consume();
				actionCancel();
			} else if (code == KeyEvent.VK_ENTER) {
				e.consume();
				actionContinue();
			}
		}
		public void focusLost(FocusEvent e) {
		}
		public void focusGained(FocusEvent e) {
			actionImport();
			s.getParentDialog(this).pack();
			s.getParentDialog(this).repaint();
		}
		MovePanel(String kind, String continuationOption, String contTestOption) {
			super();
			int y,py;
			JButton buttons[] = {new ButtonCancel(), 
								 //&new ButtonImport(),
								 new ButtonContinue(),
			};

			this.continuationOption = continuationOption;
			this.contTestOption = contTestOption;

			sfile = s.getBuffer().getFile().getAbsolutePath();
			ssfile = new JTextField(sfile);
			ssfile.setEditable(false);
			ssfile.setFocusable(false);
			sline = s.getTextArea().getCaretLine()+1;
			ssline = new JTextField(""+sline);
			ssline.setEditable(false);
			ssline.setFocusable(false);
			scaret = s.getTextArea().getCaretPosition();
			stext = s.getTextArea().getText();

			if (s.targetFile!=null && s.targetLine>0) {
				s.moveToPosition(s.view, s.targetFile, s.targetLine, 0);
			}
			tfile = new JTextField("");
			tfile.setEditable(false);
			tfile.setFocusable(false);
			tline = new JTextField("1");
			tline.setEditable(false);
			tline.setFocusable(false);

			setLayout(new GridBagLayout());

			JPanel mainpanel = new JPanel();
			mainpanel.setLayout(new GridBagLayout());

			py = 0;
			s.addGbcComponent(mainpanel, 0,py, buttons.length+2,1, 1,1, 
							  GridBagConstraints.NONE,
							  new JPanel());

			py++;
			s.addGbcComponent(mainpanel, 0,py, buttons.length+2,1, 1,1, 
							  GridBagConstraints.NONE,
							  new JLabel("With current settings, Xrefactory will move " + kind));

			py ++;
			s.addGbcComponent(mainpanel, 0,py, buttons.length+2,1, 1,1, 
							  GridBagConstraints.NONE,
							  new JPanel());

			py ++;
			s.addGbcComponent(mainpanel, 0,py, 1,1, 1,1, 
							  GridBagConstraints.BOTH,
							  new JPanel());

			s.addGbcComponent(mainpanel, 1,py, 1,1, 1,1, 
							  GridBagConstraints.NONE,
							  new JLabel("  from file :", SwingConstants.RIGHT));
			s.addGbcComponent(mainpanel, 2,py, 1,1, 1,1, 
							  GridBagConstraints.BOTH,
							  ssfile);
			s.addGbcComponent(mainpanel, 3,py, 1,1, 1,1, 
							  GridBagConstraints.BOTH,
							  new JPanel());

			py ++;
			s.addGbcComponent(mainpanel, 0,py, 1,1, 1,1, 
							  GridBagConstraints.BOTH,
							  new JPanel());
			s.addGbcComponent(mainpanel, 1,py, 1,1, 1,1, 
							  GridBagConstraints.NONE,
							  new JLabel("   and line :", SwingConstants.RIGHT));
			s.addGbcComponent(mainpanel, 2,py, 1,1, 1000,1, 
							  GridBagConstraints.BOTH,
							  ssline);
			s.addGbcComponent(mainpanel, 3,py, 1,1, 1,1, 
							  GridBagConstraints.BOTH,
							  new JPanel());
			py ++;
			s.addGbcComponent(mainpanel, 0,py, buttons.length+2,1, 1,1, 
							  GridBagConstraints.NONE,
							  new JPanel());

			py ++;
			s.addGbcComponent(mainpanel, 0,py, 1,1, 1,1, 
							  GridBagConstraints.BOTH,
							  new JPanel());

			s.addGbcComponent(mainpanel, 1,py, 1,1, 1,1, 
							  GridBagConstraints.NONE,
							  new JLabel("    to file :", SwingConstants.RIGHT));
			s.addGbcComponent(mainpanel, 2,py, 1,1, 1,1, 
							  GridBagConstraints.BOTH,
							  tfile);
			s.addGbcComponent(mainpanel, 3,py, 1,1, 1,1, 
							  GridBagConstraints.BOTH,
							  new JPanel());

			py ++;
			s.addGbcComponent(mainpanel, 0,py, 1,1, 1,1, 
							  GridBagConstraints.BOTH,
							  new JPanel());
			s.addGbcComponent(mainpanel, 1,py, 1,1, 1,1, 
							  GridBagConstraints.NONE,
							  new JLabel("    on line :", SwingConstants.RIGHT));
			s.addGbcComponent(mainpanel, 2,py, 1,1, 1000,1, 
							  GridBagConstraints.BOTH,
							  tline);
			s.addGbcComponent(mainpanel, 3,py, 1,1, 1,1, 
							  GridBagConstraints.BOTH,
							  new JPanel());
			py ++;
			s.addGbcComponent(mainpanel, 0,py, 4,1, 1,1, 
							  GridBagConstraints.BOTH,
							  new JPanel());

			py ++;
			s.addGbcComponent(mainpanel, 0,py, buttons.length+2,1, 1,1, 
							  GridBagConstraints.NONE,
							  new JLabel("(to change the target, open the target file with jEdit and set caret on target line)"));


			y=0;
			s.addGbcComponent(this, 0,y, buttons.length+2,1, 1,1, 
							  GridBagConstraints.BOTH,
							  new JPanel());
			y++;
			s.addGbcComponent(this, 0,y, buttons.length+2,1, 1,1, 
							  GridBagConstraints.BOTH,
							  mainpanel);
			y++;
			s.addGbcComponent(this, 0,y, buttons.length+2,1, 1,1, 
							  GridBagConstraints.BOTH,
							  new JPanel());
			y++;
			s.addButtonLine(this, y, buttons,true);

			y++;
			s.addGbcComponent(this, 0,y, buttons.length+2,1, 1,1, 
							  GridBagConstraints.BOTH,
							  new JPanel());

			for(int i=0; i<buttons.length; i++) {
				buttons[i].addKeyListener(this);
				buttons[i].addFocusListener(this);
			}
			tfile.addKeyListener(this);
			tfile.addFocusListener(this);
			tline.addKeyListener(this);
			tline.addFocusListener(this);
			actionImport();
		}
	}

	public String getFile() {
		return(((MovePanel)getContentPane()).tfile.getText());
	}

	public String getLine() {
		return(((MovePanel)getContentPane()).tline.getText());
	}

	public MoveDialog(String kind, String continuationOption, String contTestOption) {
		super(s.view, "Move "+kind);
		MovePanel panel = new MovePanel(kind, continuationOption, contTestOption);
		setContentPane(panel);
		pack();
		setLocationRelativeTo(s.view);
		setVisible(true);
		pack();
		repaint();
	}

}
