@echo off
rem  Xref-Java2Html - A cross referencing Java to Html converter.
rem  (C) 2000-2001 by Xref-Tech.
rem 
rem ###########################################################################
rem  
rem   usage:  java2html package*
rem 
rem ###########################################################################
rem 
rem 
rem      You can customize following variables:
rem  
rem  The path where the resulting html files will be generated. 

set DESTINATION_DIR=.

rem  The temporary directory where the sources with javadoc @see tags will
rem  be generated and then deleted (it is created in current directory)

set SOURCE_TMP_DIR=xrf4jdocTemporaryDir

rem ###########################################################################
rem  
rem  This script is using xref to generate html form plus javadoc commentaries
rem  generated into the source files.
rem  The meaning of usefull xref options (complete list can be found 
rem  in the 'xrefman.txt' file):
rem  -html               - generate html form of sources
rem  -htmlroot=dir       - destination path for html sources
rem  -d dir              - equivalent to -htmlroot=dir
rem  -htmlcutpath=dir    - cut this prefix when generating html file hierarchy
rem  -htmlcutcwd         - as -htmlcutpath, but for current working dir
rem  -htmlcutsourcepaths - cut also source paths of packages
rem  -nocxfile           - do not use any extern cross-reference file
rem  -htmlgxlist         - generate cross-references for global symbols
rem  -htmllxlist         - generate cross-references for local symbols
rem  -htmldirectx        - link cross-references to first letter of symbol
rem  -htmllinenums       - generate line numbers in HTML
rem  -htmllinenumcolor=color - specifies the color for line numbers
rem  -htmlnocolors       - do not generate colors in HTML
rem  -htmlnounderline    - not underlined HTML links
rem  -htmllinkcolor=color - color of html links
rem  -htmltab=n          - set tabulator to n
rem  -refnum=n           - split cross-references into n files (not alpha.)
rem  -refalphahash       - split cross-references alphabetically(-refnum=28)
rem  -refalpha2hash      - split cross-references alphabetically(-refnum=28*28)
rem  -javadoc            - generate javadoc @see tags into sources (to be
rem                        further processed by javadoc)
rem  -jdoctmpdir=dir     - destination path for sources with javadoc @see tags
rem  -mfn                - memory factor. Increasing the cxref memory.
rem  -no_local           - do not reference local symbols
rem  -packages           - allow package names as input arguments
rem  -javafilesonly      - do not process C files
rem  -sourcepath paths   - paths where to search package source
rem  -classpath paths    - java classpath

rem  -htmlgenjavadoclinks - gen links to java doc if no definition found
rem  -htmljavadocpath=path - path to standard java javadoc
rem  -htmljavadocavailable=packs - packages for which there is a javadoc

echo [java2html] Converting sources to html.

mkdir %SOURCE_TMP_DIR%

rem because MS-DOS has some restrictions on command line size, pass
rem large xref's options by file

echo -java2html -html -packages -nocxfile > %TEMP%\xrefopt.opt
echo -javafilesonly                      >> %TEMP%\xrefopt.opt
echo -htmlgxlist -htmllxlist -javadoc    >> %TEMP%\xrefopt.opt
echo -htmltab=4 -htmllinenums -no_stdop  >> %TEMP%\xrefopt.opt
echo -htmlgenjavadoclinks -htmldirectx   >> %TEMP%\xrefopt.opt
echo -htmlroot=%DESTINATION_DIR%         >> %TEMP%\xrefopt.opt
echo -jdoctmpdir=%SOURCE_TMP_DIR%        >> %TEMP%\xrefopt.opt
echo -refs=.\Xrefs -refalphahash         >> %TEMP%\xrefopt.opt
echo -mf2                                >> %TEMP%\xrefopt.opt
echo -htmljavadocpath=http://java.sun.com/j2se/1.3/docs/api >> %TEMP%\xrefopt.opt
echo -htmljavadocavailable=java.applet:java.awt:java.beans:java.io:java.lang:java.math:java.net:java.rmi:java.security:java.sql:java.text:java.util:javax.accessibility:javax.swing:org.omg.CORBA:org.omg.CosNaming >> %TEMP%\xrefopt.opt

rem now collect command line arguments
SET ARGS=
:argsloop
if .%1 == . goto :argsend
SET ARGS=%ARGS% %1
SHIFT
goto :argsloop
:argsend


echo ARGS = %ARGS%

xref -stdop %TEMP%\xrefopt.opt %ARGS% -htmlcutsourcepaths -htmlcutcwd

del %TEMP%\xrefopt.opt

echo [java2html] Starting javadoc.

cd %SOURCE_TMP_DIR%
javadoc -d ..\%DESTINATION_DIR% -sourcepath . %ARGS%
cd ..

echo [java2html] Cleaning.

if .%OS% == .Windows_NT goto :ntwin
deltree /Y %SOURCE_TMP_DIR%
goto :jend
:ntwin
rd /s /q %SOURCE_TMP_DIR%
:jend

echo [java2html] Done.


