
/*

Copyright (C) Marian Vittek, Xref-Tech, Bratislava, 1997-2002.
All Rights Reserved.

    THIS FILE IS CONSIDERED A TRADE SECRET BY XREF-TECH.
UNAUTHORIZED ACCESS, USE, REPRODUCTION OR DISTRIBUTION IS PROHIBITED.

*/
#ifndef STDINC__H
#define STDINC__H
#if defined(__WIN32) && (! defined(__WIN32__))
#define __WIN32__ 1
#endif
#ifdef __WIN32__
#include <windows.h>
#include <direct.h>
#else
#include <unistd.h>
#include <dirent.h>
#endif
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <assert.h>
#include <string.h>
#include <time.h>
#include <setjmp.h>
#include <sys/types.h>
#include <sys/stat.h>
#endif
#include "head2.h"
#include "proto.h"
typedef unsigned char bitArray;
static char * VERSION_NUMBER = "1.5.10je";
static char * FILE_VERSION_NUMBER = "1.5.10je";
static char * PPC_VERSION_MISMATCH = "version-mismatch";
static char * PPC_MULTIPLE_COMPLETIONS = "completions";
static char * PPC_MULTIPLE_COMPLETION_LINE = "cl";
static char * PPC_SINGLE_COMPLETION = "single-completion";
static char * PPC_FQT_COMPLETION = "fqt-completion";
static char * PPC_SYMBOL_LIST = "symbol-list";
static char * PPC_REFACTORING_PRECHECK = "precheck";
static char * PPC_REFACTORING_REPLACEMENT = "replacement";
static char * PPC_REFACTORING_REPLACE = "replace";
static char * PPC_REFACTORING_REPLACE_WITH = "with";
static char * PPC_REFACTORING_CUT_BLOCK = "cut-block";
static char * PPC_REFACTORING_COPY_BLOCK = "copy-block";
static char * PPC_REFACTORING_PASTE_BLOCK = "past-block";
static char * PPC_EXTRACTION_DIALOG = "extraction-dialog";
static char * PPC_DISPLAY_CLASS_TREE = "display-class-tree";
static char * PPC_DISPLAY_RESOLUTION = "display-resolution";
static char * PPC_DISPLAY_OR_UPDATE_BROWSER = "display-or-update-browser";
static char * PPC_SYMBOL_RESOLUTION = "resolution";
static char * PPC_SYMBOL = "symbol";
static char * PPC_VIRTUAL_SYMBOL = "virtual-symbol";
static char * PPC_CLASS = "class";
static char * PPC_REFERENCE_LIST = "reference-list";
static char * PPC_SRC_LINE = "src-line";
static char * PPC_UPDATE_CURRENT_REFERENCE = "update-current-refn";
static char * PPC_NO_PROJECT = "no-project-found";
static char * PPC_SET_PROJECT = "set-project";
static char * PPC_SET_INFO = "set-info";
static char * PPC_WARNING = "warning";
static char * PPC_ERROR = "error";
static char * PPC_FATAL_ERROR = "fatalError";
static char * PPC_INFORMATION = "information";
static char * PPC_BOTTOM_INFORMATION = "bottom-information";
static char * PPC_DEBUG_INFORMATION = "debug-information";
static char * PPC_ASK_CONFIRMATION = "ask-confirmation";
static char * PPC_GOTO = "goto";
static char * PPC_BROWSE_URL = "browse-url";
static char * PPC_FILE_SAVE_AS = "file-save-as";
static char * PPC_MOVE_FILE_AS = "file-move-as";
static char * PPC_FILE_REMOVE = "file-remove";
static char * PPC_MOVE_DIRECTORY = "move-directory";
static char * PPC_INDENT = "indent-block";
static char * PPC_IGNORE = "ignore";
static char * PPC_PROGRESS = "progress";
static char * PPC_UPDATE_REPORT = "update-report";
static char * PPC_AVAILABLE_REFACTORINGS = "available-refactorings";
static char * PPC_SYNCHRO_RECORD = "sync";
static char * PPC_LC_POSITION = "position-lc";
static char * PPC_OFFSET_POSITION = "position-off";
static char * PPC_STRING_VALUE = "string-value";
static char * PPC_INT_VALUE = "int-value";
static char * PPCA_LEN = "len";
static char * PPCA_LINE = "line";
static char * PPCA_COL = "col";
static char * PPCA_OFFSET = "off";
static char * PPCA_VALUE = "val";
static char * PPCA_SELECTED = "selected";
static char * PPCA_BASE = "base";
static char * PPCA_DEF_REFN = "drefn";
static char * PPCA_REFN = "refn";
static char * PPCA_TYPE = "type";
static char * PPCA_MTYPE = "mtype";
static char * PPCA_CONTINUE = "continue";
static char * PPCA_INTERFACE = "interface";
static char * PPCA_INDENT = "indent";
static char * PPCA_TREE_DEPS = "deps";
static char * PPCA_TREE_UP = "up";
static char * PPCA_DEFINITION = "definition";
static int PPCV_BROWSER_TYPE_INFO = 0;
static int PPCV_BROWSER_TYPE_WARNING = 1;
static int PPC_AVR_NO_REFACTORING = 0;
static int PPC_AVR_RENAME_SYMBOL = 1;
static int PPC_AVR_RENAME_CLASS = 2;
static int PPC_AVR_RENAME_PACKAGE = 3;
static int PPC_AVR_ADD_PARAMETER = 4;
static int PPC_AVR_DEL_PARAMETER = 5;
static int PPC_AVR_MOVE_PARAMETER = 6;
static int PPC_AVR_EXTRACT_METHOD = 7;
static int PPC_AVR_EXTRACT_MACRO = 8;
static int PPC_AVR_MOVE_STATIC_FIELD = 9;
static int PPC_AVR_MOVE_STATIC_METHOD = 10;
static int PPC_AVR_MOVE_FIELD = 11;
static int PPC_AVR_PULL_UP_FIELD = 12;
static int PPC_AVR_PULL_UP_METHOD = 13;
static int PPC_AVR_PUSH_DOWN_FIELD = 14;
static int PPC_AVR_PUSH_DOWN_METHOD = 15;
static int PPC_AVR_MOVE_CLASS = 16;
static int PPC_AVR_ENCAPSULATE_FIELD = 17;
static int PPC_AVR_SELF_ENCAPSULATE_FIELD = 18;
static int PPC_AVR_TURN_DYNAMIC_METHOD_TO_STATIC = 19;
static int PPC_AVR_TURN_STATIC_METHOD_TO_DYNAMIC = 20;
static int PPC_AVR_REDUCE_NAMES = 21;
static int PPC_AVR_EXPAND_NAMES = 22;
static int PPC_AVR_SET_MOVE_TARGET = 23;
static int PPC_MAX_AVAILABLE_REFACTORINGS = 24;
static bitArray tmpChRelevant[(((MAX_FILES)+(8 -1))/8)];
static bitArray tmpChProcessed[(((MAX_FILES)+(8 -1))/8)];
static bitArray tmpChMarkProcessed[(((MAX_FILES)+(8 -1))/8)];
static S_olSymbolsMenu *tmpVApplClassBackPointersToMenu[MAX_FILES];
static int s_symbolListOutputCurrentLine =0;
static void clearTmpChRelevant() {
        memset(tmpChRelevant, 0, sizeof(tmpChRelevant));
}
static void clearTmpChProcessed() {
        memset(tmpChProcessed, 0, sizeof(tmpChProcessed));
}
static void clearTmpChMarkProcessed() {
        memset(tmpChMarkProcessed, 0, sizeof(tmpChMarkProcessed));
}
static void clearTmpClassBackPointersToMenu() {
        memset(tmpVApplClassBackPointersToMenu, 0, sizeof(tmpVApplClassBackPointersToMenu));
}
int classHierarchyClassNameLess(int c1, int c2) {
        char *n2, *nn;
        S_fileItem *fi1, *fi2;
        int ccc;
        char ttt[MAX_FILE_NAME_SIZE];
        fi1 = s_fileTab.tab[c1];
        fi2 = s_fileTab.tab[c2];
        { if (!(fi1 && fi2)) internalCheckFail("fi1 && fi2", "classh.c", 53);};
        if (fi2->b.isInterface && ! fi1->b.isInterface) return(1);
        if (fi1->b.isInterface && ! fi2->b.isInterface) return(0);
        nn = fi1->name;
        nn = javaGetNudePreTypeName_st(getRealFileNameStatic(nn),s_opt.nestedClassDisplaying);
        strcpy(ttt,nn);
        nn = fi2->name;
    nn = javaGetNudePreTypeName_st(getRealFileNameStatic(nn),s_opt.nestedClassDisplaying);
        ccc = strcmp(ttt,nn);
        if (ccc!=0) return(ccc<0);
        ccc = strcmp(fi1->name, fi2->name);
        return(ccc<0);
}
int classHierarchySupClassNameLess(S_chReference *c1, S_chReference *c2) {
        return(classHierarchyClassNameLess(c1->clas, c2->clas));
}
static int markTransitiveRelevantSubsRec(int cind, int pass) {
        S_fileItem *fi, *tt;
        S_chReference *s;
        int res;
        fi = s_fileTab.tab[cind];
        if (((tmpChMarkProcessed[(((cind) & ~(((8 -1))))>> 3)] & (1<<((cind) & ((8 -1)))))!=0)) return(((tmpChRelevant[(((cind) & ~(((8 -1))))>> 3)] & (1<<((cind) & ((8 -1)))))!=0));
        {tmpChMarkProcessed[(((cind) & ~(((8 -1))))>> 3)] |= (1<<((cind) & ((8 -1))));};
        res = 0;
        for(s=fi->infs; s!=NULL; s=s->next) {
                tt = s_fileTab.tab[s->clas];
                { if (!(tt)) internalCheckFail("tt", "classh.c", 82);};
                if (markTransitiveRelevantSubsRec(s->clas, pass)) {
                        {tmpChRelevant[(((cind) & ~(((8 -1))))>> 3)] |= (1<<((cind) & ((8 -1))));};
                }
        }
        return(((tmpChRelevant[(((cind) & ~(((8 -1))))>> 3)] & (1<<((cind) & ((8 -1)))))!=0));
}
static void markTransitiveRelevantSubs(int cind, int pass) {
        S_fileItem *fi;
        fi = s_fileTab.tab[cind];
        if (((tmpChRelevant[(((cind) & ~(((8 -1))))>> 3)] & (1<<((cind) & ((8 -1)))))!=0)==0) return;
        markTransitiveRelevantSubsRec(cind, pass);
}
void classHierarchyGenInit(S_olSymbolsMenu *menu) {
        S_olSymbolsMenu *ss;
        clearTmpChRelevant();
        clearTmpChProcessed();
        clearTmpClassBackPointersToMenu();
        for(ss=menu; ss!=NULL; ss=ss->next) {
                tmpVApplClassBackPointersToMenu[ss->s.vApplClass] = ss;
        }
}
static void genClassHierarchyVerticalBars( FILE *ff, S_intlist *nextbars,
                                                                                   int secondpass) {
        S_intlist *nn;
        if (s_opt.xref2) fprintf(ff," %s=\"", PPCA_TREE_DEPS);
        if (nextbars!=NULL) {
                { register S_intlist *list,*tmp,*revlist; list = nextbars; revlist = NULL; while (list!=NULL) { tmp = list->next; list->next = revlist; revlist = list; list = tmp; } nextbars = revlist;};
                for(nn = nextbars; nn!=NULL; nn=nn->next) {
                        if (nn->next==NULL) {
                                if (secondpass) fprintf(ff,"  +- ");
                                else fprintf(ff,"  |  ");
                        }
                        else if (nn->i) fprintf(ff,"  | ");
                        else fprintf(ff,"    ");
                }
                { register S_intlist *list,*tmp,*revlist; list = nextbars; revlist = NULL; while (list!=NULL) { tmp = list->next; list->next = revlist; revlist = list; list = tmp; } nextbars = revlist;};
        }
        if (s_opt.xref2) fprintf(ff,"\"");
}
static S_olSymbolsMenu *htmlItemInOriginalList(S_olSymbolsMenu *orr, int fInd) {
        S_olSymbolsMenu *rr;
        if (fInd == -1) return(NULL);
        { if (!(fInd>=0 && fInd<MAX_FILES)) internalCheckFail("fInd>=0 && fInd<MAX_FILES", "classh.c", 143);};
        rr = tmpVApplClassBackPointersToMenu[fInd];
        return(rr);
}
static void htmlCHEmptyIndent( FILE *ff ) {
  fprintf(ff,"    ");
}
static void htmlPrintClassHierarchyLine( FILE *ff, int fInd,
                                                                                 S_intlist *nextbars,
                                                                                 int virtFlag,
                                                                                 S_olSymbolsMenu *itt ) {
        char *cname, *pref1, *pref2, *suf1, *suf2;
        S_fileItem *fi;
        int cnt;
        fi = s_fileTab.tab[fInd];
        htmlCHEmptyIndent( ff);
        genClassHierarchyVerticalBars( ff, nextbars, 0);
        fprintf(ff,"\n");
        cname = javaGetNudePreTypeName_st(getRealFileNameStatic(fi->name),
                                                                          s_opt.nestedClassDisplaying);
        pref1 = pref2 = suf1 = suf2 = "";
        if (fi->b.isInterface) {
                pref2 = "<em>"; suf2 = "</em>";
        }
        if (itt!=NULL && ((tmpChProcessed[(((fInd) & ~(((8 -1))))>> 3)] & (1<<((fInd) & ((8 -1)))))!=0)==0) {
                { if (!(itt)) internalCheckFail("itt", "classh.c", 174);};
                genClassHierarchyItemLinks( ff, itt, virtFlag);
                genClassHierarchyVerticalBars( ff, nextbars, 1);
                if (itt->s.vApplClass == itt->s.vFunClass) {
                        pref1 = "<B>"; suf1 = "</B>";
                }
                fprintf(ff,"%s%s%s%s%s", pref1, pref2, cname, suf2, suf1);
                cnt = itt->defRefn+itt->refn;
                if (cnt > 0) {
                        fprintf(ff,"\t\t(%d)", cnt);
                }
        } else {
            htmlCHEmptyIndent( ff);
            genClassHierarchyVerticalBars( ff, nextbars, 1);
                fprintf(ff,"%s%s%s%s%s", pref1, pref2, cname, suf2, suf1);
        }
        if (((tmpChProcessed[(((fInd) & ~(((8 -1))))>> 3)] & (1<<((fInd) & ((8 -1)))))!=0)==1) {
                fprintf(ff, " ---> up");
        }
        fprintf(ff,"\n");
}
static void olcxPrintMenuItemPrefix(FILE *ff, S_olSymbolsMenu *itt,
                                                                   int selectable) {
        { if (!(s_olcxCurrentUser && s_olcxCurrentUser->tops)) internalCheckFail("s_olcxCurrentUser && s_olcxCurrentUser->tops", "classh.c", 199);};
        if (s_opt.cxrefs==OLO_CLASS_TREE || s_opt.cxrefs==OLO_SHOW_CLASS_TREE) {
                fprintf(ff,"");
        } else if (! selectable) {
                if (s_opt.xref2) fprintf(ff, " %s=2", PPCA_SELECTED);
                else fprintf(ff,"- ");
        } else if (itt!=NULL && itt->selected) {
                if (s_opt.xref2) fprintf(ff, " %s=1", PPCA_SELECTED);
                else fprintf(ff,"+ ");
        } else {
                if (s_opt.xref2) fprintf(ff, " %s=0", PPCA_SELECTED);
                else fprintf(ff,"  ");
        }
        if (itt!=NULL
                && itt->vlevel==1
                && ooBitsGreaterOrEqual(itt->ooBits, 02000)) {
                if (s_opt.xref2) fprintf(ff, " %s=1", PPCA_BASE);
                else fprintf(ff,">>");
        } else {
                if (s_opt.xref2) fprintf(ff, " %s=0", PPCA_BASE);
                else fprintf(ff,"  ");
        }
        if (! s_opt.xref2) fprintf(ff," ");
        if (s_opt.cxrefs==OLO_CLASS_TREE || s_opt.cxrefs==OLO_SHOW_CLASS_TREE) {
                fprintf(ff, "");
        } else if (itt==NULL || (itt->defRefn==0 && itt->refn==0) || !selectable) {
                if (s_opt.xref2) fprintf(ff, " %s=0 %s=0", PPCA_DEF_REFN, PPCA_REFN);
                else fprintf(ff, "  -/-  ");
        } else if (itt->defRefn==0) {
                if (s_opt.xref2) fprintf(ff, " %s=0 %s=%d", PPCA_DEF_REFN, PPCA_REFN, itt->refn);
                else fprintf(ff, "  -/%-3d", itt->refn);
        } else if (itt->refn==0) {
                if (s_opt.xref2) fprintf(ff, " %s=%d %s=0", PPCA_DEF_REFN, itt->defRefn, PPCA_REFN);
                else fprintf(ff, "%3d/-  ", itt->defRefn);
        } else {
                if (s_opt.xref2) fprintf(ff, " %s=%d %s=%d", PPCA_DEF_REFN, itt->defRefn, PPCA_REFN, itt->refn);
                else fprintf(ff, "%3d/%-3d", itt->defRefn, itt->refn);
        }
        if (! s_opt.xref2) fprintf(ff,"    ");
}
static void olcxMenuGenNonVirtualGlobSymList( FILE *ff, S_olSymbolsMenu *ss) {
        int ii;
        char ttt[MAX_CX_SYMBOL_SIZE];
        if (s_opt.xref2) {
                ppcIndentOffset();
                fprintf(ff,"<%s %s=%d", PPC_SYMBOL, PPCA_LINE, s_symbolListOutputCurrentLine+2);
                if (ss->s.b.symType!=TypeDefault) {
                        fprintf(ff," %s=%s", PPCA_TYPE, typesName[ss->s.b.symType]);
                }
                olcxPrintMenuItemPrefix(ff, ss, 1);
                sprintfSymbolLinkName(ttt, ss);
                fprintf(ff," %s=%d>%s</%s>\n", PPCA_LEN, strlen(ttt), ttt, PPC_SYMBOL);
        } else {
                olcxPrintMenuItemPrefix(ff, ss, 1);
                printSymbolLinkName(ff, ss);
                if (ss->s.b.symType != TypeDefault) {
                        fprintf(ff,"\t(%s)", typesName[ss->s.b.symType]);
                }
                fprintf(ff,"\n");
        }
        ss->outOnLine = s_symbolListOutputCurrentLine;
        s_symbolListOutputCurrentLine ++ ;
}
static void olcxMenuPrintClassHierarchyLine( FILE *ff, int fInd,
                                                                                 S_intlist *nextbars,
                                                                                 int virtFlag,
                                                                                 S_olSymbolsMenu *itt ) {
        char *cname;
        S_fileItem *fi;
        int yetProcesed, indent;
        yetProcesed = ((tmpChProcessed[(((fInd) & ~(((8 -1))))>> 3)] & (1<<((fInd) & ((8 -1)))))!=0);
        if (s_opt.xref2) {
                ppcIndentOffset();
                fprintf(ff, "<%s %s=%d", PPC_CLASS, PPCA_LINE,
                                s_symbolListOutputCurrentLine+2);
        }
        olcxPrintMenuItemPrefix(ff, itt, ! yetProcesed);
        if (s_opt.xref2) {
                { register S_intlist *tmp; register int co=0; tmp = nextbars; while (tmp!=NULL) {++co; tmp = tmp->next; } indent = co; };
                fprintf(ff, " %s=%d", PPCA_INDENT, indent);
        }
        genClassHierarchyVerticalBars( ff, nextbars, 1);
        fi = s_fileTab.tab[fInd];
        if (itt!=NULL) {
                { if (!(itt)) internalCheckFail("itt", "classh.c", 287);};
                if (itt->s.vApplClass == itt->s.vFunClass) {
                        if (s_opt.xref2) fprintf(ff, " %s=1", PPCA_DEFINITION);
                        else fprintf(ff,"*");
                }
                itt->visible = 1;
        }
        if (fi->b.isInterface) {
                if (s_opt.xref2) fprintf(ff, " %s=1", PPCA_INTERFACE);
                else fprintf(ff,"~");
        }
        cname = javaGetNudePreTypeName_st(getRealFileNameStatic(fi->name),
                                                                          s_opt.nestedClassDisplaying);
        if (s_opt.xref2) {
                if (((tmpChProcessed[(((fInd) & ~(((8 -1))))>> 3)] & (1<<((fInd) & ((8 -1)))))!=0)) fprintf(ff," %s=1", PPCA_TREE_UP);
                fprintf(ff, " %s=%d>%s</%s>\n", PPCA_LEN, strlen(cname), cname, PPC_CLASS);
        } else {
                if (((tmpChProcessed[(((fInd) & ~(((8 -1))))>> 3)] & (1<<((fInd) & ((8 -1)))))!=0)) fprintf(ff,"(%s) -> up", cname);
                else fprintf(ff,"%s", cname);
                fprintf(ff,"\n");
        }
}
static void htmlDescendTheClassHierarchy( FILE *ff,
                                                                                        int fInd,
                                                                                        S_olSymbolsMenu *rrr,
                                                                                        int level,
                                                                                        S_intlist *nextbars,
                                                                                        int virtFlag,
                                                                                        int pass
        ) {
        S_intlist snextbar,*nn;
        S_fileItem *tt, *fi;
        S_chReference *s,*ol,*snext;
        S_olSymbolsMenu *itt;
        char *cname,*pref1,*pref2,*suf1,*suf2;
        int i;
        fi = s_fileTab.tab[fInd];
        { if (!(fi!=NULL)) internalCheckFail("fi!=NULL", "classh.c", 327);};
        if (((tmpChRelevant[(((fInd) & ~(((8 -1))))>> 3)] & (1<<((fInd) & ((8 -1)))))!=0)==0) return;
        itt = htmlItemInOriginalList(rrr, fInd);
        if (s_opt.taskRegime==RegimeHtmlGenerate) {
                htmlPrintClassHierarchyLine( ff, fInd, nextbars, virtFlag, itt);
        } else {
                olcxMenuPrintClassHierarchyLine( ff, fInd, nextbars, virtFlag, itt);
        }
        s_symbolListOutputCurrentLine ++;
        if (((tmpChProcessed[(((fInd) & ~(((8 -1))))>> 3)] & (1<<((fInd) & ((8 -1)))))!=0)==1) return;
        {tmpChProcessed[(((fInd) & ~(((8 -1))))>> 3)] |= (1<<((fInd) & ((8 -1))));};
        if (itt!=NULL) itt->outOnLine = s_symbolListOutputCurrentLine-1;
        { S_chReference *_macrores; _macrores = (fi->infs); { S_chReference *a, *b, *todo, *t, **restail; int i, n, contFlag; contFlag = 1; for(n=1; contFlag; n=n+n) { todo=_macrores; _macrores=NULL; restail = &_macrores; contFlag=0; while (todo!=NULL) { a=todo; for(i=1, t=a; i<n && t!=NULL; i++, t=t->next) ; if (t==NULL) { *restail = a; break; } b=t->next; t->next=NULL; for(i=1, t=b; i<n && t!=NULL; i++, t=t->next) ; if (t==NULL) todo=NULL; else { todo=t->next; t->next=NULL; } { while (a!=NULL && b!=NULL) { if (classHierarchySupClassNameLess(a, b)) { *restail=a; restail= &(a->next); a=a->next; } else { *restail=b; restail= &(b->next); b=b->next; } } if (a!=NULL) *restail=a; else *restail=b; while (*restail!=NULL) restail= &((*restail)->next);}; contFlag=1; } } } (fi->infs) = _macrores;};
        s=fi->infs;
        while (s!=NULL) {
                { if (!(s_fileTab.tab[s->clas])) internalCheckFail("s_fileTab.tab[s->clas]", "classh.c", 348);};
                snext = s->next;
                while (snext!=NULL && ((tmpChRelevant[(((snext->clas) & ~(((8 -1))))>> 3)] & (1<<((snext->clas) & ((8 -1)))))!=0)==0) {
                        snext = snext->next;
                }
                { (&snextbar)->i = (snext!=NULL); (&snextbar)->next = nextbars;}
                htmlDescendTheClassHierarchy(ff, s->clas, rrr, level+1,
                                                                         &snextbar, virtFlag, pass);
                s = snext;
        }
}
static int htmlGenThisClassHierarchy(int fInd,
                                                                          FILE *ff,
                                                                          S_olSymbolsMenu *rrr,
                                                                          int virtFlag,
                                                                         int pass) {
        S_fileItem *top,*tt,*fi;
        S_chReference *s;
        fi = s_fileTab.tab[fInd];
        if (fi==NULL) return(0);
        if (((tmpChProcessed[(((fInd) & ~(((8 -1))))>> 3)] & (1<<((fInd) & ((8 -1)))))!=0)) return(0);
        if (((tmpChRelevant[(((fInd) & ~(((8 -1))))>> 3)] & (1<<((fInd) & ((8 -1)))))!=0)==0) return(0);
        for(s=fi->sups; s!=NULL; s=s->next) {
                tt = s_fileTab.tab[s->clas];
                { if (!(tt)) internalCheckFail("tt", "classh.c", 374);};
                if (((tmpChRelevant[(((s->clas) & ~(((8 -1))))>> 3)] & (1<<((s->clas) & ((8 -1)))))!=0) && ((tmpChProcessed[(((s->clas) & ~(((8 -1))))>> 3)] & (1<<((s->clas) & ((8 -1)))))!=0)==0) return(0);
        }
        if (pass==FIRST_PASS && fi->b.isInterface) return(0);
        htmlDescendTheClassHierarchy(ff, fInd, rrr, 0, NULL, virtFlag, pass);
        return(1);
}
void htmlGenClassHierarchies( FILE *ff, S_olSymbolsMenu *rrr,
                                                                                int virtFlag, int pass ) {
        S_olSymbolsMenu *ss;
        int i,rr;
        S_fileItem *fi;
        clearTmpChRelevant();
        for(ss=rrr; ss!=NULL; ss=ss->next) {
                { if (!(s_fileTab.tab[ss->s.vApplClass])) internalCheckFail("s_fileTab.tab[ss->s.vApplClass]", "classh.c", 393);};
                if (ss->visible) {
                        {tmpChRelevant[(((ss->s.vApplClass) & ~(((8 -1))))>> 3)] |= (1<<((ss->s.vApplClass) & ((8 -1))));};
                        {tmpChRelevant[(((ss->s.vFunClass) & ~(((8 -1))))>> 3)] |= (1<<((ss->s.vFunClass) & ((8 -1))));};
                }
        }
        clearTmpChMarkProcessed();
        for(ss=rrr; ss!=NULL; ss=ss->next) {
                markTransitiveRelevantSubs(ss->s.vFunClass, pass);
                markTransitiveRelevantSubs(ss->s.vApplClass, pass);
        }
        for(ss=rrr; ss!=NULL; ss=ss->next) {
                htmlGenThisClassHierarchy(ss->s.vFunClass,ff,rrr,virtFlag,pass);
                htmlGenThisClassHierarchy(ss->s.vApplClass,ff,rrr,virtFlag,pass);
        }
}
static int isInterface(int fnum) {
        S_fileItem *fi;
        fi = s_fileTab.tab[fnum];
        { if (!(fi!=NULL)) internalCheckFail("fi!=NULL", "classh.c", 415);};
        return(fi->b.isInterface);
}
static int htmlRefItemsClassNameLess(S_olSymbolsMenu *ss1,
                                                                         S_olSymbolsMenu *ss2) {
        return(classHierarchyClassNameLess(ss1->s.vApplClass,ss2->s.vApplClass));
}
int chLineOrderLess(S_olSymbolsMenu *r1, S_olSymbolsMenu *r2) {
        return(r1->outOnLine < r2->outOnLine);
}
void olcxMenuGenGlobRefsForVirtMethod(FILE *ff, S_olSymbolsMenu *rrr) {
        char ln[MAX_HTML_REF_LEN];
        int virtFlag;
        linkNamePrettyPrint(ln,rrr->s.name,MAX_HTML_REF_LEN,SHORT_NAME);
        if (strcmp(rrr->s.name, " [classTree]")==0) {
        } else {
                if (s_opt.xref2) ppcGenRecord(PPC_VIRTUAL_SYMBOL, ln, "\n");
                else fprintf(ff, "\n== %s\n", ln);
                s_symbolListOutputCurrentLine += 2 ;
        }
        classHierarchyGenInit(rrr);
        htmlGenClassHierarchies( ff, rrr, SINGLE_VIRT_ITEM, FIRST_PASS);
        htmlGenClassHierarchies( ff, rrr, SINGLE_VIRT_ITEM, SECOND_PASS);
        if (! s_opt.xref2) fprintf(ff, "\n");
        s_symbolListOutputCurrentLine ++ ;
}
static void htmlMarkVisibleAllClassesHavingDefinition( S_olSymbolsMenu *rrr ) {
        S_olSymbolsMenu *rr;
        for(rr=rrr; rr!=NULL; rr=rr->next) {
                if (rr->s.vApplClass==rr->s.vFunClass) rr->visible = 1;
        }
}
static int isVirtualMenuItem(S_symbolRefItem *p) {
        return (p->b.storage == StorageField
                        || p->b.storage == StorageMethod
                        || p->b.storage == StorageConstructor);
}
static void genVirtualsGlobRefLists( S_olSymbolsMenu *rrr,
                                                                                FILE *ff,
                                                                                char *fn
        ) {
        S_olSymbolsMenu *rr,*ss;
        int i,olen,nlen,count,virtFlag;
        S_symbolRefItem *p;
        S_fileItem *fi;
        count = 0;
        for(ss=rrr; ss!=NULL && ss->visible==0; ss=ss->next) ;
        if (ss == NULL) return;
        { if (!(rrr!=NULL)) internalCheckFail("rrr!=NULL", "classh.c", 476);};
        p = &rrr->s;
        { if (!(p!=NULL)) internalCheckFail("p!=NULL", "classh.c", 478);};
        if (isVirtualMenuItem(p)) {
                if (s_opt.taskRegime==RegimeHtmlGenerate) {
                        htmlMarkVisibleAllClassesHavingDefinition( rrr);
                        htmlGenGlobRefsForVirtMethod( ff, fn, rrr);
                } else {
                        olcxMenuGenGlobRefsForVirtMethod( ff, rrr);
                }
        }
}
static void genNonVirtualsGlobRefLists( S_olSymbolsMenu *rrr,
                                                                                FILE *ff,
                                                                                char *fn
        ) {
        S_olSymbolsMenu *rr,*ss;
        int i,olen,nlen,count,virtFlag;
        S_symbolRefItem *p;
        S_fileItem *fi;
        count = 0;
        for(ss=rrr; ss!=NULL && ss->visible==0; ss=ss->next) ;
        if (ss == NULL) return;
        { if (!(rrr!=NULL)) internalCheckFail("rrr!=NULL", "classh.c", 502);};
        p = &rrr->s;
        { if (!(p!=NULL)) internalCheckFail("p!=NULL", "classh.c", 504);};
        if (! isVirtualMenuItem(p)) {
                for(ss=rrr; ss!=NULL; ss=ss->next) {
                        p = &ss->s;
                        if (s_opt.taskRegime==RegimeHtmlGenerate) {
                                htmlGenNonVirtualGlobSymList( ff, fn, p);
                        } else {
                                olcxMenuGenNonVirtualGlobSymList( ff, ss);
                        }
                }
        }
}
static void genGlobVirtNonVirtRefList(S_olSymbolsMenu *rrr, FILE *ff,
                                                                          char *fn, int virtFlag ) {
        S_olSymbolsMenu *rr, *ss, *nextl;
        rr = rrr;
        while (rr!=NULL) {
                for(ss= rr;
                        ss!=NULL&&ss->next!=NULL && itIsSameCxSymbol(&ss->next->s,&rr->s);
                        ss = ss->next
                        ) ;
                { if (!(ss!=NULL)) internalCheckFail("ss!=NULL", "classh.c", 527);};
                nextl = ss->next;
                ss->next = NULL;
                if (virtFlag == GEN_VIRTUALS) {
                        genVirtualsGlobRefLists(rr,ff,fn);
                } else {
                        genNonVirtualsGlobRefLists(rr,ff,fn);
                }
                { if ((rr)==NULL) rr = nextl; else { register S_olSymbolsMenu *tempnsl; tempnsl = rr; while (tempnsl->next!=NULL) tempnsl=tempnsl->next; tempnsl->next = nextl; } };
                rr = nextl;
        }
}
void htmlGenGlobRefLists(S_olSymbolsMenu *rrr, FILE *ff, char *fn) {
        S_olSymbolsMenu *rr,*ss,*nextl;
        int i,n;
        static int counter;
        S_symbolRefItem *p;
        for(rr=rrr; rr!=NULL; rr=rr->next) rr->outOnLine = 0;
        s_symbolListOutputCurrentLine = 1;
        genGlobVirtNonVirtRefList( rrr, ff, fn, GEN_NON_VIRTUALS);
        genGlobVirtNonVirtRefList( rrr, ff, fn, GEN_VIRTUALS);
}
