
/*

Copyright (C) Marian Vittek, Xref-Tech, Bratislava, 1997-2002.
All Rights Reserved.

    THIS FILE IS CONSIDERED A TRADE SECRET BY XREF-TECH.
UNAUTHORIZED ACCESS, USE, REPRODUCTION OR DISTRIBUTION IS PROHIBITED.

*/
#ifndef STDINC__H
#define STDINC__H
#if defined(__WIN32) && (! defined(__WIN32__))
#define __WIN32__ 1
#endif
#ifdef __WIN32__
#include <windows.h>
#include <direct.h>
#else
#include <unistd.h>
#include <dirent.h>
#endif
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <assert.h>
#include <string.h>
#include <time.h>
#include <setjmp.h>
#include <sys/types.h>
#include <sys/stat.h>
#endif
#include "head2.h"
#include "proto.h"
#ifdef __WIN32__
#endif
typedef union {
        int integer;
        unsigned unsign;
        S_symbol *symbol;
        S_symbolList *symbolList;
        S_typeModifiers *typeModif;
        S_typeModifiersList *typeModifList;
        S_freeTrail *trail;
        S_idIdent *idIdent;
        S_idIdentList *idlist;
        S_exprTokenType exprType;
        S_intPair intpair;
        S_whileExtractData *whiledata;
        S_position position;
        S_unsPositionPair unsPositionPair;
        S_symbolPositionPair symbolPositionPair;
        S_symbolPositionLstPair symbolPositionLstPair;
        S_positionLst *positionLst;
        S_typeModifiersListPositionLstPair typeModifiersListPositionLstPair;
} YYSTYPE;
extern YYSTYPE yylval;
extern YYSTYPE cyylval;
extern YYSTYPE javayylval;
extern YYSTYPE javaslyylval;
extern YYSTYPE cccyylval;
extern YYSTYPE yaccyylval;
extern YYSTYPE *uniyylval;
static char * VERSION_NUMBER = "1.5.10je";
static char * FILE_VERSION_NUMBER = "1.5.10je";
static char * PPC_VERSION_MISMATCH = "version-mismatch";
static char * PPC_MULTIPLE_COMPLETIONS = "completions";
static char * PPC_MULTIPLE_COMPLETION_LINE = "cl";
static char * PPC_SINGLE_COMPLETION = "single-completion";
static char * PPC_FQT_COMPLETION = "fqt-completion";
static char * PPC_SYMBOL_LIST = "symbol-list";
static char * PPC_REFACTORING_PRECHECK = "precheck";
static char * PPC_REFACTORING_REPLACEMENT = "replacement";
static char * PPC_REFACTORING_REPLACE = "replace";
static char * PPC_REFACTORING_REPLACE_WITH = "with";
static char * PPC_REFACTORING_CUT_BLOCK = "cut-block";
static char * PPC_REFACTORING_COPY_BLOCK = "copy-block";
static char * PPC_REFACTORING_PASTE_BLOCK = "past-block";
static char * PPC_EXTRACTION_DIALOG = "extraction-dialog";
static char * PPC_DISPLAY_CLASS_TREE = "display-class-tree";
static char * PPC_DISPLAY_RESOLUTION = "display-resolution";
static char * PPC_DISPLAY_OR_UPDATE_BROWSER = "display-or-update-browser";
static char * PPC_SYMBOL_RESOLUTION = "resolution";
static char * PPC_SYMBOL = "symbol";
static char * PPC_VIRTUAL_SYMBOL = "virtual-symbol";
static char * PPC_CLASS = "class";
static char * PPC_REFERENCE_LIST = "reference-list";
static char * PPC_SRC_LINE = "src-line";
static char * PPC_UPDATE_CURRENT_REFERENCE = "update-current-refn";
static char * PPC_NO_PROJECT = "no-project-found";
static char * PPC_SET_PROJECT = "set-project";
static char * PPC_SET_INFO = "set-info";
static char * PPC_WARNING = "warning";
static char * PPC_ERROR = "error";
static char * PPC_FATAL_ERROR = "fatalError";
static char * PPC_INFORMATION = "information";
static char * PPC_BOTTOM_INFORMATION = "bottom-information";
static char * PPC_DEBUG_INFORMATION = "debug-information";
static char * PPC_ASK_CONFIRMATION = "ask-confirmation";
static char * PPC_GOTO = "goto";
static char * PPC_BROWSE_URL = "browse-url";
static char * PPC_FILE_SAVE_AS = "file-save-as";
static char * PPC_MOVE_FILE_AS = "file-move-as";
static char * PPC_FILE_REMOVE = "file-remove";
static char * PPC_MOVE_DIRECTORY = "move-directory";
static char * PPC_INDENT = "indent-block";
static char * PPC_IGNORE = "ignore";
static char * PPC_PROGRESS = "progress";
static char * PPC_UPDATE_REPORT = "update-report";
static char * PPC_AVAILABLE_REFACTORINGS = "available-refactorings";
static char * PPC_SYNCHRO_RECORD = "sync";
static char * PPC_LC_POSITION = "position-lc";
static char * PPC_OFFSET_POSITION = "position-off";
static char * PPC_STRING_VALUE = "string-value";
static char * PPC_INT_VALUE = "int-value";
static char * PPCA_LEN = "len";
static char * PPCA_LINE = "line";
static char * PPCA_COL = "col";
static char * PPCA_OFFSET = "off";
static char * PPCA_VALUE = "val";
static char * PPCA_SELECTED = "selected";
static char * PPCA_BASE = "base";
static char * PPCA_DEF_REFN = "drefn";
static char * PPCA_REFN = "refn";
static char * PPCA_TYPE = "type";
static char * PPCA_MTYPE = "mtype";
static char * PPCA_CONTINUE = "continue";
static char * PPCA_INTERFACE = "interface";
static char * PPCA_INDENT = "indent";
static char * PPCA_TREE_DEPS = "deps";
static char * PPCA_TREE_UP = "up";
static char * PPCA_DEFINITION = "definition";
static int PPCV_BROWSER_TYPE_INFO = 0;
static int PPCV_BROWSER_TYPE_WARNING = 1;
static int PPC_AVR_NO_REFACTORING = 0;
static int PPC_AVR_RENAME_SYMBOL = 1;
static int PPC_AVR_RENAME_CLASS = 2;
static int PPC_AVR_RENAME_PACKAGE = 3;
static int PPC_AVR_ADD_PARAMETER = 4;
static int PPC_AVR_DEL_PARAMETER = 5;
static int PPC_AVR_MOVE_PARAMETER = 6;
static int PPC_AVR_EXTRACT_METHOD = 7;
static int PPC_AVR_EXTRACT_MACRO = 8;
static int PPC_AVR_MOVE_STATIC_FIELD = 9;
static int PPC_AVR_MOVE_STATIC_METHOD = 10;
static int PPC_AVR_MOVE_FIELD = 11;
static int PPC_AVR_PULL_UP_FIELD = 12;
static int PPC_AVR_PULL_UP_METHOD = 13;
static int PPC_AVR_PUSH_DOWN_FIELD = 14;
static int PPC_AVR_PUSH_DOWN_METHOD = 15;
static int PPC_AVR_MOVE_CLASS = 16;
static int PPC_AVR_ENCAPSULATE_FIELD = 17;
static int PPC_AVR_SELF_ENCAPSULATE_FIELD = 18;
static int PPC_AVR_TURN_DYNAMIC_METHOD_TO_STATIC = 19;
static int PPC_AVR_TURN_STATIC_METHOD_TO_DYNAMIC = 20;
static int PPC_AVR_REDUCE_NAMES = 21;
static int PPC_AVR_EXPAND_NAMES = 22;
static int PPC_AVR_SET_MOVE_TARGET = 23;
static int PPC_MAX_AVAILABLE_REFACTORINGS = 24;
static unsigned s_javaExtractFromFunctionMods=0x000;
static char *rb;
static void dumpProgram(S_programGraphNode *program) {
        S_programGraphNode *p;
        fprintf(dumpOut,"[ProgramDump]\n");
        for(p=program; p!=NULL; p=p->next) {
                fprintf(dumpOut,"%x: %2d %2d %s %s",p,
                        p->posBits,p->stateBits,
                        p->symRef->name,
                        usagesName[p->ref->usage]+5);
                if (p->symRef->b.symType==TypeLabel && p->ref->usage!=UsageDefined) {
                        fprintf(dumpOut," %x",p->jump);
                }
                fprintf(dumpOut,"\n");
        }
        fflush(dumpOut);
}
void genInternalLabelReference(int counter, int usage) {
        char ttt[TMP_STRING_SIZE];
        S_idIdent ll;
        { sprintf(ttt,"%%L%d",counter); { if (!(strlen(ttt) < TMP_STRING_SIZE-1)) internalCheckFail("strlen(ttt) < TMP_STRING_SIZE-1", "extract.c", 51);};};
        { (&ll)->name = ttt; (&ll)->sd = NULL; (&ll)->p.file = cFile.lb.cb.fileNumber; (&ll)->p.line = 0; (&ll)->p.coll = 0;};
        if (usage != UsageDefined) ll.p.line++;
        labelReference(&ll, usage);
}
S_symbol * addContinueBreakLabelSymbol(int labn, char *name) {
        S_symbol *s;
        {s = (S_symbol*) stackMemoryAlloc(sizeof(S_symbol)); };
        { (&s->b)->record = 0; (&s->b)->accessFlags = 0; (&s->b)->javaSourceLoaded = 0; (&s->b)->javaFileLoaded = 0; (&s->b)->symType = TypeLabel; (&s->b)->storage = StorageAuto; (&s->b)->npointers = 0;};
        { (s)->name = name; (s)->linkName = name; (s)->pos = s_noPos; (s)->b = s->b; (s)->u.labn = labn; (s)->next = NULL;};
        { int i; S_symbol *memb; symTabIsMember(s_symTab,s,&i,&memb); if ( ((s_language & (16)) != 0) && s->b.symType==TypeDefault && s->u.type->m == TypeFunction) { s->u.type->u.f.thisFunList = &(s_symTab->tab[i]); } symTabSet(s_symTab,s,i);};
        return(s);
}
void deleteContinueBreakLabelSymbol(char *name) {
        S_symbol ss,*memb;
        int ii;
        { (&ss.b)->record = 0; (&ss.b)->accessFlags = 0; (&ss.b)->javaSourceLoaded = 0; (&ss.b)->javaFileLoaded = 0; (&ss.b)->symType = TypeLabel; (&ss.b)->storage = StorageAuto; (&ss.b)->npointers = 0;};
        { (&ss)->name = name; (&ss)->linkName = name; (&ss)->pos = s_noPos; (&ss)->b = ss.b; (&ss)->u.labn = 0; (&ss)->next = NULL;};
        if (symTabIsMember(s_symTab, &ss, &ii, &memb)) {
          { if (s_opt.cxrefs == OLO_EXTRACT) deleteSymDef(memb);};
        } else {
          { if (!(0)) internalCheckFail("0", "extract.c", 77);};
        }
}
void genContinueBreakReference(char *name) {
        S_symbol ss,*memb;
        int ii;
        { (&ss.b)->record = 0; (&ss.b)->accessFlags = 0; (&ss.b)->javaSourceLoaded = 0; (&ss.b)->javaFileLoaded = 0; (&ss.b)->symType = TypeLabel; (&ss.b)->storage = StorageAuto; (&ss.b)->npointers = 0;};
        { (&ss)->name = name; (&ss)->linkName = name; (&ss)->pos = s_noPos; (&ss)->b = ss.b; (&ss)->u.labn = 0; (&ss)->next = NULL;};
        if (symTabIsMember(s_symTab, &ss, &ii, &memb)) {
                genInternalLabelReference(memb->u.labn, UsageUsed);
        }
}
void genSwitchCaseFork(int lastFlag) {
        S_symbol ss,*memb;
        int ii;
        { (&ss.b)->record = 0; (&ss.b)->accessFlags = 0; (&ss.b)->javaSourceLoaded = 0; (&ss.b)->javaFileLoaded = 0; (&ss.b)->symType = TypeLabel; (&ss.b)->storage = StorageAuto; (&ss.b)->npointers = 0;};
        { (&ss)->name = " %swtl%"; (&ss)->linkName = " %swtl%"; (&ss)->pos = s_noPos; (&ss)->b = ss.b; (&ss)->u.labn = 0; (&ss)->next = NULL;};
        if (symTabIsMember(s_symTab, &ss, &ii, &memb)) {
                genInternalLabelReference(memb->u.labn, UsageDefined);
                if (! lastFlag) {
                        memb->u.labn++;
                        genInternalLabelReference(memb->u.labn, UsageFork);
                }
        }
}
static void extractFunGraphRef(S_symbolRefItem *rr, void *prog) {
        S_reference *r;
        S_programGraphNode *p,**ap;
        ap = (S_programGraphNode **) prog;
        for(r=rr->refs; r!=NULL; r=r->next) {
                if (( ((char*)r) >= ((char*)&cxMemory->b) + (s_cp.cxMemiAtFunBegin) && ((char*)r) < ((char*)&cxMemory->b) + (s_cp.cxMemiAtFunEnd) )){
                        {{{ { if (!((1) >= 0)) internalCheckFail("(1) >= 0", "extract.c", 111);}; cxMemory->i = ((char*)(((char*)(((char*)&cxMemory->b)+cxMemory->i))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(((char*)&cxMemory->b)+cxMemory->i))-1) & (STANDARD_ALLIGNEMENT-1))))) - ((char*)&cxMemory->b); if (cxMemory->i+(1)*sizeof(S_programGraphNode) >= cxMemory->size) { if (cxMemory->overflowHandler(1)) longjmp(s_memoryResize,1); else fatalError(ERR_NO_MEMORY,"cxMemory", 65); } p = (S_programGraphNode*) (((char*)&cxMemory->b) + cxMemory->i); cxMemory->i += (1)*sizeof(S_programGraphNode);};};};
                        { (p)->ref = r; (p)->symRef = rr; (p)->jump = NULL; (p)->posBits = 0; (p)->stateBits = 0; (p)->classifBits = EXTRACT_NONE; (p)->next = *ap;};
                        *ap = p;
                }
        }
}
static S_programGraphNode *getGraphAddress( S_programGraphNode *program,
                                                                                        S_reference *ref
                                                                                ) {
        S_programGraphNode *p,*res;
        res = NULL;
        for(p=program; res==NULL && p!=NULL; p=p->next) {
                if (p->ref == ref) res = p;
        }
        return(res);
}
static S_reference *getDefinitionReference(S_symbolRefItem *lab) {
        S_reference *res;
        for(res=lab->refs; res!=NULL && res->usage!=UsageDefined; res=res->next) ;
        if (res == NULL) {
                sprintf(tmpBuff,"jump to unknown label '%s'\n",lab->name);
                error(ERR_ST,tmpBuff);
        }
        return(res);
}
static S_programGraphNode *getLabelGraphAddress(S_programGraphNode *program,
                                                                                                S_symbolRefItem *lab
                                                                                        ) {
        S_programGraphNode *res;
        S_reference *defref;
        { if (!(lab->b.symType == TypeLabel)) internalCheckFail("lab->b.symType == TypeLabel", "extract.c", 144);};
        defref = getDefinitionReference(lab);
        res = getGraphAddress(program, defref);
        return(res);
}
static int linearOrder(S_programGraphNode *n1, S_programGraphNode *n2) {
        return(n1->ref < n2->ref);
}
static S_programGraphNode * extMakeProgramGraph() {
        S_programGraphNode *program,*p;
        program = NULL;
        refTabMap5(&s_cxrefTab, extractFunGraphRef, ((void *) &program));
        { register S_programGraphNode *tmpInList, *tmptmp; S_programGraphNode *tmpOutList; tmpOutList = NULL; tmpInList = program; while (tmpInList!=NULL) { tmptmp = tmpInList->next; tmpInList->next = NULL; { S_programGraphNode **ptmp; { register S_programGraphNode *tmp,**lStMp; tmp = *((&tmpOutList)); lStMp = (&tmpOutList); while (tmp!=NULL && linearOrder(tmp, ((tmpInList)))) { lStMp = &(tmp->next); tmp = *lStMp; } ptmp = lStMp; }; {(tmpInList)->next = ((*ptmp)); (*ptmp) = tmpInList;}; }; tmpInList = tmptmp; } program = tmpOutList;};
        for(p=program; p!=NULL; p=p->next) {
                if (p->symRef->b.symType==TypeLabel && p->ref->usage!=UsageDefined) {
                        p->jump = getLabelGraphAddress(program, p->symRef);
                }
        }
        return(program);
}
static void extSetSetStates( S_programGraphNode *p,
                                                                S_symbolRefItem *symRef,
                                                                unsigned cstate
                                                        ) {
        unsigned cpos,oldStateBits;
        for(; p!=NULL; p=p->next) {
                cont:
                if (p->stateBits == cstate) return;
                oldStateBits = p->stateBits;
                cstate = p->stateBits = (cstate | oldStateBits | 1);
                cpos = p->posBits | 1;
                if (p->symRef == symRef) {
                        if (p->ref->usage == UsageAddrUsed) {
                                cstate = cpos;
                        } else if (p->ref->usage == UsageLvalUsed
                                        || (p->ref->usage == UsageDefined
                                                && ! (p->symRef->name[0]=='*'))
                                ) {
                                p->stateBits = cstate = cpos;
                        }
                } else if (p->symRef->b.symType==TypeBlockMarker &&
                                        (p->posBits&2) == 0) {
                        if (cstate & 2) {
                                cstate |= 8;
                        }
                        if (cstate & 4) {
                                cstate |= 16;
                        }
                } else if (p->symRef->b.symType==TypeLabel) {
                        if (p->ref->usage==UsageUsed) {
                                p = p->jump;
                                goto cont;
                        } else if (p->ref->usage==UsageFork) {
                                extSetSetStates(p->jump, symRef, cstate);
                        }
                }
        }
}
static int extCategorizeLocalVar0( S_programGraphNode *program,
                                                                        S_programGraphNode *varRef
                                                                ) {
        S_programGraphNode *p;
        S_symbolRefItem *symRef;
        unsigned inUsages,outUsages,outUsageBothExists;
        symRef = varRef->symRef;
        for(p=program; p!=NULL; p=p->next) {
                p->stateBits = 0;
        }
        extSetSetStates(program, symRef, 1);
        inUsages = outUsages = outUsageBothExists = 0;
        for(p=program; p!=NULL; p=p->next) {
                if (p->symRef == varRef->symRef && p->ref->usage != UsageNone) {
                        if (p->posBits==2) {
                                inUsages |= p->stateBits;
                        } else if (p->posBits==4) {
                                outUsages |= p->stateBits;
                        } else { if (!(0)) internalCheckFail("0", "extract.c", 250);};
                }
        }
        if (varRef->posBits == 4) {
                if (outUsages & 2) {
                        if ((inUsages & 8) == 0
                                && (inUsages & 4) == 0
                                && (outUsages & 16) == 0
                                ) {
                                return(EXTRACT_OUT_ARGUMENT);
                        } else {
                                return(EXTRACT_IN_OUT_ARGUMENT);
                        }
                }
                if (inUsages & 8) return(EXTRACT_IN_OUT_ARGUMENT);
                if (inUsages & 4) return(EXTRACT_VALUE_ARGUMENT);
                if (inUsages) return(EXTRACT_LOCAL_VAR);
                return(EXTRACT_NONE);
        } else {
                if ( outUsages & 2
                        || outUsages & 4) {
                        return(EXTRACT_LOCAL_OUT_ARGUMENT);
                } else {
                        return(EXTRACT_NONE);
                }
        }
}
static int extCategorizeLocalVar( S_programGraphNode *program,
                                                                        S_programGraphNode *varRef
                                                                ) {
        int res;
        res = extCategorizeLocalVar0(program, varRef);
        if ((varRef->symRef->name[0]=='*')
                && res!=EXTRACT_NONE && res!=EXTRACT_LOCAL_VAR) {
                return(EXTRACT_ADDRESS_ARGUMENT);
        }
        return(res);
}
static void extSetInOutBlockFields(S_programGraphNode *program) {
        S_programGraphNode *p;
        unsigned pos;
        pos = 4;
        for(p=program; p!=NULL; p=p->next) {
                if (p->symRef->b.symType == TypeBlockMarker) { if (pos==2) pos = 4; else if (pos==4) pos = 2; else { if (!(0)) internalCheckFail("0", "extract.c", 305);};};
                p->posBits = pos;
        }
}
static int extIsJumpInOutBlock(S_programGraphNode *program) {
        S_programGraphNode *p;
        for(p=program; p!=NULL; p=p->next) {
                if (p->symRef->b.symType==TypeLabel) {
                        if (p->ref->usage==UsageUsed || p->ref->usage==UsageFork) {
                                if (p->posBits != p->jump->posBits) {
                                        return(1);
                                }
                        }
                }
        }
        return(0);
}
static void extClassifyLocalVariables(S_programGraphNode *program) {
        S_programGraphNode *p;
        for(p=program; p!=NULL; p=p->next) {
                if (( p->ref->usage==UsageDefined && p->symRef->b.symType==TypeDefault && p->symRef->b.scope==ScopeAuto )) {
                        p->classifBits = extCategorizeLocalVar(program,p);
                }
        }
}
static void extReClassifyIOVars(S_programGraphNode *program) {
        S_programGraphNode *p,*op;
        int uniqueOutFlag;
        op = NULL; uniqueOutFlag = 1;
        for(p=program; p!=NULL; p=p->next) {
                if (s_opt.extractMode == EXTR_FUNCTION_ADDRESS_ARGS) {
                        if ( p->classifBits == EXTRACT_OUT_ARGUMENT
                                        || p->classifBits == EXTRACT_LOCAL_OUT_ARGUMENT
                                        || p->classifBits == EXTRACT_IN_OUT_ARGUMENT
                                ) {
                                p->classifBits = EXTRACT_ADDRESS_ARGUMENT;
                        }
                } else if (s_opt.extractMode == EXTR_FUNCTION) {
                        if (p->classifBits == EXTRACT_OUT_ARGUMENT
                                || p->classifBits == EXTRACT_LOCAL_OUT_ARGUMENT
                                ) {
                                if (op == NULL) op = p;
                                else uniqueOutFlag = 0;
                        }
                }
        }
        if (op!=NULL && uniqueOutFlag) {
                if (op->classifBits == EXTRACT_LOCAL_OUT_ARGUMENT) {
                        op->classifBits = EXTRACT_LOCAL_RESULT_VALUE;
                } else {
                        op->classifBits = EXTRACT_RESULT_VALUE;
                }
                return;
        }
        op = NULL; uniqueOutFlag = 1;
        for(p=program; p!=NULL; p=p->next) {
                if (s_opt.extractMode == EXTR_FUNCTION) {
                        if (p->classifBits == EXTRACT_IN_OUT_ARGUMENT) {
                                if (op == NULL) op = p;
                                else uniqueOutFlag = 0;
                        }
                }
        }
        if (op!=NULL && uniqueOutFlag) {
                op->classifBits = EXTRACT_IN_RESULT_VALUE;
                return;
        }
}
static void extGenNewMacroCall(S_programGraphNode *program) {
        char dcla[TMP_STRING_SIZE];
        char decl[TMP_STRING_SIZE];
        char name[TMP_STRING_SIZE];
        S_programGraphNode *p;
        char *declAddr;
        int i, fFlag=1;
        rb[0]=0;
        sprintf(rb+strlen(rb),"\t%s",s_opt.extractName);
        for(p=program; p!=NULL; p=p->next) {
                if ( p->classifBits == EXTRACT_VALUE_ARGUMENT
                        || p->classifBits == EXTRACT_IN_OUT_ARGUMENT
                        || p->classifBits == EXTRACT_ADDRESS_ARGUMENT
                        || p->classifBits == EXTRACT_OUT_ARGUMENT
                        || p->classifBits == EXTRACT_LOCAL_OUT_ARGUMENT
                        || p->classifBits == EXTRACT_RESULT_VALUE
                        || p->classifBits == EXTRACT_IN_RESULT_VALUE
                        || p->classifBits == EXTRACT_LOCAL_VAR) {
                        { register char *s,*d,*dn,*dd; int nLen; for( s=p->symRef->name+1,d=decl,dd=dcla; *s!=0 && *s!='!'; s++,d++,dd++) { *d = *dd = *s; } *dd = 0; { if (!(*s)) internalCheckFail("*s", "extract.c", 457);}; for(s++; *s!=0 && *s!='!'; s++,d++) { *d = *s; } { if (!(*s)) internalCheckFail("*s", "extract.c", 457);}; d = strmcpy(d, ""); for(dn=name,s++; *s!=0 && *s!='!'; s++,dn++) { *dn = *s; if (1) *d++ = *s; } { if (!(*s)) internalCheckFail("*s", "extract.c", 457);}; *dn = 0; { if (!(*s)) internalCheckFail("*s", "extract.c", 457);}; for(s++; *s!=0 && *s!='!'; s++,d++) { *d = *s; } *d = 0;};
                        sprintf(rb+strlen(rb), "%s%s", fFlag?"(":", " , name);
                        fFlag = 0;
                }
        }
        sprintf(rb+strlen(rb), "%s);\n", fFlag?"(":"");
        { if (!(strlen(rb)<500000 -1)) internalCheckFail("strlen(rb)<EXTRACT_GEN_BUFFER_SIZE-1", "extract.c", 464);};
        if (s_opt.xref2) {
                ppcGenRecord(PPC_STRING_VALUE, rb, "\n");
        } else {
                fprintf(ccOut, "%s", rb);
        }
}
static void extGenNewMacroHead(S_programGraphNode *program) {
        char nhead[MAX_EXTRACT_FUN_HEAD_SIZE];
        int nhi;
        char dcla[TMP_STRING_SIZE];
        char decl[MAX_EXTRACT_FUN_HEAD_SIZE];
        char name[MAX_EXTRACT_FUN_HEAD_SIZE];
        S_programGraphNode *p,*op;
        char *declAddr;
        int i, uniqueOutFlag, fFlag=1;
        rb[0]=0;
        sprintf(rb+strlen(rb),"#define %s",s_opt.extractName);
        for(p=program; p!=NULL; p=p->next) {
                if ( p->classifBits == EXTRACT_VALUE_ARGUMENT
                        || p->classifBits == EXTRACT_IN_OUT_ARGUMENT
                        || p->classifBits == EXTRACT_OUT_ARGUMENT
                        || p->classifBits == EXTRACT_LOCAL_OUT_ARGUMENT
                        || p->classifBits == EXTRACT_ADDRESS_ARGUMENT
                        || p->classifBits == EXTRACT_RESULT_VALUE
                        || p->classifBits == EXTRACT_IN_RESULT_VALUE
                        || p->classifBits == EXTRACT_LOCAL_VAR) {
                        { register char *s,*d,*dn,*dd; int nLen; for( s=p->symRef->name+1,d=decl,dd=dcla; *s!=0 && *s!='!'; s++,d++,dd++) { *d = *dd = *s; } *dd = 0; { if (!(*s)) internalCheckFail("*s", "extract.c", 494);}; for(s++; *s!=0 && *s!='!'; s++,d++) { *d = *s; } { if (!(*s)) internalCheckFail("*s", "extract.c", 494);}; d = strmcpy(d, ""); for(dn=name,s++; *s!=0 && *s!='!'; s++,dn++) { *dn = *s; if (1) *d++ = *s; } { if (!(*s)) internalCheckFail("*s", "extract.c", 494);}; *dn = 0; { if (!(*s)) internalCheckFail("*s", "extract.c", 494);}; for(s++; *s!=0 && *s!='!'; s++,d++) { *d = *s; } *d = 0;};
                        sprintf(rb+strlen(rb), "%s%s", fFlag?"(":"," , name);
                        fFlag = 0;
                }
        }
        sprintf(rb+strlen(rb), "%s) {\\\n", fFlag?"(":"");
        { if (!(strlen(rb)<500000 -1)) internalCheckFail("strlen(rb)<EXTRACT_GEN_BUFFER_SIZE-1", "extract.c", 500);};
        if (s_opt.xref2) {
                ppcGenRecord(PPC_STRING_VALUE, rb, "\n");
        } else {
                fprintf(ccOut, "%s", rb);
        }
}
static void extGenNewMacroTail(S_programGraphNode *program) {
        rb[0]=0;
        sprintf(rb+strlen(rb),"}\n\n");
        { if (!(strlen(rb)<500000 -1)) internalCheckFail("strlen(rb)<EXTRACT_GEN_BUFFER_SIZE-1", "extract.c", 513);};
        if (s_opt.xref2) {
                ppcGenRecord(PPC_STRING_VALUE, rb, "\n");
        } else {
                fprintf(ccOut, "%s", rb);
        }
}
static void extGenNewFunCall(S_programGraphNode *program) {
        char dcla[TMP_STRING_SIZE];
        char decl[TMP_STRING_SIZE];
        char name[TMP_STRING_SIZE];
        S_programGraphNode *p;
        char *declAddr;
        int i, fFlag=1;
        rb[0]=0;
        for(p=program; p!=NULL; p=p->next) {
                if (p->classifBits == EXTRACT_RESULT_VALUE
                        || p->classifBits == EXTRACT_LOCAL_RESULT_VALUE
                        || p->classifBits == EXTRACT_IN_RESULT_VALUE
                        ) break;
        }
        if (p!=NULL) {
                { register char *s,*d,*dn,*dd; int nLen; for( s=p->symRef->name+1,d=decl,dd=dcla; *s!=0 && *s!='!'; s++,d++,dd++) { *d = *dd = *s; } *dd = 0; { if (!(*s)) internalCheckFail("*s", "extract.c", 543);}; for(s++; *s!=0 && *s!='!'; s++,d++) { *d = *s; } { if (!(*s)) internalCheckFail("*s", "extract.c", 543);}; d = strmcpy(d, ""); for(dn=name,s++; *s!=0 && *s!='!'; s++,dn++) { *dn = *s; if (1) *d++ = *s; } { if (!(*s)) internalCheckFail("*s", "extract.c", 543);}; *dn = 0; { if (!(*s)) internalCheckFail("*s", "extract.c", 543);}; for(s++; *s!=0 && *s!='!'; s++,d++) { *d = *s; } *d = 0;};
                if (p->classifBits == EXTRACT_LOCAL_RESULT_VALUE) {
                        sprintf(rb+strlen(rb),"\t%s = ", decl);
                } else {
                        sprintf(rb+strlen(rb),"\t%s = ", name);
                }
        } else {
                sprintf(rb+strlen(rb),"\t");
        }
        sprintf(rb+strlen(rb),"%s",s_opt.extractName);
        for(p=program; p!=NULL; p=p->next) {
                if (p->classifBits == EXTRACT_VALUE_ARGUMENT
                        || p->classifBits == EXTRACT_IN_RESULT_VALUE) {
                        { register char *s,*d,*dn,*dd; int nLen; for( s=p->symRef->name+1,d=decl,dd=dcla; *s!=0 && *s!='!'; s++,d++,dd++) { *d = *dd = *s; } *dd = 0; { if (!(*s)) internalCheckFail("*s", "extract.c", 557);}; for(s++; *s!=0 && *s!='!'; s++,d++) { *d = *s; } { if (!(*s)) internalCheckFail("*s", "extract.c", 557);}; d = strmcpy(d, ""); for(dn=name,s++; *s!=0 && *s!='!'; s++,dn++) { *dn = *s; if (1) *d++ = *s; } { if (!(*s)) internalCheckFail("*s", "extract.c", 557);}; *dn = 0; { if (!(*s)) internalCheckFail("*s", "extract.c", 557);}; for(s++; *s!=0 && *s!='!'; s++,d++) { *d = *s; } *d = 0;};
                        sprintf(rb+strlen(rb), "%s%s", fFlag?"(":", " , name);
                        fFlag = 0;
                }
        }
        for(p=program; p!=NULL; p=p->next) {
                if ( p->classifBits == EXTRACT_IN_OUT_ARGUMENT
                        || p->classifBits == EXTRACT_ADDRESS_ARGUMENT
                        || p->classifBits == EXTRACT_OUT_ARGUMENT
                        || p->classifBits == EXTRACT_LOCAL_OUT_ARGUMENT
                        ) {
                        { register char *s,*d,*dn,*dd; int nLen; for( s=p->symRef->name+1,d=decl,dd=dcla; *s!=0 && *s!='!'; s++,d++,dd++) { *d = *dd = *s; } *dd = 0; { if (!(*s)) internalCheckFail("*s", "extract.c", 568);}; for(s++; *s!=0 && *s!='!'; s++,d++) { *d = *s; } { if (!(*s)) internalCheckFail("*s", "extract.c", 568);}; d = strmcpy(d, s_opt.olExtractAddrParPrefix); for(dn=name,s++; *s!=0 && *s!='!'; s++,dn++) { *dn = *s; if (1) *d++ = *s; } { if (!(*s)) internalCheckFail("*s", "extract.c", 568);}; *dn = 0; { if (!(*s)) internalCheckFail("*s", "extract.c", 568);}; for(s++; *s!=0 && *s!='!'; s++,d++) { *d = *s; } *d = 0;};
                        sprintf(rb+strlen(rb), "%s&%s", fFlag?"(":", " , name);
                        fFlag = 0;
                }
        }
        sprintf(rb+strlen(rb), "%s);\n", fFlag?"(":"");
        { if (!(strlen(rb)<500000 -1)) internalCheckFail("strlen(rb)<EXTRACT_GEN_BUFFER_SIZE-1", "extract.c", 575);};
        if (s_opt.xref2) {
                ppcGenRecord(PPC_STRING_VALUE, rb, "\n");
        } else {
                fprintf(ccOut, "%s", rb);
        }
}
static void removeSymbolFromSymRefList(S_symbolRefItemList **ll, S_symbolRefItem *s) {
        S_symbolRefItemList **r;
        r=ll;
        while (*r!=NULL) {
                if (isSmallerOrEqClass(getClassNumFromClassLinkName((*r)->d->name, s_noneFileIndex),
                                                           getClassNumFromClassLinkName(s->name, s_noneFileIndex))) {
                        *r = (*r)->next;
                } else {
                        r= &(*r)->next;
                }
        }
}
static void addSymbolToSymRefList(S_symbolRefItemList **ll, S_symbolRefItem *s) {
        S_symbolRefItemList *r, *rr;
        r = *ll;
        while (r!=NULL) {
                if (isSmallerOrEqClass(getClassNumFromClassLinkName(s->name, s_noneFileIndex),
                                                           getClassNumFromClassLinkName(r->d->name, s_noneFileIndex))) {
                        return;
                }
                r= r->next;
        }
        removeSymbolFromSymRefList(ll, s);
        {{{ { if (!((1) >= 0)) internalCheckFail("(1) >= 0", "extract.c", 608);}; cxMemory->i = ((char*)(((char*)(((char*)&cxMemory->b)+cxMemory->i))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(((char*)&cxMemory->b)+cxMemory->i))-1) & (STANDARD_ALLIGNEMENT-1))))) - ((char*)&cxMemory->b); if (cxMemory->i+(1)*sizeof(S_symbolRefItemList) >= cxMemory->size) { if (cxMemory->overflowHandler(1)) longjmp(s_memoryResize,1); else fatalError(ERR_NO_MEMORY,"cxMemory", 65); } rr = (S_symbolRefItemList*) (((char*)&cxMemory->b) + cxMemory->i); cxMemory->i += (1)*sizeof(S_symbolRefItemList);};};};
        { (rr)->d = s; (rr)->next = *ll;};
        *ll = rr;
}
static S_symbolRefItemList *computeExceptionsThrownBetween(S_programGraphNode *bb,
                                                                                                                   S_programGraphNode *ee
        ) {
        S_symbolRefItemList *res, *excs, *catched, *noncatched, **cl;
        S_programGraphNode *p, *b, *e;
        int deep;
        catched = NULL; noncatched = NULL; cl = &catched;
        for(p=bb; p!=NULL && p!=ee; p=p->next) {
                if (p->symRef->b.symType == TypeTryCatchMarker && p->ref->usage == UsageTryCatchBegin) {
                        deep = 0;
                        for(e=p; e!=NULL && e!=ee; e=e->next) {
                                if (e->symRef->b.symType == TypeTryCatchMarker) {
                                        if (e->ref->usage == UsageTryCatchBegin) deep++;
                                        else deep --;
                                        if (deep == 0) break;
                                }
                        }
                        if (deep==0) {
                                for(excs=computeExceptionsThrownBetween(p->next,e); excs!=NULL; excs=excs->next){
                                        addSymbolToSymRefList(cl, excs->d);
                                }
                        }
                }
                if (p->ref->usage == UsageThrown) {
                        addSymbolToSymRefList(cl, p->symRef);
                } else if (p->ref->usage == UsageCatched) {
                        removeSymbolFromSymRefList(&catched, p->symRef);
                        cl = &noncatched;
                }
        }
        res = catched;
        for(excs=noncatched; excs!=NULL; excs=excs->next) {
                addSymbolToSymRefList(&res, excs->d);
        }
        return(res);
}
static S_symbolRefItemList *computeExceptionsThrownInBlock(S_programGraphNode *program) {
        S_programGraphNode *pp, *ee;
        for(pp=program; pp!=NULL && pp->symRef->b.symType!=TypeBlockMarker; pp=pp->next) ;
        if (pp==NULL) return(NULL);
        for(ee=pp->next; ee!=NULL && ee->symRef->b.symType!=TypeBlockMarker; ee=ee->next) ;
        return(computeExceptionsThrownBetween(pp, ee));
}
static void extractSprintThrownExceptions(char *nhead, S_programGraphNode *program) {
        S_symbolRefItemList *exceptions, *ee;
        int nhi;
        char *sname;
        nhi = 0;
        exceptions = computeExceptionsThrownInBlock(program);
        if (exceptions!=NULL) {
                sprintf(nhead+nhi, " throws");
                nhi += strlen(nhead+nhi);
                for(ee=exceptions; ee!=NULL; ee=ee->next) {
                        sname = lastOccurenceInString(ee->d->name, '$');
                        if (sname==NULL) sname = lastOccurenceInString(ee->d->name, '/');
                        if (sname==NULL) {
                                sname = ee->d->name;
                        } else {
                                sname ++;
                        }
                        sprintf(nhead+nhi, "%s%s", ee==exceptions?" ":", ", sname);
                        nhi += strlen(nhead+nhi);
                }
        }
}
static void extGenNewFunHead(S_programGraphNode *program) {
        char nhead[MAX_EXTRACT_FUN_HEAD_SIZE];
        int nhi,ldclaLen;
        char ldcla[TMP_STRING_SIZE];
        char dcla[TMP_STRING_SIZE];
        char decl[MAX_EXTRACT_FUN_HEAD_SIZE];
        char name[MAX_EXTRACT_FUN_HEAD_SIZE];
        S_programGraphNode *p,*op;
        char *declAddr;
        int i, uniqueOutFlag, fFlag=1;
        S_symbolRefItemList *exceptions, *ee;
        rb[0]=0;
        nhi = 0;
        sprintf(nhead+nhi,"%s",s_opt.extractName);
        nhi += strlen(nhead+nhi);
        for(p=program; p!=NULL; p=p->next) {
                if (p->classifBits == EXTRACT_VALUE_ARGUMENT
                        || p->classifBits == EXTRACT_IN_RESULT_VALUE
                        ) {
                        { register char *s,*d,*dn,*dd; int nLen; for( s=p->symRef->name+1,d=decl,dd=dcla; *s!=0 && *s!='!'; s++,d++,dd++) { *d = *dd = *s; } *dd = 0; { if (!(*s)) internalCheckFail("*s", "extract.c", 708);}; for(s++; *s!=0 && *s!='!'; s++,d++) { *d = *s; } { if (!(*s)) internalCheckFail("*s", "extract.c", 708);}; d = strmcpy(d, ""); for(dn=name,s++; *s!=0 && *s!='!'; s++,dn++) { *dn = *s; if (1) *d++ = *s; } { if (!(*s)) internalCheckFail("*s", "extract.c", 708);}; *dn = 0; { if (!(*s)) internalCheckFail("*s", "extract.c", 708);}; for(s++; *s!=0 && *s!='!'; s++,d++) { *d = *s; } *d = 0;};
                        sprintf(nhead+nhi, "%s%s", fFlag?"(":", " , decl);
                        nhi += strlen(nhead+nhi);
                        fFlag = 0;
                }
        }
        for(p=program; p!=NULL; p=p->next) {
                if ( p->classifBits == EXTRACT_IN_OUT_ARGUMENT
                                || p->classifBits == EXTRACT_OUT_ARGUMENT
                                || p->classifBits == EXTRACT_LOCAL_OUT_ARGUMENT
                        ) {
                        { register char *s,*d,*dn,*dd; int nLen; for( s=p->symRef->name+1,d=decl,dd=dcla; *s!=0 && *s!='!'; s++,d++,dd++) { *d = *dd = *s; } *dd = 0; { if (!(*s)) internalCheckFail("*s", "extract.c", 719);}; for(s++; *s!=0 && *s!='!'; s++,d++) { *d = *s; } { if (!(*s)) internalCheckFail("*s", "extract.c", 719);}; d = strmcpy(d, s_opt.olExtractAddrParPrefix); for(dn=name,s++; *s!=0 && *s!='!'; s++,dn++) { *dn = *s; if (1) *d++ = *s; } { if (!(*s)) internalCheckFail("*s", "extract.c", 719);}; *dn = 0; { if (!(*s)) internalCheckFail("*s", "extract.c", 719);}; for(s++; *s!=0 && *s!='!'; s++,d++) { *d = *s; } *d = 0;};
                        sprintf(nhead+nhi, "%s%s", fFlag?"(":", " , decl);
                        nhi += strlen(nhead+nhi);
                        fFlag = 0;
                }
        }
        for(p=program; p!=NULL; p=p->next) {
                if (p->classifBits == EXTRACT_ADDRESS_ARGUMENT) {
                        { register char *s,*d,*dn,*dd; int nLen; for( s=p->symRef->name+1,d=decl,dd=dcla; *s!=0 && *s!='!'; s++,d++,dd++) { *d = *dd = *s; } *dd = 0; { if (!(*s)) internalCheckFail("*s", "extract.c", 728);}; for(s++; *s!=0 && *s!='!'; s++,d++) { *d = *s; } { if (!(*s)) internalCheckFail("*s", "extract.c", 728);}; d = strmcpy(d, EXTRACT_REFERENCE_ARG_STRING); for(dn=name,s++; *s!=0 && *s!='!'; s++,dn++) { *dn = *s; if (1) *d++ = *s; } { if (!(*s)) internalCheckFail("*s", "extract.c", 728);}; *dn = 0; { if (!(*s)) internalCheckFail("*s", "extract.c", 728);}; for(s++; *s!=0 && *s!='!'; s++,d++) { *d = *s; } *d = 0;};
                        sprintf(nhead+nhi, "%s%s", fFlag?"(":", " , decl);
                        nhi += strlen(nhead+nhi);
                        fFlag = 0;
                }
        }
        sprintf(nhead+nhi, "%s)", fFlag?"(":"");
        nhi += strlen(nhead+nhi);
        extractSprintThrownExceptions(nhead+nhi, program);
        nhi += strlen(nhead+nhi);
        if (((s_language & (4)) != 0) && (s_javaExtractFromFunctionMods&0x008)==0){
                sprintf(rb+strlen(rb), "");
        } else {
                sprintf(rb+strlen(rb), "static ");
        }
        for(p=program; p!=NULL; p=p->next) {
                if (p->classifBits == EXTRACT_RESULT_VALUE
                        || p->classifBits == EXTRACT_LOCAL_RESULT_VALUE
                        || p->classifBits == EXTRACT_IN_RESULT_VALUE) break;
        }
        if (p==NULL) {
                sprintf(rb+strlen(rb),"void %s",nhead);
        } else {
                { register char *s,*d,*dn,*dd; int nLen; for( s=p->symRef->name+1,d=decl,dd=dcla; *s!=0 && *s!='!'; s++,d++,dd++) { *d = *dd = *s; } *dd = 0; { if (!(*s)) internalCheckFail("*s", "extract.c", 755);}; for(s++; *s!=0 && *s!='!'; s++,d++) { *d = *s; } { if (!(*s)) internalCheckFail("*s", "extract.c", 755);}; d = strmcpy(d, nhead); for(dn=name,s++; *s!=0 && *s!='!'; s++,dn++) { *dn = *s; if (0) *d++ = *s; } { if (!(*s)) internalCheckFail("*s", "extract.c", 755);}; *dn = 0; { if (!(*s)) internalCheckFail("*s", "extract.c", 755);}; for(s++; *s!=0 && *s!='!'; s++,d++) { *d = *s; } *d = 0;};
                sprintf(rb+strlen(rb), "%s", decl);
        }
        sprintf(rb+strlen(rb), " {\n");
        ldcla[0] = 0; ldclaLen = 0; fFlag = 1;
        for(p=program; p!=NULL; p=p->next) {
                if ( p->classifBits == EXTRACT_IN_OUT_ARGUMENT
                                        || p->classifBits == EXTRACT_LOCAL_VAR
                                        || p->classifBits == EXTRACT_OUT_ARGUMENT
                                        || p->classifBits == EXTRACT_RESULT_VALUE
                                        || ( p->symRef->b.storage == StorageExtern
                                                        && p->ref->usage == UsageDeclared)
                        ) {
                        { register char *s,*d,*dn,*dd; int nLen; for( s=p->symRef->name+1,d=decl,dd=dcla; *s!=0 && *s!='!'; s++,d++,dd++) { *d = *dd = *s; } *dd = 0; { if (!(*s)) internalCheckFail("*s", "extract.c", 771);}; for(s++; *s!=0 && *s!='!'; s++,d++) { *d = *s; } { if (!(*s)) internalCheckFail("*s", "extract.c", 771);}; d = strmcpy(d, ""); for(dn=name,s++; *s!=0 && *s!='!'; s++,dn++) { *dn = *s; if (1) *d++ = *s; } { if (!(*s)) internalCheckFail("*s", "extract.c", 771);}; *dn = 0; { if (!(*s)) internalCheckFail("*s", "extract.c", 771);}; for(s++; *s!=0 && *s!='!'; s++,d++) { *d = *s; } *d = 0;};
                        if (strcmp(ldcla,dcla)==0) {
                                sprintf(rb+strlen(rb), ",%s",decl+ldclaLen);
                        } else {
                                strcpy(ldcla,dcla); ldclaLen=strlen(ldcla);
                                if (fFlag) sprintf(rb+strlen(rb), "\t%s",decl);
                                else sprintf(rb+strlen(rb), ";\n\t%s",decl);
                        }
                        if (p->classifBits == EXTRACT_IN_OUT_ARGUMENT) {
                                sprintf(rb+strlen(rb), " = %s%s", s_opt.olExtractAddrParPrefix, name);
                        }
                        fFlag = 0;
                }
        }
        if (fFlag == 0) sprintf(rb+strlen(rb), ";\n");
        { if (!(strlen(rb)<500000 -1)) internalCheckFail("strlen(rb)<EXTRACT_GEN_BUFFER_SIZE-1", "extract.c", 786);};
        if (s_opt.xref2) {
                ppcGenRecord(PPC_STRING_VALUE, rb, "\n");
        } else {
                fprintf(ccOut, "%s", rb);
        }
}
static void extGenNewFunTail(S_programGraphNode *program) {
        char dcla[TMP_STRING_SIZE];
        char decl[TMP_STRING_SIZE];
        char name[TMP_STRING_SIZE];
        S_programGraphNode *p;
        rb[0]=0;
        for(p=program; p!=NULL; p=p->next) {
                if ( p->classifBits == EXTRACT_IN_OUT_ARGUMENT
                        || p->classifBits == EXTRACT_OUT_ARGUMENT
                        || p->classifBits == EXTRACT_LOCAL_OUT_ARGUMENT
                        ) {
                        { register char *s,*d,*dn,*dd; int nLen; for( s=p->symRef->name+1,d=decl,dd=dcla; *s!=0 && *s!='!'; s++,d++,dd++) { *d = *dd = *s; } *dd = 0; { if (!(*s)) internalCheckFail("*s", "extract.c", 807);}; for(s++; *s!=0 && *s!='!'; s++,d++) { *d = *s; } { if (!(*s)) internalCheckFail("*s", "extract.c", 807);}; d = strmcpy(d, ""); for(dn=name,s++; *s!=0 && *s!='!'; s++,dn++) { *dn = *s; if (1) *d++ = *s; } { if (!(*s)) internalCheckFail("*s", "extract.c", 807);}; *dn = 0; { if (!(*s)) internalCheckFail("*s", "extract.c", 807);}; for(s++; *s!=0 && *s!='!'; s++,d++) { *d = *s; } *d = 0;};
                        sprintf(rb+strlen(rb), "\t%s%s = %s;\n", s_opt.olExtractAddrParPrefix,
                                        name, name);
                }
        }
        for(p=program; p!=NULL; p=p->next) {
                if (p->classifBits == EXTRACT_RESULT_VALUE
                        || p->classifBits == EXTRACT_IN_RESULT_VALUE
                        || p->classifBits == EXTRACT_LOCAL_RESULT_VALUE
                        ) {
                        { register char *s,*d,*dn,*dd; int nLen; for( s=p->symRef->name+1,d=decl,dd=dcla; *s!=0 && *s!='!'; s++,d++,dd++) { *d = *dd = *s; } *dd = 0; { if (!(*s)) internalCheckFail("*s", "extract.c", 817);}; for(s++; *s!=0 && *s!='!'; s++,d++) { *d = *s; } { if (!(*s)) internalCheckFail("*s", "extract.c", 817);}; d = strmcpy(d, ""); for(dn=name,s++; *s!=0 && *s!='!'; s++,dn++) { *dn = *s; if (1) *d++ = *s; } { if (!(*s)) internalCheckFail("*s", "extract.c", 817);}; *dn = 0; { if (!(*s)) internalCheckFail("*s", "extract.c", 817);}; for(s++; *s!=0 && *s!='!'; s++,d++) { *d = *s; } *d = 0;};
                        sprintf(rb+strlen(rb), "\treturn(%s);\n", name);
                }
        }
        sprintf(rb+strlen(rb),"}\n\n");
        { if (!(strlen(rb)<500000 -1)) internalCheckFail("strlen(rb)<EXTRACT_GEN_BUFFER_SIZE-1", "extract.c", 822);};
        if (s_opt.xref2) {
                ppcGenRecord(PPC_STRING_VALUE, rb, "\n");
        } else {
                fprintf(ccOut, "%s", rb);
        }
}
static char * extJavaNewClassName() {
  static char classname[TMP_STRING_SIZE];
  if (s_opt.extractName[0]==0) {
        sprintf(classname,"NewClass");
  } else {
        sprintf(classname, "%c%s", toupper(s_opt.extractName[0]),
                        s_opt.extractName+1);
  }
  return(classname);
}
static void extJavaGenNewClassCall(S_programGraphNode *program) {
        char dcla[TMP_STRING_SIZE];
        char decl[TMP_STRING_SIZE];
        char name[TMP_STRING_SIZE];
        S_programGraphNode *p;
        char *declAddr,*classname;
        int i, fFlag=1;
        rb[0]=0;
        classname = extJavaNewClassName();
        sprintf(rb+strlen(rb),"\t\t%s %s = new %s",classname, s_opt.extractName,classname);
        fFlag = 1;
        for(p=program; p!=NULL; p=p->next) {
          if (p->classifBits == EXTRACT_IN_OUT_ARGUMENT) {
                { register char *s,*d,*dn,*dd; int nLen; for( s=p->symRef->name+1,d=decl,dd=dcla; *s!=0 && *s!='!'; s++,d++,dd++) { *d = *dd = *s; } *dd = 0; { if (!(*s)) internalCheckFail("*s", "extract.c", 877);}; for(s++; *s!=0 && *s!='!'; s++,d++) { *d = *s; } { if (!(*s)) internalCheckFail("*s", "extract.c", 877);}; d = strmcpy(d, ""); for(dn=name,s++; *s!=0 && *s!='!'; s++,dn++) { *dn = *s; if (1) *d++ = *s; } { if (!(*s)) internalCheckFail("*s", "extract.c", 877);}; *dn = 0; { if (!(*s)) internalCheckFail("*s", "extract.c", 877);}; for(s++; *s!=0 && *s!='!'; s++,d++) { *d = *s; } *d = 0;};
                sprintf(rb+strlen(rb), "%s%s", fFlag?"(":", " , name);
                fFlag = 0;
          }
        }
        sprintf(rb+strlen(rb), "%s);\n", fFlag?"(":"");
        for(p=program; p!=NULL; p=p->next) {
                if (p->classifBits == EXTRACT_RESULT_VALUE
                        || p->classifBits == EXTRACT_IN_RESULT_VALUE
                        || p->classifBits == EXTRACT_LOCAL_RESULT_VALUE
                        ) break;
        }
        if (p!=NULL) {
                { register char *s,*d,*dn,*dd; int nLen; for( s=p->symRef->name+1,d=decl,dd=dcla; *s!=0 && *s!='!'; s++,d++,dd++) { *d = *dd = *s; } *dd = 0; { if (!(*s)) internalCheckFail("*s", "extract.c", 892);}; for(s++; *s!=0 && *s!='!'; s++,d++) { *d = *s; } { if (!(*s)) internalCheckFail("*s", "extract.c", 892);}; d = strmcpy(d, ""); for(dn=name,s++; *s!=0 && *s!='!'; s++,dn++) { *dn = *s; if (1) *d++ = *s; } { if (!(*s)) internalCheckFail("*s", "extract.c", 892);}; *dn = 0; { if (!(*s)) internalCheckFail("*s", "extract.c", 892);}; for(s++; *s!=0 && *s!='!'; s++,d++) { *d = *s; } *d = 0;};
                if (p->classifBits == EXTRACT_LOCAL_RESULT_VALUE) {
                        sprintf(rb+strlen(rb),"\t\t%s = ", decl);
                } else {
                        sprintf(rb+strlen(rb),"\t\t%s = ", name);
                }
        } else {
                sprintf(rb+strlen(rb),"\t\t");
        }
        sprintf(rb+strlen(rb),"%s.perform",s_opt.extractName);
        fFlag=1;
        for(p=program; p!=NULL; p=p->next) {
                if (p->classifBits == EXTRACT_VALUE_ARGUMENT
                        || p->classifBits == EXTRACT_IN_RESULT_VALUE) {
                        { register char *s,*d,*dn,*dd; int nLen; for( s=p->symRef->name+1,d=decl,dd=dcla; *s!=0 && *s!='!'; s++,d++,dd++) { *d = *dd = *s; } *dd = 0; { if (!(*s)) internalCheckFail("*s", "extract.c", 907);}; for(s++; *s!=0 && *s!='!'; s++,d++) { *d = *s; } { if (!(*s)) internalCheckFail("*s", "extract.c", 907);}; d = strmcpy(d, ""); for(dn=name,s++; *s!=0 && *s!='!'; s++,dn++) { *dn = *s; if (1) *d++ = *s; } { if (!(*s)) internalCheckFail("*s", "extract.c", 907);}; *dn = 0; { if (!(*s)) internalCheckFail("*s", "extract.c", 907);}; for(s++; *s!=0 && *s!='!'; s++,d++) { *d = *s; } *d = 0;};
                        sprintf(rb+strlen(rb), "%s%s", fFlag?"(":", " , name);
                        fFlag = 0;
                }
        }
        sprintf(rb+strlen(rb), "%s);\n", fFlag?"(":"");
        sprintf(rb+strlen(rb), "\t\t");
        for(p=program; p!=NULL; p=p->next) {
                if ( p->classifBits == EXTRACT_IN_OUT_ARGUMENT
                        || p->classifBits == EXTRACT_OUT_ARGUMENT
                        || p->classifBits == EXTRACT_LOCAL_OUT_ARGUMENT
                        ) {
                        { register char *s,*d,*dn,*dd; int nLen; for( s=p->symRef->name+1,d=decl,dd=dcla; *s!=0 && *s!='!'; s++,d++,dd++) { *d = *dd = *s; } *dd = 0; { if (!(*s)) internalCheckFail("*s", "extract.c", 921);}; for(s++; *s!=0 && *s!='!'; s++,d++) { *d = *s; } { if (!(*s)) internalCheckFail("*s", "extract.c", 921);}; d = strmcpy(d, ""); for(dn=name,s++; *s!=0 && *s!='!'; s++,dn++) { *dn = *s; if (1) *d++ = *s; } { if (!(*s)) internalCheckFail("*s", "extract.c", 921);}; *dn = 0; { if (!(*s)) internalCheckFail("*s", "extract.c", 921);}; for(s++; *s!=0 && *s!='!'; s++,d++) { *d = *s; } *d = 0;};
                        if (p->classifBits == EXTRACT_LOCAL_OUT_ARGUMENT) {
                                sprintf(rb+strlen(rb), "%s=%s.%s; ", decl, s_opt.extractName, name);
                        } else {
                                sprintf(rb+strlen(rb), "%s=%s.%s; ", name, s_opt.extractName, name);
                        }
                        fFlag = 0;
                }
        }
        sprintf(rb+strlen(rb), "\n");
        sprintf(rb+strlen(rb),"\t\t%s = null;\n", s_opt.extractName);
        { if (!(strlen(rb)<500000 -1)) internalCheckFail("strlen(rb)<EXTRACT_GEN_BUFFER_SIZE-1", "extract.c", 934);};
        if (s_opt.xref2) {
                ppcGenRecord(PPC_STRING_VALUE, rb, "\n");
        } else {
                fprintf(ccOut, "%s", rb);
        }
}
static void extJavaGenNewClassHead(S_programGraphNode *program) {
        char nhead[MAX_EXTRACT_FUN_HEAD_SIZE];
        int nhi,ldclaLen;
        char ldcla[TMP_STRING_SIZE];
        char dcla[TMP_STRING_SIZE];
        char *classname;
        char decl[MAX_EXTRACT_FUN_HEAD_SIZE];
        char name[MAX_EXTRACT_FUN_HEAD_SIZE];
        S_programGraphNode *p,*op;
        char *declAddr, *mattrib;
        int i, uniqueOutFlag, fFlag=1;
        rb[0]=0;
        classname = extJavaNewClassName();
        sprintf(rb+strlen(rb), "\t");
        if (s_javaExtractFromFunctionMods & 0x008){
          sprintf(rb+strlen(rb), "static ");
        }
        sprintf(rb+strlen(rb), "class %s {\n", classname);
        for(p=program; p!=NULL; p=p->next) {
                if (p->classifBits == EXTRACT_OUT_ARGUMENT
                        || p->classifBits == EXTRACT_LOCAL_OUT_ARGUMENT
                        || p->classifBits == EXTRACT_IN_OUT_ARGUMENT
                        ) {
                        { register char *s,*d,*dn,*dd; int nLen; for( s=p->symRef->name+1,d=decl,dd=dcla; *s!=0 && *s!='!'; s++,d++,dd++) { *d = *dd = *s; } *dd = 0; { if (!(*s)) internalCheckFail("*s", "extract.c", 970);}; for(s++; *s!=0 && *s!='!'; s++,d++) { *d = *s; } { if (!(*s)) internalCheckFail("*s", "extract.c", 970);}; d = strmcpy(d, ""); for(dn=name,s++; *s!=0 && *s!='!'; s++,dn++) { *dn = *s; if (1) *d++ = *s; } { if (!(*s)) internalCheckFail("*s", "extract.c", 970);}; *dn = 0; { if (!(*s)) internalCheckFail("*s", "extract.c", 970);}; for(s++; *s!=0 && *s!='!'; s++,d++) { *d = *s; } *d = 0;};
                        sprintf(rb+strlen(rb), "\t\t%s;\n", decl);
                }
        }
        sprintf(rb+strlen(rb), "\t\t%s", classname);
        fFlag = 1;
        for(p=program; p!=NULL; p=p->next) {
                if ( p->classifBits == EXTRACT_IN_OUT_ARGUMENT){
                        { register char *s,*d,*dn,*dd; int nLen; for( s=p->symRef->name+1,d=decl,dd=dcla; *s!=0 && *s!='!'; s++,d++,dd++) { *d = *dd = *s; } *dd = 0; { if (!(*s)) internalCheckFail("*s", "extract.c", 982);}; for(s++; *s!=0 && *s!='!'; s++,d++) { *d = *s; } { if (!(*s)) internalCheckFail("*s", "extract.c", 982);}; d = strmcpy(d, ""); for(dn=name,s++; *s!=0 && *s!='!'; s++,dn++) { *dn = *s; if (1) *d++ = *s; } { if (!(*s)) internalCheckFail("*s", "extract.c", 982);}; *dn = 0; { if (!(*s)) internalCheckFail("*s", "extract.c", 982);}; for(s++; *s!=0 && *s!='!'; s++,d++) { *d = *s; } *d = 0;};
                        sprintf(rb+strlen(rb), "%s%s", fFlag?"(":", " , decl);
                        fFlag = 0;
                }
        }
        sprintf(rb+strlen(rb), "%s) {", fFlag?"(":"");
        fFlag = 1;
        for(p=program; p!=NULL; p=p->next) {
                if ( p->classifBits == EXTRACT_IN_OUT_ARGUMENT){
                        { register char *s,*d,*dn,*dd; int nLen; for( s=p->symRef->name+1,d=decl,dd=dcla; *s!=0 && *s!='!'; s++,d++,dd++) { *d = *dd = *s; } *dd = 0; { if (!(*s)) internalCheckFail("*s", "extract.c", 992);}; for(s++; *s!=0 && *s!='!'; s++,d++) { *d = *s; } { if (!(*s)) internalCheckFail("*s", "extract.c", 992);}; d = strmcpy(d, ""); for(dn=name,s++; *s!=0 && *s!='!'; s++,dn++) { *dn = *s; if (1) *d++ = *s; } { if (!(*s)) internalCheckFail("*s", "extract.c", 992);}; *dn = 0; { if (!(*s)) internalCheckFail("*s", "extract.c", 992);}; for(s++; *s!=0 && *s!='!'; s++,d++) { *d = *s; } *d = 0;};
                        if (fFlag) sprintf(rb+strlen(rb), "\n\t\t\t");
                        sprintf(rb+strlen(rb), "this.%s = %s; ", name, name);
                        fFlag = 0;
                }
        }
        if (! fFlag) sprintf(rb+strlen(rb),"\n\t\t");
        sprintf(rb+strlen(rb),"}\n");
        nhi = 0; fFlag = 1;
        sprintf(nhead+nhi,"%s", "perform");
        nhi += strlen(nhead+nhi);
        for(p=program; p!=NULL; p=p->next) {
                if (p->classifBits == EXTRACT_VALUE_ARGUMENT
                        || p->classifBits == EXTRACT_IN_RESULT_VALUE) {
                        { register char *s,*d,*dn,*dd; int nLen; for( s=p->symRef->name+1,d=decl,dd=dcla; *s!=0 && *s!='!'; s++,d++,dd++) { *d = *dd = *s; } *dd = 0; { if (!(*s)) internalCheckFail("*s", "extract.c", 1010);}; for(s++; *s!=0 && *s!='!'; s++,d++) { *d = *s; } { if (!(*s)) internalCheckFail("*s", "extract.c", 1010);}; d = strmcpy(d, ""); for(dn=name,s++; *s!=0 && *s!='!'; s++,dn++) { *dn = *s; if (1) *d++ = *s; } { if (!(*s)) internalCheckFail("*s", "extract.c", 1010);}; *dn = 0; { if (!(*s)) internalCheckFail("*s", "extract.c", 1010);}; for(s++; *s!=0 && *s!='!'; s++,d++) { *d = *s; } *d = 0;};
                        sprintf(nhead+nhi, "%s%s", fFlag?"(":", " , decl);
                        nhi += strlen(nhead+nhi);
                        fFlag = 0;
                }
        }
        sprintf(nhead+nhi, "%s)", fFlag?"(":"");
        nhi += strlen(nhead+nhi);
        extractSprintThrownExceptions(nhead+nhi, program);
        nhi += strlen(nhead+nhi);
        for(p=program; p!=NULL; p=p->next) {
                if (p->classifBits == EXTRACT_RESULT_VALUE
                        || p->classifBits == EXTRACT_IN_RESULT_VALUE) break;
        }
        if (p==NULL) {
                sprintf(rb+strlen(rb),"\t\tvoid %s", nhead);
        } else {
                { register char *s,*d,*dn,*dd; int nLen; for( s=p->symRef->name+1,d=decl,dd=dcla; *s!=0 && *s!='!'; s++,d++,dd++) { *d = *dd = *s; } *dd = 0; { if (!(*s)) internalCheckFail("*s", "extract.c", 1031);}; for(s++; *s!=0 && *s!='!'; s++,d++) { *d = *s; } { if (!(*s)) internalCheckFail("*s", "extract.c", 1031);}; d = strmcpy(d, nhead); for(dn=name,s++; *s!=0 && *s!='!'; s++,dn++) { *dn = *s; if (0) *d++ = *s; } { if (!(*s)) internalCheckFail("*s", "extract.c", 1031);}; *dn = 0; { if (!(*s)) internalCheckFail("*s", "extract.c", 1031);}; for(s++; *s!=0 && *s!='!'; s++,d++) { *d = *s; } *d = 0;};
                sprintf(rb+strlen(rb), "\t\t%s", decl);
        }
        sprintf(rb+strlen(rb), " {\n");
        ldcla[0] = 0; ldclaLen = 0; fFlag = 1;
        for(p=program; p!=NULL; p=p->next) {
                if ( p->classifBits == EXTRACT_LOCAL_VAR
                                || p->classifBits == EXTRACT_RESULT_VALUE
                                || ( p->symRef->b.storage == StorageExtern
                                         && p->ref->usage == UsageDeclared)
                                        ) {
                        { register char *s,*d,*dn,*dd; int nLen; for( s=p->symRef->name+1,d=decl,dd=dcla; *s!=0 && *s!='!'; s++,d++,dd++) { *d = *dd = *s; } *dd = 0; { if (!(*s)) internalCheckFail("*s", "extract.c", 1045);}; for(s++; *s!=0 && *s!='!'; s++,d++) { *d = *s; } { if (!(*s)) internalCheckFail("*s", "extract.c", 1045);}; d = strmcpy(d, ""); for(dn=name,s++; *s!=0 && *s!='!'; s++,dn++) { *dn = *s; if (1) *d++ = *s; } { if (!(*s)) internalCheckFail("*s", "extract.c", 1045);}; *dn = 0; { if (!(*s)) internalCheckFail("*s", "extract.c", 1045);}; for(s++; *s!=0 && *s!='!'; s++,d++) { *d = *s; } *d = 0;};
                        if (strcmp(ldcla,dcla)==0) {
                                sprintf(rb+strlen(rb), ",%s",decl+ldclaLen);
                        } else {
                                strcpy(ldcla,dcla); ldclaLen=strlen(ldcla);
                                if (fFlag) sprintf(rb+strlen(rb), "\t\t\t%s",decl);
                                else sprintf(rb+strlen(rb), ";\n\t\t\t%s",decl);
                        }
                        fFlag = 0;
                }
        }
        if (fFlag == 0) sprintf(rb+strlen(rb), ";\n");
        { if (!(strlen(rb)<500000 -1)) internalCheckFail("strlen(rb)<EXTRACT_GEN_BUFFER_SIZE-1", "extract.c", 1057);};
        if (s_opt.xref2) {
                ppcGenRecord(PPC_STRING_VALUE, rb, "\n");
        } else {
                fprintf(ccOut, "%s", rb);
        }
}
static void extJavaGenNewClassTail(S_programGraphNode *program) {
        char dcla[TMP_STRING_SIZE];
        char decl[TMP_STRING_SIZE];
        char name[TMP_STRING_SIZE];
        S_programGraphNode *p;
        int fFlag;
        rb[0]=0;
        fFlag = 1;
        for(p=program; p!=NULL; p=p->next) {
                if (p->classifBits == EXTRACT_LOCAL_OUT_ARGUMENT) {
                        { register char *s,*d,*dn,*dd; int nLen; for( s=p->symRef->name+1,d=decl,dd=dcla; *s!=0 && *s!='!'; s++,d++,dd++) { *d = *dd = *s; } *dd = 0; { if (!(*s)) internalCheckFail("*s", "extract.c", 1079);}; for(s++; *s!=0 && *s!='!'; s++,d++) { *d = *s; } { if (!(*s)) internalCheckFail("*s", "extract.c", 1079);}; d = strmcpy(d, ""); for(dn=name,s++; *s!=0 && *s!='!'; s++,dn++) { *dn = *s; if (1) *d++ = *s; } { if (!(*s)) internalCheckFail("*s", "extract.c", 1079);}; *dn = 0; { if (!(*s)) internalCheckFail("*s", "extract.c", 1079);}; for(s++; *s!=0 && *s!='!'; s++,d++) { *d = *s; } *d = 0;};
                        if (fFlag) sprintf(rb+strlen(rb), "\t\t\t");
                        sprintf(rb+strlen(rb), "this.%s=%s; ", name, name);
                        fFlag = 0;
                }
        }
        sprintf(rb+strlen(rb), "\n");
        for(p=program; p!=NULL; p=p->next) {
                if (p->classifBits == EXTRACT_RESULT_VALUE
                        || p->classifBits == EXTRACT_LOCAL_RESULT_VALUE
                        || p->classifBits == EXTRACT_IN_RESULT_VALUE
                        ) {
                        { register char *s,*d,*dn,*dd; int nLen; for( s=p->symRef->name+1,d=decl,dd=dcla; *s!=0 && *s!='!'; s++,d++,dd++) { *d = *dd = *s; } *dd = 0; { if (!(*s)) internalCheckFail("*s", "extract.c", 1094);}; for(s++; *s!=0 && *s!='!'; s++,d++) { *d = *s; } { if (!(*s)) internalCheckFail("*s", "extract.c", 1094);}; d = strmcpy(d, ""); for(dn=name,s++; *s!=0 && *s!='!'; s++,dn++) { *dn = *s; if (1) *d++ = *s; } { if (!(*s)) internalCheckFail("*s", "extract.c", 1094);}; *dn = 0; { if (!(*s)) internalCheckFail("*s", "extract.c", 1094);}; for(s++; *s!=0 && *s!='!'; s++,d++) { *d = *s; } *d = 0;};
                        sprintf(rb+strlen(rb), "\t\t\treturn(%s);\n", name);
                }
        }
        sprintf(rb+strlen(rb),"\t\t}\n\t}\n\n");
        { if (!(strlen(rb)<500000 -1)) internalCheckFail("strlen(rb)<EXTRACT_GEN_BUFFER_SIZE-1", "extract.c", 1100);};
        if (s_opt.xref2) {
                ppcGenRecord(PPC_STRING_VALUE, rb, "\n");
        } else {
                fprintf(ccOut, "%s", rb);
        }
}
static int extJavaIsNewClassNecesary(S_programGraphNode *program) {
        S_programGraphNode *p;
        for(p=program; p!=NULL; p=p->next) {
                if (p->classifBits == EXTRACT_OUT_ARGUMENT
                        || p->classifBits == EXTRACT_LOCAL_OUT_ARGUMENT
                        || p->classifBits == EXTRACT_IN_OUT_ARGUMENT
                        ) break;
        }
        if (p==NULL) return(0);
        return(1);
}
static void extMakeExtraction() {
        S_programGraphNode *program,*p;
        int cat,newClassExt;
        if (s_cp.cxMemiAtFunBegin > s_cps.cxMemiAtBlockBegin
                || s_cps.cxMemiAtBlockBegin > s_cps.cxMemiAtBlockEnd
                || s_cps.cxMemiAtBlockEnd > s_cp.cxMemiAtFunEnd
                || s_cps.workMemiAtBlockBegin != s_cps.workMemiAtBlockEnd) {
                error(ERR_ST, "Region / program structure mismatch");
                return;
        }
        { if (!(s_cp.cxMemiAtFunBegin)) internalCheckFail("s_cp.cxMemiAtFunBegin", "extract.c", 1133);};
        { if (!(s_cps.cxMemiAtBlockBegin)) internalCheckFail("s_cps.cxMemiAtBlockBegin", "extract.c", 1134);};
        { if (!(s_cps.cxMemiAtBlockEnd)) internalCheckFail("s_cps.cxMemiAtBlockEnd", "extract.c", 1135);};
        { if (!(s_cp.cxMemiAtFunEnd)) internalCheckFail("s_cp.cxMemiAtFunEnd", "extract.c", 1136);};
        program = extMakeProgramGraph();
        extSetInOutBlockFields(program);
        if (s_opt.extractMode!=EXTR_MACRO && extIsJumpInOutBlock(program)) {
                error(ERR_ST, "There are jumps in or out of region");
                return;
        }
        extClassifyLocalVariables(program);
        extReClassifyIOVars(program);
        newClassExt = 0;
        if (((s_language & (4)) != 0)) newClassExt = extJavaIsNewClassNecesary(program);
        if (s_opt.xref2) ppcGenRecordBegin(PPC_EXTRACTION_DIALOG);
        {{ { if (!((500000) >= 0)) internalCheckFail("(500000) >= 0", "extract.c", 1153);}; cxMemory->i = ((char*)(((char*)(((char*)&cxMemory->b)+cxMemory->i))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(((char*)&cxMemory->b)+cxMemory->i))-1) & (STANDARD_ALLIGNEMENT-1))))) - ((char*)&cxMemory->b); if (cxMemory->i+(500000)*sizeof(char) >= cxMemory->size) { if (cxMemory->overflowHandler(500000)) longjmp(s_memoryResize,1); else fatalError(ERR_NO_MEMORY,"cxMemory", 65); } rb = (char*) (((char*)&cxMemory->b) + cxMemory->i); cxMemory->i += (500000)*sizeof(char);};};
        if (! s_opt.xref2) {
                fprintf(ccOut,
"%%!\n------------------------ The Invocation ------------------------\n!\n");
        }
        if (s_opt.extractMode==EXTR_MACRO) extGenNewMacroCall(program);
        else if (newClassExt) extJavaGenNewClassCall(program);
        else extGenNewFunCall(program);
        if (! s_opt.xref2) {
                fprintf(ccOut,
"!\n--------------------------- The Head ---------------------------\n!\n");
        }
        if (s_opt.extractMode==EXTR_MACRO) extGenNewMacroHead(program);
        else if (newClassExt) extJavaGenNewClassHead(program);
        else extGenNewFunHead(program);
        if (! s_opt.xref2) {
                fprintf(ccOut,
"!\n--------------------------- The Tail ---------------------------\n!\n");
        }
        if (s_opt.extractMode==EXTR_MACRO) extGenNewMacroTail(program);
        else if (newClassExt) extJavaGenNewClassTail(program);
        else extGenNewFunTail(program);
        if (s_opt.xref2) {
                ppcGenNumericRecord(PPC_INT_VALUE, s_cp.funBegPosition, "", "\n");
        } else {
                fprintf(ccOut,"!%d!\n", s_cp.funBegPosition);
                fflush(ccOut);
        }
        if (s_opt.xref2) ppcGenRecordEnd(PPC_EXTRACTION_DIALOG);
}
void actionsBeforeAfterExternalDefinition() {
        int pi;
        if (s_cps.cxMemiAtBlockEnd != 0
                && s_cp.cxMemiAtFunBegin != 0
                && s_cp.cxMemiAtFunBegin <= s_cps.cxMemiAtBlockBegin
                && s_opt.cxrefs == OLO_EXTRACT
                && (! s_cps.extractProcessedFlag)) {
                        s_cp.cxMemiAtFunEnd = cxMemory->i;
                        extMakeExtraction();
                        s_cps.extractProcessedFlag = 1;
        }
        s_cp.cxMemiAtFunBegin = cxMemory->i;
        if (inStacki) {
                s_cp.funBegPosition = inStack[0].lineNumber+1;
        } else {
                s_cp.funBegPosition = cFile.lineNumber+1;
        }
}
void extractActionOnBlockMarker() {
        S_position pos;
        if (s_cps.cxMemiAtBlockBegin == 0) {
                s_cps.cxMemiAtBlockBegin = cxMemory->i;
                s_cps.workMemiAtBlockBegin = s_topBlock->previousTopBlock;
                if (((s_language & (4)) != 0)) {
                        s_javaExtractFromFunctionMods = s_javaStat->cpMethodMods;
                }
        } else {
                { if (!(s_cps.cxMemiAtBlockEnd == 0)) internalCheckFail("s_cps.cxMemiAtBlockEnd == 0", "extract.c", 1223);};
                s_cps.cxMemiAtBlockEnd = cxMemory->i;
                s_cps.workMemiAtBlockEnd = s_topBlock->previousTopBlock;
        }
        { (&pos)->file = cFile.lb.cb.fileNumber; (&pos)->line = 0; (&pos)->coll = 0;};
        addTrivialCxReference("Block", TypeBlockMarker,StorageDefault, &pos, UsageUsed);
}
