
/*

Copyright (C) Marian Vittek, Xref-Tech, Bratislava, 1997-2002.
All Rights Reserved.

    THIS FILE IS CONSIDERED A TRADE SECRET BY XREF-TECH.
UNAUTHORIZED ACCESS, USE, REPRODUCTION OR DISTRIBUTION IS PROHIBITED.

*/
#ifndef STDINC__H
#define STDINC__H
#if defined(__WIN32) && (! defined(__WIN32__))
#define __WIN32__ 1
#endif
#ifdef __WIN32__
#include <windows.h>
#include <direct.h>
#else
#include <unistd.h>
#include <dirent.h>
#endif
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <assert.h>
#include <string.h>
#include <time.h>
#include <setjmp.h>
#include <sys/types.h>
#include <sys/stat.h>
#endif
#include "head2.h"
#include "proto.h"
#ifdef __WIN32__
#endif
typedef union {
        int integer;
        unsigned unsign;
        S_symbol *symbol;
        S_symbolList *symbolList;
        S_typeModifiers *typeModif;
        S_typeModifiersList *typeModifList;
        S_freeTrail *trail;
        S_idIdent *idIdent;
        S_idIdentList *idlist;
        S_exprTokenType exprType;
        S_intPair intpair;
        S_whileExtractData *whiledata;
        S_position position;
        S_unsPositionPair unsPositionPair;
        S_symbolPositionPair symbolPositionPair;
        S_symbolPositionLstPair symbolPositionLstPair;
        S_positionLst *positionLst;
        S_typeModifiersListPositionLstPair typeModifiersListPositionLstPair;
} YYSTYPE;
extern YYSTYPE yylval;
extern YYSTYPE cyylval;
extern YYSTYPE javayylval;
extern YYSTYPE javaslyylval;
extern YYSTYPE cccyylval;
extern YYSTYPE yaccyylval;
extern YYSTYPE *uniyylval;
struct yyGlobalState {
        int gyydebug;
        int gyynerrs;
        int gyyerrflag;
        int gyychar;
        int lastgyystate;
        short *gyyssp;
        YYSTYPE *gyyvsp;
        YYSTYPE gyyval;
        YYSTYPE gyylval;
        short gyyss[10000];
        YYSTYPE gyyvs[10000];
};
extern struct yyGlobalState *s_yygstate;
extern struct yyGlobalState *s_initYygstate;
static char * VERSION_NUMBER = "1.5.10je";
static char * FILE_VERSION_NUMBER = "1.5.10je";
static char * PPC_VERSION_MISMATCH = "version-mismatch";
static char * PPC_MULTIPLE_COMPLETIONS = "completions";
static char * PPC_MULTIPLE_COMPLETION_LINE = "cl";
static char * PPC_SINGLE_COMPLETION = "single-completion";
static char * PPC_FQT_COMPLETION = "fqt-completion";
static char * PPC_SYMBOL_LIST = "symbol-list";
static char * PPC_REFACTORING_PRECHECK = "precheck";
static char * PPC_REFACTORING_REPLACEMENT = "replacement";
static char * PPC_REFACTORING_REPLACE = "replace";
static char * PPC_REFACTORING_REPLACE_WITH = "with";
static char * PPC_REFACTORING_CUT_BLOCK = "cut-block";
static char * PPC_REFACTORING_COPY_BLOCK = "copy-block";
static char * PPC_REFACTORING_PASTE_BLOCK = "past-block";
static char * PPC_EXTRACTION_DIALOG = "extraction-dialog";
static char * PPC_DISPLAY_CLASS_TREE = "display-class-tree";
static char * PPC_DISPLAY_RESOLUTION = "display-resolution";
static char * PPC_DISPLAY_OR_UPDATE_BROWSER = "display-or-update-browser";
static char * PPC_SYMBOL_RESOLUTION = "resolution";
static char * PPC_SYMBOL = "symbol";
static char * PPC_VIRTUAL_SYMBOL = "virtual-symbol";
static char * PPC_CLASS = "class";
static char * PPC_REFERENCE_LIST = "reference-list";
static char * PPC_SRC_LINE = "src-line";
static char * PPC_UPDATE_CURRENT_REFERENCE = "update-current-refn";
static char * PPC_NO_PROJECT = "no-project-found";
static char * PPC_SET_PROJECT = "set-project";
static char * PPC_SET_INFO = "set-info";
static char * PPC_WARNING = "warning";
static char * PPC_ERROR = "error";
static char * PPC_FATAL_ERROR = "fatalError";
static char * PPC_INFORMATION = "information";
static char * PPC_BOTTOM_INFORMATION = "bottom-information";
static char * PPC_DEBUG_INFORMATION = "debug-information";
static char * PPC_ASK_CONFIRMATION = "ask-confirmation";
static char * PPC_GOTO = "goto";
static char * PPC_BROWSE_URL = "browse-url";
static char * PPC_FILE_SAVE_AS = "file-save-as";
static char * PPC_MOVE_FILE_AS = "file-move-as";
static char * PPC_FILE_REMOVE = "file-remove";
static char * PPC_MOVE_DIRECTORY = "move-directory";
static char * PPC_INDENT = "indent-block";
static char * PPC_IGNORE = "ignore";
static char * PPC_PROGRESS = "progress";
static char * PPC_UPDATE_REPORT = "update-report";
static char * PPC_AVAILABLE_REFACTORINGS = "available-refactorings";
static char * PPC_SYNCHRO_RECORD = "sync";
static char * PPC_LC_POSITION = "position-lc";
static char * PPC_OFFSET_POSITION = "position-off";
static char * PPC_STRING_VALUE = "string-value";
static char * PPC_INT_VALUE = "int-value";
static char * PPCA_LEN = "len";
static char * PPCA_LINE = "line";
static char * PPCA_COL = "col";
static char * PPCA_OFFSET = "off";
static char * PPCA_VALUE = "val";
static char * PPCA_SELECTED = "selected";
static char * PPCA_BASE = "base";
static char * PPCA_DEF_REFN = "drefn";
static char * PPCA_REFN = "refn";
static char * PPCA_TYPE = "type";
static char * PPCA_MTYPE = "mtype";
static char * PPCA_CONTINUE = "continue";
static char * PPCA_INTERFACE = "interface";
static char * PPCA_INDENT = "indent";
static char * PPCA_TREE_DEPS = "deps";
static char * PPCA_TREE_UP = "up";
static char * PPCA_DEFINITION = "definition";
static int PPCV_BROWSER_TYPE_INFO = 0;
static int PPCV_BROWSER_TYPE_WARNING = 1;
static int PPC_AVR_NO_REFACTORING = 0;
static int PPC_AVR_RENAME_SYMBOL = 1;
static int PPC_AVR_RENAME_CLASS = 2;
static int PPC_AVR_RENAME_PACKAGE = 3;
static int PPC_AVR_ADD_PARAMETER = 4;
static int PPC_AVR_DEL_PARAMETER = 5;
static int PPC_AVR_MOVE_PARAMETER = 6;
static int PPC_AVR_EXTRACT_METHOD = 7;
static int PPC_AVR_EXTRACT_MACRO = 8;
static int PPC_AVR_MOVE_STATIC_FIELD = 9;
static int PPC_AVR_MOVE_STATIC_METHOD = 10;
static int PPC_AVR_MOVE_FIELD = 11;
static int PPC_AVR_PULL_UP_FIELD = 12;
static int PPC_AVR_PULL_UP_METHOD = 13;
static int PPC_AVR_PUSH_DOWN_FIELD = 14;
static int PPC_AVR_PUSH_DOWN_METHOD = 15;
static int PPC_AVR_MOVE_CLASS = 16;
static int PPC_AVR_ENCAPSULATE_FIELD = 17;
static int PPC_AVR_SELF_ENCAPSULATE_FIELD = 18;
static int PPC_AVR_TURN_DYNAMIC_METHOD_TO_STATIC = 19;
static int PPC_AVR_TURN_STATIC_METHOD_TO_DYNAMIC = 20;
static int PPC_AVR_REDUCE_NAMES = 21;
static int PPC_AVR_EXPAND_NAMES = 22;
static int PPC_AVR_SET_MOVE_TARGET = 23;
static int PPC_MAX_AVAILABLE_REFACTORINGS = 24;
static int javaNotFqtUsageCorrection(S_symbol *sym, int usage);
char *javaCreateComposedName(
                                                                        char *prefix,
                                                                        S_idIdentList *className,
                                                                        int classNameSeparator,
                                                                        char *name,
                                                                        char *resBuff,
                                                                        int resBuffSize
                                                                ) {
        int len,ll,sss,totallen;
        char *ln,*lastName;
        char separator;
        S_idIdentList *ii;
        if (name == NULL) name = "";
        if (prefix == NULL) prefix = "";
        sss = 0;
        len = 0;
        ll = strlen(prefix);
        if (ll!=0) sss=1;
        len += ll;
        for (ii=className; ii!=NULL; ii=ii->next) {
                if (sss) len ++;
                len += strlen(ii->fname);
                sss = 1;
        }
        ll = strlen(name);
        if (sss && ll!=0) len++;
        len += ll;
        totallen = len;
        if (resBuff == NULL) {
                {ln = (char*) stackMemoryAlloc((len+1)*sizeof(char)); };
        } else {
                { if (!(len < resBuffSize)) internalCheckFail("len < resBuffSize", "jsemact.c", 61);};
                ln = resBuff;
        }
        ll = strlen(name);
        len -= ll;
        strcpy(ln+len,name);
        if (ll == 0) sss = 0;
        else sss = 1;
        separator = '.';
        for (ii=className; ii!=NULL; ii=ii->next) {
                if (sss) {
                        len --;
                        ln[len] = separator;
                }
                ll = strlen(ii->fname);
                len -= ll;
                strncpy(ln+len,ii->fname,ll);
                sss = 1;
                { if (!(ii->nameType==TypeStruct || ii->nameType==TypePackage || ii->nameType==TypeExpression)) internalCheckFail("ii->nameType==TypeStruct || ii->nameType==TypePackage || ii->nameType==TypeExpression", "jsemact.c", 79);};
                if (ii->nameType==TypeStruct &&
                                ii->next!=NULL && ii->next->nameType==TypeStruct) {
                        separator = '$';
                } else {
                        separator = classNameSeparator;
                }
        }
        ll = strlen(prefix);
        if (sss && ll!=0) {len --; ln[len] = separator; }
        len -= ll;
        strncpy(ln+len, prefix, ll);
        { if (!(len == 0)) internalCheckFail("len == 0", "jsemact.c", 92);};
        return(ln);
}
void javaCheckForPrimaryStart(S_position *cpos, S_position *bpos) {
        if (s_opt.taskRegime != RegimeEditServer) return;
        if ((! ( ((s_cxRefPos).file != (*cpos).file) || ((s_cxRefPos).line != (*cpos).line) || ((s_cxRefPos).coll != (*cpos).coll) ))) {
                s_primaryStartPosition = *bpos;
        }
}
void javaCheckForPrimaryStartInNameList(S_idIdentList *name, S_position *pp) {
        S_idIdentList *ll;
        if (s_opt.taskRegime != RegimeEditServer) return;
        for(ll=name; ll!=NULL; ll=ll->next) {
                javaCheckForPrimaryStart(&ll->idi.p, pp);
        }
}
void javaCheckForStaticPrefixStart(S_position *cpos, S_position *bpos) {
        if (s_opt.taskRegime != RegimeEditServer) return;
        if ((! ( ((s_cxRefPos).file != (*cpos).file) || ((s_cxRefPos).line != (*cpos).line) || ((s_cxRefPos).coll != (*cpos).coll) ))) {
                s_staticPrefixStartPosition = *bpos;
        }
}
void javaCheckForStaticPrefixInNameList(S_idIdentList *name, S_position *pp) {
        S_idIdentList *ll;
        if (s_opt.taskRegime != RegimeEditServer) return;
        for(ll=name; ll!=NULL; ll=ll->next) {
                javaCheckForStaticPrefixStart(&ll->idi.p, pp);
        }
}
S_position *javaGetNameStartingPosition(S_idIdentList *name) {
        S_idIdentList *ll;
        S_position *res;
        res = &s_noPos;
        for(ll=name; ll!=NULL; ll=ll->next) {
                res = &ll->idi.p;
        }
        return(res);
}
static S_reference *javaAddClassCxReference(S_symbol *dd, S_position *pos, unsigned usage) {
        S_reference *res;
        res = addCxReference(dd, pos, usage, s_noneFileIndex, s_noneFileIndex);
        return(res);
}
static void javaAddNameCxReference(S_idIdentList *id, unsigned usage) {
        char *cname;
        S_symbol dd;
        { if (!(id != NULL)) internalCheckFail("id != NULL", "jsemact.c", 146);};
        cname = javaCreateComposedName(NULL,id,'/',NULL,tmpMemory,SIZE_TMP_MEM);
        { (&dd.b)->record = 0; (&dd.b)->accessFlags = 0; (&dd.b)->javaSourceLoaded = 0; (&dd.b)->javaFileLoaded = 0; (&dd.b)->symType = id->nameType; (&dd.b)->storage = StorageNone; (&dd.b)->npointers = 0;};
        { (&dd)->name = id->idi.name; (&dd)->linkName = cname; (&dd)->pos = id->idi.p; (&dd)->b = dd.b; (&dd)->u.type = NULL; (&dd)->next = NULL;};
        addCxReference(&dd, &id->idi.p, usage,s_noneFileIndex, s_noneFileIndex);
}
S_symbol *javaAddType(S_idIdentList *clas, int accessFlags, S_position *p) {
        S_symbol *dd;
        dd = javaTypeSymbolDefinition(clas, accessFlags, TYPE_ADD_YES);
        dd->b.accessFlags = accessFlags;
        addCxReference(dd, p, UsageDefined,s_noneFileIndex, s_noneFileIndex);
        htmlAddJavaDocReference(dd, p, s_noneFileIndex, s_noneFileIndex);
        return(dd);
}
void javaAddNestedClassesAsTypeDefs(S_symbol *cc, S_idIdentList *oclassname,
                                                                        int accessFlags) {
        S_symStructSpecific *ss;
        S_idIdentList ll;
        S_symbol *nn;
        int i;
        { if (!(cc && cc->b.symType==TypeStruct)) internalCheckFail("cc && cc->b.symType==TypeStruct", "jsemact.c", 169);};
        ss = cc->u.s;
        { if (!(ss)) internalCheckFail("ss", "jsemact.c", 171);};
        for(i=0; i<ss->nnested; i++) {
                if (ss->nest[i].membFlag) {
                        nn = ss->nest[i].cl;
                        { if (!(nn)) internalCheckFail("nn", "jsemact.c", 175);};
                        { (&ll.idi)->name = nn->name; (&ll.idi)->sd = cc; (&ll.idi)->p = s_noPos;};
                        { (&ll)->idi = ll.idi; (&ll)->fname = nn->name; (&ll)->nameType = TypeStruct; (&ll)->next = oclassname;};
                        javaTypeSymbolDefinition(&ll, accessFlags, TYPE_ADD_YES);
                }
        }
}
static int javaFindFile0( char *classPath,char *slash,char *name,
                                                  char *suffix, char **resName, struct stat *stt) {
        char fname[MAX_FILE_NAME_SIZE];
        char *ffn,*ss;
        int res;
        res = 0;
        ss = strmcpy(fname,classPath);
        ss = strmcpy(ss,slash);
        ss = strmcpy(ss,name);
        ss = strmcpy(ss, suffix);
        { if (!(ss-fname+1 < MAX_FILE_NAME_SIZE)) internalCheckFail("ss-fname+1 < MAX_FILE_NAME_SIZE", "jsemact.c", 195);};
        ffn = normalizeFileName(fname,s_cwd);
        if (statb(ffn,stt) == 0) {
                res = 1;
        }
        if (res && resName!=NULL) {
                {*resName = (char*) stackMemoryAlloc((strlen(ffn)+1)*sizeof(char)); };
                strcpy(*resName, ffn);
        }
        return(res);
}
int specialFileNameCasesCheck(char *fname) {
#ifdef __WIN32__
        WIN32_FIND_DATA fdata;
        HANDLE han;
        int dif;
        char *ss;
        S_editorBuffer *buff;
        buff = editorGetOpenedBuffer(fname);
        if (buff != NULL) return(1);
        ss = lastOccurenceInString(fname, '/');
        if (ss==NULL) ss = lastOccurenceInString(fname, '\\');
        if (ss==NULL) return(1);
        han = FindFirstFile(fname, &fdata);
        if (han == INVALID_HANDLE_VALUE) return(1);
        dif = strcmp(ss+1, fdata.cFileName);
        FindClose(han);
        return(dif==0);
#else
        return(1);
#endif
}
int javaTypeFileExist(S_idIdentList *name) {
        char *fname;
        struct stat stt;
        S_stringList *cp;
        int i,ii,nameType;
        S_idIdentList tname;
        S_fileItem dd;
        S_zipArchiveDir *place;
        if (name==NULL) return(0);
        tname = *name;
        tname.nameType = TypeStruct;
        fname = javaCreateComposedName(":",&tname,'/',"class",tmpMemory,SIZE_TMP_MEM);
        fname[1] = ';';
        { (&dd)->name = fname+1; (&dd)->lastModif = 0; (&dd)->lastInspect = 0; (&dd)->lastUpdateMtime = 0; (&dd)->lastFullUpdateMtime = 0; (&dd)->b.cxLoading = 0; (&dd)->b.cxLoaded = 0; (&dd)->b.cxSaved = 0; (&dd)->b.commandLineEntered = 0; (&dd)->b.scheduledToProcess = 0; (&dd)->b.scheduledToUpdate = 0; (&dd)->b.fullUpdateIncludesProcessed = 0; (&dd)->b.isInterface = 0; (&dd)->b.sourceFile = s_noneFileIndex; (&dd)->sups = NULL; (&dd)->infs = NULL; (&dd)->directEnclosingInstance = s_noneFileIndex;};
        if (idTabIsMember(&s_fileTab, &dd, &ii) &&
                 s_fileTab.tab[ii]->b.sourceFile!=s_noneFileIndex) {
                return(1);
        }
        if (s_javaStat->unNamedPackageDir != NULL) {
                fname = javaCreateComposedName(NULL,&tname,SLASH,"java",tmpMemory,SIZE_TMP_MEM);
                if (statb(fname,&stt)==0 && specialFileNameCasesCheck(fname)) return(1);
        }
        { char *currentPath, *jmop_pp, *jmop_ecp; int jmop_i, jmop_ind; char sourcepathes[MAX_SOURCE_PATH_SIZE]; { if (!(s_javaSourcePaths!=NULL)) internalCheckFail("s_javaSourcePaths!=NULL", "jsemact.c", 269);}; jmop_pp = s_javaSourcePaths; strcpy(sourcepathes, jmop_pp); currentPath = sourcepathes; jmop_ecp = currentPath+strlen(currentPath); while (currentPath<jmop_ecp) { for(jmop_ind=0; currentPath[jmop_ind]!=0 && currentPath[jmop_ind]!=CLASS_PATH_SEPARATOR; jmop_ind++) ; currentPath[jmop_ind] = 0; jmop_i = jmop_ind; if (jmop_i>0 && currentPath[jmop_i-1]==SLASH) currentPath[--jmop_i] = 0; { fname = javaCreateComposedName(currentPath,&tname,SLASH,"java",tmpMemory,SIZE_TMP_MEM); if (statb(fname,&stt)==0 && specialFileNameCasesCheck(fname)) return(1); }; currentPath += jmop_ind; currentPath++; }};
        for (cp=s_javaClassPaths; cp!=NULL; cp=cp->next) {
                fname = javaCreateComposedName(cp->d,&tname,SLASH,"class",tmpMemory,SIZE_TMP_MEM);
                if (statb(fname,&stt)==0 && specialFileNameCasesCheck(fname)) return(1);
        }
        fname=javaCreateComposedName(NULL,&tname,'/',"class",tmpMemory,SIZE_TMP_MEM);
        for(i=0; i<MAX_JAVA_ZIP_ARCHIVES && s_zipArchivTab[i].fn[0]!=0; i++) {
                if (fsIsMember(&s_zipArchivTab[i].dir,fname,0,ADD_NO,&place))return(1);
        }
        if (s_javaStat->namedPackageDir != NULL) {
                fname = javaCreateComposedName(s_javaStat->namedPackageDir,&tname,SLASH,"java",tmpMemory,SIZE_TMP_MEM);
                if (statb(fname,&stt)==0 && specialFileNameCasesCheck(fname)) return(1);
        }
        return(0);
}
int javaFindClassFile(char *name, char **resName, struct stat *stt) {
        char fname[MAX_FILE_NAME_SIZE];
        S_stringList *cp;
        int i,res;
        if (s_javaStat->unNamedPackageDir != NULL) {
                if (javaFindFile0( s_javaStat->unNamedPackageDir,"/",name, ".class",
                                                  resName, stt)) return(1);
        }
        for (cp=s_javaClassPaths; cp!=NULL; cp=cp->next) {
                if (javaFindFile0( cp->d,"/",name, ".class", resName, stt)) return(1);
        }
        for(i=0; i<MAX_JAVA_ZIP_ARCHIVES && s_zipArchivTab[i].fn[0]!=0; i++) {
                if (zipFindFile(name,resName,&s_zipArchivTab[i])) {
                        *stt = s_zipArchivTab[i].st;
                        return(1);
                }
        }
        return(0);
}
int javaFindSourceFile(char *name, char **resName, struct stat *stt) {
        char fname[MAX_FILE_NAME_SIZE];
        S_stringList *cp;
        int i,res;
        if (s_javaStat->unNamedPackageDir != NULL) {
                if (javaFindFile0( s_javaStat->unNamedPackageDir,"/",name, ".java",
                                                  resName, stt)) return(1);
        }
        { char *currentPath, *jmop_pp, *jmop_ecp; int jmop_i, jmop_ind; char sourcepathes[MAX_SOURCE_PATH_SIZE]; { if (!(s_javaSourcePaths!=NULL)) internalCheckFail("s_javaSourcePaths!=NULL", "jsemact.c", 325);}; jmop_pp = s_javaSourcePaths; strcpy(sourcepathes, jmop_pp); currentPath = sourcepathes; jmop_ecp = currentPath+strlen(currentPath); while (currentPath<jmop_ecp) { for(jmop_ind=0; currentPath[jmop_ind]!=0 && currentPath[jmop_ind]!=CLASS_PATH_SEPARATOR; jmop_ind++) ; currentPath[jmop_ind] = 0; jmop_i = jmop_ind; if (jmop_i>0 && currentPath[jmop_i-1]==SLASH) currentPath[--jmop_i] = 0; { if (javaFindFile0(currentPath,"/",name,".java",resName,stt)) return(1); }; currentPath += jmop_ind; currentPath++; }};
        for (cp=s_javaClassPaths; cp!=NULL; cp=cp->next) {
                if (javaFindFile0( cp->d,"/",name, ".java", resName, stt)) return(1);
        }
        if (s_javaStat->namedPackageDir != NULL) {
                if (javaFindFile0(s_javaStat->namedPackageDir,"/",name, ".java", resName, stt)) return(1);
        }
        return(0);
}
static int javaFindFile(S_symbol *clas,
                                                char **resSourceFile,
                                                char **resClassFile
        ) {
        char ttt[MAX_FILE_NAME_SIZE];
        int rc,rs,si;
        struct stat sourceStat;
        struct stat classStat;
        char *lname, *nn, *slname;
        lname = slname = clas->linkName;
        if (strchr(lname, '$')!=NULL) {
                strcpy(ttt, clas->linkName);
                slname = ttt;
                nn = strchr(ttt, '$');
                { if (!(nn)) internalCheckFail("nn", "jsemact.c", 355);};
                *nn = 0;
        }
        *resClassFile = *resSourceFile = "";
        rs = javaFindSourceFile(slname, resSourceFile, &sourceStat);
        { if (!(clas->u.s && s_fileTab.tab[clas->u.s->classFile])) internalCheckFail("clas->u.s && s_fileTab.tab[clas->u.s->classFile]", "jsemact.c", 361);};
        si = s_fileTab.tab[clas->u.s->classFile]->b.sourceFile;
        if (rs==0 && si!= -1 && si!=s_noneFileIndex) {
                { if (!(s_fileTab.tab[si])) internalCheckFail("s_fileTab.tab[si]", "jsemact.c", 366);};
                rs = javaFindFile0( "","",s_fileTab.tab[si]->name, "", resSourceFile,
                                                        &sourceStat);
        }
        rc = javaFindClassFile(lname, resClassFile, &classStat);
        if (rc==0) *resClassFile = NULL;
        if (rs==0) *resSourceFile = NULL;
        if (s_opt.javaSlAllowed == 0) {
                if (rc) return(RESULT_IS_CLASS_FILE);
                else return(RESULT_NO_FILE_FOUND);
        }
        if (rc==0 && rs==0) return(RESULT_NO_FILE_FOUND);
        if (rc==1 && rs==0) return(RESULT_IS_CLASS_FILE);
        if (rc==0 && rs==1) return(RESULT_IS_JAVA_FILE);
        { if (!(rs==1 && rc==1)) internalCheckFail("rs==1 && rc==1", "jsemact.c", 394);};
        if (sourceStat.st_mtime > classStat.st_mtime) {
                return(RESULT_IS_JAVA_FILE);
        } else {
                return(RESULT_IS_CLASS_FILE);
        }
}
int javaIsInCurrentPackage(char *classFqName) {
        char *cpack,*p1,*p2;
        if (s_javaThisPackageName == NULL) return(0);
        cpack = s_javaThisPackageName;
        for(p1=cpack, p2=classFqName; *p1 == *p2; p1++,p2++) ;
        if (*p1 != 0) return(0);
        if (*p2 == 0) return(0);
        for(p2++; *p2; p2++) if (*p2 == '/') return(0);
        return(1);
}
static S_symbol *javaFQTypeSymbolDefinitionCreate(char *name,
                                                                                        char *fqName, int ii) {
        S_symbol *memb;
        S_symbolList *pppl;
        char *lname1,*sname;
        {{ { if (!((strlen(name)+1) >= 0)) internalCheckFail("(strlen(name)+1) >= 0", "jsemact.c", 419);}; ppmMemoryi = ((char*)(((char*)(ppmMemory+ppmMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(ppmMemory+ppmMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - ppmMemory; if (ppmMemoryi+(strlen(name)+1)*sizeof(char) >= SIZE_ppmMemory) { fatalError(ERR_NO_MEMORY,"ppmMemory", 65); } sname = (char*) (ppmMemory + ppmMemoryi); ppmMemoryi += (strlen(name)+1)*sizeof(char);};};
        strcpy(sname, name);
        {{ { if (!((strlen(fqName)+1) >= 0)) internalCheckFail("(strlen(fqName)+1) >= 0", "jsemact.c", 421);}; ppmMemoryi = ((char*)(((char*)(ppmMemory+ppmMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(ppmMemory+ppmMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - ppmMemory; if (ppmMemoryi+(strlen(fqName)+1)*sizeof(char) >= SIZE_ppmMemory) { fatalError(ERR_NO_MEMORY,"ppmMemory", 65); } lname1 = (char*) (ppmMemory + ppmMemoryi); ppmMemoryi += (strlen(fqName)+1)*sizeof(char);};};
        strcpy(lname1, fqName);
        {{{ { if (!((1) >= 0)) internalCheckFail("(1) >= 0", "jsemact.c", 423);}; ppmMemoryi = ((char*)(((char*)(ppmMemory+ppmMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(ppmMemory+ppmMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - ppmMemory; if (ppmMemoryi+(1)*sizeof(S_symbol) >= SIZE_ppmMemory) { fatalError(ERR_NO_MEMORY,"ppmMemory", 65); } memb = (S_symbol*) (ppmMemory + ppmMemoryi); ppmMemoryi += (1)*sizeof(S_symbol);};};};
        { (&memb->b)->record = 0; (&memb->b)->accessFlags = 0; (&memb->b)->javaSourceLoaded = 0; (&memb->b)->javaFileLoaded = 0; (&memb->b)->symType = TypeStruct; (&memb->b)->storage = StorageNone; (&memb->b)->npointers = 0;};
        { (memb)->name = sname; (memb)->linkName = lname1; (memb)->pos = s_noPos; (memb)->b = memb->b; (memb)->u.s = NULL; (memb)->next = NULL;};
        {{{ { if (!((1) >= 0)) internalCheckFail("(1) >= 0", "jsemact.c", 426);}; ppmMemoryi = ((char*)(((char*)(ppmMemory+ppmMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(ppmMemory+ppmMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - ppmMemory; if (ppmMemoryi+(1)*sizeof(S_symStructSpecific) >= SIZE_ppmMemory) { fatalError(ERR_NO_MEMORY,"ppmMemory", 65); } memb->u.s = (S_symStructSpecific*) (ppmMemory + ppmMemoryi); ppmMemoryi += (1)*sizeof(S_symStructSpecific);};};};
        { (memb->u.s)->super = NULL; (memb->u.s)->records = NULL; (memb->u.s)->casts.node = NULL; (memb->u.s)->casts.sub = NULL; (memb->u.s)->nnested = 0; (memb->u.s)->nest = NULL; (memb->u.s)->stype.m = TypeStruct; (&(memb->u.s)->stype.u)->t = NULL;; (memb->u.s)->stype.typedefin = NULL; (memb->u.s)->stype.next = NULL; (memb->u.s)->sptrtype.m = TypePointer; { (&((&(memb->u.s)->sptrtype.u)->f))->args = NULL; (&((&(memb->u.s)->sptrtype.u)->f))->thisFunList = NULL;}; (memb->u.s)->sptrtype.typedefin = NULL; (memb->u.s)->sptrtype.next = &memb->u.s->stype; (memb->u.s)->currPackage = javaIsInCurrentPackage(lname1); (memb->u.s)->existsDEIarg = 0; (memb->u.s)->classFile = -1; (memb->u.s)->recSearchCounter = 0;};
        memb->u.s->stype.u.t = memb;
        {{{ { if (!((1) >= 0)) internalCheckFail("(1) >= 0", "jsemact.c", 433);}; ppmMemoryi = ((char*)(((char*)(ppmMemory+ppmMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(ppmMemory+ppmMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - ppmMemory; if (ppmMemoryi+(1)*sizeof(S_symbolList) >= SIZE_ppmMemory) { fatalError(ERR_NO_MEMORY,"ppmMemory", 65); } pppl = (S_symbolList*) (ppmMemory + ppmMemoryi); ppmMemoryi += (1)*sizeof(S_symbolList);};};};
        { (pppl)->d = memb; (pppl)->next = NULL;};
        if (ii < 0) {
                javaFqtTabAdd(&s_javaFqtTab,pppl,&ii);
        } else {
                javaFqtTabSet(&s_javaFqtTab,pppl,ii);
        }
        javaCreateClassFileItem(memb);
        return(memb);
}
S_symbol *javaFQTypeSymbol(char *name, char *fqName) {
        S_symbol pp,*memb;
        S_symbolList ppl, *pppl;
        int ii;
        { { (&pp.b)->record = 0; (&pp.b)->accessFlags = 0; (&pp.b)->javaSourceLoaded = 0; (&pp.b)->javaFileLoaded = 0; (&pp.b)->symType = TypeStruct; (&pp.b)->storage = StorageNone; (&pp.b)->npointers = 0;}; { (&pp)->name = name; (&pp)->linkName = fqName; (&pp)->pos = s_noPos; (&pp)->b = pp.b; (&pp)->u.s = NULL; (&pp)->next = NULL;}; { (&ppl)->d = &pp; (&ppl)->next = NULL;};};
        if (javaFqtTabIsMember(&s_javaFqtTab, &ppl, &ii, &pppl)) {
                memb = pppl->d;
        } else {
                memb = NULL;
        }
        return(memb);
}
S_symbol *javaFQTypeSymbolDefinition(char *name, char *fqName) {
        S_symbol pp,*memb;
        S_symbolList ppl, *pppl;
        int ii;
        { { (&pp.b)->record = 0; (&pp.b)->accessFlags = 0; (&pp.b)->javaSourceLoaded = 0; (&pp.b)->javaFileLoaded = 0; (&pp.b)->symType = TypeStruct; (&pp.b)->storage = StorageNone; (&pp.b)->npointers = 0;}; { (&pp)->name = name; (&pp)->linkName = fqName; (&pp)->pos = s_noPos; (&pp)->b = pp.b; (&pp)->u.s = NULL; (&pp)->next = NULL;}; { (&ppl)->d = &pp; (&ppl)->next = NULL;};};
        if (javaFqtTabIsMember(&s_javaFqtTab, &ppl, &ii, &pppl)) {
                memb = pppl->d;
        } else {
                memb = javaFQTypeSymbolDefinitionCreate(name, fqName, ii);
        }
        return(memb);
}
S_symbol * javaGetFieldClass(char *fieldLinkName, char **fieldAdr) {
        char sbuf[MAX_FILE_NAME_SIZE];
        char fqbuf[MAX_FILE_NAME_SIZE];
        char *p,*lp,*lpp;
        S_symbol pp,*memb;
        int fqlen,slen;
        lp = fieldLinkName;
        lpp = NULL;
        for(p=fieldLinkName; *p && *p!=';'; p++) {
                if (*p == '/' || *p == '$') lp = p+1;
                if (*p == '.') lpp = p;
        }
        if (lpp != NULL) p = lpp;
        if (fieldAdr != NULL) *fieldAdr = p;
        fqlen = p-fieldLinkName;
        { if (!(fqlen+1 < MAX_FILE_NAME_SIZE)) internalCheckFail("fqlen+1 < MAX_FILE_NAME_SIZE", "jsemact.c", 499);};
        strncpy(fqbuf,fieldLinkName, fqlen);
        fqbuf[fqlen]=0;
        slen = p-lp;
        strncpy(sbuf,lp,slen);
        sbuf[slen]=0;
        memb = javaFQTypeSymbolDefinition(sbuf, fqbuf);
        return(memb);
}
static S_symbol *javaAddTypeToSymbolTable( S_symbol *memb, int accessFlags) {
        S_symbol *nmemb;
        S_symbol *memb2;
        int ii;
        if (! symTabIsMember(s_symTab, memb, &ii, &memb2)) {
                addSymbol(memb, s_symTab);
        } else {
                        {nmemb = (S_symbol*) stackMemoryAlloc(sizeof(S_symbol)); };
                        *nmemb = *memb;
                        addSymbol(nmemb, s_symTab);
                        memb = nmemb;
        }
        memb->b.accessFlags = accessFlags;
        return(memb);
}
S_symbol *javaTypeSymbolDefinition(S_idIdentList *tname,
                                                                   int accessFlags,
                                                                   int addTyp){
        S_symbol pp,*memb,*memb2,*nmemb;
        int ii;
        char fqtName[MAX_FILE_NAME_SIZE];
        S_javaStat *ttt;
        { if (!(tname)) internalCheckFail("tname", "jsemact.c", 547);};
        { if (!(tname->nameType == TypeStruct)) internalCheckFail("tname->nameType == TypeStruct", "jsemact.c", 548);};
        { (&pp.b)->record = 0; (&pp.b)->accessFlags = accessFlags; (&pp.b)->javaSourceLoaded = 0; (&pp.b)->javaFileLoaded = 0; (&pp.b)->symType = TypeStruct; (&pp.b)->storage = StorageNone; (&pp.b)->npointers = 0;};
        { (&pp)->name = tname->idi.name; (&pp)->linkName = tname->idi.name; (&pp)->pos = s_noPos; (&pp)->b = pp.b; (&pp)->u.s = NULL; (&pp)->next = NULL;};
        javaCreateComposedName(NULL,tname,'/',NULL,fqtName,MAX_FILE_NAME_SIZE);
        memb = javaFQTypeSymbolDefinition(tname->idi.name, fqtName);
        if (addTyp == TYPE_ADD_YES) {
                memb = javaAddTypeToSymbolTable( memb, accessFlags);
        }
        return(memb);
}
S_symbol *javaTypeSymbolUsage(S_idIdentList *tname,
                                                                   int accessFlags){
        S_symbol pp,*memb,*memb2,*nmemb;
        int ii;
        char fqtName[MAX_FILE_NAME_SIZE];
        S_javaStat *ttt;
        { if (!(tname)) internalCheckFail("tname", "jsemact.c", 566);};
        { if (!(tname->nameType == TypeStruct)) internalCheckFail("tname->nameType == TypeStruct", "jsemact.c", 567);};
        { (&pp.b)->record = 0; (&pp.b)->accessFlags = accessFlags; (&pp.b)->javaSourceLoaded = 0; (&pp.b)->javaFileLoaded = 0; (&pp.b)->symType = TypeStruct; (&pp.b)->storage = StorageNone; (&pp.b)->npointers = 0;};
        { (&pp)->name = tname->idi.name; (&pp)->linkName = tname->idi.name; (&pp)->pos = s_noPos; (&pp)->b = pp.b; (&pp)->u.s = NULL; (&pp)->next = NULL;};
        if (tname->next==NULL && symTabIsMember(s_symTab, &pp, &ii, &memb)) {
                return(memb);
        }
        javaCreateComposedName(NULL,tname,'/',NULL,fqtName,MAX_FILE_NAME_SIZE);
        memb = javaFQTypeSymbolDefinition(tname->idi.name, fqtName);
        return(memb);
}
S_symbol *javaTypeNameDefinition(S_idIdentList *tname) {
        S_symbol *memb;
        S_symbol *dd;
        S_typeModifiers *td;
        memb = javaTypeSymbolUsage(tname,0x000);
        {td = (S_typeModifiers*) stackMemoryAlloc(sizeof(S_typeModifiers)); };
        { (td)->m = TypeStruct; (&(td)->u)->t = memb;; (td)->typedefin = NULL; (td)->next = NULL;};
        td->u.t = memb;
        {dd = (S_symbol*) stackMemoryAlloc(sizeof(S_symbol)); };
        { (&dd->b)->record = 0; (&dd->b)->accessFlags = 0; (&dd->b)->javaSourceLoaded = 0; (&dd->b)->javaFileLoaded = 0; (&dd->b)->symType = TypeDefault; (&dd->b)->storage = StorageDefault; (&dd->b)->npointers = 0;};
        { (dd)->name = memb->name; (dd)->linkName = memb->linkName; (dd)->pos = tname->idi.p; (dd)->b = dd->b; (dd)->u.type = td; (dd)->next = NULL;};
        dd->u.type = td;
        return(dd);
}
static void javaJslLoadSuperClasses(S_symbol *cc, int currentParsedFile) {
        S_symbolList *ss;
        int classfilenum, sourcefilenum;
        static int nestCounter = 0;
        nestCounter ++;
        if (nestCounter > MAX_CLASSES) {
                fatalError(ERR_INTERNAL, "unexpected cycle in class hierarchy", 65);
        }
        for(ss=cc->u.s->super; ss!=NULL; ss=ss->next) {
                cfAddCastsToModule(cc, ss->d);
        }
        nestCounter --;
}
void javaReadSymbolFromSourceFileInit( int sourceFileNum,
                                                                           S_jslTypeTab *typeTab ) {
        S_jslStat *njsl;
        {njsl = (S_jslStat*) stackMemoryAlloc(sizeof(S_jslStat)); };
        { (njsl)->pass = 0; (njsl)->sourceFileNumber = sourceFileNum; (njsl)->language = s_language; (njsl)->typeTab = typeTab; (njsl)->classStat = NULL; (njsl)->waitList = NULL; (njsl)->savedyylval = uniyylval; (njsl)->savedYYstate = s_yygstate; (njsl)->next = s_jsl;};
        memcpy(njsl->yyIdentBuf, s_yyIdentBuf,
                   sizeof(S_idIdent[YYBUFFERED_ID_INDEX]));
        s_jsl = njsl;
        s_language = 4;
}
void javaReadSymbolFromSourceFileEnd() {
        s_language = s_jsl->language;
        uniyylval = s_jsl->savedyylval;
        s_yygstate = s_jsl->savedYYstate;
        memcpy(s_yyIdentBuf, s_jsl->yyIdentBuf,
                   sizeof(S_idIdent[YYBUFFERED_ID_INDEX]));
        s_jsl = s_jsl->next;
}
struct yyGlobalState *javaAllocateNewYygstate() {
        struct yyGlobalState *res;
        {res = (struct yyGlobalState*) stackMemoryAlloc(sizeof(struct yyGlobalState)); };
        memset(res, sizeof(struct yyGlobalState), 0);
        return(res);
}
void javaReadSymbolsFromSourceFileNoFreeing(char *fname, char *asfname) {
        FILE *ff;
        S_editorBuffer *bb;
        char *cname;
        S_symbolList *ll;
        int cfilenum, loadingbit;
        static int nestDeep = 0;
        nestDeep ++;
        { if (s_opt.debug) {fprintf(dumpOut,"\n[jsl] FIRST PASS through %s level %d\n",fname,nestDeep);fflush(dumpOut);}};
        ff = NULL;
        bb = editorFindFile(fname);
        if (bb==NULL) {
                ff = fopen(fname, "r");
                if (ff==NULL) {
                        error(ERR_CANT_OPEN, fname);
                        goto fini;
                }
        }
        s_yygstate = javaAllocateNewYygstate();
        uniyylval = & s_yygstate->gyylval;
        pushNewInclude(ff, bb, asfname, "\n");
        cfilenum = cFile.lb.cb.fileNumber;
        s_jsl->pass = 1;
        javayyparse();
        popInclude();
        { if (s_opt.debug) {fprintf(dumpOut,"\n[jsl] CLOSE file %s level %d\n",fname,nestDeep);fflush(dumpOut);}};
        { if (s_opt.debug) {fprintf(dumpOut,"\n[jsl] SECOND PASS through %s level %d\n",fname,nestDeep);fflush(dumpOut);}};
        ff = NULL;
        bb = editorFindFile(fname);
        if (bb==NULL) {
                ff = fopen(fname, "r");
                if (ff==NULL) {
                        error(ERR_CANT_OPEN, fname);
                        goto fini;
                }
        }
        pushNewInclude(ff, bb, asfname, "\n");
        cfilenum = cFile.lb.cb.fileNumber;
        s_jsl->pass = 2;
        javayyparse();
        popInclude();
        { if (s_opt.debug) {fprintf(dumpOut,"\n[jsl] CLOSE file %s level %d\n",fname,nestDeep);fflush(dumpOut);}};
        for(ll=s_jsl->waitList; ll!=NULL; ll=ll->next) {
                javaJslLoadSuperClasses(ll->d, cfilenum);
        }
 fini:
        nestDeep --;
}
void javaReadSymbolsFromSourceFile(char *fname) {
        S_jslTypeTab *typeTab;
        int ii;
        int savedJslSourceFn, memBalance;
        addFileTabItem(fname, &ii);
        {typeTab = (S_jslTypeTab*) stackMemoryAlloc(sizeof(S_jslTypeTab)); };
        javaReadSymbolFromSourceFileInit(ii, typeTab);
        memBalance = s_topBlock->firstFreeIndex;
        stackMemoryBlockStart();
        jslTypeTabInit(typeTab, MAX_JSL_SYMBOLS);
        javaReadSymbolsFromSourceFileNoFreeing(fname, fname);
        while (memBalance < s_topBlock->firstFreeIndex) stackMemoryBlockFree();
        javaReadSymbolFromSourceFileEnd();
}
static void addJavaFileDependency(int file, char *onfile) {
        int fn;
        S_position pos;
        if (s_opt.taskRegime != RegimeXref) return;
        if (! s_fileTab.tab[file]->b.commandLineEntered) return;
        fn = -1;
        addFileTabItem(onfile, &fn);
        { if (!(fn != -1 && fn != s_noneFileIndex)) internalCheckFail("fn != -1 && fn != s_noneFileIndex", "jsemact.c", 732);};
        { (&pos)->file = file; (&pos)->line = 0; (&pos)->coll = 0;};
        addIncludeReference(fn, &pos);
}
static void javaHackCopySourceLoadedCopyPars(S_symbol *memb) {
        S_symbol *cl;
        cl = javaFQTypeSymbolDefinition(memb->name, memb->linkName);
        if (cl->b.javaSourceLoaded) {
                memb->b.accessFlags = cl->b.accessFlags;
                memb->b.storage = cl->b.storage;
                memb->b.symType = cl->b.symType;
                memb->b.javaSourceLoaded = cl->b.javaSourceLoaded;
        }
}
void javaLoadClassSymbolsFromFile(S_symbol *memb) {
        char *sname, *cname;
        S_symbol *cl;
        int ii, ffound, cfi, cInd;
        if (memb == NULL) return;
        sname = cname = "";
        if (memb->b.javaFileLoaded == 0) {
                memb->b.javaFileLoaded = 1;
                cl = javaFQTypeSymbolDefinition(memb->name, memb->linkName);
                if (cl!=NULL && cl!=memb) cl->b.javaFileLoaded = 1;
                cInd = javaCreateClassFileItem(memb);
                addCfClassTreeHierarchyRef(cInd, UsageClassFileDefinition);
                ffound = javaFindFile(memb, &sname, &cname);
                if (ffound == RESULT_IS_JAVA_FILE) {
                        { if (!(memb->u.s)) internalCheckFail("memb->u.s", "jsemact.c", 767);};
                        cfi = memb->u.s->classFile;
                        { if (!(s_fileTab.tab[cfi])) internalCheckFail("s_fileTab.tab[cfi]", "jsemact.c", 769);};
                        s_fileTab.tab[cfi]->b.sourceFile=s_noneFileIndex;
                        javaReadSymbolsFromSourceFile(sname);
                        if (s_fileTab.tab[cfi]->b.sourceFile == s_noneFileIndex) {
                                ffound = javaFindFile(memb, &sname, &cname);
                        }
                        if (memb->b.javaSourceLoaded == 0){
                                javaHackCopySourceLoadedCopyPars(memb);
                        }
                }
                if (ffound == RESULT_IS_CLASS_FILE) {
                        javaReadClassFile(cname,memb, LOAD_SUPER);
                } else if (ffound == RESULT_NO_FILE_FOUND) {
                        if (displayingErrorMessages()) {
                                sprintf(tmpBuff, "class %s not found", memb->name);
                                error(ERR_ST, tmpBuff);
                        }
                }
                if (cl!=NULL && cl!=memb) cl->b = memb->b;
                if (sname != NULL) {
                        addJavaFileDependency(s_olOriginalFileNumber, sname);
                }
        }
}
static int findTopLevelNameInternal(
                                                                char *name,
                                                                S_recFindStr *resRfs,
                                                                S_symbol **resMemb,
                                                                int classif,
                                                                S_javaStat *startingScope,
                                                                int accCheck,
                                                                int visibCheck,
                                                                S_javaStat **rscope
                                                                ) {
        int ii,res;
        S_symbol sd;
        S_javaStat *cscope, *scopeToSearch;
        { if (!((!((s_language & (4)) != 0)) || (classif==CLASS_TO_EXPR || classif==CLASS_TO_METHOD))) internalCheckFail("(!((s_language & (4)) != 0)) || (classif==CLASS_TO_EXPR || classif==CLASS_TO_METHOD)", "jsemact.c", 814);};
        { if (!(accCheck==ACC_CHECK_YES || accCheck==ACC_CHECK_NO)) internalCheckFail("accCheck==ACC_CHECK_YES || accCheck==ACC_CHECK_NO", "jsemact.c", 816);};
        { if (!(visibCheck==VISIB_CHECK_YES || visibCheck==VISIB_CHECK_NO)) internalCheckFail("visibCheck==VISIB_CHECK_YES || visibCheck==VISIB_CHECK_NO", "jsemact.c", 817);};
        { (&sd.b)->record = 0; (&sd.b)->accessFlags = 0; (&sd.b)->javaSourceLoaded = 0; (&sd.b)->javaFileLoaded = 0; (&sd.b)->symType = TypeDefault; (&sd.b)->storage = StorageNone; (&sd.b)->npointers = 0;};
        { (&sd)->name = name; (&sd)->linkName = name; (&sd)->pos = s_noPos; (&sd)->b = sd.b; (&sd)->u.type = NULL; (&sd)->next = NULL;};
        res = 1;
        for( cscope=startingScope;
                        cscope!=NULL && cscope->thisClass!=NULL && res!=0;
                        cscope=cscope->next
                ) {
                { if (!(cscope->thisClass)) internalCheckFail("cscope->thisClass", "jsemact.c", 826);};
                if (classif!=CLASS_TO_METHOD && symTabIsMember(cscope->locals, &sd, &ii, resMemb)) {
                        { (resRfs)->baseClass = NULL; (resRfs)->currClass = NULL; (resRfs)->nextRecord = *resMemb; (resRfs)->recsClassCounter = s_recFindCl++; (resRfs)->sti = 0;};
                        *rscope = NULL;
                } else {
                        { (resRfs)->baseClass = cscope->thisClass; (resRfs)->currClass = NULL; (resRfs)->nextRecord = NULL; (resRfs)->recsClassCounter = s_recFindCl++; (resRfs)->sti = 0;};
                        recFindPush(cscope->thisClass, resRfs);
                        *rscope = cscope;
                }
                res = findStrRecordSym(resRfs, name, resMemb, classif, accCheck, visibCheck);
        }
        return(res);
}
int findTopLevelName(
                                                                char *name,
                                                                S_recFindStr *resRfs,
                                                                S_symbol **resMemb,
                                                                int classif
                                                                ) {
        int res;
        S_javaStat *scopeToSearch, *resultScope;
        res = findTopLevelNameInternal(name, resRfs, resMemb, classif,
                                                                   s_javaStat, ACC_CHECK_YES, VISIB_CHECK_YES,
                                                                   &scopeToSearch);
        if (res != 0) {
                scopeToSearch = s_javaStat;
        }
        if (scopeToSearch!=NULL) {
                res = findTopLevelNameInternal(name, resRfs, resMemb, classif,
                                                                           scopeToSearch, ACC_CHECK_NO, VISIB_CHECK_NO,
                                                                           &resultScope);
        }
        return(res);
}
static int javaIsNestedClass(S_symbol *tclas, char *name, S_symbol **innmemb) {
        register int i,n;
        S_nestedSpec *inners;
        S_symbol *clas;
        for(clas=tclas;
                clas!=NULL && clas->u.s->super!=NULL;
                clas=clas->u.s->super->d) {
                { if (!(clas->b.symType == TypeStruct && clas->u.s)) internalCheckFail("clas->b.symType == TypeStruct && clas->u.s", "jsemact.c", 887);};
                n = clas->u.s->nnested;
                inners = clas->u.s->nest;
                for(i=0; i<n; i++) {
                        if (inners[i].membFlag && strcmp(inners[i].cl->name, name)==0) {
                                        *innmemb = inners[i].cl;
                                        return(1);
                        }
                }
        }
        return(0);
}
static int javaClassIsInnerMemberClass(S_symbol *tclas, S_symbol *name) {
        register int i,n;
        S_nestedSpec *inners;
        S_symbol *clas;
        for(clas=tclas;
                clas!=NULL && clas->u.s->super!=NULL;
                clas=clas->u.s->super->d) {
                { if (!(clas->b.symType == TypeStruct && clas->u.s)) internalCheckFail("clas->b.symType == TypeStruct && clas->u.s", "jsemact.c", 914);};
                n = clas->u.s->nnested;
                inners = clas->u.s->nest;
                for(i=0; i<n; i++) {
                        if (inners[i].membFlag && strcmp(inners[i].cl->linkName, name->linkName)==0) {
                                return(1);
                        }
                }
        }
        return(0);
}
static int javaSimpleNameIsInnerMemberClass(char *name, S_symbol **innmemb) {
        S_javaStat *cscope;
        for( cscope=s_javaStat;
                        cscope!=NULL && cscope->thisClass!=NULL;
                        cscope=cscope->next
                ) {
                if (javaIsNestedClass(cscope->thisClass, name, innmemb)) {
                        return(1);
                }
        }
        return(0);
}
int javaIsInnerAndCanGetUnnamedEnclosingInstance(S_symbol *name, S_symbol **outEi) {
        S_javaStat *cscope;
        for( cscope=s_javaStat;
                        cscope!=NULL && cscope->thisClass!=NULL;
                        cscope=cscope->next
                ) {
                if (javaClassIsInnerMemberClass(cscope->thisClass, name)) {
                        *outEi = cscope->thisClass;
                        return(1);
                }
        }
        return(0);
}
int javaClassifySingleAmbigNameToTypeOrPack(S_idIdentList *name,
                                                                                        S_symbol **str
        ){
        S_symbol sd, *memb, *nextmemb;
        int ii,haveit;
        { (&sd.b)->record = 0; (&sd.b)->accessFlags = 0; (&sd.b)->javaSourceLoaded = 0; (&sd.b)->javaFileLoaded = 0; (&sd.b)->symType = TypeStruct; (&sd.b)->storage = StorageNone; (&sd.b)->npointers = 0;};
        { (&sd)->name = name->idi.name; (&sd)->linkName = name->idi.name; (&sd)->pos = s_noPos; (&sd)->b = sd.b; (&sd)->u.type = NULL; (&sd)->next = NULL;};
        if (symTabIsMember(s_symTab, &sd, &ii, &memb)) {
                { if (!(memb)) internalCheckFail("memb", "jsemact.c", 967);};
                for(; memb!=NULL; memb=nextmemb) {
                        nextmemb = memb;
                        symTabNextMember(&sd, &nextmemb);
                        haveit = 1;
                        if (nextmemb!=NULL) {
                                javaLoadClassSymbolsFromFile(memb);
                                haveit = javaOuterClassAccessible(memb);
                        }
                        if (haveit) {
                                *str = memb;
                                name->nameType = TypeStruct;
                                name->fname = memb->linkName;
                                return(TypeStruct);
                        }
                }
        }
        name->nameType = TypePackage;
        return(TypePackage);
}
static int javaClassifySingleAmbigName( S_idIdentList *name,
                                                                                S_recFindStr *rfs,
                                                                                S_symbol **str,
                                                                                S_typeModifiers **expr,
                                                                                S_reference **oref,
                                                                                int classif, int uusage,
                                                                                int cxrefFlag
        ) {
        int res, nfqtusage;
        S_recFindStr *nullRfs = NULL;
        if (classif==CLASS_TO_EXPR || classif==CLASS_TO_METHOD) {
                if (findTopLevelName(name->idi.name,rfs,str,classif)==0) {
                        *expr = (*str)->u.type;
                        name->nameType = TypeExpression;
                        if (cxrefFlag==ADD_CX_REFS) {
                                { if (classif!=CLASS_TO_METHOD) { if (rfs != NULL && rfs->currClass!=NULL) { { if (!(rfs && rfs->currClass && rfs->currClass->b.symType==TypeStruct && rfs->currClass->u.s)) internalCheckFail("rfs && rfs->currClass && rfs->currClass->b.symType==TypeStruct && rfs->currClass->u.s", "jsemact.c", 1033);}; { if (!(rfs && rfs->baseClass && rfs->baseClass->b.symType==TypeStruct && rfs->baseClass->u.s)) internalCheckFail("rfs && rfs->baseClass && rfs->baseClass->b.symType==TypeStruct && rfs->baseClass->u.s", "jsemact.c", 1033);}; if (s_opt.cxrefs!=OLO_ENCAPSULATE || ! javaRecordAccessible(rfs, rfs->baseClass, rfs->currClass, *str, 0x002)) { *oref=addCxReference(*str,&name->idi.p,uusage, rfs->currClass->u.s->classFile, rfs->baseClass->u.s->classFile); } } else { *oref=addCxReference(*str,&name->idi.p,uusage,s_noneFileIndex,s_noneFileIndex); } }};
                                if (rfs!=NULL && rfs->currClass != NULL) {
                                        if ((*str)->b.accessFlags & 0x008) {
                                                nfqtusage = javaNotFqtUsageCorrection(rfs->currClass,UsageNotFQField);
                                                addSpecialFieldReference("  not fully qualified names",StorageField,
                                                                rfs->currClass->u.s->classFile,
                                                                &name->idi.p, nfqtusage);
                                        } else {
                                                addThisCxReferences(rfs->baseClass->u.s->classFile, &name->idi.p);
                                        }
                                }
                        }
                        return(name->nameType);
                }
        }
        res = javaClassifySingleAmbigNameToTypeOrPack( name, str);
        if (res == TypeStruct) {
                if (cxrefFlag==ADD_CX_REFS) {
                        { if (classif!=CLASS_TO_METHOD) { if (nullRfs != NULL && nullRfs->currClass!=NULL) { { if (!(nullRfs && nullRfs->currClass && nullRfs->currClass->b.symType==TypeStruct && nullRfs->currClass->u.s)) internalCheckFail("nullRfs && nullRfs->currClass && nullRfs->currClass->b.symType==TypeStruct && nullRfs->currClass->u.s", "jsemact.c", 1054);}; { if (!(nullRfs && nullRfs->baseClass && nullRfs->baseClass->b.symType==TypeStruct && nullRfs->baseClass->u.s)) internalCheckFail("nullRfs && nullRfs->baseClass && nullRfs->baseClass->b.symType==TypeStruct && nullRfs->baseClass->u.s", "jsemact.c", 1054);}; if (s_opt.cxrefs!=OLO_ENCAPSULATE || ! javaRecordAccessible(nullRfs, nullRfs->baseClass, nullRfs->currClass, *str, 0x002)) { *oref=addCxReference(*str,&name->idi.p,uusage, nullRfs->currClass->u.s->classFile, nullRfs->baseClass->u.s->classFile); } } else { *oref=addCxReference(*str,&name->idi.p,uusage,s_noneFileIndex,s_noneFileIndex); } }};
                        nfqtusage = javaNotFqtUsageCorrection((*str), UsageNotFQType);
                        addSpecialFieldReference("  not fully qualified names", StorageField,
                                                                         (*str)->u.s->classFile,
                                                                         &name->idi.p, nfqtusage);
                }
        } else if (res == TypePackage) {
                if (cxrefFlag==ADD_CX_REFS) {
                        javaAddNameCxReference(name, uusage);
                }
        } else {
                { if (!(0)) internalCheckFail("0", "jsemact.c", 1067);};
        }
        return(name->nameType);
}
static int javaNotFqtUsageCorrection(S_symbol *sym, int usage) {
        int rr,pplen;
        S_recFindStr localRfs;
        S_symbol *str;
        S_typeModifiers *expr;
        S_reference *loref;
        S_idIdentList sname, *nn;
        char *pp, packname[TMP_STRING_SIZE];
        if (s_opt.taskRegime == RegimeHtmlGenerate) return(usage);
        pp = strchr(sym->linkName, '/');
        if (pp==NULL) pp = sym->linkName;
        pplen = pp - sym->linkName;
        { if (!(pplen < TMP_STRING_SIZE-1)) internalCheckFail("pplen < TMP_STRING_SIZE-1", "jsemact.c", 1086);};
        strncpy(packname, sym->linkName, pplen);
        packname[pplen] = 0;
        { (&sname)->idi.name = packname; (&sname)->idi.sd = NULL; (&sname)->idi.p.file = s_noPos.file; (&sname)->idi.p.line = s_noPos.line; (&sname)->idi.p.coll = s_noPos.coll; (&sname)->fname = packname; (&sname)->nameType = TypeExpression; (&sname)->next = NULL;}
        rr = javaClassifySingleAmbigName(&sname,&localRfs,&str,&expr,&loref,
                                                                          CLASS_TO_EXPR, UsageNone, NO_CX_REFS);
        if (rr!=TypePackage) {
                return(UsageNonExpandableNotFQTName);
        }
        return(usage);
}
static void javaResetUselessReference(S_reference *ref) {
        if (ref != NULL ) {
                ref->usage = UsageOtherUseless;
        }
}
static void javaCheckForUselessFqt(S_idIdentList *name, int classif, S_symbol *rstr,
                                                                   S_reference **oref, S_reference *lref){
        int rr;
        S_recFindStr localRfs;
        S_symbol *str;
        S_typeModifiers *expr;
        S_reference *loref;
        S_idIdentList sname, *nn;
        if (s_opt.taskRegime == RegimeHtmlGenerate) return;
        sname = *name;
        sname.next = NULL;
        rr = javaClassifySingleAmbigName(&sname,&localRfs,&str,&expr,&loref,
                                                                          classif,UsageNone, NO_CX_REFS);
        if (rr==TypeStruct) {
                { if (!(str && rstr)) internalCheckFail("str && rstr", "jsemact.c", 1135);};
                { if (!(str->u.s!=NULL && rstr->u.s!=NULL)) internalCheckFail("str->u.s!=NULL && rstr->u.s!=NULL", "jsemact.c", 1140);};
                if (str->u.s->classFile == rstr->u.s->classFile) {
                        { if (!(name && rstr->u.s)) internalCheckFail("name && rstr->u.s", "jsemact.c", 1142);};
                        *oref = addSpecialFieldReference(" redundant long names of the project",StorageField,
                                                                                         rstr->u.s->classFile,&name->idi.p,
                                                                                         UsageLastUseless);
                        javaResetUselessReference(lref);
                }
        }
}
static S_reference *javaCheckForUselessTypeName(S_idIdentList *name,
                                                                                                int classif,
                                                                                                S_recFindStr *rfs,
                                                                                                S_reference **oref,
                                                                                                S_reference *lref
        ) {
        int rr;
        S_recFindStr localRfs;
        S_symbol *str;
        S_typeModifiers *expr;
        S_reference *loref;
        S_idIdentList sname, *nn;
        S_reference *res;
        res = NULL;
        if (s_opt.taskRegime == RegimeHtmlGenerate) return(res);
        sname = *name;
        sname.next = NULL;
        rr = javaClassifySingleAmbigName(&sname,&localRfs,&str,&expr,&loref,
                                                                          classif,UsageNone, NO_CX_REFS);
        { if (!(rfs && rfs->currClass && rfs->currClass->u.s && name)) internalCheckFail("rfs && rfs->currClass && rfs->currClass->u.s && name", "jsemact.c", 1184);};
        if (rr==TypeExpression && localRfs.currClass!=NULL) {
                if(rfs->currClass->u.s->classFile==localRfs.currClass->u.s->classFile){
                        *oref = addSpecialFieldReference(" redundant long names of the project",StorageField,
                                                                         rfs->currClass->u.s->classFile,
                                                                         &name->idi.p,
                                                                         UsageLastUseless);
                        javaResetUselessReference(lref);
                }
        }
        return(res);
}
static void javaClassifyNameToNestedType(S_idIdentList *name, S_symbol *outerc, int uusage, S_symbol **str, S_reference **oref) {
        name->nameType = TypeStruct;
        *str = javaTypeSymbolUsage(name,0x000);
        javaLoadClassSymbolsFromFile(*str);
        if ((s_opt.ooChecksBits & 00010)==0
                || javaRecordAccessible(NULL,outerc, outerc, *str, (*str)->b.accessFlags)) {
                *oref = javaAddClassCxReference(*str, &name->idi.p, uusage);
        }
}
static void classifiedToNestedClass(S_idIdentList *name, S_symbol **str, S_reference **oref, S_reference **rdtoref, int classif, int uusage, S_symbol *pstr, S_reference *prdtoref) {
        name->nameType = TypeStruct;
        javaLoadClassSymbolsFromFile(*str);
        if ((s_opt.ooChecksBits & 00010)==0
                || javaRecordAccessible(NULL,pstr, pstr, *str, (*str)->b.accessFlags)) {
                *oref = javaAddClassCxReference(*str, &name->idi.p, uusage);
                javaCheckForUselessFqt(name, classif, *str, rdtoref, prdtoref);
        }
}
int javaClassifyAmbiguousName(
                S_idIdentList *name,
                S_recFindStr *rfs,
                S_symbol **str,
                S_typeModifiers **expr,
                S_reference **oref,
                S_reference **rdtoref,
                int classif,
                int usage) {
        S_symbol *memb, *innm, sd;
        int ii,pres,rf,classif2,rr;
        int uusage,res;
        S_symbol *pstr;
        S_recFindStr localRfs;
        S_typeModifiers *pexpr;
        S_reference *poref, *localrdref, *prdtoref;
        { if (!(classif==CLASS_TO_TYPE || classif==CLASS_TO_EXPR || classif==CLASS_TO_METHOD)) internalCheckFail("classif==CLASS_TO_TYPE || classif==CLASS_TO_EXPR || classif==CLASS_TO_METHOD", "jsemact.c", 1241);};
        uusage = usage;
        if (uusage==UsageUsed && (s_topBlock->previousTopBlock == NULL)) uusage = UsageAddrUsed;
        if (rfs == NULL) rfs = &localRfs;
        if (rdtoref == NULL) rdtoref = &localrdref;
        *oref = NULL; *rdtoref = NULL;
        { if (!(name)) internalCheckFail("name", "jsemact.c", 1249);};
        if (name->next == NULL) {
                javaClassifySingleAmbigName(name,rfs,str,expr,oref,classif,uusage, ADD_CX_REFS);
        } else {
                if (classif == CLASS_TO_METHOD) {
                        classif2 = CLASS_TO_EXPR;
                } else {
                        classif2 = classif;
                }
                pres = javaClassifyAmbiguousName(name->next, NULL, &pstr,
                                                                                 &pexpr, &poref, &prdtoref,
                                                                                 classif2,UsageUsed);
                *rdtoref = prdtoref;
                switch (pres) {
                case TypePackage:
                        if (javaTypeFileExist(name)) {
                                name->nameType = TypeStruct;
                                *str = javaTypeSymbolUsage(name, 0x000);
                                javaCheckForUselessFqt(name, classif, *str, rdtoref, prdtoref);
                                javaLoadClassSymbolsFromFile(*str);
                                if ((s_opt.ooChecksBits & 00010)==0
                                        || javaOuterClassAccessible(*str)) {
                                        *oref = javaAddClassCxReference(*str, &name->idi.p, uusage);
                                }
                        } else {
                                name->nameType = TypePackage;
                                javaAddNameCxReference(name, uusage);
                        }
                        break;
                case TypeStruct:
                        if (classif==CLASS_TO_TYPE) {
                                javaLoadClassSymbolsFromFile(pstr);
                                name->nameType = TypeStruct;
                                if (javaIsNestedClass(pstr,name->idi.name,str)) {
                                        classifiedToNestedClass(name, str, oref, rdtoref, classif, uusage, pstr, prdtoref);
                                } else {
                                        javaClassifyNameToNestedType(name, pstr, uusage, str, oref);
                                        javaCheckForUselessFqt(name,classif,*str,rdtoref,prdtoref);
                                }
                        } else {
                                javaLoadClassSymbolsFromFile(pstr);
                                rf = findStrRecordSym(iniFind(pstr,rfs), name->idi.name, str,
                                                                          classif, ACC_CHECK_NO, VISIB_CHECK_NO);
                                *expr = (*str)->u.type;
                                if (rf == 0) {
                                        name->nameType = TypeExpression;
                                        if ((s_opt.ooChecksBits & 00010)==0
                                                || javaRecordVisibleAndAccessible(rfs, rfs->baseClass, rfs->currClass, *str)) {
                                                { if (classif!=CLASS_TO_METHOD) { if (rfs != NULL && rfs->currClass!=NULL) { { if (!(rfs && rfs->currClass && rfs->currClass->b.symType==TypeStruct && rfs->currClass->u.s)) internalCheckFail("rfs && rfs->currClass && rfs->currClass->b.symType==TypeStruct && rfs->currClass->u.s", "jsemact.c", 1299);}; { if (!(rfs && rfs->baseClass && rfs->baseClass->b.symType==TypeStruct && rfs->baseClass->u.s)) internalCheckFail("rfs && rfs->baseClass && rfs->baseClass->b.symType==TypeStruct && rfs->baseClass->u.s", "jsemact.c", 1299);}; if (s_opt.cxrefs!=OLO_ENCAPSULATE || ! javaRecordAccessible(rfs, rfs->baseClass, rfs->currClass, *str, 0x002)) { *oref=addCxReference(*str,&name->idi.p,uusage, rfs->currClass->u.s->classFile, rfs->baseClass->u.s->classFile); } } else { *oref=addCxReference(*str,&name->idi.p,uusage,s_noneFileIndex,s_noneFileIndex); } }};
                                                javaCheckForUselessTypeName(name, classif, rfs,
                                                                                                        rdtoref, prdtoref);
                                        }
                                } else {
                                        if (javaIsNestedClass(pstr,name->idi.name,str)) {
                                                classifiedToNestedClass(name, str, oref, rdtoref, classif, uusage, pstr, prdtoref);
                                        } else {
                                                name->nameType = TypeExpression;
                                                noSuchRecordError(name->idi.name);
                                        }
                                }
                        }
                        break;
                case TypeExpression:
                        if (pexpr->m == TypeArray) pexpr = &s_javaArrayObjectSymbol.u.s->stype;
                        if (pexpr->m != TypeStruct) {
                                *str = &s_errorSymbol;
                        } else {
                                javaLoadClassSymbolsFromFile(pexpr->u.t);
                                rr = findStrRecordSym(iniFind(pexpr->u.t,rfs), name->idi.name,
                                                                          str, classif, ACC_CHECK_NO, VISIB_CHECK_NO);
                                if (rr == RESULT_OK) {
                                        if ((s_opt.ooChecksBits & 00010)==0
                                                || javaRecordVisibleAndAccessible(rfs, rfs->baseClass, rfs->currClass, *str)) {
                                                { if (classif!=CLASS_TO_METHOD) { if (rfs != NULL && rfs->currClass!=NULL) { { if (!(rfs && rfs->currClass && rfs->currClass->b.symType==TypeStruct && rfs->currClass->u.s)) internalCheckFail("rfs && rfs->currClass && rfs->currClass->b.symType==TypeStruct && rfs->currClass->u.s", "jsemact.c", 1328);}; { if (!(rfs && rfs->baseClass && rfs->baseClass->b.symType==TypeStruct && rfs->baseClass->u.s)) internalCheckFail("rfs && rfs->baseClass && rfs->baseClass->b.symType==TypeStruct && rfs->baseClass->u.s", "jsemact.c", 1328);}; if (s_opt.cxrefs!=OLO_ENCAPSULATE || ! javaRecordAccessible(rfs, rfs->baseClass, rfs->currClass, *str, 0x002)) { *oref=addCxReference(*str,&name->idi.p,uusage, rfs->currClass->u.s->classFile, rfs->baseClass->u.s->classFile); } } else { *oref=addCxReference(*str,&name->idi.p,uusage,s_noneFileIndex,s_noneFileIndex); } }};
                                        }
                                } else {
                                        noSuchRecordError(name->idi.name);
                                }
                        }
                        *expr = (*str)->u.type;
                        name->nameType = TypeExpression;
                        break;
                default: { if (!(0)) internalCheckFail("0", "jsemact.c", 1337);};
                }
        }
        return(name->nameType);
}
S_typeModifiers *javaClassifyToExpressionName(S_idIdentList *name,
                                                                                          S_reference **oref) {
        S_symbol *str;
        S_typeModifiers *expr,*res;
        int atype;
        atype = javaClassifyAmbiguousName(name,NULL,&str,&expr,oref,NULL,CLASS_TO_EXPR,UsageUsed);
        if (atype == TypeExpression) res = expr;
        else if (atype == TypeStruct) {
                { if (!(str && str->u.s)) internalCheckFail("str && str->u.s", "jsemact.c", 1353);};
                res = &str->u.s->stype;
                { if (!(res && res->m == TypeStruct)) internalCheckFail("res && res->m == TypeStruct", "jsemact.c", 1355);};
        } else res = & s_errorModifier;
        return(res);
}
S_reference *javaClassifyToTypeOrPackageName(S_idIdentList *tname, int usage, S_symbol **str) {
        S_typeModifiers *expr;
        S_idIdentList *ii;
        S_reference *rr, *lastUselessRef;
        lastUselessRef = NULL;
        javaClassifyAmbiguousName(tname, NULL, str, &expr, &rr, &lastUselessRef,
                                                          CLASS_TO_TYPE, usage);
        return(lastUselessRef);
}
S_reference *javaClassifyToTypeName(S_idIdentList *tname, int usage, S_symbol **str) {
        S_reference *res;
        S_symbol *ss;
        res = javaClassifyToTypeOrPackageName(tname, usage, str);
        if (tname->nameType != TypeStruct) {
                tname->nameType = TypeStruct;
        }
        return(res);
}
S_symbol * javaQualifiedThis(S_idIdentList *tname, S_idIdent *thisid) {
        S_symbol *str;
        S_typeModifiers *expr;
        S_idIdentList *ii;
        S_reference *rr, *lastUselessRef;
        int ttype;
        lastUselessRef = NULL;
        ttype = javaClassifyAmbiguousName(tname, NULL,&str,&expr,&rr,
                                                                          &lastUselessRef,CLASS_TO_TYPE,UsageUsed);
        if (ttype == TypeStruct) {
                addThisCxReferences(str->u.s->classFile, &thisid->p);
                if (str->u.s->classFile == s_javaStat->classFileInd) {
                        addSpecialFieldReference(" redundant long names of the project",StorageField,
                                                                         str->u.s->classFile,
                                                                         &thisid->p,
                                                                         UsageLastUseless);
                        javaResetUselessReference(lastUselessRef);
                }
        } else {
                str = &s_errorSymbol;
        }
        tname->nameType = TypeStruct;
        return(str);
}
void javaClassifyToPackageName( S_idIdentList *id ) {
        S_idIdentList *ii;
        for (ii=id; ii!=NULL; ii=ii->next) ii->nameType = TypePackage;
}
void javaClassifyToPackageNameAndAddRefs(S_idIdentList *id, int usage) {
        S_idIdentList *ii;
        javaClassifyToPackageName( id);
        for (ii=id; ii!=NULL; ii=ii->next) javaAddNameCxReference(ii, usage);
}
void javaAddPackageDefinition(S_idIdentList *id) {
        javaClassifyToPackageNameAndAddRefs(id, UsageUsed);
}
void javaSetFieldLinkName(S_symbol *field) {
        char *ln;
        { if (!(s_javaStat)) internalCheckFail("s_javaStat", "jsemact.c", 1435);};
        ln = javaCreateComposedName(NULL,s_javaStat->className,'/', field->name, NULL, 0);
        field->linkName = ln;
}
S_symbol *javaCreateNewMethod(char *nn, S_position *p, int mem) {
        S_typeModifiers *m;
        S_symbol *res;
        char *name;
        if (mem==MEM_CF) {
                {{ { if (!((strlen(nn)+1) >= 0)) internalCheckFail("(strlen(nn)+1) >= 0", "jsemact.c", 1446);}; ppmMemoryi = ((char*)(((char*)(ppmMemory+ppmMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(ppmMemory+ppmMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - ppmMemory; if (ppmMemoryi+(strlen(nn)+1)*sizeof(char) >= SIZE_ppmMemory) { fatalError(ERR_NO_MEMORY,"ppmMemory", 65); } name = (char*) (ppmMemory + ppmMemoryi); ppmMemoryi += (strlen(nn)+1)*sizeof(char);};};
                strcpy(name, nn);
                {{{ { if (!((1) >= 0)) internalCheckFail("(1) >= 0", "jsemact.c", 1448);}; ppmMemoryi = ((char*)(((char*)(ppmMemory+ppmMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(ppmMemory+ppmMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - ppmMemory; if (ppmMemoryi+(1)*sizeof(S_typeModifiers) >= SIZE_ppmMemory) { fatalError(ERR_NO_MEMORY,"ppmMemory", 65); } m = (S_typeModifiers*) (ppmMemory + ppmMemoryi); ppmMemoryi += (1)*sizeof(S_typeModifiers);};};};
                {{{ { if (!((1) >= 0)) internalCheckFail("(1) >= 0", "jsemact.c", 1449);}; ppmMemoryi = ((char*)(((char*)(ppmMemory+ppmMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(ppmMemory+ppmMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - ppmMemory; if (ppmMemoryi+(1)*sizeof(S_symbol) >= SIZE_ppmMemory) { fatalError(ERR_NO_MEMORY,"ppmMemory", 65); } res = (S_symbol*) (ppmMemory + ppmMemoryi); ppmMemoryi += (1)*sizeof(S_symbol);};};};
        } else {
                name = nn;
                m = ((S_typeModifiers*) stackMemoryAlloc(sizeof(S_typeModifiers)));
                res = ((S_symbol*) stackMemoryAlloc(sizeof(S_symbol)));
        }
        { (m)->m = TypeFunction; { (&((&(m)->u)->f))->args = NULL; (&((&(m)->u)->f))->thisFunList = NULL;}; (m)->typedefin = NULL; (m)->next = NULL;};
        { (&res->b)->record = 0; (&res->b)->accessFlags = 0; (&res->b)->javaSourceLoaded = 0; (&res->b)->javaFileLoaded = 0; (&res->b)->symType = TypeDefault; (&res->b)->storage = StorageDefault; (&res->b)->npointers = 0;};
        { (res)->name = name; (res)->linkName = name; (res)->pos = *p; (res)->b = res->b; (res)->u.type = m; (res)->next = NULL;};
        res->u.type = m;
        return(res);
}
static int javaTypeToString(S_typeModifiers *type, char *pp, int ppSize) {
        int ppi;
        S_typeModifiers *tt;
        ppi=0;
        for (tt=type; tt!=NULL; tt=tt->next) {
                if (tt->m == TypeArray) {
                        sprintf(pp+ppi,"[");
                        ppi += strlen(pp+ppi);
                } else if (tt->m == TypeStruct) {
                        { if (!(tt->u.t)) internalCheckFail("tt->u.t", "jsemact.c", 1473);};
                        sprintf(pp+ppi,"L%s;",tt->u.t->linkName);
                        ppi += strlen(pp+ppi);
                } else {
                        { if (!(s_javaBaseTypeCharCodes[tt->m]!=0)) internalCheckFail("s_javaBaseTypeCharCodes[tt->m]!=0", "jsemact.c", 1477);};
                        pp[ppi++] = s_javaBaseTypeCharCodes[tt->m];
                }
                { if (!(ppi < ppSize)) internalCheckFail("ppi < ppSize", "jsemact.c", 1480);};
        }
        pp[ppi]=0;
        return(ppi);
}
int javaIsYetInTheClass(S_symbol *clas, char *lname, S_symbol **eq) {
        S_symbol *memb,*r;
        { if (!(clas && clas->u.s)) internalCheckFail("clas && clas->u.s", "jsemact.c", 1515);};
        for (r=clas->u.s->records; r!=NULL; r=r->next) {
                if (strcmp(r->linkName, lname)==0) {
                        *eq = r;
                        return(1);
                }
        }
        *eq = NULL;
        return(0);
}
static int javaNumberOfNativeMethodsWithThisName(S_symbol *clas, char *name) {
        S_symbol *memb,*r;
        int res;
        res = 0;
        { if (!(clas && clas->b.symType==TypeStruct && clas->u.s)) internalCheckFail("clas && clas->b.symType==TypeStruct && clas->u.s", "jsemact.c", 1532);};
        for (r=clas->u.s->records; r!=NULL; r=r->next) {
                if (strcmp(r->name, name)==0 && (r->b.accessFlags&0x100)) {
                        res++;
                }
        }
        return(res);
}
int javaSetFunctionLinkName(S_symbol *clas, S_symbol *decl,int mem) {
        static char pp[MAX_PROFILE_SIZE];
        char *ln, *classn;
        int ppi,profilei, res;
        S_symbol *args;
        S_typeModifiers *tt;
        S_symbol *memb;
        res = 0;
        if (decl == &s_errorSymbol || decl->b.symType==TypeError) return(res);
        { if (!(decl->b.symType == TypeDefault)) internalCheckFail("decl->b.symType == TypeDefault", "jsemact.c", 1551);};
        { if (!(decl->u.type)) internalCheckFail("decl->u.type", "jsemact.c", 1552);};
        if (decl->u.type->m != TypeFunction) return(res);
        ppi=0;
                sprintf(pp+ppi,"%s", decl->name);
        ppi += strlen(pp+ppi);
        profilei = ppi;
        sprintf(pp+ppi,"(");
        ppi += strlen(pp+ppi);
        for(args=decl->u.type->u.f.args; args!=NULL; args=args->next) {
                ppi += javaTypeToString(args->u.type, pp+ppi, MAX_PROFILE_SIZE-ppi);
        }
        sprintf(pp+ppi,")");
        ppi += strlen(pp+ppi);
        { if (!(ppi<MAX_PROFILE_SIZE)) internalCheckFail("ppi<MAX_PROFILE_SIZE", "jsemact.c", 1569);};
        if (javaIsYetInTheClass(clas, pp, &memb)) {
                decl->linkName = memb->linkName;
        } else {
                if (mem == MEM_CF) {
                        {{ { if (!((ppi+1) >= 0)) internalCheckFail("(ppi+1) >= 0", "jsemact.c", 1575);}; ppmMemoryi = ((char*)(((char*)(ppmMemory+ppmMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(ppmMemory+ppmMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - ppmMemory; if (ppmMemoryi+(ppi+1)*sizeof(char) >= SIZE_ppmMemory) { fatalError(ERR_NO_MEMORY,"ppmMemory", 65); } ln = (char*) (ppmMemory + ppmMemoryi); ppmMemoryi += (ppi+1)*sizeof(char);};};
                } else {
                        { if (!(mem==MEM_XX)) internalCheckFail("mem==MEM_XX", "jsemact.c", 1577);};
                        {ln = (char*) stackMemoryAlloc((ppi+1)*sizeof(char)); };
                }
                strcpy(ln,pp);
                decl->linkName = ln;
                res = 1;
        }
        return(res);
}
static void addNativeMethodCxReference(S_symbol *decl, S_symbol *clas) {
        char nlname[MAX_CX_SYMBOL_SIZE];
        char *s, *d;
        int baselen;
        sprintf(nlname, "Java_");
        s = clas->linkName;
        d = nlname + strlen(nlname);
        for(; *s; s++,d++) {
                if (*s=='/' || *s=='\\' || *s=='.') *d = '_';
                else if (*s=='_') {*d++ = '_'; *d = '1';}
                else if (*s=='$') {*d++ = '_'; *d++='0'; *d++='0'; *d++='0'; *d++='2'; *d='4';}
                else *d = *s;
        }
        *d++ = '_';
        if (javaNumberOfNativeMethodsWithThisName(clas, decl->name) > 1) {
                s = decl->linkName;
        } else {
                s = decl->name;
        }
        for(; *s; s++,d++) {
                if (*s=='/' || *s=='\\' || *s=='.') *d = '_';
                else if (*s=='_') {*d++ = '_'; *d = '1';}
                else if (*s==';') {*d++ = '_'; *d = '2';}
                else if (*s=='[') {*d++ = '_'; *d = '3';}
                else if (*s=='$') {*d++ = '_'; *d++='0'; *d++='0'; *d++='0'; *d++='2'; *d='4';}
                else if (*s=='(') {*d++ = '_'; *d = '_';}
                else if (*s==')') *d=0;
                else *d = *s;
        }
        *d = 0;
        { if (!(d-nlname < MAX_CX_SYMBOL_SIZE-1)) internalCheckFail("d-nlname < MAX_CX_SYMBOL_SIZE-1", "jsemact.c", 1617);};
        addTrivialCxReference(nlname, TypeDefault,StorageExtern, &decl->pos,
                                                  UsageJavaNativeDeclared);
}
int javaLinkNameIsANestedClass(char *cname) {
        if (strchr(cname, '$') != NULL) return(1);
        return(0);
}
int isANestedClass(S_symbol *ss) {
        return(javaLinkNameIsANestedClass(ss->linkName));
}
int javaLinkNameIsAnnonymousClass(char *linkname) {
        char *ss;
        ss = linkname;
        while ((ss=strchr(ss, '$'))!=NULL) {
                ss++;
                if (isdigit(*ss)) return(1);
        }
        return(0);
}
void addThisCxReferences(int classIndex, S_position *pos) {
        int usage;
        if (classIndex == s_javaStat->classFileInd) {
                usage = UsageMaybeThis;
        } else {
                usage = UsageMaybeQualifiedThis;
        }
        addSpecialFieldReference("  method's \"maybe this\" dependencies",StorageField,
                                                         classIndex, pos, usage);
}
S_reference *addUselessFQTReference(int classIndex, S_position *pos) {
        S_reference *res;
        res = addSpecialFieldReference(" redundant long names of the project",StorageField,
                                                                   classIndex, pos, UsageLastUseless);
        return(res);
}
void addSuperMethodCxReferences(int classIndex, S_position *pos) {
        addSpecialFieldReference("  \"super\" dot method references",StorageField,
                                                         classIndex, pos,
                                                         UsageSuperMethod);
}
S_symbol *javaPrependDirectEnclosingInstanceArgument(S_symbol *args) {
        warning(ERR_ST,"[javaPrependDirectEnclosingInstanceArgument] not yet implemented");
        return(args);
}
void addMethodCxReferences(unsigned modif, S_symbol *method, S_symbol *clas) {
        int clasn;
        { if (!(clas && clas->u.s)) internalCheckFail("clas && clas->u.s", "jsemact.c", 1677);};
        clasn = clas->u.s->classFile;
        { if (!(clasn!=s_noneFileIndex)) internalCheckFail("clasn!=s_noneFileIndex", "jsemact.c", 1679);};
        addCxReference(method, &method->pos, UsageDefined, clasn, clasn);
        if (modif & 0x100) {
                addNativeMethodCxReference(method, clas);
        }
}
S_symbol *javaMethodHeader(unsigned modif, S_symbol *type,
                                                   S_symbol *decl, int storage) {
        int newFun,vClass;
        completeDeclarator(type, decl);
        decl->b.accessFlags = modif;
        decl->b.storage = storage;
        if (s_javaStat->thisClass->b.accessFlags & 0x200) {
                decl->b.accessFlags |= (0x001 | 0x400);
        }
        newFun = javaSetFunctionLinkName(s_javaStat->thisClass, decl,MEM_XX);
        vClass = s_javaStat->classFileInd;
        addMethodCxReferences(modif, decl, s_javaStat->thisClass);
        htmlAddJavaDocReference(decl, &decl->pos, vClass, vClass);
        if (newFun) {
                { if ((s_javaStat->thisClass->u.s->records)==NULL) s_javaStat->thisClass->u.s->records = decl; else { register S_symbol *tempnsl; tempnsl = s_javaStat->thisClass->u.s->records; while (tempnsl->next!=NULL) tempnsl=tempnsl->next; tempnsl->next = decl; } };
        }
        return(decl);
}
void javaAddMethodParametersToSymTable(S_symbol *method) {
        S_symbol *p, *pp, *pa;
        int i;
        for(p=method->u.type->u.f.args,i=1; p!=NULL; p=p->next,i++) {
                addFunctionParameterToSymTable(method, p, i, s_javaStat->locals);
        }
}
void javaMethodBodyBeginning(S_symbol *method) {
        S_symbol *p,*pp;
        int i;
        { if (!(method->u.type && method->u.type->m == TypeFunction)) internalCheckFail("method->u.type && method->u.type->m == TypeFunction", "jsemact.c", 1724);};
        s_cp.function = method;
        { if (s_opt.cxrefs == OLO_EXTRACT) genInternalLabelReference(-1, UsageDefined);};
        s_count.localVar = 0;
        javaAddMethodParametersToSymTable(method);
        method->u.type->u.m.sig = strchr(method->linkName, '(');
        s_javaStat->cpMethodMods = method->b.accessFlags;
}
void javaMethodBodyEnding(S_position *endpos) {
        { if ((((unsigned)time(NULL))>(unsigned)1057010400) ||(((unsigned)time(NULL))<=(unsigned)0)) { fatalError(ERR_LICENSE, "", 67); }};
        if (s_opt.taskRegime == RegimeHtmlGenerate) {
                htmlAddFunctionSeparatorReference();
        } else if (s_opt.taskRegime == RegimeEditServer) {
                if (s_cp.parserPassedMarker && !s_cp.thisMethodMemoriesStored){
                        s_cps.methodCoordEndLine = cFile.lineNumber+1;
                        s_cps.methodCoordEndPosition = *endpos;
                }
        }
        s_cp.function = NULL;
}
void javaAddMapedTypeName(
                                                        char *file,
                                                        char *path,
                                                        char *pack,
                                                        S_completions *c,
                                                        void *vdirid,
                                                        int *storage
                                                ) {
        char *p,*suff;
        char ttt1[MAX_FILE_NAME_SIZE];
        char ttt2[MAX_FILE_NAME_SIZE];
        int len2;
        S_idIdentList dd1,dd2,*packid;
        S_symbol *memb;
        packid = (S_idIdentList *) vdirid;
        for(p=file; *p && *p!='.' && *p!='$'; p++) ;
        if (*p != '.') return;
        if (strcmp(p,".class")!=0 && strcmp(p,".java")!=0) return;
        len2 = p - file;
        strncpy(ttt2, file, len2);
        { if (!(len2+1 < MAX_FILE_NAME_SIZE)) internalCheckFail("len2+1 < MAX_FILE_NAME_SIZE", "jsemact.c", 1769);};
        ttt2[len2] = 0;
        { (&dd2)->idi.name = ttt2; (&dd2)->idi.sd = NULL; (&dd2)->idi.p.file = -1; (&dd2)->idi.p.line = 0; (&dd2)->idi.p.coll = 0; (&dd2)->fname = ttt2; (&dd2)->nameType = TypeStruct; (&dd2)->next = packid;};
        memb = javaTypeSymbolDefinition(&dd2,0x000, TYPE_ADD_YES);
        { if (s_opt.debug) {fprintf(dumpOut,":import type %s == %s\n",memb->name,memb->linkName);fflush(dumpOut);}};
}
S_typeModifiers *javaClassNameType(S_idIdentList *typeName) {
        S_typeModifiers *tt; S_symbol *st;
        { if (!(typeName)) internalCheckFail("typeName", "jsemact.c", 1778);};
        { if (!(typeName->nameType == TypeStruct)) internalCheckFail("typeName->nameType == TypeStruct", "jsemact.c", 1779);};
        {tt = (S_typeModifiers*) stackMemoryAlloc(sizeof(S_typeModifiers)); };
        st = javaTypeSymbolUsage(typeName,0x000);
        { (tt)->m = TypeStruct; (&(tt)->u)->t = st;; (tt)->typedefin = NULL; (tt)->next = NULL;};
        return(tt);
}
S_typeModifiers *javaNestedNewType(S_symbol *sym, S_idIdent *thenew,
                                                                   S_idIdentList *idl) {
        S_idIdentList d1,d2;
        S_typeModifiers *res;
        char *id2;
        S_idIdent *id;
        S_symbol *str;
        S_reference *rr;
        if (idl->next == NULL) {
                id = &idl->idi;
                { if (!(sym && sym->linkName)) internalCheckFail("sym && sym->linkName", "jsemact.c", 1797);};
                id2 = sym->linkName;
                { (&d2)->idi.name = id2; (&d2)->idi.sd = sym; (&d2)->idi.p.file = -1; (&d2)->idi.p.line = 0; (&d2)->idi.p.coll = 0; (&d2)->fname = id2; (&d2)->nameType = TypeStruct; (&d2)->next = NULL;};
                { (&d1)->idi = *id; (&d1)->fname = id->name; (&d1)->nameType = TypeStruct; (&d1)->next = &d2;};
                javaClassifyNameToNestedType(&d1, sym, UsageUsed, &str, &rr);
                res = javaClassNameType(&d1);
        } else {
                javaClassifyToTypeName(idl, UsageUsed, &str);
                res = javaClassNameType(idl);
                if (res && res->m == TypeStruct) {
                        { if (!(res->u.t && res->u.t->u.s)) internalCheckFail("res->u.t && res->u.t->u.s", "jsemact.c", 1809);};
                        if (res->u.t->b.accessFlags & 0x008) {
                                addUselessFQTReference(res->u.t->u.s->classFile, &thenew->p);
                        }
                } else {
                        res = &s_errorModifier;
                }
        }
        return(res);
}
S_typeModifiers *javaNewAfterName(S_idIdentList *name, S_idIdent *thenew, S_idIdentList *idl) {
        S_symbol *str;
        S_typeModifiers *expr,*res;
        int atype;
        S_reference *rr;
        S_idIdent *id;
        id = &idl->idi;
        atype = javaClassifyAmbiguousName(name,NULL,&str,&expr,&rr,NULL,CLASS_TO_EXPR,UsageUsed);
        if (atype == TypeExpression) {
                if (expr->m != TypeStruct) res = & s_errorModifier;
                else res = javaNestedNewType(expr->u.t, thenew, idl);
        } else if (atype == TypeStruct) {
                { if (!(str)) internalCheckFail("str", "jsemact.c", 1833);};
                { if (!(str->b.symType == TypeStruct)) internalCheckFail("str->b.symType == TypeStruct", "jsemact.c", 1834);};
                res = javaNestedNewType(str, thenew, idl);
        } else res = & s_errorModifier;
        return(res);
}
static int javaExistBaseTypeWideningConversion(int t1, int t2) {
        int i1,i2,res;
        { if (!(t1>=0 && t1<MAX_TYPE)) internalCheckFail("t1>=0 && t1<MAX_TYPE", "jsemact.c", 1842);};
        { if (!(t2>=0 && t2<MAX_TYPE)) internalCheckFail("t2>=0 && t2<MAX_TYPE", "jsemact.c", 1843);};
        if (t1 == t2) return(1);
        i1 = s_javaTypePCTIConvert[t1];
        i2 = s_javaTypePCTIConvert[t2];
        if (i1 == 0 || i2 == 0) return(0);
        { if (!(i1-1>=0 && i1-1<MAX_PCTIndex-1)) internalCheckFail("i1-1>=0 && i1-1<MAX_PCTIndex-1", "jsemact.c", 1849);};
        { if (!(i2-1>=0 && i2-1<MAX_PCTIndex-1)) internalCheckFail("i2-1>=0 && i2-1<MAX_PCTIndex-1", "jsemact.c", 1850);};
        res = s_javaPrimitiveWideningConversions[i1-1][i2-1];
        { if (!(res == 0 || res == 1)) internalCheckFail("res == 0 || res == 1", "jsemact.c", 1852);};
        return(res);
}
static int javaExistBaseWideningConversion(char c1, char c2) {
        int t1,t2;
        { if (!(c1>=0 && c1<127)) internalCheckFail("c1>=0 && c1<127", "jsemact.c", 1860);};
        { if (!(c2>=0 && c2<127)) internalCheckFail("c2>=0 && c2<127", "jsemact.c", 1861);};
        if (c1 == c2) return(1);
        t1 = s_javaCharCodeBaseTypes[c1];
        t2 = s_javaCharCodeBaseTypes[c2];
        return(javaExistBaseTypeWideningConversion(t1, t2));
}
static char * javaPassToNextParamInTypeString(char *ss) {
        { if (!(ss)) internalCheckFail("ss", "jsemact.c", 1873);};
        while (*ss == '[') { for(ss++; *ss && isdigit(*ss); ss++) ;} ;
        { if (!(*ss)) internalCheckFail("*ss", "jsemact.c", 1875);};
        if (*ss == 'L') {
                for(ss++; *ss && *ss!=';'; ss++) ;
                ss++;
        } else {
                ss++;
        }
        return(ss);
}
static S_symbol *javaStringTypeObject(char **ss) {
        char *s;
        S_symbol *res;
        s = *ss;
        if (*s == 'L') {
                res = javaGetFieldClass(s+1,&s);
                s++;
        } else if (*s == '[') {
                res = &s_javaArrayObjectSymbol;
                s = javaPassToNextParamInTypeString(s);
        } else {
                res = NULL;
                s++;
        }
        *ss = s;
        return(res);
}
static int javaExistWideningConversion(char **t1, char **t2) {
        char ss1,*s1, *s2;
        char c1,c2;
        S_symbol *sym1,*sym2;
        int res = 1;
        s1 = *t1; s2 = *t2;
        { if (!(s1 && s2)) internalCheckFail("s1 && s2", "jsemact.c", 1909);};
        while (*s1 == '[' && *s2 == '[') {
                { for(s1++; *s1 && isdigit(*s1); s1++) ;};
                { if (!(*s1)) internalCheckFail("*s1", "jsemact.c", 1914);};
                { for(s2++; *s2 && isdigit(*s2); s2++) ;};
                { if (!(*s2)) internalCheckFail("*s2", "jsemact.c", 1916);};
        }
        if (*s1 == 'N' && *s2 == '[') {
                s1++;
                while (*s2 == '[') { for(s2++; *s2 && isdigit(*s2); s2++) ;};
                if (*s2 == 'L') javaStringTypeObject(&s2);
                else s2++;
                goto finish;
        }
        if (*s1 == 'L' || *s2 == 'L') {
                ss1 = *s1;
                sym1 = javaStringTypeObject(&s1);
                sym2 = javaStringTypeObject(&s2);
                if (ss1 == 'N') {res &= 1; goto finish;}
                if (ss1 == '['
                                && (sym2 == s_javaCloneableSymbol
                                         || sym2 == s_javaIoSerializableSymbol
                                         || sym2 == s_javaObjectSymbol)) {
                        res &= 1; goto finish;
                }
                if (sym1==NULL || sym2 == NULL) {res &= 0; goto finish;}
                { if (!(sym1 && sym2 && sym1->u.s)) internalCheckFail("sym1 && sym2 && sym1->u.s", "jsemact.c", 1937);};
                if (sym1 == sym2) {res &= 1; goto finish;}
                javaLoadClassSymbolsFromFile(sym1);
                res &= cctIsMember(& sym1->u.s->casts, sym2, 1);
                goto finish;
        } else {
                c1 = *s1++; c2 = *s2++;
                res &= javaExistBaseWideningConversion(c1,c2);
                goto finish;
        }
        { if (!(0)) internalCheckFail("0", "jsemact.c", 1948);};
finish:
        *t1 = s1; *t2 = s2;
        return(res);
}
static int javaSmallerProfile(S_symbol *s1, S_symbol *s2) {
        int r;
        char *p1,*p2;
        { if (!(s1 && s1->b.symType==TypeDefault && s1->u.type)) internalCheckFail("s1 && s1->b.symType==TypeDefault && s1->u.type", "jsemact.c", 1959);};
        { if (!(s1->u.type->m == TypeFunction && s1->u.type->u.m.sig)) internalCheckFail("s1->u.type->m == TypeFunction && s1->u.type->u.m.sig", "jsemact.c", 1960);};
        { if (!(s2 && s2->b.symType==TypeDefault && s2->u.type)) internalCheckFail("s2 && s2->b.symType==TypeDefault && s2->u.type", "jsemact.c", 1961);};
        { if (!(s2->u.type->m == TypeFunction && s2->u.type->u.m.sig)) internalCheckFail("s2->u.type->m == TypeFunction && s2->u.type->u.m.sig", "jsemact.c", 1962);};
        p1 = s1->u.type->u.m.sig;
        p2 = s2->u.type->u.m.sig;
        { if (!(*p1 == '(')) internalCheckFail("*p1 == '('", "jsemact.c", 1966);};
        { if (!(*p2 == '(')) internalCheckFail("*p2 == '('", "jsemact.c", 1967);};
        p1 ++; p2++;
        while (*p1 != ')' && *p2 != ')') {
                r = javaExistWideningConversion(&p1, &p2);
                if (r == 0) return(0);
        }
        if (*p1 != ')' || *p2 != ')') return(0);
        return(1);
}
static int javaMethodApplicable(S_symbol *memb, char *actArgs) {
        int r;
        char *fargs;
        { if (!(memb && memb->b.symType==TypeDefault && memb->u.type)) internalCheckFail("memb && memb->b.symType==TypeDefault && memb->u.type", "jsemact.c", 1981);};
        { if (!(memb->u.type->m == TypeFunction && memb->u.type->u.m.sig)) internalCheckFail("memb->u.type->m == TypeFunction && memb->u.type->u.m.sig", "jsemact.c", 1982);};
        fargs = memb->u.type->u.m.sig;
        { if (!(*fargs == '(')) internalCheckFail("*fargs == '('", "jsemact.c", 1985);};
        fargs ++;
        while (*fargs != ')' && *actArgs!=0) {
                r = javaExistWideningConversion(&actArgs, &fargs);
                if (r == 0) return(0);
        }
        if (*fargs == ')' && *actArgs == 0) return(1);
        return(0);
}
S_symbol *javaGetSuperClass(S_symbol *cc) {
        S_symbolList *sups;
        { if (!(cc->b.symType == TypeStruct && cc->u.s)) internalCheckFail("cc->b.symType == TypeStruct && cc->u.s", "jsemact.c", 1997);};
        sups = cc->u.s->super;
        if (sups == NULL) return(&s_errorSymbol);
        return(sups->d);
}
S_symbol *javaCurrentSuperClass() {
        S_typeModifiers *tt;
        S_symbol *cc;
        S_symbolList *sups;
        int nsup;
        { if (!(s_javaStat)) internalCheckFail("s_javaStat", "jsemact.c", 2008);};
        tt = s_javaStat->thisType;
        { if (!(tt->m == TypeStruct)) internalCheckFail("tt->m == TypeStruct", "jsemact.c", 2010);};
        cc = tt->u.t;
        return(javaGetSuperClass(cc));
}
static S_typeModifiers *javaMethodInvocation(
                                                                                S_recFindStr *rfs,
                                                                                S_symbol *memb,
                                                                                S_idIdent *name,
                                                                                S_typeModifiersList *args,
                                                                                int invocationType,
                                                                                S_position *superPos) {
        char actArg[MAX_PROFILE_SIZE];
        S_symbol * appl[MAX_APPL_OVERLOAD_FUNS];
        int funCl[MAX_APPL_OVERLOAD_FUNS];
        S_symbol dd;
        S_symbolList *ee;
        S_typeModifiersList *aaa;
        int smallesti, baseCl, vApplCl, vFunCl, usedusage;
        int i,appli,actArgi,rr, cxflag;
        { if (!(rfs->baseClass)) internalCheckFail("rfs->baseClass", "jsemact.c", 2033);};
        { if (!(rfs->baseClass->b.symType == TypeStruct)) internalCheckFail("rfs->baseClass->b.symType == TypeStruct", "jsemact.c", 2034);};
        baseCl = rfs->baseClass->u.s->classFile;
        { if (!(baseCl != -1)) internalCheckFail("baseCl != -1", "jsemact.c", 2036);};
        { if (!(memb && memb->b.symType==TypeDefault && memb->u.type->m == TypeFunction)) internalCheckFail("memb && memb->b.symType==TypeDefault && memb->u.type->m == TypeFunction", "jsemact.c", 2040);};
        for(aaa=args; aaa!=NULL; aaa=aaa->next) {
                if (aaa->d->m == TypeError) {
                        addTrivialCxReference("  References Misinterpreted due to previous Errors",TypeInducedError,StorageDefault,
                                                                  &name->p, UsageUsed);
                        return(&s_errorModifier);
                }
        }
        *actArg = 0; actArgi = 0;
        for(aaa=args; aaa!=NULL; aaa=aaa->next) {
                actArgi += javaTypeToString(aaa->d,actArg+actArgi,MAX_PROFILE_SIZE-actArgi);
        }
        appli = 0;
        do {
                { if (!(memb != NULL)) internalCheckFail("memb != NULL", "jsemact.c", 2056);};
                if (javaRecordVisibleAndAccessible(rfs, rfs->baseClass, rfs->currClass, memb)
                        && javaMethodApplicable(memb,actArg)) {
                        appl[appli] = memb;
                        { if (!(rfs && rfs->currClass && rfs->currClass->b.symType==TypeStruct)) internalCheckFail("rfs && rfs->currClass && rfs->currClass->b.symType==TypeStruct", "jsemact.c", 2061);};
                        funCl[appli] = rfs->currClass->u.s->classFile;
                        { if (!(funCl[appli] != -1)) internalCheckFail("funCl[appli] != -1", "jsemact.c", 2063);};
                        appli++;
                }
                rr = findStrRecordSym(rfs, name->name, &memb,
                                                          CLASS_TO_METHOD, ACC_CHECK_NO, VISIB_CHECK_NO);
                if(invocationType==CONSTRUCTOR_INVOCATION&&rfs->baseClass!=rfs->currClass){
                        rr = 1;
                }
        } while (rr==0);
        if (appli == 0) return(&s_errorModifier);
        smallesti = 0;
        for (i=1; i<appli; i++) {
                if (! javaSmallerProfile(appl[smallesti], appl[i])) smallesti = i;
        }
        for (i=0; i<appli; i++) {
                if (! javaSmallerProfile(appl[smallesti], appl[i])) return(&s_errorModifier);
        }
        { if (!(appl[smallesti]->b.symType == TypeDefault)) internalCheckFail("appl[smallesti]->b.symType == TypeDefault", "jsemact.c", 2088);};
        { if (!(appl[smallesti]->u.type->m == TypeFunction)) internalCheckFail("appl[smallesti]->u.type->m == TypeFunction", "jsemact.c", 2089);};
        { if (!(funCl[smallesti] != -1)) internalCheckFail("funCl[smallesti] != -1", "jsemact.c", 2090);};
        vFunCl = funCl[smallesti];
        vApplCl = baseCl;
        usedusage = UsageUsed;
        if (invocationType == CONSTRUCTOR_INVOCATION) {
                usedusage = UsageConstructorUsed;
        }
        if (invocationType == SUPER_METHOD_INVOCATION) {
                usedusage = UsageMethodInvokedViaSuper;
                addSuperMethodCxReferences(vFunCl, superPos);
        }
        addCxReference(appl[smallesti], &name->p, usedusage, vFunCl, vApplCl);
        if (s_opt.cxrefs == OLO_EXTRACT) {
                for(ee=appl[smallesti]->u.type->u.m.exceptions; ee!=NULL; ee=ee->next) {
                        addCxReference(ee->d, &name->p, UsageThrown, s_noneFileIndex, s_noneFileIndex);
                }
        }
        return(appl[smallesti]->u.type->next);
}
S_typeModifiers *javaMethodInvocationN( S_idIdentList *name,
                                                                                S_typeModifiersList *args
                                                                        ) {
        S_symbol *memb;
        S_recFindStr rfs;
        S_typeModifiers *expr,*res;
        S_reference *rr;
        int nt;
        nt = javaClassifyAmbiguousName(name, &rfs,&memb,&expr,&rr,NULL,CLASS_TO_METHOD,UsageUsed);
        if (nt != TypeExpression) {
                methodNameNotRecognized(name->idi.name);
                return(&s_errorModifier);
        }
        if (expr == &s_errorModifier) return(&s_errorModifier);
        res = javaMethodInvocation(&rfs, memb, &name->idi, args,REGULAR_METHOD,&s_noPos);
        return(res);
}
S_typeModifiers *javaMethodInvocationT( S_typeModifiers *tt,
                                                                                S_idIdent *name,
                                                                                S_typeModifiersList *args
                                                                        ) {
        S_symbol *memb;
        S_recFindStr rfs;
        S_typeModifiers *res;
        int rr;
        if (tt->m == TypeArray) tt = &s_javaArrayObjectSymbol.u.s->stype;
        if (tt->m != TypeStruct) {
                methodAppliedOnNonClass(name->name);
                return(&s_errorModifier);
        }
        javaLoadClassSymbolsFromFile(tt->u.t);
        rr = findStrRecordSym(iniFind(tt->u.t,&rfs), name->name, &memb,
                                                CLASS_TO_METHOD, ACC_CHECK_NO,VISIB_CHECK_NO);
        if (rr != 0) {
                noSuchRecordError(name->name);
                return(&s_errorModifier);
        }
        res = javaMethodInvocation(&rfs, memb, name, args,REGULAR_METHOD,&s_noPos);
        return(res);
}
S_typeModifiers *javaMethodInvocationS(S_idIdent *super,
                                                                           S_idIdent *name,
                                                                           S_typeModifiersList *args
        ) {
        S_symbol *memb,*ss;
        S_recFindStr rfs;
        S_typeModifiers *expr,*res;
        int rr;
        ss = javaCurrentSuperClass();
        if (ss == &s_errorSymbol || ss->b.symType==TypeError) return(&s_errorModifier);
        { if (!(ss && ss->b.symType == TypeStruct)) internalCheckFail("ss && ss->b.symType == TypeStruct", "jsemact.c", 2168);};
        { if (!(ss->b.javaFileLoaded)) internalCheckFail("ss->b.javaFileLoaded", "jsemact.c", 2169);};
        rr = findStrRecordSym(iniFind(ss, &rfs), name->name, &memb,
                                                CLASS_TO_METHOD,ACC_CHECK_NO,VISIB_CHECK_NO);
        if (rr != 0) return(&s_errorModifier);
        res = javaMethodInvocation(&rfs, memb, name, args, SUPER_METHOD_INVOCATION,&super->p);
        { if (!(rfs.currClass && rfs.currClass->u.s)) internalCheckFail("rfs.currClass && rfs.currClass->u.s", "jsemact.c", 2179);};
        return(res);
}
S_typeModifiers *javaConstructorInvocation(S_symbol *clas,
                                                                                   S_position *pos,
                                                                                   S_typeModifiersList *args
        ) {
        S_symbol *memb;
        S_recFindStr rfs;
        S_typeModifiers *expr,*res;
        S_idIdent name;
        int rr;
        if (clas == &s_errorSymbol || clas->b.symType==TypeError) return(&s_errorModifier);
        { if (!(clas && clas->b.symType == TypeStruct)) internalCheckFail("clas && clas->b.symType == TypeStruct", "jsemact.c", 2193);};
        javaLoadClassSymbolsFromFile(clas);
        { if (!(clas->b.javaFileLoaded)) internalCheckFail("clas->b.javaFileLoaded", "jsemact.c", 2195);};
        { (&name)->name = clas->name; (&name)->sd = NULL; (&name)->p = *pos;};
        rr = findStrRecordSym(iniFind(clas, &rfs), name.name, &memb,
                                                CLASS_TO_METHOD,ACC_CHECK_NO,VISIB_CHECK_NO);
        if (rr != 0) return(&s_errorModifier);
        if (rfs.baseClass != rfs.currClass) return(&s_errorModifier);
        res = javaMethodInvocation(&rfs, memb, &name, args,CONSTRUCTOR_INVOCATION,&s_noPos);
        return(res);
}
static int javaIsNumeric(S_typeModifiers *tt) {
        { if (!(tt)) internalCheckFail("tt", "jsemact.c", 2211);};
        switch (tt->m) {
        case TypeByte: case TypeShort: case TypeChar:
        case TypeInt: case TypeLong:
        case TypeDouble: case TypeFloat:
                return(1);
        default:
                return(0);
        }
}
S_typeModifiers *javaCheckNumeric(S_typeModifiers *tt) {
        if (javaIsNumeric(tt)) return(tt);
        else return(&s_errorModifier);
}
S_typeModifiers *javaNumericPromotion(S_typeModifiers *tt) {
        S_typeModifiers *rr;
        { if (!(tt)) internalCheckFail("tt", "jsemact.c", 2229);};
        switch (tt->m) {
        case TypeByte: case TypeShort: case TypeChar:
                {rr = (S_typeModifiers*) stackMemoryAlloc(sizeof(S_typeModifiers)); };
                { (rr)->m = TypeInt; (&(rr)->u)->t = NULL;; (rr)->typedefin = NULL; (rr)->next = NULL;};
                return(rr);
        case TypeInt: case TypeLong:
        case TypeDouble: case TypeFloat:
                return(tt);
        default:
                return(&s_errorModifier);
        }
}
S_typeModifiers *javaBinaryNumericPromotion( S_typeModifiers *t1,
                                                                                                S_typeModifiers *t2
                                                                                        ) {
        int m1,m2,res;
        S_typeModifiers *rr;
        m1 = t1->m;
        m2 = t2->m;
        { if (!(t1 && t2)) internalCheckFail("t1 && t2", "jsemact.c", 2250);};
        res = TypeInt;
        if (m1 == TypeDouble || m2 == TypeDouble) res = TypeDouble;
        else if (m1 == TypeFloat || m2 == TypeFloat) res = TypeFloat;
        else if (m1 == TypeLong || m2 == TypeLong) res = TypeLong;
        {rr = (S_typeModifiers*) stackMemoryAlloc(sizeof(S_typeModifiers)); };
        { (rr)->m = res; (&(rr)->u)->t = NULL;; (rr)->typedefin = NULL; (rr)->next = NULL;};
        return(rr);
}
S_typeModifiers *javaBitwiseLogicalPromotion( S_typeModifiers *t1,
                                                                                                S_typeModifiers *t2
                                                                                        ) {
        { if (!(t1 && t2)) internalCheckFail("t1 && t2", "jsemact.c", 2263);};
        if (t1->m == TypeBoolean && t2->m == TypeBoolean) return(t1);
        return(javaBinaryNumericPromotion(t1,t2));
}
int javaIsStringType(S_typeModifiers *tt) {
        if (tt->m != TypeStruct) return(0);
        return(tt->u.t == s_javaStringSymbol);
}
static int javaEqualTypes(S_typeModifiers *t1,S_typeModifiers *t2) {
        int m;
lastRecursionLabel:
        if (t1->m != t2->m) return(0);
        m = t1->m;
        if (m == TypeStruct || m == TypeUnion) return(t1->u.t == t2->u.t);
        if (m == TypeArray) {
                t1 = t1->next; t2 = t2->next;
                goto lastRecursionLabel;
        }
        { if (!(m != TypeFunction)) internalCheckFail("m != TypeFunction", "jsemact.c", 2283);};
        return(1);
}
static int javaTypeConvertible( S_typeModifiers *t1,
                                                                S_typeModifiers *t2
                                                        ) {
        S_symbol *s1,*s2;
        int res;
lastRecLabel:
        if (javaIsNumeric(t1) && javaIsNumeric(t2)) {
                return(javaExistBaseTypeWideningConversion(t1->m, t2->m));
        }
        if (t1->m != t2->m) return(0);
        if (t1->m == TypeArray) {
                t1 = t1->next; t2 = t2->next;
                goto lastRecLabel;
        }
        if (t1->m == TypeStruct) {
                s1 = t1->u.t; s2 = t2->u.t;
                { if (!(s1 && s2)) internalCheckFail("s1 && s2", "jsemact.c", 2303);};
                { if (!(s1->b.symType == TypeStruct && s1->u.s)) internalCheckFail("s1->b.symType == TypeStruct && s1->u.s", "jsemact.c", 2304);};
                javaLoadClassSymbolsFromFile(s1);
                res = cctIsMember(&s1->u.s->casts, s2, 1);
                return(res);
        }
        return(0);
}
S_typeModifiers *javaConditionalPromotion( S_typeModifiers *t1,
                                                                                        S_typeModifiers *t2
                                                                                ) {
        if (javaEqualTypes(t1,t2)) return(t1);
        if (javaIsNumeric(t1) && javaIsNumeric(t2)) {
                if (t1->m == TypeShort && t2->m == TypeByte) return(t1);
                if (t1->m == TypeByte && t2->m == TypeShort) return(t2);
                return(javaBinaryNumericPromotion(t1,t2));
        }
        if (t1->m == TypeNull && (t2->m==TypeStruct || t2->m==TypeArray)) return(t2);
        if (t2->m == TypeNull && (t1->m==TypeStruct || t1->m==TypeArray)) return(t1);
        if (! (t1->m==TypeStruct || t1->m==TypeArray) || ! (t2->m==TypeStruct || t2->m==TypeArray)) {
                return(&s_errorModifier);
        }
        if (javaTypeConvertible(t1,t2)) return(t2);
        if (javaTypeConvertible(t2,t1)) return(t1);
        return(&s_errorModifier);
}
void javaTypeDump(S_typeModifiers *tt) {
        { if (!(tt)) internalCheckFail("tt", "jsemact.c", 2334);};
        if (tt->m == TypeArray) {
                javaTypeDump(tt->next);
                fprintf(dumpOut,"[]");
        } else if (tt->m == TypeStruct) {
                fprintf(dumpOut,"%s",tt->u.t->linkName);
        } else {
                fprintf(dumpOut,"%s",typesName[tt->m]);
        }
}
void removeFunNestedClass(void *ddv) {
        S_symbol *dd;
        S_symbolList ss;
        dd = (S_symbol *) ddv;
        { (&ss)->d = dd; (&ss)->next = NULL;};
        javaFqtTabDelete(&s_javaFqtTab, &ss);
}
void javaAddJslReadedTopLevelClasses(S_jslTypeTab *jslTypeTab) {
        int i;
        S_symbolList *ss;
        for(i=0; i<jslTypeTab->size; i++) {
                if (jslTypeTab->tab[i]!=NULL) {
                        { register S_symbolList *list,*tmp,*revlist; list = jslTypeTab->tab[i]; revlist = NULL; while (list!=NULL) { tmp = list->next; list->next = revlist; revlist = list; list = tmp; } jslTypeTab->tab[i] = revlist;};
                        for(ss=jslTypeTab->tab[i]; ss!=NULL; ss=ss->next) {
                                javaAddTypeToSymbolTable(ss->d, ss->d->b.accessFlags);
                        }
                        { register S_symbolList *list,*tmp,*revlist; list = jslTypeTab->tab[i]; revlist = NULL; while (list!=NULL) { tmp = list->next; list->next = revlist; revlist = list; list = tmp; } jslTypeTab->tab[i] = revlist;};
                }
        }
}
void javaAddNestedClassToSymbolTab( S_symbol *str ) {
        S_symStructSpecific *ss;
        int i;
        S_symbol *nss;
        { if (!(str && str->b.symType==TypeStruct)) internalCheckFail("str && str->b.symType==TypeStruct", "jsemact.c", 2371);};
        ss = str->u.s;
        { if (!(ss)) internalCheckFail("ss", "jsemact.c", 2373);};
        for(i=0; i<ss->nnested; i++) {
                if (ss->nest[i].membFlag && javaRecordAccessible(NULL,str, str, ss->nest[i].cl, ss->nest[i].accFlags)) {
                        {{{ { if (!((1) >= 0)) internalCheckFail("(1) >= 0", "jsemact.c", 2378);}; ppmMemoryi = ((char*)(((char*)(ppmMemory+ppmMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(ppmMemory+ppmMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - ppmMemory; if (ppmMemoryi+(1)*sizeof(S_symbol) >= SIZE_ppmMemory) { fatalError(ERR_NO_MEMORY,"ppmMemory", 65); } nss = (S_symbol*) (ppmMemory + ppmMemoryi); ppmMemoryi += (1)*sizeof(S_symbol);};};};
                        *nss = *ss->nest[i].cl;
                        addSymbol(nss, s_symTab);
                }
        }
}
void javaAddSuperNestedClassToSymbolTab( S_symbol *cc ) {
        S_symbolList *ss;
        for(ss=cc->u.s->super; ss != NULL; ss=ss->next) {
                javaAddSuperNestedClassToSymbolTab(ss->d);
        }
        javaAddNestedClassToSymbolTab(cc);
}
struct freeTrail * newClassDefinitionBegin( S_idIdent *name,
                                                                                        int accessFlags,
                                                                                        S_symbol *anonInterf) {
        S_idIdentList *p;
        S_symbol *dd,*ddd;
        S_typeModifiers *tt;
        S_freeTrail *res;
        S_javaStat *oldStat;
        int i,nnest,noff,classf,innerNamesCorrect;
        S_nestedSpec *nst,*nn;
        S_symTab *locals;
        S_idIdent idi;
        S_symStructSpecific *ss;
        { if (!(s_javaStat)) internalCheckFail("s_javaStat", "jsemact.c", 2408);};
        oldStat = s_javaStat;
        {s_javaStat = (S_javaStat*) stackMemoryAlloc(sizeof(S_javaStat)); };
        *s_javaStat = *oldStat;
        s_javaStat->next = oldStat;
        {locals = (S_symTab*) stackMemoryAlloc(sizeof(S_symTab)); };
        symTabInit(locals, MAX_CL_SYMBOLS);
        if (oldStat->next!=NULL) {
                if (oldStat->thisClass->b.accessFlags & 0x200) {
                        accessFlags |= (0x001 | 0x008);
                }
                nnest = oldStat->thisClass->u.s->nnested;
                nst = oldStat->thisClass->u.s->nest;
                noff = oldStat->currentNestIndex;
                oldStat->currentNestIndex ++;
                { if (!(noff >=0 && noff<nnest)) internalCheckFail("noff >=0 && noff<nnest", "jsemact.c", 2426);};
                nn = & nst[noff];
                dd = nn->cl;
                { (&idi)->name = dd->linkName; (&idi)->sd = NULL; (&idi)->p = name->p;};
                {p = (S_idIdentList*) stackMemoryAlloc(sizeof(S_idIdentList)); };
                { (p)->idi = idi; (p)->fname = dd->linkName; (p)->nameType = TypeStruct; (p)->next = NULL;};
                ddd = javaAddType(p, accessFlags, & name->p);
                res = s_topBlock->trail;
                javaCreateClassFileItem(dd);
        } else {
                {p = (S_idIdentList*) stackMemoryAlloc(sizeof(S_idIdentList)); };
                { (p)->idi = *name; (p)->fname = name->name; (p)->nameType = TypeStruct; (p)->next = s_javaStat->className;};
                dd = javaAddType(p, accessFlags, & name->p);
                res = s_topBlock->trail;
                { if (!(dd->b.symType == TypeStruct)) internalCheckFail("dd->b.symType == TypeStruct", "jsemact.c", 2445);};
        }
        classf = dd->u.s->classFile;
        if (classf == -1) classf = s_noneFileIndex;
        { (s_javaStat)->className = p; (s_javaStat)->thisType = &dd->u.s->stype; (s_javaStat)->thisClass = dd; (s_javaStat)->currentNestIndex = 0; (s_javaStat)->unNamedPackageDir = oldStat->unNamedPackageDir; (s_javaStat)->namedPackageDir = oldStat->namedPackageDir; (s_javaStat)->locals = locals; (s_javaStat)->lastParsedName = oldStat->lastParsedName; (s_javaStat)->cpMethodMods = 0x000; (s_javaStat)->cp = s_cp; (s_javaStat)->classFileInd = classf; (s_javaStat)->next = oldStat;};
        s_cp = s_cpInit;
        return(res);
}
struct freeTrail * newAnonClassDefinitionBegin(S_idIdent *interfName) {
        struct freeTrail * res;
        S_idIdentList *ll;
        S_symbol *interf, *str;
        {ll = (S_idIdentList*) stackMemoryAlloc(sizeof(S_idIdentList)); };
        { (ll)->idi = *interfName; (ll)->fname = interfName->name; (ll)->nameType = TypeDefault; (ll)->next = NULL;};
        javaClassifyToTypeName(ll,UsageUsed,&str);
        interf = javaTypeNameDefinition(ll);
        res = newClassDefinitionBegin(&s_javaAnonymousClassName, 0x000,
                                                                  interf);
        return(res);
}
void newClassDefinitionEnd(S_freeTrail *trail) {
        { if (!(s_javaStat && s_javaStat->next)) internalCheckFail("s_javaStat && s_javaStat->next", "jsemact.c", 2472);};
        removeFromTrailUntil(trail);
        s_cp = s_javaStat->cp;
        s_javaStat = s_javaStat->next;
}
void javaInitArrayObject() {
        static S_symbol s_lengthSymbol;
        static S_symStructSpecific s_arraySpec;
        { if (!(s_javaObjectSymbol != NULL)) internalCheckFail("s_javaObjectSymbol != NULL", "jsemact.c", 2485);};
        javaLoadClassSymbolsFromFile(s_javaObjectSymbol);
        { (&s_lengthSymbol.b)->record = 0; (&s_lengthSymbol.b)->accessFlags = 0x001; (&s_lengthSymbol.b)->javaSourceLoaded = 0; (&s_lengthSymbol.b)->javaFileLoaded = 0; (&s_lengthSymbol.b)->symType = TypeDefault; (&s_lengthSymbol.b)->storage = StorageDefault; (&s_lengthSymbol.b)->npointers = 0;};
        { (&s_lengthSymbol)->name = "length"; (&s_lengthSymbol)->linkName = "java/lang/array.length"; (&s_lengthSymbol)->pos = s_noPos; (&s_lengthSymbol)->b = s_lengthSymbol.b; (&s_lengthSymbol)->u.type = &s_defaultIntModifier; (&s_lengthSymbol)->next = NULL;};
        s_lengthSymbol.u.type = & s_defaultIntModifier;
        { (&s_arraySpec)->super = NULL; (&s_arraySpec)->records = &s_lengthSymbol; (&s_arraySpec)->casts.node = NULL; (&s_arraySpec)->casts.sub = NULL; (&s_arraySpec)->nnested = 0; (&s_arraySpec)->nest = NULL; (&s_arraySpec)->stype.m = TypeStruct; (&(&s_arraySpec)->stype.u)->t = NULL;; (&s_arraySpec)->stype.typedefin = NULL; (&s_arraySpec)->stype.next = NULL; (&s_arraySpec)->sptrtype.m = TypePointer; { (&((&(&s_arraySpec)->sptrtype.u)->f))->args = NULL; (&((&(&s_arraySpec)->sptrtype.u)->f))->thisFunList = NULL;}; (&s_arraySpec)->sptrtype.typedefin = NULL; (&s_arraySpec)->sptrtype.next = &s_arraySpec.stype; (&s_arraySpec)->currPackage = 1; (&s_arraySpec)->existsDEIarg = 0; (&s_arraySpec)->classFile = -1; (&s_arraySpec)->recSearchCounter = 0;};
        s_arraySpec.stype.u.t = &s_javaArrayObjectSymbol;
        { (&s_javaArrayObjectSymbol.b)->record = 0; (&s_javaArrayObjectSymbol.b)->accessFlags = 0x001; (&s_javaArrayObjectSymbol.b)->javaSourceLoaded = 0; (&s_javaArrayObjectSymbol.b)->javaFileLoaded = 1; (&s_javaArrayObjectSymbol.b)->symType = TypeStruct; (&s_javaArrayObjectSymbol.b)->storage = StorageDefault; (&s_javaArrayObjectSymbol.b)->npointers = 0;};
        { (&s_javaArrayObjectSymbol)->name = "__arrayObject__"; (&s_javaArrayObjectSymbol)->linkName = "__arrayObject__"; (&s_javaArrayObjectSymbol)->pos = s_noPos; (&s_javaArrayObjectSymbol)->b = s_javaArrayObjectSymbol.b; (&s_javaArrayObjectSymbol)->u.s = &s_arraySpec; (&s_javaArrayObjectSymbol)->next = NULL;};
        s_javaArrayObjectSymbol.u.s = &s_arraySpec;
        javaCreateClassFileItem(&s_javaArrayObjectSymbol);
        addSuperClassOrInterfaceByName(&s_javaArrayObjectSymbol,s_javaLangObjectLinkName, s_noneFileIndex, LOAD_SUPER);
}
S_typeModifiers *javaArrayFieldAccess(S_idIdent *id) {
        S_symbol *rec=NULL;
        findStrRecordFromType(&s_javaArrayObjectSymbol.u.s->stype, id, &rec, CLASS_TO_EXPR);
        { if (!(rec)) internalCheckFail("rec", "jsemact.c", 2513);};
        return(rec->u.type);
}
void javaParsedSuperClass(S_symbol *s) {
        S_symbolList *pp;
        { if (!(s_javaStat->thisClass&&s_javaStat->thisClass->b.symType==TypeStruct)) internalCheckFail("s_javaStat->thisClass&&s_javaStat->thisClass->b.symType==TypeStruct", "jsemact.c", 2519);};
        { if (!(s_javaStat->thisClass->u.s)) internalCheckFail("s_javaStat->thisClass->u.s", "jsemact.c", 2520);};
        { if (!(s && s->b.symType==TypeStruct && s->u.s)) internalCheckFail("s && s->b.symType==TypeStruct && s->u.s", "jsemact.c", 2521);};
        for(pp=s_javaStat->thisClass->u.s->super; pp!=NULL; pp=pp->next) {
                if (pp->d == s) break;
        }
        if (pp==NULL) {
                javaLoadClassSymbolsFromFile(s);
                addSuperClassOrInterface(s_javaStat->thisClass, s,
                                                                 cFile.lb.cb.fileNumber);
        }
}
void javaSetClassSourceInformation(char *package, S_idIdent *cl) {
        char fqt[MAX_FILE_NAME_SIZE];
        char classItem[MAX_FILE_NAME_SIZE];
        int ii;
        { if (!(cl!=NULL)) internalCheckFail("cl!=NULL", "jsemact.c", 2538);};
        if (*package == 0) {
                sprintf(fqt, "%s", cl->name);
        } else {
                sprintf(fqt, "%s/%s", package, cl->name);
        }
        { sprintf(classItem, "%c%s.class", ';', fqt); { if (!(strlen(classItem)+1 < MAX_FILE_NAME_SIZE)) internalCheckFail("strlen(classItem)+1 < MAX_FILE_NAME_SIZE", "jsemact.c", 2544);};};
        addFileTabItem(classItem, &ii);
        s_fileTab.tab[ii]->b.sourceFile = cl->p.file;
}
