
/*

Copyright (C) Marian Vittek, Xref-Tech, Bratislava, 1997-2002.
All Rights Reserved.

    THIS FILE IS CONSIDERED A TRADE SECRET BY XREF-TECH.
UNAUTHORIZED ACCESS, USE, REPRODUCTION OR DISTRIBUTION IS PROHIBITED.

*/
#ifndef STDINC__H
#define STDINC__H
#if defined(__WIN32) && (! defined(__WIN32__))
#define __WIN32__ 1
#endif
#ifdef __WIN32__
#include <windows.h>
#include <direct.h>
#else
#include <unistd.h>
#include <dirent.h>
#endif
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <assert.h>
#include <string.h>
#include <time.h>
#include <setjmp.h>
#include <sys/types.h>
#include <sys/stat.h>
#endif
#include "head2.h"
#include "proto.h"
#ifdef __WIN32__
#endif
typedef union {
        int integer;
        unsigned unsign;
        S_symbol *symbol;
        S_symbolList *symbolList;
        S_typeModifiers *typeModif;
        S_typeModifiersList *typeModifList;
        S_freeTrail *trail;
        S_idIdent *idIdent;
        S_idIdentList *idlist;
        S_exprTokenType exprType;
        S_intPair intpair;
        S_whileExtractData *whiledata;
        S_position position;
        S_unsPositionPair unsPositionPair;
        S_symbolPositionPair symbolPositionPair;
        S_symbolPositionLstPair symbolPositionLstPair;
        S_positionLst *positionLst;
        S_typeModifiersListPositionLstPair typeModifiersListPositionLstPair;
} YYSTYPE;
extern YYSTYPE yylval;
extern YYSTYPE cyylval;
extern YYSTYPE javayylval;
extern YYSTYPE javaslyylval;
extern YYSTYPE cccyylval;
extern YYSTYPE yaccyylval;
extern YYSTYPE *uniyylval;
struct yyGlobalState {
        int gyydebug;
        int gyynerrs;
        int gyyerrflag;
        int gyychar;
        int lastgyystate;
        short *gyyssp;
        YYSTYPE *gyyvsp;
        YYSTYPE gyyval;
        YYSTYPE gyylval;
        short gyyss[10000];
        YYSTYPE gyyvs[10000];
};
extern struct yyGlobalState *s_yygstate;
extern struct yyGlobalState *s_initYygstate;
static char * VERSION_NUMBER = "1.5.10je";
static char * FILE_VERSION_NUMBER = "1.5.10je";
static char * PPC_VERSION_MISMATCH = "version-mismatch";
static char * PPC_MULTIPLE_COMPLETIONS = "completions";
static char * PPC_MULTIPLE_COMPLETION_LINE = "cl";
static char * PPC_SINGLE_COMPLETION = "single-completion";
static char * PPC_FQT_COMPLETION = "fqt-completion";
static char * PPC_SYMBOL_LIST = "symbol-list";
static char * PPC_REFACTORING_PRECHECK = "precheck";
static char * PPC_REFACTORING_REPLACEMENT = "replacement";
static char * PPC_REFACTORING_REPLACE = "replace";
static char * PPC_REFACTORING_REPLACE_WITH = "with";
static char * PPC_REFACTORING_CUT_BLOCK = "cut-block";
static char * PPC_REFACTORING_COPY_BLOCK = "copy-block";
static char * PPC_REFACTORING_PASTE_BLOCK = "past-block";
static char * PPC_EXTRACTION_DIALOG = "extraction-dialog";
static char * PPC_DISPLAY_CLASS_TREE = "display-class-tree";
static char * PPC_DISPLAY_RESOLUTION = "display-resolution";
static char * PPC_DISPLAY_OR_UPDATE_BROWSER = "display-or-update-browser";
static char * PPC_SYMBOL_RESOLUTION = "resolution";
static char * PPC_SYMBOL = "symbol";
static char * PPC_VIRTUAL_SYMBOL = "virtual-symbol";
static char * PPC_CLASS = "class";
static char * PPC_REFERENCE_LIST = "reference-list";
static char * PPC_SRC_LINE = "src-line";
static char * PPC_UPDATE_CURRENT_REFERENCE = "update-current-refn";
static char * PPC_NO_PROJECT = "no-project-found";
static char * PPC_SET_PROJECT = "set-project";
static char * PPC_SET_INFO = "set-info";
static char * PPC_WARNING = "warning";
static char * PPC_ERROR = "error";
static char * PPC_FATAL_ERROR = "fatalError";
static char * PPC_INFORMATION = "information";
static char * PPC_BOTTOM_INFORMATION = "bottom-information";
static char * PPC_DEBUG_INFORMATION = "debug-information";
static char * PPC_ASK_CONFIRMATION = "ask-confirmation";
static char * PPC_GOTO = "goto";
static char * PPC_BROWSE_URL = "browse-url";
static char * PPC_FILE_SAVE_AS = "file-save-as";
static char * PPC_MOVE_FILE_AS = "file-move-as";
static char * PPC_FILE_REMOVE = "file-remove";
static char * PPC_MOVE_DIRECTORY = "move-directory";
static char * PPC_INDENT = "indent-block";
static char * PPC_IGNORE = "ignore";
static char * PPC_PROGRESS = "progress";
static char * PPC_UPDATE_REPORT = "update-report";
static char * PPC_AVAILABLE_REFACTORINGS = "available-refactorings";
static char * PPC_SYNCHRO_RECORD = "sync";
static char * PPC_LC_POSITION = "position-lc";
static char * PPC_OFFSET_POSITION = "position-off";
static char * PPC_STRING_VALUE = "string-value";
static char * PPC_INT_VALUE = "int-value";
static char * PPCA_LEN = "len";
static char * PPCA_LINE = "line";
static char * PPCA_COL = "col";
static char * PPCA_OFFSET = "off";
static char * PPCA_VALUE = "val";
static char * PPCA_SELECTED = "selected";
static char * PPCA_BASE = "base";
static char * PPCA_DEF_REFN = "drefn";
static char * PPCA_REFN = "refn";
static char * PPCA_TYPE = "type";
static char * PPCA_MTYPE = "mtype";
static char * PPCA_CONTINUE = "continue";
static char * PPCA_INTERFACE = "interface";
static char * PPCA_INDENT = "indent";
static char * PPCA_TREE_DEPS = "deps";
static char * PPCA_TREE_UP = "up";
static char * PPCA_DEFINITION = "definition";
static int PPCV_BROWSER_TYPE_INFO = 0;
static int PPCV_BROWSER_TYPE_WARNING = 1;
static int PPC_AVR_NO_REFACTORING = 0;
static int PPC_AVR_RENAME_SYMBOL = 1;
static int PPC_AVR_RENAME_CLASS = 2;
static int PPC_AVR_RENAME_PACKAGE = 3;
static int PPC_AVR_ADD_PARAMETER = 4;
static int PPC_AVR_DEL_PARAMETER = 5;
static int PPC_AVR_MOVE_PARAMETER = 6;
static int PPC_AVR_EXTRACT_METHOD = 7;
static int PPC_AVR_EXTRACT_MACRO = 8;
static int PPC_AVR_MOVE_STATIC_FIELD = 9;
static int PPC_AVR_MOVE_STATIC_METHOD = 10;
static int PPC_AVR_MOVE_FIELD = 11;
static int PPC_AVR_PULL_UP_FIELD = 12;
static int PPC_AVR_PULL_UP_METHOD = 13;
static int PPC_AVR_PUSH_DOWN_FIELD = 14;
static int PPC_AVR_PUSH_DOWN_METHOD = 15;
static int PPC_AVR_MOVE_CLASS = 16;
static int PPC_AVR_ENCAPSULATE_FIELD = 17;
static int PPC_AVR_SELF_ENCAPSULATE_FIELD = 18;
static int PPC_AVR_TURN_DYNAMIC_METHOD_TO_STATIC = 19;
static int PPC_AVR_TURN_STATIC_METHOD_TO_DYNAMIC = 20;
static int PPC_AVR_REDUCE_NAMES = 21;
static int PPC_AVR_EXPAND_NAMES = 22;
static int PPC_AVR_SET_MOVE_TARGET = 23;
static int PPC_MAX_AVAILABLE_REFACTORINGS = 24;
static char olExtractAddrParPrefixStatChar[TMP_STRING_SIZE];
static char oldStdopFile[MAX_FILE_NAME_SIZE];
static char oldStdopSection[MAX_FILE_NAME_SIZE];
static char oldOnLineClassPath[MAX_OPTION_LEN];
static time_t oldStdopTime;
static int oldLanguage;
static int oldCppPass;
static char qnxMsgBuff[QNX_MSG_BUF_SIZE];
static S_options s_tmpOptions;
static void usage(char *s) {
        fprintf(stdout,"usage: \t\t%s <option>+ ",s);
        fprintf(stdout,"<input files>");
        fprintf(stdout,"\n");
        fprintf(stdout,"options:\n");
        fprintf(stdout,"\t-r                    - recursively descent directories\n");
        fprintf(stdout,"\t-html                 - convert sources to html format\n");
        fprintf(stdout,"\t-htmlroot=<dir>       - specifies root dir. for html output\n");
        fprintf(stdout,"\t-htmltab=<n>          - set tabulator to <n> in htmls\n");
        fprintf(stdout,"\t-htmlgxlist           - generate xref-lists for global symbols\n");
        fprintf(stdout,"\t-htmllxlist           - generate xref-lists for local symbols\n");
        fprintf(stdout,"\t-htmldirectx          - link first character to cross references\n");
        fprintf(stdout,"\t-htmlfunseparate      - separate functions by a bar\n");
        fprintf(stdout,"\t-htmlzip=<command>    - zip command, ! stands for the file name\n");
        fprintf(stdout,"\t-htmllinksuffix=<suf> - add this suffix to file links\n");
        fprintf(stdout,"\t-htmllinenums         - generate line numbers in HTML\n");
        fprintf(stdout,"\t-htmlnocolors         - do not generate colors in HTML\n");
        fprintf(stdout,"\t-htmlnounderline      - not underlined HTML links\n");
        fprintf(stdout,"\t-htmlcutpath=<path>   - cut path in generated html\n");
        fprintf(stdout,"\t-htmlcutcwd           - cut current dir in html\n");
        fprintf(stdout,"\t-htmlcutsourcepaths   - cut source paths in html\n");
        fprintf(stdout,"\t-htmlcutsuffix        - cut language suffix in html\n");
        fprintf(stdout,"\t-htmllinkcolor=<color>- color of HTML links\n");
        fprintf(stdout,"\t-htmllinenumcolor=<color>- color of line numbers in HTML links\n");
        fprintf(stdout,"\t-htmlgenjavadoclinks  - gen links to javadoc if no definition\n");
        fprintf(stdout,"\t                      - only for packages from -htmljavadocavailable\n");
        fprintf(stdout,"\t-javadocurl=<http>    - url to existing java docs\n");
        fprintf(stdout,"\t-javadocpath=<path>   - paths to existing java docs\n");
        fprintf(stdout,"\t-javadocavailable=<packs> - packages for which javadoc is available\n");
        fprintf(stdout,"\t-p <prj>              - read options from <prj> section\n");
        fprintf(stdout,"\t-I <dir>              - search for includes in <dir>\n");
        fprintf(stdout,"\t-D<mac>[=<body>]      - define macro <mac> with body <body>\n");
        fprintf(stdout,"\t-packages             - allow packages as input files\n");
        fprintf(stdout,"\t-sourcepath <path>    - set java sources paths\n");
        fprintf(stdout,"\t-classpath <path>     - set java class path\n");
        fprintf(stdout,"\t-filescasesensitive   - file names are case sensitive\n");
        fprintf(stdout,"\t-filescaseunsensitive - file names are case unsensitive\n");
        fprintf(stdout,"\t-csuffixes=<paths>    - list of C files suffixes separated by : (or ;)");
        fprintf(stdout,"\t-javasuffixes=<paths> - list of Java files suffixes separated by : (or ;)\n");
        fprintf(stdout,"\t-stdop <file>         - read options from <file>\n");
        fprintf(stdout,"\t-no_cpp_comment       - C++ like comments // not admitted\n");
        fprintf(stdout,"\t-license=<string>     - license string\n");
        fprintf(stdout,"\t-refs <file>          - name of file with cxrefs\n");
        fprintf(stdout,"\t-refnum=<n>           - number of cxref files\n");
        fprintf(stdout,"\t-refalphahash         - split references alphabetically (-refnum=28)\n");
        fprintf(stdout,"\t-refalpha2hash        - split references alphabetically (-refnum=28*28)\n");
        fprintf(stdout,"\t-exactpositionresolve - resolve symbols by def. position\n");
        fprintf(stdout,"\t-mf<n>                - factor increasing cxMemory\n");
        fprintf(stdout,"\t-debug                - produce debug trace of the execution\n");
        fprintf(stdout,"\t-no_enum         - don't cross reference enumeration constants\n");
        fprintf(stdout,"\t-no_mac          - don't cross reference macros\n");
        fprintf(stdout,"\t-no_type         - don't cross reference type names\n");
        fprintf(stdout,"\t-no_str          - don't cross reference str. records\n");
        fprintf(stdout,"\t-no_local        - don't cross reference local vars\n");
        fprintf(stdout,"\t-nobrief         - generate cxrefs in long format\n");
        fprintf(stdout,"\t-update          - update old 'refs' reference file\n");
        fprintf(stdout,"\t-fastupdate      - fast update (modified files only)\n");
        fprintf(stdout,"\t-no_stdop        - don't read the '~/.xrefrc' option file \n");
        fprintf(stdout,"\t-errors          - report all error messages\n");
        fprintf(stdout,"\t-version         - give this release version number\n");
}
static void aboutMessage() {
        time_t tt;
        int j;
        fprintf(stdout,"This is Xrefactory version %s (%s).\n",
                        VERSION_NUMBER, "Jan  7 2003");
        tt = 1057010400;
        fprintf(stdout,"Time limit: %s",ctime(&tt));
        fprintf(stdout,"(c) 1997-2002 by Xref-Tech, http://www.xref-tech.com\n");
        exit(0);
}
void dirInputFile(char *file, char *a1,char *a2,S_completions *a3,void *a4,int *a5) {
        char *dir,*fname,*fin,*suff;
        void *recurseFlag;
        void *nrecurseFlag;
        struct stat st;
        char fn[MAX_FILE_NAME_SIZE];
        char ttt[MAX_FILE_NAME_SIZE];
        int ii,len,topCallFlag,stt;
        dir = a1; fname = file; recurseFlag = a4; topCallFlag = *a5;
        if (topCallFlag == 0) {
                if (strcmp(fname,".")==0) return;
                if (strcmp(fname,"..")==0) return;
                sprintf(fn,"%s%c%s",dir,SLASH,fname);
        } else {
                strcpy(fn,fname);
        }
        strcpy(fn, normalizeFileName(fn, s_cwd));
        suff = getFileSuffix(fname);
        stt = statb(fn, &st);
        if (stt==0 && (st.st_mode & S_IFMT)==S_IFDIR) {
                if (recurseFlag!=NULL) {
                        topCallFlag = 0;
                        if (s_opt.recursivelyDirs) nrecurseFlag = &topCallFlag;
                        else nrecurseFlag = NULL;
                        mapDirectoryFiles(fn, dirInputFile,DO_NOT_ALLOW_EDITOR_FILES,
                                                          fn, NULL, NULL, nrecurseFlag, &topCallFlag);
                        editorMapOnNonexistantFiles(fn, dirInputFile, DEEP_ANY,
                                                          fn, NULL, NULL, nrecurseFlag, &topCallFlag);
                } else {
                }
        } else if (stt==0) {
                if ( topCallFlag==0
                                && (! fileNameHasOneOfSuffixes(fname, s_opt.cFilesSuffixes))
                                && (! fileNameHasOneOfSuffixes(fname, s_opt.javaFilesSuffixes))
                                && fnCmp(suff,".y")!=0
                        ) {
                        return;
                }
                if (s_opt.javaFilesOnly && s_opt.taskRegime != RegimeEditServer
                        && (! fileNameHasOneOfSuffixes(fname, s_opt.javaFilesSuffixes))
                        && (! fileNameHasOneOfSuffixes(fname, "jar:class"))
                        ) {
                        return;
                }
                addFileTabItem(fn,&ii);
                if (s_opt.taskRegime!=RegimeEditServer) {
                        s_fileTab.tab[ii]->b.commandLineEntered = 1;
                }
                if (s_opt.updateOnlyModifiedFiles==0) {
                        s_fileTab.tab[ii]->b.scheduledToProcess = 1;
                }
#ifdef __WIN32__
        } else if (strchr(fn,'*')!=NULL) {
                copyDir(ttt, fn, &ii);
                mapPatternFiles(fn, dirInputFile, ttt,
                                                NULL, NULL, recurseFlag, &topCallFlag);
#endif
        } else if (topCallFlag
                           && ((!s_opt.allowPackagesOnCl)
                                   || packageOnCommandLine(fname)==0)) {
                if (s_opt.taskRegime!=RegimeEditServer) error(ERR_CANT_OPEN, fn);
        }
}
static void optionAddToAllocatedList(char **dest) {
        S_stringAddrList *ll;
        for(ll=s_opt.allAllocatedStrings; ll!=NULL; ll=ll->next) {
                if (ll->d == dest) break;
        }
        if (ll==NULL) {
                {{{ { if (!((1) >= 0)) internalCheckFail("(1) >= 0", "main.c", 252);}; ((S_memory*)&s_opt.pendingMemory)->i = ((char*)(((char*)(((char*)&((S_memory*)&s_opt.pendingMemory)->b)+((S_memory*)&s_opt.pendingMemory)->i))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(((char*)&((S_memory*)&s_opt.pendingMemory)->b)+((S_memory*)&s_opt.pendingMemory)->i))-1) & (STANDARD_ALLIGNEMENT-1))))) - ((char*)&((S_memory*)&s_opt.pendingMemory)->b); if (((S_memory*)&s_opt.pendingMemory)->i+(1)*sizeof(S_stringAddrList) >= ((S_memory*)&s_opt.pendingMemory)->size) { if (((S_memory*)&s_opt.pendingMemory)->overflowHandler(1)) longjmp(s_memoryResize,1); else fatalError(ERR_NO_MEMORY,"((S_memory*)&s_opt.pendingMemory)", 65); } ll = (S_stringAddrList*) (((char*)&((S_memory*)&s_opt.pendingMemory)->b) + ((S_memory*)&s_opt.pendingMemory)->i); ((S_memory*)&s_opt.pendingMemory)->i += (1)*sizeof(S_stringAddrList);};};};
                { (ll)->d = dest; (ll)->next = s_opt.allAllocatedStrings;};
                s_opt.allAllocatedStrings = ll;
        }
}
void allocOptionSpace(void **optAddress, int size) {
        char **res;
        res = (char**)optAddress;
        {{ { if (!((size) >= 0)) internalCheckFail("(size) >= 0", "main.c", 261);}; ((S_memory*)&s_opt.pendingMemory)->i = ((char*)(((char*)(((char*)&((S_memory*)&s_opt.pendingMemory)->b)+((S_memory*)&s_opt.pendingMemory)->i))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(((char*)&((S_memory*)&s_opt.pendingMemory)->b)+((S_memory*)&s_opt.pendingMemory)->i))-1) & (STANDARD_ALLIGNEMENT-1))))) - ((char*)&((S_memory*)&s_opt.pendingMemory)->b); if (((S_memory*)&s_opt.pendingMemory)->i+(size)*sizeof(char) >= ((S_memory*)&s_opt.pendingMemory)->size) { if (((S_memory*)&s_opt.pendingMemory)->overflowHandler(size)) longjmp(s_memoryResize,1); else fatalError(ERR_NO_MEMORY,"((S_memory*)&s_opt.pendingMemory)", 65); } (*res) = (char*) (((char*)&((S_memory*)&s_opt.pendingMemory)->b) + ((S_memory*)&s_opt.pendingMemory)->i); ((S_memory*)&s_opt.pendingMemory)->i += (size)*sizeof(char);};};
        optionAddToAllocatedList(res);
}
void crOptionStr(char **optAddress, char *text) {
        int alen = strlen(text)+1;
        allocOptionSpace((void**)optAddress, alen);
        strcpy(*optAddress, text);
}
static void copyOptionShiftPointer(char **lld, S_options *dest, S_options *src) {
        char *str, **dlld;
        int offset, localOffset;
        offset = ((char*)dest) - ((char*)src);
        localOffset = ((char*)lld) - ((char*)src);
        dlld = ((char**) (((char*)dest) + localOffset));
        if (*dlld != *lld) {
                fprintf(dumpOut,"problem %s\n", *lld);
        }
        { if (!(*dlld == *lld)) internalCheckFail("*dlld == *lld", "main.c", 282);};
        *dlld = *lld + offset;
}
void copyOptions(S_options *dest, S_options *src) {
        S_stringAddrList **ll;
        memcpy(dest, src, sizeof(S_options));
        for(ll= &src->allAllocatedStrings; *ll!=NULL; ll = &(*ll)->next) {
                copyOptionShiftPointer((*ll)->d, dest, src);
                copyOptionShiftPointer(((char**)&(*ll)->d), dest, src);
                copyOptionShiftPointer(((char**)ll), dest, src);
        }
}
void xrefSetenv(char *name, char *val) {
        S_setGetEnv *sge;
        int j, n;
        sge = &s_opt.setGetEnv;
        n = sge->num;
        if (n+1>=MAX_SET_GET_OPTIONS) {
                sprintf(tmpBuff, "maximum of %d -set options reached", MAX_SET_GET_OPTIONS);
                error(ERR_ST, tmpBuff);
                sge->num--; n--;
        }
        for(j=0; j<n; j++) {
                { if (!(sge->name[j])) internalCheckFail("sge->name[j]", "main.c", 308);};
                if (strcmp(sge->name[j], name)==0) break;
        }
        if (j==n) crOptionStr(&(sge->name[j]), name);
        if (j==n || strcmp(sge->value[j], val)!=0) {
                crOptionStr(&(sge->value[j]), val);
        }
        if (j==n) sge->num ++;
}
int mainHandleSetOption( int argc, char **argv, int i ) {
        S_setGetEnv *sge;
        char *name, *val;
        int j,n;
        { i++; if (i >= argc) { sprintf(tmpBuff,"further argument(s) expected after %s\n",argv[i-1]); error(ERR_ST,tmpBuff); usage(argv[0]); }};
        name = argv[i];
        { if (!(name)) internalCheckFail("name", "main.c", 326);};
        { i++; if (i >= argc) { sprintf(tmpBuff,"further argument(s) expected after %s\n",argv[i-1]); error(ERR_ST,tmpBuff); usage(argv[0]); }};
        val = argv[i];
        xrefSetenv(name, val);
        return(i);
}
static int mainHandleIncludeOption(int argc, char **argv, int i) {
        int nargc,aaa;
        char **nargv;
        { i++; if (i >= argc) { sprintf(tmpBuff,"file name expected after %s\n",argv[i-1]); error(ERR_ST,tmpBuff); usage(argv[0]); }};
        s_opt.stdopFlag = 1;
        readOptionFile(argv[i],&nargc,&nargv,"",NULL);
        processOptions(nargc, nargv, INFILES_DISABLED);
        s_opt.stdopFlag = 0;
        return(i);
}
int addHtmlCutPath( char *ss ) {
        int i,ln,len, res;
        res = 0;
        ss = htmlNormalizedPath(ss);
        ln = strlen(ss);
        if (ln>=1 && ss[ln-1] == SLASH) {
                warning(ERR_ST,"slash at the end of -htmlcutpath path, ignoring it");
                return(res);
        }
        for(i=0; i<s_opt.htmlCut.pathesNum; i++) {
                if (strcmp(s_opt.htmlCut.path[i], ss)==0) return(res);
        }
        crOptionStr(&(s_opt.htmlCut.path[s_opt.htmlCut.pathesNum]), ss);
        ss = s_opt.htmlCut.path[s_opt.htmlCut.pathesNum];
        s_opt.htmlCut.plen[s_opt.htmlCut.pathesNum] = ln;
        for(i=0; i<s_opt.htmlCut.pathesNum; i++) {
                len = s_opt.htmlCut.plen[i];
                if (fnnCmp(s_opt.htmlCut.path[i], ss, len)==0) {
                        sprintf(tmpBuff,
                                        "htmlcutpath: '%s' supersede \n\t\t'%s', exchanging them",
                                        s_opt.htmlCut.path[i], ss);
                        warning(ERR_ST, tmpBuff);
                        res = 1;
                        s_opt.htmlCut.path[s_opt.htmlCut.pathesNum]=s_opt.htmlCut.path[i];
                        s_opt.htmlCut.plen[s_opt.htmlCut.pathesNum]=s_opt.htmlCut.plen[i];
                        s_opt.htmlCut.path[i] = ss;
                        s_opt.htmlCut.plen[i] = ln;
                }
        }
        if (s_opt.htmlCut.pathesNum+2 >= MAX_HTML_CUT_PATHES) {
                error(ERR_ST,"# of htmlcutpathes overflow over MAX_HTML_CUT_PATHES");
        } else {
                s_opt.htmlCut.pathesNum++;
        }
        return(res);
}
static int processNegativeOption(int *ii, int argc, char **argv, int infilesFlag) {
        int i = * ii;
        if (0) {}
        else if (strcmp(argv[i],"--r")==0) {
                if (infilesFlag == INFILES_ENABLED) s_opt.recursivelyDirs = 0;
        }
        else return(0);
        *ii = i;
        return(1);
}
static int processAOption(int *ii, int argc, char **argv) {
        int i = * ii;
        if (0) {}
        else if (strcmp(argv[i],"-version")==0 || strcmp(argv[i],"-about")==0){
                s_opt.aboutOption = 1;
        }
        else return(0);
        *ii = i;
        return(1);
}
static int processBOption(int *ii, int argc, char **argv) {
        int i = * ii;
        if (0) {}
        else if (strcmp(argv[i],"-brief")==0) s_opt.brief = 1;
        else if (strcmp(argv[i],"-briefoutput")==0) s_opt.briefoutput = 1;
        else if (strcmp(argv[i],"-body")==0) s_opt.body = 1;
        else if (strncmp(argv[i],"-browsedsym=",12)==0) {
                crOptionStr(&s_opt.browsedSymName, argv[i]+12);
        }
        else return(0);
        *ii = i;
        return(1);
}
static int processCOption(int *ii, int argc, char **argv) {
        int i = * ii;
        if (0) {}
        else if (strcmp(argv[i],"-c_struct_scope")==0) s_opt.c_struct_scope=1;
        else if (strcmp(argv[i],"-cacheincludes")==0) s_opt.cacheIncludes=1;
        else if (strcmp(argv[i],"-cplusplus")==0) s_opt.cIsCplusplus=1;
        else if (strcmp(argv[i],"-crlfconversion")==0) s_opt.eolConversion|=1;
        else if (strcmp(argv[i],"-crconversion")==0) s_opt.eolConversion|=2;
        else if (strcmp(argv[i],"-classpath")==0) {
                { i++; if (i >= argc) { sprintf(tmpBuff,"file name expected after %s\n",argv[i-1]); error(ERR_ST,tmpBuff); usage(argv[0]); }};
                        crOptionStr(&s_opt.classpath, argv[i]);
        }
        else if (strncmp(argv[i],"-csuffixes=",11)==0) {
                crOptionStr(&s_opt.cFilesSuffixes, argv[i]+11);
        }
        else if (strcmp(argv[i],"-create")==0) s_opt.create = 1;
        else return(0);
        *ii = i;
        return(1);
}
static int processDOption(int *ii, int argc, char **argv) {
        int i = * ii;
        if (0) {}
        else if (strcmp(argv[i],"-debug")==0) s_opt.debug = 1;
        else if (strcmp(argv[i],"-d")==0) {
                int ln;
                { i++; if (i >= argc) { sprintf(tmpBuff,"file name expected after %s\n",argv[i-1]); error(ERR_ST,tmpBuff); usage(argv[0]); }};
                ln=strlen(argv[i]);
                if (ln>1 && argv[i][ln-1] == SLASH) {
                        warning(ERR_ST,"slash at the end of -d path");
                }
                if (! isAbsolutePath(argv[i])) {
                        warning(ERR_ST,"'-d' option should be followed by an ABSOLUTE path!");
                }
                crOptionStr(&s_opt.htmlRoot, argv[i]);
        }
        else if (strncmp(argv[i],"-D",2)==0) addMacroDefinedByOption(argv[i]+2);
        else if (strcmp(argv[i],"-displaynestedwithouters")==0) {
                s_opt.nestedClassDisplaying = NO_OUTERS_CUT;
        }
        else return(0);
        *ii = i;
        return(1);
}
static int processEOption(int *ii, int argc, char **argv) {
        int i = * ii;
        char ttt[TMP_STRING_SIZE];
        int alen;
        if (0) {}
        else if (strcmp(argv[i],"-errors")==0) s_opt.err = 1;
        else if (strcmp(argv[i],"-enum_name")==0) s_opt.enum_name = 1;
        else if (strcmp(argv[i],"-emacs")==0) {
                s_opt.editor = ED_EMACS;
        }
        else if (strncmp(argv[i],"-extractAddrParPrefix=",22)==0) {
                sprintf(ttt, "*%s", argv[i]+22);
                crOptionStr(&s_opt.olExtractAddrParPrefix, ttt);
        }
        else if (strcmp(argv[i],"-exactpositionresolve")==0) {
                s_opt.exactPositionResolve = 1;
        }
        else return(0);
        *ii = i;
        return(1);
}
static int processFOption(int *ii, int argc, char **argv) {
        int i = * ii;
        if (0) {}
        else if (strcmp(argv[i],"-filescasesensitive")==0) {
                s_opt.fileNamesCaseSensitive = 1;
        }
        else if (strcmp(argv[i],"-filescaseunsensitive")==0) {
                s_opt.fileNamesCaseSensitive = 0;
        }
        else if (strcmp(argv[i],"-fastupdate")==0) {
                s_opt.update = UP_FAST_UPDATE;
                s_opt.updateOnlyModifiedFiles = 1;
        }
        else if (strcmp(argv[i],"-fupdate")==0) {
                s_opt.update = UP_FULL_UPDATE;
                s_opt.updateOnlyModifiedFiles = 0;
        }
        else return(0);
        *ii = i;
        return(1);
}
static int processGOption(int *ii, int argc, char **argv) {
        int i = * ii;
        if (0) {}
        else if (strcmp(argv[i],"-getlastimportline")==0) {
                s_opt.trivialPreCheckCode = TPC_GET_LAST_IMPORT_LINE;
        }
        else if (strcmp(argv[i],"-get")==0) {
                { i++; if (i >= argc) { sprintf(tmpBuff,"further argument(s) expected after %s\n",argv[i-1]); error(ERR_ST,tmpBuff); usage(argv[0]); }};
                crOptionStr(&s_opt.getValue, argv[i]);
                s_opt.cxrefs = OLO_GET_ENV_VALUE;
        }
        else return(0);
        *ii = i;
        return(1);
}
static int processHOption(int *ii, int argc, char **argv) {
        int i = * ii;
        if (strncmp(argv[i],"-htmltab=",9)==0) {
                sscanf(argv[i]+9,"%d",&s_opt.tabulator);
        }
        else if (strcmp(argv[i],"-htmllinenums")==0) s_opt.htmlLineNums = 1;
        else if (strcmp(argv[i],"-htmlnocolors")==0) s_opt.htmlNoColors = 1;
        else if (strcmp(argv[i],"-htmlgxlist")==0) s_opt.htmlglobalx = 1;
        else if (strcmp(argv[i],"-htmllxlist")==0) s_opt.htmllocalx = 1;
        else if (strcmp(argv[i],"-htmlrichlist")==0) {
                warning(ERR_ST,"-htmlrichlist option is no longer supported");
        }
        else if (strcmp(argv[i],"-htmlfunseparate")==0)s_opt.htmlFunSeparate=1;
        else if (strcmp(argv[i],"-html")==0) {
                s_opt.taskRegime = RegimeHtmlGenerate;
                s_opt.multiHeadRefsCare = 0;
        }
        else if (strncmp(argv[i],"-htmlroot=",10)==0) {
                int ln;
                ln=strlen(argv[i]);
                if (ln>11 && argv[i][ln-1] == SLASH) {
                        warning(ERR_ST,"slash at the end of -htmlroot path");
                }
                crOptionStr(&s_opt.htmlRoot, argv[i]+10);
        }
        else if (strcmp(argv[i],"-htmlgenjavadoclinks")==0) {
                s_opt.htmlGenJdkDocLinks = 1;
        }
        else if (strncmp(argv[i],"-htmljavadocavailable=",22)==0) {
                crOptionStr(&s_opt.htmlJdkDocAvailable, argv[i]+22);
        }
        else if (strncmp(argv[i],"-htmljavadocpath=",17)==0) {
                crOptionStr(&s_opt.htmlJdkDocUrl, argv[i]+17);
        }
        else if (strncmp(argv[i],"-htmlcutpath=",13)==0) {
                addHtmlCutPath(argv[i]+13);
        }
        else if (strcmp(argv[i],"-htmlcutcwd")==0) {
                int tmp;
                tmp = addHtmlCutPath(s_cwd);
                if (s_opt.java2html && tmp) {
                        fatalError(ERR_ST, "a path clash occurred, please, run java2html from different directory", 65);
                }
        }
        else if (strcmp(argv[i],"-htmlcutsourcepaths")==0) {
                addSourcePathesCut();
        }
        else if (strcmp(argv[i],"-htmlcutsourcepathes")==0) {
                addSourcePathesCut();
        }
        else if (strcmp(argv[i],"-htmlcutsuffix")==0) {
                s_opt.htmlCutSuffix = 1;
        }
        else if (strncmp(argv[i],"-htmllinenumlabel=", 18)==0) {
                crOptionStr(&s_opt.htmlLineNumLabel, argv[i]+18);
        }
        else if (strcmp(argv[i],"-htmlnounderline")==0) {
                s_opt.htmlNoUnderline = 1;
        }
        else if (strcmp(argv[i],"-htmldirectx")==0) {
                s_opt.htmlDirectX = 1;
        }
        else if (strncmp(argv[i],"-htmllinkcolor=",15)==0) {
                crOptionStr(&s_opt.htmlLinkColor, argv[i]+15);
        }
        else if (strncmp(argv[i],"-htmllinenumcolor=",18)==0) {
                crOptionStr(&s_opt.htmlLineNumColor, argv[i]+18);
        }
        else if (strncmp(argv[i],"-htmlcxlinelen=",15)==0) {
                sscanf(argv[i]+15, "%d", &s_opt.htmlCxLineLen);
        }
        else if (strncmp(argv[i],"-htmlzip=",9)==0) {
                crOptionStr(&s_opt.htmlZipCommand, argv[i]+9);
        }
        else if (strncmp(argv[i],"-htmllinksuffix=",16)==0) {
                crOptionStr(&s_opt.htmlLinkSuffix, argv[i]+16);
        }
        else if (strcmp(argv[i],"-header")==0) s_opt.header = 1;
        else if (strcmp(argv[i],"-help")==0) {
                usage(argv[0]);
                exit(0);
        }
        else return(0);
        *ii = i;
        return(1);
}
static void addIncludeDirectory(char *argvi) {
        S_stringList **ll, *list;
        for(ll= &s_opt.includeDirs; *ll!=NULL; ll= &(*ll)->next) ;
        allocOptionSpace((void**)ll, sizeof(S_stringList));
        crOptionStr(&(*ll)->d, argvi);
        (*ll)->next = NULL;
}
static int processIOption(int *ii, int argc, char **argv) {
        int i = * ii;
        if (0) {}
        else if (strcmp(argv[i],"-I")==0) {
                i++;
                if (i >= argc) {
                        sprintf(tmpBuff,"directory name expected after -I\n");
                        error(ERR_ST,tmpBuff);
                        usage(argv[0]);
                }
                addIncludeDirectory(argv[i]);
        }
        else if (strncmp(argv[i],"-I", 2)==0 && argv[i][2]!=0) {
                addIncludeDirectory(argv[i]+2);
        }
        else if (strcmp(argv[i],"-include")==0) {
                i = mainHandleIncludeOption(argc, argv, i);
        }
        else return(0);
        *ii = i;
        return(1);
}
static int processJOption(int *ii, int argc, char **argv) {
        int i = * ii;
        if (0) {}
        else if (strcmp(argv[i],"-javadoc")==0) s_opt.javaDoc = 1;
        else if (strcmp(argv[i],"-java2html")==0) s_opt.java2html = 1;
        else if (strcmp(argv[i],"-java1.4")==0) {
                crOptionStr(&s_opt.javaVersion, "1.4");
        }
        else if (strncmp(argv[i],"-jdoctmpdir=",12)==0) {
                int ln;
                ln=strlen(argv[i]);
                if (ln>13 && argv[i][ln-1] == SLASH) {
                        warning(ERR_ST,"slash at the end of -jdoctmpdir path");
                }
                crOptionStr(&s_opt.jdocTmpDir, argv[i]+12);
        }
        else if (strncmp(argv[i],"-javadocavailable=",18)==0) {
                crOptionStr(&s_opt.htmlJdkDocAvailable, argv[i]+18);
        }
        else if (strncmp(argv[i],"-javadocurl=",12)==0) {
                crOptionStr(&s_opt.htmlJdkDocUrl, argv[i]+12);
        }
        else if (strncmp(argv[i],"-javadocpath=",13)==0) {
                crOptionStr(&s_opt.javaDocPath, argv[i]+13);
        } else if (strcmp(argv[i],"-javadocpath")==0) {
                { i++; if (i >= argc) { sprintf(tmpBuff,"file name expected after %s\n",argv[i-1]); error(ERR_ST,tmpBuff); usage(argv[0]); }};
                crOptionStr(&s_opt.javaDocPath, argv[i]);
        }
        else if (strncmp(argv[i],"-javasuffixes=",14)==0) {
                crOptionStr(&s_opt.javaFilesSuffixes, argv[i]+14);
        }
        else if (strcmp(argv[i],"-javafilesonly")==0) {
                s_opt.javaFilesOnly = 1;
        }
        else if (strcmp(argv[i],"-jdkclasspath")==0 || strcmp(argv[i],"-javaruntime")==0) {
                { i++; if (i >= argc) { sprintf(tmpBuff,"file name expected after %s\n",argv[i-1]); error(ERR_ST,tmpBuff); usage(argv[0]); }};
                crOptionStr(&s_opt.jdkClassPath, argv[i]);
        }
        else return(0);
        *ii = i;
        return(1);
}
static int processKOption(int *ii, int argc, char **argv) {
        int i = * ii;
        if (0) {}
        else if (strcmp(argv[i],"-kawa")==0) {
                s_opt.editor = ED_KAWA;
                s_opt.olineLen = 250;
        }
        else if (strcmp(argv[i],"-keep_old")==0) s_opt.keep_old = 1;
        else return(0);
        *ii = i;
        return(1);
}
static int processLOption(int *ii, int argc, char **argv) {
        int i = * ii;
        if (0) {}
        else if (strncmp(argv[i],"-last_message=",14)==0) {
                crOptionStr(&s_opt.last_message, argv[i]+14);
        }
        else return(0);
        *ii = i;
        return(1);
}
static int processMOption(int *ii, int argc, char **argv) {
        int i = * ii;
        if (0) {}
        else if (strncmp(argv[i],"-mf",3)==0) {
                int newmf;
                sscanf(argv[i]+3, "%d", &newmf);
                if (newmf<=0 || newmf>255) {
                        fatalError(ERR_ST, "memory factor out of range <1,255>", 65);
                }
                s_opt.cxMemoryFaktor = newmf;
        }
        else if (strncmp(argv[i],"-maxCompls=",11)==0 || strncmp(argv[i],"-maxcompls=",11)==0) {
                sscanf(argv[i]+11, "%d", &s_opt.maxCompletions);
        }
        else if (strncmp(argv[i],"-movetargetclass=",17)==0) {
                crOptionStr(&s_opt.moveTargetClass, argv[i]+17);
        }
        else if (strncmp(argv[i],"-movetargetfile=",16)==0) {
                crOptionStr(&s_opt.moveTargetFile, argv[i]+16);
        }
        else if (strcmp(argv[i],"-movefromuser")==0) {
                { i++; if (i >= argc) { sprintf(tmpBuff,"file name expected after %s\n",argv[i-1]); error(ERR_ST,tmpBuff); usage(argv[0]); }};
                crOptionStr(&s_opt.moveFromUser, argv[i]);
                s_opt.cxrefs = OLO_MOVE_FROM_USER;
        }
        else return(0);
        *ii = i;
        return(1);
}
static int processNOption(int *ii, int argc, char **argv) {
        int i = * ii;
        if (0) {}
        else if (strcmp(argv[i],"-noincluderefs")==0) s_opt.noIncludeRefs = 1;
        else if (strcmp(argv[i],"-noincluderefresh")==0) s_opt.noIncludeRefs=1;
        else if (strcmp(argv[i],"-nocxfile")==0) s_opt.noCxFile = 1;
        else if (strcmp(argv[i],"-no_cpp_comment")==0) s_opt.cpp_comment = 0;
        else if (strcmp(argv[i],"-nobrief")==0) s_opt.brief = 0;
        else if (strcmp(argv[i],"-no_enum")==0) s_opt.no_ref_enumerator = 1;
        else if (strcmp(argv[i],"-no_mac")==0) s_opt.no_ref_macro = 1;
        else if (strcmp(argv[i],"-no_type")==0) s_opt.no_ref_typedef = 1;
        else if (strcmp(argv[i],"-no_str")==0) s_opt.no_ref_records = 1;
        else if (strcmp(argv[i],"-no_local")==0) s_opt.no_ref_locals = 1;
        else if (strcmp(argv[i],"-no_cfrefs")==0) s_opt.allowClassFileRefs = 0;
        else if (strcmp(argv[i],"-no_stdop")==0
                         || strcmp(argv[i],"-nostdop")==0) s_opt.no_stdop = 1;
        else if (strcmp(argv[i],"-noautoupdatefromsrc")==0) s_opt.javaSlAllowed = 0;
        else if (strcmp(argv[i],"-noerrors")==0) s_opt.noErrors=1;
        else return(0);
        *ii = i;
        return(1);
}
static int processOOption(int *ii, int argc, char **argv) {
        int i = * ii;
        if (0) {}
        else if (strncmp(argv[i],"-oocheckbits=",13)==0) {
                sscanf(argv[i]+13,"%o",&s_opt.ooChecksBits);
        }
        else if (strncmp(argv[i],"-olinelen=",10)==0) {
                sscanf(argv[i]+10,"%d",&s_opt.olineLen);
                if (s_opt.olineLen == 0) s_opt.olineLen =79;
                else s_opt.olineLen--;
        }
        else if (strncmp(argv[i],"-olcursor=",10)==0) {
                sscanf(argv[i]+10,"%d",&s_opt.olCursorPos);
        }
        else if (strncmp(argv[i],"-olmark=",8)==0) {
                sscanf(argv[i]+8,"%d",&s_opt.olMarkPos);
        }
        else if (strncmp(argv[i],"-olcheckversion=",16)==0) {
                crOptionStr(&s_opt.checkVersion, argv[i]+16);
                s_opt.cxrefs = OLO_CHECK_VERSION;
        }
        else if (strncmp(argv[i],"-olcxrefsuffix=",15)==0) {
                crOptionStr(&s_opt.olcxRefSuffix, argv[i]+15);
        }
        else if (strncmp(argv[i],"-olcxresetrefsuffix=",20)==0) {
                s_opt.cxrefs = OLO_RESET_REF_SUFFIX;
                crOptionStr(&s_opt.olcxRefSuffix, argv[i]+20);
        }
        else if (strncmp(argv[i],"-olcxextract=",13)==0) {
                s_opt.cxrefs = OLO_EXTRACT;
                crOptionStr(&s_opt.extractName, argv[i]+13);
        }
        else if (strcmp(argv[i],"-olcxtrivialprecheck")==0) {
                s_opt.cxrefs = OLO_TRIVIAL_PRECHECK;
        }
        else if (strcmp(argv[i],"-olmanualresolve")==0) {
                s_opt.manualResolve = RESOLVE_DIALOG_ALLWAYS;
        }
        else if (strcmp(argv[i],"-olnodialog")==0) {
                s_opt.manualResolve = RESOLVE_DIALOG_NEVER;
        }
        else if (strcmp(argv[i],"-olexaddress")==0) {
                s_opt.extractMode = EXTR_FUNCTION_ADDRESS_ARGS;
        }
        else if (strcmp(argv[i],"-olchecklinkage")==0) {
                s_opt.ooChecksBits |= 00001;
        }
        else if (strcmp(argv[i],"-olcheckaccess")==0) {
                s_opt.ooChecksBits |= 00002;
        }
        else if (strcmp(argv[i],"-olnocheckaccess")==0) {
                s_opt.ooChecksBits &= ~00002;
        }
        else if (strcmp(argv[i],"-olallchecks")==0) {
                s_opt.ooChecksBits |= 00010;
        }
        else if (strcmp(argv[i],"-olfqtnametocompletions")==0) {
                s_opt.fqtNameToCompletions = 1;
        }
        else if (strcmp(argv[i],"-olexmacro")==0) s_opt.extractMode=EXTR_MACRO;
        else if (strcmp(argv[i],"-olcxunmodified")==0) {
                s_opt.modifiedFlag = 0;
        }
        else if (strcmp(argv[i],"-olcxmodified")==0) {
                s_opt.modifiedFlag = 1;
        }
        else if (strcmp(argv[i],"-olcxrename")==0) s_opt.cxrefs = OLO_RENAME;
        else if (strcmp(argv[i],"-olcxencapsulate")==0) s_opt.cxrefs = OLO_ENCAPSULATE;
        else if (strcmp(argv[i],"-olcxargmanip")==0) s_opt.cxrefs = OLO_ARG_MANIP;
        else if (strcmp(argv[i],"-olcxdynamictostatic1")==0) s_opt.cxrefs = OLO_VIRTUAL2STATIC_PUSH;
        else if (strcmp(argv[i],"-olcxsafetycheckinit")==0) s_opt.cxrefs = OLO_SAFETY_CHECK_INIT;
        else if (strcmp(argv[i],"-olcxsafetycheck1")==0) s_opt.cxrefs = OLO_SAFETY_CHECK1;
        else if (strcmp(argv[i],"-olcxsafetycheck2")==0) s_opt.cxrefs = OLO_SAFETY_CHECK2;
        else if (strcmp(argv[i],"-olcxintersection")==0) s_opt.cxrefs = OLO_INTERSECTION;
        else if (strcmp(argv[i],"-olcxsafetycheckmovedfile")==0
                         || strcmp(argv[i],"-olcxsafetycheckmoved")==0
                ) {
                { i++; if (i >= argc) { sprintf(tmpBuff,"further argument(s) expected after %s\n",argv[i-1]); error(ERR_ST,tmpBuff); usage(argv[0]); }};
                crOptionStr(&s_opt.checkFileMovedFrom, argv[i]);
                { i++; if (i >= argc) { sprintf(tmpBuff,"further argument(s) expected after %s\n",argv[i-1]); error(ERR_ST,tmpBuff); usage(argv[0]); }};
                crOptionStr(&s_opt.checkFileMovedTo, argv[i]);
        }
        else if (strcmp(argv[i],"-olcxwindel")==0) {
                s_opt.cxrefs = OLO_REMOVE_WIN;
        }
        else if (strcmp(argv[i],"-olcxwindelfile")==0) {
                { i++; if (i >= argc) { sprintf(tmpBuff,"further argument(s) expected after %s\n",argv[i-1]); error(ERR_ST,tmpBuff); usage(argv[0]); }};
                crOptionStr(&s_opt.olcxWinDelFile, argv[i]);
        }
        else if (strncmp(argv[i],"-olcxwindelwin=",15)==0) {
                s_opt.olcxWinDelFromLine = s_opt.olcxWinDelToLine = 0;
                s_opt.olcxWinDelFromCol = s_opt.olcxWinDelToCol = 0;
                sscanf(argv[i]+15,"%d:%dx%d:%d",
                           &s_opt.olcxWinDelFromLine, &s_opt.olcxWinDelFromCol,
                           &s_opt.olcxWinDelToLine, &s_opt.olcxWinDelToCol);
        }
        else if (strncmp(argv[i],"-olcxsafetycheckmovedblock=",27)==0) {
                sscanf(argv[i]+27, "%d:%d:%d", &s_opt.checkFirstMovedLine,
                           &s_opt.checkLinesMoved, &s_opt.checkNewLineNumber);
        }
        else if (strcmp(argv[i],"-olcxgotodef")==0) s_opt.cxrefs = OLO_GOTO_DEF;
        else if (strcmp(argv[i],"-olcxgotocaller")==0) s_opt.cxrefs = OLO_GOTO_CALLER;
        else if (strcmp(argv[i],"-olcxgotocurrent")==0) s_opt.cxrefs = OLO_GOTO_CURRENT;
        else if (strcmp(argv[i],"-olcxgetcurrentrefn")==0)s_opt.cxrefs=OLO_GET_CURRENT_REFNUM;
        else if (strncmp(argv[i],"-olcxgotoparname",16)==0) {
                s_opt.cxrefs = OLO_GOTO_PARAM_NAME;
                s_opt.olcxGotoVal = 0;
                sscanf(argv[i]+16, "%d", &s_opt.olcxGotoVal);
        }
        else if (strncmp(argv[i],"-olcxgetparamcoord",18)==0) {
                s_opt.cxrefs = OLO_GET_PARAM_COORDINATES;
                s_opt.olcxGotoVal = 0;
                sscanf(argv[i]+18, "%d", &s_opt.olcxGotoVal);
        }
        else if (strncmp(argv[i],"-olcxparnum=",12)==0) {
                s_opt.olcxGotoVal = 0;
                sscanf(argv[i]+12, "%d", &s_opt.olcxGotoVal);
        }
        else if (strncmp(argv[i],"-olcxparnum2=",13)==0) {
                s_opt.parnum2 = 0;
                sscanf(argv[i]+13, "%d", &s_opt.parnum2);
        }
        else if (strcmp(argv[i],"-olcxtops")==0) s_opt.cxrefs = OLO_SHOW_TOP;
        else if (strcmp(argv[i],"-olcxtoptype")==0) s_opt.cxrefs = OLO_SHOW_TOP_TYPE;
        else if (strcmp(argv[i],"-olcxtopapplcl")==0) s_opt.cxrefs = OLO_SHOW_TOP_APPL_CLASS;
        else if (strcmp(argv[i],"-olcxshowctree")==0) s_opt.cxrefs = OLO_SHOW_CLASS_TREE;
        else if (strcmp(argv[i],"-olcxedittop")==0) s_opt.cxrefs = OLO_TOP_SYMBOL_RES;
        else if (strcmp(argv[i],"-olcxclasstree")==0) s_opt.cxrefs = OLO_CLASS_TREE;
        else if (strcmp(argv[i],"-olcxprimarystart")==0) {
                s_opt.cxrefs = OLO_GET_PRIMARY_START;
        }
        else if (strcmp(argv[i],"-olcxuselesslongnames")==0) s_opt.cxrefs = OLO_USELESS_LONG_NAME;
        else if (strcmp(argv[i],"-olcxuselesslongnamesinclass")==0) s_opt.cxrefs = OLO_USELESS_LONG_NAME_IN_CLASS;
        else if (strcmp(argv[i],"-olcxmaybethis")==0) s_opt.cxrefs = OLO_MAYBE_THIS;
        else if (strcmp(argv[i],"-olcxnotfqt")==0) s_opt.cxrefs = OLO_NOT_FQT_REFS;
        else if (strcmp(argv[i],"-olcxnotfqtinclass")==0) s_opt.cxrefs = OLO_NOT_FQT_REFS_IN_CLASS;
        else if (strcmp(argv[i],"-olcxgetrefactorings")==0) {
                s_opt.cxrefs = OLO_GET_AVAILABLE_REFACTORINGS;
        }
        else if (strcmp(argv[i],"-olcxpush")==0) s_opt.cxrefs = OLO_PUSH;
        else if (strcmp(argv[i],"-olcxrepush")==0) s_opt.cxrefs = OLO_REPUSH;
        else if (strcmp(argv[i],"-olcxpushonly")==0) s_opt.cxrefs = OLO_PUSH_ONLY;
        else if (strcmp(argv[i],"-olcxencapsulatesc1")==0) s_opt.cxrefs = OLO_PUSH_ENCAPSULATE_SAFETY_CHECK;
        else if (strcmp(argv[i],"-olcxencapsulatesc2")==0) s_opt.cxrefs = OLO_ENCAPSULATE_SAFETY_CHECK;
        else if (strcmp(argv[i],"-olcxpushallinmethod")==0) s_opt.cxrefs = OLO_PUSH_ALL_IN_METHOD;
        else if (strcmp(argv[i],"-olcxmmprecheck")==0) s_opt.cxrefs = OLO_MM_PRE_CHECK;
        else if (strcmp(argv[i],"-olcxppprecheck")==0) s_opt.cxrefs = OLO_PP_PRE_CHECK;
        else if (strcmp(argv[i],"-olcxpushforlm")==0) {
                s_opt.cxrefs = OLO_PUSH_FOR_LOCALM;
                s_opt.manualResolve = RESOLVE_DIALOG_NEVER;
        }
        else if (strcmp(argv[i],"-olcxlist")==0) s_opt.cxrefs = OLO_LIST;
        else if (strcmp(argv[i],"-olcxlisttop")==0) s_opt.cxrefs=OLO_LIST_TOP;
        else if (strcmp(argv[i],"-olcxpop")==0) s_opt.cxrefs = OLO_POP;
        else if (strcmp(argv[i],"-olcxpoponly")==0) s_opt.cxrefs =OLO_POP_ONLY;
        else if (strcmp(argv[i],"-olcxplus")==0) s_opt.cxrefs = OLO_PLUS;
        else if (strcmp(argv[i],"-olcxminus")==0) s_opt.cxrefs = OLO_MINUS;
        else if (strcmp(argv[i],"-olcxsearch")==0) s_opt.cxrefs = OLO_SEARCH;
        else if (strcmp(argv[i],"-olcxcomplet")==0)s_opt.cxrefs=OLO_COMPLETION;
        else if (strcmp(argv[i],"-olcxtarget")==0) s_opt.cxrefs=OLO_SET_MOVE_TARGET;
        else if (strcmp(argv[i],"-olcxmctarget")==0) s_opt.cxrefs=OLO_SET_MOVE_CLASS_TARGET;
        else if (strcmp(argv[i],"-olcxmmtarget")==0) s_opt.cxrefs=OLO_SET_MOVE_METHOD_TARGET;
        else if (strcmp(argv[i],"-olcxcurrentclass")==0) s_opt.cxrefs=OLO_GET_CURRENT_CLASS;
        else if (strcmp(argv[i],"-olcxcurrentsuperclass")==0) s_opt.cxrefs=OLO_GET_CURRENT_SUPER_CLASS;
        else if (strcmp(argv[i],"-olcxmethodlines")==0) s_opt.cxrefs=OLO_GET_METHOD_COORD;
        else if (strcmp(argv[i],"-olcxclasslines")==0) s_opt.cxrefs=OLO_GET_CLASS_COORD;
        else if (strcmp(argv[i],"-olcxgetsymboltype")==0) s_opt.cxrefs=OLO_GET_SYMBOL_TYPE;
        else if (strcmp(argv[i],"-olcxgetprojectname")==0) {
                s_opt.cxrefs=OLO_ACTIVE_PROJECT;
        }
        else if (strcmp(argv[i],"-olcxgetjavahome")==0) {
                s_opt.cxrefs=OLO_JAVA_HOME;
        }
        else if (strncmp(argv[i],"-olcxlccursor=",14)==0) {
                crOptionStr(&s_opt.olcxlccursor, argv[i]+14);
        }
        else if (strncmp(argv[i],"-olcxcplsearch=",15)==0) {
                s_opt.cxrefs=OLO_SEARCH;
                crOptionStr(&s_opt.olcxSearchString, argv[i]+15);
        }
        else if (strncmp(argv[i],"-olcxtagsearch=",15)==0) {
                s_opt.cxrefs=OLO_TAG_SEARCH;
                crOptionStr(&s_opt.olcxSearchString, argv[i]+15);
        }
        else if (strncmp(argv[i],"-olcxpushname=",14)==0) {
                s_opt.cxrefs = OLO_PUSH_NAME;
                crOptionStr(&s_opt.pushName, argv[i]+14);
        }
        else if (strncmp(argv[i],"-olcomplselect",14)==0) {
                s_opt.cxrefs=OLO_CSELECT;
                s_opt.olcxGotoVal = 0;
                sscanf(argv[i]+14,"%d",&s_opt.olcxGotoVal);
        }
        else if (strncmp(argv[i],"-olcxcgoto",10)==0) {
                s_opt.cxrefs = OLO_CGOTO;
                s_opt.olcxGotoVal = 0;
                sscanf(argv[i]+10,"%d",&s_opt.olcxGotoVal);
        }
        else if (strncmp(argv[i],"-olcxtaggoto",12)==0) {
                s_opt.cxrefs = OLO_TAGGOTO;
                s_opt.olcxGotoVal = 0;
                sscanf(argv[i]+12,"%d",&s_opt.olcxGotoVal);
        }
        else if (strncmp(argv[i],"-olcxcbrowse",12)==0) {
                s_opt.cxrefs = OLO_CBROWSE;
                s_opt.olcxGotoVal = 0;
                sscanf(argv[i]+12,"%d",&s_opt.olcxGotoVal);
        }
        else if (strncmp(argv[i],"-olcxgoto",9)==0) {
                s_opt.cxrefs = OLO_GOTO;
                s_opt.olcxGotoVal = 0;
                sscanf(argv[i]+9,"%d",&s_opt.olcxGotoVal);
        }
        else if (strncmp(argv[i],"-olcxfilter=",12)==0) {
                s_opt.cxrefs = OLO_REF_FILTER_SET;
                sscanf(argv[i]+12,"%d",&s_opt.filterValue);
        }
        else if (strncmp(argv[i], "-olcxmenusingleselect",21)==0) {
                s_opt.cxrefs = OLO_MENU_SELECT_ONLY;
                s_opt.olcxMenuSelectLineNum = 0;
                sscanf(argv[i]+21,"%d",&s_opt.olcxMenuSelectLineNum);
        }
        else if (strncmp(argv[i],"-olcxmenuselect",15)==0) {
                s_opt.cxrefs = OLO_MENU_SELECT;
                s_opt.olcxMenuSelectLineNum = 0;
                sscanf(argv[i]+15,"%d",&s_opt.olcxMenuSelectLineNum);
        }
        else if (strncmp(argv[i],"-olcxmenuinspectdef",19)==0) {
                s_opt.cxrefs = OLO_MENU_INSPECT_DEF;
                s_opt.olcxMenuSelectLineNum = 0;
                sscanf(argv[i]+19,"%d",&s_opt.olcxMenuSelectLineNum);
        }
        else if (strncmp(argv[i],"-olcxmenuinspectclass",21)==0) {
                s_opt.cxrefs = OLO_MENU_INSPECT_CLASS;
                s_opt.olcxMenuSelectLineNum = 0;
                sscanf(argv[i]+21,"%d",&s_opt.olcxMenuSelectLineNum);
        }
        else if (strncmp(argv[i],"-olcxctinspectdef",17)==0) {
                s_opt.cxrefs = OLO_CT_INSPECT_DEF;
                s_opt.olcxMenuSelectLineNum = 0;
                sscanf(argv[i]+17,"%d",&s_opt.olcxMenuSelectLineNum);
        }
        else if (strcmp(argv[i],"-olcxmenuall")==0) {
                s_opt.cxrefs = OLO_MENU_SELECT_ALL;
        }
        else if (strcmp(argv[i],"-olcxmenunone")==0) {
                s_opt.cxrefs = OLO_MENU_SELECT_NONE;
        }
        else if (strcmp(argv[i],"-olcxmenugo")==0) {
                s_opt.cxrefs = OLO_MENU_GO;
        }
        else if (strncmp(argv[i],"-olcxmenufilter=",16)==0) {
                s_opt.cxrefs = OLO_MENU_FILTER_SET;
                sscanf(argv[i]+16,"%d",&s_opt.filterValue);
        }
        else if (strcmp(argv[i],"-o")==0) {
                { i++; if (i >= argc) { sprintf(tmpBuff,"file name expected after %s\n",argv[i-1]); error(ERR_ST,tmpBuff); usage(argv[0]); }};
                crOptionStr(&s_opt.outputFileName, argv[i]);
        }
        else return(0);
        *ii = i;
        return(1);
}
static int processPOption(int *ii, int argc, char **argv) {
        char ttt[MAX_FILE_NAME_SIZE];
        int i = * ii;
        if (0) {}
        else if (strncmp(argv[i],"-pass",5)==0) {
                error(ERR_ST,"'-pass' option can't be entered from command line");
        }
        else if (strcmp(argv[i],"-packages")==0) {
                s_opt.allowPackagesOnCl = 1;
        }
        else if (strcmp(argv[i],"-p")==0) {
                { i++; if (i >= argc) { sprintf(tmpBuff,"file name expected after %s\n",argv[i-1]); error(ERR_ST,tmpBuff); usage(argv[0]); }};
                crOptionStr(&s_opt.project, argv[i]);
        }
        else if (strcmp(argv[i],"-preload")==0) {
                char *buff, *file, *fromFile;
                { i++; if (i >= argc) { sprintf(tmpBuff,"file name expected after %s\n",argv[i-1]); error(ERR_ST,tmpBuff); usage(argv[0]); }};
                file = argv[i];
                strcpy(ttt, normalizeFileName(file, s_cwd));
                { i++; if (i >= argc) { sprintf(tmpBuff,"file name expected after %s\n",argv[i-1]); error(ERR_ST,tmpBuff); usage(argv[0]); }};
                fromFile = argv[i];
                editorOpenBufferNoFileLoad(ttt, fromFile);
        }
        else return(0);
        *ii = i;
        return(1);
}
static int processQOption(int *ii, int argc, char **argv) {
        int i = * ii;
        if (0) {}
        else return(0);
        *ii = i;
        return(1);
}
static int processROption(int *ii, int argc, char **argv, int infilesFlag) {
        int i = * ii;
        if (0) {}
        else if (strncmp(argv[i],"-refnum=",8)==0) {
                sscanf(argv[i]+8, "%d", &s_opt.refnum);
        }
        else if (strcmp(argv[i],"-refalphahash")==0
                         || strcmp(argv[i],"-refalpha1hash")==0) {
                int check;
                s_opt.xfileHashingMethod = 1;
                check = changeRefNumOption(('z'-'a'+2));
                if (check == 0) {
                        { if (!(s_opt.taskRegime)) internalCheckFail("s_opt.taskRegime", "main.c", 1115);};
                        fatalError(ERR_ST,"'-refalphahash' conflicts with '-refnum' option", 65);
                }
        }
        else if (strcmp(argv[i],"-refalpha2hash")==0) {
                int check;
                s_opt.xfileHashingMethod = 2;
                check = changeRefNumOption((('z'-'a'+2)*('z'-'a'+2)));
                if (check == 0) {
                        { if (!(s_opt.taskRegime)) internalCheckFail("s_opt.taskRegime", "main.c", 1124);};
                        fatalError(ERR_ST,"'-refalpha2hash' conflicts with '-refnum' option", 65);
                }
        }
        else if (strcmp(argv[i],"-r")==0) {
                if (infilesFlag == INFILES_ENABLED) s_opt.recursivelyDirs = 1;
        }
        else if (strncmp(argv[i],"-renameto=", 10)==0) {
                crOptionStr(&s_opt.renameTo, argv[i]+10);
        }
        else if (strcmp(argv[i],"-resetIncludeDirs")==0) {
                s_opt.includeDirs = NULL;
        }
        else if (strcmp(argv[i],"-refs")==0) {
                { i++; if (i >= argc) { sprintf(tmpBuff,"file name expected after %s\n",argv[i-1]); error(ERR_ST,tmpBuff); usage(argv[0]); }};
                crOptionStr(&s_opt.cxrefFileName, argv[i]);
        }
        else if (strncmp(argv[i],"-refs=",6)==0) {
                crOptionStr(&s_opt.cxrefFileName, argv[i]+6);
        }
        else if (strcmp(argv[i],"-refactory")==0) {
                s_opt.refactoringRegime = RegimeRefactory;
        }
        else if (strcmp(argv[i],"-rfct-rename")==0) {
                s_opt.theRefactoring = PPC_AVR_RENAME_SYMBOL;
        }
        else if (strcmp(argv[i],"-rfct-rename-class")==0) {
                s_opt.theRefactoring = PPC_AVR_RENAME_CLASS;
        }
        else if (strcmp(argv[i],"-rfct-rename-package")==0) {
                s_opt.theRefactoring = PPC_AVR_RENAME_PACKAGE;
        }
        else if (strcmp(argv[i],"-rfct-expand")==0) {
                s_opt.theRefactoring = PPC_AVR_EXPAND_NAMES;
        }
        else if (strcmp(argv[i],"-rfct-reduce")==0) {
                s_opt.theRefactoring = PPC_AVR_REDUCE_NAMES;
        }
        else if (strcmp(argv[i],"-rfct-add-param")==0) {
                s_opt.theRefactoring = PPC_AVR_ADD_PARAMETER;
        }
        else if (strcmp(argv[i],"-rfct-del-param")==0) {
                s_opt.theRefactoring = PPC_AVR_DEL_PARAMETER;
        }
        else if (strcmp(argv[i],"-rfct-move-param")==0) {
                s_opt.theRefactoring = PPC_AVR_MOVE_PARAMETER;
        }
        else if (strcmp(argv[i],"-rfct-move-static-field")==0) {
                s_opt.theRefactoring = PPC_AVR_MOVE_STATIC_FIELD;
        }
        else if (strcmp(argv[i],"-rfct-move-static-method")==0) {
                s_opt.theRefactoring = PPC_AVR_MOVE_STATIC_METHOD;
        }
        else if (strcmp(argv[i],"-rfct-move-class")==0) {
                s_opt.theRefactoring = PPC_AVR_MOVE_CLASS;
        }
        else if (strcmp(argv[i],"-rfct-static-to-dynamic")==0) {
                s_opt.theRefactoring = PPC_AVR_TURN_STATIC_METHOD_TO_DYNAMIC;
        }
        else if (strcmp(argv[i],"-rfct-dynamic-to-static")==0) {
                s_opt.theRefactoring = PPC_AVR_TURN_DYNAMIC_METHOD_TO_STATIC;
        }
        else if (strcmp(argv[i],"-rfct-extract-method")==0) {
                s_opt.theRefactoring = PPC_AVR_EXTRACT_METHOD;
        }
        else if (strncmp(argv[i], "-rfct-param1=", 13)==0) {
                crOptionStr(&s_opt.refpar1, argv[i]+13);
        }
        else if (strncmp(argv[i], "-rfct-param2=", 13)==0) {
                crOptionStr(&s_opt.refpar2, argv[i]+13);
        }
        else return(0);
        *ii = i;
        return(1);
}
static int processSOption(int *ii, int argc, char **argv) {
        int i = * ii;
        char *name, *val;
        if (0) {}
        else if (strcmp(argv[i],"-strict")==0) s_opt.strictAnsi = 1;
        else if (strcmp(argv[i],"-str_fill")==0) s_opt.str_fill = 1;
        else if (strcmp(argv[i],"-str_copy")==0) s_opt.str_copy = 1;
        else if (strcmp(argv[i],"-stderr")==0) errOut = stdout;
        else if (strcmp(argv[i],"-source")==0) {
                { i++; if (i >= argc) { sprintf(tmpBuff,"further argument(s) expected after %s\n",argv[i-1]); error(ERR_ST,tmpBuff); usage(argv[0]); }};
                if (strcmp(argv[i], "1.3")!=0 && strcmp(argv[i], "1.4")!=0) {
                        sprintf(tmpBuff,"wrong -javaversion=<value>, available values are %s, %s",
                                        "1.3", "1.4");
                        error(ERR_ST, tmpBuff);
                } else {
                        crOptionStr(&s_opt.javaVersion, argv[i]);
                }
        }
        else if (strcmp(argv[i],"-sourcepath")==0) {
                { i++; if (i >= argc) { sprintf(tmpBuff,"file name expected after %s\n",argv[i-1]); error(ERR_ST,tmpBuff); usage(argv[0]); }};
                crOptionStr(&s_opt.sourcePath, argv[i]);
                xrefSetenv("-sourcepath", s_opt.sourcePath);
        }
        else if (strcmp(argv[i],"-stdop")==0) {
                i = mainHandleIncludeOption(argc, argv, i);
        }
        else if (strcmp(argv[i],"-set")==0) {
                i = mainHandleSetOption(argc, argv, i);
        }
        else if (strncmp(argv[i],"-set",4)==0) {
                name = argv[i]+4;
                { i++; if (i >= argc) { sprintf(tmpBuff,"further argument(s) expected after %s\n",argv[i-1]); error(ERR_ST,tmpBuff); usage(argv[0]); }};
                val = argv[i];
                xrefSetenv(name, val);
        }
        else if (strcmp(argv[i],"-searchdef")==0) {
                s_opt.tagSearchSpecif = TSS_SEARCH_DEFS_ONLY;
        }
        else if (strcmp(argv[i],"-searchshortlist")==0) {
                s_opt.tagSearchSpecif = TSS_FULL_SEARCH_SHORT;
        }
        else if (strcmp(argv[i],"-searchdefshortlist")==0) {
                s_opt.tagSearchSpecif = TSS_SEARCH_DEFS_ONLY_SHORT;
        }
        else return(0);
        *ii = i;
        return(1);
}
static int processTOption(int *ii, int argc, char **argv) {
        int i = * ii;
        if (0) {}
        else if (strcmp(argv[i],"-typedefs")==0) s_opt.typedefg = 1;
        else if (strcmp(argv[i],"-task_regime_server")==0) {
                s_opt.taskRegime = RegimeEditServer;
        }
        else if (strcmp(argv[i],"-task_regime_generate")==0) {
                s_opt.taskRegime = RegimeGenerate;
        }
        else if (strcmp(argv[i],"-tpchrenamepackage")==0) {
                s_opt.trivialPreCheckCode = TPC_RENAME_PACKAGE;
        }
        else if (strcmp(argv[i],"-tpchrenameclass")==0) {
                s_opt.trivialPreCheckCode = TPC_RENAME_CLASS;
        }
        else if (strcmp(argv[i],"-tpchmoveclass")==0) {
                s_opt.trivialPreCheckCode = TPC_MOVE_CLASS;
        }
        else if (strcmp(argv[i],"-tpchmovefield")==0) {
                s_opt.trivialPreCheckCode = TPC_MOVE_FIELD;
        }
        else if (strcmp(argv[i],"-tpchmovestaticfield")==0) {
                s_opt.trivialPreCheckCode = TPC_MOVE_STATIC_FIELD;
        }
        else if (strcmp(argv[i],"-tpchmovestaticmethod")==0) {
                s_opt.trivialPreCheckCode = TPC_MOVE_STATIC_METHOD;
        }
        else if (strcmp(argv[i],"-tpchturndyntostatic")==0) {
                s_opt.trivialPreCheckCode = TPC_TURN_DYN_METHOD_TO_STATIC;
        }
        else if (strcmp(argv[i],"-tpchturnstatictodyn")==0) {
                s_opt.trivialPreCheckCode = TPC_TURN_STATIC_METHOD_TO_DYN;
        }
        else if (strcmp(argv[i],"-tpchpullupmethod")==0) {
                s_opt.trivialPreCheckCode = TPC_PULL_UP_METHOD;
        }
        else if (strcmp(argv[i],"-tpchpushdownmethod")==0) {
                s_opt.trivialPreCheckCode = TPC_PUSH_DOWN_METHOD;
        }
        else if (strcmp(argv[i],"-tpchpushdownmethodpostcheck")==0) {
                s_opt.trivialPreCheckCode = TPC_PUSH_DOWN_METHOD_POST_CHECK;
        }
        else if (strcmp(argv[i],"-tpchpullupfield")==0) {
                s_opt.trivialPreCheckCode = TPC_PULL_UP_FIELD;
        }
        else if (strcmp(argv[i],"-tpchpushdownfield")==0) {
                s_opt.trivialPreCheckCode = TPC_PUSH_DOWN_FIELD;
        }
        else return(0);
        *ii = i;
        return(1);
}
static int processUOption(int *ii, int argc, char **argv) {
        int i = * ii;
        if (0) {}
        else if (strcmp(argv[i],"-urlmanualredirect")==0) {
                s_opt.urlAutoRedirect = 0;
        }
        else if (strcmp(argv[i],"-urldirect")==0) {
                s_opt.urlGenTemporaryFile = 0;
        }
        else if (strcmp(argv[i],"-user")==0) {
                { i++; if (i >= argc) { sprintf(tmpBuff,"file name expected after %s\n",argv[i-1]); error(ERR_ST,tmpBuff); usage(argv[0]); }};
                crOptionStr(&s_opt.user, argv[i]);
        }
        else if (strcmp(argv[i],"-update")==0) {
                s_opt.update = UP_FULL_UPDATE;
                s_opt.updateOnlyModifiedFiles = 1;
        }
        else if (strcmp(argv[i],"-updatem")==0) {
                s_opt.update = UP_FULL_UPDATE;
                s_opt.updateOnlyModifiedFiles = 1;
        }
        else return(0);
        *ii = i;
        return(1);
}
static int processVOption(int *ii, int argc, char **argv) {
        int i = * ii;
        if (0) {}
        else if (strcmp(argv[i],"-version")==0||strcmp(argv[i],"-about")==0){
                s_opt.aboutOption = 1;
        }
        else return(0);
        *ii = i;
        return(1);
}
static int processWOption(int *ii, int argc, char **argv) {
        int i = * ii;
        if (0) {}
        else return(0);
        *ii = i;
        return(1);
}
static int processXOption(int *ii, int argc, char **argv) {
        int i = * ii;
        if (0) {}
        else if (strcmp(argv[i],"-xrefactory-II") == 0){
                s_opt.xref2 = 1;
        }
        else if (strncmp(argv[i],"-xrefrc=",8) == 0){
                crOptionStr(&s_opt.xrefrc, argv[i]+8);
        }
        else return(0);
        *ii = i;
        return(1);
}
static int processYOption(int *ii, int argc, char **argv) {
        int i = * ii;
        if (0) {}
        else return(0);
        *ii = i;
        return(1);
}
static int processZOption(int *ii, int argc, char **argv) {
        int i = * ii;
        if (0) {}
        else return(0);
        *ii = i;
        return(1);
}
void processOptions(int argc, char **argv, int infilesFlag) {
        S_stringList *ll;
        S_fileItem *fi,ffi;
        char *fin,*ftin;
        int i,ii,newRefNum,ln,topCallFlag,processed,tmp;
        void *recursFlag;
        for (i=1; i<argc; i++) {
                if (s_opt.taskRegime==RegimeEditServer &&
                        strncmp(argv[i],"-last_message=",14)==0) {
                        { if (s_opt.debug) {fprintf(dumpOut,"option -lastmessage=...\n");fflush(dumpOut);}};
                } else {
                        { if (s_opt.debug) {fprintf(dumpOut,"option %s\n",argv[i]);fflush(dumpOut);}};
                }
                processed = 0;
                if (argv[i][0] == '-') {
                        switch (argv[i][1]) {
                        case '-': processed = processNegativeOption(&i, argc, argv, infilesFlag);
                                break;
                        case 'a': case 'A': processed = processAOption(&i, argc, argv);
                                break;
                        case 'b': case 'B': processed = processBOption(&i, argc, argv);
                                break;
                        case 'c': case 'C': processed = processCOption(&i, argc, argv);
                                break;
                        case 'd': case 'D': processed = processDOption(&i, argc, argv);
                                break;
                        case 'e': case 'E': processed = processEOption(&i, argc, argv);
                                break;
                        case 'f': case 'F': processed = processFOption(&i, argc, argv);
                                break;
                        case 'g': case 'G': processed = processGOption(&i, argc, argv);
                                break;
                        case 'h': case 'H': processed = processHOption(&i, argc, argv);
                                break;
                        case 'i': case 'I': processed = processIOption(&i, argc, argv);
                                break;
                        case 'j': case 'J': processed = processJOption(&i, argc, argv);
                                break;
                        case 'k': case 'K': processed = processKOption(&i, argc, argv);
                                break;
                        case 'l': case 'L': processed = processLOption(&i, argc, argv);
                                break;
                        case 'm': case 'M': processed = processMOption(&i, argc, argv);
                                break;
                        case 'n': case 'N': processed = processNOption(&i, argc, argv);
                                break;
                        case 'o': case 'O': processed = processOOption(&i, argc, argv);
                                break;
                        case 'p': case 'P': processed = processPOption(&i, argc, argv);
                                break;
                        case 'q': case 'Q': processed = processQOption(&i, argc, argv);
                                break;
                        case 'r': case 'R': processed = processROption(&i, argc, argv, infilesFlag);
                                break;
                        case 's': case 'S': processed = processSOption(&i, argc, argv);
                                break;
                        case 't': case 'T': processed = processTOption(&i, argc, argv);
                                break;
                        case 'u': case 'U': processed = processUOption(&i, argc, argv);
                                break;
                        case 'v': case 'V': processed = processVOption(&i, argc, argv);
                                break;
                        case 'w': case 'W': processed = processWOption(&i, argc, argv);
                                break;
                        case 'x': case 'X': processed = processXOption(&i, argc, argv);
                                break;
                        case 'y': case 'Y': processed = processYOption(&i, argc, argv);
                                break;
                        case 'z': case 'Z': processed = processZOption(&i, argc, argv);
                                break;
                        default: processed = 0;
                        }
                } else {
                        processed = 1;
                        if (infilesFlag == INFILES_ENABLED) {
                                if (argv[i][0]=='`' && argv[i][strlen(argv[i])-1]=='`') {
                                        int nargc,aaa;
                                        char **nargv, *pp;
                                        char command[MAX_OPTION_LEN];
                                        if (infilesFlag==INFILES_ENABLED) {
                                                s_opt.stdopFlag = 1;
                                                strcpy(command, argv[i]+1);
                                                pp = strchr(command, '`');
                                                if (pp!=NULL) *pp = 0;
                                                readOptionPipe(command, &nargc, &nargv, "");
                                                processOptions(nargc, nargv, INFILES_ENABLED);
                                                s_opt.stdopFlag = 0;
                                        }
                                } else {
                                        topCallFlag = 1;
                                        recursFlag = &topCallFlag;
                                        { char *currentPath, *jmop_pp, *jmop_ecp; int jmop_i, jmop_ind; char sourcepathes[MAX_SOURCE_PATH_SIZE]; { if (!(argv[i]!=NULL)) internalCheckFail("argv[i]!=NULL", "main.c", 1478);}; jmop_pp = argv[i]; strcpy(sourcepathes, jmop_pp); currentPath = sourcepathes; jmop_ecp = currentPath+strlen(currentPath); while (currentPath<jmop_ecp) { for(jmop_ind=0; currentPath[jmop_ind]!=0 && currentPath[jmop_ind]!=CLASS_PATH_SEPARATOR; jmop_ind++) ; currentPath[jmop_ind] = 0; jmop_i = jmop_ind; if (jmop_i>0 && currentPath[jmop_i-1]==SLASH) currentPath[--jmop_i] = 0; { dirInputFile(currentPath,"",NULL,NULL,recursFlag,&topCallFlag); }; currentPath += jmop_ind; currentPath++; }};
                                }
                        }
                }
                if (! processed) {
                        sprintf(tmpBuff,"unknown option %s, (try xref -help)\n",argv[i]);
                        error(ERR_ST,tmpBuff);
                        if ( s_opt.taskRegime==RegimeXref
                                        || s_opt.taskRegime==RegimeHtmlGenerate) {
                                emergencyExit(65);
                        }
                }
        }
}
static char * getInputFileFromFtab(int *fArgCount, int flag) {
        char *res;
        int i;
        S_fileItem *fi;
        for(i= *fArgCount; i<s_fileTab.size; i++) {
                fi = s_fileTab.tab[i];
                if (fi!=NULL) {
                        if (flag==FF_SCHEDULED_TO_PROCESS&&fi->b.scheduledToProcess)break;
                        if (flag==FF_COMMAND_LINE_ENTERED&&fi->b.commandLineEntered)break;
                }
        }
        *fArgCount = i;
        if (i<s_fileTab.size) return(s_fileTab.tab[i]->name);
        else return(NULL);
}
char * getInputFile(int *fArgCount) {
        return(getInputFileFromFtab(fArgCount,FF_SCHEDULED_TO_PROCESS));
}
static char * getCommandLineFile(int *fArgCount) {
        return(getInputFileFromFtab(fArgCount,FF_COMMAND_LINE_ENTERED));
}
static void mainGenerateReferenceFile() {
        char *inputRefFile;
        static int updateFlag = 0;
        if (s_opt.cxrefFileName == NULL) return;
        if (updateFlag == 0 && s_opt.update == 0) {
                genReferenceFile(0, s_opt.cxrefFileName);
                updateFlag = 1;
        } else {
                genReferenceFile(1,s_opt.cxrefFileName);
        }
}
static void schedulingUpdateToProcess(S_fileItem *p) {
        if (p->b.scheduledToUpdate && p->b.commandLineEntered) {
                p->b.scheduledToProcess = 1;
        }
}
static void schedulingToUpdate(S_fileItem *p, void *rs) {
        struct stat fstat,hstat,*refStat;
        char sss[MAX_FILE_NAME_SIZE];
        refStat = (struct stat *) rs;
        if (p == s_fileTab.tab[s_noneFileIndex]) return;
        if (statb(p->name, &fstat)) {
                if (p->b.commandLineEntered) {
                        if (s_ropt.refactoringRegime != RegimeRefactory) {
                                sprintf(tmpBuff,"file %s not accessible\n", p->name);
                                warning(ERR_ST, tmpBuff);
                        }
                }
                p->b.commandLineEntered = 0;
                p->b.scheduledToProcess = 0;
                p->b.scheduledToUpdate = 0;
                if (p->name[0] != ';') {
                        p->b.cxLoading = 1;
                }
        } else if (s_opt.taskRegime == RegimeHtmlGenerate) {
                concatPathes(sss,MAX_FILE_NAME_SIZE,s_opt.htmlRoot,p->name,".html");
                strcat(sss, s_opt.htmlLinkSuffix);
                { if (!(strlen(sss) < MAX_FILE_NAME_SIZE-2)) internalCheckFail("strlen(sss) < MAX_FILE_NAME_SIZE-2", "main.c", 1569);};
                if (statb(sss, &hstat) || fstat.st_mtime >= hstat.st_mtime) {
                        p->b.scheduledToUpdate = 1;
                }
        } else if (s_opt.update == UP_FULL_UPDATE) {
                if (fstat.st_mtime != p->lastFullUpdateMtime) {
                        p->b.scheduledToUpdate = 1;
                }
        } else {
                if (fstat.st_mtime != p->lastUpdateMtime) {
                        p->b.scheduledToUpdate = 1;
                }
        }
}
void searchDefaultOptionsFile(char *file, char *ttt, char *sect) {
        struct stat fst;
        int ii,findFlag=0;
        FILE *ff=NULL;
        FILE *ffn;
        int nargc,aaa,hlen;
        char **nargv,*hh;
        ttt[0] = 0; sect[0]=0;
        if (file == NULL) return;
        if (s_opt.stdopFlag || s_opt.no_stdop) return;
        getXrefrcFileName( ttt);
        ff = fopen(ttt,"r");
        if (ff!=NULL) {
                findFlag = readOptionFromFile(ff,&nargc,&nargv,MEM_NO_ALLOC,file,s_opt.project,sect);
                if (findFlag) {
                        { if (s_opt.debug) {fprintf(dumpOut,"options file '%s' section '%s'\n",ttt,sect);fflush(dumpOut);}};
                }
                fclose(ff);
        }
        if (findFlag) return;
        strcpy(ttt,normalizeFileName(file,s_cwd));
        for(; findFlag==0; ) {
                copyDir(ttt,ttt,&ii);
                if (ii == 0) break;
                { if (!(ii+15<MAX_FILE_NAME_SIZE)) internalCheckFail("ii+15<MAX_FILE_NAME_SIZE", "main.c", 1614);};
                sprintf(ttt+ii,"Xref.opt");
                if (stat(ttt,&fst)==0 && (fst.st_mode & S_IFMT) != S_IFDIR) {
                        { if (s_opt.debug) {fprintf(dumpOut,"options file '%s'\n",ttt);fflush(dumpOut);}};
                        findFlag = 1;
                } else {
                        ttt[ii-1]=0;
                }
        }
        if (findFlag) {
                if (s_opt.taskRegime!=RegimeEditServer) {
                        sprintf(tmpBuff,"%s\n\t\t%s",
                                        "using of 'Xref.opt' file is an obsolete way of passing",
#ifdef __WIN32__
                                        "options to xref task. Please, use '%HOME%\\_xrefrc' file"
#else
                                        "options to xref task. Please, use '~/.xrefrc' file"
#endif
                                        );
                        error(ERR_ST, tmpBuff);
                }
                return;
        }
        if (s_opt.project==NULL) {
                strcpy(ttt, oldStdopFile);
                strcpy(sect, oldStdopSection);
                return;
        }
        ttt[0]=0;
        return;
}
static void writeOptionsFileMessage( char *file,
                                                                         char *outFName, char *outSect ) {
        if (s_opt.refactoringRegime==RegimeRefactory) return;
        if (s_opt.aboutOption) return;
        if (outFName[0]==0) {
                if (s_opt.project!=NULL) {
                        sprintf(tmpBuff,"'%s' project options not found",
                                        s_opt.project);
                        if (s_opt.taskRegime == RegimeEditServer) {
                                error(ERR_ST, tmpBuff);
                        } else {
                                fatalError(ERR_ST, tmpBuff, 66);
                        }
                } else if (! (s_opt.java2html)) {
                        if (s_opt.xref2) {
                                ppcGenRecord(PPC_NO_PROJECT,file,"\n");
                        } else {
                                sprintf(tmpBuff,"no project name covers '%s'",file);
                                warning(ERR_ST, tmpBuff);
                        }
                }
        } else if (s_opt.taskRegime==RegimeXref) {
                if (s_opt.xref2) {
                        sprintf(tmpBuff,"Xrefactory project: %s", outSect);
                        ppcGenRecord(PPC_INFORMATION, tmpBuff, "\n");
                } else {
                        fprintf(dumpOut,"[Xref] active project: '%s'\n", outSect);
                        fflush(dumpOut);
                }
        }
}
static void handlePathologicProjectCases(char *file,char *outFName,char *outSect,int errMessage){
        { if (!(s_opt.taskRegime)) internalCheckFail("s_opt.taskRegime", "main.c", 1685);};
        if (s_opt.taskRegime == RegimeEditServer) {
                if (errMessage!=NO_ERROR_MESSAGE) {
                        writeOptionsFileMessage(file, outFName, outSect);
                }
        } else {
                if (*oldStdopFile == 0) {
                        static int messageYetWritten=0;
                        if (errMessage!=NO_ERROR_MESSAGE && messageYetWritten == 0) {
                                messageYetWritten = 1;
                                writeOptionsFileMessage( file, outFName, outSect);
                        }
                } else {
                        if ((outFName[0]==0 || outSect[0]==0) && s_opt.editor!=ED_KAWA) {
                                warning(ERR_ST,"no project name covers this file");
                        }
                        if (outFName[0]==0 && outSect[0]==0) {
                                strcpy(outSect, oldStdopSection);
                        }
                        if (outFName[0]==0) {
                                strcpy(outFName, oldStdopFile);
                        }
                        if(strcmp(oldStdopFile,outFName)||strcmp(oldStdopSection,outSect)){
                                if (s_opt.xref2) {
                                        sprintf(tmpBuff, "[Xref] new project: '%s'", outSect);
                                        ppcGenRecord(PPC_INFORMATION, tmpBuff, "\n");
                                } else {
                                        fprintf(dumpOut,"[Xref] new project: '%s'\n", outSect);
                                }
                        }
                }
        }
}
static void getOptionsFile(char *file, char *outFName, char *outSect,int errMessage) {
        searchDefaultOptionsFile(file, outFName, outSect);
        handlePathologicProjectCases(file, outFName, outSect, errMessage);
        return;
}
static int computeAndOpenInputFile() {
        FILE *inputIn;
        S_editorBuffer *inputBuff;
        { if (!(s_language)) internalCheckFail("s_language", "main.c", 1728);};
        inputBuff = NULL;
        if (((s_language & (32)) != 0) || ((s_language & (64)) != 0)) return(0);
        if (s_input_file_name == NULL) {
                { if (!(0)) internalCheckFail("0", "main.c", 1733);};
                inputIn = stdin;
                s_input_file_name = "__none__";
        } else {
                inputIn = NULL;
                inputBuff = editorFindFile(s_input_file_name);
                if (inputBuff == NULL) {
#ifdef __WIN32__
                        inputIn = fopen(s_input_file_name,"rb");
#else
                        inputIn = fopen(s_input_file_name,"r");
#endif
                        if (inputIn == NULL) {
                                error(ERR_CANT_OPEN, s_input_file_name);
                        }
                }
        }
        initInput(inputIn, inputBuff, "\n", s_input_file_name);
        if (inputIn==NULL && inputBuff==NULL) {
                return(0);
        } else {
                return(1);
        }
}
static void initOptions() {
        copyOptions(&s_opt, &s_initOpt);
        s_opt.stdopFlag = 0;
        s_input_file_number = s_noneFileIndex;
}
static void initDefaultCxrefFileName(char *inputfile) {
        int ii;
        static char dcx[MAX_FILE_NAME_SIZE];
        copyDir(dcx, normalizeFileName(inputfile, s_cwd), &ii);
        { if (!(ii < MAX_FILE_NAME_SIZE)) internalCheckFail("ii < MAX_FILE_NAME_SIZE", "main.c", 1781);};
        strcpy(&dcx[ii], DEFAULT_CXREF_FILE);
        { if (!(strlen(dcx) < MAX_FILE_NAME_SIZE)) internalCheckFail("strlen(dcx) < MAX_FILE_NAME_SIZE", "main.c", 1783);};
        strcpy(dcx, getRealFileNameStatic(normalizeFileName(dcx, s_cwd)));
        { if (!(strlen(dcx) < MAX_FILE_NAME_SIZE)) internalCheckFail("strlen(dcx) < MAX_FILE_NAME_SIZE", "main.c", 1785);};
        s_opt.cxrefFileName = dcx;
}
static void initializationsPerInvocation() {
        s_cp = s_cpInit;
        s_cps = s_cpsInit;
        s_cps.methodCoordEndPosition = s_noPos;
        s_cxRefFlag=0;
        s_cxRefPos = s_noPos;
        s_olstringFound = 0;
        s_olstringServed = 0;
        s_olstringInMbody = NULL;
        s_yygstate = s_initYygstate;
        s_jsl = NULL;
}
static void fileTabInit() {
        int len;
        char *ff;
        struct fileItem ffi,*ffii;
        idTabNAInit( &s_fileTab,MAX_FILES);
        len = strlen("___None___");
        {{ { if (!((len+1) >= 0)) internalCheckFail("(len+1) >= 0", "main.c", 1808);}; ftMemoryi = ((char*)(((char*)(ftMemory+ftMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(ftMemory+ftMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - ftMemory; if (ftMemoryi+(len+1)*sizeof(char) >= SIZE_ftMemory) { fatalError(ERR_NO_MEMORY,"ftMemory", 65); } ff = (char*) (ftMemory + ftMemoryi); ftMemoryi += (len+1)*sizeof(char);};};
        strcpy(ff, "___None___");
        {{{ { if (!((1) >= 0)) internalCheckFail("(1) >= 0", "main.c", 1810);}; ftMemoryi = ((char*)(((char*)(ftMemory+ftMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(ftMemory+ftMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - ftMemory; if (ftMemoryi+(1)*sizeof(S_fileItem) >= SIZE_ftMemory) { fatalError(ERR_NO_MEMORY,"ftMemory", 65); } ffii = (S_fileItem*) (ftMemory + ftMemoryi); ftMemoryi += (1)*sizeof(S_fileItem);};};};
        { (ffii)->name = ff; (ffii)->lastModif = 0; (ffii)->lastInspect = 0; (ffii)->lastUpdateMtime = 0; (ffii)->lastFullUpdateMtime = 0; (ffii)->b.cxLoading = 0; (ffii)->b.cxLoaded = 0; (ffii)->b.cxSaved = 0; (ffii)->b.commandLineEntered = 0; (ffii)->b.scheduledToProcess = 0; (ffii)->b.scheduledToUpdate = 0; (ffii)->b.fullUpdateIncludesProcessed = 0; (ffii)->b.isInterface = 0; (ffii)->b.sourceFile = s_noneFileIndex; (ffii)->sups = NULL; (ffii)->infs = NULL; (ffii)->directEnclosingInstance = s_noneFileIndex;};
        idTabAdd(&s_fileTab, ffii, &s_noneFileIndex);
}
static void mainParseInputFile() {
        if (s_language == 4) {
                uniyylval = & s_yygstate->gyylval;
                javayyparse();
        }
        else if (s_language == 8) {
                uniyylval = & yaccyylval;
                yaccyyparse();
        }
        else {
                uniyylval = & cyylval;
                cyyparse();
        }
        s_cache.activeCache = 0;
        cFile.fileName = NULL;
}
static void mainSetLanguage( char *inFileName,
                                                                int *outLanguage
        ) {
        char *suff;
        suff = getFileSuffix(inFileName);
        if (fileNameHasOneOfSuffixes(inFileName, s_opt.javaFilesSuffixes)
                || (fnnCmp(simpleFileName(inFileName), "Untitled-", 9)==0)
                ) {
                *outLanguage = 4;
                typesName[TypeStruct] = "class";
        } else if (fnCmp(suff,".zip")==0 || fnCmp(suff,".jar")==0) {
                *outLanguage = 32;
        } else if (fnCmp(suff,".class")==0) {
                *outLanguage = 64;
        } else if (fnCmp(suff,".y")==0) {
                *outLanguage = 8;
                typesName[TypeStruct] = "struct";
        } else {
                *outLanguage = 2;
                typesName[TypeStruct] = "struct";
        }
}
void getAndProcessXrefrcOptions(char *dffname, char *dffsect,char *project) {
        int dfargc;
        char **dfargv;
        if (*dffname != 0 && s_opt.stdopFlag==0 && s_opt.no_stdop==0) {
                readOptionFile(dffname,&dfargc,&dfargv,dffsect,project);
                processOptions(dfargc, dfargv, INFILES_DISABLED);
        }
}
static void checkExactPositionUpdate(int message) {
        if (s_opt.update == UP_FAST_UPDATE && s_opt.exactPositionResolve) {
                s_opt.update = UP_FULL_UPDATE;
                if (message) {
                        warning(ERR_ST,"-exactpositionresolve implies full update");
                }
        }
}
static void writeProgressInformation(int progress) {
        static int lastprogress;
        static time_t timeZero;
        static int dialogDisplayed = 0;
        static int initialCall = 1;
        time_t ct;
        if (progress == 0 || initialCall) {
                initialCall = 0;
                dialogDisplayed = 0;
                lastprogress = 0;
                timeZero = time(NULL);
        } else {
                if (progress <= lastprogress) return;
        }
        ct = time(NULL);
        if (dialogDisplayed
                || (progress == 0 && ct-timeZero > 1)
                || (progress != 0 && ct-timeZero >= 1 && 100*((double)ct-timeZero)/progress > 3)
                ) {
                if (! dialogDisplayed) {
                        fprintf(stdout,"<%s>0 \n", PPC_PROGRESS);
                        dialogDisplayed = 1;
                }
                fprintf(stdout,"<%s>%d \n", PPC_PROGRESS, progress);
                fflush(stdout);
                lastprogress = progress;
        }
}
void writeRelativeProgress(int val) {
        writeProgressInformation((100*s_progressOffset + val)/s_progressFactor);
        if (val==100) s_progressOffset++;
}
static void mainFileProcessingInitialisations(
                                        int *firstPassing,
                                        int argc, char **argv,
                                        int nargc, char **nargv,
                                        int *outInputIn,
                                        int *outLanguage
        ) {
        int stargc;
        char **stargv;
        int dfargc;
        char **dfargv;
        char dffname[MAX_FILE_NAME_SIZE];
        char dffsect[MAX_FILE_NAME_SIZE];
        char *ss, *fvv;
        struct stat dffstat;
        char *fileName;
        int lc;
        fileName = s_input_file_name;
        mainSetLanguage(fileName, outLanguage);
        getOptionsFile(fileName, dffname, dffsect,DEFAULT_VALUE);
        if (s_ropt.refactoringRegime!=RegimeRefactory && ! (s_opt.java2html)) {
                {lc=0;};
                if (lc!=0) {
                        unsigned rndval = (unsigned)(rand() & 0x0f0);
                        if (rndval == 0) {
                                if (! s_opt.xref2) fprintf(errOut,"\n");
                                error(ERR_BIN_LICENSE,"");
                        }
                }
        }
        initAllInputs();
        if (dffname[0] != 0 ) stat(dffname, &dffstat);
        else dffstat.st_mtime = oldStdopTime;
        if ( *firstPassing
                        || oldCppPass != s_currCppPass
                        || strcmp(oldStdopFile,dffname)
                        || strcmp(oldStdopSection,dffsect)
                        || oldStdopTime != dffstat.st_mtime
                        || oldLanguage!= *outLanguage
                        || strcmp(oldOnLineClassPath, s_opt.classpath)
                        || s_cache.cpi == 1
                ) {
                if (*firstPassing) {
                        initCaching();
                        *firstPassing = 0;
                } else {
                        recoverCachePoint(0,s_cache.cp[0].lbcc,0);
                }
                strcpy(oldOnLineClassPath, s_opt.classpath);
                { if (!(strlen(oldOnLineClassPath)<MAX_OPTION_LEN-1)) internalCheckFail("strlen(oldOnLineClassPath)<MAX_OPTION_LEN-1", "main.c", 2042);};
                s_opt.stdopFlag = 0;
                initPreCreatedTypes();
                initOptions();
                initDefaultCxrefFileName(fileName);
                mainSetLanguage(fileName, outLanguage);
                getStandardOptions(&stargc,&stargv);
                processOptions(stargc,stargv, INFILES_DISABLED);
                processOptions(argc, argv, INFILES_DISABLED);
                {
                        copyOptions(&s_tmpOptions, &s_opt);
                        processOptions(nargc, nargv, INFILES_DISABLED);
                        strcpy(oldStdopFile,dffname);
                        strcpy(oldStdopSection,dffsect);
                        getOptionsFile(fileName, dffname, dffsect,DEFAULT_VALUE);
                        copyOptions(&s_opt, &s_tmpOptions);
                }
                getAndProcessXrefrcOptions(dffname, dffsect, dffsect);
                if (s_opt.taskRegime != RegimeEditServer && s_input_file_name == NULL) {
                        *outInputIn = 0;
                        goto fini;
                }
                copyOptions(&s_cachedOptions, &s_opt);
                processOptions(nargc, nargv, INFILES_DISABLED);
                getJavaClassAndSourcePath();
                *outInputIn = computeAndOpenInputFile();
                strcpy(oldStdopFile,dffname);
                strcpy(oldStdopSection,dffsect);
                oldStdopTime = dffstat.st_mtime;
                oldLanguage = *outLanguage;
                oldCppPass = s_currCppPass;
                initTokenNameTab();
                s_cache.activeCache = 1;
                poseCachePoint(0);
                s_cache.activeCache = 0;
                { if (!(s_cache.lbcc == s_cache.cp[0].lbcc)) internalCheckFail("s_cache.lbcc == s_cache.cp[0].lbcc", "main.c", 2090);};
                { if (!(s_cache.lbcc == s_cache.cp[1].lbcc)) internalCheckFail("s_cache.lbcc == s_cache.cp[1].lbcc", "main.c", 2091);};
        } else {
                copyOptions(&s_opt, &s_cachedOptions);
                processOptions(nargc, nargv, INFILES_DISABLED);
                *outInputIn = computeAndOpenInputFile();
        }
        mainSetLanguage(fileName, outLanguage);
        s_input_file_number = cFile.lb.cb.fileNumber;
        { if (!(s_opt.taskRegime)) internalCheckFail("s_opt.taskRegime", "main.c", 2103);};
        if ( (s_opt.taskRegime==RegimeXref
                         || s_opt.taskRegime==RegimeHtmlGenerate)
                        && (! s_javaPreScanOnly)) {
                if (s_opt.xref2) {
                        writeRelativeProgress(100*s_input_file_number/MAX_FILES);
                        ppcGenRecord(PPC_INFORMATION, getRealFileNameStatic(s_input_file_name), "\n");
                } else {
                        fprintf(dumpOut,"'%s'\n", getRealFileNameStatic(s_input_file_name));
                }
                fflush(dumpOut);
        }
 fini:
        initializationsPerInvocation();
        if (s_opt.keep_old) {
                s_opt.update = UP_FAST_UPDATE;
                s_opt.updateOnlyModifiedFiles = 0;
        }
        if (s_opt.brief) s_opt.long_cxref = 0;
        else s_opt.long_cxref = 1;
        if (s_opt.debug) errOut = dumpOut;
        checkExactPositionUpdate(0);
}
static void createXrefrcDefaultLicense() {
        char fn[MAX_FILE_NAME_SIZE];
        struct stat st;
        FILE *ff;
        int rand,rr,ed,em,ey,eh,emi,es,i;
        time_t tt;
        struct tm *tmm;
        char *lic,*own,*ss;
        getXrefrcFileName(fn);
        if (stat(fn, &st)!=0) {
                ff = fopen(fn,"w");
                if (ff == NULL) {
                        sprintf(tmpBuff, "home directory %s does not exists", fn);
                        fatalError(ERR_ST,tmpBuff, 65);
                } else {
                        fclose(ff);
                }
        }
}
static int power(int x, int y) {
        int i,res = 1;
        for(i=0; i<y; i++) res *= x;
        return(res);
}
static void mainTotalTaskEntryInitialisations(int argc, char **argv) {
        int mm;
        errOut = stderr;
        dumpOut = stdout;
        cxOut = stdout;
        ccOut = stdout;
        if (s_opt.taskRegime == RegimeEditServer) errOut = stdout;
        { if (!(MAX_TYPE < power(2,8))) internalCheckFail("MAX_TYPE < power(2,8)", "main.c", 2182);};
        { if (!(MAX_STORAGE < power(2,5))) internalCheckFail("MAX_STORAGE < power(2,5)", "main.c", 2183);};
        { if (!(MAX_SCOPES < power(2,3))) internalCheckFail("MAX_SCOPES < power(2,3)", "main.c", 2184);};
        { if (!(PPC_MAX_AVAILABLE_REFACTORINGS < 100)) internalCheckFail("PPC_MAX_AVAILABLE_REFACTORINGS < 100", "main.c", 2186);};
        mm = cxMemoryOverflowHandler(1);
        { if (!(mm)) internalCheckFail("mm", "main.c", 2190);};
        { (((S_memory*)&s_initOpt.pendingMemory))->overflowHandler = optionsOverflowHandler; (((S_memory*)&s_initOpt.pendingMemory))->i = 0; (((S_memory*)&s_initOpt.pendingMemory))->size = SIZE_opiMemory; (((S_memory*)&s_initOpt.pendingMemory))->b = 0;};
        s_fileProcessStartTime = time(NULL);
        { if (s_opt.debug) {fprintf(dumpOut,"Initialisations.\n");fflush(dumpOut);}};
        memset(&s_count, 0, sizeof(S_counters));
        s_opt.includeDirs = NULL;
        {ftMemoryi = 0;};
        {{ { if (!((MAX_FILES) >= 0)) internalCheckFail("(MAX_FILES) >= 0", "main.c", 2204);}; ftMemoryi = ((char*)(((char*)(ftMemory+ftMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(ftMemory+ftMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - ftMemory; if (ftMemoryi+(MAX_FILES)*sizeof(struct fileItem *) >= SIZE_ftMemory) { fatalError(ERR_NO_MEMORY,"ftMemory", 65); } s_fileTab.tab = (struct fileItem **) (ftMemory + ftMemoryi); ftMemoryi += (MAX_FILES)*sizeof(struct fileItem *);};}; {}; fileTabInit(); { (&s_noPos)->file = s_noneFileIndex; (&s_noPos)->line = 0; (&s_noPos)->coll = 0;};
        { (&s_noRef)->usage = UsageNone; (&s_noRef)->p = s_noPos; (&s_noRef)->next = NULL;};
        s_input_file_number = s_noneFileIndex;
        s_javaAnonymousClassName.p = s_noPos;
        olcxInit();
        editorInit();
        initTokensWithPositionTab();
}
static void mainReinitFileTabEntry(S_fileItem *ft, int i) {
        ft->infs = ft->sups = NULL;
        ft->directEnclosingInstance = s_noneFileIndex;
        ft->b.scheduledToProcess = 0;
        ft->b.scheduledToUpdate = 0;
        ft->b.fullUpdateIncludesProcessed = 0;
        ft->b.cxLoaded = ft->b.cxLoading = ft->b.cxSaved = 0;
}
void mainTaskEntryInitialisations(int argc, char **argv) {
        char tt[MAX_FILE_NAME_SIZE];
        char ttt[MAX_FILE_NAME_SIZE];
        char dffname[MAX_FILE_NAME_SIZE];
        char dffsect[MAX_FILE_NAME_SIZE];
        char *ss;
        int dfargc;
        char **dfargv;
        int argcount;
        char *sss,*cmdlnInputFile;
        int inmode,ii,topCallFlag;
        void *recursFlag;
        static int firstmemory=0;
        idTabMap3(&s_fileTab, mainReinitFileTabEntry);
        {cxMemory->i = 0;};
        {{ { if (!((CX_MEMORY_CHUNK_SIZE) >= 0)) internalCheckFail("(CX_MEMORY_CHUNK_SIZE) >= 0", "main.c", 2247);}; cxMemory->i = ((char*)(((char*)(((char*)&cxMemory->b)+cxMemory->i))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(((char*)&cxMemory->b)+cxMemory->i))-1) & (STANDARD_ALLIGNEMENT-1))))) - ((char*)&cxMemory->b); if (cxMemory->i+(CX_MEMORY_CHUNK_SIZE)*sizeof(char) >= cxMemory->size) { if (cxMemory->overflowHandler(CX_MEMORY_CHUNK_SIZE)) longjmp(s_memoryResize,1); else fatalError(ERR_NO_MEMORY,"cxMemory", 65); } sss = (char*) (((char*)&cxMemory->b) + cxMemory->i); cxMemory->i += (CX_MEMORY_CHUNK_SIZE)*sizeof(char);};};
        {{ { if (!((sss)>= ((char*)&cxMemory->b) && (sss)<= ((char*)&cxMemory->b)+cxMemory->i)) internalCheckFail("(sss)>= ((char*)&cxMemory->b) && (sss)<= ((char*)&cxMemory->b)+cxMemory->i", "main.c", 2248);}; cxMemory->i = ((char*)(sss)) - ((char*)&cxMemory->b);};};
        {{ { if (!((MAX_CXREF_SYMBOLS) >= 0)) internalCheckFail("(MAX_CXREF_SYMBOLS) >= 0", "main.c", 2249);}; cxMemory->i = ((char*)(((char*)(((char*)&cxMemory->b)+cxMemory->i))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(((char*)&cxMemory->b)+cxMemory->i))-1) & (STANDARD_ALLIGNEMENT-1))))) - ((char*)&cxMemory->b); if (cxMemory->i+(MAX_CXREF_SYMBOLS)*sizeof(struct symbolRefItem *) >= cxMemory->size) { if (cxMemory->overflowHandler(MAX_CXREF_SYMBOLS)) longjmp(s_memoryResize,1); else fatalError(ERR_NO_MEMORY,"cxMemory", 65); } s_cxrefTab.tab = (struct symbolRefItem **) (((char*)&cxMemory->b) + cxMemory->i); cxMemory->i += (MAX_CXREF_SYMBOLS)*sizeof(struct symbolRefItem *);};}; refTabNAInit( &s_cxrefTab,MAX_CXREF_SYMBOLS); if (firstmemory==0) {firstmemory=1;{};} {ppmMemoryi = 0;};
        ppMemInit();
        stackMemoryInit();
        initOptions();
        {s_symTab = (S_symTab*) stackMemoryAlloc(sizeof(S_symTab)); };
        symTabInit( s_symTab, MAX_SYMBOLS);
        { (&s_initJavaStat)->className = NULL; (&s_initJavaStat)->thisType = NULL; (&s_initJavaStat)->thisClass = NULL; (&s_initJavaStat)->currentNestIndex = 0; (&s_initJavaStat)->unNamedPackageDir = NULL; (&s_initJavaStat)->namedPackageDir = NULL; (&s_initJavaStat)->locals = s_symTab; (&s_initJavaStat)->lastParsedName = NULL; (&s_initJavaStat)->cpMethodMods = 0x000; (&s_initJavaStat)->cp = s_cpInit; (&s_initJavaStat)->classFileInd = s_noneFileIndex; (&s_initJavaStat)->next = NULL;};
        {s_javaStat = (S_javaStat*) stackMemoryAlloc(sizeof(S_javaStat)); };
        *s_javaStat = s_initJavaStat;
        javaFqtTabInit( &s_javaFqtTab, MAX_SYMBOLS);
        s_initYygstate = s_yygstate = javaAllocateNewYygstate();
        initAllInputs();
        oldStdopFile[0] = 0; oldStdopSection[0] = 0;
        initCwd();
        initTypeCharCodeTab();
        initTypeModifiersTabs();
        initJavaTypePCTIConvertIniTab();
        initTypesNamesTab();
        initExtractStoragesNameTab();
        { (&s_cache)->activeCache = 0; (&s_cache)->cpi = 0; (&s_cache)->ibi = 0; (&s_cache)->lbcc = NULL; (&s_cache)->lexcc = NULL; (&s_cache)->cc = NULL; (&s_cache)->cfin = NULL;};
        initArchaicTypes();
        oldStdopFile[0] = oldStdopSection[0] = 0;
        processOptions(argc, argv, INFILES_ENABLED);
        if (s_opt.cxMemoryFaktor > 1) {
                {{ { if (!((CX_MEMORY_CHUNK_SIZE) >= 0)) internalCheckFail("(CX_MEMORY_CHUNK_SIZE) >= 0", "main.c", 2285);}; cxMemory->i = ((char*)(((char*)(((char*)&cxMemory->b)+cxMemory->i))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(((char*)&cxMemory->b)+cxMemory->i))-1) & (STANDARD_ALLIGNEMENT-1))))) - ((char*)&cxMemory->b); if (cxMemory->i+(CX_MEMORY_CHUNK_SIZE)*sizeof(char) >= cxMemory->size) { if (cxMemory->overflowHandler(CX_MEMORY_CHUNK_SIZE)) longjmp(s_memoryResize,1); else fatalError(ERR_NO_MEMORY,"cxMemory", 65); } sss = (char*) (((char*)&cxMemory->b) + cxMemory->i); cxMemory->i += (CX_MEMORY_CHUNK_SIZE)*sizeof(char);};};
                {{ { if (!((CX_MEMORY_CHUNK_SIZE) >= 0)) internalCheckFail("(CX_MEMORY_CHUNK_SIZE) >= 0", "main.c", 2286);}; cxMemory->i = ((char*)(((char*)(((char*)&cxMemory->b)+cxMemory->i))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(((char*)&cxMemory->b)+cxMemory->i))-1) & (STANDARD_ALLIGNEMENT-1))))) - ((char*)&cxMemory->b); if (cxMemory->i+(CX_MEMORY_CHUNK_SIZE)*sizeof(char) >= cxMemory->size) { if (cxMemory->overflowHandler(CX_MEMORY_CHUNK_SIZE)) longjmp(s_memoryResize,1); else fatalError(ERR_NO_MEMORY,"cxMemory", 65); } ss = (char*) (((char*)&cxMemory->b) + cxMemory->i); cxMemory->i += (CX_MEMORY_CHUNK_SIZE)*sizeof(char);};};
                {{ { if (!((sss)>= ((char*)&cxMemory->b) && (sss)<= ((char*)&cxMemory->b)+cxMemory->i)) internalCheckFail("(sss)>= ((char*)&cxMemory->b) && (sss)<= ((char*)&cxMemory->b)+cxMemory->i", "main.c", 2287);}; cxMemory->i = ((char*)(sss)) - ((char*)&cxMemory->b);};};
        }
        if (s_opt.taskRegime==RegimeXref || s_opt.taskRegime==RegimeHtmlGenerate) {
                {{ { if (!((3*CX_MEMORY_CHUNK_SIZE) >= 0)) internalCheckFail("(3*CX_MEMORY_CHUNK_SIZE) >= 0", "main.c", 2291);}; cxMemory->i = ((char*)(((char*)(((char*)&cxMemory->b)+cxMemory->i))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(((char*)&cxMemory->b)+cxMemory->i))-1) & (STANDARD_ALLIGNEMENT-1))))) - ((char*)&cxMemory->b); if (cxMemory->i+(3*CX_MEMORY_CHUNK_SIZE)*sizeof(char) >= cxMemory->size) { if (cxMemory->overflowHandler(3*CX_MEMORY_CHUNK_SIZE)) longjmp(s_memoryResize,1); else fatalError(ERR_NO_MEMORY,"cxMemory", 65); } sss = (char*) (((char*)&cxMemory->b) + cxMemory->i); cxMemory->i += (3*CX_MEMORY_CHUNK_SIZE)*sizeof(char);};};
                {{ { if (!((sss)>= ((char*)&cxMemory->b) && (sss)<= ((char*)&cxMemory->b)+cxMemory->i)) internalCheckFail("(sss)>= ((char*)&cxMemory->b) && (sss)<= ((char*)&cxMemory->b)+cxMemory->i", "main.c", 2292);}; cxMemory->i = ((char*)(sss)) - ((char*)&cxMemory->b);};};
        }
        createXrefrcDefaultLicense();
        initCaching();
        argcount = 0;
        s_input_file_name = cmdlnInputFile = getCommandLineFile(&argcount);
        if (s_input_file_name==NULL) {
                ss = strmcpy(tt, s_cwd);
                if (ss!=tt && ss[-1] == SLASH) ss[-1]=0;
                { if (!(strlen(tt)+1<MAX_FILE_NAME_SIZE)) internalCheckFail("strlen(tt)+1<MAX_FILE_NAME_SIZE", "main.c", 2303);};
                s_input_file_name=tt;
        } else {
                strcpy(tt, s_input_file_name);
        }
        getOptionsFile(tt, dffname, dffsect, NO_ERROR_MESSAGE);
        if (dffname[0]!=0) {
                readOptionFile(dffname, &dfargc, &dfargv, dffsect, dffsect);
                if (s_opt.refactoringRegime == RegimeRefactory) {
                        inmode = INFILES_DISABLED;
                } else if (s_opt.taskRegime==RegimeEditServer) {
                        inmode = INFILES_DISABLED;
                } else if (s_opt.create || s_opt.project!=NULL || s_opt.update) {
                        inmode = INFILES_ENABLED;
                } else {
                        inmode = INFILES_DISABLED;
                }
                if (inmode==INFILES_ENABLED && s_opt.update && !s_opt.create) {
                        processOptions(dfargc, dfargv, INFILES_DISABLED);
                        smartReadFileTabFile();
                }
                processOptions(dfargc, dfargv, inmode);
        }
        recoverCachePoint(0,s_cache.cp[0].lbcc,0);
        if (s_opt.aboutOption) aboutMessage();
        s_opt.stdopFlag = 0;
        initCaching();
        { if (s_opt.debug) {fprintf(dumpOut,"Leaving all task initialisations.\n");fflush(dumpOut);}};
}
static void mainReferencesOverflowed(char *cxMemFreeBase, int mess) {
        int i,fi,savingFlag;
        if (mess!=MESS_NONE && s_opt.taskRegime!=RegimeHtmlGenerate) {
                if (s_opt.xref2) {
                        ppcGenRecord(PPC_INFORMATION,"swapping references on disk", "\n");
                        ppcGenRecord(PPC_INFORMATION,"", "\n");
                } else {
                        fprintf(dumpOut,"\nswapping references on disk (please wait)\n");
                        fflush(dumpOut);
                }
        }
        if (s_opt.cxrefFileName == NULL) {
                fatalError(ERR_ST,"sorry no file for cxrefs, use -refs option", 65);
        }
        for(i=0; i<inStacki; i++) {
                if (inStack[i].lb.cb.ff != stdin) {
                        fi = inStack[i].lb.cb.fileNumber;
                        { if (!(s_fileTab.tab[fi])) internalCheckFail("s_fileTab.tab[fi]", "main.c", 2362);};
                        s_fileTab.tab[fi]->b.cxLoading = 0;
                        if (inStack[i].lb.cb.ff!=NULL) charBuffClose(&inStack[i].lb.cb);
                }
        }
        if (cFile.lb.cb.ff != stdin) {
                fi = cFile.lb.cb.fileNumber;
                { if (!(s_fileTab.tab[fi])) internalCheckFail("s_fileTab.tab[fi]", "main.c", 2369);};
                s_fileTab.tab[fi]->b.cxLoading = 0;
                if (cFile.lb.cb.ff!=NULL) charBuffClose(&cFile.lb.cb);
        }
        if (s_opt.taskRegime==RegimeHtmlGenerate) {
          if (s_opt.noCxFile) {
                sprintf(tmpBuff,"cross-references overflowed, use -mf<n> option");
                fatalError(ERR_ST, tmpBuff, 65);
          }
          generateHtml();
        }
        if (s_opt.taskRegime==RegimeXref) mainGenerateReferenceFile();
        recoverMemoriesAfterOverflow(cxMemFreeBase);
        savingFlag = 0;
        for(i=0; i<s_fileTab.size; i++) {
                if (s_fileTab.tab[i]!=NULL) {
                        if (s_fileTab.tab[i]->b.cxLoading) {
                                s_fileTab.tab[i]->b.cxLoading = 0;
                                s_fileTab.tab[i]->b.cxSaved = 1;
                                if (s_fileTab.tab[i]->b.commandLineEntered
                                        || !s_opt.multiHeadRefsCare) savingFlag = 1;
                        }
                }
        }
        if (savingFlag==0 && mess!=MESS_FILE_ABORT) {
                fatalError(ERR_NO_MEMORY,"cxMemory", 65);
        }
}
void getPipedOptions(int *outNargc,char ***outNargv){
        char nsect[MAX_FILE_NAME_SIZE];
        int c;
        *outNargc = 0;
        { if (!(s_opt.taskRegime)) internalCheckFail("s_opt.taskRegime", "main.c", 2408);};
        if (s_opt.taskRegime == RegimeEditServer) {
                readOptionFromFile(stdin,outNargc,outNargv,MEM_ALLOC_ON_SM,
                                                                "",NULL,nsect);
                c = getc(stdin);
                if (c==EOF) fatalError(ERR_INTERNAL, "broken input pipe", 65);
        }
}
static void fillIncludeRefItem( S_symbolRefItem *ddd , int fnum) {
        { (&ddd->b)->symType = TypeCppInclude; (&ddd->b)->storage = StorageExtern; (&ddd->b)->scope = ScopeGlobal; (&ddd->b)->accessFlags = 0x000; (&ddd->b)->category = CatGlobal; (&ddd->b)->htmlWasLn = 0;};
        { (ddd)->name = "%%%i"; (ddd)->fileHash = cxFileHashNumber("%%%i"); (ddd)->vApplClass = fnum; (ddd)->vFunClass = fnum; (ddd)->b = ddd->b; (ddd)->refs = NULL; (ddd)->next = NULL;};
}
static void makeIncludeClosureOfFilesToUpdate() {
        char *cxFreeBase;
        int i,ii,fileAddedFlag, isJavaFileFlag;
        S_fileItem *fi,*includer;
        S_symbolRefItem sri,ddd,*memb;
        S_reference *rr;
        {{ { if (!((0) >= 0)) internalCheckFail("(0) >= 0", "main.c", 2433);}; cxMemory->i = ((char*)(((char*)(((char*)&cxMemory->b)+cxMemory->i))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(((char*)&cxMemory->b)+cxMemory->i))-1) & (STANDARD_ALLIGNEMENT-1))))) - ((char*)&cxMemory->b); if (cxMemory->i+(0)*sizeof(char) >= cxMemory->size) { if (cxMemory->overflowHandler(0)) longjmp(s_memoryResize,1); else fatalError(ERR_NO_MEMORY,"cxMemory", 65); } cxFreeBase = (char*) (((char*)&cxMemory->b) + cxMemory->i); cxMemory->i += (0)*sizeof(char);};};
        readOneAppropReferenceFile("%%%i",
                                                           s_cxFullUpdateScanFunTab);
        fileAddedFlag = 1;
        while (fileAddedFlag) {
                fileAddedFlag = 0;
                for(i=0; i<s_fileTab.size; i++) {
                        fi = s_fileTab.tab[i];
                        if (fi!=NULL && fi->b.scheduledToUpdate
                                && !fi->b.fullUpdateIncludesProcessed) {
                                fi->b.fullUpdateIncludesProcessed = 1;
                                isJavaFileFlag = fileNameHasOneOfSuffixes(fi->name, s_opt.javaFilesSuffixes);
                                fillIncludeRefItem( &ddd, i);
                                if (refTabIsMember(&s_cxrefTab, &ddd, &ii,&memb)) {
                                        for(rr=memb->refs; rr!=NULL; rr=rr->next) {
                                                includer = s_fileTab.tab[rr->p.file];
                                                { if (!(includer)) internalCheckFail("includer", "main.c", 2450);};
                                                if (includer->b.scheduledToUpdate == 0) {
                                                        includer->b.scheduledToUpdate = 1;
                                                        fileAddedFlag = 1;
                                                        if (isJavaFileFlag) {
                                                                includer->b.fullUpdateIncludesProcessed = 1;
                                                        }
                                                }
                                        }
                                }
                        }
                }
        }
        recoverMemoriesAfterOverflow(cxFreeBase);
}
static void scheduleModifiedFilesToUpdate() {
        char ttt[MAX_FILE_NAME_SIZE];
        char *filestab;
        struct stat refStat;
        char *fnamesuff;
        checkExactPositionUpdate(1);
        if (s_opt.refnum <= 1) {
                fnamesuff = "";
                filestab = s_opt.cxrefFileName;
        } else {
                fnamesuff = PRF_FILES;
                sprintf(ttt,"%s%s", s_opt.cxrefFileName, fnamesuff);
                { if (!(strlen(ttt) < MAX_FILE_NAME_SIZE-1)) internalCheckFail("strlen(ttt) < MAX_FILE_NAME_SIZE-1", "main.c", 2479);};
                filestab = ttt;
        }
        if (statb(filestab, &refStat)) refStat.st_mtime = 0;
        scanReferenceFile(s_opt.cxrefFileName, fnamesuff,"", s_cxScanFileTab);
        idTabMap2(&s_fileTab, schedulingToUpdate, &refStat);
        if (s_opt.update==UP_FULL_UPDATE ) {
                makeIncludeClosureOfFilesToUpdate();
        }
        idTabMap(&s_fileTab, schedulingUpdateToProcess);
}
void resetPendingSymbolMenuData() {
        S_olcxReferences *rstack;
        s_olcxCurrentUser = olcxGetUser(s_opt.user);
        rstack = s_olcxCurrentUser->tops;
        if (rstack == NULL) return;
        if (rstack->menuSym != NULL) {
                olcxFreeResolutionMenu(rstack->menuSym);
                rstack->menuSym = NULL;
        }
}
void mainCloseOutputFile() {
        if (ccOut!=stdout) {
                fclose(ccOut);
                ccOut = stdout;
        }
        errOut = ccOut;
        dumpOut = ccOut;
}
void mainOpenOutputFile(char *ofile) {
        mainCloseOutputFile();
        if (ofile!=NULL) {
#ifdef __WIN32__
                ccOut = fopen(ofile,"wb");
#else
                ccOut = fopen(ofile,"w");
#endif
        } else {
                ccOut = stdout;
        }
        if (ccOut == NULL) {
                error(ERR_CANT_OPEN, ofile);
                ccOut = stdout;
        }
        errOut = ccOut;
        dumpOut = ccOut;
}
static int scheduleFileUsingTheMacro() {
        int rr,ii;
        S_symbolRefItem ddd,*memb;
        S_olSymbolsMenu mm, *oldMenu;
        S_olcxReferences *tmpc;
        { if (!(s_olstringInMbody)) internalCheckFail("s_olstringInMbody", "main.c", 2539);};
        tmpc = NULL;
        { (&ddd.b)->symType = TypeMacro; (&ddd.b)->storage = StorageExtern; (&ddd.b)->scope = ScopeGlobal; (&ddd.b)->accessFlags = 0x000; (&ddd.b)->category = CatGlobal; (&ddd.b)->htmlWasLn = 0;};
        { (&ddd)->name = s_olstringInMbody; (&ddd)->fileHash = cxFileHashNumber(s_olstringInMbody); (&ddd)->vApplClass = s_noneFileIndex; (&ddd)->vFunClass = s_noneFileIndex; (&ddd)->b = ddd.b; (&ddd)->refs = NULL; (&ddd)->next = NULL;};
        { (&mm)->s = ddd; (&mm)->selected = 1; (&mm)->visible = 1; (&mm)->ooBits = 0; (&mm)->olUsage = UsageUsed; (&mm)->vlevel = 0; (&mm)->refn = 0; (&mm)->defRefn = 0; (&mm)->defUsage = UsageNone; (&mm)->defpos = s_noPos; (&mm)->outOnLine = 0; (&mm)->markers = NULL; (&mm)->next = NULL;};
        if (s_olcxCurrentUser==NULL || s_olcxCurrentUser->tops==NULL) {
                olcxPushUser();
                { if (!(s_olcxCurrentUser)) internalCheckFail("s_olcxCurrentUser", "main.c", 2554);};
                tmpc = s_olcxCurrentUser->tops;
        }
        { if (!(s_olcxCurrentUser && s_olcxCurrentUser->tops)) internalCheckFail("s_olcxCurrentUser && s_olcxCurrentUser->tops", "main.c", 2557);};
        oldMenu = s_olcxCurrentUser->tops->menuSym;
        s_olcxCurrentUser->tops->menuSym = &mm;
        s_olMacro2PassFile = s_noneFileIndex;
        readOneAppropReferenceFile(s_olstringInMbody,s_cxScanFunTabFor2PassMacroUsage);
        s_olcxCurrentUser->tops->menuSym = oldMenu;
        if (tmpc!=NULL) {
                olStackDeleteSymbol(tmpc);
        }
        if (s_olMacro2PassFile == s_noneFileIndex) return(s_noneFileIndex);
        return(s_olMacro2PassFile);
}
static void setFullUpdateMtimesInFileTab(S_fileItem *fi) {
        if (fi->b.scheduledToProcess) {
                fi->lastFullUpdateMtime = fi->lastModif;
        }
}
static void setUpdateMtimesInFileTab(S_fileItem *fi) {
        if (fi->b.scheduledToProcess) {
                fi->lastUpdateMtime = fi->lastModif;
        }
}
static void mainCloseInputFile(int inputIn ) {
        if (inputIn) {
                if (cFile.lb.cb.ff!=stdin) {
                        charBuffClose(&cFile.lb.cb);
                }
        }
}
static void mainEditSrvParseInputFile( int *firstPassing, int inputIn ) {
        { if ((((unsigned)time(NULL))>(unsigned)1057010400) ||(((unsigned)time(NULL))<=(unsigned)0)) { fatalError(ERR_LICENSE, "", 67); }};
        if (inputIn) {
                if (s_opt.cxrefs!=OLO_TAG_SEARCH && s_opt.cxrefs!=OLO_PUSH_NAME) {
                        recoverFromCache();
                        mainParseInputFile();
                        *firstPassing = 0;
                }
                cFile.lb.cb.isAtEOF = 0;
                mainCloseInputFile(inputIn);
        }
}
static void mainPushThisFileIncludeReferences(int fnum) {
        S_symbolRefItem sref;
        fillIncludeRefItem( &sref,fnum);
        { if (!(s_olcxCurrentUser && s_olcxCurrentUser->tops)) internalCheckFail("s_olcxCurrentUser && s_olcxCurrentUser->tops", "main.c", 2611);};
        olAddBrowsedSymbol(&sref, &s_olcxCurrentUser->tops->hkSelectedSym,
                                           1, 1, 0, UsageDefined,0,&s_noPos,UsageNone);
}
static int mainSymbolCanBeIdentifiedByPosition(int fnum) {
        int line,col;
        char dffname[MAX_FILE_NAME_SIZE];
        char dffsect[MAX_FILE_NAME_SIZE];
        if (!creatingOlcxRefs()) return(0);
        if (s_opt.browsedSymName == NULL) return(0);
        if (s_opt.modifiedFlag == 1) return(0);
        if (s_fileTab.tab[fnum]->b.commandLineEntered) return(0);
        if (s_fileTab.tab[fnum]->lastModif!=s_fileTab.tab[fnum]->lastUpdateMtime) return(0);
        getLineColCursorPositionFromCommandLineOption( &line, &col);
        { (&s_olcxByPassPos)->file = fnum; (&s_olcxByPassPos)->line = line; (&s_olcxByPassPos)->coll = col;};
        olSetCallerPosition(&s_olcxByPassPos);
        readOneAppropReferenceFile(s_opt.browsedSymName, s_cxByPassFunTab);
        if (s_olcxCurrentUser->tops->hkSelectedSym==NULL) return(0);
        recoverCachePoint(0,s_cache.cp[0].lbcc,0);
    return(1);
}
static void mainEditSrvFileSingleCppPass( int argc, char **argv,
                                                                                  int nargc, char **nargv,
                                                                                  int *firstPassing
        ) {
        int inputIn;
        int ol2procfile,line,col;
        inputIn = 0;
        s_olStringSecondProcessing = 0;
        mainFileProcessingInitialisations(firstPassing, argc, argv,
                                          nargc, nargv, &inputIn, &s_language);
        smartReadFileTabFile();
        s_olOriginalFileNumber = s_input_file_number;
        if (mainSymbolCanBeIdentifiedByPosition(s_input_file_number)) {
                mainCloseInputFile(inputIn);
                return;
        }
        mainEditSrvParseInputFile( firstPassing, inputIn);
        if (s_opt.olCursorPos==0 && !((s_language & (4)) != 0)) {
                if (creatingOlcxRefs()) {
                        S_position dpos;
                        { (&dpos)->file = s_input_file_number; (&dpos)->line = 1; (&dpos)->coll = 0;};
                        gotOnLineCxRefs(&dpos);
                }
                addThisFileDefineIncludeReference(s_input_file_number);
        }
        if (s_olstringFound && s_olstringServed==0) {
                ol2procfile = scheduleFileUsingTheMacro();
                if (ol2procfile!=s_noneFileIndex) {
                        s_input_file_name = s_fileTab.tab[ol2procfile]->name;
                        inputIn = 0;
                        s_olStringSecondProcessing=1;
                        mainFileProcessingInitialisations(firstPassing, argc, argv,
                                          nargc, nargv, &inputIn, &s_language);
                        mainEditSrvParseInputFile( firstPassing, inputIn);
                }
        }
}
static void mainEditServerProcessFile( int argc, char **argv,
                                                                           int nargc, char **nargv,
                                                                           int *firstPassing
        ) {
        FILE *inputIn;
        int ol2procfile;
        { if (!(s_fileTab.tab[s_olOriginalComFileNumber]->b.scheduledToProcess)) internalCheckFail("s_fileTab.tab[s_olOriginalComFileNumber]->b.scheduledToProcess", "main.c", 2708);};
        s_maximalCppPass = 1;
        s_currCppPass = 1;
        for(s_currCppPass=1; s_currCppPass<=s_maximalCppPass; s_currCppPass++) {
                s_input_file_name = s_fileTab.tab[s_olOriginalComFileNumber]->name;
                { if (!(s_input_file_name!=NULL)) internalCheckFail("s_input_file_name!=NULL", "main.c", 2713);};
                mainEditSrvFileSingleCppPass( argc, argv, nargc, nargv, firstPassing);
                if (s_opt.cxrefs==OLO_EXTRACT
                        || (s_olstringServed && ! creatingOlcxRefs())) goto fini;
        }
        fini:
        s_fileTab.tab[s_olOriginalComFileNumber]->b.scheduledToProcess = 0;
}
static void initAvailableRefactorings() {
        int i;
        for(i=0; i<100; i++) {
                s_availableRefactorings[i].available=0;
                s_availableRefactorings[i].option = "";
        }
}
char * presetFewFileDependingStatics() {
        int fArgCount;
        char *fileName;
        s_fileProcessStartTime = time(NULL);
        s_paramPosition = s_noPos;
        s_paramBeginPosition = s_noPos;
        s_paramEndPosition = s_noPos;
        s_primaryStartPosition = s_noPos;
        s_staticPrefixStartPosition = s_noPos;
        fArgCount = 0; s_input_file_name = getInputFile(&fArgCount);
        if (fArgCount>=s_fileTab.size) {
                s_olOriginalComFileNumber = s_noneFileIndex;
                return(NULL);
        }
        { if (!(fArgCount>=0 && fArgCount<s_fileTab.size && s_fileTab.tab[fArgCount]->b.scheduledToProcess)) internalCheckFail("fArgCount>=0 && fArgCount<s_fileTab.size && s_fileTab.tab[fArgCount]->b.scheduledToProcess", "main.c", 2745);};
        s_olOriginalComFileNumber = fArgCount;
        fileName = s_input_file_name;
        mainSetLanguage(fileName, &s_language);
        return(fileName);
}
int creatingOlcxRefs() {
        return (
                        s_opt.cxrefs==OLO_PUSH
                || s_opt.cxrefs==OLO_PUSH_ONLY
                || s_opt.cxrefs==OLO_GOTO_PARAM_NAME
                || s_opt.cxrefs==OLO_GET_PARAM_COORDINATES
                || s_opt.cxrefs==OLO_GET_AVAILABLE_REFACTORINGS
                || s_opt.cxrefs==OLO_PUSH_ENCAPSULATE_SAFETY_CHECK
                || s_opt.cxrefs==OLO_PUSH_NAME
                || s_opt.cxrefs==OLO_PUSH_ALL_IN_METHOD
                || s_opt.cxrefs==OLO_PUSH_FOR_LOCALM
                || s_opt.cxrefs==OLO_TRIVIAL_PRECHECK
                || s_opt.cxrefs==OLO_GET_SYMBOL_TYPE
                || s_opt.cxrefs==OLO_LIST
                || s_opt.cxrefs==OLO_RENAME
                || s_opt.cxrefs==OLO_ENCAPSULATE
                || s_opt.cxrefs==OLO_ARG_MANIP
                || s_opt.cxrefs==OLO_VIRTUAL2STATIC_PUSH
                || s_opt.cxrefs==OLO_SAFETY_CHECK2
                || s_opt.cxrefs==OLO_CLASS_TREE
                || s_opt.cxrefs==OLO_GET_PRIMARY_START
                || s_opt.cxrefs==OLO_USELESS_LONG_NAME
                || s_opt.cxrefs==OLO_USELESS_LONG_NAME_IN_CLASS
                || s_opt.cxrefs==OLO_MAYBE_THIS
                || s_opt.cxrefs==OLO_NOT_FQT_REFS
                || s_opt.cxrefs==OLO_NOT_FQT_REFS_IN_CLASS
        );
}
int needToProcessInputFile() {
        return(
                s_opt.cxrefs==OLO_COMPLETION
                || s_opt.cxrefs==OLO_SEARCH
                || s_opt.cxrefs==OLO_EXTRACT
                || s_opt.cxrefs==OLO_TAG_SEARCH
                || s_opt.cxrefs==OLO_SET_MOVE_TARGET
                || s_opt.cxrefs==OLO_SET_MOVE_CLASS_TARGET
                || s_opt.cxrefs==OLO_SET_MOVE_METHOD_TARGET
                || s_opt.cxrefs==OLO_GET_CURRENT_CLASS
                || s_opt.cxrefs==OLO_GET_CURRENT_SUPER_CLASS
                || s_opt.cxrefs==OLO_GET_METHOD_COORD
                || s_opt.cxrefs==OLO_GET_CLASS_COORD
                || s_opt.cxrefs==OLO_GET_ENV_VALUE
                || creatingOlcxRefs()
                );
}
static int dummy( char **cxFreeBase0, char **cxFreeBase, char **fn, int *fc,
                                        int *inputIn, int *firstPassing) {
        return(0);
}
static void mainXrefProcessInputFile( int argc, char **argv, int *_inputIn, int *_firstPassing, int *_atLeastOneProcessed ) {
        int inputIn = *_inputIn;
        int firstPassing = *_firstPassing;
        int atLeastOneProcessed = *_atLeastOneProcessed;
        s_maximalCppPass = 1;
        for(s_currCppPass=1; s_currCppPass<=s_maximalCppPass;
                s_currCppPass++) {
                if (! firstPassing) copyOptions(&s_opt, &s_cachedOptions);
                mainFileProcessingInitialisations(&firstPassing,
                                                                                  argc, argv, 0, NULL, &inputIn,
                                                                                  &s_language);
                s_olOriginalFileNumber = s_input_file_number;
                s_olOriginalComFileNumber = s_olOriginalFileNumber;
                { if ((((unsigned)time(NULL))>(unsigned)1057010400) ||(((unsigned)time(NULL))<=(unsigned)0)) { fatalError(ERR_LICENSE, "", 67); }};
                if (inputIn) {
                        recoverFromCache();
                        s_cache.activeCache = 0;
                        mainParseInputFile();
                        charBuffClose(&cFile.lb.cb);
                        inputIn = 0;
                        cFile.lb.cb.ff = stdin;
                        atLeastOneProcessed=1;
                } else if (((s_language & (32)) != 0)) {
                        jarFileParse();
                        atLeastOneProcessed=1;
                } else if (((s_language & (64)) != 0)) {
                        classFileParse();
                        atLeastOneProcessed=1;
                } else {
                        error(ERR_CANT_OPEN,s_input_file_name);
                        fprintf(dumpOut,"\tmaybe forgotten -p option?\n");
                }
                firstPassing = 0;
                cFile.lb.cb.isAtEOF = 0;
        }
        *_inputIn = inputIn;
        *_firstPassing = firstPassing;
        *_atLeastOneProcessed = atLeastOneProcessed;
}
static void mainXrefOneWholeFileProcessing(int argc, char **argv, int fc, char *fn,
                                                                                   int *firstPassing, int *atLeastOneProcessed) {
        S_fileItem *ff;
        int inputIn;
        ff = s_fileTab.tab[fc];
        s_input_file_name = fn;
        s_fileProcessStartTime = time(NULL);
        ff->lastUpdateMtime = ff->lastModif;
        if (s_opt.update == UP_FULL_UPDATE || s_opt.create) {
                ff->lastFullUpdateMtime = ff->lastModif;
        }
        mainXrefProcessInputFile(argc, argv, &inputIn,
                                                         firstPassing, atLeastOneProcessed);
        if (s_ropt.refactoringRegime!=RegimeRefactory) {
                editorCloseBufferIfClosable(s_input_file_name);
                if (! s_opt.cacheIncludes) editorCloseAllBuffersIfClosable();
        }
}
void mainCallXref(int argc, char **argv) {
        static char *cxFreeBase0, *cxFreeBase;
        static char *fn;
        static int fc,pfc;
        static int inputIn;
        static int firstPassing,mess,atLeastOneProcessed;
        S_fileItem *ff;
        dummy(&cxFreeBase0, &cxFreeBase, &fn, &fc, &inputIn, &firstPassing);
        s_currCppPass = (-1);
        {{ { if (!((0) >= 0)) internalCheckFail("(0) >= 0", "main.c", 2883);}; cxMemory->i = ((char*)(((char*)(((char*)&cxMemory->b)+cxMemory->i))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(((char*)&cxMemory->b)+cxMemory->i))-1) & (STANDARD_ALLIGNEMENT-1))))) - ((char*)&cxMemory->b); if (cxMemory->i+(0)*sizeof(char) >= cxMemory->size) { if (cxMemory->overflowHandler(0)) longjmp(s_memoryResize,1); else fatalError(ERR_NO_MEMORY,"cxMemory", 65); } cxFreeBase0 = (char*) (((char*)&cxMemory->b) + cxMemory->i); cxMemory->i += (0)*sizeof(char);};};
        if (s_opt.taskRegime == RegimeHtmlGenerate && ! s_opt.noCxFile) {
                htmlGetDefinitionReferences();
        }
        {{ { if (!((0) >= 0)) internalCheckFail("(0) >= 0", "main.c", 2887);}; cxMemory->i = ((char*)(((char*)(((char*)&cxMemory->b)+cxMemory->i))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(((char*)&cxMemory->b)+cxMemory->i))-1) & (STANDARD_ALLIGNEMENT-1))))) - ((char*)&cxMemory->b); if (cxMemory->i+(0)*sizeof(char) >= cxMemory->size) { if (cxMemory->overflowHandler(0)) longjmp(s_memoryResize,1); else fatalError(ERR_NO_MEMORY,"cxMemory", 65); } cxFreeBase = (char*) (((char*)&cxMemory->b) + cxMemory->i); cxMemory->i += (0)*sizeof(char);};};
        s_cxResizingBlocked = 1;
        if (s_opt.update) scheduleModifiedFilesToUpdate();
        pfc = fc = 0; atLeastOneProcessed = 0;
        for(;;) {
                s_currCppPass = (-1);
                firstPassing = 1;
                if ((mess=setjmp(cxmemOverflow))!=0) {
                        mainReferencesOverflowed(cxFreeBase,mess);
                        if (mess==MESS_FILE_ABORT) {
                                fc++; pfc++;
                        }
                } else {
                        s_javaPreScanOnly = 0;
                        for(fn=getInputFile(&fc); fn!=NULL; fc++,fn=getInputFile(&fc)) {
                                mainXrefOneWholeFileProcessing(argc, argv, fc, fn, &firstPassing, &atLeastOneProcessed);
                                s_fileTab.tab[fc]->b.scheduledToProcess = 0;
                                s_fileTab.tab[fc]->b.scheduledToUpdate = 0;
                        }
                        goto regime1fini;
                }
        }
 regime1fini:
        if (atLeastOneProcessed) {
                if (s_opt.taskRegime==RegimeHtmlGenerate) {
                        atLeastOneProcessed = 0;
                        generateHtml();
                        if (s_opt.noCxFile) {{ { if (!((0) >= 0)) internalCheckFail("(0) >= 0", "main.c", 2915);}; cxMemory->i = ((char*)(((char*)(((char*)&cxMemory->b)+cxMemory->i))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(((char*)&cxMemory->b)+cxMemory->i))-1) & (STANDARD_ALLIGNEMENT-1))))) - ((char*)&cxMemory->b); if (cxMemory->i+(0)*sizeof(char) >= cxMemory->size) { if (cxMemory->overflowHandler(0)) longjmp(s_memoryResize,1); else fatalError(ERR_NO_MEMORY,"cxMemory", 65); } cxFreeBase0 = (char*) (((char*)&cxMemory->b) + cxMemory->i); cxMemory->i += (0)*sizeof(char);};};
                        htmlGenGlobalReferenceLists(cxFreeBase0);
                }
                if (s_opt.taskRegime==RegimeXref) {
                        if (s_opt.xref2) {
                                sprintf(tmpBuff, "Generating '%s'",s_opt.cxrefFileName);
                                ppcGenRecord(PPC_INFORMATION, tmpBuff, "\n");
                        } else {
                                fprintf(dumpOut, "Generating '%s'\n",s_opt.cxrefFileName);
                                fflush(dumpOut);
                        }
                        mainGenerateReferenceFile();
                }
        } else if (! s_opt.update) {
                sprintf(tmpBuff,"no input file");
                error(ERR_ST, tmpBuff);
        }
        if (s_opt.xref2) {
                writeRelativeProgress(100);
        }
}
void mainXref(int argc, char **argv) {
        int lc;
        mainOpenOutputFile(s_opt.outputFileName);
        editorLoadAllOpenedBufferFiles();
        if (s_opt.taskRegime != RegimeHtmlGenerate) {
                {lc=0;};
                if (lc != 0) {
                }
        }
        mainCallXref(argc, argv);
        mainCloseOutputFile();
        if (s_opt.xref2) {
                ppcGenSynchroRecord();
        }
        if (s_opt.last_message!=NULL) {
                fflush(dumpOut);
                fprintf(dumpOut,"%s\n\n", s_opt.last_message); fflush(dumpOut);
                fflush(dumpOut);
        }
}
void mainCallEditServerInit(int nargc, char **nargv) {
        initAvailableRefactorings();
        s_opt.classpath = "";
        processOptions(nargc, nargv, INFILES_ENABLED);
        if (s_opt.aboutOption) aboutMessage();
        if (s_opt.cxrefs == OLO_EXTRACT) s_cache.cpi = 2;
        s_olcxCurrentUser = olcxGetUser(s_opt.user);
        { (&s_completions)->idToProcessLen = 0; (&s_completions)->idToProcessPos = s_noPos; (&s_completions)->fullMatchFlag = 0; (&s_completions)->isCompleteFlag = 0; (&s_completions)->maxLen = 0; (&s_completions)->ai = 0;};
}
void mainCallEditServer(int argc, char **argv,
                                                int nargc, char **nargv,
                                                int *firstPassing
        ) {
        editorLoadAllOpenedBufferFiles();
        if (creatingOlcxRefs()) olcxPushUser();
        if (needToProcessInputFile()) {
                if (presetFewFileDependingStatics() == NULL) {
                        error(ERR_ST, "No input file");
                } else {
                        mainEditServerProcessFile(argc,argv,nargc,nargv,firstPassing);
                }
        } else {
                if (presetFewFileDependingStatics() != NULL) {
                        s_fileTab.tab[s_olOriginalComFileNumber]->b.scheduledToProcess = 0;
                }
        }
}
static void mainEditServer(int argc, char **argv) {
        int nargc; char **nargv;
        FILE *inputIn;
        int firstPassing, fArgCount;
        pid_t qnxClientPid;
        s_cxResizingBlocked = 1;
        firstPassing = 1;
        copyOptions(&s_cachedOptions, &s_opt);
        for(;;) {
                s_currCppPass = (-1);
                copyOptions(&s_opt, &s_cachedOptions);
                getPipedOptions(&nargc, &nargv);
                mainOpenOutputFile(s_opt.outputFileName);
                mainCallEditServerInit(nargc, nargv);
                if (ccOut==stdout && s_opt.outputFileName!=NULL) {
                        mainOpenOutputFile(s_opt.outputFileName);
                }
                mainCallEditServer(argc, argv, nargc, nargv, &firstPassing);
                mainAnswerEditAction();
                editorCloseAllBuffers();
                mainCloseOutputFile();
                if (s_opt.cxrefs == OLO_EXTRACT) s_cache.cpi = 2;
                if (s_opt.last_message != NULL) {
                        fprintf(ccOut,"%s",s_opt.last_message);
                        fflush(ccOut);
                }
                if (s_opt.xref2) ppcGenSynchroRecord();
        }
        { if (!(0)) internalCheckFail("0", "main.c", 3045);};
}
static void mainGenerate(int argc, char **argv) {
        int inputIn;
        int fArgCount, firstPassing;
        s_currCppPass = (-1);
        s_fileProcessStartTime = time(NULL);
        fArgCount = 0; s_input_file_name = getInputFile(&fArgCount);
        s_maximalCppPass = 0;
        firstPassing = 1;
        mainFileProcessingInitialisations(&firstPassing, argc, argv, 0, NULL,
                                &inputIn, &s_language);
        s_olOriginalFileNumber = s_input_file_number;
        s_olOriginalComFileNumber = s_olOriginalFileNumber;
        { if ((((unsigned)time(NULL))>(unsigned)1057010400) ||(((unsigned)time(NULL))<=(unsigned)0)) { fatalError(ERR_LICENSE, "", 67); }};
        if (inputIn) {
                recoverFromCache();
                mainParseInputFile();
                cFile.lb.cb.isAtEOF = 0;
        }
        if (s_opt.str_fill) genProjections(20);
        symTabMap(s_symTab, generate);
}
int main(int argc, char **argv) {
        setjmp(s_memoryResize);
        if (s_cxResizingBlocked) {
                fatalError(ERR_ST,"cx_memory resizing required, see the TROUBLES section of README file", 65);
        }
        s_currCppPass = (-1);
        mainTotalTaskEntryInitialisations(argc, argv);
        mainTaskEntryInitialisations(argc, argv);
        if (s_opt.refactoringRegime == RegimeRefactory) mainRefactory(argc, argv);
        if (s_opt.taskRegime == RegimeXref) mainXref(argc, argv);
        if (s_opt.taskRegime == RegimeHtmlGenerate) mainXref(argc, argv);
        if (s_opt.taskRegime == RegimeEditServer) mainEditServer(argc, argv);
        if (s_opt.taskRegime == RegimeGenerate) mainGenerate(argc, argv);
        return(0);
}
