
/*

Copyright (C) Marian Vittek, Xref-Tech, Bratislava, 1997-2002.
All Rights Reserved.

    THIS FILE IS CONSIDERED A TRADE SECRET BY XREF-TECH.
UNAUTHORIZED ACCESS, USE, REPRODUCTION OR DISTRIBUTION IS PROHIBITED.

*/
#ifndef STDINC__H
#define STDINC__H
#if defined(__WIN32) && (! defined(__WIN32__))
#define __WIN32__ 1
#endif
#ifdef __WIN32__
#include <windows.h>
#include <direct.h>
#else
#include <unistd.h>
#include <dirent.h>
#endif
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <assert.h>
#include <string.h>
#include <time.h>
#include <setjmp.h>
#include <sys/types.h>
#include <sys/stat.h>
#endif
#include "head2.h"
#include "proto.h"
static char * VERSION_NUMBER = "1.5.10je";
static char * FILE_VERSION_NUMBER = "1.5.10je";
static char * PPC_VERSION_MISMATCH = "version-mismatch";
static char * PPC_MULTIPLE_COMPLETIONS = "completions";
static char * PPC_MULTIPLE_COMPLETION_LINE = "cl";
static char * PPC_SINGLE_COMPLETION = "single-completion";
static char * PPC_FQT_COMPLETION = "fqt-completion";
static char * PPC_SYMBOL_LIST = "symbol-list";
static char * PPC_REFACTORING_PRECHECK = "precheck";
static char * PPC_REFACTORING_REPLACEMENT = "replacement";
static char * PPC_REFACTORING_REPLACE = "replace";
static char * PPC_REFACTORING_REPLACE_WITH = "with";
static char * PPC_REFACTORING_CUT_BLOCK = "cut-block";
static char * PPC_REFACTORING_COPY_BLOCK = "copy-block";
static char * PPC_REFACTORING_PASTE_BLOCK = "past-block";
static char * PPC_EXTRACTION_DIALOG = "extraction-dialog";
static char * PPC_DISPLAY_CLASS_TREE = "display-class-tree";
static char * PPC_DISPLAY_RESOLUTION = "display-resolution";
static char * PPC_DISPLAY_OR_UPDATE_BROWSER = "display-or-update-browser";
static char * PPC_SYMBOL_RESOLUTION = "resolution";
static char * PPC_SYMBOL = "symbol";
static char * PPC_VIRTUAL_SYMBOL = "virtual-symbol";
static char * PPC_CLASS = "class";
static char * PPC_REFERENCE_LIST = "reference-list";
static char * PPC_SRC_LINE = "src-line";
static char * PPC_UPDATE_CURRENT_REFERENCE = "update-current-refn";
static char * PPC_NO_PROJECT = "no-project-found";
static char * PPC_SET_PROJECT = "set-project";
static char * PPC_SET_INFO = "set-info";
static char * PPC_WARNING = "warning";
static char * PPC_ERROR = "error";
static char * PPC_FATAL_ERROR = "fatalError";
static char * PPC_INFORMATION = "information";
static char * PPC_BOTTOM_INFORMATION = "bottom-information";
static char * PPC_DEBUG_INFORMATION = "debug-information";
static char * PPC_ASK_CONFIRMATION = "ask-confirmation";
static char * PPC_GOTO = "goto";
static char * PPC_BROWSE_URL = "browse-url";
static char * PPC_FILE_SAVE_AS = "file-save-as";
static char * PPC_MOVE_FILE_AS = "file-move-as";
static char * PPC_FILE_REMOVE = "file-remove";
static char * PPC_MOVE_DIRECTORY = "move-directory";
static char * PPC_INDENT = "indent-block";
static char * PPC_IGNORE = "ignore";
static char * PPC_PROGRESS = "progress";
static char * PPC_UPDATE_REPORT = "update-report";
static char * PPC_AVAILABLE_REFACTORINGS = "available-refactorings";
static char * PPC_SYNCHRO_RECORD = "sync";
static char * PPC_LC_POSITION = "position-lc";
static char * PPC_OFFSET_POSITION = "position-off";
static char * PPC_STRING_VALUE = "string-value";
static char * PPC_INT_VALUE = "int-value";
static char * PPCA_LEN = "len";
static char * PPCA_LINE = "line";
static char * PPCA_COL = "col";
static char * PPCA_OFFSET = "off";
static char * PPCA_VALUE = "val";
static char * PPCA_SELECTED = "selected";
static char * PPCA_BASE = "base";
static char * PPCA_DEF_REFN = "drefn";
static char * PPCA_REFN = "refn";
static char * PPCA_TYPE = "type";
static char * PPCA_MTYPE = "mtype";
static char * PPCA_CONTINUE = "continue";
static char * PPCA_INTERFACE = "interface";
static char * PPCA_INDENT = "indent";
static char * PPCA_TREE_DEPS = "deps";
static char * PPCA_TREE_UP = "up";
static char * PPCA_DEFINITION = "definition";
static int PPCV_BROWSER_TYPE_INFO = 0;
static int PPCV_BROWSER_TYPE_WARNING = 1;
static int PPC_AVR_NO_REFACTORING = 0;
static int PPC_AVR_RENAME_SYMBOL = 1;
static int PPC_AVR_RENAME_CLASS = 2;
static int PPC_AVR_RENAME_PACKAGE = 3;
static int PPC_AVR_ADD_PARAMETER = 4;
static int PPC_AVR_DEL_PARAMETER = 5;
static int PPC_AVR_MOVE_PARAMETER = 6;
static int PPC_AVR_EXTRACT_METHOD = 7;
static int PPC_AVR_EXTRACT_MACRO = 8;
static int PPC_AVR_MOVE_STATIC_FIELD = 9;
static int PPC_AVR_MOVE_STATIC_METHOD = 10;
static int PPC_AVR_MOVE_FIELD = 11;
static int PPC_AVR_PULL_UP_FIELD = 12;
static int PPC_AVR_PULL_UP_METHOD = 13;
static int PPC_AVR_PUSH_DOWN_FIELD = 14;
static int PPC_AVR_PUSH_DOWN_METHOD = 15;
static int PPC_AVR_MOVE_CLASS = 16;
static int PPC_AVR_ENCAPSULATE_FIELD = 17;
static int PPC_AVR_SELF_ENCAPSULATE_FIELD = 18;
static int PPC_AVR_TURN_DYNAMIC_METHOD_TO_STATIC = 19;
static int PPC_AVR_TURN_STATIC_METHOD_TO_DYNAMIC = 20;
static int PPC_AVR_REDUCE_NAMES = 21;
static int PPC_AVR_EXPAND_NAMES = 22;
static int PPC_AVR_SET_MOVE_TARGET = 23;
static int PPC_MAX_AVAILABLE_REFACTORINGS = 24;
static int s_cxGeneratedSingleRecords[] = {
        'm',
        'p',
        'f',
        'o',
        't',
        'u',
        'l',
        'c',
        's',
        'r',
        'h',
        'd',
        'e',
        'i',
        'b',
        'n',
        'a',
        'g',
        'k',
        -1
};
struct lastCxFileInfos {
        int onLineReferencedSym;
        S_olSymbolsMenu *onLineRefMenuItem;
        int onLineRefIsBestMatchFlag;
        S_symbolRefItem *symbolTab[2];
        char symbolIsWritten[2];
        char *symbolBestMatchFlag[2];
        int macroBaseFileGeneratedForSym[2];
        char singleRecord[127];
        int counter[127];
        void (*fun[127])(int size,int ri,char **ccc,char **ffin,S_charBuf *bbb, int additional);
        int additional[127];
        S_symbolRefItem _symbolTab[2];
        char _symbolTabNames[2][MAX_CX_SYMBOL_SIZE];
};
static struct lastCxFileInfos s_inLastInfos;
static struct lastCxFileInfos s_outLastInfos;
static S_charBuf cxfBuf;
static unsigned s_decodeFilesNum[MAX_FILES];
static char tmpFileName[MAX_FILE_NAME_SIZE];
int cxFileHashNumber(char *sym) {
        register unsigned res,r;
        register char *ss,*bb;
        register int c;
        if (s_opt.refnum <= 1) return(0);
        if (s_opt.xfileHashingMethod == 0) {
          res = 0;
          ss = sym;
          while ((c = *ss)) {
                if (c == '(') break;
                { res+=c; res+=(res<<10); res^=(res>>6);};
                if (( c=='.' || c=='/' || c=='!' || c=='#' || c=='$')) res = 0;
                ss++;
          }
          { res+=(res<<3); res^=(res>>11); res+=(res<<15);};
          res %= s_opt.refnum;
          return(res);
        } else if (s_opt.xfileHashingMethod == 1) {
          { if (!(s_opt.refnum == ('z'-'a'+2))) internalCheckFail("s_opt.refnum == ('z'-'a'+2)", "cxfile.c", 130);};
          for(ss = bb = sym; *ss && *ss!='('; ss++) {
                c = *ss;
                if (( c=='.' || c=='/' || c=='!' || c=='#' || c=='$')) bb = ss+1;
          }
          c = *bb;
          c = tolower(c);
          if (c>='a' && c<='z') res = c-'a';
          else res = ('z'-'a')+1;
          { if (!(res>=0 && res<s_opt.refnum)) internalCheckFail("res>=0 && res<s_opt.refnum", "cxfile.c", 139);};
          return(res);
        } else if (s_opt.xfileHashingMethod == 2) {
          for(ss = bb = sym; *ss && *ss!='('; ss++) {
                c = *ss;
                if (( c=='.' || c=='/' || c=='!' || c=='#' || c=='$')) bb = ss+1;
          }
          c = *bb;
          c = tolower(c);
          if (c>='a' && c<='z') r = c-'a';
          else r = ('z'-'a')+1;
          if (c==0) res=0;
          else {
                c = *(bb+1);
                c = tolower(c);
                if (c>='a' && c<='z') res = c-'a';
                else res = ('z'-'a')+1;
          }
          res = r*('z'-'a'+2) + res;
          { if (!(res>=0 && res<s_opt.refnum)) internalCheckFail("res>=0 && res<s_opt.refnum", "cxfile.c", 158);};
          return(res);
        } else {
          { if (!(0)) internalCheckFail("0", "cxfile.c", 161);};
          return(0);
        }
}
static int searchSingleStringFitness(char *cxtag, char *searchedStr, int len) {
        char *cc,*s,*c,*tt;
        int i,pilotc;
        { if (!(searchedStr)) internalCheckFail("searchedStr", "cxfile.c", 169);};
        pilotc = tolower(*searchedStr);
        cc = cxtag;
        for(cc=cxtag, i=0; *cc && i<len; cc++,i++) {
                c=cc;
                s=searchedStr;
                while (*s!=0 && *s!=' ' && *s!='\t' && tolower(*s)==tolower(*c)) {
                        c++; s++;
                }
                if (*s==0 || *s==' ' || *s=='\t') return(1);
        }
 fini0:
        return(0);
}
int searchStringFitness(char *cxtag, int len) {
        char *ss;
        int r;
        ss = s_opt.olcxSearchString;
        while (*ss) {
                while (*ss==' ' || *ss=='\t') ss++;
                if (*ss == 0) goto fini1;
                r = searchSingleStringFitness(cxtag, ss, len);
                if (r==0) return(0);
                while (*ss!=0 && *ss!=' ' && *ss!='\t') ss++;
        }
 fini1:
        return(1);
}
char *crTagSearchLineStatic(char *name, S_position *p,
                                                        int *len1, int *len2, int *len3) {
        static char res[COMPLETION_STRING_SIZE];
        char type[TMP_STRING_SIZE];
        char file[TMP_STRING_SIZE];
        char dir[TMP_STRING_SIZE];
        char *ffname;
        int l1,l2,l3,fl, dl;
        l1 = l2 = l3 = 0;
        l1 = strlen(name);
        ffname = s_fileTab.tab[p->file]->name;
        { if (!(ffname)) internalCheckFail("ffname", "cxfile.c", 222);};
        ffname = getRealFileNameStatic(ffname);
        fl = strlen(ffname);
        l3 = strmcpy(file,simpleFileName(ffname)) - file;
        dl = fl ;
        strncpy(dir, ffname, dl);
        dir[dl]=0;
        { if (l1 > *len1) *len1 = l1;};
        { if (l2 > *len2) *len2 = l2;};
        { if (l3 > *len3) *len3 = l3;};
        if (s_opt.tagSearchSpecif == TSS_SEARCH_DEFS_ONLY_SHORT
                || s_opt.tagSearchSpecif==TSS_FULL_SEARCH_SHORT) {
                sprintf(res, "%s", name);
        } else {
                sprintf(res, "%-*s :%-*s :%s", *len1, name, *len3, file, dir);
        }
        return(res);
}
static int symbolNameShouldBeHiddenFromReports(char *name) {
        int nlen;
        char *s;
        nlen = strlen(name);
        if (name[0] == ' ') return(1);
        if (! ((s_language & (4)) != 0)) return(0);
        if (strncmp(name, "class$", 6)==0) return(1);
        if (s_opt.tagSearchSpecif==TSS_FULL_SEARCH
                || s_opt.tagSearchSpecif==TSS_SEARCH_DEFS_ONLY_SHORT) {
                if (isdigit(name[0])) return(1);
                s = name;
                while ((s=strchr(s, '$'))!=NULL) {
                        s++;
                        while (isdigit(*s)) s++;
                        if (*s == '.' || *s=='(' || *s=='$') return(1);
                }
        }
        return(0);
}
void searchSymbolCheckReference(S_symbolRefItem *ss, S_reference *rr) {
        int fitness;
        char ssname[MAX_CX_SYMBOL_SIZE];
        char sss[MAX_CX_SYMBOL_SIZE];
        char searchss[MAX_CX_SYMBOL_SIZE];
        char *sname, *lname, *s;
        char *sline;
        int i, len1,len2,len3, slen;
        len1 = len2 = len3 = 1;
        sname = ssname;
        lname = ss->name;
        if (ss->b.symType == TypeCppInclude) return;
        if (symbolNameShouldBeHiddenFromReports(ss->name)) return;
        linkNamePrettyPrint(sname, lname, MAX_CX_SYMBOL_SIZE, SHORT_NAME);
        sline = sname;
        slen = strlen(sline);
        if (s_opt.tagSearchSpecif==TSS_SEARCH_DEFS_ONLY
                || s_opt.tagSearchSpecif==TSS_SEARCH_DEFS_ONLY_SHORT
                || s_opt.tagSearchSpecif==TSS_FULL_SEARCH_SHORT) {
                s = strchr(sline, '(');
                if (s!=NULL) {
                        slen = s-sline;
                } else {
                        do {
                                s = strchr(sline, '.');
                                if (s!=NULL) sline = s+1;
                        } while (s!=NULL);
                        slen = strlen(sline);
                }
                if (s_opt.tagSearchSpecif==TSS_SEARCH_DEFS_ONLY_SHORT
                        || s_opt.tagSearchSpecif==TSS_FULL_SEARCH_SHORT) {
                        sname = sline;
                        sname[slen]=0;
                }
        } else {
                strcpy(searchss, simpleFileNameFromFileNum(ss->vFunClass));
                if (symbolNameShouldBeHiddenFromReports(searchss)) return;
                for(i=strlen(searchss); i>0 && searchss[i]!='.'; i--) ;
                searchss[i] = 0;
                sprintf(searchss+i, "\t%s", sname);
                sline = searchss;
                slen = strlen(sline);
                { if (!(slen+1 < MAX_CX_SYMBOL_SIZE)) internalCheckFail("slen+1 < MAX_CX_SYMBOL_SIZE", "cxfile.c", 334);};
        }
        fitness = searchStringFitness(sline, slen);
        if (fitness) {
                static int count = 0;
                olCompletionListPrepend(sname, NULL, ss, rr, ss->b.symType, ss->vFunClass);
                count ++;
                if (count > COMPACT_TAG_SEARCH_AFTER) {
                        tagSearchCompactShortResults();
                        count = 0;
                }
        }
}
static void genCompactRecord(int recNum, int info, char *blankPrefix) {
        { if (!(recNum >= 0 && recNum < 127)) internalCheckFail("recNum >= 0 && recNum < 127", "cxfile.c", 355);};
        { if (!(info >= 0)) internalCheckFail("info >= 0", "cxfile.c", 356);};
        fprintf(cxOut,"%s", blankPrefix);
        if (info != 0) fprintf(cxOut,"%d", info);
        fprintf(cxOut,"%c", recNum);
        s_outLastInfos.counter[recNum] = info;
}
static void genOptCompactRecord(int recNum, int info, char *blankPrefix) {
        { if (!(recNum >= 0 && recNum < 127)) internalCheckFail("recNum >= 0 && recNum < 127", "cxfile.c", 366);};
        if (s_outLastInfos.counter[recNum] != info) {
                genCompactRecord(recNum, info, blankPrefix);
        } else {
                fprintf(cxOut,"%s", blankPrefix);
        }
}
static void genStringRecord(int recNum, char *s, char *blankPrefix) {
        int rsize;
        sprintf(tmpMemory,"%c%s", recNum, s);
        rsize = strlen(tmpMemory);
        { if (!(rsize < SIZE_TMP_MEM)) internalCheckFail("rsize < SIZE_TMP_MEM", "cxfile.c", 378);};
        fprintf(cxOut,"%s%d%s",blankPrefix,rsize,tmpMemory);
}
static void genSymbolItem(int symIndex) {
        char ttt[TMP_STRING_SIZE];
        S_symbolRefItem *d;
        genOptCompactRecord('s', symIndex, "");
        d = s_outLastInfos.symbolTab[symIndex];
        genOptCompactRecord('t', d->b.symType, "\n\n\n");
        genOptCompactRecord('d', d->vApplClass, "");
        genOptCompactRecord('h', d->vFunClass, "");
        genOptCompactRecord('a', d->b.accessFlags, "");
        genOptCompactRecord('g', d->b.storage, "");
        s_outLastInfos.macroBaseFileGeneratedForSym[symIndex] = 0;
        s_outLastInfos.symbolIsWritten[symIndex] = 1;
        if (s_opt.long_cxref) {
                sprintf(ttt,"\t%s",typesName[d->b.symType]);
                genStringRecord('#',ttt,"");
        }
        genStringRecord('/', d->name, "\t\t\t");
        if (s_opt.long_cxref) {
                if (d->vApplClass != s_noneFileIndex) {
                        sprintf(ttt,"\ton %s",s_fileTab.tab[d->vApplClass]->name);
                        genStringRecord('#',ttt,"\n");
                }
        }
        if (s_opt.long_cxref) {
                if (d->vApplClass != s_noneFileIndex) {
                        sprintf(ttt,"\tfun %s",s_fileTab.tab[d->vFunClass]->name);
                        genStringRecord('#',ttt,"\n");
                }
        }
        fprintf(cxOut,"\n\n");
}
static void genOptSymbolItem(int symIndex) {
        if (! s_outLastInfos.symbolIsWritten[symIndex]) {
                genSymbolItem(symIndex);
        }
}
static void genCxReference(S_reference *rr, int symbolNum) {
        char ttt[TMP_STRING_SIZE];
        genOptSymbolItem(symbolNum);
        if (rr->usage == UsageMacroBaseFileUsage) {
                { if (!(symbolNum>=0 && symbolNum<2)) internalCheckFail("symbolNum>=0 && symbolNum<2", "cxfile.c", 426);};
                if (s_outLastInfos.macroBaseFileGeneratedForSym[symbolNum]) return;
                s_outLastInfos.macroBaseFileGeneratedForSym[symbolNum] = 1;
        }
        genOptCompactRecord('u', rr->usage, " ");
        genOptCompactRecord('s', symbolNum, "");
        genOptCompactRecord('f', rr->p.file, "");
        genOptCompactRecord('l', rr->p.line, "");
        genOptCompactRecord('c', rr->p.coll, "");
        genCompactRecord('r', 0, "");
        if (s_opt.long_cxref) {
                sprintf(ttt,"\t%-7s in %30s:%u:%d\n",usagesName[rr->usage]+5,
                        s_fileTab.tab[rr->p.file]->name,rr->p.line,rr->p.coll);
                genStringRecord('#',ttt,"");
        }
}
static void genSubClassInfo(int sup, int inf, int origin) {
        char ttt[TMP_STRING_SIZE];
        genOptCompactRecord('f', origin, "\n");
        genOptCompactRecord('h', sup, "");
        genOptCompactRecord('d', inf, "");
        genCompactRecord('e', 0, "");
        if (s_opt.long_cxref) {
                sprintf(ttt,"\t\t%s",s_fileTab.tab[inf]->name);
                genStringRecord('#',ttt,"\n");
                sprintf(ttt,"  extends\t%s",s_fileTab.tab[sup]->name);
                genStringRecord('#',ttt,"\n");
        }
}
static void genFileIndexItem(struct fileItem *fi, int ii) {
        genOptCompactRecord('f', ii, "\n");
        genOptCompactRecord('p', fi->lastUpdateMtime, " ");
        genOptCompactRecord('m', fi->lastFullUpdateMtime, " ");
        genOptCompactRecord('i', fi->b.commandLineEntered, "");
        if (fi->b.isInterface) {
                genOptCompactRecord('a', 0x200, "");
        } else {
                genOptCompactRecord('a', 0x000, "");
        }
        genStringRecord(':', fi->name, " ");
}
static void genFileSourceIndexItem(struct fileItem *fi, int ii) {
        if (fi->b.sourceFile != -1 && fi->b.sourceFile != s_noneFileIndex) {
                genOptCompactRecord('f', ii, "\n");
                genCompactRecord('o', fi->b.sourceFile, " ");
        }
}
static void genClassHierarchyItems(struct fileItem *fi, int ii) {
        S_chReference *p;
        for(p=fi->sups; p!=NULL; p=p->next) {
                genSubClassInfo(p->clas, ii, p->ofile);
        }
}
static void crSubClassInfo(int sup, int inf, int origin, int genfl) {
        S_fileItem *ii,*jj;
        S_chReference *p,*pp;
        int mm;
        ii = s_fileTab.tab[inf];
        jj = s_fileTab.tab[sup];
        { if (!(ii && jj)) internalCheckFail("ii && jj", "cxfile.c", 490);};
        for(p=ii->sups; p!=NULL && p->clas!=sup; p=p->next) ;
        if (p==NULL) {
                {{{ { if (!((1) >= 0)) internalCheckFail("(1) >= 0", "cxfile.c", 493);}; cxMemory->i = ((char*)(((char*)(((char*)&cxMemory->b)+cxMemory->i))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(((char*)&cxMemory->b)+cxMemory->i))-1) & (STANDARD_ALLIGNEMENT-1))))) - ((char*)&cxMemory->b); if (cxMemory->i+(1)*sizeof(S_chReference) >= cxMemory->size) { if (cxMemory->overflowHandler(1)) longjmp(s_memoryResize,1); else fatalError(ERR_NO_MEMORY,"cxMemory", 65); } p = (S_chReference*) (((char*)&cxMemory->b) + cxMemory->i); cxMemory->i += (1)*sizeof(S_chReference);};};};
                { (p)->ofile = origin; (p)->clas = sup; (p)->next = ii->sups;};
                ii->sups = p;
                { if (!(s_opt.taskRegime)) internalCheckFail("s_opt.taskRegime", "cxfile.c", 496);};
                if (s_opt.taskRegime == RegimeXref) {
                        if (genfl == CX_FILE_ITEM_GEN) genSubClassInfo(sup, inf, origin);
                }
                {{{ { if (!((1) >= 0)) internalCheckFail("(1) >= 0", "cxfile.c", 500);}; cxMemory->i = ((char*)(((char*)(((char*)&cxMemory->b)+cxMemory->i))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(((char*)&cxMemory->b)+cxMemory->i))-1) & (STANDARD_ALLIGNEMENT-1))))) - ((char*)&cxMemory->b); if (cxMemory->i+(1)*sizeof(S_chReference) >= cxMemory->size) { if (cxMemory->overflowHandler(1)) longjmp(s_memoryResize,1); else fatalError(ERR_NO_MEMORY,"cxMemory", 65); } pp = (S_chReference*) (((char*)&cxMemory->b) + cxMemory->i); cxMemory->i += (1)*sizeof(S_chReference);};};};
                { (pp)->ofile = origin; (pp)->clas = inf; (pp)->next = jj->infs;};
                jj->infs = pp;
        }
}
void addSubClassItemToFileTab( int sup, int inf, int origin) {
        if (sup >= 0 && inf >= 0) {
                crSubClassInfo(sup, inf, origin, NO_CX_FILE_ITEM_GEN);
        }
}
void addSubClassesItemsToFileTab(S_symbol *ss, int origin) {
        int i,cf1;
        S_symbolList *sups;
        if (ss->b.symType != TypeStruct) return;
        { if (!(ss->b.javaFileLoaded)) internalCheckFail("ss->b.javaFileLoaded", "cxfile.c", 518);};
        if (ss->b.javaFileLoaded == 0) return;
        cf1 = ss->u.s->classFile;
        { if (!(cf1 >= 0 && cf1 < MAX_FILES)) internalCheckFail("cf1 >= 0 && cf1 < MAX_FILES", "cxfile.c", 521);};
        for(sups=ss->u.s->super; sups!=NULL; sups=sups->next) {
                { if (!(sups->d && sups->d->b.symType == TypeStruct)) internalCheckFail("sups->d && sups->d->b.symType == TypeStruct", "cxfile.c", 524);};
                addSubClassItemToFileTab( sups->d->u.s->classFile, cf1, origin);
        }
}
static void genRefItem0(S_symbolRefItem *d, int forceGen) {
        S_reference *rr;
        int symIndex;
        symIndex = 0;
        { if (!(strlen(d->name)+1 < MAX_CX_SYMBOL_SIZE)) internalCheckFail("strlen(d->name)+1 < MAX_CX_SYMBOL_SIZE", "cxfile.c", 536);};
        strcpy(s_outLastInfos._symbolTabNames[symIndex], d->name);
        { (&s_outLastInfos._symbolTab[symIndex].b)->symType = d->b.symType; (&s_outLastInfos._symbolTab[symIndex].b)->storage = d->b.storage; (&s_outLastInfos._symbolTab[symIndex].b)->scope = d->b.scope; (&s_outLastInfos._symbolTab[symIndex].b)->accessFlags = d->b.accessFlags; (&s_outLastInfos._symbolTab[symIndex].b)->category = d->b.category; (&s_outLastInfos._symbolTab[symIndex].b)->htmlWasLn = 0;};
        { (&s_outLastInfos._symbolTab[symIndex])->name = s_outLastInfos._symbolTabNames[symIndex]; (&s_outLastInfos._symbolTab[symIndex])->fileHash = d->fileHash; (&s_outLastInfos._symbolTab[symIndex])->vApplClass = d->vApplClass; (&s_outLastInfos._symbolTab[symIndex])->vFunClass = d->vFunClass; (&s_outLastInfos._symbolTab[symIndex])->b = s_outLastInfos._symbolTab[symIndex].b; (&s_outLastInfos._symbolTab[symIndex])->refs = NULL; (&s_outLastInfos._symbolTab[symIndex])->next = NULL;};
        s_outLastInfos.symbolTab[symIndex] = &s_outLastInfos._symbolTab[symIndex];
        s_outLastInfos.symbolIsWritten[symIndex] = 0;
        if ( d->b.category == CatLocal) return;
        if ( d->refs == NULL && ! forceGen) return;
        for(rr = d->refs; rr!=NULL; rr=rr->next) {
                if (s_opt.update==UP_NO_UPDATE || s_fileTab.tab[rr->p.file]->b.cxLoading) {
                        genCxReference(rr, symIndex);
                }
        }
        fflush(cxOut);
}
static void genRefItem(S_symbolRefItem *dd) {
        genRefItem0(dd,0);
}
static void genCxFileHead() {
        char sr[127];
        char ttt[TMP_STRING_SIZE];
        int i, magicnum;
        memset(&s_outLastInfos, 0, sizeof(s_outLastInfos));
        for(i=0; i<127; i++) {
                s_outLastInfos.counter[i] = -1;
        }
        { sprintf(ttt," file format: Xrefactory %s ",FILE_VERSION_NUMBER);};
        genStringRecord('v', ttt, "\n\n");
        fprintf(cxOut,"\n\n\n");
        for(i=0; i<127 && s_cxGeneratedSingleRecords[i] != -1; i++) {
                sr[i] = s_cxGeneratedSingleRecords[i];
        }
        { if (!(i < 127)) internalCheckFail("i < 127", "cxfile.c", 603);};
        sr[i]=0;
        genStringRecord('@', sr, "");
        genCompactRecord('n', s_opt.refnum, " ");
        genCompactRecord('k', ( ((MAX_FILES)*3 +s_opt.xfileHashingMethod)*2+s_opt.exactPositionResolve), " ");
}
static void openInOutReferenceFiles(int updateFlag, char *fname) {
        char *ttt;
        tmpFileName[0] = 0;
        if (updateFlag) {
                ttt = crTmpFileName_st();
                { if (!(strlen(ttt)+1 < MAX_FILE_NAME_SIZE)) internalCheckFail("strlen(ttt)+1 < MAX_FILE_NAME_SIZE", "cxfile.c", 619);};
                strcpy(tmpFileName, ttt);
                copyFile(fname, tmpFileName);
        }
        { if (!(fname)) internalCheckFail("fname", "cxfile.c", 623);};
        cxOut = fopen(fname,"w");
        if (cxOut == NULL) fatalError(ERR_CANT_OPEN, fname, 65);
        if (updateFlag) {
                fIn = fopen(tmpFileName,"r");
                if (fIn==NULL) warning(ERR_CANT_OPEN,tmpFileName);
        } else {
                fIn = NULL;
        }
}
static void referenceFileEnd(int updateFlag, char *fname) {
        if (fIn != NULL) {
                fclose(fIn);
                fIn = NULL;
                removeFile(tmpFileName);
        }
        fclose(cxOut);
        cxOut = stdout;
}
static void createDirIfNotExists(char *dirname) {
        struct stat st;
        int createFlag;
        createFlag = 1;
        if (stat(dirname, &st)==0) {
                if ((st.st_mode & S_IFMT) == S_IFDIR) return;
                removeFile(dirname);
        }
        createDir(dirname);
}
static void genPartialFileTabRefFile( int updateFlag,
                                                                                char *dirname,
                                                                                char *fnamesuff,
                                                                                void mapfun(S_fileItem *, int),
                                                                                void mapfun2(S_fileItem *, int)
                                                        ) {
        char fn[MAX_FILE_NAME_SIZE];
        sprintf(fn, "%s%s", dirname, fnamesuff);
        { if (!(strlen(fn) < MAX_FILE_NAME_SIZE-1)) internalCheckFail("strlen(fn) < MAX_FILE_NAME_SIZE-1", "cxfile.c", 665);};
        openInOutReferenceFiles(updateFlag, fn);
        genCxFileHead();
        idTabMap3(&s_fileTab, mapfun);
        if (mapfun2!=NULL) idTabMap3(&s_fileTab, mapfun2);
        scanCxFile(s_cxFullScanFunTab);
        referenceFileEnd(updateFlag, fn);
}
static void generateRefsFromMemory(int fileOrder) {
        int i;
        int tsize;
        S_symbolRefItem *pp;
        tsize = s_cxrefTab.size;
        for(i=0; i<tsize; i++) {
                for(pp=s_cxrefTab.tab[i]; pp!=NULL; pp=pp->next) {
                        if (pp->b.category == CatLocal) goto nextitem;
                        if (pp->refs == NULL) goto nextitem;
                        if (pp->fileHash == fileOrder) genRefItem0(pp,0);
                nextitem:;
                }
        }
}
void genReferenceFile(int updateFlag, char *fname) {
        char fn[MAX_FILE_NAME_SIZE];
        char *dirname;
        int i;
        if (! isAbsolutePath(fname)) {
                sprintf(tmpBuff,"'%s' is not an absolute path, correct -refs option", fname);
                warning(ERR_ST, tmpBuff);
        }
        if (updateFlag==0) removeFile(fname);
        recursivelyCreateFileDirIfNotExists(fname);
        if (s_opt.refnum <= 1) {
                openInOutReferenceFiles(updateFlag, fname);
                genCxFileHead();
                idTabMap3(&s_fileTab, genFileIndexItem);
                idTabMap3(&s_fileTab, genFileSourceIndexItem);
                idTabMap3(&s_fileTab, genClassHierarchyItems);
                scanCxFile(s_cxFullScanFunTab);
                refTabMap(&s_cxrefTab, genRefItem);
                referenceFileEnd(updateFlag, fname);
        } else {
                dirname = fname;
                createDirIfNotExists(dirname);
                genPartialFileTabRefFile(updateFlag,dirname,PRF_FILES,
                                                  genFileIndexItem, genFileSourceIndexItem);
                genPartialFileTabRefFile(updateFlag,dirname,PRF_CLASS,
                                                  genClassHierarchyItems, NULL);
                for (i=0; i<s_opt.refnum; i++) {
                        sprintf(fn, "%s%s%04d", dirname, PRF_REF_PREFIX, i);
                        { if (!(strlen(fn) < MAX_FILE_NAME_SIZE-1)) internalCheckFail("strlen(fn) < MAX_FILE_NAME_SIZE-1", "cxfile.c", 739);};
                        openInOutReferenceFiles(updateFlag, fn);
                        genCxFileHead();
                        scanCxFile(s_cxFullScanFunTab);
                        generateRefsFromMemory(i);
                        referenceFileEnd(updateFlag, fn);
                }
        }
}
static void cxrfSetSingleRecords( int size,
                                                                int ri,
                                                                char **ccc,
                                                                char **ffin,
                                                                S_charBuf *bbb,
                                                                int additionalArg
                                                        ) {
        int i,cch;
        char *cc, *fin;
        cc = *ccc; fin = *ffin;
        { if (!(ri == '@')) internalCheckFail("ri == '@'", "cxfile.c", 799);};
        for(i=0; i<size-1; i++) {
                { if (cc >= fin) { (bbb)->cc = cc; if ((bbb)->isAtEOF || getCharBuf(bbb) == 0) { cch = -1; (bbb)->isAtEOF = 1; } else { cc = (bbb)->cc; fin = (bbb)->fin; cch = * ((unsigned char*)cc); cc ++; } } else { cch = * ((unsigned char*)cc); cc++; } };
                s_inLastInfos.singleRecord[cch] = 1;
        }
        *ccc = cc; *ffin = fin;
}
static void writeCxFileCompatibilityError(char *message) {
        static time_t lastMessageTime;
        if (s_opt.taskRegime == RegimeEditServer) {
                if (lastMessageTime < s_fileProcessStartTime) {
                        error(ERR_ST, message);
                        lastMessageTime = time(NULL);
                }
        } else {
                fatalError(ERR_ST, message, 65);
        }
}
static void cxrfVersionCheck( int size,
                                                                int ri,
                                                                char **ccc,
                                                                char **ffin,
                                                                S_charBuf *bbb,
                                                                int additionalArg
                                                        ) {
        char versionString[TMP_STRING_SIZE];
        char thisVersionString[TMP_STRING_SIZE];
        int i,cch;
        char *cc, *fin;
        cc = *ccc; fin = *ffin;
        { if (!(ri == 'v')) internalCheckFail("ri == 'v'", "cxfile.c", 832);};
        for(i=0; i<size-1; i++) {
                { if (cc >= fin) { (bbb)->cc = cc; if ((bbb)->isAtEOF || getCharBuf(bbb) == 0) { cch = -1; (bbb)->isAtEOF = 1; } else { cc = (bbb)->cc; fin = (bbb)->fin; cch = * ((unsigned char*)cc); cc ++; } } else { cch = * ((unsigned char*)cc); cc++; } };
                versionString[i]=cch;
        }
        versionString[i]=0;
        { sprintf(thisVersionString," file format: Xrefactory %s ",FILE_VERSION_NUMBER);};
        if (strcmp(versionString, thisVersionString)) {
                writeCxFileCompatibilityError("The Tag file was not generated by the current version of Xrefactory, recreate it");
        }
        *ccc = cc; *ffin = fin;
}
static void cxrfCheckNumber( int size,
                                                                int ri,
                                                                char **ccc,
                                                                char **ffin,
                                                                S_charBuf *bbb,
                                                                int additionalArg
        ) {
        int i,cch;
        int magicn, filen, hashMethod, exactPositionLinkFlag;
        char *cc, *fin;
        cc = *ccc; fin = *ffin;
        { if (!(ri == 'k')) internalCheckFail("ri == 'k'", "cxfile.c", 856);};
        if (s_opt.create) return;
        magicn = s_inLastInfos.counter['k'];
        { unsigned tmp; tmp = magicn; exactPositionLinkFlag = tmp % 2; tmp = tmp / 2; hashMethod = tmp % 3; tmp = tmp / 3; filen = tmp;};
        if (filen != MAX_FILES) {
                sprintf(tmpBuff,"The Tag file was generated with different MAX_FILES, recreate it");
                writeCxFileCompatibilityError(tmpBuff);
        }
        if (hashMethod != s_opt.xfileHashingMethod) {
                sprintf(tmpBuff,"The Tag file was generated with different hash method, recreate it");
                writeCxFileCompatibilityError(tmpBuff);
        }
        if (exactPositionLinkFlag != s_opt.exactPositionResolve) {
                if (exactPositionLinkFlag) {
                        sprintf(tmpBuff,"The Tag file was generated with '-exactpositionresolve' flag, recreate it");
                } else {
                        sprintf(tmpBuff,"The Tag file was generated without '-exactpositionresolve' flag, recreate it");
                }
                writeCxFileCompatibilityError(tmpBuff);
        }
        *ccc = cc; *ffin = fin;
}
static int cxrfFileItemShouldBeUpdatedFromCxFile(S_fileItem *ffi) {
        int updateFromCxFile = 1;
        if (s_opt.taskRegime == RegimeXref) {
                if (ffi->b.cxLoading && ! ffi->b.cxSaved) {
                        updateFromCxFile = 0;
                } else {
                        updateFromCxFile = 1;
                }
        }
        if (s_opt.taskRegime == RegimeEditServer) {
                if (ffi->lastInspect < s_fileProcessStartTime) {
                        updateFromCxFile = 1;
                } else {
                        updateFromCxFile = 0;
                }
        }
        return(updateFromCxFile);
}
static void cxrfFileName( int size,
                                                                int ri,
                                                                char **ccc,
                                                                char **ffin,
                                                                S_charBuf *bbb,
                                                                int genFl
                                                        ) {
        char id[MAX_FILE_NAME_SIZE];
        char *fn;
        struct fileItem *ffi,tffi;
        int i,ii,dii,len,commandLineFlag,isInterface;
        time_t fumtime, umtime;
        char *cc, *fin, cch;
        { if (!(ri == ':')) internalCheckFail("ri == ':'", "cxfile.c", 915);};
        cc = *ccc; fin = *ffin;
        fumtime = (time_t) s_inLastInfos.counter['m'];
        umtime = (time_t) s_inLastInfos.counter['p'];
        commandLineFlag = s_inLastInfos.counter['i'];
        isInterface=((s_inLastInfos.counter['a'] & 0x200)!=0);
        ii = s_inLastInfos.counter['f'];
        for (i=0; i<size-1; i++) {
                { if (cc >= fin) { (bbb)->cc = cc; if ((bbb)->isAtEOF || getCharBuf(bbb) == 0) { cch = -1; (bbb)->isAtEOF = 1; } else { cc = (bbb)->cc; fin = (bbb)->fin; cch = * ((unsigned char*)cc); cc ++; } } else { cch = * ((unsigned char*)cc); cc++; } };
                id[i] = cch;
        }
        id[i] = 0;
        len = i;
        { if (!(len+1 < MAX_FILE_NAME_SIZE)) internalCheckFail("len+1 < MAX_FILE_NAME_SIZE", "cxfile.c", 928);};
        { if (!(ii>=0 && ii<MAX_FILES)) internalCheckFail("ii>=0 && ii<MAX_FILES", "cxfile.c", 929);};
        { (&tffi)->name = id; (&tffi)->lastModif = 0; (&tffi)->lastInspect = 0; (&tffi)->lastUpdateMtime = 0; (&tffi)->lastFullUpdateMtime = 0; (&tffi)->b.cxLoading = 0; (&tffi)->b.cxLoaded = 0; (&tffi)->b.cxSaved = 0; (&tffi)->b.commandLineEntered = commandLineFlag; (&tffi)->b.scheduledToProcess = 0; (&tffi)->b.scheduledToUpdate = 0; (&tffi)->b.fullUpdateIncludesProcessed = 0; (&tffi)->b.isInterface = 0; (&tffi)->b.sourceFile = s_noneFileIndex; (&tffi)->sups = NULL; (&tffi)->infs = NULL; (&tffi)->directEnclosingInstance = s_noneFileIndex;};
        if (! idTabIsMember(&s_fileTab,&tffi,&dii)) {
                addFileTabItem(id, &dii);
                ffi = s_fileTab.tab[dii];
                ffi->b.commandLineEntered = commandLineFlag;
                ffi->b.isInterface = isInterface;
                if (ffi->lastFullUpdateMtime == 0) ffi->lastFullUpdateMtime=fumtime;
                if (ffi->lastUpdateMtime == 0) ffi->lastUpdateMtime=umtime;
                { if (!(s_opt.taskRegime)) internalCheckFail("s_opt.taskRegime", "cxfile.c", 942);};
                if (s_opt.taskRegime == RegimeXref) {
                        if (genFl == CX_GENERATE_OUTPUT) {
                                genFileIndexItem(ffi, dii);
                        }
                }
        } else {
                ffi = s_fileTab.tab[dii];
                if (cxrfFileItemShouldBeUpdatedFromCxFile(ffi)) {
                        ffi->b.isInterface = isInterface;
                        ffi->b.sourceFile = s_noneFileIndex;
                }
                if (s_opt.taskRegime == RegimeEditServer) {
                        ffi->b.commandLineEntered = commandLineFlag;
                }
                if (ffi->lastFullUpdateMtime == 0) ffi->lastFullUpdateMtime=fumtime;
                if (ffi->lastUpdateMtime == 0) ffi->lastUpdateMtime=umtime;
        }
        s_decodeFilesNum[ii]=dii;
        *ccc = cc; *ffin = fin;
}
static void cxrfSourceIndex( int size,
                                                                int ri,
                                                                char **ccc,
                                                                char **ffin,
                                                                S_charBuf *bbb,
                                                                int genFl
                                                        ) {
        char *cc, *fin, cch;
        int file, sfile;
        { if (!(ri == 'o')) internalCheckFail("ri == 'o'", "cxfile.c", 977);};
        cc = *ccc; fin = *ffin;
        file = s_inLastInfos.counter['f'];
        file = s_decodeFilesNum[file];
        sfile = s_inLastInfos.counter['o'];
        sfile = s_decodeFilesNum[sfile];
        { if (!(file>=0 && file<MAX_FILES && s_fileTab.tab[file])) internalCheckFail("file>=0 && file<MAX_FILES && s_fileTab.tab[file]", "cxfile.c", 983);};
        if (s_fileTab.tab[file]->b.sourceFile == s_noneFileIndex
                || s_fileTab.tab[file]->b.sourceFile == -1) {
                if (! s_fileTab.tab[file]->b.cxLoading) {
                        s_fileTab.tab[file]->b.sourceFile = sfile;
                }
        }
        *ccc = cc; *ffin = fin;
}
static int scanSymNameString(int size,char **ccc,char **ffin,
                                                                 S_charBuf *bbb,char *id) {
        int i, len;
        char *cc, *fin, cch;
        cc = *ccc; fin = *ffin;
        for (i=0; i<size-1; i++) {
                { if (cc >= fin) { (bbb)->cc = cc; if ((bbb)->isAtEOF || getCharBuf(bbb) == 0) { cch = -1; (bbb)->isAtEOF = 1; } else { cc = (bbb)->cc; fin = (bbb)->fin; cch = * ((unsigned char*)cc); cc ++; } } else { cch = * ((unsigned char*)cc); cc++; } };
                id[i] = cch;
        }
        id[i] = 0;
        len = i;
        { if (!(len+1 < MAX_CX_SYMBOL_SIZE)) internalCheckFail("len+1 < MAX_CX_SYMBOL_SIZE", "cxfile.c", 1013);};
        *ccc = cc; *ffin = fin;
        return(len);
}
static void getSymTypeAndClasses(int *_symType, int *_vApplClass,
                                                                  int *_vFunClass) {
        int symType, vApplClass, vFunClass;
        symType = s_inLastInfos.counter['t'];
        vApplClass = s_inLastInfos.counter['d'];
        vApplClass = s_decodeFilesNum[vApplClass];
        { if (!(s_fileTab.tab[vApplClass] != NULL)) internalCheckFail("s_fileTab.tab[vApplClass] != NULL", "cxfile.c", 1025);};
        vFunClass = s_inLastInfos.counter['h'];
        vFunClass = s_decodeFilesNum[vFunClass];
        { if (!(s_fileTab.tab[vFunClass] != NULL)) internalCheckFail("s_fileTab.tab[vFunClass] != NULL", "cxfile.c", 1028);};
        *_symType = symType;
        *_vApplClass = vApplClass;
        *_vFunClass = vFunClass;
}
static void cxrfSymbolNameForFullUpdateSchedule( int size,
                                                                                                        int ri,
                                                                                                        char **ccc,
                                                                                                        char **ffin,
                                                                                                        S_charBuf *bbb,
                                                                                                        int additionalArg
        ) {
        S_symbol *d;
        S_symbolRefItem *ddd,dd,*memb;
        int i,ii,si,symType,len,rr,vApplClass,vFunClass,accessFlags;
        int storage;
        char *id;
        char *fn,*ss;
        char *cc, *fin, cch;
        { if (!(ri == '/')) internalCheckFail("ri == '/'", "cxfile.c", 1050);};
        accessFlags = s_inLastInfos.counter['a'];
        storage = s_inLastInfos.counter['g'];
        si = s_inLastInfos.counter['s'];
        { if (!(si>=0 && si<2)) internalCheckFail("si>=0 && si<MAX_CX_SYMBOL_TAB", "cxfile.c", 1054);};
        id = s_inLastInfos._symbolTabNames[si];
        len = scanSymNameString( size, ccc, ffin, bbb, id);
        cc = *ccc; fin = *ffin;
        getSymTypeAndClasses( &symType, &vApplClass, &vFunClass);
        if (symType!=TypeCppInclude || strcmp(id, "%%%i")!=0) {
                s_inLastInfos.onLineReferencedSym = -1;
                return;
        }
        ddd = &s_inLastInfos._symbolTab[si];
        s_inLastInfos.symbolTab[si] = ddd;
        { (&ddd->b)->symType = symType; (&ddd->b)->storage = storage; (&ddd->b)->scope = ScopeGlobal; (&ddd->b)->accessFlags = accessFlags; (&ddd->b)->category = CatGlobal; (&ddd->b)->htmlWasLn = 0;};
        { (ddd)->name = id; (ddd)->fileHash = cxFileHashNumber(id); (ddd)->vApplClass = vApplClass; (ddd)->vFunClass = vFunClass; (ddd)->b = ddd->b; (ddd)->refs = NULL; (ddd)->next = NULL;};
        rr = refTabIsMember(&s_cxrefTab, ddd, &ii,&memb);
        if (rr == 0) {
                {{ { if (!((len+1) >= 0)) internalCheckFail("(len+1) >= 0", "cxfile.c", 1073);}; cxMemory->i = ((char*)(((char*)(((char*)&cxMemory->b)+cxMemory->i))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(((char*)&cxMemory->b)+cxMemory->i))-1) & (STANDARD_ALLIGNEMENT-1))))) - ((char*)&cxMemory->b); if (cxMemory->i+(len+1)*sizeof(char) >= cxMemory->size) { if (cxMemory->overflowHandler(len+1)) longjmp(s_memoryResize,1); else fatalError(ERR_NO_MEMORY,"cxMemory", 65); } ss = (char*) (((char*)&cxMemory->b) + cxMemory->i); cxMemory->i += (len+1)*sizeof(char);};};
                strcpy(ss,id);
                {{{ { if (!((1) >= 0)) internalCheckFail("(1) >= 0", "cxfile.c", 1075);}; cxMemory->i = ((char*)(((char*)(((char*)&cxMemory->b)+cxMemory->i))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(((char*)&cxMemory->b)+cxMemory->i))-1) & (STANDARD_ALLIGNEMENT-1))))) - ((char*)&cxMemory->b); if (cxMemory->i+(1)*sizeof(S_symbolRefItem) >= cxMemory->size) { if (cxMemory->overflowHandler(1)) longjmp(s_memoryResize,1); else fatalError(ERR_NO_MEMORY,"cxMemory", 65); } memb = (S_symbolRefItem*) (((char*)&cxMemory->b) + cxMemory->i); cxMemory->i += (1)*sizeof(S_symbolRefItem);};};};
                { (&memb->b)->symType = symType; (&memb->b)->storage = storage; (&memb->b)->scope = ScopeGlobal; (&memb->b)->accessFlags = accessFlags; (&memb->b)->category = CatGlobal; (&memb->b)->htmlWasLn = 0;};
                { (memb)->name = ss; (memb)->fileHash = cxFileHashNumber(ss); (memb)->vApplClass = vApplClass; (memb)->vFunClass = vFunClass; (memb)->b = memb->b; (memb)->refs = NULL; (memb)->next = NULL;};
                refTabAdd(&s_cxrefTab, memb, &ii);
        }
        s_inLastInfos.symbolTab[si] = memb;
        s_inLastInfos.onLineReferencedSym = si;
        *ccc = cc; *ffin = fin;
}
static void cxrfSymbolName( int size,
                                                                int ri,
                                                                char **ccc,
                                                                char **ffin,
                                                                S_charBuf *bbb,
                                                                int additionalArg
        ) {
        S_symbol *d;
        S_symbolRefItem *ddd,dd,*memb;
        S_olSymbolsMenu *cms;
        int i,ii,si,symType,len,rr,vApplClass,vFunClass,ols,accessFlags,storage;
        char *id;
        char *fn,*ss;
        char *cc, *fin, cch;
        { if (!(ri == '/')) internalCheckFail("ri == '/'", "cxfile.c", 1101);};
        accessFlags = s_inLastInfos.counter['a'];
        storage = s_inLastInfos.counter['g'];
        si = s_inLastInfos.counter['s'];
        { if (!(si>=0 && si<2)) internalCheckFail("si>=0 && si<MAX_CX_SYMBOL_TAB", "cxfile.c", 1105);};
        id = s_inLastInfos._symbolTabNames[si];
        len = scanSymNameString( size, ccc, ffin, bbb, id);
        cc = *ccc; fin = *ffin;
        getSymTypeAndClasses( &symType, &vApplClass, &vFunClass);
        ddd = &s_inLastInfos._symbolTab[si];
        s_inLastInfos.symbolTab[si] = ddd;
        { (&ddd->b)->symType = symType; (&ddd->b)->storage = storage; (&ddd->b)->scope = ScopeGlobal; (&ddd->b)->accessFlags = accessFlags; (&ddd->b)->category = CatGlobal; (&ddd->b)->htmlWasLn = 0;};
        { (ddd)->name = id; (ddd)->fileHash = cxFileHashNumber(id); (ddd)->vApplClass = vApplClass; (ddd)->vFunClass = vFunClass; (ddd)->b = ddd->b; (ddd)->refs = NULL; (ddd)->next = NULL;};
        rr = refTabIsMember(&s_cxrefTab, ddd, &ii,&memb);
        while (rr && memb->b.category!=CatGlobal) rr=refTabNextMember(ddd, &memb);
        { if (!(s_opt.taskRegime)) internalCheckFail("s_opt.taskRegime", "cxfile.c", 1120);};
        if (s_opt.taskRegime == RegimeHtmlGenerate) {
                if (memb==NULL) {
                        {{ { if (!((len+1) >= 0)) internalCheckFail("(len+1) >= 0", "cxfile.c", 1123);}; cxMemory->i = ((char*)(((char*)(((char*)&cxMemory->b)+cxMemory->i))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(((char*)&cxMemory->b)+cxMemory->i))-1) & (STANDARD_ALLIGNEMENT-1))))) - ((char*)&cxMemory->b); if (cxMemory->i+(len+1)*sizeof(char) >= cxMemory->size) { if (cxMemory->overflowHandler(len+1)) longjmp(s_memoryResize,1); else fatalError(ERR_NO_MEMORY,"cxMemory", 65); } ss = (char*) (((char*)&cxMemory->b) + cxMemory->i); cxMemory->i += (len+1)*sizeof(char);};};
                        strcpy(ss,id);
                        {{{ { if (!((1) >= 0)) internalCheckFail("(1) >= 0", "cxfile.c", 1125);}; cxMemory->i = ((char*)(((char*)(((char*)&cxMemory->b)+cxMemory->i))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(((char*)&cxMemory->b)+cxMemory->i))-1) & (STANDARD_ALLIGNEMENT-1))))) - ((char*)&cxMemory->b); if (cxMemory->i+(1)*sizeof(S_symbolRefItem) >= cxMemory->size) { if (cxMemory->overflowHandler(1)) longjmp(s_memoryResize,1); else fatalError(ERR_NO_MEMORY,"cxMemory", 65); } memb = (S_symbolRefItem*) (((char*)&cxMemory->b) + cxMemory->i); cxMemory->i += (1)*sizeof(S_symbolRefItem);};};};
                        { (&memb->b)->symType = symType; (&memb->b)->storage = storage; (&memb->b)->scope = ScopeGlobal; (&memb->b)->accessFlags = accessFlags; (&memb->b)->category = CatGlobal; (&memb->b)->htmlWasLn = 0;};
                        { (memb)->name = ss; (memb)->fileHash = cxFileHashNumber(ss); (memb)->vApplClass = vApplClass; (memb)->vFunClass = vFunClass; (memb)->b = memb->b; (memb)->refs = NULL; (memb)->next = NULL;};
                        refTabAdd(&s_cxrefTab,memb, &ii);
                }
                s_inLastInfos.symbolTab[si] = memb;
        }
        if (s_opt.taskRegime == RegimeXref) {
                if (memb==NULL) memb=ddd;
                genRefItem0(memb,1);
                ddd->refs = memb->refs;
                memb->refs = NULL;
        }
        if (s_opt.taskRegime == RegimeEditServer && s_opt.cxrefs!=OLO_TAG_SEARCH) {
                S_olSymbolsMenu *ss;
                cms = NULL; ols = 0;
                if (additionalArg == CX_MENU_CREATION) {
                        cms = createSelectionMenu(ddd);
                        if (cms == NULL) {
                                ols = 0;
                        } else {
                                if (( (cms->ooBits&00700)==00500)) ols = 2;
                                else ols = 1;
                        }
                } else if (additionalArg!=CX_BY_PASS) {
                        ols=itIsSymbolToPushOlRefences(ddd,s_olcxCurrentUser->tops,&cms,DEFAULT_VALUE);
                }
                s_inLastInfos.onLineRefMenuItem = cms;
                if (ols || (additionalArg==CX_BY_PASS&&byPassAcceptableSymbol(ddd))
                        ) {
                        s_inLastInfos.onLineReferencedSym = si;
                        s_inLastInfos.onLineRefIsBestMatchFlag = (ols == 2);
                } else {
                        if (s_inLastInfos.onLineReferencedSym == si) {
                                s_inLastInfos.onLineReferencedSym = -1;
                        }
                }
        }
        *ccc = cc; *ffin = fin;
}
static void cxrfReferenceForFullUpdateSchedule( int size,
                                                                                                        int ri,
                                                                                                        char **ccc,
                                                                                                        char **ffin,
                                                                                                        S_charBuf *bbb,
                                                                                                        int additionalArg
        ) {
        S_position pos;
        S_reference rr,rro;
        S_symbolRefItem *memb;
        int ii,file,line,coll,usage,sym,vApplClass,vFunClass,addfl,symType;
        int copyrefFl;
        { if (!(ri == 'r')) internalCheckFail("ri == 'r'", "cxfile.c", 1183);};
        usage = s_inLastInfos.counter['u'];
        sym = s_inLastInfos.counter['s'];
        file = s_inLastInfos.counter['f'];
        file = s_decodeFilesNum[file];
        { if (!(s_fileTab.tab[file]!=NULL)) internalCheckFail("s_fileTab.tab[file]!=NULL", "cxfile.c", 1188);};
        line = s_inLastInfos.counter['l'];
        coll = s_inLastInfos.counter['c'];
        getSymTypeAndClasses( &symType, &vApplClass, &vFunClass);
        { (&pos)->file = file; (&pos)->line = line; (&pos)->coll = coll;};
        if (s_inLastInfos.onLineReferencedSym ==
                s_inLastInfos.counter['s']) {
                        addToRefList(&s_inLastInfos.symbolTab[sym]->refs,
                                                 usage,&pos,CatGlobal);
        }
}
static void cxrfReference( int size,
                                                                int ri,
                                                                char **ccc,
                                                                char **ffin,
                                                                S_charBuf *bbb,
                                                                int additionalArg
        ) {
        S_position pos;
        S_reference rr,rro;
        S_symbolRefItem *memb;
        int ii,file,line,coll,usage,sym,vApplClass,vFunClass,addfl,symType;
        int copyrefFl;
        { if (!(ri == 'r')) internalCheckFail("ri == 'r'", "cxfile.c", 1213);};
        usage = s_inLastInfos.counter['u'];
        sym = s_inLastInfos.counter['s'];
        file = s_inLastInfos.counter['f'];
        file = s_decodeFilesNum[file];
        { if (!(s_fileTab.tab[file]!=NULL)) internalCheckFail("s_fileTab.tab[file]!=NULL", "cxfile.c", 1218);};
        line = s_inLastInfos.counter['l'];
        coll = s_inLastInfos.counter['c'];
        getSymTypeAndClasses( &symType, &vApplClass, &vFunClass);
        { (&pos)->file = file; (&pos)->line = line; (&pos)->coll = coll;};
        { (&rr)->usage = usage; (&rr)->p = pos; (&rr)->next = NULL;};
        { if (!(s_opt.taskRegime)) internalCheckFail("s_opt.taskRegime", "cxfile.c", 1225);};
        if (s_opt.taskRegime == RegimeHtmlGenerate) {
                { if (!(sym>=0 && sym<2)) internalCheckFail("sym>=0 && sym<MAX_CX_SYMBOL_TAB", "cxfile.c", 1227);};
                if (additionalArg==CX_HTML_SECOND_PASS) {
                  if (rr.usage<UsageMaxOLUsages || rr.usage==UsageClassTreeDefinition) {
                        addToRefList(&s_inLastInfos.symbolTab[sym]->refs,
                                                 rr.usage,&rr.p,CatGlobal);
                  }
                } else if (rr.usage==UsageDefined || rr.usage==UsageDeclared
                                || s_fileTab.tab[rr.p.file]->b.commandLineEntered==0 ) {
                        addToRefList(&s_inLastInfos.symbolTab[sym]->refs,
                                                 rr.usage,&rr.p,CatGlobal);
                }
        }
        if (s_opt.taskRegime == RegimeXref) {
                if (s_opt.keep_old ||
                        (s_fileTab.tab[file]->b.cxLoading&&s_fileTab.tab[file]->b.cxSaved)
                        ) {
                        copyrefFl = ! isInRefList(s_inLastInfos.symbolTab[sym]->refs,
                                                                          usage, &pos, CatGlobal);
                } else {
                        copyrefFl = ! s_fileTab.tab[file]->b.cxLoading;
                }
                if (copyrefFl) genCxReference(&rr, sym);
        }
        if (s_opt.taskRegime == RegimeEditServer) {
                if (additionalArg == OL_LOOKING_2_PASS_MACRO_USAGE) {
                        if ( s_inLastInfos.onLineReferencedSym ==
                                        s_inLastInfos.counter['s']
                                && rr.usage == UsageMacroBaseFileUsage) {
                                s_olMacro2PassFile = rr.p.file;
                        }
                } else {
                        if (s_opt.cxrefs == OLO_TAG_SEARCH) {
                                if (rr.usage==UsageDefined
                                        || ((s_opt.tagSearchSpecif==TSS_FULL_SEARCH
                                                 || s_opt.tagSearchSpecif==TSS_FULL_SEARCH_SHORT)
                                                && (rr.usage==UsageDeclared
                                                         || rr.usage==UsageClassFileDefinition))) {
                                        searchSymbolCheckReference(s_inLastInfos.symbolTab[sym],&rr);
                                }
                        } else if (s_opt.cxrefs == OLO_SAFETY_CHECK1) {
                                if ( s_inLastInfos.onLineReferencedSym !=
                                                s_inLastInfos.counter['s']) {
                                        olcxCheck1CxFileReference(s_inLastInfos.symbolTab[sym],
                                                                                         &rr);
                                }
                        } else {
                                if ( s_inLastInfos.onLineReferencedSym ==
                                                s_inLastInfos.counter['s']) {
                                        if (additionalArg == CX_MENU_CREATION) {
                                                { if (!(s_inLastInfos.onLineRefMenuItem)) internalCheckFail("s_inLastInfos.onLineRefMenuItem", "cxfile.c", 1278);};
                                                if (s_opt.keep_old
                                                        || file!=s_olOriginalFileNumber
                                                        || s_fileTab.tab[file]->b.commandLineEntered==0
                                                        || s_opt.cxrefs==OLO_GOTO
                                                        || s_opt.cxrefs==OLO_CGOTO
                                                        || s_opt.cxrefs==OLO_PUSH_NAME
                                                        ) {
                                                        olcxAddReferenceToOlSymbolsMenu(s_inLastInfos.onLineRefMenuItem, &rr, s_inLastInfos.onLineRefIsBestMatchFlag);
                                                }
                                        } else if (additionalArg == CX_BY_PASS) {
                                                if ((! ( ((s_olcxByPassPos).file != (rr.p).file) || ((s_olcxByPassPos).line != (rr.p).line) || ((s_olcxByPassPos).coll != (rr.p).coll) ))) {
                                                        olAddBrowsedSymbol(s_inLastInfos.symbolTab[sym],
                                                                   &s_olcxCurrentUser->tops->hkSelectedSym,
                                                                        1, 1, 0, usage,0,&s_noPos,UsageNone);
                                                }
                                        } else if (1
                                                ) {
                                                        olcxAddReference(&s_olcxCurrentUser->tops->r, &rr,
                                                                        s_inLastInfos.onLineRefIsBestMatchFlag);
                                        }
                                }
                        }
                }
        }
}
static void cxrfRefNum( int fileRefNum,
                                                        int ri,
                                                        char **ccc,
                                                        char **ffin,
                                                        S_charBuf *bbb,
                                                        int additionalArg
                                                ) {
        int check;
        check = changeRefNumOption(fileRefNum);
        if (check == 0) {
                { if (!(s_opt.taskRegime)) internalCheckFail("s_opt.taskRegime", "cxfile.c", 1327);};
                fatalError(ERR_ST,"Tag file was generated with different '-refnum' options, recreate it!", 65);
        }
}
static void cxrfSubClass( int size,
                                                                int ri,
                                                                char **ccc,
                                                                char **ffin,
                                                                S_charBuf *bbb,
                                                                int additionalArg
                                                        ) {
        S_position pos;
        S_reference rr;
        int of, file, sup, inf;
        { if (!(ri == 'e')) internalCheckFail("ri == 'e'", "cxfile.c", 1342);};
        file = of = s_inLastInfos.counter['f'];
        sup = s_inLastInfos.counter['h'];
        inf = s_inLastInfos.counter['d'];
        file = s_decodeFilesNum[file];
        { if (!(s_fileTab.tab[file]!=NULL)) internalCheckFail("s_fileTab.tab[file]!=NULL", "cxfile.c", 1350);};
        sup = s_decodeFilesNum[sup];
        { if (!(s_fileTab.tab[sup]!=NULL)) internalCheckFail("s_fileTab.tab[sup]!=NULL", "cxfile.c", 1352);};
        inf = s_decodeFilesNum[inf];
        { if (!(s_fileTab.tab[inf]!=NULL)) internalCheckFail("s_fileTab.tab[inf]!=NULL", "cxfile.c", 1354);};
        { if (!(s_opt.taskRegime)) internalCheckFail("s_opt.taskRegime", "cxfile.c", 1355);};
        if (s_opt.taskRegime == RegimeHtmlGenerate) {
                crSubClassInfo(sup, inf, file, NO_CX_FILE_ITEM_GEN);
        }
        if (s_opt.taskRegime == RegimeXref) {
                if (s_fileTab.tab[file]->b.cxLoading==0 &&
                        additionalArg==CX_GENERATE_OUTPUT) {
                        genSubClassInfo(sup, inf, file);
                }
        }
        if (s_opt.taskRegime == RegimeEditServer) {
                if (file!=s_input_file_number) {
                        crSubClassInfo(sup, inf, file, NO_CX_FILE_ITEM_GEN);
                }
        }
}
void scanCxFile(S_cxScanFileFunctionLink *scanFuns) {
        int recInfo;
        int ch,i;
        char *cc, *cfin;
        if (fIn == NULL) return;
        memset(&s_inLastInfos, 0, sizeof(s_inLastInfos));
        s_inLastInfos.onLineReferencedSym = -1;
        s_inLastInfos.onLineRefMenuItem = NULL;
        s_inLastInfos.singleRecord['d'] = s_noneFileIndex;
        s_inLastInfos.singleRecord['h'] = s_noneFileIndex;
        s_decodeFilesNum[s_noneFileIndex] = s_noneFileIndex;
        for(i=0; scanFuns[i].recordCode>0; i++) {
                { if (!(scanFuns[i].recordCode < 127)) internalCheckFail("scanFuns[i].recordCode < 127", "cxfile.c", 1388);};
                ch = scanFuns[i].recordCode;
                s_inLastInfos.fun[ch] = scanFuns[i].handleFun;
                s_inLastInfos.additional[ch] = scanFuns[i].additionalArg;
        }
        { (&cxfBuf)->cc = cxfBuf.a; (&cxfBuf)->fin = cxfBuf.a; (&cxfBuf)->ff = fIn; (&cxfBuf)->filePos = 0; (&cxfBuf)->fileNumber = -1; (&cxfBuf)->lineNum = 0; (&cxfBuf)->lineBegin = 0; (&cxfBuf)->collumnOffset = 0; (&cxfBuf)->isAtEOF = 0; (&cxfBuf)->inputMethod = INPUT_DIRECT; (&cxfBuf)->zipStream = s_defaultZStream;};
        ch = ' '; cc = cxfBuf.a; cfin = cxfBuf.fin;
        while(! cxfBuf.isAtEOF) {
                { while (ch==' ' || ch=='\n' || ch=='\t') { if (cc >= cfin) { (&cxfBuf)->cc = cc; if ((&cxfBuf)->isAtEOF || getCharBuf(&cxfBuf) == 0) { ch = -1; (&cxfBuf)->isAtEOF = 1; } else { cc = (&cxfBuf)->cc; cfin = (&cxfBuf)->fin; ch = * ((unsigned char*)cc); cc ++; } } else { ch = * ((unsigned char*)cc); cc++; } }; recInfo = 0; while (isdigit(ch)) { recInfo = recInfo*10 + ch-'0'; { if (cc >= cfin) { (&cxfBuf)->cc = cc; if ((&cxfBuf)->isAtEOF || getCharBuf(&cxfBuf) == 0) { ch = -1; (&cxfBuf)->isAtEOF = 1; } else { cc = (&cxfBuf)->cc; cfin = (&cxfBuf)->fin; ch = * ((unsigned char*)cc); cc ++; } } else { ch = * ((unsigned char*)cc); cc++; } }; }};
                if (cxfBuf.isAtEOF) break;
                { if (!(ch >= 0 && ch<127)) internalCheckFail("ch >= 0 && ch<127", "cxfile.c", 1401);};
                if (s_inLastInfos.singleRecord[ch]) {
                        s_inLastInfos.counter[ch] = recInfo;
                }
                if (s_inLastInfos.fun[ch] != NULL) {
                        (*s_inLastInfos.fun[ch])(recInfo, ch, &cc, &cfin, &cxfBuf,
                                                                         s_inLastInfos.additional[ch]);
                } else if (! s_inLastInfos.singleRecord[ch]) {
                        { if (!(recInfo>0)) internalCheckFail("recInfo>0", "cxfile.c", 1409);};
                        { register int ccount,i,ch; ccount = recInfo-1; while (cc + ccount > cfin) { ccount -= cfin - cc; cc = cfin; { if (cc >= cfin) { (&cxfBuf)->cc = cc; if ((&cxfBuf)->isAtEOF || getCharBuf(&cxfBuf) == 0) { ch = -1; (&cxfBuf)->isAtEOF = 1; } else { cc = (&cxfBuf)->cc; cfin = (&cxfBuf)->fin; ch = * ((unsigned char*)cc); cc ++; } } else { ch = * ((unsigned char*)cc); cc++; } }; ccount --; } cc += ccount;};
                }
                { if (cc >= cfin) { (&cxfBuf)->cc = cc; if ((&cxfBuf)->isAtEOF || getCharBuf(&cxfBuf) == 0) { ch = -1; (&cxfBuf)->isAtEOF = 1; } else { cc = (&cxfBuf)->cc; cfin = (&cxfBuf)->fin; ch = * ((unsigned char*)cc); cc ++; } } else { ch = * ((unsigned char*)cc); cc++; } };
        }
}
int scanReferenceFile( char *fname, char *fns1, char *fns2,
                                                S_cxScanFileFunctionLink *scanFunTab
        ) {
        char fn[MAX_FILE_NAME_SIZE];
        sprintf(fn, "%s%s%s", fname, fns1, fns2);
        { if (!(strlen(fn) < MAX_FILE_NAME_SIZE-1)) internalCheckFail("strlen(fn) < MAX_FILE_NAME_SIZE-1", "cxfile.c", 1425);};
        fIn = fopen(fn,"r");
        if (fIn==NULL) {
                return(0);
        } else {
                scanCxFile(scanFunTab);
                fclose(fIn);
                fIn = NULL;
                return(1);
        }
}
void scanReferenceFiles(char *fname, S_cxScanFileFunctionLink *scanFunTab) {
        char nn[MAX_FILE_NAME_SIZE];
        char *dirname;
        int i;
        if (s_opt.refnum <= 1) {
                scanReferenceFile(fname,"","",scanFunTab);
        } else {
                scanReferenceFile(fname,PRF_FILES,"",scanFunTab);
                scanReferenceFile(fname,PRF_CLASS,"",scanFunTab);
                for (i=0; i<s_opt.refnum; i++) {
                        sprintf(nn,"%04d",i);
                        scanReferenceFile(fname,PRF_REF_PREFIX,nn,scanFunTab);
                }
        }
}
int smartReadFileTabFile() {
        static time_t readedFileModTime = 0;
        static off_t readedFileSize = 0;
        static char readedFileFile[MAX_FILE_NAME_SIZE] = {0};
        char tt[MAX_FILE_NAME_SIZE];
        struct stat st;
        int tmp;
        if (s_opt.refnum > 1) {
                sprintf(tt, "%s%s", s_opt.cxrefFileName, PRF_FILES);
        } else {
                sprintf(tt, "%s", s_opt.cxrefFileName);
        }
        if (statb(tt,&st)==0) {
                if ( readedFileModTime != st.st_mtime
                        || readedFileSize != st.st_size
                        || strcmp(readedFileFile, tt) != 0) {
                        tmp = scanReferenceFile(tt,"","",s_cxScanFileTab);
                        if (tmp != 0) {
                                readedFileModTime = st.st_mtime;
                                readedFileSize = st.st_size;
                                strcpy(readedFileFile, tt);
                        }
                } else {
                }
                return(1);
        }
        return(0);
}
void readOneAppropReferenceFile(char *symbolName,
                                                                S_cxScanFileFunctionLink *scanFunTab
        ) {
        static char fns[MAX_FILE_NAME_SIZE];
        int i,tmp;
        if (s_opt.cxrefFileName == NULL) return;
        cxOut = stdout;
        if (s_opt.refnum <= 1) {
                tmp = scanReferenceFile(s_opt.cxrefFileName,"","",scanFunTab);
                if (tmp == 0) return;
        } else {
                tmp = smartReadFileTabFile();
                if (tmp == 0) return;
                tmp = scanReferenceFile(s_opt.cxrefFileName,PRF_CLASS,"",
                                                                scanFunTab);
                if (tmp == 0) return;
                if (symbolName == NULL) return;
                i = cxFileHashNumber(symbolName);
                sprintf(fns, "%04d", i);
                { if (!(strlen(fns) < MAX_FILE_NAME_SIZE-1)) internalCheckFail("strlen(fns) < MAX_FILE_NAME_SIZE-1", "cxfile.c", 1511);};
                tmp = scanReferenceFile(s_opt.cxrefFileName,PRF_REF_PREFIX,fns,
                                                                scanFunTab);
                if (tmp == 0) return;
        }
}
S_cxScanFileFunctionLink s_cxScanFileTab[]={
        {'@',cxrfSetSingleRecords, 0},
        {':',cxrfFileName, CX_JUST_READ},
        {'k', cxrfCheckNumber, 0},
        {'o', cxrfSourceIndex, CX_JUST_READ},
        {'n',cxrfRefNum, 0},
        {-1,NULL, 0},
};
S_cxScanFileFunctionLink s_cxFullScanFunTab[]={
        {'@',cxrfSetSingleRecords, 0},
        {'v', cxrfVersionCheck, 0},
        {'k', cxrfCheckNumber, 0},
        {':',cxrfFileName, CX_GENERATE_OUTPUT},
        {'o', cxrfSourceIndex, CX_GENERATE_OUTPUT},
        {'/',cxrfSymbolName, DEFAULT_VALUE},
        {'r',cxrfReference, CX_HTML_FIRST_PASS},
        {'e',cxrfSubClass, CX_GENERATE_OUTPUT},
        {'n',cxrfRefNum, 0},
        {-1,NULL, 0},
};
S_cxScanFileFunctionLink s_cxByPassFunTab[]={
        {'@',cxrfSetSingleRecords, 0},
        {'v', cxrfVersionCheck, 0},
        {':',cxrfFileName, CX_JUST_READ},
        {'o', cxrfSourceIndex, CX_JUST_READ},
        {'/',cxrfSymbolName, CX_BY_PASS},
        {'r',cxrfReference, CX_BY_PASS},
        {'e',cxrfSubClass, CX_JUST_READ},
        {'n',cxrfRefNum, 0},
        {-1,NULL, 0},
};
S_cxScanFileFunctionLink s_cxSymbolLoadMenuRefs[]={
        {'@',cxrfSetSingleRecords, 0},
        {'v', cxrfVersionCheck, 0},
        {'k', cxrfCheckNumber, 0},
        {':',cxrfFileName, CX_JUST_READ},
        {'o', cxrfSourceIndex, CX_JUST_READ},
        {'/',cxrfSymbolName, DEFAULT_VALUE},
        {'r',cxrfReference, CX_MENU_CREATION},
        {'e',cxrfSubClass, CX_JUST_READ},
        {'n',cxrfRefNum, 0},
        {-1,NULL, 0},
};
S_cxScanFileFunctionLink s_cxSymbolMenuCreationTab[]={
        {'@',cxrfSetSingleRecords, 0},
        {'v', cxrfVersionCheck, 0},
        {'k', cxrfCheckNumber, 0},
        {':',cxrfFileName, CX_JUST_READ},
        {'o', cxrfSourceIndex, CX_JUST_READ},
        {'/',cxrfSymbolName, CX_MENU_CREATION},
        {'r',cxrfReference, CX_MENU_CREATION},
        {'e',cxrfSubClass, CX_JUST_READ},
        {'n',cxrfRefNum, 0},
        {-1,NULL, 0},
};
S_cxScanFileFunctionLink s_cxFullUpdateScanFunTab[]={
        {'@',cxrfSetSingleRecords, 0},
        {'v', cxrfVersionCheck, 0},
        {'k', cxrfCheckNumber, 0},
        {':',cxrfFileName, CX_JUST_READ},
        {'o', cxrfSourceIndex, CX_JUST_READ},
        {'/',cxrfSymbolNameForFullUpdateSchedule, DEFAULT_VALUE},
        {'r',cxrfReferenceForFullUpdateSchedule, DEFAULT_VALUE},
        {'n',cxrfRefNum, 0},
        {-1,NULL, 0},
};
S_cxScanFileFunctionLink s_cxScanFunTabFor2PassMacroUsage[]={
        {'@',cxrfSetSingleRecords, DEFAULT_VALUE},
        {':',cxrfFileName, CX_JUST_READ},
        {'o', cxrfSourceIndex, CX_JUST_READ},
        {'/',cxrfSymbolName, OL_LOOKING_2_PASS_MACRO_USAGE},
        {'r',cxrfReference, OL_LOOKING_2_PASS_MACRO_USAGE},
        {'e',cxrfSubClass, CX_JUST_READ},
        {'n',cxrfRefNum, DEFAULT_VALUE},
        {-1,NULL, 0},
};
S_cxScanFileFunctionLink s_cxScanFunTabForClassHierarchy[]={
        {'@',cxrfSetSingleRecords, DEFAULT_VALUE},
        {':',cxrfFileName, CX_JUST_READ},
        {'e',cxrfSubClass, CX_JUST_READ},
        {'n',cxrfRefNum, DEFAULT_VALUE},
        {-1,NULL, 0},
};
S_cxScanFileFunctionLink s_cxHtmlGlobRefListScanFunTab[]={
        {'@',cxrfSetSingleRecords, 0},
        {':',cxrfFileName, CX_JUST_READ},
        {'o', cxrfSourceIndex, CX_JUST_READ},
        {'e',cxrfSubClass, CX_JUST_READ},
        {'/',cxrfSymbolName, CX_HTML_SECOND_PASS},
        {'r',cxrfReference, CX_HTML_SECOND_PASS},
        {'n',cxrfRefNum, 0},
        {-1,NULL, 0},
};
S_cxScanFileFunctionLink s_cxSymbolSearchScanFunTab[]={
        {'@',cxrfSetSingleRecords, 0},
        {'n',cxrfRefNum, 0},
        {':',cxrfFileName, CX_JUST_READ},
        {'o', cxrfSourceIndex, CX_JUST_READ},
        {'/',cxrfSymbolName, SEARCH_SYMBOL},
        {'r',cxrfReference, CX_HTML_FIRST_PASS},
        {-1,NULL, 0},
};
