
/*

Copyright (C) Marian Vittek, Xref-Tech, Bratislava, 1997-2002.
All Rights Reserved.

    THIS FILE IS CONSIDERED A TRADE SECRET BY XREF-TECH.
UNAUTHORIZED ACCESS, USE, REPRODUCTION OR DISTRIBUTION IS PROHIBITED.

*/
#ifndef STDINC__H
#define STDINC__H
#if defined(__WIN32) && (! defined(__WIN32__))
#define __WIN32__ 1
#endif
#ifdef __WIN32__
#include <windows.h>
#include <direct.h>
#else
#include <unistd.h>
#include <dirent.h>
#endif
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <assert.h>
#include <string.h>
#include <time.h>
#include <setjmp.h>
#include <sys/types.h>
#include <sys/stat.h>
#endif
#include "head2.h"
#include "proto.h"
static char * VERSION_NUMBER = "1.5.10je";
static char * FILE_VERSION_NUMBER = "1.5.10je";
static char * PPC_VERSION_MISMATCH = "version-mismatch";
static char * PPC_MULTIPLE_COMPLETIONS = "completions";
static char * PPC_MULTIPLE_COMPLETION_LINE = "cl";
static char * PPC_SINGLE_COMPLETION = "single-completion";
static char * PPC_FQT_COMPLETION = "fqt-completion";
static char * PPC_SYMBOL_LIST = "symbol-list";
static char * PPC_REFACTORING_PRECHECK = "precheck";
static char * PPC_REFACTORING_REPLACEMENT = "replacement";
static char * PPC_REFACTORING_REPLACE = "replace";
static char * PPC_REFACTORING_REPLACE_WITH = "with";
static char * PPC_REFACTORING_CUT_BLOCK = "cut-block";
static char * PPC_REFACTORING_COPY_BLOCK = "copy-block";
static char * PPC_REFACTORING_PASTE_BLOCK = "past-block";
static char * PPC_EXTRACTION_DIALOG = "extraction-dialog";
static char * PPC_DISPLAY_CLASS_TREE = "display-class-tree";
static char * PPC_DISPLAY_RESOLUTION = "display-resolution";
static char * PPC_DISPLAY_OR_UPDATE_BROWSER = "display-or-update-browser";
static char * PPC_SYMBOL_RESOLUTION = "resolution";
static char * PPC_SYMBOL = "symbol";
static char * PPC_VIRTUAL_SYMBOL = "virtual-symbol";
static char * PPC_CLASS = "class";
static char * PPC_REFERENCE_LIST = "reference-list";
static char * PPC_SRC_LINE = "src-line";
static char * PPC_UPDATE_CURRENT_REFERENCE = "update-current-refn";
static char * PPC_NO_PROJECT = "no-project-found";
static char * PPC_SET_PROJECT = "set-project";
static char * PPC_SET_INFO = "set-info";
static char * PPC_WARNING = "warning";
static char * PPC_ERROR = "error";
static char * PPC_FATAL_ERROR = "fatalError";
static char * PPC_INFORMATION = "information";
static char * PPC_BOTTOM_INFORMATION = "bottom-information";
static char * PPC_DEBUG_INFORMATION = "debug-information";
static char * PPC_ASK_CONFIRMATION = "ask-confirmation";
static char * PPC_GOTO = "goto";
static char * PPC_BROWSE_URL = "browse-url";
static char * PPC_FILE_SAVE_AS = "file-save-as";
static char * PPC_MOVE_FILE_AS = "file-move-as";
static char * PPC_FILE_REMOVE = "file-remove";
static char * PPC_MOVE_DIRECTORY = "move-directory";
static char * PPC_INDENT = "indent-block";
static char * PPC_IGNORE = "ignore";
static char * PPC_PROGRESS = "progress";
static char * PPC_UPDATE_REPORT = "update-report";
static char * PPC_AVAILABLE_REFACTORINGS = "available-refactorings";
static char * PPC_SYNCHRO_RECORD = "sync";
static char * PPC_LC_POSITION = "position-lc";
static char * PPC_OFFSET_POSITION = "position-off";
static char * PPC_STRING_VALUE = "string-value";
static char * PPC_INT_VALUE = "int-value";
static char * PPCA_LEN = "len";
static char * PPCA_LINE = "line";
static char * PPCA_COL = "col";
static char * PPCA_OFFSET = "off";
static char * PPCA_VALUE = "val";
static char * PPCA_SELECTED = "selected";
static char * PPCA_BASE = "base";
static char * PPCA_DEF_REFN = "drefn";
static char * PPCA_REFN = "refn";
static char * PPCA_TYPE = "type";
static char * PPCA_MTYPE = "mtype";
static char * PPCA_CONTINUE = "continue";
static char * PPCA_INTERFACE = "interface";
static char * PPCA_INDENT = "indent";
static char * PPCA_TREE_DEPS = "deps";
static char * PPCA_TREE_UP = "up";
static char * PPCA_DEFINITION = "definition";
static int PPCV_BROWSER_TYPE_INFO = 0;
static int PPCV_BROWSER_TYPE_WARNING = 1;
static int PPC_AVR_NO_REFACTORING = 0;
static int PPC_AVR_RENAME_SYMBOL = 1;
static int PPC_AVR_RENAME_CLASS = 2;
static int PPC_AVR_RENAME_PACKAGE = 3;
static int PPC_AVR_ADD_PARAMETER = 4;
static int PPC_AVR_DEL_PARAMETER = 5;
static int PPC_AVR_MOVE_PARAMETER = 6;
static int PPC_AVR_EXTRACT_METHOD = 7;
static int PPC_AVR_EXTRACT_MACRO = 8;
static int PPC_AVR_MOVE_STATIC_FIELD = 9;
static int PPC_AVR_MOVE_STATIC_METHOD = 10;
static int PPC_AVR_MOVE_FIELD = 11;
static int PPC_AVR_PULL_UP_FIELD = 12;
static int PPC_AVR_PULL_UP_METHOD = 13;
static int PPC_AVR_PUSH_DOWN_FIELD = 14;
static int PPC_AVR_PUSH_DOWN_METHOD = 15;
static int PPC_AVR_MOVE_CLASS = 16;
static int PPC_AVR_ENCAPSULATE_FIELD = 17;
static int PPC_AVR_SELF_ENCAPSULATE_FIELD = 18;
static int PPC_AVR_TURN_DYNAMIC_METHOD_TO_STATIC = 19;
static int PPC_AVR_TURN_STATIC_METHOD_TO_DYNAMIC = 20;
static int PPC_AVR_REDUCE_NAMES = 21;
static int PPC_AVR_EXPAND_NAMES = 22;
static int PPC_AVR_SET_MOVE_TARGET = 23;
static int PPC_MAX_AVAILABLE_REFACTORINGS = 24;
static char optMemory[SIZE_opiMemory];
static int optMemoryi;
static char *s_standardCOptions[] = {
        "standardCOptions",
        "-set", "nl", "\n",
        "-set", "dq", "\"",
        "-set", "pc", "%",
        "-set", "dl", "$",
        "-D__FILE__=\"__FILE__\"",
        "-D__LINE__=0",
        "-D__DATE__=\"__DATE__\"",
        "-D__TIME__=\"__TIME__\"",
        "-D__STDC__=1",
        "-D__ptr_t=void*",
        "-D__wchar_t=int",
#ifdef __WIN32__
        "-D_based(xxx)=",
        "-D__based(xxx)=",
        "-D__declspec(xxx)=",
        "-I", "\\Program Files\\DevStudio\\VC\\include\\",
        "-I", "C:\\Program Files\\DevStudio\\VC\\include\\",
        "-I", "D:\\Program Files\\DevStudio\\VC\\include\\",
#else
        "-I", "/usr/include/",
#endif
#ifdef __linux__
        "-Dlinux=1",
        "-D__linux=1",
        "-D__linux__=1",
        "-Dunix=1",
        "-D__unix=1",
        "-D__unix__=1",
        "-D__GNUC__=2",
        "-D__GNUC_MINOR__=7",
        "-D__ELF__=1",
        "-D__attribute__(xxx) ",
        "-D__alignof__(xxx) 8",
        "-D__typeof__(xxx) int",
        "-D__gnuc_va_list void",
        "-I", "/usr/lib/g++-include/",
        "-I", "/usr/lib/gcc-lib/i386-redhat-linux/3.0.2/include/",
        "-I", "/usr/lib/gcc-lib/i386-redhat-linux/2.96/include/",
        "-I", "/usr/lib/gcc-lib/i386-redhat-linux/egcs-2.91.66/include/",
        "-I", "/usr/lib/gcc-lib/i386-redhat-linux/2.7.2.3/include/",
        "-I", "/usr/lib/gcc-lib/i486-linux/2.7.2.1/include",
        "-I", "/usr/include/g++/",
        "-I", "/usr/include/g++/std",
        "-I", "/usr/lib/gcc-lib/i386-glibc21-linux/egcs-2.91.66/include/",
#endif
};
static int s_standardCOptNum = sizeof(s_standardCOptions)/sizeof(char*);
static char *s_standardCccOptions[] = {
        "standardCccOptions",
        "-set", "nl", "\n",
        "-set", "dq", "\"",
        "-set", "pc", "%",
        "-set", "dl", "$",
        "-D__cplusplus__",
        "-D__cplusplus",
        "-D__FILE__=\"__FILE__\"",
        "-D__LINE__=0",
        "-D__DATE__=\"__DATE__\"",
        "-D__TIME__=\"__TIME__\"",
        "-D__STDC__=1",
        "-I", "/usr/include/",
#ifdef __linux__
        "-Dlinux=1",
        "-D__linux=1",
        "-D__linux__=1",
        "-Dunix=1",
        "-D__unix=1",
        "-D__unix__=1",
        "-D__GNUC__=2",
        "-D__GNUC_MINOR__=7",
        "-D__ELF__=1",
        "-D__attribute__(xxx) ",
        "-D__alignof__(xxx) 8",
        "-D__asm__(xxx) {}",
        "-I", "/usr/lib/g++-include/",
        "-I", "/usr/lib/gcc-lib/i386-redhat-linux/2.96/include/",
        "-I", "/usr/lib/gcc-lib/i386-redhat-linux/egcs-2.91.66/include/",
        "-I", "/usr/lib/gcc-lib/i386-redhat-linux/2.7.2.3/include/",
        "-I", "/usr/lib/gcc-lib/i486-linux/2.7.2.1/include",
        "-I", "/usr/include/g++/",
        "-I", "/usr/include/g++/std",
#endif
};
static int s_standardCccOptNum = sizeof(s_standardCccOptions)/sizeof(char*);
static char *s_standardJavaOptions[] = {
        "standardJavaOptions",
        "-set", "nl", "\n",
        "-set", "dq", "\"",
        "-set", "pc", "%",
        "-set", "dl", "$",
};
static int s_standardJavaOptNum = sizeof(s_standardJavaOptions)/sizeof(char*);
void getStandardOptions(int *nargc, char ***nargv) {
        int i;
        char **aargv;
        int standardOptNum;
        char **standardOptions;
        if (((s_language & (4)) != 0)) {
                standardOptNum = s_standardJavaOptNum;
                standardOptions = s_standardJavaOptions;
        } else if (((s_language & (16)) != 0)) {
                standardOptNum = s_standardCccOptNum;
                standardOptions = s_standardCccOptions;
        } else {
                standardOptNum = s_standardCOptNum;
                standardOptions = s_standardCOptions;
        }
        {{ { if (!((standardOptNum) >= 0)) internalCheckFail("(standardOptNum) >= 0", "options.c", 155);}; ppmMemoryi = ((char*)(((char*)(ppmMemory+ppmMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(ppmMemory+ppmMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - ppmMemory; if (ppmMemoryi+(standardOptNum)*sizeof(char*) >= SIZE_ppmMemory) { fatalError(ERR_NO_MEMORY,"ppmMemory", 65); } aargv = (char**) (ppmMemory + ppmMemoryi); ppmMemoryi += (standardOptNum)*sizeof(char*);};};
        for (i=0; i<standardOptNum; i++) {
                {{ { if (!((strlen(standardOptions[i])+1) >= 0)) internalCheckFail("(strlen(standardOptions[i])+1) >= 0", "options.c", 157);}; ppmMemoryi = ((char*)(((char*)(ppmMemory+ppmMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(ppmMemory+ppmMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - ppmMemory; if (ppmMemoryi+(strlen(standardOptions[i])+1)*sizeof(char) >= SIZE_ppmMemory) { fatalError(ERR_NO_MEMORY,"ppmMemory", 65); } aargv[i] = (char*) (ppmMemory + ppmMemoryi); ppmMemoryi += (strlen(standardOptions[i])+1)*sizeof(char);};};
                strcpy(aargv[i],standardOptions[i]);
        }
        *nargc = standardOptNum;
        *nargv = aargv;
}
char *expandSpecialFilePredefinedVariables_st(char *tt) {
        static char res[MAX_OPTION_LEN];
        int i,j,len,flen,plen,nlen,slen,tlen,suplen;
        char *fvv, *suffix;
        char file[MAX_FILE_NAME_SIZE];
        char path[MAX_FILE_NAME_SIZE];
        char name[MAX_FILE_NAME_SIZE];
        char thisclass[MAX_FILE_NAME_SIZE];
        char superclass[MAX_FILE_NAME_SIZE];
        fvv = getRealFileNameStatic(s_input_file_name);
        strcpy(file, fvv);
        { if (!(strlen(file) < MAX_FILE_NAME_SIZE-1)) internalCheckFail("strlen(file) < MAX_FILE_NAME_SIZE-1", "options.c", 182);};
        strcpy(path, directoryName_st(file));
        strcpy(name, simpleFileNameWithoutSuffix_st(file));
        suffix = lastOccurenceInString(file, '.');
        if (suffix==NULL) suffix="";
        else suffix++;
        strcpy(thisclass, s_cps.currentClassAnswer);
        strcpy(superclass, s_cps.currentSuperClassAnswer);
        javaDotifyFileName(thisclass);
        javaDotifyFileName(superclass);
        len = strlen(tt);
        flen = strlen("${__file}");
        plen = strlen("${__path}");
        nlen = strlen("${__name}");
        slen = strlen("${__suff}");
        tlen = strlen("${__this}");
        suplen = strlen("${__super}");
        i = j = 0;
        while (i<len) {
                if (strncmp(&tt[i], "${__file}", flen)==0) {
                        sprintf(&res[j], "%s", file);
                        i += flen;
                        j += strlen(&res[j]);
                } else if (strncmp(&tt[i], "${__path}", plen)==0) {
                        sprintf(&res[j], "%s", path);
                        i += plen;
                        j += strlen(&res[j]);
                } else if (strncmp(&tt[i], "${__name}", nlen)==0) {
                        sprintf(&res[j], "%s", name);
                        i += nlen;
                        j += strlen(&res[j]);
                } else if (strncmp(&tt[i], "${__suff}", slen)==0) {
                        sprintf(&res[j], "%s", suffix);
                        i += slen;
                        j += strlen(&res[j]);
                } else if (strncmp(&tt[i], "${__this}", tlen)==0) {
                        sprintf(&res[j], "%s", thisclass);
                        i += tlen;
                        j += strlen(&res[j]);
                } else if (strncmp(&tt[i], "${__super}", suplen)==0) {
                        sprintf(&res[j], "%s", superclass);
                        i += suplen;
                        j += strlen(&res[j]);
                } else {
                        res[j++] = tt[i++];
                }
                { if (!(j<MAX_OPTION_LEN)) internalCheckFail("j<MAX_OPTION_LEN", "options.c", 230);};
        }
        res[j]=0;
        return(res);
}
static void expandEnvironmentVariables(char *tt, int ttsize, int *len,
                                                                           int envFlag) {
        char ttt[MAX_OPTION_LEN];
        char vname[MAX_OPTION_LEN];
        char *vval;
        int i, d, j, starti, termc, expanded, vlen, tilda;
        i = d = 0;
        while(tt[i] && i<ttsize-2) {
                starti = -1;
                expanded = 0;
                termc = 0;
                tilda = 0;
#ifndef __WIN32__
                if (i==0 && tt[i]=='~' && tt[i+1]=='/') {starti = i; termc='~'; tilda=1;}
#endif
                if (tt[i]=='$' && tt[i+1]=='{') {starti = i+2; termc='}';}
                if (tt[i]=='%') {starti = i+1; termc='%';}
                if (starti >= 0) {
                        j = starti;
                        while (isalpha(tt[j]) || isdigit(tt[j]) || tt[j]=='_') j++;
                        if (j<ttsize-2 && tt[j]==termc) {
                                vlen = j-starti;
                                strncpy(vname, &tt[starti], vlen);
                                vname[vlen]=0;
                                vval = NULL;
                                if (envFlag != GLOBAL_ENV_ONLY) {
                                        vval = getXrefEnvironmentValue(vname);
                                }
                                if (vval==NULL) vval = getenv(vname);
#ifndef __WIN32__
                                if (tilda) vval = getenv("HOME");
#endif
                                if (vval != NULL) {
                                        strcpy(&ttt[d], vval);
                                        d += strlen(vval);
                                        expanded = 1;
                                }
                                if (expanded) i = j+1;
                        }
                }
                if (expanded==0) {
                        ttt[d++] = tt[i++];
                }
                { if (!(d<MAX_OPTION_LEN-2)) internalCheckFail("d<MAX_OPTION_LEN-2", "options.c", 281);};
        }
        ttt[d] = 0;
        *len = d;
        strcpy(tt, ttt);
}
static int getOptionFromFile(FILE *ff, char *tt, int ttsize, int *outI) {
        int i,c,lc,comment,res,verbat,quotamess;
        c = getc(ff);
        do {
                quotamess = 0;
                *outI = i = comment = 0;
                while ((c>=0 && c<=' ') || c=='\n' || c=='\t') c=getc(ff);
                if (c==EOF) {
                        res = EOF;
                        goto fini;
                }
                if (c=='\"') {
                        lc=c; c=getc(ff);
                        while (c!=EOF && (c!='\"' )) {
                                if (i < ttsize-1) tt[i++]=c;
                                lc=c; c=getc(ff);
                        }
                        if (c!='\"' && s_opt.taskRegime!=RegimeEditServer) {
                                fatalError(ERR_ST, "option string through end of file", 65);
                        }
                } else if (c=='`') {
                        tt[i++]=c;
                        lc=c; c=getc(ff);
                        while (c!=EOF && c!='\n' && (c!='`' )) {
                                if (i < ttsize-1) tt[i++]=c;
                                lc=c; c=getc(ff);
                        }
                        if (i < ttsize-1) tt[i++]=c;
                        if (c!='`' && s_opt.taskRegime!=RegimeEditServer) {
                                error(ERR_ST, "option string through end of line");
                        }
                } else if (c=='[') {
                        tt[i++] = c;
                        lc=c; c=getc(ff);
                        while (c!=EOF && c!='\n' && (c!=']' )) {
                                if (i < ttsize-1) tt[i++]=c;
                                lc=c; c=getc(ff);
                        }
                        if (c==']') tt[i++]=c;
                } else {
                        while (c!=EOF && c>' ') {
                                if (c=='\"') quotamess = 1;
                                if (i < ttsize-1) tt[i++]=c;
                                c=getc(ff);
                        }
                }
                tt[i]=0;
                if (quotamess && s_opt.taskRegime!=RegimeEditServer) {
                        static int messageWritten=0;
                        if (! messageWritten) {
                                messageWritten = 1;
                                sprintf(tmpBuff,"option '%s' contains quotas.",tt);
                                warning(ERR_ST, tmpBuff);
                        }
                }
                if (i>=2 && tt[0]=='/' && tt[1]=='/') {
                        while (c!=EOF && c!='\n') c=getc(ff);
                        comment = 1;
                }
        } while (comment);
        if (strcmp(tt,END_OF_OPTIONS_STRING)==0) {
                i = 0; res = EOF;
        } else {
                res = 'A';
        }
fini:
        tt[i] = 0;
        *outI = i;
        return(res);
}
static void processSingleSectionMarker(char *tt,char *section,
                                                                           int *writeFlag, char *resSection) {
        int sl,casesensitivity=1;
        sl = strlen(tt);
#ifdef __WIN32__
        casesensitivity = 0;
#endif
        if (pathncmp(tt, section, sl, casesensitivity)==0
                && (section[sl]=='/' || section[sl]=='\\' || section[sl]==0)) {
                if (sl > strlen(resSection)) {
                        strcpy(resSection,tt);
                        { if (!(strlen(resSection)+1 < MAX_FILE_NAME_SIZE)) internalCheckFail("strlen(resSection)+1 < MAX_FILE_NAME_SIZE", "options.c", 377);};
                }
                *writeFlag = 1;
        } else {
                *writeFlag = 0;
        }
}
static void processSectionMarker(char *ttt,int i,char *project,char *section,
                                                                 int *writeFlag, char *resSection) {
        int sl;
        char *tt;
        char firstPath[MAX_FILE_NAME_SIZE];
        ttt[i-1]=0;
        tt = ttt+1;
        firstPath[0]=0;
        *writeFlag = 0;
        { char *currentPath, *jmop_pp, *jmop_ecp; int jmop_i, jmop_ind; char sourcepathes[MAX_SOURCE_PATH_SIZE]; { if (!(tt!=NULL)) internalCheckFail("tt!=NULL", "options.c", 396);}; jmop_pp = tt; strcpy(sourcepathes, jmop_pp); currentPath = sourcepathes; jmop_ecp = currentPath+strlen(currentPath); while (currentPath<jmop_ecp) { for(jmop_ind=0; currentPath[jmop_ind]!=0 && currentPath[jmop_ind]!=CLASS_PATH_SEPARATOR; jmop_ind++) ; currentPath[jmop_ind] = 0; jmop_i = jmop_ind; if (jmop_i>0 && currentPath[jmop_i-1]==SLASH) currentPath[--jmop_i] = 0; { if (firstPath[0]==0) strcpy(firstPath, currentPath); if (project!=NULL) { if (strcmp(currentPath, project)==0) { strcpy(resSection,currentPath); { if (!(strlen(resSection)+1 < MAX_FILE_NAME_SIZE)) internalCheckFail("strlen(resSection)+1 < MAX_FILE_NAME_SIZE", "options.c", 396);}; *writeFlag = 1; goto fini; } else { *writeFlag = 0; } } else { processSingleSectionMarker(currentPath, section, writeFlag, resSection); if (*writeFlag) goto fini; } }; currentPath += jmop_ind; currentPath++; }};
 fini:;
        if (*writeFlag) {
                strcpy(s_base, resSection);
                { if (!(strlen(resSection) < MAX_FILE_NAME_SIZE-1)) internalCheckFail("strlen(resSection) < MAX_FILE_NAME_SIZE-1", "options.c", 430);};
                xrefSetenv("__BASE", s_base);
                strcpy(resSection, firstPath);
        }
}
int readOptionFromFile(FILE *ff, int *nargc, char ***nargv, int memFl,
                                                char *sectionFile,char *project, char *resSection) {
        char tt[MAX_OPTION_LEN];
        int len,argc,i,c,isActiveSect,isActivePass,res,sl,passn=0;
        char **aargv,*argv[MAX_STD_ARGS];
        argc = 1; res = 0; isActiveSect = isActivePass = 1; aargv=NULL;
        resSection[0]=0;
        if (memFl==MEM_ALLOC_ON_SM) {optMemoryi = 0;};
        c = 'a';
        while (c!=EOF) {
                c = getOptionFromFile(ff,tt,MAX_OPTION_LEN,&len);
                if (len>=2 && tt[0]=='[' && tt[len-1]==']') {
                        expandEnvironmentVariables(tt+1,MAX_OPTION_LEN,&len,GLOBAL_ENV_ONLY);
                        processSectionMarker(tt,len+1,project,sectionFile,&isActiveSect,resSection);
                } else if (isActiveSect && strncmp(tt,"-pass",5)==0) {
                        sscanf(tt+5, "%d", &passn);
                        if (passn==s_currCppPass || s_currCppPass==(-1)) {
                                isActivePass = 1;
                        } else {
                                isActivePass = 0;
                        }
                        if (passn > s_maximalCppPass) s_maximalCppPass = passn;
                } else if (strncmp(tt,"-license=",9)==0) {
                        strcpy(s_opt.licenseString, tt+9);
                        s_expTime = 0;
                } else if (strcmp(tt,"-set")==0 && (isActiveSect && isActivePass)
                                   && memFl!=MEM_NO_ALLOC) {
                        res = 1;
                        { char *cc; cc=NULL; if (memFl!=MEM_NO_ALLOC) { { if (memFl==MEM_ALLOC_ON_SM) { { { if (!((len+1) >= 0)) internalCheckFail("(len+1) >= 0", "options.c", 498);}; optMemoryi = ((char*)(((char*)(optMemory+optMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(optMemory+optMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - optMemory; if (optMemoryi+(len+1)*sizeof(char) >= SIZE_opiMemory) { fatalError(ERR_NO_MEMORY,"optMemory", 65); } cc = (char*) (optMemory + optMemoryi); optMemoryi += (len+1)*sizeof(char);}; } else if (memFl==MEM_ALLOC_ON_PP) { {{ { if (!((len+1) >= 0)) internalCheckFail("(len+1) >= 0", "options.c", 498);}; ppmMemoryi = ((char*)(((char*)(ppmMemory+ppmMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(ppmMemory+ppmMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - ppmMemory; if (ppmMemoryi+(len+1)*sizeof(char) >= SIZE_ppmMemory) { fatalError(ERR_NO_MEMORY,"ppmMemory", 65); } cc = (char*) (ppmMemory + ppmMemoryi); ppmMemoryi += (len+1)*sizeof(char);};}; } else { { if (!(0)) internalCheckFail("0", "options.c", 498);}; }}; { if (!(cc)) internalCheckFail("cc", "options.c", 498);}; strcpy(cc,tt); argv[argc] = cc; if (argc < MAX_STD_ARGS-1) argc++; }};
                        c = getOptionFromFile(ff,tt,MAX_OPTION_LEN,&len);
                        expandEnvironmentVariables(tt,MAX_OPTION_LEN,&len,DEFAULT_VALUE);
                        { char *cc; cc=NULL; if (memFl!=MEM_NO_ALLOC) { { if (memFl==MEM_ALLOC_ON_SM) { { { if (!((len+1) >= 0)) internalCheckFail("(len+1) >= 0", "options.c", 501);}; optMemoryi = ((char*)(((char*)(optMemory+optMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(optMemory+optMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - optMemory; if (optMemoryi+(len+1)*sizeof(char) >= SIZE_opiMemory) { fatalError(ERR_NO_MEMORY,"optMemory", 65); } cc = (char*) (optMemory + optMemoryi); optMemoryi += (len+1)*sizeof(char);}; } else if (memFl==MEM_ALLOC_ON_PP) { {{ { if (!((len+1) >= 0)) internalCheckFail("(len+1) >= 0", "options.c", 501);}; ppmMemoryi = ((char*)(((char*)(ppmMemory+ppmMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(ppmMemory+ppmMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - ppmMemory; if (ppmMemoryi+(len+1)*sizeof(char) >= SIZE_ppmMemory) { fatalError(ERR_NO_MEMORY,"ppmMemory", 65); } cc = (char*) (ppmMemory + ppmMemoryi); ppmMemoryi += (len+1)*sizeof(char);};}; } else { { if (!(0)) internalCheckFail("0", "options.c", 501);}; }}; { if (!(cc)) internalCheckFail("cc", "options.c", 501);}; strcpy(cc,tt); argv[argc] = cc; if (argc < MAX_STD_ARGS-1) argc++; }};
                        c = getOptionFromFile(ff,tt,MAX_OPTION_LEN,&len);
                        expandEnvironmentVariables(tt,MAX_OPTION_LEN,&len,DEFAULT_VALUE);
                        { char *cc; cc=NULL; if (memFl!=MEM_NO_ALLOC) { { if (memFl==MEM_ALLOC_ON_SM) { { { if (!((len+1) >= 0)) internalCheckFail("(len+1) >= 0", "options.c", 504);}; optMemoryi = ((char*)(((char*)(optMemory+optMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(optMemory+optMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - optMemory; if (optMemoryi+(len+1)*sizeof(char) >= SIZE_opiMemory) { fatalError(ERR_NO_MEMORY,"optMemory", 65); } cc = (char*) (optMemory + optMemoryi); optMemoryi += (len+1)*sizeof(char);}; } else if (memFl==MEM_ALLOC_ON_PP) { {{ { if (!((len+1) >= 0)) internalCheckFail("(len+1) >= 0", "options.c", 504);}; ppmMemoryi = ((char*)(((char*)(ppmMemory+ppmMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(ppmMemory+ppmMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - ppmMemory; if (ppmMemoryi+(len+1)*sizeof(char) >= SIZE_ppmMemory) { fatalError(ERR_NO_MEMORY,"ppmMemory", 65); } cc = (char*) (ppmMemory + ppmMemoryi); ppmMemoryi += (len+1)*sizeof(char);};}; } else { { if (!(0)) internalCheckFail("0", "options.c", 504);}; }}; { if (!(cc)) internalCheckFail("cc", "options.c", 504);}; strcpy(cc,tt); argv[argc] = cc; if (argc < MAX_STD_ARGS-1) argc++; }};
                        if (argc < MAX_STD_ARGS) {
                                { if (!(argc>=3)) internalCheckFail("argc>=3", "options.c", 506);};
                                mainHandleSetOption(argc, argv, argc-3);
                        }
                } else if (len>0 && (isActiveSect && isActivePass)) {
                        res = 1;
                        expandEnvironmentVariables(tt,MAX_OPTION_LEN,&len,DEFAULT_VALUE);
                        { char *cc; cc=NULL; if (memFl!=MEM_NO_ALLOC) { { if (memFl==MEM_ALLOC_ON_SM) { { { if (!((len+1) >= 0)) internalCheckFail("(len+1) >= 0", "options.c", 512);}; optMemoryi = ((char*)(((char*)(optMemory+optMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(optMemory+optMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - optMemory; if (optMemoryi+(len+1)*sizeof(char) >= SIZE_opiMemory) { fatalError(ERR_NO_MEMORY,"optMemory", 65); } cc = (char*) (optMemory + optMemoryi); optMemoryi += (len+1)*sizeof(char);}; } else if (memFl==MEM_ALLOC_ON_PP) { {{ { if (!((len+1) >= 0)) internalCheckFail("(len+1) >= 0", "options.c", 512);}; ppmMemoryi = ((char*)(((char*)(ppmMemory+ppmMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(ppmMemory+ppmMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - ppmMemory; if (ppmMemoryi+(len+1)*sizeof(char) >= SIZE_ppmMemory) { fatalError(ERR_NO_MEMORY,"ppmMemory", 65); } cc = (char*) (ppmMemory + ppmMemoryi); ppmMemoryi += (len+1)*sizeof(char);};}; } else { { if (!(0)) internalCheckFail("0", "options.c", 512);}; }}; { if (!(cc)) internalCheckFail("cc", "options.c", 512);}; strcpy(cc,tt); argv[argc] = cc; if (argc < MAX_STD_ARGS-1) argc++; }};
                }
        }
        if (argc >= MAX_STD_ARGS-1) error(ERR_ST,"too much options");
        if (res && memFl!=MEM_NO_ALLOC) {
                { if (memFl==MEM_ALLOC_ON_SM) { { { if (!((argc) >= 0)) internalCheckFail("(argc) >= 0", "options.c", 517);}; optMemoryi = ((char*)(((char*)(optMemory+optMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(optMemory+optMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - optMemory; if (optMemoryi+(argc)*sizeof(char*) >= SIZE_opiMemory) { fatalError(ERR_NO_MEMORY,"optMemory", 65); } aargv = (char**) (optMemory + optMemoryi); optMemoryi += (argc)*sizeof(char*);}; } else if (memFl==MEM_ALLOC_ON_PP) { {{ { if (!((argc) >= 0)) internalCheckFail("(argc) >= 0", "options.c", 517);}; ppmMemoryi = ((char*)(((char*)(ppmMemory+ppmMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(ppmMemory+ppmMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - ppmMemory; if (ppmMemoryi+(argc)*sizeof(char*) >= SIZE_ppmMemory) { fatalError(ERR_NO_MEMORY,"ppmMemory", 65); } aargv = (char**) (ppmMemory + ppmMemoryi); ppmMemoryi += (argc)*sizeof(char*);};}; } else { { if (!(0)) internalCheckFail("0", "options.c", 517);}; }};
                for(i=1; i<argc; i++) aargv[i] = argv[i];
        }
        *nargc = argc;
        *nargv = aargv;
        return(res);
}
void readOptionFile(char *name, int *nargc, char ***nargv, char *sectionFile, char *project) {
        FILE *ff;
        char realSection[MAX_FILE_NAME_SIZE];
        ff = fopen(name,"r");
        if (ff==NULL) fatalError(ERR_CANT_OPEN,name, 65);
        readOptionFromFile(ff,nargc,nargv,MEM_ALLOC_ON_PP,sectionFile, project, realSection);
        fclose(ff);
}
void readOptionPipe(char *comm, int *nargc, char ***nargv, char *sectionFile) {
        FILE *ff;
        char realSection[MAX_FILE_NAME_SIZE];
        ff = popen(comm, "r");
        if (ff==NULL) fatalError(ERR_CANT_OPEN, comm, 65);
        readOptionFromFile(ff,nargc,nargv,MEM_ALLOC_ON_PP,sectionFile,NULL,realSection);
        fclose(ff);
}
void getOptionsFromMessage(char *qnxMsgBuff, int *nargc, char ***nargv) {
        int i,b;
        int argc;
        char **aargv,*argv[MAX_STD_ARGS];
        i=0; argc = 1;
        {optMemoryi = 0;};
        while (qnxMsgBuff[i]) {
                argv[argc] = qnxMsgBuff+i;
                argc++;
                while (qnxMsgBuff[i]!=' ' && qnxMsgBuff[i]) i++;
                qnxMsgBuff[i]=0;
                i++;
        }
        { { if (!((argc) >= 0)) internalCheckFail("(argc) >= 0", "options.c", 556);}; optMemoryi = ((char*)(((char*)(optMemory+optMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(optMemory+optMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - optMemory; if (optMemoryi+(argc)*sizeof(char*) >= SIZE_opiMemory) { fatalError(ERR_NO_MEMORY,"optMemory", 65); } aargv = (char**) (optMemory + optMemoryi); optMemoryi += (argc)*sizeof(char*);};
        for(i=1; i<argc; i++) aargv[i] = argv[i];
        *nargc = argc;
        *nargv = aargv;
}
static char *getClassPath(int defaultCpAllowed) {
        char *cp;
        cp = s_opt.classpath;
        if (cp == NULL || *cp==0) cp = getenv("CLASSPATH");
        if (cp == NULL || *cp==0) {
                if (defaultCpAllowed) cp = s_defaultClassPath;
                else cp = NULL;
        }
        return(cp);
}
static char *getSourcePath(int defaultCpAllowed) {
        char *cp;
        cp = s_opt.sourcePath;
        if (cp == NULL || *cp==0) cp = getenv("SOURCEPATH");
        if (cp == NULL || *cp==0) cp = getClassPath(defaultCpAllowed);
        return(cp);
}
static void processClassPathString( char *cp) {
        char *nn, *np, *sfp;
        char ttt[MAX_FILE_NAME_SIZE];
        S_stringList **ll;
        int ind, nlen;
        for(ll= & s_javaClassPaths; *ll!=NULL; ll= &(*ll)->next) ;
        while (*cp!=0) {
                for(ind=0; cp[ind]!=0 && cp[ind]!=CLASS_PATH_SEPARATOR; ind++) {
                        ttt[ind]=cp[ind];
                }
                ttt[ind]=0;
                np = normalizeFileName(ttt,s_cwd);
                nlen = strlen(np); sfp = np+nlen-4;
                if (nlen>=4 && (strcmp(sfp,".zip")==0 || strcmp(sfp,".jar")==0)){
                        { if (s_opt.debug) {fprintf(dumpOut,"Indexing '%s'\n",np);fflush(dumpOut);}};
                        zipIndexArchive(np);
                        { if (s_opt.debug) {fprintf(dumpOut,"Done.\n");fflush(dumpOut);}};
                } else {
                        {{ { if (!((strlen(np)+1) >= 0)) internalCheckFail("(strlen(np)+1) >= 0", "options.c", 602);}; ppmMemoryi = ((char*)(((char*)(ppmMemory+ppmMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(ppmMemory+ppmMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - ppmMemory; if (ppmMemoryi+(strlen(np)+1)*sizeof(char) >= SIZE_ppmMemory) { fatalError(ERR_NO_MEMORY,"ppmMemory", 65); } nn = (char*) (ppmMemory + ppmMemoryi); ppmMemoryi += (strlen(np)+1)*sizeof(char);};};
                        strcpy(nn,np);
                        {{{ { if (!((1) >= 0)) internalCheckFail("(1) >= 0", "options.c", 604);}; ppmMemoryi = ((char*)(((char*)(ppmMemory+ppmMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(ppmMemory+ppmMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - ppmMemory; if (ppmMemoryi+(1)*sizeof(S_stringList) >= SIZE_ppmMemory) { fatalError(ERR_NO_MEMORY,"ppmMemory", 65); } *ll = (S_stringList*) (ppmMemory + ppmMemoryi); ppmMemoryi += (1)*sizeof(S_stringList);};};};
                        { (*ll)->d = nn; (*ll)->next = NULL;};
                        ll = & (*ll)->next;
                }
                cp += ind;
                if (*cp == CLASS_PATH_SEPARATOR) cp++;
        }
}
int packageOnCommandLine(char *fn) {
        char *cp,*ss,*dd;
        char ttt[MAX_FILE_NAME_SIZE];
        char ppp[MAX_FILE_NAME_SIZE];
        struct stat st;
        int i, ind, stt, topCallFlag, res;
        void *recursFlag;
        res = 0;
        for(dd=ppp,ss=fn; *ss; dd++,ss++) {
                if (*ss == '.') *dd = SLASH;
                else *dd = *ss;
        }
        *dd = 0;
        { if (!(strlen(ppp)<MAX_FILE_NAME_SIZE-1)) internalCheckFail("strlen(ppp)<MAX_FILE_NAME_SIZE-1", "options.c", 626);};
        cp = getSourcePath(1);
        while (cp!=NULL && *cp!=0) {
                for(ind=0; cp[ind]!=0 && cp[ind]!=CLASS_PATH_SEPARATOR; ind++) {
                        ttt[ind]=cp[ind];
                }
                ttt[ind] = 0;
                i = ind;
                if (i==0 || ttt[i-1]!=SLASH) {
                        ttt[i++] = SLASH;
                }
                strcpy(ttt+i, ppp);
                { if (!(strlen(ttt)<MAX_FILE_NAME_SIZE-1)) internalCheckFail("strlen(ttt)<MAX_FILE_NAME_SIZE-1", "options.c", 638);};
                stt = statb(ttt, &st);
                if (stt==0 && (st.st_mode & S_IFMT)==S_IFDIR) {
                        res = 1;
                        topCallFlag = 1;
                        if (s_opt.recursivelyDirs) recursFlag = &topCallFlag;
                        else recursFlag = NULL;
                        dirInputFile(ttt,"",NULL,NULL,recursFlag,&topCallFlag);
                }
                cp += ind;
                if (*cp == CLASS_PATH_SEPARATOR) cp++;
        }
        return(res);
}
void addSourcePathesCut() {
        s_javaSourcePaths = getSourcePath(1);
        { char *currentPath, *jmop_pp, *jmop_ecp; int jmop_i, jmop_ind; char sourcepathes[MAX_SOURCE_PATH_SIZE]; { if (!(s_javaSourcePaths!=NULL)) internalCheckFail("s_javaSourcePaths!=NULL", "options.c", 658);}; jmop_pp = s_javaSourcePaths; strcpy(sourcepathes, jmop_pp); currentPath = sourcepathes; jmop_ecp = currentPath+strlen(currentPath); while (currentPath<jmop_ecp) { for(jmop_ind=0; currentPath[jmop_ind]!=0 && currentPath[jmop_ind]!=CLASS_PATH_SEPARATOR; jmop_ind++) ; currentPath[jmop_ind] = 0; jmop_i = jmop_ind; if (jmop_i>0 && currentPath[jmop_i-1]==SLASH) currentPath[--jmop_i] = 0; { addHtmlCutPath(currentPath); }; currentPath += jmop_ind; currentPath++; }};
}
static char * canItBeJavaBinPath(char *ttt) {
        static char res[MAX_FILE_NAME_SIZE];
        char *np;
        struct stat st;
        int stt, len;
        np = normalizeFileName(ttt, s_cwd);
        len = strlen(np);
#ifdef __WIN32__
        sprintf(res,"%s%cjava.exe", np, SLASH);
#else
        sprintf(res,"%s%cjava", np, SLASH);
#endif
        { if (!(len+6<MAX_FILE_NAME_SIZE)) internalCheckFail("len+6<MAX_FILE_NAME_SIZE", "options.c", 676);};
        stt = stat(res, &st);
        if (stt==0 && (st.st_mode & S_IFMT)!=S_IFDIR) {
                res[len]=0;
                if (len>4 && fnCmp(res+len-3,"bin")==0 && res[len-4]==SLASH) {
                        sprintf(res+len-3,"jre%clib%crt.jar",SLASH,SLASH);
                        { if (!(strlen(res)<MAX_FILE_NAME_SIZE-1)) internalCheckFail("strlen(res)<MAX_FILE_NAME_SIZE-1", "options.c", 682);};
                        stt = stat(res,&st);
                        if (stt==0) {
                                return(res);
                        }
                }
        }
        return(NULL);
}
static char *getJdk12AutoClassPathFastly() {
        char ttt[MAX_FILE_NAME_SIZE];
        char *res;
        char *cp;
        int len;
        cp = getenv("JAVA_HOME");
        if (cp!=NULL) {
                strcpy(ttt,cp);
                len = strlen(ttt);
                if (len>0 && (ttt[len-1]=='/' || ttt[len-1]=='\\')) len--;
                sprintf(ttt+len, "%cbin", SLASH);
                res = canItBeJavaBinPath(ttt);
                if (res!=NULL) return(res);
        }
        cp = getenv("PATH");
        if (cp!=NULL) {
                { char *currentPath, *jmop_pp, *jmop_ecp; int jmop_i, jmop_ind; char sourcepathes[MAX_SOURCE_PATH_SIZE]; { if (!(cp!=NULL)) internalCheckFail("cp!=NULL", "options.c", 709);}; jmop_pp = cp; strcpy(sourcepathes, jmop_pp); currentPath = sourcepathes; jmop_ecp = currentPath+strlen(currentPath); while (currentPath<jmop_ecp) { for(jmop_ind=0; currentPath[jmop_ind]!=0 && currentPath[jmop_ind]!=CLASS_PATH_SEPARATOR; jmop_ind++) ; currentPath[jmop_ind] = 0; jmop_i = jmop_ind; if (jmop_i>0 && currentPath[jmop_i-1]==SLASH) currentPath[--jmop_i] = 0; { res = canItBeJavaBinPath(currentPath); if (res != NULL) return(res); }; currentPath += jmop_ind; currentPath++; }};
        }
        return(NULL);
}
char *getJdkClassPathFastly() {
        char *jdkcp;
        jdkcp = s_opt.jdkClassPath;
        if (jdkcp == NULL || *jdkcp==0) jdkcp = getenv("JDKCLASSPATH");
        if (jdkcp == NULL || *jdkcp==0) jdkcp = getJdk12AutoClassPathFastly();
        return(jdkcp);
}
char *getJdkClassPath() {
        char ttt[MAX_FILE_NAME_SIZE];
        char *res, *cp;
        FILE *ff;
        res = getJdkClassPathFastly();
        if (res!=NULL && *res!=0) return(res);
#ifdef __WIN32__
#else
#endif
        return(NULL);
}
char *getJavaHome() {
        static char res[MAX_FILE_NAME_SIZE];
        char *tt;
        char *cp;
        int ii;
        tt = getJdkClassPath();
        if (tt!=NULL && *tt!=0) {
                copyDir(res, tt, &ii);
                if (ii>0) res[ii-1] = 0;
                copyDir(res, res, &ii);
                if (ii>0) res[ii-1] = 0;
                copyDir(res, res, &ii);
                if (ii>0) res[ii-1] = 0;
                return(res);
        }
        return(NULL);
}
void getJavaClassAndSourcePath() {
        char *cp,*jdkcp,*path;
        int i;
        for(i=0; i<MAX_JAVA_ZIP_ARCHIVES; i++) {
                if (s_zipArchivTab[i].fn[0] == 0) break;
                s_zipArchivTab[i].fn[0]=0;
        }
        s_javaSourcePaths = getSourcePath(0);
        if (s_javaSourcePaths==NULL) {
                if (((s_language & (4)) != 0)) {
                        error(ERR_ST,"no classpath or sourcepath specified");
                }
                s_javaSourcePaths = s_defaultClassPath;
        }
        cp = getClassPath(1);
        crOptionStr(&s_opt.classpath, cp);
        s_javaClassPaths = NULL;
        processClassPathString( cp);
        jdkcp = getJdkClassPathFastly();
        if (jdkcp != NULL && *jdkcp!=0) {
                crOptionStr(&s_opt.jdkClassPath, jdkcp);
                processClassPathString( jdkcp);
        }
        if (((s_language & (4)) != 0) && s_opt.taskRegime != RegimeEditServer) {
                static int messageFlag=0;
                if (messageFlag==0 && ! s_opt.briefoutput) {
                        FILE *ofile;
                        if (s_opt.xref2) {
                                if (jdkcp!=NULL && *jdkcp!=0) {
                                        sprintf(tmpBuff,"java runtime == %s", jdkcp);
                                        ppcGenRecord(PPC_INFORMATION, tmpBuff, "\n");
                                }
                                sprintf(tmpBuff,"classpath == %s", cp);
                                ppcGenRecord(PPC_INFORMATION, tmpBuff, "\n");
                                sprintf(tmpBuff,"sourcepath == %s", s_javaSourcePaths);
                                ppcGenRecord(PPC_INFORMATION, tmpBuff, "\n");
                        } else {
                                if (jdkcp!=NULL && *jdkcp!=0) {
                                        fprintf(dumpOut,"java runtime == %s\n", jdkcp);
                                }
                                fprintf(dumpOut,"classpath == %s\n", cp);
                                fprintf(dumpOut,"sourcepath == %s\n", s_javaSourcePaths);
                                fflush(dumpOut);
                        }
                        messageFlag = 1;
                }
        }
}
int changeRefNumOption(int newRefNum) {
        int check;
        if (s_opt.refnum == 0) check=1;
        else if (s_opt.refnum == 1) check = (newRefNum <= 1);
        else check = (newRefNum == s_opt.refnum);
        s_opt.refnum = newRefNum;
        return(check);
}
void getXrefrcFileName(char *ttt) {
        int hlen;
        char *hh;
        if (s_opt.xrefrc!=NULL) {
                sprintf(ttt, normalizeFileName(s_opt.xrefrc, s_cwd));
                return;
        }
        hh = getenv("HOME");
#ifdef __WIN32__
        if (hh == NULL) hh = "c:\\";
#else
        if (hh == NULL) hh = "";
#endif
        hlen = strlen(hh);
        if (hlen>0 && (hh[hlen-1]=='/' || hh[hlen-1]=='\\')) {
                sprintf(ttt, "%s%cxrefrc", hh, FILE_BEGIN_DOT);
        } else {
                sprintf(ttt, "%s%c%cxrefrc", hh, SLASH, FILE_BEGIN_DOT);
        }
        { if (!(strlen(ttt) < MAX_FILE_NAME_SIZE-1)) internalCheckFail("strlen(ttt) < MAX_FILE_NAME_SIZE-1", "options.c", 841);};
}
void optionsVisualEdit() {
}
