
/*

Copyright (C) Marian Vittek, Xref-Tech, Bratislava, 1997-2002.
All Rights Reserved.

    THIS FILE IS CONSIDERED A TRADE SECRET BY XREF-TECH.
UNAUTHORIZED ACCESS, USE, REPRODUCTION OR DISTRIBUTION IS PROHIBITED.

*/
#ifndef STDINC__H
#define STDINC__H
#if defined(__WIN32) && (! defined(__WIN32__))
#define __WIN32__ 1
#endif
#ifdef __WIN32__
#include <windows.h>
#include <direct.h>
#else
#include <unistd.h>
#include <dirent.h>
#endif
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <assert.h>
#include <string.h>
#include <time.h>
#include <setjmp.h>
#include <sys/types.h>
#include <sys/stat.h>
#endif
#include "head2.h"
#include "proto.h"
static char * VERSION_NUMBER = "1.5.10je";
static char * FILE_VERSION_NUMBER = "1.5.10je";
static char * PPC_VERSION_MISMATCH = "version-mismatch";
static char * PPC_MULTIPLE_COMPLETIONS = "completions";
static char * PPC_MULTIPLE_COMPLETION_LINE = "cl";
static char * PPC_SINGLE_COMPLETION = "single-completion";
static char * PPC_FQT_COMPLETION = "fqt-completion";
static char * PPC_SYMBOL_LIST = "symbol-list";
static char * PPC_REFACTORING_PRECHECK = "precheck";
static char * PPC_REFACTORING_REPLACEMENT = "replacement";
static char * PPC_REFACTORING_REPLACE = "replace";
static char * PPC_REFACTORING_REPLACE_WITH = "with";
static char * PPC_REFACTORING_CUT_BLOCK = "cut-block";
static char * PPC_REFACTORING_COPY_BLOCK = "copy-block";
static char * PPC_REFACTORING_PASTE_BLOCK = "past-block";
static char * PPC_EXTRACTION_DIALOG = "extraction-dialog";
static char * PPC_DISPLAY_CLASS_TREE = "display-class-tree";
static char * PPC_DISPLAY_RESOLUTION = "display-resolution";
static char * PPC_DISPLAY_OR_UPDATE_BROWSER = "display-or-update-browser";
static char * PPC_SYMBOL_RESOLUTION = "resolution";
static char * PPC_SYMBOL = "symbol";
static char * PPC_VIRTUAL_SYMBOL = "virtual-symbol";
static char * PPC_CLASS = "class";
static char * PPC_REFERENCE_LIST = "reference-list";
static char * PPC_SRC_LINE = "src-line";
static char * PPC_UPDATE_CURRENT_REFERENCE = "update-current-refn";
static char * PPC_NO_PROJECT = "no-project-found";
static char * PPC_SET_PROJECT = "set-project";
static char * PPC_SET_INFO = "set-info";
static char * PPC_WARNING = "warning";
static char * PPC_ERROR = "error";
static char * PPC_FATAL_ERROR = "fatalError";
static char * PPC_INFORMATION = "information";
static char * PPC_BOTTOM_INFORMATION = "bottom-information";
static char * PPC_DEBUG_INFORMATION = "debug-information";
static char * PPC_ASK_CONFIRMATION = "ask-confirmation";
static char * PPC_GOTO = "goto";
static char * PPC_BROWSE_URL = "browse-url";
static char * PPC_FILE_SAVE_AS = "file-save-as";
static char * PPC_MOVE_FILE_AS = "file-move-as";
static char * PPC_FILE_REMOVE = "file-remove";
static char * PPC_MOVE_DIRECTORY = "move-directory";
static char * PPC_INDENT = "indent-block";
static char * PPC_IGNORE = "ignore";
static char * PPC_PROGRESS = "progress";
static char * PPC_UPDATE_REPORT = "update-report";
static char * PPC_AVAILABLE_REFACTORINGS = "available-refactorings";
static char * PPC_SYNCHRO_RECORD = "sync";
static char * PPC_LC_POSITION = "position-lc";
static char * PPC_OFFSET_POSITION = "position-off";
static char * PPC_STRING_VALUE = "string-value";
static char * PPC_INT_VALUE = "int-value";
static char * PPCA_LEN = "len";
static char * PPCA_LINE = "line";
static char * PPCA_COL = "col";
static char * PPCA_OFFSET = "off";
static char * PPCA_VALUE = "val";
static char * PPCA_SELECTED = "selected";
static char * PPCA_BASE = "base";
static char * PPCA_DEF_REFN = "drefn";
static char * PPCA_REFN = "refn";
static char * PPCA_TYPE = "type";
static char * PPCA_MTYPE = "mtype";
static char * PPCA_CONTINUE = "continue";
static char * PPCA_INTERFACE = "interface";
static char * PPCA_INDENT = "indent";
static char * PPCA_TREE_DEPS = "deps";
static char * PPCA_TREE_UP = "up";
static char * PPCA_DEFINITION = "definition";
static int PPCV_BROWSER_TYPE_INFO = 0;
static int PPCV_BROWSER_TYPE_WARNING = 1;
static int PPC_AVR_NO_REFACTORING = 0;
static int PPC_AVR_RENAME_SYMBOL = 1;
static int PPC_AVR_RENAME_CLASS = 2;
static int PPC_AVR_RENAME_PACKAGE = 3;
static int PPC_AVR_ADD_PARAMETER = 4;
static int PPC_AVR_DEL_PARAMETER = 5;
static int PPC_AVR_MOVE_PARAMETER = 6;
static int PPC_AVR_EXTRACT_METHOD = 7;
static int PPC_AVR_EXTRACT_MACRO = 8;
static int PPC_AVR_MOVE_STATIC_FIELD = 9;
static int PPC_AVR_MOVE_STATIC_METHOD = 10;
static int PPC_AVR_MOVE_FIELD = 11;
static int PPC_AVR_PULL_UP_FIELD = 12;
static int PPC_AVR_PULL_UP_METHOD = 13;
static int PPC_AVR_PUSH_DOWN_FIELD = 14;
static int PPC_AVR_PUSH_DOWN_METHOD = 15;
static int PPC_AVR_MOVE_CLASS = 16;
static int PPC_AVR_ENCAPSULATE_FIELD = 17;
static int PPC_AVR_SELF_ENCAPSULATE_FIELD = 18;
static int PPC_AVR_TURN_DYNAMIC_METHOD_TO_STATIC = 19;
static int PPC_AVR_TURN_STATIC_METHOD_TO_DYNAMIC = 20;
static int PPC_AVR_REDUCE_NAMES = 21;
static int PPC_AVR_EXPAND_NAMES = 22;
static int PPC_AVR_SET_MOVE_TARGET = 23;
static int PPC_MAX_AVAILABLE_REFACTORINGS = 24;
static S_editorUndo *s_refactoringStartPoint;
static int s_refactoryXrefEditSrvSubTaskFirstPassing = 1;
static char *s_refactoryEditSrvInitOptions[] = {
        "xref",
        "-xrefactory-II",
        "-task_regime_server",
        NULL,
};
static char *s_refactoryXrefInitOptions[] = {
        "xref",
        "-xrefactory-II",
        "-briefoutput",
        "-fastupdate",
        NULL,
};
static int argnum(char **margv) {
        int res;
        char **aa;
        for(res=0, aa=margv; *margv!=NULL; res++,margv++) ;
        return(res);
}
int filter0(S_reference *rr) {
        if (rr->usage < UsageMaxOLUsages) return(1);
        return(0);
}
int filter1(S_reference *rr) {
        if (rr->usage < s_refListFilters[1]) return(1);
        return(0);
}
int filter2(S_reference *rr) {
        if (rr->usage < s_refListFilters[2]) return(1);
        return(0);
}
static void refactoringGenGUISynchronisation() {
}
static void refactorySetNargv(char *nargv[50],
                                                          S_editorBuffer *buf,
                                                          char *project,
                                                          S_editorMarker *point,
                                                          S_editorMarker *mark
        ) {
        static char optPoint[TMP_STRING_SIZE];
        static char optMark[TMP_STRING_SIZE];
        static char optXrefrc[MAX_FILE_NAME_SIZE];
        int i;
        i = 0;
        nargv[i] = "null";
        i++;
        if (s_ropt.xrefrc!=NULL) {
                sprintf(optXrefrc, "-xrefrc=%s", s_ropt.xrefrc);
                { if (!(strlen(optXrefrc)+1 < MAX_FILE_NAME_SIZE)) internalCheckFail("strlen(optXrefrc)+1 < MAX_FILE_NAME_SIZE", "refactory.c", 86);};
                nargv[i] = optXrefrc;
                i++;
        }
        if (s_ropt.eolConversion & 1) {
                nargv[i] = "-crlfconversion";
                i++;
        }
        if (s_ropt.eolConversion & 2) {
                nargv[i] = "-crconversion";
                i++;
        }
        if (project!=NULL) {
                nargv[i] = "-p";
                i++;
                nargv[i] = project;
                i++;
        }
        { if (!(i < 50)) internalCheckFail("i < 50", "refactory.c", 104);};
        if (point!=NULL) {
                sprintf(optPoint, "-olcursor=%d", point->offset);
                nargv[i] = optPoint;
                i++;
        }
        { if (!(i < 50)) internalCheckFail("i < 50", "refactory.c", 110);};
        if (mark!=NULL) {
                sprintf(optMark, "-olmark=%d", mark->offset);
                nargv[i] = optMark;
                i++;
        }
        { if (!(i < 50)) internalCheckFail("i < 50", "refactory.c", 116);};
        if (buf!=NULL) {
                { if (!(buf == point->buffer)) internalCheckFail("buf == point->buffer", "refactory.c", 119);};
                nargv[i] = buf->name;
                i++;
        }
        { if (!(i < 50)) internalCheckFail("i < 50", "refactory.c", 132);};
        if (s_ropt.user!=NULL) {
                nargv[i] = "-user";
                i++;
                nargv[i] = s_ropt.user;
                i++;
        }
        nargv[i] = NULL;
        i++;
        { if (!(i < 50)) internalCheckFail("i < 50", "refactory.c", 142);};
}
static void dumpNargv(int argc, char **argv) {
        int i;
        tmpBuff[0]=0;
        for (i=0; i<argc; i++) {
                sprintf(tmpBuff+strlen(tmpBuff), " %s", argv[i]);
        }
        ppcGenRecord(PPC_INFORMATION, tmpBuff, "\n");
}
static void refactoryUpdateReferences(char *project) {
        int i, nargc, refactoryXrefInitOptionsNum;
        S_editorBuffer bb;
        char *nargv[50];
        static S_options savedOptions;
        ppcGenRecordBegin(PPC_UPDATE_REPORT);
        editorQuasySaveModifiedBuffers();
        copyOptions(&savedOptions, &s_opt);
        refactorySetNargv(nargv, NULL, project, NULL, NULL);
        nargc = argnum(nargv);
        refactoryXrefInitOptionsNum = argnum(s_refactoryXrefInitOptions);
        for(i=1; i<refactoryXrefInitOptionsNum; i++) {
                nargv[nargc++] = s_refactoryXrefInitOptions[i];
        }
        s_currCppPass = (-1);
        mainTaskEntryInitialisations(nargc, nargv);
        mainCallXref(nargc, nargv);
        copyOptions(&s_opt, &savedOptions);
        ppcGenRecordEnd(PPC_UPDATE_REPORT);
        mainTaskEntryInitialisations(argnum(s_refactoryEditSrvInitOptions),
                                                                 s_refactoryEditSrvInitOptions);
        s_refactoryXrefEditSrvSubTaskFirstPassing = 1;
        return;
}
static void refactoryEditServerParseBuffer(char *project,
                                                                                   S_editorBuffer *buf,
                                                                                   S_editorMarker *point, S_editorMarker *mark,
                                                                                   char *pushOption, char *pushOption2
        ) {
        char *nargv[50];
        int nargc;
        s_currCppPass = (-1);
        copyOptions(&s_cachedOptions, &s_opt);
        { if (!(s_opt.taskRegime == RegimeEditServer)) internalCheckFail("s_opt.taskRegime == RegimeEditServer", "refactory.c", 211);};
        refactorySetNargv(nargv, buf, project, point, mark);
        nargc = argnum(nargv);
        if (pushOption!=NULL) {
                nargv[nargc++] = pushOption;
        }
        if (pushOption2!=NULL) {
                nargv[nargc++] = pushOption2;
        }
        mainCallEditServerInit(nargc, nargv);
        mainCallEditServer(argnum(s_refactoryEditSrvInitOptions),
                                           s_refactoryEditSrvInitOptions,
                                           nargc, nargv, &s_refactoryXrefEditSrvSubTaskFirstPassing);
}
static void refactoryBeInteractive() {
        int pargc;
        char **pargv;
        copyOptions(&s_cachedOptions, &s_opt);
        for(;;) {
                mainCloseOutputFile();
                ppcGenSynchroRecord();
                copyOptions(&s_opt, &s_cachedOptions);
                processOptions(argnum(s_refactoryEditSrvInitOptions),
                                           s_refactoryEditSrvInitOptions, INFILES_DISABLED);
                getPipedOptions(&pargc, &pargv);
                mainOpenOutputFile(s_ropt.outputFileName);
                if (pargc <= 1) break;
                mainCallEditServerInit(pargc, pargv);
                mainCallEditServer(argnum(s_refactoryEditSrvInitOptions),
                                                   s_refactoryEditSrvInitOptions,
                                                   pargc, pargv, &s_refactoryXrefEditSrvSubTaskFirstPassing);
                mainAnswerEditAction();
        }
}
void refactoryDisplayResolutionDialog(char *message,int messageType,int continuation) {
        int pargc;
        char **pargv;
        ppcGenDisplaySelectionRecord(message, messageType, continuation);
        refactoryBeInteractive();
}
static void refactoryPushReferences(S_editorBuffer *buf, S_editorMarker *point,
                                                                        char *pushOption, char *resolveMessage,
                                                                        int messageType
        ) {
        refactoryEditServerParseBuffer( s_ropt.project, buf, point,NULL, pushOption,NULL);
        { if (!(s_olcxCurrentUser!=NULL && s_olcxCurrentUser->tops!=NULL)) internalCheckFail("s_olcxCurrentUser!=NULL && s_olcxCurrentUser->tops!=NULL", "refactory.c", 270);};
        if (s_olcxCurrentUser->tops->hkSelectedSym==NULL) {
                error(ERR_INTERNAL, "no symbol found for refactoring push");
        }
        olCreateSelectionMenu();
        if (olcxShowSelectionMenu()) {
                refactoryDisplayResolutionDialog( resolveMessage, messageType,CONTINUATION_ENABLED);
        }
}
static void refactorySafetyCheck(char *project, S_editorBuffer *buf, S_editorMarker *point) {
        refactoryUpdateReferences(s_ropt.project);
        refactoryEditServerParseBuffer( project, buf, point,NULL, "-olcxsafetycheck2",NULL);
        { if (!(s_olcxCurrentUser!=NULL && s_olcxCurrentUser->tops!=NULL)) internalCheckFail("s_olcxCurrentUser!=NULL && s_olcxCurrentUser->tops!=NULL", "refactory.c", 285);};
        if (s_olcxCurrentUser->tops->hkSelectedSym==NULL) {
                error(ERR_ST, "No symbol found for refactoring safety check");
        }
        olCreateSelectionMenu();
        if (safetyCheck2ShouldWarn()) {
                refactoryDisplayResolutionDialog(
                        "This is  class hierarchy of given  symbol as it will  appear after the\nrefactoring.  It  does not  corresponf  to  the  hierarchy before  the\nrefactoring. It is probable that the refactoring will not be behaviour\npreserving. If you are not  sure about your action, you should abandon\nthis refactoring!",
                        PPCV_BROWSER_TYPE_WARNING,CONTINUATION_ENABLED);
        }
}
static char *refactoryGetIdentifierOnMarker_st(S_editorMarker *pos) {
        S_editorBuffer *buff;
        char *s, *e, *smax, *smin;
        static char res[TMP_STRING_SIZE];
        int reslen;
        buff = pos->buffer;
        { if (!(buff && buff->a.text && pos->offset<=buff->a.bufferSize)) internalCheckFail("buff && buff->a.text && pos->offset<=buff->a.bufferSize", "refactory.c", 304);};
        s = buff->a.text + pos->offset;
        smin = buff->a.text;
        smax = buff->a.text + buff->a.bufferSize;
        for(; s>=smin && (isalpha(*s) || isdigit(*s) || *s=='_' || *s=='$'); s--) ;
        for(s++; s<smax && isdigit(*s); s++) ;
        for(e=s; e<smax && (isalpha(*e) || isdigit(*e) || *e=='_' || *e=='$'); e++) ;
        reslen = e-s;
        { if (!(reslen < TMP_STRING_SIZE-1)) internalCheckFail("reslen < TMP_STRING_SIZE-1", "refactory.c", 314);};
        strncpy(res, s, reslen);
        res[reslen] = 0;
        return(res);
}
static void refactoryReplaceString(S_editorMarker *pos, int len, char *newVal) {
        char *bVal;
        bVal = pos->buffer->a.text + pos->offset;
        editorReplaceString(pos->buffer, pos->offset, len,
                                                newVal, strlen(newVal), &s_editorUndo);
}
static void refactoryCheckedReplaceString(S_editorMarker *pos, int len,
                                                                                  char *oldVal, char *newVal) {
        char *bVal;
        int check;
        bVal = pos->buffer->a.text + pos->offset;
        check = strlen(oldVal)==len && strncmp(oldVal, bVal, len);
        if (check == 0) {
                refactoryReplaceString(pos, len, newVal);
        } else {
                sprintf(tmpBuff, "checked replacement of %s to %s failed\n", oldVal, newVal);
                error(ERR_INTERNAL, tmpBuff);
        }
}
static void editorFreeSingleUndo(S_editorUndo *uu) {
        if (uu->u.replace.str!=NULL && uu->u.replace.strlen!=0) {
                switch (uu->operation) {
                case UNDO_REPLACE_STRING:
                        { int n = (int) (((char*)((uu->u.replace.strlen)))+(STANDARD_ALLIGNEMENT-1-((((unsigned)((uu->u.replace.strlen)))-1) & (STANDARD_ALLIGNEMENT-1)))); * (void **) uu->u.replace.str = olcxMemoryFreeList[n]; olcxMemoryFreeList[n] = uu->u.replace.str;};
                        break;
                case UNDO_RENAME_BUFFER:
                        { int n = (int) (((char*)((strlen(uu->u.rename.name)+1)))+(STANDARD_ALLIGNEMENT-1-((((unsigned)((strlen(uu->u.rename.name)+1)))-1) & (STANDARD_ALLIGNEMENT-1)))); * (void **) uu->u.rename.name = olcxMemoryFreeList[n]; olcxMemoryFreeList[n] = uu->u.rename.name;};
                        break;
                case UNDO_MOVE_BLOCK:
                        break;
                default:
                        error(ERR_INTERNAL,"Unknown operation to undo");
                }
        }
        { int n = (int) (((char*)((sizeof(S_editorUndo))))+(STANDARD_ALLIGNEMENT-1-((((unsigned)((sizeof(S_editorUndo))))-1) & (STANDARD_ALLIGNEMENT-1)))); * (void **) uu = olcxMemoryFreeList[n]; olcxMemoryFreeList[n] = uu;};
}
static void editorFreeUndos(S_editorUndo *undos) {
        S_editorUndo *uu, *next;
        uu=undos;
        while (uu!=NULL) {
                next = uu->next;
                editorFreeSingleUndo(uu);
                uu = next;
        }
}
void editorApplyUndos(S_editorUndo *undos, S_editorUndo *until,
                                          S_editorUndo **undoundo, int gen) {
        S_editorUndo *uu, *next;
        S_editorMarker *m1, *m2;
        uu = undos;
        while (uu!=until && uu!=NULL) {
                switch (uu->operation) {
                case UNDO_REPLACE_STRING:
                        if (gen == GEN_FULL_OUTPUT) {
                                ppcGenReplaceRecord(uu->buffer->name, uu->u.replace.offset,
                                                                        uu->buffer->a.text+uu->u.replace.offset,
                                                                        uu->u.replace.size, uu->u.replace.str);
                        }
                        editorReplaceString(uu->buffer, uu->u.replace.offset, uu->u.replace.size,
                                                                uu->u.replace.str, uu->u.replace.strlen, undoundo);
                        break;
                case UNDO_RENAME_BUFFER:
                        if (gen == GEN_FULL_OUTPUT) {
                                ppcGenGotoOffsetPosition(uu->buffer->name, 0);
                                ppcGenRecord(PPC_MOVE_FILE_AS, uu->u.rename.name, "\n");
                        }
                        editorRenameBuffer(uu->buffer, uu->u.rename.name, undoundo);
                        break;
                case UNDO_MOVE_BLOCK:
                        m1 = editorCrNewBufferMarker(uu->buffer, uu->u.moveBlock.offset);
                        m2 = editorCrNewBufferMarker(uu->u.moveBlock.dbuffer, uu->u.moveBlock.doffset);
                        if (gen == GEN_FULL_OUTPUT) {
                                ppcGenGotoMarkerRecord(m1);
                                ppcGenNumericRecord(PPC_REFACTORING_CUT_BLOCK,uu->u.moveBlock.size,"","\n");
                        }
                        editorMoveBlock(m2, m1, uu->u.moveBlock.size, undoundo);
                        if (gen == GEN_FULL_OUTPUT) {
                                ppcGenGotoMarkerRecord(m1);
                                ppcGenRecord(PPC_REFACTORING_PASTE_BLOCK, "", "\n");
                        }
                        editorFreeMarker(m2);
                        editorFreeMarker(m1);
                        break;
                default:
                        error(ERR_INTERNAL,"Unknown operation to undo");
                }
                next = uu->next;
                editorFreeSingleUndo(uu);
                uu = next;
        }
        { if (!(uu==until)) internalCheckFail("uu==until", "refactory.c", 416);};
}
void editorUndoUntil(S_editorUndo *until, S_editorUndo **undoundo) {
        editorApplyUndos(s_editorUndo, until, undoundo, GEN_NO_OUTPUT);
        s_editorUndo = until;
}
static void refactoryAplyWholeRefactoringFromUndo() {
        S_editorUndo *redoTrack;
        redoTrack = NULL;
        editorUndoUntil(s_refactoringStartPoint, &redoTrack);
        editorApplyUndos(redoTrack, NULL, NULL, GEN_FULL_OUTPUT);
}
static void refactoryFatalErrorOnPosition(S_editorMarker *p, int errType, char *message) {
        S_editorUndo *redo;
        redo = NULL;
        editorUndoUntil(s_refactoringStartPoint, &redo);
        ppcGenGotoMarkerRecord(p);
        fatalError(errType, message, 65);
        editorApplyUndos(redo, NULL, &s_editorUndo, GEN_NO_OUTPUT);
}
static void refactoryRemoveNonCommentCode(S_editorMarker *m, int len) {
        int c, nn, n;
        char *s;
        S_editorMarker *mm;
        { if (!(m->buffer && m->buffer->a.text)) internalCheckFail("m->buffer && m->buffer->a.text", "refactory.c", 447);};
        s = m->buffer->a.text + m->offset;
        nn = len;
        mm = editorCrNewBufferMarker(m->buffer, m->offset);
        if (m->offset + nn > m->buffer->a.bufferSize) {
                nn = m->buffer->a.bufferSize - m->offset;
        }
        n = 0;
        while(nn>0) {
                c = *s;
                if (c=='/' && nn>1 && *(s+1)=='*' && (nn<=2 || *(s+2)!='&')) {
                        refactoryReplaceString(mm, n, "");
                        s = mm->buffer->a.text + mm->offset;
                        s += 2; nn -= 2;
                        while (! (*s=='*' && *(s+1)=='/')) {s++; nn--;}
                        s += 2; nn -= 2;
                        mm->offset = s - mm->buffer->a.text;
                        n = 0;
                } else if (c=='/' && nn>1 && *(s+1)=='/' && (nn<=2 || *(s+2)!='&')) {
                        refactoryReplaceString(mm, n, "");
                        s = mm->buffer->a.text + mm->offset;
                        s += 2; nn -= 2;
                        while (*s!='\n') {s++; nn--;}
                        s += 1; nn -= 1;
                        mm->offset = s - mm->buffer->a.text;
                        n = 0;
                } else if (c=='"') {
                        s++; nn--; n++;
                        while (*s!='"' && nn>0) {
                                s++; nn--; n++;
                                if (*s=='\\') {
                                        s++; nn--; n++;
                                        s++; nn--; n++;
                                }
                        }
                } else {
                        s++; nn--; n++;
                }
        }
        if (n>0) {
                refactoryReplaceString(mm, n, "");
        }
        editorFreeMarker(mm);
}
static void refactoryRenameTo(S_editorMarker *pos, char *oldName, char *newName) {
        char *actName;
        int nlen;
        nlen = strlen(oldName);
        actName = refactoryGetIdentifierOnMarker_st(pos);
        { if (!(strcmp(actName, oldName)==0)) internalCheckFail("strcmp(actName, oldName)==0", "refactory.c", 500);};
        refactoryCheckedReplaceString(pos, nlen, oldName, newName);
}
static S_editorMarker *refactoryPointMark(S_editorBuffer *buf, int offset) {
        S_editorMarker *point;
        point = NULL;
        if (offset >= 0) {
                point = editorCrNewBufferMarker(buf, offset);
        }
        return(point);
}
static S_editorMarker *refactoryGetPointFromRefactoryOptions(S_editorBuffer *buf) {
        return(refactoryPointMark(buf, s_ropt.olCursorPos));
}
static S_editorMarker *refactoryGetMarkFromRefactoryOptions(S_editorBuffer *buf) {
        return(refactoryPointMark(buf, s_ropt.olMarkPos));
}
static void refactoryPushMarkersAsReferences(S_editorMarkerList **markers,
                                                                                         S_olcxReferences *refs, char *sym) {
        S_olSymbolsMenu *mm;
        S_reference *r, *rr;
        rr = editorMarkersToReferences(markers);
        for(mm=refs->menuSym; mm!=NULL; mm=mm->next) {
                if (strcmp(mm->s.name, sym)==0) {
                        for(r=rr; r!=NULL; r=r->next) {
                                olcxAddReference(&mm->s.refs, r, 0);
                        }
                }
        }
        olcxFreeReferences(rr);
        olcxRecomputeSelRefs(refs);
}
static int refactoryHandleSafetyCheckDifferenceLists(
        S_editorMarkerList *diff1, S_editorMarkerList *diff2, S_olcxReferences *diffrefs
        ) {
        int res, pbflag;
        S_olcxReferences *refs;
        S_olSymbolsMenu *mm;
        res = 1;
        if (diff1!=NULL || diff2!=NULL) {
                res = 0;
                for(mm=diffrefs->menuSym; mm!=NULL; mm=mm->next) {
                        mm->selected = mm->visible = 1;
                        mm->ooBits = 07777777;
                        olcxFreeReferences(mm->s.refs); mm->s.refs = NULL;
                }
                refactoryPushMarkersAsReferences(&diff1, diffrefs, "  Conflicting References");
                refactoryPushMarkersAsReferences(&diff2, diffrefs, "  Conflicting References");
                editorFreeMarkerListNotMarkers(diff1);
                editorFreeMarkerListNotMarkers(diff2);
                olcxReferencePopOnly();
                if (s_ropt.theRefactoring == PPC_AVR_RENAME_PACKAGE) {
                        refactoryDisplayResolutionDialog(
"The package exists and is referenced in the original project. Renaming\nwill join two packages without possibility of inverse refactoring",
                                PPCV_BROWSER_TYPE_WARNING, CONTINUATION_ENABLED);
                } else {
                        refactoryDisplayResolutionDialog(
                                "Those references will be  misinterpreted after refactoring",
                                PPCV_BROWSER_TYPE_WARNING, CONTINUATION_ENABLED);
                }
        }
        return(res);
}
static int refactoryMakeSafetyCheckAndUndo(
        S_editorBuffer *buf, S_editorMarker *point,
        S_editorMarkerList **occs, S_editorUndo *startPoint,
        S_editorUndo **redoTrack
        ) {
        int res, pbflag;
        S_editorMarkerList *chks, *dd;
        S_editorMarker *defin;
        S_reference *df1, *df2, *rr;
        S_editorMarkerList *diff1, *diff2;
        S_olcxReferences *refs, *origrefs, *newrefs, *diffrefs;
        S_olSymbolsMenu *mm;
        for(dd= *occs; dd!=NULL; dd=dd->next) {
                if (( (dd->usage)==UsageDefined || (dd->usage)==UsageOLBestFitDefined)) break;
        }
        if (dd == NULL) defin = point;
        else defin = dd->d;
        olcxPushSpecialCheckMenuSym(OLO_SAFETY_CHECK_INIT, "  Conflicting References");
        refactorySafetyCheck( s_ropt.project, defin->buffer, defin);
        chks = editorReferencesToMarkers(s_olcxCurrentUser->tops->r,filter0);
        editorMarkersDifferences(occs, &chks, &diff1, &diff2);
        editorFreeMarkersAndMarkerList(chks);
        editorUndoUntil(startPoint, redoTrack);
        origrefs = newrefs = diffrefs = NULL;
        { { if (!(s_olcxCurrentUser)) internalCheckFail("s_olcxCurrentUser", "refactory.c", 613);}; refs = s_olcxCurrentUser->tops; if (refs==NULL || refs->previous==NULL || refs->previous->previous==NULL){ error(ERR_INTERNAL, "something goes wrong at safety check"); pbflag = 1; } else { newrefs = refs; diffrefs = refs->previous; origrefs = refs->previous->previous; }};
        { if (!(origrefs!=NULL && newrefs!=NULL && diffrefs!=NULL)) internalCheckFail("origrefs!=NULL && newrefs!=NULL && diffrefs!=NULL", "refactory.c", 614);};
        res = refactoryHandleSafetyCheckDifferenceLists(diff1, diff2, diffrefs);
        return(res);
}
void refactoryAskForReallyContinueConfirmation() {
        ppcGenRecord(PPC_ASK_CONFIRMATION,"The refactoring may change program behaviour, really continue?", "\n");
}
static void refactoryPreCheckThatSymbolRefsCorresponds(char *oldName, S_editorMarkerList *occs) {
        char *bVal, *cid;
        int check, off1, off2;
        S_editorMarkerList *ll;
        S_editorMarker *pos, *pp;
        for(ll=occs; ll!=NULL; ll=ll->next) {
                pos = ll->d;
                cid = refactoryGetIdentifierOnMarker_st(pos);
                if (strcmp(cid, oldName)!=0) {
                        sprintf(tmpBuff,
                                   "something goes wrong: expecting %s instead of %s at %s, offset:%d",
                                   oldName, cid, simpleFileName(getRealFileNameStatic(pos->buffer->name)),
                                   pos->offset);
                        error(ERR_INTERNAL, tmpBuff);
                        return;
                }
                off1 = pos->offset - 1;
                off2 = pos->offset + strlen(oldName) + 1;
                if (off1 < 0) off1 = 0;
                if (off2 >= pos->buffer->a.bufferSize) off2 = pos->buffer->a.bufferSize-1;
                pp = editorCrNewBufferMarker(pos->buffer, off1);
                bVal = pos->buffer->a.text + off1;
                ppcGenPreCheckRecord(pp, off2-off1);
                editorFreeMarker(pp);
        }
}
static S_editorMarker *refactoryCrNewMarkerForExpressionBegin(S_editorMarker *d, int kind) {
        S_editorMarker *pp;
        S_editorBuffer *bb;
        S_position *pos;
        refactoryEditServerParseBuffer( s_ropt.project, d->buffer,
                                                                   d,NULL, "-olcxprimarystart",NULL);
        olStackDeleteSymbol(s_olcxCurrentUser->tops);
        if (kind == GET_PRIMARY_START) {
                pos = &s_primaryStartPosition;
        } else if (kind == GET_STATIC_PREFIX_START) {
                pos = &s_staticPrefixStartPosition;
        } else {
                pos = NULL;
                { if (!(0)) internalCheckFail("0", "refactory.c", 665);};
        }
        if (pos->file == s_noneFileIndex) {
                if (kind == GET_STATIC_PREFIX_START) {
                        refactoryFatalErrorOnPosition(d, ERR_ST, "Can't determine static prefix. Maybe non-static reference\nto a static object? Make this invocation static before refactoring.");
                } else {
                        refactoryFatalErrorOnPosition(d, ERR_INTERNAL, "Can't determine beginning of primary expression");
                }
                return(NULL);
        } else {
                bb = editorGetOpenedAndLoadedBuffer(s_fileTab.tab[pos->file]->name);
                pp = editorCrNewBufferMarker(bb, 0);
                editorMoveMarkerToLineCol(pp, pos->line, pos->coll);
                { if (!(pp->buffer == d->buffer)) internalCheckFail("pp->buffer == d->buffer", "refactory.c", 678);};
                { if (!(pp->offset <= d->offset)) internalCheckFail("pp->offset <= d->offset", "refactory.c", 679);};
                return(pp);
        }
}
static int refactoryShouldIMoveDirectoryNow(S_editorUndo *undoBase, char *dir) {
        S_editorUndo *uu;
        int dlen;
        dlen = strlen(dir);
        for(uu = s_editorUndo; uu!=NULL && uu!=undoBase; uu=uu->next) {
                if (uu->operation == UNDO_RENAME_BUFFER) {
                        if (fnnCmp(uu->u.rename.name, dir, dlen)==0
                                && (uu->u.rename.name[dlen] == '/'
                                        || uu->u.rename.name[dlen] == '\\')) {
                                return(0);
                        }
                }
        }
        return(1);
}
static void refactoryCheckedRenameBuffer(
        S_editorBuffer *buff, char *newName, S_editorUndo **undo
        ) {
        struct stat st;
        if (statb(newName, &st)==0) {
                sprintf(tmpBuff, "Renaming buffer %s to an existing file. Can I do this?", buff->name);
                ppcGenRecord(PPC_ASK_CONFIRMATION, tmpBuff, "\n");
        }
        editorRenameBuffer(buff, newName, undo);
}
static void refactoryMoveFileAndDirForPackageRename(
        char *currentPath, S_editorUndo *undoBase, S_editorMarker *lld,
        char *symLinkName
        ) {
        char newfile[MAX_FILE_NAME_SIZE];
        char packdir[MAX_FILE_NAME_SIZE];
        char newpackdir[MAX_FILE_NAME_SIZE];
        char path[MAX_FILE_NAME_SIZE];
        int plen;
        strcpy(path, currentPath);
        plen = strlen(path);
        if (plen>0 && (path[plen-1]=='/'||path[plen-1]=='\\')) {
                plen--;
                path[plen]=0;
        }
        sprintf(packdir, "%s%c%s", path, SLASH, symLinkName);
        sprintf(newpackdir, "%s%c%s", path, SLASH, s_ropt.renameTo);
        javaSlashifyDotName(newpackdir+strlen(path));
        sprintf(newfile, "%s%s", newpackdir, lld->buffer->name+strlen(packdir));
        refactoryCheckedRenameBuffer(lld->buffer, newfile, &s_editorUndo);
}
static void refactorySimplePackageRenaming(
        S_editorMarkerList *occs, S_editorMarker *point,
        char *symname,char *symLinkName, int symtype
        ) {
        char rtpack[MAX_FILE_NAME_SIZE];
        char rtprefix[MAX_FILE_NAME_SIZE];
        char *ss, *singlefname;
        int i, cdirlen, snlen, slnlen, plen;
        S_editorMarkerList *ll;
        S_editorMarker *pp;
        S_editorUndo *rpundo;
        snlen = strlen(symname);
        slnlen = strlen(symLinkName);
        strcpy(rtprefix, s_ropt.renameTo);
        ss = lastOccurenceInString(rtprefix, '.');
        if (ss == NULL) {
                strcpy(rtpack, rtprefix);
                rtprefix[0] = 0;
        } else {
                strcpy(rtpack, ss+1);
                *(ss+1)=0;
        }
        for(ll=occs; ll!=NULL; ll=ll->next) {
                pp = refactoryCrNewMarkerForExpressionBegin(ll->d, GET_STATIC_PREFIX_START);
                if (pp!=NULL) {
                        refactoryRemoveNonCommentCode(pp, ll->d->offset - pp->offset);
                        refactoryCheckedReplaceString(pp, snlen, symname, rtpack);
                        refactoryReplaceString(pp, 0, rtprefix);
                }
                editorFreeMarker(pp);
        }
        rpundo = s_editorUndo;
        for(ll=occs; ll!=NULL; ll=ll->next) {
                if (ll->next == NULL || ll->next->d->buffer!=ll->d->buffer) {
                        { char *currentPath, *jmop_pp, *jmop_ecp; int jmop_i, jmop_ind; char sourcepathes[MAX_SOURCE_PATH_SIZE]; { if (!(s_javaSourcePaths!=NULL)) internalCheckFail("s_javaSourcePaths!=NULL", "refactory.c", 774);}; jmop_pp = s_javaSourcePaths; strcpy(sourcepathes, jmop_pp); currentPath = sourcepathes; jmop_ecp = currentPath+strlen(currentPath); while (currentPath<jmop_ecp) { for(jmop_ind=0; currentPath[jmop_ind]!=0 && currentPath[jmop_ind]!=CLASS_PATH_SEPARATOR; jmop_ind++) ; currentPath[jmop_ind] = 0; jmop_i = jmop_ind; if (jmop_i>0 && currentPath[jmop_i-1]==SLASH) currentPath[--jmop_i] = 0; { plen = strlen(currentPath); if (fnnCmp(ll->d->buffer->name, currentPath, plen)==0 && ll->d->buffer->name[plen] == SLASH && fnnCmp(ll->d->buffer->name+plen+1, symLinkName, slnlen)==0) { refactoryMoveFileAndDirForPackageRename( currentPath, rpundo, ll->d, symLinkName); goto moved; } }; currentPath += jmop_ind; currentPath++; }};
                moved:;
                }
        }
}
static void refactorySimpleRenaming(S_editorMarkerList *occs, S_editorMarker *point,
                                                                        char *symname,char *symLinkName, int symtype) {
        char nfile[MAX_FILE_NAME_SIZE];
        char *ss;
        S_editorMarkerList *ll;
        if (symtype == TypeStruct && ((s_language & (4)) != 0)
                && s_ropt.theRefactoring != PPC_AVR_RENAME_CLASS) {
                error(ERR_INTERNAL, "Use Rename Class to rename classes");
        }
        if (symtype == TypePackage && ((s_language & (4)) != 0)
                && s_ropt.theRefactoring != PPC_AVR_RENAME_PACKAGE) {
                error(ERR_INTERNAL, "Use Rename Package to rename packages");
        }
        if (s_ropt.theRefactoring == PPC_AVR_RENAME_PACKAGE) {
                refactorySimplePackageRenaming(occs, point, symname, symLinkName, symtype);
        } else {
                for(ll=occs; ll!=NULL; ll=ll->next) {
                        refactoryRenameTo(ll->d, symname, s_ropt.renameTo);
                }
                ppcGenGotoMarkerRecord(point);
                if (s_ropt.theRefactoring == PPC_AVR_RENAME_CLASS) {
                        if (strcmp(simpleFileNameWithoutSuffix_st(point->buffer->name), symname)==0) {
                                strcpy(nfile, point->buffer->name);
                                ss = lastOccurenceInString(nfile, SLASH);
                                if (ss==NULL) ss=nfile;
                                else ss++;
                                sprintf(ss, "%s.java", s_ropt.renameTo);
                                { if (!(strlen(nfile) < MAX_FILE_NAME_SIZE-1)) internalCheckFail("strlen(nfile) < MAX_FILE_NAME_SIZE-1", "refactory.c", 818);};
                                if (strcmp(nfile, point->buffer->name)!=0) {
                                        refactoryCheckedRenameBuffer(point->buffer, nfile, &s_editorUndo);
                                }
                        }
                }
        }
}
static S_editorMarkerList *refactoryGetReferences(
        S_editorBuffer *buf, S_editorMarker *point,
        char *resolveMessage, int messageType
        ) {
        S_editorMarkerList *occs;
        refactoryPushReferences( buf, point, "-olcxrename", resolveMessage,
                                                        messageType);
        { if (!(s_olcxCurrentUser->tops && s_olcxCurrentUser->tops->hkSelectedSym)) internalCheckFail("s_olcxCurrentUser->tops && s_olcxCurrentUser->tops->hkSelectedSym", "refactory.c", 835);};
        occs = editorReferencesToMarkers(s_olcxCurrentUser->tops->r, filter0);
        return(occs);
}
static S_editorMarkerList *refactoryPushGetAndPreCheckReferences(
        S_editorBuffer *buf, S_editorMarker *point, char *nameOnPoint,
        char *resolveMessage, int messageType
        ) {
        S_editorMarkerList *occs;
        occs = refactoryGetReferences(buf, point, resolveMessage, messageType);
        refactoryPreCheckThatSymbolRefsCorresponds(nameOnPoint, occs);
        return(occs);
}
static void refactoryRename(S_editorBuffer *buf, S_editorMarker *point) {
        char nameOnPoint[TMP_STRING_SIZE];
        char *ss, *symLinkName;
        int check, symtype;
        S_editorMarkerList *occs, *ll, *chks, *diff1, *diff2;
        S_reference *df1, *df2, *rr;
        S_editorUndo *undoStartPoint, *redoTrack;
        S_olSymbolsMenu *csym;
        if (s_ropt.renameTo == NULL) {
                error(ERR_ST, "this refactoring requires -renameto=<new name> option");
        }
        refactoryUpdateReferences(s_ropt.project);
        strcpy(nameOnPoint, refactoryGetIdentifierOnMarker_st(point));
        { if (!(strlen(nameOnPoint) < TMP_STRING_SIZE-1)) internalCheckFail("strlen(nameOnPoint) < TMP_STRING_SIZE-1", "refactory.c", 871);};
        occs = refactoryPushGetAndPreCheckReferences(buf, point, nameOnPoint,"Select classes in left window.  Those classes will be  processed during\nrefactoring. It  is highly recommended  to process whole  hierarchy of\nrelated classes  at once. Unselection  of any class and  its exclusion\nfrom refactoring may cause changes in your program behaviour.\n",PPCV_BROWSER_TYPE_INFO);
        csym = s_olcxCurrentUser->tops->hkSelectedSym;
        symtype = csym->s.b.symType;
        symLinkName = csym->s.name;
        undoStartPoint = s_editorUndo;
        refactorySimpleRenaming( occs, point,nameOnPoint,symLinkName, symtype);
        redoTrack = NULL;
        check = refactoryMakeSafetyCheckAndUndo(buf, point, &occs, undoStartPoint, &redoTrack);
        if (! check) {
                refactoryAskForReallyContinueConfirmation();
        }
        editorApplyUndos(redoTrack, NULL, NULL, GEN_FULL_OUTPUT);
        ppcGenGotoMarkerRecord(point);
        editorFreeMarkersAndMarkerList(occs);
}
static int refactoryGetParamNamePosition(S_editorMarker *pos, char *fname, int argn) {
        char pushOpt[TMP_STRING_SIZE];
        char *actName;
        int res;
        actName = refactoryGetIdentifierOnMarker_st(pos);
        { if (!(strcmp(actName, fname)==0)) internalCheckFail("strcmp(actName, fname)==0", "refactory.c", 901);};
        sprintf(pushOpt, "-olcxgotoparname%d", argn);
        refactoryEditServerParseBuffer( s_ropt.project, pos->buffer, pos,NULL, pushOpt,NULL);
        olcxReferencePopOnly();
        if (s_paramPosition.file != s_noneFileIndex) {
                res = 0;
        } else {
                res = 2;
        }
        return(res);
}
static int refactoryGetParamPosition(S_editorMarker *pos, char *fname, int argn) {
        char pushOpt[TMP_STRING_SIZE];
        char *actName;
        int res;
        actName = refactoryGetIdentifierOnMarker_st(pos);
        { if (!(strcmp(actName, fname)==0)) internalCheckFail("strcmp(actName, fname)==0", "refactory.c", 918);};
        sprintf(pushOpt, "-olcxgetparamcoord%d", argn);
        refactoryEditServerParseBuffer( s_ropt.project, pos->buffer, pos,NULL, pushOpt,NULL);
        olcxReferencePopOnly();
        res = 0;
        if (s_paramBeginPosition.file == s_noneFileIndex
                || s_paramEndPosition.file == s_noneFileIndex
                || s_paramBeginPosition.file == -1
                || s_paramEndPosition.file == -1
                ) {
                ppcGenGotoMarkerRecord(pos);
                error(ERR_INTERNAL, "Can't get end of parameter");
                res = 2;
        }
        if (s_paramBeginPosition.file != s_paramEndPosition.file
                || s_paramBeginPosition.line > s_paramEndPosition.line
                || (s_paramBeginPosition.line == s_paramEndPosition.line
                        && s_paramBeginPosition.coll > s_paramEndPosition.coll)) {
                ppcGenGotoMarkerRecord(pos);
                error(ERR_ST, "Something goes wrong at this occurence, can't get reasonable parameter bornes");
                res = 2;
        }
        if (! ((s_language & (4)) != 0)) {
        }
        return(res);
}
static void dumpContext(S_editorMarker *mm) {
        int i, j, m;
        char tt[REFACTORING_TMP_STRING_SIZE];
        char *text;
        text = mm->buffer->a.text;
        sprintf(tt, "[dumping context at %s:%d]\n", mm->buffer->name, mm->offset);
        j = strlen(tt);
        i = mm->offset;
        i -= 50;
        if (i<0) i=0;
        while (i<mm->offset) {
                tt[j++] = text[i++];
        }
        sprintf(tt+j, "[MARKER]");
        j = strlen(tt);
        m = mm->offset+50;
        if (m>mm->buffer->a.bufferSize) m = mm->buffer->a.bufferSize;
        while (i<m) {
                tt[j++] = text[i++];
        }
        tt[j++]=0;
        ppcGenRecord(PPC_INFORMATION, tt, "\n");
}
static int refactoryAddStringAsParameter(S_editorMarker *pos, S_editorMarker *endm,
                                                                                  char *fname, int argn, char *param) {
        char *actName, *text;
        char pushOpt[TMP_STRING_SIZE];
        char par[REFACTORING_TMP_STRING_SIZE];
        char *sep1, *sep2;
        int ipos,rr,insertionOffset;
        S_editorMarker *mm;
        insertionOffset = -1;
        rr = refactoryGetParamPosition(pos, fname, argn);
        if (rr != 0) {
                error(ERR_INTERNAL, "Problem while adding parameter");
                return(insertionOffset);
        }
        text = pos->buffer->a.text;
        if (endm==NULL) {
                mm = editorCrNewMarkerForPosition(&s_paramBeginPosition);
        } else {
                mm = endm;
                { if (!(mm->buffer->ftnum == s_paramBeginPosition.file)) internalCheckFail("mm->buffer->ftnum == s_paramBeginPosition.file", "refactory.c", 1000);};
                editorMoveMarkerToLineCol(mm, s_paramBeginPosition.line, s_paramBeginPosition.coll);
        }
        sep1=""; sep2="";
        if ((! ( ((s_paramBeginPosition).file != (s_paramEndPosition).file) || ((s_paramBeginPosition).line != (s_paramEndPosition).line) || ((s_paramBeginPosition).coll != (s_paramEndPosition).coll) ))) {
                if (text[mm->offset] == '(') {
                        mm->offset ++;
                        sep1=""; sep2="";
                } else if (text[mm->offset] == ')') {
                        sep1=", "; sep2="";
                } else {
                        { if (!(0)) internalCheckFail("0", "refactory.c", 1014);};
                }
        } else {
                if (text[mm->offset] == '(') {
                        sep1 = "";
                        sep2 = ", ";
                } else {
                        sep1 = " ";
                        sep2 = ",";
                }
                mm->offset ++;
        }
        sprintf(par, "%s%s%s", sep1, param, sep2);
        { if (!(strlen(param) < REFACTORING_TMP_STRING_SIZE-1)) internalCheckFail("strlen(param) < REFACTORING_TMP_STRING_SIZE-1", "refactory.c", 1028);};
        insertionOffset = mm->offset;
        refactoryReplaceString(mm, 0, par);
        if (endm == NULL) {
                editorFreeMarker(mm);
        }
        return(insertionOffset);
}
static int refactoryIsThisSymbolUsed(S_editorMarker *pos) {
        int refn;
        refactoryPushReferences( pos->buffer, pos, "-olcxpushforlm","Select classes in left window.  Those classes will be  processed during\nrefactoring. It  is highly recommended  to process whole  hierarchy of\nrelated classes  at once. Unselection  of any class and  its exclusion\nfrom refactoring may cause changes in your program behaviour.\n",PPCV_BROWSER_TYPE_INFO);
        { register S_reference *tmp; register int co=0; tmp = s_olcxCurrentUser->tops->r; while (tmp!=NULL) {++co; tmp = tmp->next; } refn = co; };
        olcxReferencePopOnly();
        return(refn > 1);
}
static void refactoryCheckThatParameterIsUnused(S_editorMarker *pos, char *fname,
                                                                                                int argn, int checkfor) {
        char *actName, *text;
        char pname[TMP_STRING_SIZE];
        int ipos,rr;
        S_editorMarker *mm;
        rr = refactoryGetParamNamePosition(pos, fname, argn);
        if (rr != 0) {
                ppcGenRecord(PPC_ASK_CONFIRMATION, "Can not parse parameter definition, continue anyway?", "\n");
                return;
        }
        mm = editorCrNewMarkerForPosition(&s_paramPosition);
        strncpy(pname, refactoryGetIdentifierOnMarker_st(mm), TMP_STRING_SIZE);
        pname[TMP_STRING_SIZE-1] = 0;
        text = pos->buffer->a.text;
        if (refactoryIsThisSymbolUsed(mm)) {
                if (checkfor==CHECK_FOR_ADD_PARAM) {
                        sprintf(tmpBuff, "parameter '%s' clashes with an existing symbol, use another name", pname);
                        ppcGenRecord(PPC_ERROR, tmpBuff, "\n");
                } else if (checkfor==CHECK_FOR_DEL_PARAM) {
                        sprintf(tmpBuff, "parameter '%s' is used, delete it anyway?", pname);
                        ppcGenRecord(PPC_ASK_CONFIRMATION, tmpBuff, "\n");
                } else {
                        { if (!(0)) internalCheckFail("0", "refactory.c", 1073);};
                }
        }
        editorFreeMarker(mm);
}
static void refactoryAddParameter(S_editorMarker *pos, char *fname,
                                                                  int argn, int usage) {
        if (( (usage)==UsageDefined || (usage)==UsageOLBestFitDefined)) {
                refactoryAddStringAsParameter(pos,NULL, fname, argn, s_ropt.refpar1
);
                refactoryCheckThatParameterIsUnused(pos, fname, argn
, CHECK_FOR_ADD_PARAM
);
        } else {
                refactoryAddStringAsParameter(pos,NULL, fname, argn, s_ropt.refpar2);
        }
}
static void refactoryDeleteParameter(S_editorMarker *pos, char *fname,
                                                                         int argn, int usage) {
        char *text;
        char pname[TMP_STRING_SIZE];
        int ipos, res;
        S_editorMarker *m1, *m2;
        res = refactoryGetParamPosition(pos, fname, argn);
        if (res != 0) return;
        m1 = editorCrNewMarkerForPosition(&s_paramBeginPosition);
        m2 = editorCrNewMarkerForPosition(&s_paramEndPosition);
        text = pos->buffer->a.text;
        if ((! ( ((s_paramBeginPosition).file != (s_paramEndPosition).file) || ((s_paramBeginPosition).line != (s_paramEndPosition).line) || ((s_paramBeginPosition).coll != (s_paramEndPosition).coll) ))) {
                if (text[m1->offset] == '(') {
                } else if (text[m1->offset] == ')') {
                } else {
                        { if (!(0)) internalCheckFail("0", "refactory.c", 1114);};
                }
                error(ERR_ST, "Parameter out of limit");
        } else {
                if (text[m1->offset] == '(') {
                        m1->offset ++;
                        if (text[m2->offset] == ',') {
                                m2->offset ++;
                        }
                        editorMoveMarkerToNonBlank(m2, 1);
                }
                if (( ( (usage)==UsageDefined || (usage)==UsageOLBestFitDefined) || (usage)==UsageDeclared )) {
                        refactoryCheckThatParameterIsUnused(pos, fname, argn
, CHECK_FOR_DEL_PARAM
);
                }
                { if (!(m1->offset <= m2->offset)) internalCheckFail("m1->offset <= m2->offset", "refactory.c", 1134);};
                refactoryReplaceString(m1, m2->offset - m1->offset, "");
        }
        editorFreeMarker(m1);
        editorFreeMarker(m2);
}
static void refactoryMoveParameter(S_editorMarker *pos, char *fname,
                                                                   int argFrom, int argTo) {
        char *actName, *text;
        char par[REFACTORING_TMP_STRING_SIZE];
        int ipos, res, plen;
        S_editorMarker *m1, *m2;
        res = refactoryGetParamPosition(pos, fname, argFrom);
        if (res != 0) return;
        m1 = editorCrNewMarkerForPosition(&s_paramBeginPosition);
        m2 = editorCrNewMarkerForPosition(&s_paramEndPosition);
        text = pos->buffer->a.text;
        plen = 0;
        par[plen]=0;
        if ((! ( ((s_paramBeginPosition).file != (s_paramEndPosition).file) || ((s_paramBeginPosition).line != (s_paramEndPosition).line) || ((s_paramBeginPosition).coll != (s_paramEndPosition).coll) ))) {
                if (text[m1->offset] == '(') {
                } else if (text[m1->offset] == ')') {
                } else {
                        { if (!(0)) internalCheckFail("0", "refactory.c", 1164);};
                }
                error(ERR_ST, "Parameter out of limit");
        } else {
                m1->offset++;
                editorMoveMarkerToNonBlank(m1, 1);
                m2->offset--;
                editorMoveMarkerToNonBlank(m2, -1);
                m2->offset++;
                { if (!(m1->offset <= m2->offset)) internalCheckFail("m1->offset <= m2->offset", "refactory.c", 1173);};
                plen = m2->offset - m1->offset;
                strncpy(par, (m1->buffer->a.text+m1->offset), plen);
                par[plen]=0;
                refactoryDeleteParameter(pos, fname, argFrom, UsageUsed);
                refactoryAddStringAsParameter(pos, NULL, fname, argTo, par);
        }
        editorFreeMarker(m1);
        editorFreeMarker(m2);
}
static void refactoryApplyParamManip(char *functionName, S_editorMarkerList *occs,
                                                                         int manip, int argn1, int argn2
        ) {
        S_editorMarkerList *ll;
        int progressi, progressn;
        { register S_editorMarkerList *tmp; register int co=0; tmp = occs; while (tmp!=NULL) {++co; tmp = tmp->next; } progressn = co; }; progressi=0;
        for(ll=occs; ll!=NULL; ll=ll->next) {
                if (manip==PPC_AVR_ADD_PARAMETER) {
                        refactoryAddParameter(ll->d, functionName, argn1,
                                                                  ll->usage);
                } else if (manip==PPC_AVR_DEL_PARAMETER) {
                        refactoryDeleteParameter(ll->d, functionName, argn1,
                                                                         ll->usage);
                } else if (manip==PPC_AVR_MOVE_PARAMETER) {
                        refactoryMoveParameter(ll->d, functionName,
                                                                   argn1, argn2
);
                } else {
                        error(ERR_INTERNAL, "unknown parameter manipulation");
                }
                writeRelativeProgress((progressi++)*100/progressn);
        }
        writeRelativeProgress(100);
}
static void refactoryApplyParameterManipulation(S_editorBuffer *buf, S_editorMarker *point,
                                                                                   int manip, int argn1, int argn2) {
        char nameOnPoint[TMP_STRING_SIZE];
        int check;
        S_editorMarkerList *occs, *ll, *chks, *diff1, *diff2;
        S_reference *df1, *df2, *rr;
        S_editorUndo *startPoint, *redoTrack;
        refactoryUpdateReferences(s_ropt.project);
        strcpy(nameOnPoint, refactoryGetIdentifierOnMarker_st(point));
        refactoryPushReferences( buf, point, "-olcxargmanip","Select classes in left window.  Those classes will be  processed during\nrefactoring. It  is highly recommended  to process whole  hierarchy of\nrelated classes  at once. Unselection  of any class and  its exclusion\nfrom refactoring may cause changes in your program behaviour.\n",PPCV_BROWSER_TYPE_INFO);
        occs = editorReferencesToMarkers(s_olcxCurrentUser->tops->r, filter0);
        startPoint = s_editorUndo;
        ppcGenGotoMarkerRecord(point);
        redoTrack = NULL;
        refactoryApplyParamManip(nameOnPoint, occs,
                                                          manip, argn1, argn2
);
        if (((s_language & (4)) != 0)) {
                check = refactoryMakeSafetyCheckAndUndo(buf, point, &occs, startPoint, &redoTrack);
                if (! check) refactoryAskForReallyContinueConfirmation();
                editorApplyUndos(redoTrack, NULL, &s_editorUndo, GEN_NO_OUTPUT);
        }
        editorFreeMarkersAndMarkerList(occs);
}
static void refactoryParameterManipulation(S_editorBuffer *buf, S_editorMarker *point,
                                                                                   int manip, int argn1, int argn2) {
        refactoryApplyParameterManipulation(buf, point, manip, argn1, argn2);
        refactoryAplyWholeRefactoringFromUndo();
        ppcGenGotoMarkerRecord(point);
}
static int createMarkersForAllReferences() {
        S_olSymbolsMenu *mm;
        int res, n;
        res = 0;
        for(mm = s_olcxCurrentUser->tops->menuSym; mm!=NULL; mm=mm->next) {
                { if (!(mm->markers==NULL)) internalCheckFail("mm->markers==NULL", "refactory.c", 1258);};
                if (mm->selected && mm->visible) {
                        mm->markers = editorReferencesToMarkers(mm->s.refs,filter0);
                        { S_editorMarkerList *_macrores; _macrores = (mm->markers); { S_editorMarkerList *a, *b, *todo, *t, **restail; int i, n, contFlag; contFlag = 1; for(n=1; contFlag; n=n+n) { todo=_macrores; _macrores=NULL; restail = &_macrores; contFlag=0; while (todo!=NULL) { a=todo; for(i=1, t=a; i<n && t!=NULL; i++, t=t->next) ; if (t==NULL) { *restail = a; break; } b=t->next; t->next=NULL; for(i=1, t=b; i<n && t!=NULL; i++, t=t->next) ; if (t==NULL) todo=NULL; else { todo=t->next; t->next=NULL; } { while (a!=NULL && b!=NULL) { if (editorMarkerListLess(a, b)) { *restail=a; restail= &(a->next); a=a->next; } else { *restail=b; restail= &(b->next); b=b->next; } } if (a!=NULL) *restail=a; else *restail=b; while (*restail!=NULL) restail= &((*restail)->next);}; contFlag=1; } } } (mm->markers) = _macrores;};
                        { register S_editorMarkerList *tmp; register int co=0; tmp = mm->markers; while (tmp!=NULL) {++co; tmp = tmp->next; } n = co; };
                        res += n;
                }
        }
        return(res);
}
static void refactoryApplyExpandShortNames(S_editorBuffer *buf, S_editorMarker *point) {
        S_olSymbolsMenu *mm;
        S_editorMarkerList *ppp;
        char fqtName[MAX_FILE_NAME_SIZE];
        char fqtNameDot[MAX_FILE_NAME_SIZE];
        char *shortName;
        int shortNameLen, n;
        refactoryEditServerParseBuffer( s_ropt.project, buf, point,NULL, "-olcxnotfqt",NULL);
        olcxPushSpecial("  not fully qualified names");
        createMarkersForAllReferences();
        for(mm = s_olcxCurrentUser->tops->menuSym; mm!=NULL; mm=mm->next) {
                if (mm->selected && mm->visible) {
                        javaGetClassNameFromFileNum(mm->s.vApplClass, fqtName, DOTIFY_NAME);
                        javaDotifyClassName(fqtName);
                        sprintf(fqtNameDot, "%s.", fqtName);
                        shortName = javaGetNudeTypeName(fqtName);
                        shortNameLen = strlen(shortName);
                        if (isdigit(shortName[0])) {
                                goto cont;
                        }
                        for(ppp=mm->markers; ppp!=NULL; ppp=ppp->next) {
                                if (ppp->usage == UsageNonExpandableNotFQTNameInClassOrMethod) {
                                        ppcGenGotoMarkerRecord(ppp->d);
                                        sprintf(tmpBuff, "This occurence of %s would be misinterpreted after expansion to %s.\nNo action made at this place.", shortName, fqtName);
                                        warning(ERR_ST, tmpBuff);
                                } else if (ppp->usage == UsageNotFQFieldInClassOrMethod) {
                                        refactoryReplaceString(ppp->d, 0, fqtNameDot);
                                } else if (ppp->usage == UsageNotFQTypeInClassOrMethod) {
                                        refactoryCheckedReplaceString(ppp->d, shortNameLen, shortName, fqtName
);
                                }
                        }
                }
        cont:;
                editorFreeMarkerListNotMarkers(mm->markers);
                mm->markers = NULL;
        }
}
static void refactoryExpandShortNames(S_editorBuffer *buf, S_editorMarker *point) {
        refactoryApplyExpandShortNames(buf, point);
        refactoryAplyWholeRefactoringFromUndo();
        ppcGenGotoMarkerRecord(point);
}
static S_editorMarker *refactoryReplaceStaticPrefix(S_editorMarker *d, char *npref) {
        int ppoffset;
        S_editorMarker *pp;
        pp = refactoryCrNewMarkerForExpressionBegin(d, GET_STATIC_PREFIX_START);
        if (pp==NULL) {
                pp = editorCrNewBufferMarker(d->buffer, d->offset);
        } else {
                ppoffset = pp->offset;
                refactoryRemoveNonCommentCode(pp, d->offset-pp->offset);
                if (*npref!=0) {
                        refactoryReplaceString(pp, 0, npref);
                }
                pp->offset = ppoffset;
        }
        return(pp);
}
static void refactoryApplyReduceLongNames(S_editorBuffer *buf, S_editorMarker *point) {
        S_editorMarkerList *ll;
        S_editorMarker *pp;
        int progressi, progressn;
        refactoryEditServerParseBuffer( s_ropt.project, buf, point,NULL, "-olcxuselesslongnames",NULL);
        olcxPushSpecial(" redundant long names of the project");
        ll = editorReferencesToMarkers(s_olcxCurrentUser->tops->r, filter2);
        { register S_editorMarkerList *tmp; register int co=0; tmp = ll; while (tmp!=NULL) {++co; tmp = tmp->next; } progressn = co; }; progressi=0;
        for(; ll!=NULL; ll=ll->next) {
                pp = refactoryReplaceStaticPrefix(ll->d, "");
                editorFreeMarker(pp);
                writeRelativeProgress((progressi++)*100/progressn);
        }
        writeRelativeProgress(100);
        olcxReferencePopOnly();
}
static void refactoryReduceLongNames(S_editorBuffer *buf, S_editorMarker *point) {
        refactoryApplyReduceLongNames(buf, point);
        refactoryAplyWholeRefactoringFromUndo();
        ppcGenGotoMarkerRecord(point);
}
static void refactoryReduceExpandedLongReferences(
        S_editorMarker *point,
        S_editorMarkerList **regBegins,
        S_editorMarkerList **regEnds
        ) {
        S_editorMarkerList *ee, *bb, *rli, *rll;
        S_editorMarker *pp;
        int progressi, progressn;
        refactoryUpdateReferences(s_ropt.project);
        refactoryEditServerParseBuffer( s_ropt.project, point->buffer, point,NULL, "-olcxuselesslongnames",NULL);
        olcxPushSpecial(" redundant long names of the project");
        rli = editorReferencesToMarkers(s_olcxCurrentUser->tops->r, filter0);
        { S_editorMarkerList *_macrores; _macrores = (rli); { S_editorMarkerList *a, *b, *todo, *t, **restail; int i, n, contFlag; contFlag = 1; for(n=1; contFlag; n=n+n) { todo=_macrores; _macrores=NULL; restail = &_macrores; contFlag=0; while (todo!=NULL) { a=todo; for(i=1, t=a; i<n && t!=NULL; i++, t=t->next) ; if (t==NULL) { *restail = a; break; } b=t->next; t->next=NULL; for(i=1, t=b; i<n && t!=NULL; i++, t=t->next) ; if (t==NULL) todo=NULL; else { todo=t->next; t->next=NULL; } { while (a!=NULL && b!=NULL) { if (editorMarkerListLess(a, b)) { *restail=a; restail= &(a->next); a=a->next; } else { *restail=b; restail= &(b->next); b=b->next; } } if (a!=NULL) *restail=a; else *restail=b; while (*restail!=NULL) restail= &((*restail)->next);}; contFlag=1; } } } (rli) = _macrores;};
        { S_editorMarkerList *_macrores; _macrores = (*regBegins); { S_editorMarkerList *a, *b, *todo, *t, **restail; int i, n, contFlag; contFlag = 1; for(n=1; contFlag; n=n+n) { todo=_macrores; _macrores=NULL; restail = &_macrores; contFlag=0; while (todo!=NULL) { a=todo; for(i=1, t=a; i<n && t!=NULL; i++, t=t->next) ; if (t==NULL) { *restail = a; break; } b=t->next; t->next=NULL; for(i=1, t=b; i<n && t!=NULL; i++, t=t->next) ; if (t==NULL) todo=NULL; else { todo=t->next; t->next=NULL; } { while (a!=NULL && b!=NULL) { if (editorMarkerListLess(a, b)) { *restail=a; restail= &(a->next); a=a->next; } else { *restail=b; restail= &(b->next); b=b->next; } } if (a!=NULL) *restail=a; else *restail=b; while (*restail!=NULL) restail= &((*restail)->next);}; contFlag=1; } } } (*regBegins) = _macrores;};
        { S_editorMarkerList *_macrores; _macrores = (*regEnds); { S_editorMarkerList *a, *b, *todo, *t, **restail; int i, n, contFlag; contFlag = 1; for(n=1; contFlag; n=n+n) { todo=_macrores; _macrores=NULL; restail = &_macrores; contFlag=0; while (todo!=NULL) { a=todo; for(i=1, t=a; i<n && t!=NULL; i++, t=t->next) ; if (t==NULL) { *restail = a; break; } b=t->next; t->next=NULL; for(i=1, t=b; i<n && t!=NULL; i++, t=t->next) ; if (t==NULL) todo=NULL; else { todo=t->next; t->next=NULL; } { while (a!=NULL && b!=NULL) { if (editorMarkerListLess(a, b)) { *restail=a; restail= &(a->next); a=a->next; } else { *restail=b; restail= &(b->next); b=b->next; } } if (a!=NULL) *restail=a; else *restail=b; while (*restail!=NULL) restail= &((*restail)->next);}; contFlag=1; } } } (*regEnds) = _macrores;};
        { register S_editorMarkerList *tmp; register int co=0; tmp = *regBegins; while (tmp!=NULL) {++co; tmp = tmp->next; } progressn = co; }; progressi=0;
        rll = rli;
        for(ee= *regEnds, bb= *regBegins; ee!=NULL&&bb!=NULL; ee=ee->next,bb=bb->next) {
                if (ee->d!=NULL && bb->d!=NULL) {
                        { if (!(bb->d->buffer == ee->d->buffer)) internalCheckFail("bb->d->buffer == ee->d->buffer", "refactory.c", 1409);};
                        { if (!(bb->d->offset <= ee->d->offset)) internalCheckFail("bb->d->offset <= ee->d->offset", "refactory.c", 1410);};
                        while(rll!=NULL && editorMarkerLess(rll->d, bb->d)) rll=rll->next;
                        while (rll!=NULL
                                   && rll->d->buffer == ee->d->buffer
                                   && editorMarkerLessOrEq(rll->d, ee->d)
                                ) {
                                pp = refactoryReplaceStaticPrefix(rll->d, "");
                                editorFreeMarker(pp);
                                rll = rll->next;
                        }
                }
                writeRelativeProgress((progressi++)*100/progressn);
        }
        writeRelativeProgress(100);
}
static void refactoryPushAllReferencesOfMethod(S_editorMarker *m1, char *specialOption) {
        refactoryEditServerParseBuffer( s_ropt.project, m1->buffer, m1,NULL, "-olcxpushallinmethod", specialOption);
        olPushAllReferencesInBetween(s_cps.cxMemiAtMethodBeginning, s_cps.cxMemiAtMethodEnd);
}
static void moveFirstElementOfMarkerList(S_editorMarkerList **l1, S_editorMarkerList **l2) {
        S_editorMarkerList *mm;
        if (*l1!=NULL) {
                mm = *l1;
                *l1 = (*l1)->next;
                mm->next = NULL;
                { if ((*l2)==NULL) *l2 = mm; else { register S_editorMarkerList *tempnsl; tempnsl = *l2; while (tempnsl->next!=NULL) tempnsl=tempnsl->next; tempnsl->next = mm; } };
        }
}
static void refactoryShowSafetyCheckFailingDialog(S_editorMarkerList **totalDiff, char *message) {
        S_editorUndo *redo;
        redo = NULL;
        editorUndoUntil(s_refactoringStartPoint, &redo);
        olcxPushSpecialCheckMenuSym(OLO_SAFETY_CHECK_INIT, "  Conflicting References");
        refactoryPushMarkersAsReferences(totalDiff, s_olcxCurrentUser->tops,
                                                                         "  Conflicting References");
        refactoryDisplayResolutionDialog(
 message,
                PPCV_BROWSER_TYPE_WARNING, CONTINUATION_DISABLED);
        editorApplyUndos(redo, NULL, &s_editorUndo, GEN_NO_OUTPUT);
}
static void refactoryStaticMoveCheckCorrespondance(
        S_olSymbolsMenu *menu1, S_olSymbolsMenu *menu2, S_symbolRefItem *theMethod
        ) {
        S_olSymbolsMenu *mm1, *mm2;
        S_editorMarkerList *diff1, *diff2, *totalDiff, *mmm;
        int problem;
        problem = 0;
        totalDiff = NULL;
        mm1=menu1;
        while (mm1!=NULL) {
                if (itIsSameCxSymbolIncludingFunClass(&mm1->s, theMethod)) goto cont;
                if (mm1->s.b.storage == StorageAuto) goto cont;
                if (mm1->s.b.symType == TypeLabel) goto cont;
                if (isStrictlyEnclosingClass(mm1->s.vFunClass, theMethod->vFunClass)) goto cont;
                for(mm2=menu2; mm2!=NULL; mm2=mm2->next) {
                        if (itIsSameCxSymbolIncludingApplClass(&mm1->s, &mm2->s)) break;
                }
                if (mm2==NULL) {
                        moveFirstElementOfMarkerList(&mm1->markers, &totalDiff);
                } else {
                        editorMarkersDifferences(&mm1->markers, &mm2->markers, &diff1, &diff2);
                        if (diff1!=NULL) {
                                moveFirstElementOfMarkerList(&diff1, &totalDiff);
                        } else {
                                moveFirstElementOfMarkerList(&diff2, &totalDiff);
                        }
                        editorFreeMarkersAndMarkerList(diff1);
                        editorFreeMarkersAndMarkerList(diff2);
                }
                editorFreeMarkersAndMarkerList(mm1->markers);
                mm1->markers = NULL;
        cont:
                mm1=mm1->next;
        }
        for(mm2=menu2; mm2!=NULL; mm2=mm2->next) {
                editorFreeMarkersAndMarkerList(mm2->markers);
                mm2->markers = NULL;
        }
        if (totalDiff!=NULL) {
                        refactoryShowSafetyCheckFailingDialog(&totalDiff,"Those references will be  misinterpreted after refactoring. Fix them first.\n(each symbol is reported only once)");
                editorFreeMarkersAndMarkerList(totalDiff); totalDiff=NULL;
                refactoryAskForReallyContinueConfirmation();
        }
}
static void refactoryPerformMovingOfStaticObject(
        S_editorMarker *mstart, S_editorMarker *point, S_editorMarker *mend,
        S_editorMarker *target, char fqtname[],int check
        ) {
        char nameOnPoint[TMP_STRING_SIZE];
        int size, ppoffset;
        S_olSymbolsMenu *mm1, *mm2;
        S_editorMarker *pp;
        S_editorMarkerList *occs, *eccs, **ecclast, *ll, *ll2, *rli, *rll, *lll;
        S_symbolRefItem *theMethod;
        S_editorUndo *undoStartPoint;
        int progressi, progressn;
        size = mend->offset-mstart->offset;
        if (target->buffer == mstart->buffer
                && target->offset > mstart->offset
                && target->offset < mstart->offset+size) {
                ppcGenRecord(PPC_INFORMATION, "You can't move something into itself.", "\n");
                return;
        }
        refactoryApplyExpandShortNames(point->buffer, point);
        strcpy(nameOnPoint, refactoryGetIdentifierOnMarker_st(point));
        { if (!(strlen(nameOnPoint) < TMP_STRING_SIZE-1)) internalCheckFail("strlen(nameOnPoint) < TMP_STRING_SIZE-1", "refactory.c", 1558);};
        occs = refactoryGetReferences(point->buffer, point,"Select classes in left window.  Those classes will be  processed during\nrefactoring. It  is highly recommended  to process whole  hierarchy of\nrelated classes  at once. Unselection  of any class and  its exclusion\nfrom refactoring may cause changes in your program behaviour.\n",PPCV_BROWSER_TYPE_INFO);
        undoStartPoint = s_editorUndo;
        { S_editorMarkerList *_macrores; _macrores = (occs); { S_editorMarkerList *a, *b, *todo, *t, **restail; int i, n, contFlag; contFlag = 1; for(n=1; contFlag; n=n+n) { todo=_macrores; _macrores=NULL; restail = &_macrores; contFlag=0; while (todo!=NULL) { a=todo; for(i=1, t=a; i<n && t!=NULL; i++, t=t->next) ; if (t==NULL) { *restail = a; break; } b=t->next; t->next=NULL; for(i=1, t=b; i<n && t!=NULL; i++, t=t->next) ; if (t==NULL) todo=NULL; else { todo=t->next; t->next=NULL; } { while (a!=NULL && b!=NULL) { if (editorMarkerListLess(a, b)) { *restail=a; restail= &(a->next); a=a->next; } else { *restail=b; restail= &(b->next); b=b->next; } } if (a!=NULL) *restail=a; else *restail=b; while (*restail!=NULL) restail= &((*restail)->next);}; contFlag=1; } } } (occs) = _macrores;};
        { register S_editorMarkerList *tmp; register int co=0; tmp = occs; while (tmp!=NULL) {++co; tmp = tmp->next; } progressn = co; }; progressi=0;
        eccs = NULL; ecclast = &eccs;
        for(ll=occs; ll!=NULL; ll=ll->next) {
                if ((! ( ( (ll->usage)==UsageDefined || (ll->usage)==UsageOLBestFitDefined) || (ll->usage)==UsageDeclared ))
                        && ll->usage!=UsageConstructorDefinition) {
                        pp = refactoryReplaceStaticPrefix(ll->d, fqtname);
                } else {
                        pp = editorCrNewBufferMarker(ll->d->buffer, ll->d->offset);
                }
                { { int n = (int) (((char*)(((1)*sizeof(S_editorMarkerList))))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(((1)*sizeof(S_editorMarkerList))))-1) & (STANDARD_ALLIGNEMENT-1)))); char *rlmtmp; { if (!(n >= sizeof(void*))) internalCheckFail("n >= sizeof(void*)", "refactory.c", 1572);}; { if (!(n < MAX_BUFFERED_SIZE_olcxMemory)) internalCheckFail("n < MAX_BUFFERED_SIZE_olcxMemory", "refactory.c", 1572);}; if ((lll = (S_editorMarkerList*) olcxMemoryFreeList[n]) == NULL) { lll = NULL; if ((olcxMemoryi+(n) < SIZE_olcxMemory)) { { { if (!((n) >= 0)) internalCheckFail("(n) >= 0", "refactory.c", 1572);}; olcxMemoryi = ((char*)(((char*)(olcxMemory+olcxMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(olcxMemory+olcxMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - olcxMemory; if (olcxMemoryi+(n)*sizeof(char) >= SIZE_olcxMemory) { fatalError(ERR_NO_MEMORY,"olcxMemory", 65); } rlmtmp = (char*) (olcxMemory + olcxMemoryi); olcxMemoryi += (n)*sizeof(char);}; lll = (S_editorMarkerList *) rlmtmp; } } else { olcxMemoryFreeList[n] = *((void **) lll); }}; while (lll==NULL) { freeOldestOlcx(); { int n = (int) (((char*)(((1)*sizeof(S_editorMarkerList))))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(((1)*sizeof(S_editorMarkerList))))-1) & (STANDARD_ALLIGNEMENT-1)))); char *rlmtmp; { if (!(n >= sizeof(void*))) internalCheckFail("n >= sizeof(void*)", "refactory.c", 1572);}; { if (!(n < MAX_BUFFERED_SIZE_olcxMemory)) internalCheckFail("n < MAX_BUFFERED_SIZE_olcxMemory", "refactory.c", 1572);}; if ((lll = (S_editorMarkerList*) olcxMemoryFreeList[n]) == NULL) { lll = NULL; if ((olcxMemoryi+(n) < SIZE_olcxMemory)) { { { if (!((n) >= 0)) internalCheckFail("(n) >= 0", "refactory.c", 1572);}; olcxMemoryi = ((char*)(((char*)(olcxMemory+olcxMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(olcxMemory+olcxMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - olcxMemory; if (olcxMemoryi+(n)*sizeof(char) >= SIZE_olcxMemory) { fatalError(ERR_NO_MEMORY,"olcxMemory", 65); } rlmtmp = (char*) (olcxMemory + olcxMemoryi); olcxMemoryi += (n)*sizeof(char);}; lll = (S_editorMarkerList *) rlmtmp; } } else { olcxMemoryFreeList[n] = *((void **) lll); }}; }};
                { (lll)->d = pp; (lll)->usage = ll->usage; (lll)->next = NULL;};
                *ecclast = lll;
                ecclast = &lll->next;
                writeRelativeProgress((progressi++)*100/progressn);
        }
        writeRelativeProgress(100);
        size = mend->offset - mstart->offset;
        if (check==NO_CHECKS) {
                editorMoveBlock(target, mstart, size, &s_editorUndo);
        } else {
                { if (!(s_olcxCurrentUser->tops!=NULL && s_olcxCurrentUser->tops->hkSelectedSym!=NULL)) internalCheckFail("s_olcxCurrentUser->tops!=NULL && s_olcxCurrentUser->tops->hkSelectedSym!=NULL", "refactory.c", 1584);};
                theMethod = &s_olcxCurrentUser->tops->hkSelectedSym->s;
                refactoryPushAllReferencesOfMethod(point, "-olallchecks");
                createMarkersForAllReferences();
                editorMoveBlock(target, mstart, size, &s_editorUndo);
                refactoryPushAllReferencesOfMethod(point, "-olallchecks");
                createMarkersForAllReferences();
                { if (!(s_olcxCurrentUser->tops && s_olcxCurrentUser->tops->previous)) internalCheckFail("s_olcxCurrentUser->tops && s_olcxCurrentUser->tops->previous", "refactory.c", 1591);};
                mm1 = s_olcxCurrentUser->tops->previous->menuSym;
                mm2 = s_olcxCurrentUser->tops->menuSym;
                refactoryStaticMoveCheckCorrespondance(mm1, mm2, theMethod);
        }
        refactoryReduceExpandedLongReferences(point, &eccs, &occs);
        refactoryApplyReduceLongNames(point->buffer, point);
}
static S_editorMarker *getTargetFromOptions() {
        S_editorMarker *target;
        S_editorBuffer *tb;
        int tline;
        tb = editorFindFile(normalizeFileName(s_ropt.moveTargetFile, s_cwd));
        target = editorCrNewBufferMarker(tb, 0);
        sscanf(s_ropt.refpar1, "%d", &tline);
        editorMoveMarkerToLineCol(target, tline, 0);
        return(target);
}
static S_editorMarker *refactoryFindModifierAndCrMarker(S_editorMarker *point, char *modifier) {
        int i, j, mlen, blen;
        char *text;
        S_editorMarker *mm;
        i = point->offset;
        text = point->buffer->a.text;
        blen = point->buffer->a.bufferSize;
        mlen = strlen(modifier);
        while (i>0 && text[i]!='\n') {
                if (strncmp(text+i, modifier, mlen)==0
                        && (i==0 || isspace(text[i-1]))
                        && (i+mlen==blen || isspace(text[i+mlen]))) {
                        mm = editorCrNewBufferMarker(point->buffer, i);
                        return(mm);
                }
                i--;
        }
        return(NULL);
}
static void refactoryRemoveModifier(S_editorMarker *point, char *modifier) {
        int i, j, mlen, blen;
        char *text;
        S_editorMarker *mm;
        mlen = strlen(modifier);
        text = point->buffer->a.text;
        mm = refactoryFindModifierAndCrMarker(point, modifier);
        if (mm!=NULL) {
                i = mm->offset;
                for(j=i+mlen; isspace(text[j]); j++) ;
                refactoryReplaceString(mm, j-i, "");
                editorFreeMarker(mm);
        }
}
static void refactoryAddModifier(S_editorMarker *point, char *modifier) {
        int i, j, mlen, blen;
        char *text;
        S_editorMarker *mm;
        i = point->offset;
        text = point->buffer->a.text;
        blen = point->buffer->a.bufferSize;
        mlen = strlen(modifier);
        while (i>0 && text[i]!='\n') i--;
        while (i<blen
                   && (isspace(text[i])
                           || (i+7<blen && strncmp(text+i, "public", 6)==0 && isspace(text[i+6]))
                           || (i+8<blen && strncmp(text+i, "private", 7)==0 && isspace(text[i+7]))
                           || (i+10<blen && strncmp(text+i, "protected", 9)==0 && isspace(text[i+9]))
                           )) {
                while (i<blen && ! isspace(text[i])) i++;
                i++;
        }
        mm = editorCrNewBufferMarker(point->buffer, i);
        refactoryReplaceString(mm, 0, modifier);
        editorFreeMarker(mm);
}
static void refactoryMakeTheDefinitionPublic(S_editorMarker *point) {
        S_editorMarker *mm;
        mm = refactoryFindModifierAndCrMarker(point, "public");
        if (mm == NULL) {
                refactoryRemoveModifier(point, "private");
                refactoryRemoveModifier(point, "protected");
                refactoryAddModifier(point, "public ");
        } else {
                editorFreeMarker(mm);
        }
}
static void refactoryMoveStaticMethod(S_editorMarker *point) {
        char fqtname[MAX_FILE_NAME_SIZE];
        int tline, lines;
        S_editorMarker *target, *mstart, *mend;
        S_editorBuffer *tb;
        refactoryUpdateReferences(s_ropt.project);
        target = getTargetFromOptions();
        refactoryEditServerParseBuffer( s_ropt.project, target->buffer,
                                                                   target,NULL, "-olcxcurrentclass",NULL);
        if (s_cps.currentClassAnswer[0] == 0) {
                error(ERR_ST, "can't get target class");
                return;
        }
        sprintf(fqtname, "%s.", s_cps.currentClassAnswer);
        javaDotifyClassName(fqtname);
        mstart = editorCrNewBufferMarker(point->buffer, point->offset);
        editorMoveMarkerToNewline(mstart, -1);
        if ((*(mstart->buffer->a.text+mstart->offset))=='\n') mstart->offset++;
        refactoryEditServerParseBuffer( s_ropt.project, point->buffer,
                                                                   point,NULL, "-olcxmethodlines",NULL);
        if (s_cps.methodCoordEndPosition.file == s_noneFileIndex) {
                error(ERR_ST, "can't find end of method");
                return;
        }
        mend = editorCrNewMarkerForPosition(&s_cps.methodCoordEndPosition);
        editorMoveMarkerToNewline(mend, 1);
        if ((*(mend->buffer->a.text+mend->offset))=='\n') mend->offset++;
        { if (!(mstart->buffer == mend->buffer)) internalCheckFail("mstart->buffer == mend->buffer", "refactory.c", 1717);};
        lines = editorCountLinesBetweenMarkers(mstart, mend);
        refactoryPerformMovingOfStaticObject(mstart, point, mend, target, fqtname, APPLY_CHECKS);
        refactoryMakeTheDefinitionPublic(point);
        refactoryAplyWholeRefactoringFromUndo();
        ppcGenGotoMarkerRecord(point);
        ppcGenNumericRecord(PPC_INDENT, lines, "", "\n");
}
static void refactoryMoveClass(S_editorMarker *point) {
        char spack[MAX_FILE_NAME_SIZE];
        char tpack[MAX_FILE_NAME_SIZE];
        char fqtname[MAX_FILE_NAME_SIZE];
        int i, targetIsNestedInClass, linenum;
        S_editorMarker *target, *mstart, *mend, *mm;
        S_editorBuffer *tb;
        S_olSymbolsMenu *ss;
        S_tpCheckMoveClassData dd;
        refactoryUpdateReferences(s_ropt.project);
        target = getTargetFromOptions();
        refactoryEditServerParseBuffer( s_ropt.project, target->buffer,
                                                                   target,NULL, "-olcxcurrentclass",NULL);
        if (s_cps.currentPackageAnswer[0] == 0) {
                error(ERR_ST, "Can't get target class or package");
                return;
        }
        if (s_cps.currentClassAnswer[0] == 0) {
                sprintf(fqtname, "%s.", s_cps.currentPackageAnswer);
                targetIsNestedInClass = 0;
        } else {
                sprintf(fqtname, "%s.", s_cps.currentClassAnswer);
                targetIsNestedInClass = 1;
        }
        javaDotifyClassName(fqtname);
        mstart = editorCrNewBufferMarker(point->buffer, point->offset);
        editorMoveMarkerToNewline(mstart, -1);
        if ((*(mstart->buffer->a.text+mstart->offset))=='\n') mstart->offset++;
        refactoryEditServerParseBuffer( s_ropt.project, point->buffer,
                                                                   point, NULL, "-olcxmethodlines",NULL);
        if (s_cps.classCoordEndLine == 0) {
                error(ERR_INTERNAL, "Can't find end of class");
                return;
        }
        mend = editorCrNewBufferMarker(point->buffer, 0);
        editorMoveMarkerToLineCol(mend, s_cps.classCoordEndLine, 0);
        linenum = editorCountLinesBetweenMarkers(mstart, mend);
        refactoryEditServerParseBuffer( s_ropt.project, point->buffer,
                                                                   point, NULL, "-olcxtrivialprecheck",NULL);
        olCreateSelectionMenu();
        s_opt.moveTargetFile = s_ropt.moveTargetFile;
        { if (!(s_olcxCurrentUser && s_olcxCurrentUser->tops)) internalCheckFail("s_olcxCurrentUser && s_olcxCurrentUser->tops", "refactory.c", 1786);};
        ss = s_olcxCurrentUser->tops->hkSelectedSym;
        { if (!(ss)) internalCheckFail("ss", "refactory.c", 1788);};
        tpCheckFillMoveClassData(&dd, spack, tpack);
        tpCheckSourceIsNotInnerClass();
        tpCheckMoveClassAccessibilities();
        refactoryPerformMovingOfStaticObject(mstart, point, mend, target, fqtname,
                                                                                 NO_CHECKS);
        if (ss->s.b.accessFlags & 0x008) {
                if (! targetIsNestedInClass) {
                        refactoryRemoveModifier(point, "static");
                }
        } else {
                if (targetIsNestedInClass) {
                        refactoryAddModifier(point, "static ");
                }
        }
        if (dd.transPackageMove) {
                refactoryMakeTheDefinitionPublic(point);
        }
        refactoryAplyWholeRefactoringFromUndo();
        ppcGenGotoMarkerRecord(point);
        ppcGenNumericRecord(PPC_INDENT, linenum, "", "\n");
}
static void refactoryAddCopyOfMarkerToList(S_editorMarkerList **ll, S_editorMarker *mm, int usage) {
        S_editorMarker *nn;
        S_editorMarkerList *lll;
        nn = editorCrNewBufferMarker(mm->buffer, mm->offset);
        { { int n = (int) (((char*)(((1)*sizeof(S_editorMarkerList))))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(((1)*sizeof(S_editorMarkerList))))-1) & (STANDARD_ALLIGNEMENT-1)))); char *rlmtmp; { if (!(n >= sizeof(void*))) internalCheckFail("n >= sizeof(void*)", "refactory.c", 1827);}; { if (!(n < MAX_BUFFERED_SIZE_olcxMemory)) internalCheckFail("n < MAX_BUFFERED_SIZE_olcxMemory", "refactory.c", 1827);}; if ((lll = (S_editorMarkerList*) olcxMemoryFreeList[n]) == NULL) { lll = NULL; if ((olcxMemoryi+(n) < SIZE_olcxMemory)) { { { if (!((n) >= 0)) internalCheckFail("(n) >= 0", "refactory.c", 1827);}; olcxMemoryi = ((char*)(((char*)(olcxMemory+olcxMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(olcxMemory+olcxMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - olcxMemory; if (olcxMemoryi+(n)*sizeof(char) >= SIZE_olcxMemory) { fatalError(ERR_NO_MEMORY,"olcxMemory", 65); } rlmtmp = (char*) (olcxMemory + olcxMemoryi); olcxMemoryi += (n)*sizeof(char);}; lll = (S_editorMarkerList *) rlmtmp; } } else { olcxMemoryFreeList[n] = *((void **) lll); }}; while (lll==NULL) { freeOldestOlcx(); { int n = (int) (((char*)(((1)*sizeof(S_editorMarkerList))))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(((1)*sizeof(S_editorMarkerList))))-1) & (STANDARD_ALLIGNEMENT-1)))); char *rlmtmp; { if (!(n >= sizeof(void*))) internalCheckFail("n >= sizeof(void*)", "refactory.c", 1827);}; { if (!(n < MAX_BUFFERED_SIZE_olcxMemory)) internalCheckFail("n < MAX_BUFFERED_SIZE_olcxMemory", "refactory.c", 1827);}; if ((lll = (S_editorMarkerList*) olcxMemoryFreeList[n]) == NULL) { lll = NULL; if ((olcxMemoryi+(n) < SIZE_olcxMemory)) { { { if (!((n) >= 0)) internalCheckFail("(n) >= 0", "refactory.c", 1827);}; olcxMemoryi = ((char*)(((char*)(olcxMemory+olcxMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(olcxMemory+olcxMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - olcxMemory; if (olcxMemoryi+(n)*sizeof(char) >= SIZE_olcxMemory) { fatalError(ERR_NO_MEMORY,"olcxMemory", 65); } rlmtmp = (char*) (olcxMemory + olcxMemoryi); olcxMemoryi += (n)*sizeof(char);}; lll = (S_editorMarkerList *) rlmtmp; } } else { olcxMemoryFreeList[n] = *((void **) lll); }}; }};
        { (lll)->d = nn; (lll)->usage = usage; (lll)->next = *ll;};
        *ll = lll;
}
static void refactoryTurnDynamicToStatic(S_editorMarker *point) {
        char nameOnPoint[TMP_STRING_SIZE];
        char primary[REFACTORING_TMP_STRING_SIZE];
        char fqstaticname[REFACTORING_TMP_STRING_SIZE];
        char fqthis[REFACTORING_TMP_STRING_SIZE];
        char pardecl[REFACTORING_TMP_STRING_SIZE];
        char parusage[REFACTORING_TMP_STRING_SIZE];
        char cid[TMP_STRING_SIZE];
        int plen, ppoffset, poffset;
        int progressi, progressj, progressn;
        S_editorMarker *pp, *nparamdefpos;
        S_editorMarkerList *ll, *markers, *lll, *occs, *bccs, **bcclast, *eccs;
        S_editorMarkerList *npoccs, *npadded, *diff1, *diff2;
        S_olSymbolsMenu *csym, *mm;
        S_editorUndo *undoStartPoint;
        nparamdefpos = NULL;
        refactoryUpdateReferences(s_ropt.project);
        strcpy(nameOnPoint, refactoryGetIdentifierOnMarker_st(point));
        { if (!(strlen(nameOnPoint) < TMP_STRING_SIZE-1)) internalCheckFail("strlen(nameOnPoint) < TMP_STRING_SIZE-1", "refactory.c", 1853);};
        occs = refactoryPushGetAndPreCheckReferences(point->buffer, point, nameOnPoint,
                                                                                                 "If  you see  this  message it  is  highly probable  that turning  this\nvirtual  method into  static will  not be  behaviour  preserving! This\nrefactoring is  behaviour preserving only  if the method does  not use\nmechanism of virtual invocations. In this dialog you should select the\napplication classes which are refering to the method which will become\nstatic. If  you can't unambiguously determine those  references do not\ncontinue in this refactoring!",
                                                                                                 PPCV_BROWSER_TYPE_WARNING);
        editorFreeMarkersAndMarkerList(occs);
        if (! tpCheckOuterScopeUsagesForDynToSt()) return;
        if (! tpCheckSuperMethodReferencesForDynToSt()) return;
        csym = s_olcxCurrentUser->tops->hkSelectedSym;
        javaGetClassNameFromFileNum(csym->s.vFunClass, fqstaticname, DOTIFY_NAME);
        javaDotifyClassName(fqstaticname);
        sprintf(pardecl, "%s %s", fqstaticname, s_ropt.refpar1);
        sprintf(fqstaticname+strlen(fqstaticname), ".");
        progressn = progressi = 0;
        for(mm=s_olcxCurrentUser->tops->menuSym; mm!=NULL; mm=mm->next) {
                if (mm->selected && mm->visible) {
                        mm->markers = editorReferencesToMarkers(mm->s.refs, filter0);
                        { S_editorMarkerList *_macrores; _macrores = (mm->markers); { S_editorMarkerList *a, *b, *todo, *t, **restail; int i, n, contFlag; contFlag = 1; for(n=1; contFlag; n=n+n) { todo=_macrores; _macrores=NULL; restail = &_macrores; contFlag=0; while (todo!=NULL) { a=todo; for(i=1, t=a; i<n && t!=NULL; i++, t=t->next) ; if (t==NULL) { *restail = a; break; } b=t->next; t->next=NULL; for(i=1, t=b; i<n && t!=NULL; i++, t=t->next) ; if (t==NULL) todo=NULL; else { todo=t->next; t->next=NULL; } { while (a!=NULL && b!=NULL) { if (editorMarkerListLess(a, b)) { *restail=a; restail= &(a->next); a=a->next; } else { *restail=b; restail= &(b->next); b=b->next; } } if (a!=NULL) *restail=a; else *restail=b; while (*restail!=NULL) restail= &((*restail)->next);}; contFlag=1; } } } (mm->markers) = _macrores;};
                        { register S_editorMarkerList *tmp; register int co=0; tmp = mm->markers; while (tmp!=NULL) {++co; tmp = tmp->next; } progressj = co; };
                        progressn += progressj;
                }
        }
        undoStartPoint = s_editorUndo;
        eccs = NULL; bccs = NULL; bcclast = &bccs;
        for(mm=s_olcxCurrentUser->tops->menuSym; mm!=NULL; mm=mm->next) {
                if (mm->selected && mm->visible) {
                        javaGetClassNameFromFileNum(mm->s.vApplClass, fqthis, DOTIFY_NAME);
                        javaDotifyClassName(fqthis);
                        sprintf(fqthis+strlen(fqthis), ".this");
                        for(ll=mm->markers; ll!=NULL; ll=ll->next) {
                                pp = NULL;
                                if (( ( (ll->usage)==UsageDefined || (ll->usage)==UsageOLBestFitDefined) || (ll->usage)==UsageDeclared )) {
                                        pp = editorCrNewBufferMarker(ll->d->buffer, ll->d->offset);
                                        pp->offset = refactoryAddStringAsParameter(
                                                ll->d, ll->d, nameOnPoint, 1, pardecl
);
                                        nparamdefpos = editorCrNewBufferMarker(pp->buffer, pp->offset+strlen(pardecl)-strlen(s_ropt.refpar1));
                                } else {
                                        pp = refactoryCrNewMarkerForExpressionBegin(ll->d, GET_PRIMARY_START);
                                        { if (!(pp!=NULL)) internalCheckFail("pp!=NULL", "refactory.c", 1897);};
                                        ppoffset = pp->offset;
                                        plen = ll->d->offset - pp->offset;
                                        strncpy(primary, (pp->buffer->a.text+pp->offset), plen);
                                        while (plen>0 && primary[plen-1]!='.') plen--;
                                        if (plen>0) {
                                                primary[plen-1] = 0;
                                        } else {
                                                if (javaLinkNameIsAnnonymousClass(mm->s.name)) {
                                                        strcpy(primary, "this");
                                                } else {
                                                        strcpy(primary, fqthis);
                                                }
                                        }
                                        refactoryReplaceString(pp, ll->d->offset-pp->offset, fqstaticname
);
                                        refactoryAddStringAsParameter(ll->d, ll->d, nameOnPoint, 1, primary
);
                                        pp->offset = ppoffset;
                                }
                                { { int n = (int) (((char*)(((1)*sizeof(S_editorMarkerList))))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(((1)*sizeof(S_editorMarkerList))))-1) & (STANDARD_ALLIGNEMENT-1)))); char *rlmtmp; { if (!(n >= sizeof(void*))) internalCheckFail("n >= sizeof(void*)", "refactory.c", 1920);}; { if (!(n < MAX_BUFFERED_SIZE_olcxMemory)) internalCheckFail("n < MAX_BUFFERED_SIZE_olcxMemory", "refactory.c", 1920);}; if ((lll = (S_editorMarkerList*) olcxMemoryFreeList[n]) == NULL) { lll = NULL; if ((olcxMemoryi+(n) < SIZE_olcxMemory)) { { { if (!((n) >= 0)) internalCheckFail("(n) >= 0", "refactory.c", 1920);}; olcxMemoryi = ((char*)(((char*)(olcxMemory+olcxMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(olcxMemory+olcxMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - olcxMemory; if (olcxMemoryi+(n)*sizeof(char) >= SIZE_olcxMemory) { fatalError(ERR_NO_MEMORY,"olcxMemory", 65); } rlmtmp = (char*) (olcxMemory + olcxMemoryi); olcxMemoryi += (n)*sizeof(char);}; lll = (S_editorMarkerList *) rlmtmp; } } else { olcxMemoryFreeList[n] = *((void **) lll); }}; while (lll==NULL) { freeOldestOlcx(); { int n = (int) (((char*)(((1)*sizeof(S_editorMarkerList))))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(((1)*sizeof(S_editorMarkerList))))-1) & (STANDARD_ALLIGNEMENT-1)))); char *rlmtmp; { if (!(n >= sizeof(void*))) internalCheckFail("n >= sizeof(void*)", "refactory.c", 1920);}; { if (!(n < MAX_BUFFERED_SIZE_olcxMemory)) internalCheckFail("n < MAX_BUFFERED_SIZE_olcxMemory", "refactory.c", 1920);}; if ((lll = (S_editorMarkerList*) olcxMemoryFreeList[n]) == NULL) { lll = NULL; if ((olcxMemoryi+(n) < SIZE_olcxMemory)) { { { if (!((n) >= 0)) internalCheckFail("(n) >= 0", "refactory.c", 1920);}; olcxMemoryi = ((char*)(((char*)(olcxMemory+olcxMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(olcxMemory+olcxMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - olcxMemory; if (olcxMemoryi+(n)*sizeof(char) >= SIZE_olcxMemory) { fatalError(ERR_NO_MEMORY,"olcxMemory", 65); } rlmtmp = (char*) (olcxMemory + olcxMemoryi); olcxMemoryi += (n)*sizeof(char);}; lll = (S_editorMarkerList *) rlmtmp; } } else { olcxMemoryFreeList[n] = *((void **) lll); }}; }};
                                { (lll)->d = pp; (lll)->usage = ll->usage; (lll)->next = NULL;};
                                *bcclast = lll;
                                bcclast = &lll->next;
                                writeRelativeProgress((progressi++)*100/progressn);
                        }
                cont:;
                        { if ((eccs)==NULL) eccs = mm->markers; else { register S_editorMarkerList *tempnsl; tempnsl = eccs; while (tempnsl->next!=NULL) tempnsl=tempnsl->next; tempnsl->next = mm->markers; } };
                        mm->markers = NULL;
                }
        }
        writeRelativeProgress(100);
        refactoryReduceExpandedLongReferences(point, &bccs, &eccs);
        editorFreeMarkerListNotMarkers(eccs);
        editorFreeMarkerListNotMarkers(bccs);
        s_olcxCurrentUser->tops = s_olcxCurrentUser->tops->previous;
        sprintf(parusage, "%s.", s_ropt.refpar1);
        refactoryEditServerParseBuffer( s_ropt.project, point->buffer, point,NULL, "-olcxmaybethis",NULL);
        olcxPushSpecial("  method's \"maybe this\" dependencies");
        progressn = progressi = 0;
        { if (!(s_olcxCurrentUser->tops && s_olcxCurrentUser->tops->hkSelectedSym)) internalCheckFail("s_olcxCurrentUser->tops && s_olcxCurrentUser->tops->hkSelectedSym", "refactory.c", 1945);};
        for(mm=s_olcxCurrentUser->tops->menuSym; mm!=NULL; mm=mm->next) {
                if (mm->selected && mm->visible) {
                        mm->markers = editorReferencesToMarkers(mm->s.refs, filter0);
                        { S_editorMarkerList *_macrores; _macrores = (mm->markers); { S_editorMarkerList *a, *b, *todo, *t, **restail; int i, n, contFlag; contFlag = 1; for(n=1; contFlag; n=n+n) { todo=_macrores; _macrores=NULL; restail = &_macrores; contFlag=0; while (todo!=NULL) { a=todo; for(i=1, t=a; i<n && t!=NULL; i++, t=t->next) ; if (t==NULL) { *restail = a; break; } b=t->next; t->next=NULL; for(i=1, t=b; i<n && t!=NULL; i++, t=t->next) ; if (t==NULL) todo=NULL; else { todo=t->next; t->next=NULL; } { while (a!=NULL && b!=NULL) { if (editorMarkerListLess(a, b)) { *restail=a; restail= &(a->next); a=a->next; } else { *restail=b; restail= &(b->next); b=b->next; } } if (a!=NULL) *restail=a; else *restail=b; while (*restail!=NULL) restail= &((*restail)->next);}; contFlag=1; } } } (mm->markers) = _macrores;};
                        { register S_editorMarkerList *tmp; register int co=0; tmp = mm->markers; while (tmp!=NULL) {++co; tmp = tmp->next; } progressj = co; };
                        progressn += progressj;
                }
        }
        npadded = NULL;
        refactoryAddCopyOfMarkerToList(&npadded, nparamdefpos, UsageDefined);
        for(mm=s_olcxCurrentUser->tops->menuSym; mm!=NULL; mm=mm->next) {
                if (mm->selected && mm->visible) {
                        for(ll=mm->markers; ll!=NULL; ll=ll->next) {
                                if (ll->usage == UsageMaybeQualifThisInClassOrMethod) {
                                        editorUndoUntil(undoStartPoint,NULL);
                                        ppcGenGotoMarkerRecord(ll->d);
                                        error(ERR_ST, "The method is using qualified this to access enclosed instance. Do not know how to make it static.");
                                        return;
                                } else if (ll->usage == UsageMaybeThisInClassOrMethod) {
                                        strncpy(cid, refactoryGetIdentifierOnMarker_st(ll->d), TMP_STRING_SIZE);
                                        cid[TMP_STRING_SIZE-1]=0;
                                        poffset = ll->d->offset;
                                        if (strcmp(cid, "this")==0 || strcmp(cid, "super")==0) {
                                                pp = refactoryReplaceStaticPrefix(ll->d, "");
                                                editorFreeMarker(pp);
                                                refactoryCheckedReplaceString(ll->d, 4, cid, s_ropt.refpar1);
                                        } else {
                                                refactoryReplaceString(ll->d, 0, parusage);
                                        }
                                        ll->d->offset = poffset;
                                        refactoryAddCopyOfMarkerToList(&npadded, ll->d, ll->usage);
                                }
                                writeRelativeProgress((progressi++)*100/progressn);
                        }
                }
        }
        writeRelativeProgress(100);
        refactoryAddModifier(point, "static ");
        npoccs = refactoryGetReferences(
                nparamdefpos->buffer, nparamdefpos,
                "Internal problem, this is new parameter resolution, this mesage should never appear",
                PPCV_BROWSER_TYPE_WARNING);
        editorMarkersDifferences(&npoccs, &npadded, &diff1, &diff2);
        { if ((diff1)==NULL) diff1 = diff2; else { register S_editorMarkerList *tempnsl; tempnsl = diff1; while (tempnsl->next!=NULL) tempnsl=tempnsl->next; tempnsl->next = diff2; } }; diff2=NULL;
        if (diff1!=NULL) {
                ppcGenGotoMarkerRecord(point);
                refactoryShowSafetyCheckFailingDialog( &diff1, "The new parameter conflicts with existing symbols");
        }
        refactoryAplyWholeRefactoringFromUndo();
        ppcGenGotoMarkerRecord(point);
}
static int noSpaceChar(int c) {return(! isspace(c));}
static void dumpRefernces(S_reference *rr) {
        S_reference *r;
        fprintf(dumpOut, "[dump]");
        for(r=rr; r!=NULL; r=r->next) {
                fprintf(dumpOut,"%s:%d:%d\n", s_fileTab.tab[r->p.file]->name, r->p.line, r->p.coll);
        }
        fprintf(dumpOut, "\n\n");
}
static int refactoryIsMethodPartRedundant(S_editorMarker *m1,
                                                                                  S_editorMarker *m2
        ) {
        S_olSymbolsMenu *mm1, *mm2;
        S_editorUndo *undoMark;
        S_reference *diff;
        S_editorMarkerList *lll, *ll;
        char spaces[REFACTORING_TMP_STRING_SIZE];
        int slen, res;
        { if (!(m1->buffer == m2->buffer)) internalCheckFail("m1->buffer == m2->buffer", "refactory.c", 2032);};
        undoMark = s_editorUndo;
        refactoryPushAllReferencesOfMethod(m1,NULL);
        slen = m2->offset-m1->offset;
        { if (!(slen>=0 && slen<REFACTORING_TMP_STRING_SIZE)) internalCheckFail("slen>=0 && slen<REFACTORING_TMP_STRING_SIZE", "refactory.c", 2036);};
        memset(spaces, ' ', slen);
        spaces[slen]=0;
        refactoryReplaceString(m1, m2->offset - m1->offset, spaces);
        refactoryPushAllReferencesOfMethod(m1,NULL);
        editorUndoUntil(undoMark,NULL);
        res = 1;
        { if (!(s_olcxCurrentUser->tops && s_olcxCurrentUser->tops->previous)) internalCheckFail("s_olcxCurrentUser->tops && s_olcxCurrentUser->tops->previous", "refactory.c", 2044);};
        mm1 = s_olcxCurrentUser->tops->menuSym;
        mm2 = s_olcxCurrentUser->tops->previous->menuSym;
        while (mm1!=NULL && mm2!=NULL && res!=0) {
                olcxReferencesDiff(&mm1->s.refs, &mm2->s.refs, &diff);
                if (diff!=NULL) {
                        lll = editorReferencesToMarkers(diff, filter0);
                        { S_editorMarkerList *_macrores; _macrores = (lll); { S_editorMarkerList *a, *b, *todo, *t, **restail; int i, n, contFlag; contFlag = 1; for(n=1; contFlag; n=n+n) { todo=_macrores; _macrores=NULL; restail = &_macrores; contFlag=0; while (todo!=NULL) { a=todo; for(i=1, t=a; i<n && t!=NULL; i++, t=t->next) ; if (t==NULL) { *restail = a; break; } b=t->next; t->next=NULL; for(i=1, t=b; i<n && t!=NULL; i++, t=t->next) ; if (t==NULL) todo=NULL; else { todo=t->next; t->next=NULL; } { while (a!=NULL && b!=NULL) { if (editorMarkerListLess(a, b)) { *restail=a; restail= &(a->next); a=a->next; } else { *restail=b; restail= &(b->next); b=b->next; } } if (a!=NULL) *restail=a; else *restail=b; while (*restail!=NULL) restail= &((*restail)->next);}; contFlag=1; } } } (lll) = _macrores;};
                        for (ll=lll; ll!=NULL; ll=ll->next) {
                                { if (!(ll->d->buffer == m1->buffer)) internalCheckFail("ll->d->buffer == m1->buffer", "refactory.c", 2055);};
                                if (editorMarkerLess(ll->d, m1) || editorMarkerLessOrEq(m2, ll->d)) {
                                        res=0;
                                }
                        }
                        editorFreeMarkersAndMarkerList(lll);
                        olcxFreeReferences(diff);
                }
                mm1 = mm1->next;
                mm2 = mm2->next;
        }
        olcxReferencePopOnly();
        olcxReferencePopOnly();
        return(res);
}
static void refactoryRemoveMethodPartIfRedundant(S_editorMarker *m, int len) {
        S_editorMarker *mm;
        mm = editorCrNewBufferMarker(m->buffer, m->offset+len);
        if (refactoryIsMethodPartRedundant(m, mm)) {
                refactoryReplaceString(m, len, "");
        }
        editorFreeMarker(mm);
}
static int isMethodBeg(int c) {return(c=='{');}
static int staticToDynCanBeThisOccurence(S_editorMarker *pp, char *param, int *rlen) {
        char *pp2;
        S_editorMarker *mm;
        int res = 0;
        mm = editorCrNewBufferMarker(pp->buffer, pp->offset);
        pp2 = strchr(param, '.');
        if (pp2==NULL) {
                *rlen = strlen(param);
                res = strcmp(refactoryGetIdentifierOnMarker_st(pp), param)==0;
                goto fini;
        }
        if (strncmp(refactoryGetIdentifierOnMarker_st(mm), param, pp2-param)!=0) goto fini;
        mm->offset += (pp2-param);
        editorMoveMarkerToNonBlank(mm, 1);
        if (*((mm->buffer->a.text+mm->offset)) != '.') goto fini;
        mm->offset ++;
        editorMoveMarkerToNonBlank(mm, 1);
        if (strcmp(refactoryGetIdentifierOnMarker_st(mm), pp2+1)!=0) goto fini;
        *rlen = mm->offset - pp->offset + strlen(pp2+1);
        res = 1;
 fini:
        editorFreeMarker(mm);
        return(res);
}
static void refactoryTurnStaticToDynamic(S_editorMarker *point) {
        char nameOnPoint[TMP_STRING_SIZE];
        char param[REFACTORING_TMP_STRING_SIZE];
        char tparam[REFACTORING_TMP_STRING_SIZE];
        char testi[REFACTORING_TMP_STRING_SIZE];
        int plen, tplen, rlen, res, argn, bi;
        int classnum, parclassnum;
        int progressi, progressn;
        S_editorMarker *mm, *m1, *m2, *pp;
        S_editorMarkerList *ll, *occs, *poccs;
        S_editorUndo *checkPoint;
        refactoryUpdateReferences(s_ropt.project);
        argn = 0;
        sscanf(s_ropt.refpar1, "%d", &argn);
        { if (!(argn!=0)) internalCheckFail("argn!=0", "refactory.c", 2129);};
        strcpy(nameOnPoint, refactoryGetIdentifierOnMarker_st(point));
        res = refactoryGetParamNamePosition(point, nameOnPoint, argn);
        if (res != 0) {
                ppcGenGotoMarkerRecord(point);
                error(ERR_INTERNAL, "Can't determine position of parameter");
                return;
        }
        mm = editorCrNewMarkerForPosition(&s_paramPosition);
        if (s_ropt.refpar2[0]!=0) {
                sprintf(param, "%s.%s", refactoryGetIdentifierOnMarker_st(mm), s_ropt.refpar2);
        } else {
                sprintf(param, "%s", refactoryGetIdentifierOnMarker_st(mm));
        }
        plen = strlen(param);
        refactoryEditServerParseBuffer( s_ropt.project, point->buffer,
                                                                   point,NULL, "-olcxcurrentclass",NULL);
        if (s_cps.currentClassAnswer[0] == 0) {
                error(ERR_INTERNAL, "Can't get current class");
                return;
        }
        classnum = getClassNumFromClassLinkName(s_cps.currentClassAnswer, s_noneFileIndex);
        if (classnum==s_noneFileIndex) {
                error(ERR_INTERNAL, "Problem when getting current class");
                return;
        }
        checkPoint = s_editorUndo;
        pp = editorCrNewBufferMarker(point->buffer, point->offset);
        res = editorRunWithMarkerUntil(pp, isMethodBeg, 1);
        if (! res) {
                error(ERR_INTERNAL, "Can't find beginning of method");
                return;
        }
        pp->offset ++;
        sprintf(testi, "xxx(%s)", param);
        bi = pp->offset + 3 + plen;
        editorReplaceString(pp->buffer, pp->offset, 0, testi, strlen(testi), &s_editorUndo);
        pp->offset = bi;
        refactoryEditServerParseBuffer( s_ropt.project, pp->buffer,
                                                                   pp,NULL, "-olcxgetsymboltype","-noerrors");
        s_opt.noErrors = 0;
        if (! s_olstringServed) {
                error(ERR_ST, "Can't infer type for parameter/field");
                return;
        }
        parclassnum = getClassNumFromClassLinkName(s_olSymbolClassType, s_noneFileIndex);
        if (parclassnum==s_noneFileIndex) {
                error(ERR_INTERNAL, "Problem when getting parameter/field class");
                return;
        }
        if (! isSmallerOrEqClass(parclassnum, classnum)) {
                error(ERR_ST, "Type of parameter/field combination must be current class or its subclass");
                return;
        }
        editorUndoUntil(checkPoint, NULL);
        editorFreeMarker(pp);
        strcpy(nameOnPoint, refactoryGetIdentifierOnMarker_st(point));
        { if (!(strlen(nameOnPoint) < TMP_STRING_SIZE-1)) internalCheckFail("strlen(nameOnPoint) < TMP_STRING_SIZE-1", "refactory.c", 2196);};
        occs = refactoryPushGetAndPreCheckReferences(point->buffer, point, nameOnPoint,"Select classes in left window.  Those classes will be  processed during\nrefactoring. It  is highly recommended  to process whole  hierarchy of\nrelated classes  at once. Unselection  of any class and  its exclusion\nfrom refactoring may cause changes in your program behaviour.\n",PPCV_BROWSER_TYPE_INFO);
        { register S_editorMarkerList *tmp; register int co=0; tmp = occs; while (tmp!=NULL) {++co; tmp = tmp->next; } progressn = co; }; progressi=0;
        for(ll=occs; ll!=NULL; ll=ll->next) {
                if (! ( ( (ll->usage)==UsageDefined || (ll->usage)==UsageOLBestFitDefined) || (ll->usage)==UsageDeclared )) {
                        res = refactoryGetParamPosition(ll->d, nameOnPoint, argn);
                        if (res == 0) {
                                m1 = editorCrNewMarkerForPosition(&s_paramBeginPosition);
                                m1->offset ++;
                                editorRunWithMarkerUntil(m1, noSpaceChar, 1);
                                m2 = editorCrNewMarkerForPosition(&s_paramEndPosition);
                                m2->offset --;
                                editorRunWithMarkerUntil(m2, noSpaceChar, -1);
                                m2->offset ++;
                                tplen = m2->offset - m1->offset;
                                { if (!(tplen < REFACTORING_TMP_STRING_SIZE-1)) internalCheckFail("tplen < REFACTORING_TMP_STRING_SIZE-1", "refactory.c", 2212);};
                                strncpy(tparam, (m1->buffer->a.text+m1->offset), tplen);
                                tparam[tplen] = 0;
                                if (strcmp(tparam, "this")!=0) {
                                        sprintf(tparam+strlen(tparam), ".");
                                        if (s_ropt.refpar2[0]!=0) {
                                                sprintf(tparam+strlen(tparam), "%s.", s_ropt.refpar2);
                                        }
                                        pp = refactoryReplaceStaticPrefix(ll->d, tparam);
                                        editorFreeMarker(pp);
                                }
                                editorFreeMarker(m2);
                                editorFreeMarker(m1);
                        }
                }
                writeRelativeProgress((progressi++)*100/progressn);
        }
        writeRelativeProgress(100);
        refactoryRemoveModifier(point, "static");
        poccs = refactoryGetReferences(
                mm->buffer, mm,
                "Select classes in left window.  Those classes will be  processed during\nrefactoring. It  is highly recommended  to process whole  hierarchy of\nrelated classes  at once. Unselection  of any class and  its exclusion\nfrom refactoring may cause changes in your program behaviour.\n", PPCV_BROWSER_TYPE_INFO
                );
        for(ll=poccs; ll!=NULL; ll=ll->next) {
                if (! ( ( (ll->usage)==UsageDefined || (ll->usage)==UsageOLBestFitDefined) || (ll->usage)==UsageDeclared )) {
                        if (ll->d->offset+plen <= ll->d->buffer->a.bufferSize
                                && staticToDynCanBeThisOccurence(ll->d, param, &rlen)) {
                                refactoryReplaceString(ll->d, rlen, "this");
                                refactoryRemoveMethodPartIfRedundant(ll->d, strlen("this."));
                        }
                }
        }
        if (! refactoryIsThisSymbolUsed(mm)) {
                refactoryApplyParameterManipulation(point->buffer, point, PPC_AVR_DEL_PARAMETER, argn, 0);
        } else {
                writeRelativeProgress(100);
        }
        refactoryAplyWholeRefactoringFromUndo();
        ppcGenGotoMarkerRecord(point);
}
static void refactoryExtractMethod(S_editorMarker *point, S_editorMarker *mark) {
        refactoryEditServerParseBuffer( s_ropt.project, point->buffer, point, mark, "-olcxextract=newMethod$",NULL);
}
void mainRefactory(int argc, char **argv) {
        int fArgCount;
        char *file, *fff;
        char ifile[MAX_FILE_NAME_SIZE];
        S_editorBuffer *buf;
        S_editorMarker *point, *mark;
        copyOptions(&s_ropt, &s_opt);
        s_ropt.cxrefs = OLO_LIST;
        mainOpenOutputFile(s_ropt.outputFileName);
        editorLoadAllOpenedBufferFiles();
        editorQuasySaveModifiedBuffers();
        if (s_ropt.project==NULL) {
                fatalError(ERR_ST, "You have to specify active project with -p option",
                                   65);
        }
        fArgCount = 0; fff = getInputFile(&fArgCount);
        if (fff==NULL) {
                file = NULL;
        } else {
                strcpy(ifile, fff);
                file = ifile;
        }
        buf = NULL;
        if (file!=NULL) buf = editorFindFile(file);
        point = refactoryGetPointFromRefactoryOptions(buf);
        mark = refactoryGetMarkFromRefactoryOptions(buf);
        s_refactoringStartPoint = s_editorUndo;
        mainTaskEntryInitialisations(argnum(s_refactoryEditSrvInitOptions),
                                                                 s_refactoryEditSrvInitOptions);
        s_refactoryXrefEditSrvSubTaskFirstPassing = 1;
        s_progressFactor = 1;
        if (s_ropt.theRefactoring==PPC_AVR_RENAME_SYMBOL
                || s_ropt.theRefactoring==PPC_AVR_RENAME_CLASS
                || s_ropt.theRefactoring==PPC_AVR_RENAME_PACKAGE) {
                s_progressFactor = 2;
                refactoryRename(buf, point);
        } else if (s_ropt.theRefactoring==PPC_AVR_EXPAND_NAMES) {
                s_progressFactor = 0;
                refactoryExpandShortNames(buf, point);
        } else if (s_ropt.theRefactoring==PPC_AVR_REDUCE_NAMES) {
                s_progressFactor = 1;
                refactoryReduceLongNames(buf, point);
        } else if (s_ropt.theRefactoring==PPC_AVR_ADD_PARAMETER
                           || s_ropt.theRefactoring==PPC_AVR_DEL_PARAMETER
                           || s_ropt.theRefactoring==PPC_AVR_MOVE_PARAMETER) {
                s_progressFactor = 3;
                refactoryParameterManipulation(buf, point, s_ropt.theRefactoring,
                                                                           s_ropt.olcxGotoVal, s_ropt.parnum2);
        } else if (s_ropt.theRefactoring==PPC_AVR_MOVE_STATIC_FIELD) {
                s_progressFactor = 5;
                refactoryMoveStaticMethod(point);
        } else if (s_ropt.theRefactoring==PPC_AVR_MOVE_STATIC_METHOD) {
                s_progressFactor = 5;
                refactoryMoveStaticMethod(point);
        } else if (s_ropt.theRefactoring==PPC_AVR_MOVE_CLASS) {
                s_progressFactor = 5;
                refactoryMoveClass(point);
        } else if (s_ropt.theRefactoring==PPC_AVR_TURN_STATIC_METHOD_TO_DYNAMIC) {
                s_progressFactor = 5;
                refactoryTurnStaticToDynamic(point);
        } else if (s_ropt.theRefactoring==PPC_AVR_TURN_DYNAMIC_METHOD_TO_STATIC) {
                s_progressFactor = 5;
                refactoryTurnDynamicToStatic(point);
        } else if (s_ropt.theRefactoring==PPC_AVR_EXTRACT_METHOD) {
                s_progressFactor = 0;
                refactoryExtractMethod(point, mark);
        } else {
                error(ERR_INTERNAL, "unknown refactoring");
        }
        if (s_progressOffset != s_progressFactor) {
                sprintf(tmpBuff, "s_progressOffset (%d) != s_progressFactor (%d)", s_progressOffset, s_progressFactor);
                ppcGenRecord(PPC_DEBUG_INFORMATION, tmpBuff, "\n");
        }
        editorQuasySaveModifiedBuffers();
        mainCloseOutputFile();
        ppcGenSynchroRecord();
        s_opt.taskRegime = RegimeUndefined;
}
