
/*

Copyright (C) Marian Vittek, Xref-Tech, Bratislava, 1997-2002.
All Rights Reserved.

    THIS FILE IS CONSIDERED A TRADE SECRET BY XREF-TECH.
UNAUTHORIZED ACCESS, USE, REPRODUCTION OR DISTRIBUTION IS PROHIBITED.

*/
#ifndef STDINC__H
#define STDINC__H
#if defined(__WIN32) && (! defined(__WIN32__))
#define __WIN32__ 1
#endif
#ifdef __WIN32__
#include <windows.h>
#include <direct.h>
#else
#include <unistd.h>
#include <dirent.h>
#endif
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <assert.h>
#include <string.h>
#include <time.h>
#include <setjmp.h>
#include <sys/types.h>
#include <sys/stat.h>
#endif
#include "head2.h"
#include "proto.h"
#ifdef __WIN32__
#endif
typedef union {
        int integer;
        unsigned unsign;
        S_symbol *symbol;
        S_symbolList *symbolList;
        S_typeModifiers *typeModif;
        S_typeModifiersList *typeModifList;
        S_freeTrail *trail;
        S_idIdent *idIdent;
        S_idIdentList *idlist;
        S_exprTokenType exprType;
        S_intPair intpair;
        S_whileExtractData *whiledata;
        S_position position;
        S_unsPositionPair unsPositionPair;
        S_symbolPositionPair symbolPositionPair;
        S_symbolPositionLstPair symbolPositionLstPair;
        S_positionLst *positionLst;
        S_typeModifiersListPositionLstPair typeModifiersListPositionLstPair;
} YYSTYPE;
extern YYSTYPE yylval;
extern YYSTYPE cyylval;
extern YYSTYPE javayylval;
extern YYSTYPE javaslyylval;
extern YYSTYPE cccyylval;
extern YYSTYPE yaccyylval;
extern YYSTYPE *uniyylval;
#if XREF_HUGE
#define PutLexFilePos(xxx,dd) { unsigned tmp; tmp = xxx; *(dd)++ = tmp%256; tmp /= 256; *(dd)++ = tmp%256; tmp /= 256; *(dd)++ = tmp%256; tmp /= 256; *(dd)++ = tmp%256; tmp /= 256;}
#else
#define PutLexFilePos(xxx,dd) { *(dd)++ = ((unsigned)(xxx))%256; *(dd)++ = ((unsigned)(xxx))/256;}
#endif
#ifdef XREF_HUGE
#define PutLexNumPos(xxx,dd) { unsigned tmp; tmp = xxx; *(dd)++ = tmp%256; tmp /= 256; *(dd)++ = tmp%256; tmp /= 256; *(dd)++ = tmp%256; tmp /= 256; *(dd)++ = tmp%256; tmp /= 256;}
#else
#define PutLexNumPos(xxx,dd) { *(dd)++ = ((unsigned)(xxx))%256; *(dd)++ = ((unsigned)(xxx))/256;}
#endif
#if XREF_HUGE
#define GetLexFilePos(xxx,dd) { xxx = *((unsigned char*)dd++); xxx += 256 * *((unsigned char*)dd++); xxx += 256 * 256 * *((unsigned char*)dd++); xxx += 256 * 256 * 256 * *((unsigned char*)dd++);}
#else
#define GetLexFilePos(xxx,dd) { xxx = *((unsigned char*)dd++); xxx += 256 * *((unsigned char*)dd++);}
#endif
#ifdef XREF_HUGE
#define GetLexNumPos(xxx,dd) { xxx = *((unsigned char*)dd++); xxx += 256 * *((unsigned char*)dd++); xxx += 256 * 256 * *((unsigned char*)dd++); xxx += 256 * 256 * 256 * *((unsigned char*)dd++);}
#else
#define GetLexNumPos(xxx,dd) { xxx = *((unsigned char*)dd++); xxx += 256 * *((unsigned char*)dd++);}
#endif
#if XREF_HUGE
#define NextLexFilePos(dd) ( *((unsigned char*)dd) + 256 * *(((unsigned char*)dd)+1) + 256 * 256 * *(((unsigned char*)dd)+2) + 256 * 256 * 256 * *(((unsigned char*)dd)+3))
#else
#define NextLexFilePos(dd) ( *((unsigned char*)dd) + 256 * *(((unsigned char*)dd)+1))
#endif
#ifdef XREF_HUGE
#define NextLexNumPos(dd) ( *((unsigned char*)dd) + 256 * *(((unsigned char*)dd)+1) + 256 * 256 * *(((unsigned char*)dd)+2) + 256 * 256 * 256 * *(((unsigned char*)dd)+3))
#else
#define NextLexNumPos(dd) ( *((unsigned char*)dd) + 256 * *(((unsigned char*)dd)+1))
#endif
struct maTab {
        int size;
        int numberOfElements;
        S_macroArgTabElem **tab;
};
extern void maTabInit ();
extern void maTabNAInit ();
extern int maTabIsMember ();
void maTabSet ();
extern void maTabAdd ();
extern void maTabFree ();
extern void maTabMap ();
extern void maTabMap2 ();
extern void maTabMap4 ();
extern void maTabMap3 ();
void maTabNAInit(struct maTab *t, int size) {
        int i;
        t->numberOfElements = 0;
        t->size = size;
        memset(t->tab, 0, sizeof(S_macroArgTabElem*)*t->size);
}
void maTabInit(struct maTab *t, int size) {
        int i;
        {t->tab = (S_macroArgTabElem **) stackMemoryAlloc((size)*sizeof(S_macroArgTabElem *)); };
        maTabNAInit(t, size);
}
int maTabIsMember(
                                        struct maTab *t,
                                        S_macroArgTabElem *elem,
                                        int *position
                        ) {
        unsigned posid;
        posid = hashFun(elem->name);
        posid = posid % t->size;
        { if (!(t->tab!=NULL)) internalCheckFail("t->tab!=NULL", "hashtab.tc", 57);};
        while (t->tab[posid] != NULL) {
                if ((strcmp(t->tab[posid]->name,elem->name)==0)) {
                        *position = posid;
                        return(1);
                }
                posid=(posid+211) % t->size;
        }
        *position = posid;
        return(0);
}
void maTabSet (
                                        struct maTab *t,
                                        S_macroArgTabElem *elem,
                                        int position
                                ) {
    if (t->tab[position]==NULL) {
                t->numberOfElements ++;
            if ((t->numberOfElements * 9) / 8 >= t->size) {
          fatalError(ERR_ST, "[hashAdd] file table overflowed", 65);
            }
        }
    t->tab[position] = elem;
}
void maTabAdd (
                                        struct maTab *t,
                                        S_macroArgTabElem *elem,
                                        int *position
                                ) {
  if (! maTabIsMember(t,elem,position)) {
        maTabSet (t,elem,*position);
  }
}
void maTabFree(struct maTab *t) {
        { };
}
void maTabMap(
                                        struct maTab *t,
                                        void (*fun)(S_macroArgTabElem *)
                                ) {
        int i;
        for(i=0; i<t->size; i++) {
                if (t->tab[i]!=NULL) (*fun)(t->tab[i]);
        }
}
void maTabMap2(
                                        struct maTab *t,
                                        void (*fun)(S_macroArgTabElem *, void *),
                                        void *a
                                ) {
        int i;
        for(i=0; i<t->size; i++) {
                if (t->tab[i]!=NULL) (*fun)(t->tab[i], a);
        }
}
void maTabMap4(
                                        struct maTab *t,
                                        void (*fun)(int, void *, void *),
                                        void *a,
                                        void *b
                                ) {
        int i;
        for(i=0; i<t->size; i++) {
                if (t->tab[i]!=NULL) (*fun)(i, a, b);
        }
}
void maTabMap3(
                                        struct maTab *t,
                                        void (*fun)(S_macroArgTabElem *, int)
                                ) {
        int i;
        for(i=0; i<t->size; i++) {
                if (t->tab[i]!=NULL) (*fun)(t->tab[i], i);
        }
}
static struct maTab s_maTab;
static char ppMemory[SIZE_ppMemory];
static int ppMemoryi=0;
S_position s_yyPositionBuf[YYBUFFERED_ID_INDEX];
int s_yyPositionBufi = 0;
static void prependMacroArgument ();
static int macroCallExpand ();
void initAllInputs() {
        mbMemoryi=0;
        inStacki=0;
        macStacki=0;
        s_ifEvaluation = 0;
        s_cxRefFlag = 0;
        maTabNAInit(&s_maTab, MAX_MACRO_ARGS);
        ppMemoryi=0;
        s_olstringFound = 0;
        s_olstringServed = 0;
        s_olstringInMbody = NULL;
        s_upLevelFunctionCompletionType = NULL;
        s_structRecordCompletionType = NULL;
}
char *placeIdent() {
        static char tt[MAX_HTML_REF_LEN];
        char fn[MAX_FILE_NAME_SIZE];
        int s;
        if (cFile.fileName!=NULL) {
                if (s_opt.xref2 && s_opt.taskRegime==RegimeXref) {
                        strcpy(fn, getRealFileNameStatic(normalizeFileName(cFile.fileName, s_cwd)));
                        { if (!(strlen(fn) < MAX_FILE_NAME_SIZE)) internalCheckFail("strlen(fn) < MAX_FILE_NAME_SIZE", "yylex.c", 91);};
                        sprintf(tt,"<A HREF=\"file://%s#%d\">%s:%d</A>", fn, cFile.lineNumber,
                                        simpleFileName(fn),cFile.lineNumber);
                } else {
                        sprintf(tt,"%s:%d ",simpleFileName(getRealFileNameStatic(cFile.fileName)),cFile.lineNumber);
                }
                s = strlen(tt);
                { if (!(s<MAX_HTML_REF_LEN)) internalCheckFail("s<MAX_HTML_REF_LEN", "yylex.c", 98);};
                return(tt);
        }
        return("");
}
static void dpnewline(int n) {
        int i;
        if (s_opt.debug) {
                for(i=1; i<=n; i++) {
                        fprintf(dumpOut,"\n%s:%d ", cFile.fileName, cFile.lineNumber+i);
                        fflush(dumpOut);
                }
        }
}
int addFileTabItem(char *name, int *fileNumber) {
        int ii,len,res;
        char *fname,*nn;
        struct fileItem ffi, *ffii;
        res = 0;
        nn = normalizeFileName(name,s_cwd);
        { (&ffi)->name = nn; (&ffi)->lastModif = 0; (&ffi)->lastInspect = 0; (&ffi)->lastUpdateMtime = 0; (&ffi)->lastFullUpdateMtime = 0; (&ffi)->b.cxLoading = 0; (&ffi)->b.cxLoaded = 0; (&ffi)->b.cxSaved = 0; (&ffi)->b.commandLineEntered = 0; (&ffi)->b.scheduledToProcess = 0; (&ffi)->b.scheduledToUpdate = 0; (&ffi)->b.fullUpdateIncludesProcessed = 0; (&ffi)->b.isInterface = 0; (&ffi)->b.sourceFile = s_noneFileIndex; (&ffi)->sups = NULL; (&ffi)->infs = NULL; (&ffi)->directEnclosingInstance = s_noneFileIndex;};
        if (idTabIsMember(&s_fileTab, &ffi, fileNumber)) return(0);
        len = strlen(nn);
        {{ { if (!((len+1) >= 0)) internalCheckFail("(len+1) >= 0", "yylex.c", 130);}; ftMemoryi = ((char*)(((char*)(ftMemory+ftMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(ftMemory+ftMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - ftMemory; if (ftMemoryi+(len+1)*sizeof(char) >= SIZE_ftMemory) { fatalError(ERR_NO_MEMORY,"ftMemory", 65); } fname = (char*) (ftMemory + ftMemoryi); ftMemoryi += (len+1)*sizeof(char);};};
        strcpy(fname, nn);
        {{{ { if (!((1) >= 0)) internalCheckFail("(1) >= 0", "yylex.c", 132);}; ftMemoryi = ((char*)(((char*)(ftMemory+ftMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(ftMemory+ftMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - ftMemory; if (ftMemoryi+(1)*sizeof(S_fileItem) >= SIZE_ftMemory) { fatalError(ERR_NO_MEMORY,"ftMemory", 65); } ffii = (S_fileItem*) (ftMemory + ftMemoryi); ftMemoryi += (1)*sizeof(S_fileItem);};};};
        { (ffii)->name = fname; (ffii)->lastModif = 0; (ffii)->lastInspect = 0; (ffii)->lastUpdateMtime = 0; (ffii)->lastFullUpdateMtime = 0; (ffii)->b.cxLoading = 0; (ffii)->b.cxLoaded = 0; (ffii)->b.cxSaved = 0; (ffii)->b.commandLineEntered = 0; (ffii)->b.scheduledToProcess = 0; (ffii)->b.scheduledToUpdate = 0; (ffii)->b.fullUpdateIncludesProcessed = 0; (ffii)->b.isInterface = 0; (ffii)->b.sourceFile = s_noneFileIndex; (ffii)->sups = NULL; (ffii)->infs = NULL; (ffii)->directEnclosingInstance = s_noneFileIndex;};
        idTabAdd(&s_fileTab, ffii, &ii);
        testFileModifTime(ii);
        *fileNumber = ii;
        return(1);
}
void getOrCreateFileInfo(char *ss, int *fileNumber, char **fileName) {
        int ii,len,newFileFlag,cxloading;
        char *ff;
        struct fileItem *ffii;
        if (ss==NULL) {
                *fileNumber = ii = s_noneFileIndex;
                *fileName = s_fileTab.tab[ii]->name;
        } else {
                newFileFlag = addFileTabItem(ss, &ii);
                *fileNumber = ii;
                *fileName = s_fileTab.tab[ii]->name;
                testFileModifTime(ii);
                cxloading = s_fileTab.tab[ii]->b.cxLoading;
                if (s_opt.update) {
                        if (newFileFlag || s_fileTab.tab[ii]->b.scheduledToUpdate) {
                                cxloading = 1;
                        }
                } else {
                        cxloading = 1;
                }
                if (s_fileTab.tab[ii]->b.cxSaved==1 && ! s_opt.multiHeadRefsCare) {
                        cxloading = 0;
                }
                if (((s_language & (4)) != 0) && s_jsl!=NULL) {
                        cxloading = s_fileTab.tab[ii]->b.cxLoading;
                }
                s_fileTab.tab[ii]->b.cxLoading = cxloading;
        }
}
void setOpenFileInfo(char *ss) {
        int ii;
        char *ff;
        getOrCreateFileInfo(ss, &ii, &ff);
        cFile.lb.cb.fileNumber = ii;
        cFile.fileName = ff;
}
void ppMemInit() {
        {{ { if (!((MAX_MACRO_ARGS) >= 0)) internalCheckFail("(MAX_MACRO_ARGS) >= 0", "yylex.c", 187);}; ppmMemoryi = ((char*)(((char*)(ppmMemory+ppmMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(ppmMemory+ppmMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - ppmMemory; if (ppmMemoryi+(MAX_MACRO_ARGS)*sizeof(struct macroArgTabElem *) >= SIZE_ppmMemory) { fatalError(ERR_NO_MEMORY,"ppmMemory", 65); } s_maTab.tab = (struct macroArgTabElem **) (ppmMemory + ppmMemoryi); ppmMemoryi += (MAX_MACRO_ARGS)*sizeof(struct macroArgTabElem *);};};
        maTabNAInit(&s_maTab, MAX_MACRO_ARGS);
        ppMemoryi = 0;
}
void initInput(FILE *ff, S_editorBuffer *buffer, char *prepend, char *name) {
        int plen, bsize, filepos;
        char *bbase;
        plen = strlen(prepend);
        if (buffer!=NULL) {
                { if (!(plen < buffer->a.allocatedFreePrefixSize)) internalCheckFail("plen < buffer->a.allocatedFreePrefixSize", "yylex.c", 199);};
                strncpy(buffer->a.text-plen, prepend, plen);
                bbase = buffer->a.text-plen;
                bsize = buffer->a.bufferSize+plen;
                filepos = buffer->a.bufferSize;
                { if (!(bbase > buffer->a.allocatedBlock)) internalCheckFail("bbase > buffer->a.allocatedBlock", "yylex.c", 204);};
        } else {
                { if (!(plen < CHAR_BUFF_SIZE)) internalCheckFail("plen < CHAR_BUFF_SIZE", "yylex.c", 207);};
                strcpy(cFile.lb.cb.a,prepend);
                bbase = cFile.lb.cb.a;
                bsize = plen;
                filepos = 0;
        }
        { (&cFile)->fileName = name; (&cFile)->lineNumber = 0; (&cFile)->ifDeep = 0; (&cFile)->ifstack = NULL; (&cFile)->lb.cc = NULL; (&cFile)->lb.fin = NULL; (&cFile)->lb.posi = 0; (&cFile)->lb.cb.cc = bbase; (&cFile)->lb.cb.fin = bbase+bsize; (&cFile)->lb.cb.ff = ff; (&cFile)->lb.cb.filePos = filepos; (&cFile)->lb.cb.fileNumber = s_noneFileIndex; (&cFile)->lb.cb.lineNum = 0; (&cFile)->lb.cb.lineBegin = bbase; (&cFile)->lb.cb.collumnOffset = 0; (&cFile)->lb.cb.isAtEOF = 0; (&cFile)->lb.cb.inputMethod = INPUT_DIRECT; (&cFile)->lb.cb.zipStream.next_in = NULL; (&cFile)->lb.cb.zipStream.avail_in = 0; (&cFile)->lb.cb.zipStream.total_in = 0; (&cFile)->lb.cb.zipStream.next_out = NULL; (&cFile)->lb.cb.zipStream.avail_out = 0; (&cFile)->lb.cb.zipStream.total_out = 0; (&cFile)->lb.cb.zipStream.msg = NULL; (&cFile)->lb.cb.zipStream.state = NULL; (&cFile)->lb.cb.zipStream.zalloc = NULL; (&cFile)->lb.cb.zipStream.zfree = NULL; (&cFile)->lb.cb.zipStream.opaque = NULL; (&cFile)->lb.cb.zipStream.data_type = 0; (&cFile)->lb.cb.zipStream.adler = 0; (&cFile)->lb.cb.zipStream.reserved = 0;};
        setOpenFileInfo(name);
        { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};};
        s_ifEvaluation = 0;
}
static void testCxrefCompletionId(int *llex, char *idd, S_position *pos) {
        int line,val,len,lex,res=0;
        unsigned h;
        lex = *llex;
        { if (!(s_opt.taskRegime)) internalCheckFail("s_opt.taskRegime", "yylex.c", 325);};
        if (s_opt.taskRegime == RegimeEditServer) {
                if (lex==444) {
                        s_cache.activeCache = 0;
                        s_olstringServed = 1;
                        if (s_language == 4) {
                                makeJavaCompletions(idd, strlen(idd), pos);
                        }
                        else if (s_language == 8) {
                                makeYaccCompletions(idd, strlen(idd), pos);
                        }
                        else {
                                makeCCompletions(idd, strlen(idd), pos);
                        }
                        lex = 439;
                }
        }
        *llex = lex;
}
static void processLine() {
        char ss[TMP_STRING_SIZE];
        int i,lex,l,h,v=0;
        S_position pos;
        char ch,*cc;
        { char *lastlexcc; { while (cInput.cc >= cInput.fin) { char margFlag; margFlag = cInput.margExpFlag; if (macStacki > 0) { if (margFlag == II_MACRO_ARG) goto endOfMacArg; {{ { if (!((cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi)) internalCheckFail("(cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi", "yylex.c", 362);}; mbMemoryi = ((char*)(cInput.a))-mbMemory;};}; cInput = macStack[--macStacki]; } else if (margFlag == II_NORMAL) { { cFile.lb.cc = cInput.cc;}; getLexBuf(&cFile.lb); if (cFile.lb.cc >= cFile.lb.fin) goto endOfFile; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; } else { s_cache.cc = s_cache.cfin = NULL; cacheInput(); s_cache.lexcc = cFile.lb.cc; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; {}; } } lastlexcc = cInput.cc; { lex = *((unsigned char*)cInput.cc++); lex += 256 * *((unsigned char*)cInput.cc++);};};};
        { if (lex > 438) { if ((lex==439 || lex==446 || lex==444)){ register char *tmpcc,tmpch; h = 0; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { h+=tmpch; h+=(h<<10); h^=(h>>6);}; } { h+=(h<<3); h^=(h>>11); h+=(h<<15);}; tmpcc ++; { GetLexFilePos((pos).file,tmpcc); GetLexNumPos((pos).line,tmpcc); GetLexNumPos((pos).coll,tmpcc);}; cInput.cc = tmpcc; } else if (lex == 442) { register char *tmpcc,tmpch; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; { GetLexFilePos((pos).file,tmpcc); GetLexNumPos((pos).line,tmpcc); GetLexNumPos((pos).coll,tmpcc);}; cInput.cc = tmpcc; } else if (lex == 443) { { l = *((unsigned char*)cInput.cc++); l += 256 * *((unsigned char*)cInput.cc++);}; if (1) { if(s_opt.debug) dpnewline(l); cFile.lineNumber += l; } } else if (lex == 440 || lex == 441 || lex == 445 || lex == 447) { { v = *((unsigned char*)cInput.cc++); v += 256 * *((unsigned char*)cInput.cc++); v += 256 * 256 * *((unsigned char*)cInput.cc++); v += 256 * 256 * 256 * *((unsigned char*)cInput.cc++);}; } } else if (lex>411 && lex<424) { { GetLexFilePos((pos).file,cInput.cc); GetLexNumPos((pos).line,cInput.cc); GetLexNumPos((pos).coll,cInput.cc);}; } else if (lex == '\n' && (1)) { if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else if (lex<448 && s_tokenHasPosition[lex]) { { GetLexFilePos((pos).file,cInput.cc); GetLexNumPos((pos).line,cInput.cc); GetLexNumPos((pos).coll,cInput.cc);}; } };
        if (lex != 440) return;
        cFile.lineNumber = v-1;
        { char *lastlexcc; { while (cInput.cc >= cInput.fin) { char margFlag; margFlag = cInput.margExpFlag; if (macStacki > 0) { if (margFlag == II_MACRO_ARG) goto endOfMacArg; {{ { if (!((cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi)) internalCheckFail("(cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi", "yylex.c", 366);}; mbMemoryi = ((char*)(cInput.a))-mbMemory;};}; cInput = macStack[--macStacki]; } else if (margFlag == II_NORMAL) { { cFile.lb.cc = cInput.cc;}; getLexBuf(&cFile.lb); if (cFile.lb.cc >= cFile.lb.fin) goto endOfFile; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; } else { s_cache.cc = s_cache.cfin = NULL; cacheInput(); s_cache.lexcc = cFile.lb.cc; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; {}; } } lastlexcc = cInput.cc; { lex = *((unsigned char*)cInput.cc++); lex += 256 * *((unsigned char*)cInput.cc++);};};};
        { if (lex > 438) { if ((lex==439 || lex==446 || lex==444)){ register char *tmpcc,tmpch; h = 0; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { h+=tmpch; h+=(h<<10); h^=(h>>6);}; } { h+=(h<<3); h^=(h>>11); h+=(h<<15);}; tmpcc ++; { GetLexFilePos((pos).file,tmpcc); GetLexNumPos((pos).line,tmpcc); GetLexNumPos((pos).coll,tmpcc);}; cInput.cc = tmpcc; } else if (lex == 442) { register char *tmpcc,tmpch; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; { GetLexFilePos((pos).file,tmpcc); GetLexNumPos((pos).line,tmpcc); GetLexNumPos((pos).coll,tmpcc);}; cInput.cc = tmpcc; } else if (lex == 443) { { l = *((unsigned char*)cInput.cc++); l += 256 * *((unsigned char*)cInput.cc++);}; if (1) { if(s_opt.debug) dpnewline(l); cFile.lineNumber += l; } } else if (lex == 440 || lex == 441 || lex == 445 || lex == 447) { { v = *((unsigned char*)cInput.cc++); v += 256 * *((unsigned char*)cInput.cc++); v += 256 * 256 * *((unsigned char*)cInput.cc++); v += 256 * 256 * 256 * *((unsigned char*)cInput.cc++);}; } } else if (lex>411 && lex<424) { { GetLexFilePos((pos).file,cInput.cc); GetLexNumPos((pos).line,cInput.cc); GetLexNumPos((pos).coll,cInput.cc);}; } else if (lex == '\n' && (1)) { if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else if (lex<448 && s_tokenHasPosition[lex]) { { GetLexFilePos((pos).file,cInput.cc); GetLexNumPos((pos).line,cInput.cc); GetLexNumPos((pos).coll,cInput.cc);}; } };
        return;
endOfMacArg: { if (!(0)) internalCheckFail("0", "yylex.c", 384);};
endOfFile:;
}
static void fillIncludeSymbolItem( S_symbol *ss,
                                                                   int filenum, S_position *pos
        ){
        { (&ss->b)->record = 0; (&ss->b)->accessFlags = 0; (&ss->b)->javaSourceLoaded = 0; (&ss->b)->javaFileLoaded = 0; (&ss->b)->symType = TypeCppInclude; (&ss->b)->storage = StorageDefault; (&ss->b)->npointers = 0;};
        { (ss)->name = "%%%i"; (ss)->linkName = "%%%i"; (ss)->pos = *pos; (ss)->b = ss->b; (ss)->u.type = NULL; (ss)->next = NULL;};
}
void addThisFileDefineIncludeReference(int filenum) {
        S_position dpos;
        S_symbol ss;
        { (&dpos)->file = filenum; (&dpos)->line = 1; (&dpos)->coll = 0;};
        fillIncludeSymbolItem( &ss,filenum, &dpos);
        addCxReference(&ss, &dpos, UsageDefined, filenum, filenum);
}
void addIncludeReference(int filenum, S_position *pos) {
        S_position dpos;
        S_symbol ss;
        fillIncludeSymbolItem( &ss, filenum, pos);
        addCxReference(&ss, pos, UsageUsed, filenum, filenum);
}
static void addIncludeReferences(int filenum, S_position *pos) {
        addIncludeReference(filenum, pos);
        addThisFileDefineIncludeReference(filenum);
}
void pushNewInclude(FILE *f, S_editorBuffer *buffer, char *name, char *prepend) {
        if (cInput.margExpFlag == II_CACHE) {
                {s_cache.cc = cInput.cc;};
        } else {
                { cFile.lb.cc = cInput.cc;};
        }
        inStack[inStacki] = cFile;
        if (inStacki+1 >= INSTACK_SIZE) {
                fatalError(ERR_ST,"too deep nesting in includes", 65);
        }
        inStacki ++;
        initInput(f, buffer, prepend, name);
        cacheInclude(cFile.lb.cb.fileNumber);
}
void popInclude() {
        { if (!(s_fileTab.tab[cFile.lb.cb.fileNumber])) internalCheckFail("s_fileTab.tab[cFile.lb.cb.fileNumber]", "yylex.c", 443);};
        if (s_fileTab.tab[cFile.lb.cb.fileNumber]->b.cxLoading) {
                s_fileTab.tab[cFile.lb.cb.fileNumber]->b.cxLoaded = 1;
        }
        charBuffClose(&cFile.lb.cb);
        if (inStacki != 0) {
                cFile = inStack[--inStacki];
                if (inStacki == 0 && s_cache.cc!=NULL) {
                        { (&cInput)->cc = s_cache.cc; (&cInput)->fin = s_cache.cfin; (&cInput)->a = s_cache.lb; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_CACHE;};
                } else {
                        { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};};
                }
        }
}
static FILE *openInclude(char pchar, char *name, char **fileName) {
        S_editorBuffer *er;
        FILE *r;
        S_stringList *ll;
        char nn[MAX_FILE_NAME_SIZE];
        char rdir[MAX_FILE_NAME_SIZE];
        char *nnn;
        int nnlen,dlen,nmlen,len,ii;
        er = NULL; r = NULL;
        nmlen = strlen(name);
        if (pchar!='<') {
                copyDir(rdir, cFile.fileName, &dlen);
                strcpy(nn,normalizeFileName(name, rdir));
                        er = editorFindFile(nn);
                if (er==NULL) r = fopen(nn,"r");
        }
        for (ll=s_opt.includeDirs; ll!=NULL && er==NULL && r==NULL; ll=ll->next) {
                strcpy(nn, ll->d);
                dlen = strlen(ll->d);
                if (dlen>0 && nn[dlen-1]!=SLASH) {
                        nn[dlen] = SLASH;
                        dlen++;
                }
                strcpy(nn+dlen, name);
                nnlen = dlen+nmlen;
                nn[nnlen]=0;
                        er = editorFindFile(nn);
                if (er==NULL) r = fopen(nn,"r");
        }
        if (er==NULL && r==NULL) return(NULL);
        nnn = normalizeFileName(nn,s_cwd);
        strcpy(nn,nnn);
        pushNewInclude(r, er, nn, "\n");
        return(stdin);
}
static void processInclude2(S_position *ipos, char pchar, char *iname) {
        char *fname;
        FILE *nyyin;
        nyyin = openInclude(pchar, iname, &fname);
        if (nyyin == NULL) {
                { if (!(s_opt.taskRegime)) internalCheckFail("s_opt.taskRegime", "yylex.c", 573);};
                if (s_opt.taskRegime!=RegimeEditServer) warning(ERR_CANT_OPEN, iname);
        } else if ((s_opt.taskRegime!=RegimeGenerate)) {
                addIncludeReferences(cFile.lb.cb.fileNumber, ipos);
        }
}
static void processInclude(S_position *ipos) {
        FILE *nyyin;
        char *fname;
        char *ccc, *cc2;
        int lex,l,h,v;
        S_position pos;
        { while (cInput.cc >= cInput.fin) { char margFlag; margFlag = cInput.margExpFlag; if (macStacki > 0) { if (margFlag == II_MACRO_ARG) goto endOfMacArg; {{ { if (!((cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi)) internalCheckFail("(cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi", "yylex.c", 587);}; mbMemoryi = ((char*)(cInput.a))-mbMemory;};}; cInput = macStack[--macStacki]; } else if (margFlag == II_NORMAL) { { cFile.lb.cc = cInput.cc;}; getLexBuf(&cFile.lb); if (cFile.lb.cc >= cFile.lb.fin) goto endOfFile; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; } else { s_cache.cc = s_cache.cfin = NULL; cacheInput(); s_cache.lexcc = cFile.lb.cc; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; {}; } } cc2 = cInput.cc; { lex = *((unsigned char*)cInput.cc++); lex += 256 * *((unsigned char*)cInput.cc++);};};
        ccc = cInput.cc;
        if (lex == 442) {
                { if (lex > 438) { if ((lex==439 || lex==446 || lex==444)){ register char *tmpcc,tmpch; h = 0; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { h+=tmpch; h+=(h<<10); h^=(h>>6);}; } { h+=(h<<3); h^=(h>>11); h+=(h<<15);}; tmpcc ++; { GetLexFilePos((pos).file,tmpcc); GetLexNumPos((pos).line,tmpcc); GetLexNumPos((pos).coll,tmpcc);}; cInput.cc = tmpcc; } else if (lex == 442) { register char *tmpcc,tmpch; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; { GetLexFilePos((pos).file,tmpcc); GetLexNumPos((pos).line,tmpcc); GetLexNumPos((pos).coll,tmpcc);}; cInput.cc = tmpcc; } else if (lex == 443) { { l = *((unsigned char*)cInput.cc++); l += 256 * *((unsigned char*)cInput.cc++);}; if (1) { if(s_opt.debug) dpnewline(l); cFile.lineNumber += l; } } else if (lex == 440 || lex == 441 || lex == 445 || lex == 447) { { v = *((unsigned char*)cInput.cc++); v += 256 * *((unsigned char*)cInput.cc++); v += 256 * 256 * *((unsigned char*)cInput.cc++); v += 256 * 256 * 256 * *((unsigned char*)cInput.cc++);}; } } else if (lex>411 && lex<424) { { GetLexFilePos((pos).file,cInput.cc); GetLexNumPos((pos).line,cInput.cc); GetLexNumPos((pos).coll,cInput.cc);}; } else if (lex == '\n' && (1)) { if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else if (lex<448 && s_tokenHasPosition[lex]) { { GetLexFilePos((pos).file,cInput.cc); GetLexNumPos((pos).line,cInput.cc); GetLexNumPos((pos).coll,cInput.cc);}; } };
                if (macStacki != 0) {
                        error(ERR_INTERNAL,"include directive in macro body?");
                        cInput = macStack[0];
                        macStacki = 0;
                }
                processInclude2(ipos, *ccc, ccc+1);
        } else {
                cInput.cc = cc2;
                lex = yylex();
                if (lex == 442) {
                        cInput = macStack[0];
                        macStacki = 0;
                        processInclude2(ipos, '\"', yytext);
                } else if (lex == '<') {
                        warning(ERR_ST,"Include <> after macro expansion not yet implemented, sorry\n\tuse \"\" instead");
                }
        }
        return;
 endOfMacArg: { if (!(0)) internalCheckFail("0", "yylex.c", 611);};
 endOfFile:;
}
static void addMacroToTabs(S_symbol *pp, char *name) {
        int ii,mm;
        S_symbol *memb;
        mm = symTabIsMember(s_symTab,pp,&ii,&memb);
        if (mm) {
                { if (s_opt.debug) {fprintf(dumpOut,": masking macro %s\n",name);fflush(dumpOut);}};
        } else {
                { if (s_opt.debug) {fprintf(dumpOut,": adding macro %s\n",name);fflush(dumpOut);}};
        }
        symTabSet(s_symTab,pp,ii);
}
static void setMacArgName(S_macroArgTabElem *arg, void *at) {
        char ** argTab;
        argTab = (char**)at;
        { if (!(arg->order>=0)) internalCheckFail("arg->order>=0", "yylex.c", 642);};
        argTab[arg->order] = arg->name;
}
static void handleMacroDefinitionParameterPositions(int argi, S_position *macpos,
                                                                                                        S_position *parpos1,
                                                                                                        S_position *pos, S_position *parpos2,
                                                                                                        int final
        ) {
        if ((s_opt.cxrefs == OLO_GOTO_PARAM_NAME || s_opt.cxrefs == OLO_GET_PARAM_COORDINATES)
                && (! ( ((*macpos).file != (s_cxRefPos).file) || ((*macpos).line != (s_cxRefPos).line) || ((*macpos).coll != (s_cxRefPos).coll) ))) {
                if (final) {
                        if (argi==0) {
                                setParamPositionForFunctionWithoutParams(parpos1);
                        } else if (argi < s_opt.olcxGotoVal) {
                                setParamPositionForParameterBeyondRange(parpos2);
                        }
                } else if (argi == s_opt.olcxGotoVal) {
                        s_paramPosition = *pos;
                        s_paramBeginPosition = *parpos1;
                        s_paramEndPosition = *parpos2;
                }
        }
}
static void handleMacroUsageParameterPositions(int argi, S_position *macpos,
                                                                                           S_position *parpos1, S_position *parpos2,
                                                                                           int final
        ) {
        if (s_opt.cxrefs == OLO_GET_PARAM_COORDINATES
                && (! ( ((*macpos).file != (s_cxRefPos).file) || ((*macpos).line != (s_cxRefPos).line) || ((*macpos).coll != (s_cxRefPos).coll) ))) {
                if (final) {
                        if (argi==0) {
                                setParamPositionForFunctionWithoutParams(parpos1);
                        } else if (argi < s_opt.olcxGotoVal) {
                                setParamPositionForParameterBeyondRange(parpos2);
                        }
                } else if (argi == s_opt.olcxGotoVal) {
                        s_paramBeginPosition = *parpos1;
                        s_paramEndPosition = *parpos2;
fprintf(dumpOut,"regular setting to %d - %d\n", parpos1->coll, parpos2->coll);
                }
        }
}
static void processDefine(int argFlag) {
        int i,lex,l,h,v;
        int bodyReadingFlag = 0;
        int j,sizei,ii,msize,argi,ellipsis;
        S_symbol *pp;
        S_macroArgTabElem *maca,mmaca;
        S_macroBody *macbody;
        S_position pos, macpos, ppb1, ppb2, *parpos1, *parpos2, *tmppp;
        char ch,*cc,*mname,*aname,*mbody,*mLinkName,*mm,*fromcc,*tocc,*ddd;
        char **argNames, *argLinkName;
        sizei= -1;
        msize=0;argi=0;pp=NULL;macbody=NULL;mname=mbody=NULL;
        {ppMemoryi = 0;};
        ppb1 = s_noPos;
        ppb2 = s_noPos;
        parpos1 = &ppb1;
        parpos2 = &ppb2;
        { char *lastlexcc; { while (cInput.cc >= cInput.fin) { char margFlag; margFlag = cInput.margExpFlag; if (macStacki > 0) { if (margFlag == II_MACRO_ARG) goto endOfMacArg; {{ { if (!((cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi)) internalCheckFail("(cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi", "yylex.c", 705);}; mbMemoryi = ((char*)(cInput.a))-mbMemory;};}; cInput = macStack[--macStacki]; } else if (margFlag == II_NORMAL) { { cFile.lb.cc = cInput.cc;}; getLexBuf(&cFile.lb); if (cFile.lb.cc >= cFile.lb.fin) goto endOfFile; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; } else { s_cache.cc = s_cache.cfin = NULL; cacheInput(); s_cache.lexcc = cFile.lb.cc; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; {}; } } lastlexcc = cInput.cc; { lex = *((unsigned char*)cInput.cc++); lex += 256 * *((unsigned char*)cInput.cc++);};};};
        cc = cInput.cc;
        { if (lex > 438) { if ((lex==439 || lex==446 || lex==444)){ register char *tmpcc,tmpch; h = 0; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { h+=tmpch; h+=(h<<10); h^=(h>>6);}; } { h+=(h<<3); h^=(h>>11); h+=(h<<15);}; tmpcc ++; { GetLexFilePos((macpos).file,tmpcc); GetLexNumPos((macpos).line,tmpcc); GetLexNumPos((macpos).coll,tmpcc);}; cInput.cc = tmpcc; } else if (lex == 442) { register char *tmpcc,tmpch; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; { GetLexFilePos((macpos).file,tmpcc); GetLexNumPos((macpos).line,tmpcc); GetLexNumPos((macpos).coll,tmpcc);}; cInput.cc = tmpcc; } else if (lex == 443) { { l = *((unsigned char*)cInput.cc++); l += 256 * *((unsigned char*)cInput.cc++);}; if (1) { if(s_opt.debug) dpnewline(l); cFile.lineNumber += l; } } else if (lex == 440 || lex == 441 || lex == 445 || lex == 447) { { v = *((unsigned char*)cInput.cc++); v += 256 * *((unsigned char*)cInput.cc++); v += 256 * 256 * *((unsigned char*)cInput.cc++); v += 256 * 256 * 256 * *((unsigned char*)cInput.cc++);}; } } else if (lex>411 && lex<424) { { GetLexFilePos((macpos).file,cInput.cc); GetLexNumPos((macpos).line,cInput.cc); GetLexNumPos((macpos).coll,cInput.cc);}; } else if (lex == '\n' && (1)) { if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else if (lex<448 && s_tokenHasPosition[lex]) { { GetLexFilePos((macpos).file,cInput.cc); GetLexNumPos((macpos).line,cInput.cc); GetLexNumPos((macpos).coll,cInput.cc);}; } };
        testCxrefCompletionId(&lex,cc,&macpos);
        if (lex != 439) return;
        {{{ { if (!((1) >= 0)) internalCheckFail("(1) >= 0", "yylex.c", 710);}; ppmMemoryi = ((char*)(((char*)(ppmMemory+ppmMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(ppmMemory+ppmMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - ppmMemory; if (ppmMemoryi+(1)*sizeof(S_symbol) >= SIZE_ppmMemory) { fatalError(ERR_NO_MEMORY,"ppmMemory", 65); } pp = (S_symbol*) (ppmMemory + ppmMemoryi); ppmMemoryi += (1)*sizeof(S_symbol);};};};
        { (&pp->b)->record = 0; (&pp->b)->accessFlags = 0; (&pp->b)->javaSourceLoaded = 0; (&pp->b)->javaFileLoaded = 0; (&pp->b)->symType = TypeMacro; (&pp->b)->storage = StorageNone; (&pp->b)->npointers = 0;};
        { (pp)->name = NULL; (pp)->linkName = NULL; (pp)->pos = macpos; (pp)->b = pp->b; (pp)->u.mbody = NULL; (pp)->next = NULL;};
        setGlobalFileDepNames(cc, pp, MEM_PP);
        mname = pp->name;
        maTabNAInit(&s_maTab,s_maTab.size);
        argi = -1;
        if (argFlag) {
                { { char *lastlexcc; { while (cInput.cc >= cInput.fin) { char margFlag; margFlag = cInput.margExpFlag; if (macStacki > 0) { if (margFlag == II_MACRO_ARG) goto endOfMacArg; {{ { if (!((cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi)) internalCheckFail("(cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi", "yylex.c", 719);}; mbMemoryi = ((char*)(cInput.a))-mbMemory;};}; cInput = macStack[--macStacki]; } else if (margFlag == II_NORMAL) { { cFile.lb.cc = cInput.cc;}; getLexBuf(&cFile.lb); if (cFile.lb.cc >= cFile.lb.fin) goto endOfFile; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; } else { s_cache.cc = s_cache.cfin = NULL; cacheInput(); s_cache.lexcc = cFile.lb.cc; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; {}; } } lastlexcc = cInput.cc; { lex = *((unsigned char*)cInput.cc++); lex += 256 * *((unsigned char*)cInput.cc++);};};}; while (lex == 443) { { if (lex > 438) { if ((lex==439 || lex==446 || lex==444)){ register char *tmpcc,tmpch; h = 0; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { h+=tmpch; h+=(h<<10); h^=(h>>6);}; } { h+=(h<<3); h^=(h>>11); h+=(h<<15);}; tmpcc ++; { GetLexFilePos((pos).file,tmpcc); GetLexNumPos((pos).line,tmpcc); GetLexNumPos((pos).coll,tmpcc);}; cInput.cc = tmpcc; } else if (lex == 442) { register char *tmpcc,tmpch; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; { GetLexFilePos((pos).file,tmpcc); GetLexNumPos((pos).line,tmpcc); GetLexNumPos((pos).coll,tmpcc);}; cInput.cc = tmpcc; } else if (lex == 443) { { l = *((unsigned char*)cInput.cc++); l += 256 * *((unsigned char*)cInput.cc++);}; if (1) { if(s_opt.debug) dpnewline(l); cFile.lineNumber += l; } } else if (lex == 440 || lex == 441 || lex == 445 || lex == 447) { { v = *((unsigned char*)cInput.cc++); v += 256 * *((unsigned char*)cInput.cc++); v += 256 * 256 * *((unsigned char*)cInput.cc++); v += 256 * 256 * 256 * *((unsigned char*)cInput.cc++);}; } } else if (lex>411 && lex<424) { { GetLexFilePos((pos).file,cInput.cc); GetLexNumPos((pos).line,cInput.cc); GetLexNumPos((pos).coll,cInput.cc);}; } else if (lex == '\n' && (1)) { if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else if (lex<448 && s_tokenHasPosition[lex]) { { GetLexFilePos((pos).file,cInput.cc); GetLexNumPos((pos).line,cInput.cc); GetLexNumPos((pos).coll,cInput.cc);}; } }; { char *lastlexcc; { while (cInput.cc >= cInput.fin) { char margFlag; margFlag = cInput.margExpFlag; if (macStacki > 0) { if (margFlag == II_MACRO_ARG) goto endOfMacArg; {{ { if (!((cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi)) internalCheckFail("(cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi", "yylex.c", 719);}; mbMemoryi = ((char*)(cInput.a))-mbMemory;};}; cInput = macStack[--macStacki]; } else if (margFlag == II_NORMAL) { { cFile.lb.cc = cInput.cc;}; getLexBuf(&cFile.lb); if (cFile.lb.cc >= cFile.lb.fin) goto endOfFile; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; } else { s_cache.cc = s_cache.cfin = NULL; cacheInput(); s_cache.lexcc = cFile.lb.cc; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; {}; } } lastlexcc = cInput.cc; { lex = *((unsigned char*)cInput.cc++); lex += 256 * *((unsigned char*)cInput.cc++);};};}; }};
                { if (lex > 438) { if ((lex==439 || lex==446 || lex==444)){ register char *tmpcc,tmpch; h = 0; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { h+=tmpch; h+=(h<<10); h^=(h>>6);}; } { h+=(h<<3); h^=(h>>11); h+=(h<<15);}; tmpcc ++; { GetLexFilePos((*parpos2).file,tmpcc); GetLexNumPos((*parpos2).line,tmpcc); GetLexNumPos((*parpos2).coll,tmpcc);}; cInput.cc = tmpcc; } else if (lex == 442) { register char *tmpcc,tmpch; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; { GetLexFilePos((*parpos2).file,tmpcc); GetLexNumPos((*parpos2).line,tmpcc); GetLexNumPos((*parpos2).coll,tmpcc);}; cInput.cc = tmpcc; } else if (lex == 443) { { l = *((unsigned char*)cInput.cc++); l += 256 * *((unsigned char*)cInput.cc++);}; if (1) { if(s_opt.debug) dpnewline(l); cFile.lineNumber += l; } } else if (lex == 440 || lex == 441 || lex == 445 || lex == 447) { { v = *((unsigned char*)cInput.cc++); v += 256 * *((unsigned char*)cInput.cc++); v += 256 * 256 * *((unsigned char*)cInput.cc++); v += 256 * 256 * 256 * *((unsigned char*)cInput.cc++);}; } } else if (lex>411 && lex<424) { { GetLexFilePos((*parpos2).file,cInput.cc); GetLexNumPos((*parpos2).line,cInput.cc); GetLexNumPos((*parpos2).coll,cInput.cc);}; } else if (lex == '\n' && (1)) { if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else if (lex<448 && s_tokenHasPosition[lex]) { { GetLexFilePos((*parpos2).file,cInput.cc); GetLexNumPos((*parpos2).line,cInput.cc); GetLexNumPos((*parpos2).coll,cInput.cc);}; } };
                *parpos1 = *parpos2;
                if (lex != '(') goto errorlab;
                argi ++;
                { { char *lastlexcc; { while (cInput.cc >= cInput.fin) { char margFlag; margFlag = cInput.margExpFlag; if (macStacki > 0) { if (margFlag == II_MACRO_ARG) goto endOfMacArg; {{ { if (!((cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi)) internalCheckFail("(cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi", "yylex.c", 724);}; mbMemoryi = ((char*)(cInput.a))-mbMemory;};}; cInput = macStack[--macStacki]; } else if (margFlag == II_NORMAL) { { cFile.lb.cc = cInput.cc;}; getLexBuf(&cFile.lb); if (cFile.lb.cc >= cFile.lb.fin) goto endOfFile; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; } else { s_cache.cc = s_cache.cfin = NULL; cacheInput(); s_cache.lexcc = cFile.lb.cc; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; {}; } } lastlexcc = cInput.cc; { lex = *((unsigned char*)cInput.cc++); lex += 256 * *((unsigned char*)cInput.cc++);};};}; while (lex == 443) { { if (lex > 438) { if ((lex==439 || lex==446 || lex==444)){ register char *tmpcc,tmpch; h = 0; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { h+=tmpch; h+=(h<<10); h^=(h>>6);}; } { h+=(h<<3); h^=(h>>11); h+=(h<<15);}; tmpcc ++; { GetLexFilePos((pos).file,tmpcc); GetLexNumPos((pos).line,tmpcc); GetLexNumPos((pos).coll,tmpcc);}; cInput.cc = tmpcc; } else if (lex == 442) { register char *tmpcc,tmpch; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; { GetLexFilePos((pos).file,tmpcc); GetLexNumPos((pos).line,tmpcc); GetLexNumPos((pos).coll,tmpcc);}; cInput.cc = tmpcc; } else if (lex == 443) { { l = *((unsigned char*)cInput.cc++); l += 256 * *((unsigned char*)cInput.cc++);}; if (1) { if(s_opt.debug) dpnewline(l); cFile.lineNumber += l; } } else if (lex == 440 || lex == 441 || lex == 445 || lex == 447) { { v = *((unsigned char*)cInput.cc++); v += 256 * *((unsigned char*)cInput.cc++); v += 256 * 256 * *((unsigned char*)cInput.cc++); v += 256 * 256 * 256 * *((unsigned char*)cInput.cc++);}; } } else if (lex>411 && lex<424) { { GetLexFilePos((pos).file,cInput.cc); GetLexNumPos((pos).line,cInput.cc); GetLexNumPos((pos).coll,cInput.cc);}; } else if (lex == '\n' && (1)) { if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else if (lex<448 && s_tokenHasPosition[lex]) { { GetLexFilePos((pos).file,cInput.cc); GetLexNumPos((pos).line,cInput.cc); GetLexNumPos((pos).coll,cInput.cc);}; } }; { char *lastlexcc; { while (cInput.cc >= cInput.fin) { char margFlag; margFlag = cInput.margExpFlag; if (macStacki > 0) { if (margFlag == II_MACRO_ARG) goto endOfMacArg; {{ { if (!((cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi)) internalCheckFail("(cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi", "yylex.c", 724);}; mbMemoryi = ((char*)(cInput.a))-mbMemory;};}; cInput = macStack[--macStacki]; } else if (margFlag == II_NORMAL) { { cFile.lb.cc = cInput.cc;}; getLexBuf(&cFile.lb); if (cFile.lb.cc >= cFile.lb.fin) goto endOfFile; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; } else { s_cache.cc = s_cache.cfin = NULL; cacheInput(); s_cache.lexcc = cFile.lb.cc; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; {}; } } lastlexcc = cInput.cc; { lex = *((unsigned char*)cInput.cc++); lex += 256 * *((unsigned char*)cInput.cc++);};};}; }};
                if (lex != ')') {
                        for(;;) {
                                cc = aname = cInput.cc;
                                { if (lex > 438) { if ((lex==439 || lex==446 || lex==444)){ register char *tmpcc,tmpch; h = 0; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { h+=tmpch; h+=(h<<10); h^=(h>>6);}; } { h+=(h<<3); h^=(h>>11); h+=(h<<15);}; tmpcc ++; { GetLexFilePos((pos).file,tmpcc); GetLexNumPos((pos).line,tmpcc); GetLexNumPos((pos).coll,tmpcc);}; cInput.cc = tmpcc; } else if (lex == 442) { register char *tmpcc,tmpch; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; { GetLexFilePos((pos).file,tmpcc); GetLexNumPos((pos).line,tmpcc); GetLexNumPos((pos).coll,tmpcc);}; cInput.cc = tmpcc; } else if (lex == 443) { { l = *((unsigned char*)cInput.cc++); l += 256 * *((unsigned char*)cInput.cc++);}; if (1) { if(s_opt.debug) dpnewline(l); cFile.lineNumber += l; } } else if (lex == 440 || lex == 441 || lex == 445 || lex == 447) { { v = *((unsigned char*)cInput.cc++); v += 256 * *((unsigned char*)cInput.cc++); v += 256 * 256 * *((unsigned char*)cInput.cc++); v += 256 * 256 * 256 * *((unsigned char*)cInput.cc++);}; } } else if (lex>411 && lex<424) { { GetLexFilePos((pos).file,cInput.cc); GetLexNumPos((pos).line,cInput.cc); GetLexNumPos((pos).coll,cInput.cc);}; } else if (lex == '\n' && (1)) { if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else if (lex<448 && s_tokenHasPosition[lex]) { { GetLexFilePos((pos).file,cInput.cc); GetLexNumPos((pos).line,cInput.cc); GetLexNumPos((pos).coll,cInput.cc);}; } };
                                ellipsis = 0;
                                if (lex == 439 ) {
                                        aname = cc;
                                } else if (lex == 283) {
                                        aname = s_cppVarArgsName;
                                        pos = macpos;
                                        ellipsis = 1;
                                } else goto errorlab;
                                {{ { if (!((strlen(aname)+1) >= 0)) internalCheckFail("(strlen(aname)+1) >= 0", "yylex.c", 737);}; ppmMemoryi = ((char*)(((char*)(ppmMemory+ppmMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(ppmMemory+ppmMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - ppmMemory; if (ppmMemoryi+(strlen(aname)+1)*sizeof(char) >= SIZE_ppmMemory) { fatalError(ERR_NO_MEMORY,"ppmMemory", 65); } mm = (char*) (ppmMemory + ppmMemoryi); ppmMemoryi += (strlen(aname)+1)*sizeof(char);};};
                                strcpy(mm,aname);
                                sprintf(tmpBuff, "%x-%x%c%s", pos.file, pos.line,
                                                '!', aname);
                                {{ { if (!((strlen(tmpBuff)+1) >= 0)) internalCheckFail("(strlen(tmpBuff)+1) >= 0", "yylex.c", 741);}; ppmMemoryi = ((char*)(((char*)(ppmMemory+ppmMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(ppmMemory+ppmMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - ppmMemory; if (ppmMemoryi+(strlen(tmpBuff)+1)*sizeof(char) >= SIZE_ppmMemory) { fatalError(ERR_NO_MEMORY,"ppmMemory", 65); } argLinkName = (char*) (ppmMemory + ppmMemoryi); ppmMemoryi += (strlen(tmpBuff)+1)*sizeof(char);};};
                                strcpy(argLinkName, tmpBuff);
                                {{ { if (!((1) >= 0)) internalCheckFail("(1) >= 0", "yylex.c", 743);}; ppMemoryi = ((char*)(((char*)(ppMemory+ppMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(ppMemory+ppMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - ppMemory; if (ppMemoryi+(1)*sizeof(S_macroArgTabElem) >= SIZE_ppMemory) { fatalError(ERR_NO_MEMORY,"ppMemory", 65); } maca = (S_macroArgTabElem*) (ppMemory + ppMemoryi); ppMemoryi += (1)*sizeof(S_macroArgTabElem);};};
                                { (maca)->name = mm; (maca)->linkName = argLinkName; (maca)->order = argi;};
                                maTabAdd(&s_maTab, maca, &ii);
                                argi ++;
                                { { char *lastlexcc; { while (cInput.cc >= cInput.fin) { char margFlag; margFlag = cInput.margExpFlag; if (macStacki > 0) { if (margFlag == II_MACRO_ARG) goto endOfMacArg; {{ { if (!((cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi)) internalCheckFail("(cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi", "yylex.c", 747);}; mbMemoryi = ((char*)(cInput.a))-mbMemory;};}; cInput = macStack[--macStacki]; } else if (margFlag == II_NORMAL) { { cFile.lb.cc = cInput.cc;}; getLexBuf(&cFile.lb); if (cFile.lb.cc >= cFile.lb.fin) goto endOfFile; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; } else { s_cache.cc = s_cache.cfin = NULL; cacheInput(); s_cache.lexcc = cFile.lb.cc; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; {}; } } lastlexcc = cInput.cc; { lex = *((unsigned char*)cInput.cc++); lex += 256 * *((unsigned char*)cInput.cc++);};};}; while (lex == 443) { { if (lex > 438) { if ((lex==439 || lex==446 || lex==444)){ register char *tmpcc,tmpch; h = 0; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { h+=tmpch; h+=(h<<10); h^=(h>>6);}; } { h+=(h<<3); h^=(h>>11); h+=(h<<15);}; tmpcc ++; { GetLexFilePos((pos).file,tmpcc); GetLexNumPos((pos).line,tmpcc); GetLexNumPos((pos).coll,tmpcc);}; cInput.cc = tmpcc; } else if (lex == 442) { register char *tmpcc,tmpch; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; { GetLexFilePos((pos).file,tmpcc); GetLexNumPos((pos).line,tmpcc); GetLexNumPos((pos).coll,tmpcc);}; cInput.cc = tmpcc; } else if (lex == 443) { { l = *((unsigned char*)cInput.cc++); l += 256 * *((unsigned char*)cInput.cc++);}; if (1) { if(s_opt.debug) dpnewline(l); cFile.lineNumber += l; } } else if (lex == 440 || lex == 441 || lex == 445 || lex == 447) { { v = *((unsigned char*)cInput.cc++); v += 256 * *((unsigned char*)cInput.cc++); v += 256 * 256 * *((unsigned char*)cInput.cc++); v += 256 * 256 * 256 * *((unsigned char*)cInput.cc++);}; } } else if (lex>411 && lex<424) { { GetLexFilePos((pos).file,cInput.cc); GetLexNumPos((pos).line,cInput.cc); GetLexNumPos((pos).coll,cInput.cc);}; } else if (lex == '\n' && (1)) { if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else if (lex<448 && s_tokenHasPosition[lex]) { { GetLexFilePos((pos).file,cInput.cc); GetLexNumPos((pos).line,cInput.cc); GetLexNumPos((pos).coll,cInput.cc);}; } }; { char *lastlexcc; { while (cInput.cc >= cInput.fin) { char margFlag; margFlag = cInput.margExpFlag; if (macStacki > 0) { if (margFlag == II_MACRO_ARG) goto endOfMacArg; {{ { if (!((cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi)) internalCheckFail("(cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi", "yylex.c", 747);}; mbMemoryi = ((char*)(cInput.a))-mbMemory;};}; cInput = macStack[--macStacki]; } else if (margFlag == II_NORMAL) { { cFile.lb.cc = cInput.cc;}; getLexBuf(&cFile.lb); if (cFile.lb.cc >= cFile.lb.fin) goto endOfFile; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; } else { s_cache.cc = s_cache.cfin = NULL; cacheInput(); s_cache.lexcc = cFile.lb.cc; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; {}; } } lastlexcc = cInput.cc; { lex = *((unsigned char*)cInput.cc++); lex += 256 * *((unsigned char*)cInput.cc++);};};}; }};
                                tmppp=parpos1; parpos1=parpos2; parpos2=tmppp;
                                { if (lex > 438) { if ((lex==439 || lex==446 || lex==444)){ register char *tmpcc,tmpch; h = 0; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { h+=tmpch; h+=(h<<10); h^=(h>>6);}; } { h+=(h<<3); h^=(h>>11); h+=(h<<15);}; tmpcc ++; { GetLexFilePos((*parpos2).file,tmpcc); GetLexNumPos((*parpos2).line,tmpcc); GetLexNumPos((*parpos2).coll,tmpcc);}; cInput.cc = tmpcc; } else if (lex == 442) { register char *tmpcc,tmpch; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; { GetLexFilePos((*parpos2).file,tmpcc); GetLexNumPos((*parpos2).line,tmpcc); GetLexNumPos((*parpos2).coll,tmpcc);}; cInput.cc = tmpcc; } else if (lex == 443) { { l = *((unsigned char*)cInput.cc++); l += 256 * *((unsigned char*)cInput.cc++);}; if (1) { if(s_opt.debug) dpnewline(l); cFile.lineNumber += l; } } else if (lex == 440 || lex == 441 || lex == 445 || lex == 447) { { v = *((unsigned char*)cInput.cc++); v += 256 * *((unsigned char*)cInput.cc++); v += 256 * 256 * *((unsigned char*)cInput.cc++); v += 256 * 256 * 256 * *((unsigned char*)cInput.cc++);}; } } else if (lex>411 && lex<424) { { GetLexFilePos((*parpos2).file,cInput.cc); GetLexNumPos((*parpos2).line,cInput.cc); GetLexNumPos((*parpos2).coll,cInput.cc);}; } else if (lex == '\n' && (1)) { if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else if (lex<448 && s_tokenHasPosition[lex]) { { GetLexFilePos((*parpos2).file,cInput.cc); GetLexNumPos((*parpos2).line,cInput.cc); GetLexNumPos((*parpos2).coll,cInput.cc);}; } };
                                if (! ellipsis) {
                                        addTrivialCxReference(s_maTab.tab[ii]->linkName, TypeMacroArg,StorageDefault,
                                                                                  &pos, UsageDefined);
                                        handleMacroDefinitionParameterPositions(argi, &macpos, parpos1, &pos, parpos2, 0);
                                }
                                if (lex == 283) {
                                        { { char *lastlexcc; { while (cInput.cc >= cInput.fin) { char margFlag; margFlag = cInput.margExpFlag; if (macStacki > 0) { if (margFlag == II_MACRO_ARG) goto endOfMacArg; {{ { if (!((cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi)) internalCheckFail("(cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi", "yylex.c", 757);}; mbMemoryi = ((char*)(cInput.a))-mbMemory;};}; cInput = macStack[--macStacki]; } else if (margFlag == II_NORMAL) { { cFile.lb.cc = cInput.cc;}; getLexBuf(&cFile.lb); if (cFile.lb.cc >= cFile.lb.fin) goto endOfFile; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; } else { s_cache.cc = s_cache.cfin = NULL; cacheInput(); s_cache.lexcc = cFile.lb.cc; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; {}; } } lastlexcc = cInput.cc; { lex = *((unsigned char*)cInput.cc++); lex += 256 * *((unsigned char*)cInput.cc++);};};}; while (lex == 443) { { if (lex > 438) { if ((lex==439 || lex==446 || lex==444)){ register char *tmpcc,tmpch; h = 0; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { h+=tmpch; h+=(h<<10); h^=(h>>6);}; } { h+=(h<<3); h^=(h>>11); h+=(h<<15);}; tmpcc ++; { GetLexFilePos((pos).file,tmpcc); GetLexNumPos((pos).line,tmpcc); GetLexNumPos((pos).coll,tmpcc);}; cInput.cc = tmpcc; } else if (lex == 442) { register char *tmpcc,tmpch; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; { GetLexFilePos((pos).file,tmpcc); GetLexNumPos((pos).line,tmpcc); GetLexNumPos((pos).coll,tmpcc);}; cInput.cc = tmpcc; } else if (lex == 443) { { l = *((unsigned char*)cInput.cc++); l += 256 * *((unsigned char*)cInput.cc++);}; if (1) { if(s_opt.debug) dpnewline(l); cFile.lineNumber += l; } } else if (lex == 440 || lex == 441 || lex == 445 || lex == 447) { { v = *((unsigned char*)cInput.cc++); v += 256 * *((unsigned char*)cInput.cc++); v += 256 * 256 * *((unsigned char*)cInput.cc++); v += 256 * 256 * 256 * *((unsigned char*)cInput.cc++);}; } } else if (lex>411 && lex<424) { { GetLexFilePos((pos).file,cInput.cc); GetLexNumPos((pos).line,cInput.cc); GetLexNumPos((pos).coll,cInput.cc);}; } else if (lex == '\n' && (1)) { if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else if (lex<448 && s_tokenHasPosition[lex]) { { GetLexFilePos((pos).file,cInput.cc); GetLexNumPos((pos).line,cInput.cc); GetLexNumPos((pos).coll,cInput.cc);}; } }; { char *lastlexcc; { while (cInput.cc >= cInput.fin) { char margFlag; margFlag = cInput.margExpFlag; if (macStacki > 0) { if (margFlag == II_MACRO_ARG) goto endOfMacArg; {{ { if (!((cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi)) internalCheckFail("(cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi", "yylex.c", 757);}; mbMemoryi = ((char*)(cInput.a))-mbMemory;};}; cInput = macStack[--macStacki]; } else if (margFlag == II_NORMAL) { { cFile.lb.cc = cInput.cc;}; getLexBuf(&cFile.lb); if (cFile.lb.cc >= cFile.lb.fin) goto endOfFile; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; } else { s_cache.cc = s_cache.cfin = NULL; cacheInput(); s_cache.lexcc = cFile.lb.cc; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; {}; } } lastlexcc = cInput.cc; { lex = *((unsigned char*)cInput.cc++); lex += 256 * *((unsigned char*)cInput.cc++);};};}; }};
                                        { if (lex > 438) { if ((lex==439 || lex==446 || lex==444)){ register char *tmpcc,tmpch; h = 0; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { h+=tmpch; h+=(h<<10); h^=(h>>6);}; } { h+=(h<<3); h^=(h>>11); h+=(h<<15);}; tmpcc ++; { GetLexFilePos((*parpos2).file,tmpcc); GetLexNumPos((*parpos2).line,tmpcc); GetLexNumPos((*parpos2).coll,tmpcc);}; cInput.cc = tmpcc; } else if (lex == 442) { register char *tmpcc,tmpch; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; { GetLexFilePos((*parpos2).file,tmpcc); GetLexNumPos((*parpos2).line,tmpcc); GetLexNumPos((*parpos2).coll,tmpcc);}; cInput.cc = tmpcc; } else if (lex == 443) { { l = *((unsigned char*)cInput.cc++); l += 256 * *((unsigned char*)cInput.cc++);}; if (1) { if(s_opt.debug) dpnewline(l); cFile.lineNumber += l; } } else if (lex == 440 || lex == 441 || lex == 445 || lex == 447) { { v = *((unsigned char*)cInput.cc++); v += 256 * *((unsigned char*)cInput.cc++); v += 256 * 256 * *((unsigned char*)cInput.cc++); v += 256 * 256 * 256 * *((unsigned char*)cInput.cc++);}; } } else if (lex>411 && lex<424) { { GetLexFilePos((*parpos2).file,cInput.cc); GetLexNumPos((*parpos2).line,cInput.cc); GetLexNumPos((*parpos2).coll,cInput.cc);}; } else if (lex == '\n' && (1)) { if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else if (lex<448 && s_tokenHasPosition[lex]) { { GetLexFilePos((*parpos2).file,cInput.cc); GetLexNumPos((*parpos2).line,cInput.cc); GetLexNumPos((*parpos2).coll,cInput.cc);}; } };
                                }
                                if (lex == ')') break;
                                if (lex != ',') break;
                                { { char *lastlexcc; { while (cInput.cc >= cInput.fin) { char margFlag; margFlag = cInput.margExpFlag; if (macStacki > 0) { if (margFlag == II_MACRO_ARG) goto endOfMacArg; {{ { if (!((cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi)) internalCheckFail("(cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi", "yylex.c", 762);}; mbMemoryi = ((char*)(cInput.a))-mbMemory;};}; cInput = macStack[--macStacki]; } else if (margFlag == II_NORMAL) { { cFile.lb.cc = cInput.cc;}; getLexBuf(&cFile.lb); if (cFile.lb.cc >= cFile.lb.fin) goto endOfFile; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; } else { s_cache.cc = s_cache.cfin = NULL; cacheInput(); s_cache.lexcc = cFile.lb.cc; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; {}; } } lastlexcc = cInput.cc; { lex = *((unsigned char*)cInput.cc++); lex += 256 * *((unsigned char*)cInput.cc++);};};}; while (lex == 443) { { if (lex > 438) { if ((lex==439 || lex==446 || lex==444)){ register char *tmpcc,tmpch; h = 0; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { h+=tmpch; h+=(h<<10); h^=(h>>6);}; } { h+=(h<<3); h^=(h>>11); h+=(h<<15);}; tmpcc ++; { GetLexFilePos((pos).file,tmpcc); GetLexNumPos((pos).line,tmpcc); GetLexNumPos((pos).coll,tmpcc);}; cInput.cc = tmpcc; } else if (lex == 442) { register char *tmpcc,tmpch; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; { GetLexFilePos((pos).file,tmpcc); GetLexNumPos((pos).line,tmpcc); GetLexNumPos((pos).coll,tmpcc);}; cInput.cc = tmpcc; } else if (lex == 443) { { l = *((unsigned char*)cInput.cc++); l += 256 * *((unsigned char*)cInput.cc++);}; if (1) { if(s_opt.debug) dpnewline(l); cFile.lineNumber += l; } } else if (lex == 440 || lex == 441 || lex == 445 || lex == 447) { { v = *((unsigned char*)cInput.cc++); v += 256 * *((unsigned char*)cInput.cc++); v += 256 * 256 * *((unsigned char*)cInput.cc++); v += 256 * 256 * 256 * *((unsigned char*)cInput.cc++);}; } } else if (lex>411 && lex<424) { { GetLexFilePos((pos).file,cInput.cc); GetLexNumPos((pos).line,cInput.cc); GetLexNumPos((pos).coll,cInput.cc);}; } else if (lex == '\n' && (1)) { if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else if (lex<448 && s_tokenHasPosition[lex]) { { GetLexFilePos((pos).file,cInput.cc); GetLexNumPos((pos).line,cInput.cc); GetLexNumPos((pos).coll,cInput.cc);}; } }; { char *lastlexcc; { while (cInput.cc >= cInput.fin) { char margFlag; margFlag = cInput.margExpFlag; if (macStacki > 0) { if (margFlag == II_MACRO_ARG) goto endOfMacArg; {{ { if (!((cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi)) internalCheckFail("(cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi", "yylex.c", 762);}; mbMemoryi = ((char*)(cInput.a))-mbMemory;};}; cInput = macStack[--macStacki]; } else if (margFlag == II_NORMAL) { { cFile.lb.cc = cInput.cc;}; getLexBuf(&cFile.lb); if (cFile.lb.cc >= cFile.lb.fin) goto endOfFile; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; } else { s_cache.cc = s_cache.cfin = NULL; cacheInput(); s_cache.lexcc = cFile.lb.cc; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; {}; } } lastlexcc = cInput.cc; { lex = *((unsigned char*)cInput.cc++); lex += 256 * *((unsigned char*)cInput.cc++);};};}; }};
                        }
                        handleMacroDefinitionParameterPositions(argi, &macpos, parpos1, &s_noPos, parpos2, 1);
                } else {
                        { if (lex > 438) { if ((lex==439 || lex==446 || lex==444)){ register char *tmpcc,tmpch; h = 0; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { h+=tmpch; h+=(h<<10); h^=(h>>6);}; } { h+=(h<<3); h^=(h>>11); h+=(h<<15);}; tmpcc ++; { GetLexFilePos((*parpos2).file,tmpcc); GetLexNumPos((*parpos2).line,tmpcc); GetLexNumPos((*parpos2).coll,tmpcc);}; cInput.cc = tmpcc; } else if (lex == 442) { register char *tmpcc,tmpch; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; { GetLexFilePos((*parpos2).file,tmpcc); GetLexNumPos((*parpos2).line,tmpcc); GetLexNumPos((*parpos2).coll,tmpcc);}; cInput.cc = tmpcc; } else if (lex == 443) { { l = *((unsigned char*)cInput.cc++); l += 256 * *((unsigned char*)cInput.cc++);}; if (1) { if(s_opt.debug) dpnewline(l); cFile.lineNumber += l; } } else if (lex == 440 || lex == 441 || lex == 445 || lex == 447) { { v = *((unsigned char*)cInput.cc++); v += 256 * *((unsigned char*)cInput.cc++); v += 256 * 256 * *((unsigned char*)cInput.cc++); v += 256 * 256 * 256 * *((unsigned char*)cInput.cc++);}; } } else if (lex>411 && lex<424) { { GetLexFilePos((*parpos2).file,cInput.cc); GetLexNumPos((*parpos2).line,cInput.cc); GetLexNumPos((*parpos2).coll,cInput.cc);}; } else if (lex == '\n' && (1)) { if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else if (lex<448 && s_tokenHasPosition[lex]) { { GetLexFilePos((*parpos2).file,cInput.cc); GetLexNumPos((*parpos2).line,cInput.cc); GetLexNumPos((*parpos2).coll,cInput.cc);}; } };
                        handleMacroDefinitionParameterPositions(argi, &macpos, parpos1, &s_noPos, parpos2, 1);
                }
        }
        msize = MACRO_UNIT_SIZE;
        sizei = 0;
        {{{ { if (!((1) >= 0)) internalCheckFail("(1) >= 0", "yylex.c", 773);}; ppmMemoryi = ((char*)(((char*)(ppmMemory+ppmMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(ppmMemory+ppmMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - ppmMemory; if (ppmMemoryi+(1)*sizeof(S_macroBody) >= SIZE_ppmMemory) { fatalError(ERR_NO_MEMORY,"ppmMemory", 65); } macbody = (S_macroBody*) (ppmMemory + ppmMemoryi); ppmMemoryi += (1)*sizeof(S_macroBody);};};};
        {{ { if (!((msize+MAX_LEXEM_SIZE) >= 0)) internalCheckFail("(msize+MAX_LEXEM_SIZE) >= 0", "yylex.c", 774);}; ppmMemoryi = ((char*)(((char*)(ppmMemory+ppmMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(ppmMemory+ppmMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - ppmMemory; if (ppmMemoryi+(msize+MAX_LEXEM_SIZE)*sizeof(char) >= SIZE_ppmMemory) { fatalError(ERR_NO_MEMORY,"ppmMemory", 65); } mbody = (char*) (ppmMemory + ppmMemoryi); ppmMemoryi += (msize+MAX_LEXEM_SIZE)*sizeof(char);};};
        bodyReadingFlag = 1;
        { { char *lastlexcc; { while (cInput.cc >= cInput.fin) { char margFlag; margFlag = cInput.margExpFlag; if (macStacki > 0) { if (margFlag == II_MACRO_ARG) goto endOfMacArg; {{ { if (!((cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi)) internalCheckFail("(cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi", "yylex.c", 776);}; mbMemoryi = ((char*)(cInput.a))-mbMemory;};}; cInput = macStack[--macStacki]; } else if (margFlag == II_NORMAL) { { cFile.lb.cc = cInput.cc;}; getLexBuf(&cFile.lb); if (cFile.lb.cc >= cFile.lb.fin) goto endOfFile; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; } else { s_cache.cc = s_cache.cfin = NULL; cacheInput(); s_cache.lexcc = cFile.lb.cc; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; {}; } } lastlexcc = cInput.cc; { lex = *((unsigned char*)cInput.cc++); lex += 256 * *((unsigned char*)cInput.cc++);};};}; while (lex == 443) { { if (lex > 438) { if ((lex==439 || lex==446 || lex==444)){ register char *tmpcc,tmpch; h = 0; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { h+=tmpch; h+=(h<<10); h^=(h>>6);}; } { h+=(h<<3); h^=(h>>11); h+=(h<<15);}; tmpcc ++; { GetLexFilePos((pos).file,tmpcc); GetLexNumPos((pos).line,tmpcc); GetLexNumPos((pos).coll,tmpcc);}; cInput.cc = tmpcc; } else if (lex == 442) { register char *tmpcc,tmpch; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; { GetLexFilePos((pos).file,tmpcc); GetLexNumPos((pos).line,tmpcc); GetLexNumPos((pos).coll,tmpcc);}; cInput.cc = tmpcc; } else if (lex == 443) { { l = *((unsigned char*)cInput.cc++); l += 256 * *((unsigned char*)cInput.cc++);}; if (1) { if(s_opt.debug) dpnewline(l); cFile.lineNumber += l; } } else if (lex == 440 || lex == 441 || lex == 445 || lex == 447) { { v = *((unsigned char*)cInput.cc++); v += 256 * *((unsigned char*)cInput.cc++); v += 256 * 256 * *((unsigned char*)cInput.cc++); v += 256 * 256 * 256 * *((unsigned char*)cInput.cc++);}; } } else if (lex>411 && lex<424) { { GetLexFilePos((pos).file,cInput.cc); GetLexNumPos((pos).line,cInput.cc); GetLexNumPos((pos).coll,cInput.cc);}; } else if (lex == '\n' && (1)) { if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else if (lex<448 && s_tokenHasPosition[lex]) { { GetLexFilePos((pos).file,cInput.cc); GetLexNumPos((pos).line,cInput.cc); GetLexNumPos((pos).coll,cInput.cc);}; } }; { char *lastlexcc; { while (cInput.cc >= cInput.fin) { char margFlag; margFlag = cInput.margExpFlag; if (macStacki > 0) { if (margFlag == II_MACRO_ARG) goto endOfMacArg; {{ { if (!((cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi)) internalCheckFail("(cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi", "yylex.c", 776);}; mbMemoryi = ((char*)(cInput.a))-mbMemory;};}; cInput = macStack[--macStacki]; } else if (margFlag == II_NORMAL) { { cFile.lb.cc = cInput.cc;}; getLexBuf(&cFile.lb); if (cFile.lb.cc >= cFile.lb.fin) goto endOfFile; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; } else { s_cache.cc = s_cache.cfin = NULL; cacheInput(); s_cache.lexcc = cFile.lb.cc; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; {}; } } lastlexcc = cInput.cc; { lex = *((unsigned char*)cInput.cc++); lex += 256 * *((unsigned char*)cInput.cc++);};};}; }};
        cc = cInput.cc;
        { if (lex > 438) { if ((lex==439 || lex==446 || lex==444)){ register char *tmpcc,tmpch; h = 0; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { h+=tmpch; h+=(h<<10); h^=(h>>6);}; } { h+=(h<<3); h^=(h>>11); h+=(h<<15);}; tmpcc ++; { GetLexFilePos((pos).file,tmpcc); GetLexNumPos((pos).line,tmpcc); GetLexNumPos((pos).coll,tmpcc);}; cInput.cc = tmpcc; } else if (lex == 442) { register char *tmpcc,tmpch; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; { GetLexFilePos((pos).file,tmpcc); GetLexNumPos((pos).line,tmpcc); GetLexNumPos((pos).coll,tmpcc);}; cInput.cc = tmpcc; } else if (lex == 443) { { l = *((unsigned char*)cInput.cc++); l += 256 * *((unsigned char*)cInput.cc++);}; if (1) { if(s_opt.debug) dpnewline(l); cFile.lineNumber += l; } } else if (lex == 440 || lex == 441 || lex == 445 || lex == 447) { { v = *((unsigned char*)cInput.cc++); v += 256 * *((unsigned char*)cInput.cc++); v += 256 * 256 * *((unsigned char*)cInput.cc++); v += 256 * 256 * 256 * *((unsigned char*)cInput.cc++);}; } } else if (lex>411 && lex<424) { { GetLexFilePos((pos).file,cInput.cc); GetLexNumPos((pos).line,cInput.cc); GetLexNumPos((pos).coll,cInput.cc);}; } else if (lex == '\n' && (1)) { if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else if (lex<448 && s_tokenHasPosition[lex]) { { GetLexFilePos((pos).file,cInput.cc); GetLexNumPos((pos).line,cInput.cc); GetLexNumPos((pos).coll,cInput.cc);}; } };
        while (lex != '\n') {
                while(sizei<msize && lex != '\n') {
                        { (&mmaca)->name = cc; (&mmaca)->linkName = NULL; (&mmaca)->order = 0;};
                        if (lex==439 && maTabIsMember(&s_maTab,&mmaca,&ii)){
                                addTrivialCxReference(s_maTab.tab[ii]->linkName, TypeMacroArg,StorageDefault,
                                                                          &pos, UsageUsed);
                                ddd = mbody+sizei;
                                { *(ddd)++ = ((unsigned)(445))%256; *(ddd)++ = ((unsigned)(445))/256;};
                                { unsigned tmp; tmp = s_maTab.tab[ii]->order; *(ddd)++ = tmp%256; tmp /= 256; *(ddd)++ = tmp%256; tmp /= 256; *(ddd)++ = tmp%256; tmp /= 256; *(ddd)++ = tmp%256; tmp /= 256;};
                                sizei = ddd - mbody;
                        } else {
                                if (lex==444
                                        || (lex == 439 &&
                                                (! ( ((pos).file != (s_cxRefPos).file) || ((pos).line != (s_cxRefPos).line) || ((pos).coll != (s_cxRefPos).coll) )))) {
                                        s_cache.activeCache = 0;
                                        s_olstringFound = 1; s_olstringInMbody = pp->linkName;
                                }
                                ddd = mbody+sizei;
                                { *(ddd)++ = ((unsigned)(lex))%256; *(ddd)++ = ((unsigned)(lex))/256;};
                                for(; cc<cInput.cc; ddd++,cc++)*ddd= *cc;
                                sizei = ddd - mbody;
                        }
                        { { char *lastlexcc; { while (cInput.cc >= cInput.fin) { char margFlag; margFlag = cInput.margExpFlag; if (macStacki > 0) { if (margFlag == II_MACRO_ARG) goto endOfMacArg; {{ { if (!((cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi)) internalCheckFail("(cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi", "yylex.c", 802);}; mbMemoryi = ((char*)(cInput.a))-mbMemory;};}; cInput = macStack[--macStacki]; } else if (margFlag == II_NORMAL) { { cFile.lb.cc = cInput.cc;}; getLexBuf(&cFile.lb); if (cFile.lb.cc >= cFile.lb.fin) goto endOfFile; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; } else { s_cache.cc = s_cache.cfin = NULL; cacheInput(); s_cache.lexcc = cFile.lb.cc; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; {}; } } lastlexcc = cInput.cc; { lex = *((unsigned char*)cInput.cc++); lex += 256 * *((unsigned char*)cInput.cc++);};};}; while (lex == 443) { { if (lex > 438) { if ((lex==439 || lex==446 || lex==444)){ register char *tmpcc,tmpch; h = 0; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { h+=tmpch; h+=(h<<10); h^=(h>>6);}; } { h+=(h<<3); h^=(h>>11); h+=(h<<15);}; tmpcc ++; { GetLexFilePos((pos).file,tmpcc); GetLexNumPos((pos).line,tmpcc); GetLexNumPos((pos).coll,tmpcc);}; cInput.cc = tmpcc; } else if (lex == 442) { register char *tmpcc,tmpch; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; { GetLexFilePos((pos).file,tmpcc); GetLexNumPos((pos).line,tmpcc); GetLexNumPos((pos).coll,tmpcc);}; cInput.cc = tmpcc; } else if (lex == 443) { { l = *((unsigned char*)cInput.cc++); l += 256 * *((unsigned char*)cInput.cc++);}; if (1) { if(s_opt.debug) dpnewline(l); cFile.lineNumber += l; } } else if (lex == 440 || lex == 441 || lex == 445 || lex == 447) { { v = *((unsigned char*)cInput.cc++); v += 256 * *((unsigned char*)cInput.cc++); v += 256 * 256 * *((unsigned char*)cInput.cc++); v += 256 * 256 * 256 * *((unsigned char*)cInput.cc++);}; } } else if (lex>411 && lex<424) { { GetLexFilePos((pos).file,cInput.cc); GetLexNumPos((pos).line,cInput.cc); GetLexNumPos((pos).coll,cInput.cc);}; } else if (lex == '\n' && (1)) { if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else if (lex<448 && s_tokenHasPosition[lex]) { { GetLexFilePos((pos).file,cInput.cc); GetLexNumPos((pos).line,cInput.cc); GetLexNumPos((pos).coll,cInput.cc);}; } }; { char *lastlexcc; { while (cInput.cc >= cInput.fin) { char margFlag; margFlag = cInput.margExpFlag; if (macStacki > 0) { if (margFlag == II_MACRO_ARG) goto endOfMacArg; {{ { if (!((cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi)) internalCheckFail("(cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi", "yylex.c", 802);}; mbMemoryi = ((char*)(cInput.a))-mbMemory;};}; cInput = macStack[--macStacki]; } else if (margFlag == II_NORMAL) { { cFile.lb.cc = cInput.cc;}; getLexBuf(&cFile.lb); if (cFile.lb.cc >= cFile.lb.fin) goto endOfFile; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; } else { s_cache.cc = s_cache.cfin = NULL; cacheInput(); s_cache.lexcc = cFile.lb.cc; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; {}; } } lastlexcc = cInput.cc; { lex = *((unsigned char*)cInput.cc++); lex += 256 * *((unsigned char*)cInput.cc++);};};}; }};
                        cc = cInput.cc;
                        { if (lex > 438) { if ((lex==439 || lex==446 || lex==444)){ register char *tmpcc,tmpch; h = 0; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { h+=tmpch; h+=(h<<10); h^=(h>>6);}; } { h+=(h<<3); h^=(h>>11); h+=(h<<15);}; tmpcc ++; { GetLexFilePos((pos).file,tmpcc); GetLexNumPos((pos).line,tmpcc); GetLexNumPos((pos).coll,tmpcc);}; cInput.cc = tmpcc; } else if (lex == 442) { register char *tmpcc,tmpch; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; { GetLexFilePos((pos).file,tmpcc); GetLexNumPos((pos).line,tmpcc); GetLexNumPos((pos).coll,tmpcc);}; cInput.cc = tmpcc; } else if (lex == 443) { { l = *((unsigned char*)cInput.cc++); l += 256 * *((unsigned char*)cInput.cc++);}; if (1) { if(s_opt.debug) dpnewline(l); cFile.lineNumber += l; } } else if (lex == 440 || lex == 441 || lex == 445 || lex == 447) { { v = *((unsigned char*)cInput.cc++); v += 256 * *((unsigned char*)cInput.cc++); v += 256 * 256 * *((unsigned char*)cInput.cc++); v += 256 * 256 * 256 * *((unsigned char*)cInput.cc++);}; } } else if (lex>411 && lex<424) { { GetLexFilePos((pos).file,cInput.cc); GetLexNumPos((pos).line,cInput.cc); GetLexNumPos((pos).coll,cInput.cc);}; } else if (lex == '\n' && (1)) { if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else if (lex<448 && s_tokenHasPosition[lex]) { { GetLexFilePos((pos).file,cInput.cc); GetLexNumPos((pos).line,cInput.cc); GetLexNumPos((pos).coll,cInput.cc);}; } };
                }
                if (lex != '\n') {
                        msize += MACRO_UNIT_SIZE;
                        {{ { if (!(((char *)(mbody)) + (msize+MAX_LEXEM_SIZE-MACRO_UNIT_SIZE)*sizeof(char) == ppmMemory + ppmMemoryi)) internalCheckFail("((char *)(mbody)) + (msize+MAX_LEXEM_SIZE-MACRO_UNIT_SIZE)*sizeof(char) == ppmMemory + ppmMemoryi", "yylex.c", 808);}; ppmMemoryi = ((char*)mbody) - ppmMemory; { { if (!((msize+MAX_LEXEM_SIZE) >= 0)) internalCheckFail("(msize+MAX_LEXEM_SIZE) >= 0", "yylex.c", 808);}; ppmMemoryi = ((char*)(((char*)(ppmMemory+ppmMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(ppmMemory+ppmMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - ppmMemory; if (ppmMemoryi+(msize+MAX_LEXEM_SIZE)*sizeof(char) >= SIZE_ppmMemory) { fatalError(ERR_NO_MEMORY,"ppmMemory", 65); } mbody = (char*) (ppmMemory + ppmMemoryi); ppmMemoryi += (msize+MAX_LEXEM_SIZE)*sizeof(char);};};};
                }
        }
endOfBody:
        { if (!(sizei>=0)) internalCheckFail("sizei>=0", "yylex.c", 813);};
        {{ { if (!(((char *)(mbody)) + (msize+MAX_LEXEM_SIZE)*sizeof(char) == ppmMemory + ppmMemoryi)) internalCheckFail("((char *)(mbody)) + (msize+MAX_LEXEM_SIZE)*sizeof(char) == ppmMemory + ppmMemoryi", "yylex.c", 814);}; ppmMemoryi = ((char*)mbody) - ppmMemory; { { if (!((sizei) >= 0)) internalCheckFail("(sizei) >= 0", "yylex.c", 814);}; ppmMemoryi = ((char*)(((char*)(ppmMemory+ppmMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(ppmMemory+ppmMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - ppmMemory; if (ppmMemoryi+(sizei)*sizeof(char) >= SIZE_ppmMemory) { fatalError(ERR_NO_MEMORY,"ppmMemory", 65); } mbody = (char*) (ppmMemory + ppmMemoryi); ppmMemoryi += (sizei)*sizeof(char);};};};
        msize = sizei;
        if (argi > 0) {
                {{ { if (!((argi) >= 0)) internalCheckFail("(argi) >= 0", "yylex.c", 818);}; ppmMemoryi = ((char*)(((char*)(ppmMemory+ppmMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(ppmMemory+ppmMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - ppmMemory; if (ppmMemoryi+(argi)*sizeof(char*) >= SIZE_ppmMemory) { fatalError(ERR_NO_MEMORY,"ppmMemory", 65); } argNames = (char**) (ppmMemory + ppmMemoryi); ppmMemoryi += (argi)*sizeof(char*);};};
                memset(argNames,0,argi*sizeof(char*));
                maTabMap2(&s_maTab, setMacArgName, argNames);
        } else argNames = NULL;
        { (macbody)->argn = argi; (macbody)->size = msize; (macbody)->name = mname; (macbody)->args = argNames; (macbody)->body = mbody;};
        pp->u.mbody = macbody;
        addMacroToTabs(pp,mname);
        { if (!(s_opt.taskRegime)) internalCheckFail("s_opt.taskRegime", "yylex.c", 826);};
        if ((s_opt.taskRegime!=RegimeGenerate)) {
                addCxReference(pp, &macpos, UsageDefined,s_noneFileIndex, s_noneFileIndex);
        }
        return;
endOfMacArg: { if (!(0)) internalCheckFail("0", "yylex.c", 831);};
endOfFile:
        if (bodyReadingFlag) goto endOfBody;
        return;
errorlab:
        return;
}
void addMacroDefinedByOption(char *opt) {
        char *name,*cc,*body,*nopt;
        S_symbol *pp;
        S_macroBody *macbody;
        int size,args;
        {{ { if (!((strlen(opt)+3) >= 0)) internalCheckFail("(strlen(opt)+3) >= 0", "yylex.c", 846);}; ppmMemoryi = ((char*)(((char*)(ppmMemory+ppmMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(ppmMemory+ppmMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - ppmMemory; if (ppmMemoryi+(strlen(opt)+3)*sizeof(char) >= SIZE_ppmMemory) { fatalError(ERR_NO_MEMORY,"ppmMemory", 65); } nopt = (char*) (ppmMemory + ppmMemoryi); ppmMemoryi += (strlen(opt)+3)*sizeof(char);};};
        strcpy(nopt,opt);
        name = cc = nopt;
        while (isalpha(*cc) || isdigit(*cc) || *cc == '_') cc++;
        args = 0;
        if (*cc == '=') {
                *cc = ' ';
        } else if (*cc==0) {
                *cc++ = ' ';
                *cc++ = '1';
                *cc = 0;
        } else if (*cc=='(') {
                args = 1;
        }
        initInput(NULL, NULL,nopt,NULL);
        cFile.lineNumber = 1;
        processDefine(args);
}
static void processUnDefine() {
        int lex,l,h,v,ii;
        char *cc;
        S_position pos;
        S_symbol dd,*pp,*memb;
        { char *lastlexcc; { while (cInput.cc >= cInput.fin) { char margFlag; margFlag = cInput.margExpFlag; if (macStacki > 0) { if (margFlag == II_MACRO_ARG) goto endOfMacArg; {{ { if (!((cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi)) internalCheckFail("(cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi", "yylex.c", 872);}; mbMemoryi = ((char*)(cInput.a))-mbMemory;};}; cInput = macStack[--macStacki]; } else if (margFlag == II_NORMAL) { { cFile.lb.cc = cInput.cc;}; getLexBuf(&cFile.lb); if (cFile.lb.cc >= cFile.lb.fin) goto endOfFile; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; } else { s_cache.cc = s_cache.cfin = NULL; cacheInput(); s_cache.lexcc = cFile.lb.cc; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; {}; } } lastlexcc = cInput.cc; { lex = *((unsigned char*)cInput.cc++); lex += 256 * *((unsigned char*)cInput.cc++);};};};
        cc = cInput.cc;
        { if (lex > 438) { if ((lex==439 || lex==446 || lex==444)){ register char *tmpcc,tmpch; h = 0; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { h+=tmpch; h+=(h<<10); h^=(h>>6);}; } { h+=(h<<3); h^=(h>>11); h+=(h<<15);}; tmpcc ++; { GetLexFilePos((pos).file,tmpcc); GetLexNumPos((pos).line,tmpcc); GetLexNumPos((pos).coll,tmpcc);}; cInput.cc = tmpcc; } else if (lex == 442) { register char *tmpcc,tmpch; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; { GetLexFilePos((pos).file,tmpcc); GetLexNumPos((pos).line,tmpcc); GetLexNumPos((pos).coll,tmpcc);}; cInput.cc = tmpcc; } else if (lex == 443) { { l = *((unsigned char*)cInput.cc++); l += 256 * *((unsigned char*)cInput.cc++);}; if (1) { if(s_opt.debug) dpnewline(l); cFile.lineNumber += l; } } else if (lex == 440 || lex == 441 || lex == 445 || lex == 447) { { v = *((unsigned char*)cInput.cc++); v += 256 * *((unsigned char*)cInput.cc++); v += 256 * 256 * *((unsigned char*)cInput.cc++); v += 256 * 256 * 256 * *((unsigned char*)cInput.cc++);}; } } else if (lex>411 && lex<424) { { GetLexFilePos((pos).file,cInput.cc); GetLexNumPos((pos).line,cInput.cc); GetLexNumPos((pos).coll,cInput.cc);}; } else if (lex == '\n' && (1)) { if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else if (lex<448 && s_tokenHasPosition[lex]) { { GetLexFilePos((pos).file,cInput.cc); GetLexNumPos((pos).line,cInput.cc); GetLexNumPos((pos).coll,cInput.cc);}; } };
        testCxrefCompletionId(&lex,cc,&pos);
        if ((lex==439 || lex==446 || lex==444)) {
                { if (s_opt.debug) {fprintf(dumpOut,": undef macro %s\n",cc);fflush(dumpOut);}};
                { (&dd.b)->record = 0; (&dd.b)->accessFlags = 0; (&dd.b)->javaSourceLoaded = 0; (&dd.b)->javaFileLoaded = 0; (&dd.b)->symType = TypeMacro; (&dd.b)->storage = StorageNone; (&dd.b)->npointers = 0;};
                { (&dd)->name = cc; (&dd)->linkName = cc; (&dd)->pos = pos; (&dd)->b = dd.b; (&dd)->u.mbody = NULL; (&dd)->next = NULL;};
                { if (!(s_opt.taskRegime)) internalCheckFail("s_opt.taskRegime", "yylex.c", 880);};
                if (symTabIsMember(s_symTab, &dd, &ii, &memb)) {
                        if ((s_opt.taskRegime!=RegimeGenerate)) {
                                addCxReference(memb, &pos, UsageUsed,s_noneFileIndex, s_noneFileIndex);
                        }
                        {{{ { if (!((1) >= 0)) internalCheckFail("(1) >= 0", "yylex.c", 887);}; ppmMemoryi = ((char*)(((char*)(ppmMemory+ppmMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(ppmMemory+ppmMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - ppmMemory; if (ppmMemoryi+(1)*sizeof(S_symbol) >= SIZE_ppmMemory) { fatalError(ERR_NO_MEMORY,"ppmMemory", 65); } pp = (S_symbol*) (ppmMemory + ppmMemoryi); ppmMemoryi += (1)*sizeof(S_symbol);};};};
                        { (&pp->b)->record = 0; (&pp->b)->accessFlags = 0; (&pp->b)->javaSourceLoaded = 0; (&pp->b)->javaFileLoaded = 0; (&pp->b)->symType = TypeMacro; (&pp->b)->storage = StorageNone; (&pp->b)->npointers = 0;};
                        { (pp)->name = memb->name; (pp)->linkName = memb->linkName; (pp)->pos = pos; (pp)->b = pp->b; (pp)->u.mbody = NULL; (pp)->next = NULL;};
                        pp->u.mbody = NULL;
                        addMacroToTabs(pp,memb->name);
                }
        }
        while (lex != '\n') {{ char *lastlexcc; { while (cInput.cc >= cInput.fin) { char margFlag; margFlag = cInput.margExpFlag; if (macStacki > 0) { if (margFlag == II_MACRO_ARG) goto endOfMacArg; {{ { if (!((cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi)) internalCheckFail("(cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi", "yylex.c", 895);}; mbMemoryi = ((char*)(cInput.a))-mbMemory;};}; cInput = macStack[--macStacki]; } else if (margFlag == II_NORMAL) { { cFile.lb.cc = cInput.cc;}; getLexBuf(&cFile.lb); if (cFile.lb.cc >= cFile.lb.fin) goto endOfFile; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; } else { s_cache.cc = s_cache.cfin = NULL; cacheInput(); s_cache.lexcc = cFile.lb.cc; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; {}; } } lastlexcc = cInput.cc; { lex = *((unsigned char*)cInput.cc++); lex += 256 * *((unsigned char*)cInput.cc++);};};}; { if (lex > 438) { if ((lex==439 || lex==446 || lex==444)){ register char *tmpcc,tmpch; h = 0; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { h+=tmpch; h+=(h<<10); h^=(h>>6);}; } { h+=(h<<3); h^=(h>>11); h+=(h<<15);}; tmpcc ++; { GetLexFilePos((pos).file,tmpcc); GetLexNumPos((pos).line,tmpcc); GetLexNumPos((pos).coll,tmpcc);}; cInput.cc = tmpcc; } else if (lex == 442) { register char *tmpcc,tmpch; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; { GetLexFilePos((pos).file,tmpcc); GetLexNumPos((pos).line,tmpcc); GetLexNumPos((pos).coll,tmpcc);}; cInput.cc = tmpcc; } else if (lex == 443) { { l = *((unsigned char*)cInput.cc++); l += 256 * *((unsigned char*)cInput.cc++);}; if (1) { if(s_opt.debug) dpnewline(l); cFile.lineNumber += l; } } else if (lex == 440 || lex == 441 || lex == 445 || lex == 447) { { v = *((unsigned char*)cInput.cc++); v += 256 * *((unsigned char*)cInput.cc++); v += 256 * 256 * *((unsigned char*)cInput.cc++); v += 256 * 256 * 256 * *((unsigned char*)cInput.cc++);}; } } else if (lex>411 && lex<424) { { GetLexFilePos((pos).file,cInput.cc); GetLexNumPos((pos).line,cInput.cc); GetLexNumPos((pos).coll,cInput.cc);}; } else if (lex == '\n' && (1)) { if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else if (lex<448 && s_tokenHasPosition[lex]) { { GetLexFilePos((pos).file,cInput.cc); GetLexNumPos((pos).line,cInput.cc); GetLexNumPos((pos).coll,cInput.cc);}; } };}
        return;
endOfMacArg: { if (!(0)) internalCheckFail("0", "yylex.c", 897);};
endOfFile:;
        return;
}
static void processIf();
enum deleteUntilReturn {
        UNTIL_NOTHING,
        UNTIL_ENDIF,
        UNTIL_ELIF,
        UNTIL_ELSE,
};
static void genCppIfElseReference(int level, S_position *pos, int usage) {
        char ttt[TMP_STRING_SIZE];
        S_position dp;
        S_cppIfStack *ss;
        if (level > 0) {
          {{{ { if (!((1) >= 0)) internalCheckFail("(1) >= 0", "yylex.c", 918);}; ppmMemoryi = ((char*)(((char*)(ppmMemory+ppmMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(ppmMemory+ppmMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - ppmMemory; if (ppmMemoryi+(1)*sizeof(S_cppIfStack) >= SIZE_ppmMemory) { fatalError(ERR_NO_MEMORY,"ppmMemory", 65); } ss = (S_cppIfStack*) (ppmMemory + ppmMemoryi); ppmMemoryi += (1)*sizeof(S_cppIfStack);};};};
          { (ss)->pos = *pos; (ss)->next = cFile.ifstack;};
          cFile.ifstack = ss;
        }
        if (cFile.ifstack!=NULL) {
          dp = cFile.ifstack->pos;
          sprintf(ttt,"CppIf%x-%x-%d", dp.file, dp.coll, dp.line);
          addTrivialCxReference(ttt, TypeCppIfElse,StorageDefault, pos, usage);
          if (level < 0) cFile.ifstack = cFile.ifstack->next;
        }
}
static int cppDeleteUntilEndElse(int untilEnd) {
        int lex,l,h,v;
        int deep;
        int el;
        S_position pos;
        deep = 1;
        while (deep > 0) {
                { char *lastlexcc; { while (cInput.cc >= cInput.fin) { char margFlag; margFlag = cInput.margExpFlag; if (macStacki > 0) { if (margFlag == II_MACRO_ARG) goto endOfMacArg; {{ { if (!((cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi)) internalCheckFail("(cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi", "yylex.c", 937);}; mbMemoryi = ((char*)(cInput.a))-mbMemory;};}; cInput = macStack[--macStacki]; } else if (margFlag == II_NORMAL) { { cFile.lb.cc = cInput.cc;}; getLexBuf(&cFile.lb); if (cFile.lb.cc >= cFile.lb.fin) goto endOfFile; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; } else { s_cache.cc = s_cache.cfin = NULL; cacheInput(); s_cache.lexcc = cFile.lb.cc; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; {}; } } lastlexcc = cInput.cc; { lex = *((unsigned char*)cInput.cc++); lex += 256 * *((unsigned char*)cInput.cc++);};};};
                { if (lex > 438) { if ((lex==439 || lex==446 || lex==444)){ register char *tmpcc,tmpch; h = 0; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { h+=tmpch; h+=(h<<10); h^=(h>>6);}; } { h+=(h<<3); h^=(h>>11); h+=(h<<15);}; tmpcc ++; { GetLexFilePos((pos).file,tmpcc); GetLexNumPos((pos).line,tmpcc); GetLexNumPos((pos).coll,tmpcc);}; cInput.cc = tmpcc; } else if (lex == 442) { register char *tmpcc,tmpch; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; { GetLexFilePos((pos).file,tmpcc); GetLexNumPos((pos).line,tmpcc); GetLexNumPos((pos).coll,tmpcc);}; cInput.cc = tmpcc; } else if (lex == 443) { { l = *((unsigned char*)cInput.cc++); l += 256 * *((unsigned char*)cInput.cc++);}; if (1) { if(s_opt.debug) dpnewline(l); cFile.lineNumber += l; } } else if (lex == 440 || lex == 441 || lex == 445 || lex == 447) { { v = *((unsigned char*)cInput.cc++); v += 256 * *((unsigned char*)cInput.cc++); v += 256 * 256 * *((unsigned char*)cInput.cc++); v += 256 * 256 * 256 * *((unsigned char*)cInput.cc++);}; } } else if (lex>411 && lex<424) { { GetLexFilePos((pos).file,cInput.cc); GetLexNumPos((pos).line,cInput.cc); GetLexNumPos((pos).coll,cInput.cc);}; } else if (lex == '\n' && (1)) { if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else if (lex<448 && s_tokenHasPosition[lex]) { { GetLexFilePos((pos).file,cInput.cc); GetLexNumPos((pos).line,cInput.cc); GetLexNumPos((pos).coll,cInput.cc);}; } };
                if (lex==416 || lex==414 || lex==415) {
                        genCppIfElseReference(1, &pos, UsageDefined);
                        deep++;
                } else if (lex == 418) {
                        deep--;
                        genCppIfElseReference(-1, &pos, UsageUsed);
                } else if (lex == 419) {
                        genCppIfElseReference(0, &pos, UsageUsed);
                        if (deep == 1 && !untilEnd) {
                                { if (s_opt.debug) {fprintf(dumpOut,"#elif ");fflush(dumpOut);}};
                                return(UNTIL_ELIF);
                        }
                } else if (lex == 417) {
                        genCppIfElseReference(0, &pos, UsageUsed);
                        if (deep == 1 && !untilEnd) {
                                { if (s_opt.debug) {fprintf(dumpOut,"#else\n");fflush(dumpOut);}};
                                return(UNTIL_ELSE);
                        }
                }
        }
        { if (s_opt.debug) {fprintf(dumpOut,"#endif\n");fflush(dumpOut);}};
        return(UNTIL_ENDIF);
endOfMacArg: { if (!(0)) internalCheckFail("0", "yylex.c", 961);};
endOfFile:;
        if (s_opt.taskRegime!=RegimeEditServer) {
                warning(ERR_ST,"end of file in cpp conditional");
        }
        return(UNTIL_ENDIF);
}
static void execCppIf(int deleteSource) {
        int onElse;
        if (deleteSource==0) cFile.ifDeep ++;
        else {
                onElse = cppDeleteUntilEndElse(0);
                if (onElse==UNTIL_ELSE) {
                        cFile.ifDeep ++;
                } else if (onElse==UNTIL_ELIF) processIf();
        }
}
static void processIfdef(int isIfdef) {
        int lex,l,h,v;
        int i,ii,mm;
        char nn[MACRO_NAME_SIZE];
        S_symbol pp,*memb;
        char ch,*cc,nnn;
        S_position pos;
        int deleteSrc;
        { char *lastlexcc; { while (cInput.cc >= cInput.fin) { char margFlag; margFlag = cInput.margExpFlag; if (macStacki > 0) { if (margFlag == II_MACRO_ARG) goto endOfMacArg; {{ { if (!((cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi)) internalCheckFail("(cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi", "yylex.c", 989);}; mbMemoryi = ((char*)(cInput.a))-mbMemory;};}; cInput = macStack[--macStacki]; } else if (margFlag == II_NORMAL) { { cFile.lb.cc = cInput.cc;}; getLexBuf(&cFile.lb); if (cFile.lb.cc >= cFile.lb.fin) goto endOfFile; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; } else { s_cache.cc = s_cache.cfin = NULL; cacheInput(); s_cache.lexcc = cFile.lb.cc; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; {}; } } lastlexcc = cInput.cc; { lex = *((unsigned char*)cInput.cc++); lex += 256 * *((unsigned char*)cInput.cc++);};};};
        cc = cInput.cc;
        { if (lex > 438) { if ((lex==439 || lex==446 || lex==444)){ register char *tmpcc,tmpch; h = 0; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { h+=tmpch; h+=(h<<10); h^=(h>>6);}; } { h+=(h<<3); h^=(h>>11); h+=(h<<15);}; tmpcc ++; { GetLexFilePos((pos).file,tmpcc); GetLexNumPos((pos).line,tmpcc); GetLexNumPos((pos).coll,tmpcc);}; cInput.cc = tmpcc; } else if (lex == 442) { register char *tmpcc,tmpch; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; { GetLexFilePos((pos).file,tmpcc); GetLexNumPos((pos).line,tmpcc); GetLexNumPos((pos).coll,tmpcc);}; cInput.cc = tmpcc; } else if (lex == 443) { { l = *((unsigned char*)cInput.cc++); l += 256 * *((unsigned char*)cInput.cc++);}; if (1) { if(s_opt.debug) dpnewline(l); cFile.lineNumber += l; } } else if (lex == 440 || lex == 441 || lex == 445 || lex == 447) { { v = *((unsigned char*)cInput.cc++); v += 256 * *((unsigned char*)cInput.cc++); v += 256 * 256 * *((unsigned char*)cInput.cc++); v += 256 * 256 * 256 * *((unsigned char*)cInput.cc++);}; } } else if (lex>411 && lex<424) { { GetLexFilePos((pos).file,cInput.cc); GetLexNumPos((pos).line,cInput.cc); GetLexNumPos((pos).coll,cInput.cc);}; } else if (lex == '\n' && (1)) { if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else if (lex<448 && s_tokenHasPosition[lex]) { { GetLexFilePos((pos).file,cInput.cc); GetLexNumPos((pos).line,cInput.cc); GetLexNumPos((pos).coll,cInput.cc);}; } };
        testCxrefCompletionId(&lex,cc,&pos);
        if (! (lex==439 || lex==446 || lex==444)) return;
        { (&pp.b)->record = 0; (&pp.b)->accessFlags = 0; (&pp.b)->javaSourceLoaded = 0; (&pp.b)->javaFileLoaded = 0; (&pp.b)->symType = TypeMacro; (&pp.b)->storage = StorageNone; (&pp.b)->npointers = 0;};
        { (&pp)->name = cc; (&pp)->linkName = cc; (&pp)->pos = s_noPos; (&pp)->b = pp.b; (&pp)->u.mbody = NULL; (&pp)->next = NULL;};
        { if (!(s_opt.taskRegime)) internalCheckFail("s_opt.taskRegime", "yylex.c", 996);};
        mm = symTabIsMember(s_symTab,&pp,&ii,&memb);
        if (mm && memb->u.mbody==NULL) mm = 0;
        if (mm) {
                if ((s_opt.taskRegime!=RegimeGenerate)) {
                        addCxReference(memb,&pos,UsageUsed,s_noneFileIndex,s_noneFileIndex);
                }
                if (isIfdef) {
                        { if (s_opt.debug) {fprintf(dumpOut,"#ifdef (true)\n");fflush(dumpOut);}};
                        deleteSrc = 0;
                } else {
                        { if (s_opt.debug) {fprintf(dumpOut,"#ifndef (false)\n");fflush(dumpOut);}};
                        deleteSrc = 1;
                }
        } else {
                if (isIfdef) {
                        { if (s_opt.debug) {fprintf(dumpOut,"#ifdef (false)\n");fflush(dumpOut);}};
                        deleteSrc = 1;
                } else {
                        { if (s_opt.debug) {fprintf(dumpOut,"#ifndef (true)\n");fflush(dumpOut);}};
                        deleteSrc = 0;
                }
        }
        execCppIf(deleteSrc);
        return;
endOfMacArg: { if (!(0)) internalCheckFail("0", "yylex.c", 1021);};
endOfFile:;
}
int cexpyylex() {
        int l,v,lex,par,ii,res,mm;
        char *cc;
        unsigned h;
        S_symbol dd,*memb;
        S_position pos;
        lex = yylex();
        if ((lex==439 || lex==446 || lex==444)) {
                lex = cexpTranslateToken(440, 0);
        } else if (lex == 426) {
                { { char *lastlexcc; { while (cInput.cc >= cInput.fin) { char margFlag; margFlag = cInput.margExpFlag; if (macStacki > 0) { if (margFlag == II_MACRO_ARG) goto endOfMacArg; {{ { if (!((cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi)) internalCheckFail("(cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi", "yylex.c", 1038);}; mbMemoryi = ((char*)(cInput.a))-mbMemory;};}; cInput = macStack[--macStacki]; } else if (margFlag == II_NORMAL) { { cFile.lb.cc = cInput.cc;}; getLexBuf(&cFile.lb); if (cFile.lb.cc >= cFile.lb.fin) goto endOfFile; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; } else { s_cache.cc = s_cache.cfin = NULL; cacheInput(); s_cache.lexcc = cFile.lb.cc; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; {}; } } lastlexcc = cInput.cc; { lex = *((unsigned char*)cInput.cc++); lex += 256 * *((unsigned char*)cInput.cc++);};};}; while (lex == 443) { { if (lex > 438) { if ((lex==439 || lex==446 || lex==444)){ register char *tmpcc,tmpch; h = 0; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { h+=tmpch; h+=(h<<10); h^=(h>>6);}; } { h+=(h<<3); h^=(h>>11); h+=(h<<15);}; tmpcc ++; { GetLexFilePos((pos).file,tmpcc); GetLexNumPos((pos).line,tmpcc); GetLexNumPos((pos).coll,tmpcc);}; cInput.cc = tmpcc; } else if (lex == 442) { register char *tmpcc,tmpch; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; { GetLexFilePos((pos).file,tmpcc); GetLexNumPos((pos).line,tmpcc); GetLexNumPos((pos).coll,tmpcc);}; cInput.cc = tmpcc; } else if (lex == 443) { { l = *((unsigned char*)cInput.cc++); l += 256 * *((unsigned char*)cInput.cc++);}; if (1) { if(s_opt.debug) dpnewline(l); cFile.lineNumber += l; } } else if (lex == 440 || lex == 441 || lex == 445 || lex == 447) { { v = *((unsigned char*)cInput.cc++); v += 256 * *((unsigned char*)cInput.cc++); v += 256 * 256 * *((unsigned char*)cInput.cc++); v += 256 * 256 * 256 * *((unsigned char*)cInput.cc++);}; } } else if (lex>411 && lex<424) { { GetLexFilePos((pos).file,cInput.cc); GetLexNumPos((pos).line,cInput.cc); GetLexNumPos((pos).coll,cInput.cc);}; } else if (lex == '\n' && (1)) { if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else if (lex<448 && s_tokenHasPosition[lex]) { { GetLexFilePos((pos).file,cInput.cc); GetLexNumPos((pos).line,cInput.cc); GetLexNumPos((pos).coll,cInput.cc);}; } }; { char *lastlexcc; { while (cInput.cc >= cInput.fin) { char margFlag; margFlag = cInput.margExpFlag; if (macStacki > 0) { if (margFlag == II_MACRO_ARG) goto endOfMacArg; {{ { if (!((cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi)) internalCheckFail("(cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi", "yylex.c", 1038);}; mbMemoryi = ((char*)(cInput.a))-mbMemory;};}; cInput = macStack[--macStacki]; } else if (margFlag == II_NORMAL) { { cFile.lb.cc = cInput.cc;}; getLexBuf(&cFile.lb); if (cFile.lb.cc >= cFile.lb.fin) goto endOfFile; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; } else { s_cache.cc = s_cache.cfin = NULL; cacheInput(); s_cache.lexcc = cFile.lb.cc; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; {}; } } lastlexcc = cInput.cc; { lex = *((unsigned char*)cInput.cc++); lex += 256 * *((unsigned char*)cInput.cc++);};};}; }};
                cc = cInput.cc;
                { if (lex > 438) { if ((lex==439 || lex==446 || lex==444)){ register char *tmpcc,tmpch; h = 0; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { h+=tmpch; h+=(h<<10); h^=(h>>6);}; } { h+=(h<<3); h^=(h>>11); h+=(h<<15);}; tmpcc ++; { GetLexFilePos((pos).file,tmpcc); GetLexNumPos((pos).line,tmpcc); GetLexNumPos((pos).coll,tmpcc);}; cInput.cc = tmpcc; } else if (lex == 442) { register char *tmpcc,tmpch; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; { GetLexFilePos((pos).file,tmpcc); GetLexNumPos((pos).line,tmpcc); GetLexNumPos((pos).coll,tmpcc);}; cInput.cc = tmpcc; } else if (lex == 443) { { l = *((unsigned char*)cInput.cc++); l += 256 * *((unsigned char*)cInput.cc++);}; if (1) { if(s_opt.debug) dpnewline(l); cFile.lineNumber += l; } } else if (lex == 440 || lex == 441 || lex == 445 || lex == 447) { { v = *((unsigned char*)cInput.cc++); v += 256 * *((unsigned char*)cInput.cc++); v += 256 * 256 * *((unsigned char*)cInput.cc++); v += 256 * 256 * 256 * *((unsigned char*)cInput.cc++);}; } } else if (lex>411 && lex<424) { { GetLexFilePos((pos).file,cInput.cc); GetLexNumPos((pos).line,cInput.cc); GetLexNumPos((pos).coll,cInput.cc);}; } else if (lex == '\n' && (1)) { if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else if (lex<448 && s_tokenHasPosition[lex]) { { GetLexFilePos((pos).file,cInput.cc); GetLexNumPos((pos).line,cInput.cc); GetLexNumPos((pos).coll,cInput.cc);}; } };
                if (lex == '(') {
                        par = 1;
                        { { char *lastlexcc; { while (cInput.cc >= cInput.fin) { char margFlag; margFlag = cInput.margExpFlag; if (macStacki > 0) { if (margFlag == II_MACRO_ARG) goto endOfMacArg; {{ { if (!((cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi)) internalCheckFail("(cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi", "yylex.c", 1043);}; mbMemoryi = ((char*)(cInput.a))-mbMemory;};}; cInput = macStack[--macStacki]; } else if (margFlag == II_NORMAL) { { cFile.lb.cc = cInput.cc;}; getLexBuf(&cFile.lb); if (cFile.lb.cc >= cFile.lb.fin) goto endOfFile; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; } else { s_cache.cc = s_cache.cfin = NULL; cacheInput(); s_cache.lexcc = cFile.lb.cc; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; {}; } } lastlexcc = cInput.cc; { lex = *((unsigned char*)cInput.cc++); lex += 256 * *((unsigned char*)cInput.cc++);};};}; while (lex == 443) { { if (lex > 438) { if ((lex==439 || lex==446 || lex==444)){ register char *tmpcc,tmpch; h = 0; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { h+=tmpch; h+=(h<<10); h^=(h>>6);}; } { h+=(h<<3); h^=(h>>11); h+=(h<<15);}; tmpcc ++; { GetLexFilePos((pos).file,tmpcc); GetLexNumPos((pos).line,tmpcc); GetLexNumPos((pos).coll,tmpcc);}; cInput.cc = tmpcc; } else if (lex == 442) { register char *tmpcc,tmpch; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; { GetLexFilePos((pos).file,tmpcc); GetLexNumPos((pos).line,tmpcc); GetLexNumPos((pos).coll,tmpcc);}; cInput.cc = tmpcc; } else if (lex == 443) { { l = *((unsigned char*)cInput.cc++); l += 256 * *((unsigned char*)cInput.cc++);}; if (1) { if(s_opt.debug) dpnewline(l); cFile.lineNumber += l; } } else if (lex == 440 || lex == 441 || lex == 445 || lex == 447) { { v = *((unsigned char*)cInput.cc++); v += 256 * *((unsigned char*)cInput.cc++); v += 256 * 256 * *((unsigned char*)cInput.cc++); v += 256 * 256 * 256 * *((unsigned char*)cInput.cc++);}; } } else if (lex>411 && lex<424) { { GetLexFilePos((pos).file,cInput.cc); GetLexNumPos((pos).line,cInput.cc); GetLexNumPos((pos).coll,cInput.cc);}; } else if (lex == '\n' && (1)) { if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else if (lex<448 && s_tokenHasPosition[lex]) { { GetLexFilePos((pos).file,cInput.cc); GetLexNumPos((pos).line,cInput.cc); GetLexNumPos((pos).coll,cInput.cc);}; } }; { char *lastlexcc; { while (cInput.cc >= cInput.fin) { char margFlag; margFlag = cInput.margExpFlag; if (macStacki > 0) { if (margFlag == II_MACRO_ARG) goto endOfMacArg; {{ { if (!((cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi)) internalCheckFail("(cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi", "yylex.c", 1043);}; mbMemoryi = ((char*)(cInput.a))-mbMemory;};}; cInput = macStack[--macStacki]; } else if (margFlag == II_NORMAL) { { cFile.lb.cc = cInput.cc;}; getLexBuf(&cFile.lb); if (cFile.lb.cc >= cFile.lb.fin) goto endOfFile; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; } else { s_cache.cc = s_cache.cfin = NULL; cacheInput(); s_cache.lexcc = cFile.lb.cc; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; {}; } } lastlexcc = cInput.cc; { lex = *((unsigned char*)cInput.cc++); lex += 256 * *((unsigned char*)cInput.cc++);};};}; }};
                        cc = cInput.cc;
                        { if (lex > 438) { if ((lex==439 || lex==446 || lex==444)){ register char *tmpcc,tmpch; h = 0; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { h+=tmpch; h+=(h<<10); h^=(h>>6);}; } { h+=(h<<3); h^=(h>>11); h+=(h<<15);}; tmpcc ++; { GetLexFilePos((pos).file,tmpcc); GetLexNumPos((pos).line,tmpcc); GetLexNumPos((pos).coll,tmpcc);}; cInput.cc = tmpcc; } else if (lex == 442) { register char *tmpcc,tmpch; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; { GetLexFilePos((pos).file,tmpcc); GetLexNumPos((pos).line,tmpcc); GetLexNumPos((pos).coll,tmpcc);}; cInput.cc = tmpcc; } else if (lex == 443) { { l = *((unsigned char*)cInput.cc++); l += 256 * *((unsigned char*)cInput.cc++);}; if (1) { if(s_opt.debug) dpnewline(l); cFile.lineNumber += l; } } else if (lex == 440 || lex == 441 || lex == 445 || lex == 447) { { v = *((unsigned char*)cInput.cc++); v += 256 * *((unsigned char*)cInput.cc++); v += 256 * 256 * *((unsigned char*)cInput.cc++); v += 256 * 256 * 256 * *((unsigned char*)cInput.cc++);}; } } else if (lex>411 && lex<424) { { GetLexFilePos((pos).file,cInput.cc); GetLexNumPos((pos).line,cInput.cc); GetLexNumPos((pos).coll,cInput.cc);}; } else if (lex == '\n' && (1)) { if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else if (lex<448 && s_tokenHasPosition[lex]) { { GetLexFilePos((pos).file,cInput.cc); GetLexNumPos((pos).line,cInput.cc); GetLexNumPos((pos).coll,cInput.cc);}; } };
                } else {
                        par = 0;
                }
                if (! (lex==439 || lex==446 || lex==444)) return(0);
                { (&dd.b)->record = 0; (&dd.b)->accessFlags = 0; (&dd.b)->javaSourceLoaded = 0; (&dd.b)->javaFileLoaded = 0; (&dd.b)->symType = TypeMacro; (&dd.b)->storage = StorageNone; (&dd.b)->npointers = 0;};
                { (&dd)->name = cc; (&dd)->linkName = cc; (&dd)->pos = s_noPos; (&dd)->b = dd.b; (&dd)->u.mbody = NULL; (&dd)->next = NULL;};
                { if (s_opt.debug) {fprintf(dumpOut,"(%s) ",dd.name);fflush(dumpOut);}};
                mm = symTabIsMember(s_symTab,&dd,&ii,&memb);
                if (mm && memb->u.mbody == NULL) mm = 0;
                { if (!(s_opt.taskRegime)) internalCheckFail("s_opt.taskRegime", "yylex.c", 1055);};
                if ((s_opt.taskRegime!=RegimeGenerate)) {
                        if (mm) addCxReference(&dd, &pos, UsageUsed,s_noneFileIndex, s_noneFileIndex);
                }
                res = cexpTranslateToken(440, mm);
                if (par) {
                        { { char *lastlexcc; { while (cInput.cc >= cInput.fin) { char margFlag; margFlag = cInput.margExpFlag; if (macStacki > 0) { if (margFlag == II_MACRO_ARG) goto endOfMacArg; {{ { if (!((cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi)) internalCheckFail("(cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi", "yylex.c", 1062);}; mbMemoryi = ((char*)(cInput.a))-mbMemory;};}; cInput = macStack[--macStacki]; } else if (margFlag == II_NORMAL) { { cFile.lb.cc = cInput.cc;}; getLexBuf(&cFile.lb); if (cFile.lb.cc >= cFile.lb.fin) goto endOfFile; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; } else { s_cache.cc = s_cache.cfin = NULL; cacheInput(); s_cache.lexcc = cFile.lb.cc; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; {}; } } lastlexcc = cInput.cc; { lex = *((unsigned char*)cInput.cc++); lex += 256 * *((unsigned char*)cInput.cc++);};};}; while (lex == 443) { { if (lex > 438) { if ((lex==439 || lex==446 || lex==444)){ register char *tmpcc,tmpch; h = 0; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { h+=tmpch; h+=(h<<10); h^=(h>>6);}; } { h+=(h<<3); h^=(h>>11); h+=(h<<15);}; tmpcc ++; { GetLexFilePos((pos).file,tmpcc); GetLexNumPos((pos).line,tmpcc); GetLexNumPos((pos).coll,tmpcc);}; cInput.cc = tmpcc; } else if (lex == 442) { register char *tmpcc,tmpch; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; { GetLexFilePos((pos).file,tmpcc); GetLexNumPos((pos).line,tmpcc); GetLexNumPos((pos).coll,tmpcc);}; cInput.cc = tmpcc; } else if (lex == 443) { { l = *((unsigned char*)cInput.cc++); l += 256 * *((unsigned char*)cInput.cc++);}; if (1) { if(s_opt.debug) dpnewline(l); cFile.lineNumber += l; } } else if (lex == 440 || lex == 441 || lex == 445 || lex == 447) { { v = *((unsigned char*)cInput.cc++); v += 256 * *((unsigned char*)cInput.cc++); v += 256 * 256 * *((unsigned char*)cInput.cc++); v += 256 * 256 * 256 * *((unsigned char*)cInput.cc++);}; } } else if (lex>411 && lex<424) { { GetLexFilePos((pos).file,cInput.cc); GetLexNumPos((pos).line,cInput.cc); GetLexNumPos((pos).coll,cInput.cc);}; } else if (lex == '\n' && (1)) { if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else if (lex<448 && s_tokenHasPosition[lex]) { { GetLexFilePos((pos).file,cInput.cc); GetLexNumPos((pos).line,cInput.cc); GetLexNumPos((pos).coll,cInput.cc);}; } }; { char *lastlexcc; { while (cInput.cc >= cInput.fin) { char margFlag; margFlag = cInput.margExpFlag; if (macStacki > 0) { if (margFlag == II_MACRO_ARG) goto endOfMacArg; {{ { if (!((cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi)) internalCheckFail("(cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi", "yylex.c", 1062);}; mbMemoryi = ((char*)(cInput.a))-mbMemory;};}; cInput = macStack[--macStacki]; } else if (margFlag == II_NORMAL) { { cFile.lb.cc = cInput.cc;}; getLexBuf(&cFile.lb); if (cFile.lb.cc >= cFile.lb.fin) goto endOfFile; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; } else { s_cache.cc = s_cache.cfin = NULL; cacheInput(); s_cache.lexcc = cFile.lb.cc; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; {}; } } lastlexcc = cInput.cc; { lex = *((unsigned char*)cInput.cc++); lex += 256 * *((unsigned char*)cInput.cc++);};};}; }};
                        { if (lex > 438) { if ((lex==439 || lex==446 || lex==444)){ register char *tmpcc,tmpch; h = 0; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { h+=tmpch; h+=(h<<10); h^=(h>>6);}; } { h+=(h<<3); h^=(h>>11); h+=(h<<15);}; tmpcc ++; { GetLexFilePos((pos).file,tmpcc); GetLexNumPos((pos).line,tmpcc); GetLexNumPos((pos).coll,tmpcc);}; cInput.cc = tmpcc; } else if (lex == 442) { register char *tmpcc,tmpch; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; { GetLexFilePos((pos).file,tmpcc); GetLexNumPos((pos).line,tmpcc); GetLexNumPos((pos).coll,tmpcc);}; cInput.cc = tmpcc; } else if (lex == 443) { { l = *((unsigned char*)cInput.cc++); l += 256 * *((unsigned char*)cInput.cc++);}; if (1) { if(s_opt.debug) dpnewline(l); cFile.lineNumber += l; } } else if (lex == 440 || lex == 441 || lex == 445 || lex == 447) { { v = *((unsigned char*)cInput.cc++); v += 256 * *((unsigned char*)cInput.cc++); v += 256 * 256 * *((unsigned char*)cInput.cc++); v += 256 * 256 * 256 * *((unsigned char*)cInput.cc++);}; } } else if (lex>411 && lex<424) { { GetLexFilePos((pos).file,cInput.cc); GetLexNumPos((pos).line,cInput.cc); GetLexNumPos((pos).coll,cInput.cc);}; } else if (lex == '\n' && (1)) { if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else if (lex<448 && s_tokenHasPosition[lex]) { { GetLexFilePos((pos).file,cInput.cc); GetLexNumPos((pos).line,cInput.cc); GetLexNumPos((pos).coll,cInput.cc);}; } };
                        if (lex != ')' && s_opt.taskRegime!=RegimeEditServer) {
                                warning(ERR_ST,"missing ')' after defined( ");
                        }
                }
                lex = res;
        } else {
                lex = cexpTranslateToken(lex, uniyylval->integer);
        }
        return(lex);
endOfMacArg: { if (!(0)) internalCheckFail("0", "yylex.c", 1073);};
endOfFile:;
        return(0);
}
static void processIf() {
        int res=1,lex;
        s_ifEvaluation = 1;
        { if (s_opt.debug) {fprintf(dumpOut,": #if ");fflush(dumpOut);}};
        res = cexpyyparse();
        do lex = yylex(); while (lex != '\n');
        s_ifEvaluation = 0;
        execCppIf(! res);
        return;
endOfMacArg: { if (!(0)) internalCheckFail("0", "yylex.c", 1087);};
endOfFile:;
}
static int processCppConstruct(int lex) {
        int l,v;
        unsigned h;
        S_position pos;
        char *fname,*mname;
        { if (lex > 438) { if ((lex==439 || lex==446 || lex==444)){ register char *tmpcc,tmpch; h = 0; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { h+=tmpch; h+=(h<<10); h^=(h>>6);}; } { h+=(h<<3); h^=(h>>11); h+=(h<<15);}; tmpcc ++; { GetLexFilePos((pos).file,tmpcc); GetLexNumPos((pos).line,tmpcc); GetLexNumPos((pos).coll,tmpcc);}; cInput.cc = tmpcc; } else if (lex == 442) { register char *tmpcc,tmpch; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; { GetLexFilePos((pos).file,tmpcc); GetLexNumPos((pos).line,tmpcc); GetLexNumPos((pos).coll,tmpcc);}; cInput.cc = tmpcc; } else if (lex == 443) { { l = *((unsigned char*)cInput.cc++); l += 256 * *((unsigned char*)cInput.cc++);}; if (1) { if(s_opt.debug) dpnewline(l); cFile.lineNumber += l; } } else if (lex == 440 || lex == 441 || lex == 445 || lex == 447) { { v = *((unsigned char*)cInput.cc++); v += 256 * *((unsigned char*)cInput.cc++); v += 256 * 256 * *((unsigned char*)cInput.cc++); v += 256 * 256 * 256 * *((unsigned char*)cInput.cc++);}; } } else if (lex>411 && lex<424) { { GetLexFilePos((pos).file,cInput.cc); GetLexNumPos((pos).line,cInput.cc); GetLexNumPos((pos).coll,cInput.cc);}; } else if (lex == '\n' && (1)) { if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else if (lex<448 && s_tokenHasPosition[lex]) { { GetLexFilePos((pos).file,cInput.cc); GetLexNumPos((pos).line,cInput.cc); GetLexNumPos((pos).coll,cInput.cc);}; } };
        switch (lex) {
        case 412:
                processInclude(&pos);
                break;
        case 423:
                { if (s_opt.taskRegime==RegimeHtmlGenerate && s_opt.htmlNoColors==0) { addTrivialCxReference("_",TypeCppAny,StorageDefault,&pos,UsageUsed); }};
                processDefine(0);
                break;
        case 413:
                { if (s_opt.taskRegime==RegimeHtmlGenerate && s_opt.htmlNoColors==0) { addTrivialCxReference("_",TypeCppAny,StorageDefault,&pos,UsageUsed); }};
                processDefine(1);
                break;
        case 420:
                { if (s_opt.taskRegime==RegimeHtmlGenerate && s_opt.htmlNoColors==0) { addTrivialCxReference("_",TypeCppAny,StorageDefault,&pos,UsageUsed); }};
                processUnDefine();
                break;
        case 414:
                genCppIfElseReference(1, &pos, UsageDefined);
                processIfdef(1);
                break;
        case 415:
                genCppIfElseReference(1, &pos, UsageDefined);
                processIfdef(0);
                break;
        case 416:
                genCppIfElseReference(1, &pos, UsageDefined);
                processIf();
                break;
        case 419:
                { if (s_opt.debug) {fprintf(dumpOut,"#elif ");fflush(dumpOut);}};
                if (cFile.ifDeep) {
                        genCppIfElseReference(0, &pos, UsageUsed);
                        cFile.ifDeep --;
                        cppDeleteUntilEndElse(1);
                } else if (s_opt.taskRegime!=RegimeEditServer) {
                        warning(ERR_ST,"unmatched #elif");
                }
                break;
        case 417:
                { if (s_opt.debug) {fprintf(dumpOut,"#else\n");fflush(dumpOut);}};
                if (cFile.ifDeep) {
                        genCppIfElseReference(0, &pos, UsageUsed);
                        cFile.ifDeep --;
                        cppDeleteUntilEndElse(1);
                } else if (s_opt.taskRegime!=RegimeEditServer) {
                        warning(ERR_ST,"unmatched #else");
                }
                break;
        case 418:
                { if (s_opt.debug) {fprintf(dumpOut,"#endif\n");fflush(dumpOut);}};
                if (cFile.ifDeep) {
                        cFile.ifDeep --;
                        genCppIfElseReference(-1, &pos, UsageUsed);
                } else if (s_opt.taskRegime!=RegimeEditServer) {
                        warning(ERR_ST,"unmatched #endif");
                }
                break;
        case 421:
                { if (s_opt.debug) {fprintf(dumpOut,"#pragma\n");fflush(dumpOut);}};
                { if (s_opt.taskRegime==RegimeHtmlGenerate && s_opt.htmlNoColors==0) { addTrivialCxReference("_",TypeCppAny,StorageDefault,&pos,UsageUsed); }};
                { char *lastlexcc; { while (cInput.cc >= cInput.fin) { char margFlag; margFlag = cInput.margExpFlag; if (macStacki > 0) { if (margFlag == II_MACRO_ARG) goto endOfMacArg; {{ { if (!((cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi)) internalCheckFail("(cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi", "yylex.c", 1168);}; mbMemoryi = ((char*)(cInput.a))-mbMemory;};}; cInput = macStack[--macStacki]; } else if (margFlag == II_NORMAL) { { cFile.lb.cc = cInput.cc;}; getLexBuf(&cFile.lb); if (cFile.lb.cc >= cFile.lb.fin) goto endOfFile; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; } else { s_cache.cc = s_cache.cfin = NULL; cacheInput(); s_cache.lexcc = cFile.lb.cc; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; {}; } } lastlexcc = cInput.cc; { lex = *((unsigned char*)cInput.cc++); lex += 256 * *((unsigned char*)cInput.cc++);};};};
                while (lex != '\n') {{ if (lex > 438) { if ((lex==439 || lex==446 || lex==444)){ register char *tmpcc,tmpch; h = 0; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { h+=tmpch; h+=(h<<10); h^=(h>>6);}; } { h+=(h<<3); h^=(h>>11); h+=(h<<15);}; tmpcc ++; { GetLexFilePos((pos).file,tmpcc); GetLexNumPos((pos).line,tmpcc); GetLexNumPos((pos).coll,tmpcc);}; cInput.cc = tmpcc; } else if (lex == 442) { register char *tmpcc,tmpch; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; { GetLexFilePos((pos).file,tmpcc); GetLexNumPos((pos).line,tmpcc); GetLexNumPos((pos).coll,tmpcc);}; cInput.cc = tmpcc; } else if (lex == 443) { { l = *((unsigned char*)cInput.cc++); l += 256 * *((unsigned char*)cInput.cc++);}; if (1) { if(s_opt.debug) dpnewline(l); cFile.lineNumber += l; } } else if (lex == 440 || lex == 441 || lex == 445 || lex == 447) { { v = *((unsigned char*)cInput.cc++); v += 256 * *((unsigned char*)cInput.cc++); v += 256 * 256 * *((unsigned char*)cInput.cc++); v += 256 * 256 * 256 * *((unsigned char*)cInput.cc++);}; } } else if (lex>411 && lex<424) { { GetLexFilePos((pos).file,cInput.cc); GetLexNumPos((pos).line,cInput.cc); GetLexNumPos((pos).coll,cInput.cc);}; } else if (lex == '\n' && (1)) { if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else if (lex<448 && s_tokenHasPosition[lex]) { { GetLexFilePos((pos).file,cInput.cc); GetLexNumPos((pos).line,cInput.cc); GetLexNumPos((pos).coll,cInput.cc);}; } }; { char *lastlexcc; { while (cInput.cc >= cInput.fin) { char margFlag; margFlag = cInput.margExpFlag; if (macStacki > 0) { if (margFlag == II_MACRO_ARG) goto endOfMacArg; {{ { if (!((cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi)) internalCheckFail("(cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi", "yylex.c", 1169);}; mbMemoryi = ((char*)(cInput.a))-mbMemory;};}; cInput = macStack[--macStacki]; } else if (margFlag == II_NORMAL) { { cFile.lb.cc = cInput.cc;}; getLexBuf(&cFile.lb); if (cFile.lb.cc >= cFile.lb.fin) goto endOfFile; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; } else { s_cache.cc = s_cache.cfin = NULL; cacheInput(); s_cache.lexcc = cFile.lb.cc; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; {}; } } lastlexcc = cInput.cc; { lex = *((unsigned char*)cInput.cc++); lex += 256 * *((unsigned char*)cInput.cc++);};};};}
                { if (lex > 438) { if ((lex==439 || lex==446 || lex==444)){ register char *tmpcc,tmpch; h = 0; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { h+=tmpch; h+=(h<<10); h^=(h>>6);}; } { h+=(h<<3); h^=(h>>11); h+=(h<<15);}; tmpcc ++; { GetLexFilePos((pos).file,tmpcc); GetLexNumPos((pos).line,tmpcc); GetLexNumPos((pos).coll,tmpcc);}; cInput.cc = tmpcc; } else if (lex == 442) { register char *tmpcc,tmpch; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; { GetLexFilePos((pos).file,tmpcc); GetLexNumPos((pos).line,tmpcc); GetLexNumPos((pos).coll,tmpcc);}; cInput.cc = tmpcc; } else if (lex == 443) { { l = *((unsigned char*)cInput.cc++); l += 256 * *((unsigned char*)cInput.cc++);}; if (1) { if(s_opt.debug) dpnewline(l); cFile.lineNumber += l; } } else if (lex == 440 || lex == 441 || lex == 445 || lex == 447) { { v = *((unsigned char*)cInput.cc++); v += 256 * *((unsigned char*)cInput.cc++); v += 256 * 256 * *((unsigned char*)cInput.cc++); v += 256 * 256 * 256 * *((unsigned char*)cInput.cc++);}; } } else if (lex>411 && lex<424) { { GetLexFilePos((pos).file,cInput.cc); GetLexNumPos((pos).line,cInput.cc); GetLexNumPos((pos).coll,cInput.cc);}; } else if (lex == '\n' && (1)) { if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else if (lex<448 && s_tokenHasPosition[lex]) { { GetLexFilePos((pos).file,cInput.cc); GetLexNumPos((pos).line,cInput.cc); GetLexNumPos((pos).coll,cInput.cc);}; } };
                break;
        case 422:
                { if (s_opt.taskRegime==RegimeHtmlGenerate && s_opt.htmlNoColors==0) { addTrivialCxReference("_",TypeCppAny,StorageDefault,&pos,UsageUsed); }};
                processLine();
                { char *lastlexcc; { while (cInput.cc >= cInput.fin) { char margFlag; margFlag = cInput.margExpFlag; if (macStacki > 0) { if (margFlag == II_MACRO_ARG) goto endOfMacArg; {{ { if (!((cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi)) internalCheckFail("(cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi", "yylex.c", 1175);}; mbMemoryi = ((char*)(cInput.a))-mbMemory;};}; cInput = macStack[--macStacki]; } else if (margFlag == II_NORMAL) { { cFile.lb.cc = cInput.cc;}; getLexBuf(&cFile.lb); if (cFile.lb.cc >= cFile.lb.fin) goto endOfFile; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; } else { s_cache.cc = s_cache.cfin = NULL; cacheInput(); s_cache.lexcc = cFile.lb.cc; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; {}; } } lastlexcc = cInput.cc; { lex = *((unsigned char*)cInput.cc++); lex += 256 * *((unsigned char*)cInput.cc++);};};};
                while (lex != '\n') {{ if (lex > 438) { if ((lex==439 || lex==446 || lex==444)){ register char *tmpcc,tmpch; h = 0; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { h+=tmpch; h+=(h<<10); h^=(h>>6);}; } { h+=(h<<3); h^=(h>>11); h+=(h<<15);}; tmpcc ++; { GetLexFilePos((pos).file,tmpcc); GetLexNumPos((pos).line,tmpcc); GetLexNumPos((pos).coll,tmpcc);}; cInput.cc = tmpcc; } else if (lex == 442) { register char *tmpcc,tmpch; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; { GetLexFilePos((pos).file,tmpcc); GetLexNumPos((pos).line,tmpcc); GetLexNumPos((pos).coll,tmpcc);}; cInput.cc = tmpcc; } else if (lex == 443) { { l = *((unsigned char*)cInput.cc++); l += 256 * *((unsigned char*)cInput.cc++);}; if (1) { if(s_opt.debug) dpnewline(l); cFile.lineNumber += l; } } else if (lex == 440 || lex == 441 || lex == 445 || lex == 447) { { v = *((unsigned char*)cInput.cc++); v += 256 * *((unsigned char*)cInput.cc++); v += 256 * 256 * *((unsigned char*)cInput.cc++); v += 256 * 256 * 256 * *((unsigned char*)cInput.cc++);}; } } else if (lex>411 && lex<424) { { GetLexFilePos((pos).file,cInput.cc); GetLexNumPos((pos).line,cInput.cc); GetLexNumPos((pos).coll,cInput.cc);}; } else if (lex == '\n' && (1)) { if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else if (lex<448 && s_tokenHasPosition[lex]) { { GetLexFilePos((pos).file,cInput.cc); GetLexNumPos((pos).line,cInput.cc); GetLexNumPos((pos).coll,cInput.cc);}; } }; { char *lastlexcc; { while (cInput.cc >= cInput.fin) { char margFlag; margFlag = cInput.margExpFlag; if (macStacki > 0) { if (margFlag == II_MACRO_ARG) goto endOfMacArg; {{ { if (!((cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi)) internalCheckFail("(cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi", "yylex.c", 1176);}; mbMemoryi = ((char*)(cInput.a))-mbMemory;};}; cInput = macStack[--macStacki]; } else if (margFlag == II_NORMAL) { { cFile.lb.cc = cInput.cc;}; getLexBuf(&cFile.lb); if (cFile.lb.cc >= cFile.lb.fin) goto endOfFile; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; } else { s_cache.cc = s_cache.cfin = NULL; cacheInput(); s_cache.lexcc = cFile.lb.cc; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; {}; } } lastlexcc = cInput.cc; { lex = *((unsigned char*)cInput.cc++); lex += 256 * *((unsigned char*)cInput.cc++);};};};}
                { if (lex > 438) { if ((lex==439 || lex==446 || lex==444)){ register char *tmpcc,tmpch; h = 0; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { h+=tmpch; h+=(h<<10); h^=(h>>6);}; } { h+=(h<<3); h^=(h>>11); h+=(h<<15);}; tmpcc ++; { GetLexFilePos((pos).file,tmpcc); GetLexNumPos((pos).line,tmpcc); GetLexNumPos((pos).coll,tmpcc);}; cInput.cc = tmpcc; } else if (lex == 442) { register char *tmpcc,tmpch; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; { GetLexFilePos((pos).file,tmpcc); GetLexNumPos((pos).line,tmpcc); GetLexNumPos((pos).coll,tmpcc);}; cInput.cc = tmpcc; } else if (lex == 443) { { l = *((unsigned char*)cInput.cc++); l += 256 * *((unsigned char*)cInput.cc++);}; if (1) { if(s_opt.debug) dpnewline(l); cFile.lineNumber += l; } } else if (lex == 440 || lex == 441 || lex == 445 || lex == 447) { { v = *((unsigned char*)cInput.cc++); v += 256 * *((unsigned char*)cInput.cc++); v += 256 * 256 * *((unsigned char*)cInput.cc++); v += 256 * 256 * 256 * *((unsigned char*)cInput.cc++);}; } } else if (lex>411 && lex<424) { { GetLexFilePos((pos).file,cInput.cc); GetLexNumPos((pos).line,cInput.cc); GetLexNumPos((pos).coll,cInput.cc);}; } else if (lex == '\n' && (1)) { if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else if (lex<448 && s_tokenHasPosition[lex]) { { GetLexFilePos((pos).file,cInput.cc); GetLexNumPos((pos).line,cInput.cc); GetLexNumPos((pos).coll,cInput.cc);}; } };
                break;
        default: { if (!(0)) internalCheckFail("0", "yylex.c", 1179);};
        }
        return(1);
endOfMacArg: { if (!(0)) internalCheckFail("0", "yylex.c", 1182);};
endOfFile:
        return(0);
}
static int macroCallExpansion( char *cc2, int lex, S_position *pos ) {
        S_symbol sd, *memb;
        int ii;
        if (lex == 439) {
                { (&sd.b)->record = 0; (&sd.b)->accessFlags = 0; (&sd.b)->javaSourceLoaded = 0; (&sd.b)->javaFileLoaded = 0; (&sd.b)->symType = TypeMacro; (&sd.b)->storage = StorageNone; (&sd.b)->npointers = 0;};
                { (&sd)->name = cc2; (&sd)->linkName = cc2; (&sd)->pos = s_noPos; (&sd)->b = sd.b; (&sd)->u.mbody = NULL; (&sd)->next = NULL;};
                if (symTabIsMember(s_symTab,&sd,&ii,&memb)) {
                        if (macroCallExpand(memb,pos)) return(1);
                }
        }
        return(0);
}
static void expandMacroArgument(S_lexInput *argb) {
        S_lexInput expArg;
        S_symbol sd,*memb;
        char *buf,*cc,*cc2,*bcc;
        int nn,ii,lex,line,val,bsize,nnr,failedMacroExpansion;
        S_position pos;
        unsigned hash;
        { { if (!(macStacki < MACSTACK_SIZE-1)) internalCheckFail("macStacki < MACSTACK_SIZE-1", "yylex.c", 1230);}; macStack[macStacki++] = cInput; cInput = *argb; cInput.cc = cInput.a; cInput.margExpFlag = II_MACRO;};
        cInput.margExpFlag = II_MACRO_ARG;
        bsize = MACRO_UNIT_SIZE;
        {{ { if (!((bsize+MAX_LEXEM_SIZE) >= 0)) internalCheckFail("(bsize+MAX_LEXEM_SIZE) >= 0", "yylex.c", 1233);}; ppmMemoryi = ((char*)(((char*)(ppmMemory+ppmMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(ppmMemory+ppmMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - ppmMemory; if (ppmMemoryi+(bsize+MAX_LEXEM_SIZE)*sizeof(char) >= SIZE_ppmMemory) { fatalError(ERR_NO_MEMORY,"ppmMemory", 65); } buf = (char*) (ppmMemory + ppmMemoryi); ppmMemoryi += (bsize+MAX_LEXEM_SIZE)*sizeof(char);};};
        bcc = buf;
        for(;;) {
        nextLexem:
                { while (cInput.cc >= cInput.fin) { char margFlag; margFlag = cInput.margExpFlag; if (macStacki > 0) { if (margFlag == II_MACRO_ARG) goto endOfMacArg; {{ { if (!((cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi)) internalCheckFail("(cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi", "yylex.c", 1237);}; mbMemoryi = ((char*)(cInput.a))-mbMemory;};}; cInput = macStack[--macStacki]; } else if (margFlag == II_NORMAL) { { cFile.lb.cc = cInput.cc;}; getLexBuf(&cFile.lb); if (cFile.lb.cc >= cFile.lb.fin) goto endOfFile; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; } else { s_cache.cc = s_cache.cfin = NULL; cacheInput(); s_cache.lexcc = cFile.lb.cc; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; {}; } } cc = cInput.cc; { lex = *((unsigned char*)cInput.cc++); lex += 256 * *((unsigned char*)cInput.cc++);};};
                cc2 = cInput.cc;
                { if (lex > 438) { if ((lex==439 || lex==446 || lex==444)){ register char *tmpcc,tmpch; hash = 0; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { hash+=tmpch; hash+=(hash<<10); hash^=(hash>>6);}; } { hash+=(hash<<3); hash^=(hash>>11); hash+=(hash<<15);}; tmpcc ++; { GetLexFilePos((pos).file,tmpcc); GetLexNumPos((pos).line,tmpcc); GetLexNumPos((pos).coll,tmpcc);}; cInput.cc = tmpcc; } else if (lex == 442) { register char *tmpcc,tmpch; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; { GetLexFilePos((pos).file,tmpcc); GetLexNumPos((pos).line,tmpcc); GetLexNumPos((pos).coll,tmpcc);}; cInput.cc = tmpcc; } else if (lex == 443) { { line = *((unsigned char*)cInput.cc++); line += 256 * *((unsigned char*)cInput.cc++);}; if (macStacki == 0) { if(s_opt.debug) dpnewline(line); cFile.lineNumber += line; } } else if (lex == 440 || lex == 441 || lex == 445 || lex == 447) { { val = *((unsigned char*)cInput.cc++); val += 256 * *((unsigned char*)cInput.cc++); val += 256 * 256 * *((unsigned char*)cInput.cc++); val += 256 * 256 * 256 * *((unsigned char*)cInput.cc++);}; } } else if (lex>411 && lex<424) { { GetLexFilePos((pos).file,cInput.cc); GetLexNumPos((pos).line,cInput.cc); GetLexNumPos((pos).coll,cInput.cc);}; } else if (lex == '\n' && (macStacki == 0)) { if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else if (lex<448 && s_tokenHasPosition[lex]) { { GetLexFilePos((pos).file,cInput.cc); GetLexNumPos((pos).line,cInput.cc); GetLexNumPos((pos).coll,cInput.cc);}; } };
                nn = ((char*)cInput.cc) - cc;
                failedMacroExpansion = 0;
                if (lex == 439) {
                        { (&sd.b)->record = 0; (&sd.b)->accessFlags = 0; (&sd.b)->javaSourceLoaded = 0; (&sd.b)->javaFileLoaded = 0; (&sd.b)->symType = TypeMacro; (&sd.b)->storage = StorageNone; (&sd.b)->npointers = 0;};
                        { (&sd)->name = cc2; (&sd)->linkName = cc2; (&sd)->pos = s_noPos; (&sd)->b = sd.b; (&sd)->u.mbody = NULL; (&sd)->next = NULL;};
                        if (symTabIsMember(s_symTab,&sd,&ii,&memb)) {
                                if (macroCallExpand(memb,&pos)) goto nextLexem;
                                else failedMacroExpansion = 1;
                        }
                }
                if (failedMacroExpansion) {
                        memcpy(bcc, cc, nn);
                        { *(bcc)++ = ((unsigned)(446))%256; *(bcc)++ = ((unsigned)(446))/256;};
                        bcc = bcc + nn - sizeof(short int);
                } else {
                        memcpy(bcc, cc, nn);
                        bcc += nn;
                }
                { if (bcc >= buf+bsize) { bsize += MACRO_UNIT_SIZE; {{ { if (!(((char *)(buf)) + (bsize+MAX_LEXEM_SIZE-MACRO_UNIT_SIZE)*sizeof(char) == ppmMemory + ppmMemoryi)) internalCheckFail("((char *)(buf)) + (bsize+MAX_LEXEM_SIZE-MACRO_UNIT_SIZE)*sizeof(char) == ppmMemory + ppmMemoryi", "yylex.c", 1259);}; ppmMemoryi = ((char*)buf) - ppmMemory; { { if (!((bsize+MAX_LEXEM_SIZE) >= 0)) internalCheckFail("(bsize+MAX_LEXEM_SIZE) >= 0", "yylex.c", 1259);}; ppmMemoryi = ((char*)(((char*)(ppmMemory+ppmMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(ppmMemory+ppmMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - ppmMemory; if (ppmMemoryi+(bsize+MAX_LEXEM_SIZE)*sizeof(char) >= SIZE_ppmMemory) { fatalError(ERR_NO_MEMORY,"ppmMemory", 65); } buf = (char*) (ppmMemory + ppmMemoryi); ppmMemoryi += (bsize+MAX_LEXEM_SIZE)*sizeof(char);};};}; }};
        }
endOfMacArg:
        cInput = macStack[--macStacki];
        {{ { if (!(((char *)(buf)) + (bsize+MAX_LEXEM_SIZE)*sizeof(char) == ppmMemory + ppmMemoryi)) internalCheckFail("((char *)(buf)) + (bsize+MAX_LEXEM_SIZE)*sizeof(char) == ppmMemory + ppmMemoryi", "yylex.c", 1263);}; ppmMemoryi = ((char*)buf) - ppmMemory; { { if (!((bcc-buf) >= 0)) internalCheckFail("(bcc-buf) >= 0", "yylex.c", 1263);}; ppmMemoryi = ((char*)(((char*)(ppmMemory+ppmMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(ppmMemory+ppmMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - ppmMemory; if (ppmMemoryi+(bcc-buf)*sizeof(char) >= SIZE_ppmMemory) { fatalError(ERR_NO_MEMORY,"ppmMemory", 65); } buf = (char*) (ppmMemory + ppmMemoryi); ppmMemoryi += (bcc-buf)*sizeof(char);};};};
        { (argb)->cc = buf; (argb)->fin = bcc; (argb)->a = buf; (argb)->macname = NULL; (argb)->margExpFlag = II_NORMAL;};
        return;
endOfFile:
        { if (!(0)) internalCheckFail("0", "yylex.c", 1267);};
}
static void cxAddCollateReference( char *sym, char *cs, S_position *pos ) {
        char ttt[TMP_STRING_SIZE];
        S_position pps;
        strcpy(ttt,sym);
        { if (!(cs>=sym && cs-sym<TMP_STRING_SIZE)) internalCheckFail("cs>=sym && cs-sym<TMP_STRING_SIZE", "yylex.c", 1274);};
        sprintf(ttt+(cs-sym), "%c%c%s", '#',
                        '#', cs);
        pps = *pos;
        addTrivialCxReference(ttt, TypeCppCollate,StorageDefault, &pps, UsageDefined);
}
static void collate(char **albcc, char **abcc, char *buf, int *absize,
                                        char **ancc, S_lexInput *actArgs) {
        char *lbcc,*bcc,*cc,*ccfin,*cc0,*ncc,*cc1,*occ;
        int line, val, lex, nlex, len1, bsize, nlt;
        S_position pos,respos;
        unsigned hash;
        ncc = *ancc;
        lbcc = *albcc;
        bcc = *abcc;
        bsize = *absize;
        val=0;
        if (( *((unsigned char*)lbcc) + 256 * *(((unsigned char*)lbcc)+1)) == 445) {
                bcc = lbcc;
                { lex = *((unsigned char*)lbcc++); lex += 256 * *((unsigned char*)lbcc++);};
                { if (!(lex==445)) internalCheckFail("lex==445", "yylex.c", 1298);};
                { if (lex > 438) { if ((lex==439 || lex==446 || lex==444)){ register char *tmpcc,tmpch; hash = 0; for(tmpcc=lbcc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { hash+=tmpch; hash+=(hash<<10); hash^=(hash>>6);}; } { hash+=(hash<<3); hash^=(hash>>11); hash+=(hash<<15);}; tmpcc ++; { GetLexFilePos((respos).file,tmpcc); GetLexNumPos((respos).line,tmpcc); GetLexNumPos((respos).coll,tmpcc);}; lbcc = tmpcc; } else if (lex == 442) { register char *tmpcc,tmpch; for(tmpcc=lbcc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; { GetLexFilePos((respos).file,tmpcc); GetLexNumPos((respos).line,tmpcc); GetLexNumPos((respos).coll,tmpcc);}; lbcc = tmpcc; } else if (lex == 443) { { line = *((unsigned char*)lbcc++); line += 256 * *((unsigned char*)lbcc++);}; if (0) { if(s_opt.debug) dpnewline(line); cFile.lineNumber += line; } } else if (lex == 440 || lex == 441 || lex == 445 || lex == 447) { { val = *((unsigned char*)lbcc++); val += 256 * *((unsigned char*)lbcc++); val += 256 * 256 * *((unsigned char*)lbcc++); val += 256 * 256 * 256 * *((unsigned char*)lbcc++);}; } } else if (lex>411 && lex<424) { { GetLexFilePos((respos).file,lbcc); GetLexNumPos((respos).line,lbcc); GetLexNumPos((respos).coll,lbcc);}; } else if (lex == '\n' && (0)) { if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else if (lex<448 && s_tokenHasPosition[lex]) { { GetLexFilePos((respos).file,lbcc); GetLexNumPos((respos).line,lbcc); GetLexNumPos((respos).coll,lbcc);}; } };
                cc = actArgs[val].a; ccfin = actArgs[val].fin;
                lbcc = NULL;
                while (cc < ccfin) {
                        cc0 = cc;
                        { lex = *((unsigned char*)cc++); lex += 256 * *((unsigned char*)cc++);};
                        { if (lex > 438) { if ((lex==439 || lex==446 || lex==444)){ register char *tmpcc,tmpch; hash = 0; for(tmpcc=cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { hash+=tmpch; hash+=(hash<<10); hash^=(hash>>6);}; } { hash+=(hash<<3); hash^=(hash>>11); hash+=(hash<<15);}; tmpcc ++; { GetLexFilePos((respos).file,tmpcc); GetLexNumPos((respos).line,tmpcc); GetLexNumPos((respos).coll,tmpcc);}; cc = tmpcc; } else if (lex == 442) { register char *tmpcc,tmpch; for(tmpcc=cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; { GetLexFilePos((respos).file,tmpcc); GetLexNumPos((respos).line,tmpcc); GetLexNumPos((respos).coll,tmpcc);}; cc = tmpcc; } else if (lex == 443) { { line = *((unsigned char*)cc++); line += 256 * *((unsigned char*)cc++);}; if (0) { if(s_opt.debug) dpnewline(line); cFile.lineNumber += line; } } else if (lex == 440 || lex == 441 || lex == 445 || lex == 447) { { val = *((unsigned char*)cc++); val += 256 * *((unsigned char*)cc++); val += 256 * 256 * *((unsigned char*)cc++); val += 256 * 256 * 256 * *((unsigned char*)cc++);}; } } else if (lex>411 && lex<424) { { GetLexFilePos((respos).file,cc); GetLexNumPos((respos).line,cc); GetLexNumPos((respos).coll,cc);}; } else if (lex == '\n' && (0)) { if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else if (lex<448 && s_tokenHasPosition[lex]) { { GetLexFilePos((respos).file,cc); GetLexNumPos((respos).line,cc); GetLexNumPos((respos).coll,cc);}; } };
                        lbcc = bcc;
                        memcpy(bcc, cc0, cc-cc0);
                        bcc += cc-cc0;
                        { if (bcc >= buf+bsize) { bsize += MACRO_UNIT_SIZE; {{ { if (!(((char *)(buf)) + (bsize+MAX_LEXEM_SIZE-MACRO_UNIT_SIZE)*sizeof(char) == ppmMemory + ppmMemoryi)) internalCheckFail("((char *)(buf)) + (bsize+MAX_LEXEM_SIZE-MACRO_UNIT_SIZE)*sizeof(char) == ppmMemory + ppmMemoryi", "yylex.c", 1309);}; ppmMemoryi = ((char*)buf) - ppmMemory; { { if (!((bsize+MAX_LEXEM_SIZE) >= 0)) internalCheckFail("(bsize+MAX_LEXEM_SIZE) >= 0", "yylex.c", 1309);}; ppmMemoryi = ((char*)(((char*)(ppmMemory+ppmMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(ppmMemory+ppmMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - ppmMemory; if (ppmMemoryi+(bsize+MAX_LEXEM_SIZE)*sizeof(char) >= SIZE_ppmMemory) { fatalError(ERR_NO_MEMORY,"ppmMemory", 65); } buf = (char*) (ppmMemory + ppmMemoryi); ppmMemoryi += (bsize+MAX_LEXEM_SIZE)*sizeof(char);};};}; }};
                }
        }
        if (( *((unsigned char*)ncc) + 256 * *(((unsigned char*)ncc)+1)) == 445) {
                { lex = *((unsigned char*)ncc++); lex += 256 * *((unsigned char*)ncc++);};
                { if (lex > 438) { if ((lex==439 || lex==446 || lex==444)){ register char *tmpcc,tmpch; hash = 0; for(tmpcc=ncc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { hash+=tmpch; hash+=(hash<<10); hash^=(hash>>6);}; } { hash+=(hash<<3); hash^=(hash>>11); hash+=(hash<<15);}; tmpcc ++; { GetLexFilePos((pos).file,tmpcc); GetLexNumPos((pos).line,tmpcc); GetLexNumPos((pos).coll,tmpcc);}; ncc = tmpcc; } else if (lex == 442) { register char *tmpcc,tmpch; for(tmpcc=ncc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; { GetLexFilePos((pos).file,tmpcc); GetLexNumPos((pos).line,tmpcc); GetLexNumPos((pos).coll,tmpcc);}; ncc = tmpcc; } else if (lex == 443) { { line = *((unsigned char*)ncc++); line += 256 * *((unsigned char*)ncc++);}; if (0) { if(s_opt.debug) dpnewline(line); cFile.lineNumber += line; } } else if (lex == 440 || lex == 441 || lex == 445 || lex == 447) { { val = *((unsigned char*)ncc++); val += 256 * *((unsigned char*)ncc++); val += 256 * 256 * *((unsigned char*)ncc++); val += 256 * 256 * 256 * *((unsigned char*)ncc++);}; } } else if (lex>411 && lex<424) { { GetLexFilePos((pos).file,ncc); GetLexNumPos((pos).line,ncc); GetLexNumPos((pos).coll,ncc);}; } else if (lex == '\n' && (0)) { if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else if (lex<448 && s_tokenHasPosition[lex]) { { GetLexFilePos((pos).file,ncc); GetLexNumPos((pos).line,ncc); GetLexNumPos((pos).coll,ncc);}; } };
                cc = actArgs[val].a; ccfin = actArgs[val].fin;
        } else {
                cc = ncc;
                { lex = *((unsigned char*)ncc++); lex += 256 * *((unsigned char*)ncc++);};
                { if (lex > 438) { if ((lex==439 || lex==446 || lex==444)){ register char *tmpcc,tmpch; hash = 0; for(tmpcc=ncc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { hash+=tmpch; hash+=(hash<<10); hash^=(hash>>6);}; } { hash+=(hash<<3); hash^=(hash>>11); hash+=(hash<<15);}; tmpcc ++; { GetLexFilePos((pos).file,tmpcc); GetLexNumPos((pos).line,tmpcc); GetLexNumPos((pos).coll,tmpcc);}; ncc = tmpcc; } else if (lex == 442) { register char *tmpcc,tmpch; for(tmpcc=ncc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; { GetLexFilePos((pos).file,tmpcc); GetLexNumPos((pos).line,tmpcc); GetLexNumPos((pos).coll,tmpcc);}; ncc = tmpcc; } else if (lex == 443) { { line = *((unsigned char*)ncc++); line += 256 * *((unsigned char*)ncc++);}; if (0) { if(s_opt.debug) dpnewline(line); cFile.lineNumber += line; } } else if (lex == 440 || lex == 441 || lex == 445 || lex == 447) { { val = *((unsigned char*)ncc++); val += 256 * *((unsigned char*)ncc++); val += 256 * 256 * *((unsigned char*)ncc++); val += 256 * 256 * 256 * *((unsigned char*)ncc++);}; } } else if (lex>411 && lex<424) { { GetLexFilePos((pos).file,ncc); GetLexNumPos((pos).line,ncc); GetLexNumPos((pos).coll,ncc);}; } else if (lex == '\n' && (0)) { if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else if (lex<448 && s_tokenHasPosition[lex]) { { GetLexFilePos((pos).file,ncc); GetLexNumPos((pos).line,ncc); GetLexNumPos((pos).coll,ncc);}; } };
                ccfin = ncc;
        }
        nlt = ( *((unsigned char*)lbcc) + 256 * *(((unsigned char*)lbcc)+1));
        if (lbcc!=NULL && cc < ccfin && (nlt==439 || nlt==446 || nlt==444)) {
                nlex = ( *((unsigned char*)cc) + 256 * *(((unsigned char*)cc)+1));
                if ((nlex==439 || nlex==446 || nlex==444) || nlex == 440
                                        || nlex == 441 || nlex == 427
                                        || nlex == 428 ) {
                        len1 = strlen(lbcc+2);
                        { lex = *((unsigned char*)cc++); lex += 256 * *((unsigned char*)cc++);};
                        occ = cc;
                        { if (lex > 438) { if ((lex==439 || lex==446 || lex==444)){ register char *tmpcc,tmpch; hash = 0; for(tmpcc=cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { hash+=tmpch; hash+=(hash<<10); hash^=(hash>>6);}; } { hash+=(hash<<3); hash^=(hash>>11); hash+=(hash<<15);}; tmpcc ++; { GetLexFilePos((respos).file,tmpcc); GetLexNumPos((respos).line,tmpcc); GetLexNumPos((respos).coll,tmpcc);}; cc = tmpcc; } else if (lex == 442) { register char *tmpcc,tmpch; for(tmpcc=cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; { GetLexFilePos((respos).file,tmpcc); GetLexNumPos((respos).line,tmpcc); GetLexNumPos((respos).coll,tmpcc);}; cc = tmpcc; } else if (lex == 443) { { line = *((unsigned char*)cc++); line += 256 * *((unsigned char*)cc++);}; if (0) { if(s_opt.debug) dpnewline(line); cFile.lineNumber += line; } } else if (lex == 440 || lex == 441 || lex == 445 || lex == 447) { { val = *((unsigned char*)cc++); val += 256 * *((unsigned char*)cc++); val += 256 * 256 * *((unsigned char*)cc++); val += 256 * 256 * 256 * *((unsigned char*)cc++);}; } } else if (lex>411 && lex<424) { { GetLexFilePos((respos).file,cc); GetLexNumPos((respos).line,cc); GetLexNumPos((respos).coll,cc);}; } else if (lex == '\n' && (0)) { if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else if (lex<448 && s_tokenHasPosition[lex]) { { GetLexFilePos((respos).file,cc); GetLexNumPos((respos).line,cc); GetLexNumPos((respos).coll,cc);}; } };
                        bcc = lbcc + 2 + len1;
                        { if (!(*bcc==0)) internalCheckFail("*bcc==0", "yylex.c", 1335);};
                        if ((lex==439 || lex==446 || lex==444)) {
                                strcpy(bcc,occ);
                                respos.coll --;
                                { if (!(respos.coll>=0)) internalCheckFail("respos.coll>=0", "yylex.c", 1341);};
                                cxAddCollateReference( lbcc+2, bcc, &respos);
                                respos.coll ++;
                        } else {
                                { respos.file = NextLexFilePos(bcc+1); respos.line = NextLexNumPos(bcc+1 +sizeof(short)); respos.coll = NextLexNumPos(bcc+1 +2*sizeof(short));};
                                sprintf(bcc,"%d",val);
                                cxAddCollateReference( lbcc+2, bcc, &respos);
                        }
                        bcc += strlen(bcc);
                        { if (!(*bcc==0)) internalCheckFail("*bcc==0", "yylex.c", 1350);};
                        bcc++;
                        { PutLexFilePos(respos.file,bcc); PutLexNumPos(respos.line,bcc); PutLexNumPos(respos.coll,bcc); };
                }
        }
        { if (bcc >= buf+bsize) { bsize += MACRO_UNIT_SIZE; {{ { if (!(((char *)(buf)) + (bsize+MAX_LEXEM_SIZE-MACRO_UNIT_SIZE)*sizeof(char) == ppmMemory + ppmMemoryi)) internalCheckFail("((char *)(buf)) + (bsize+MAX_LEXEM_SIZE-MACRO_UNIT_SIZE)*sizeof(char) == ppmMemory + ppmMemoryi", "yylex.c", 1355);}; ppmMemoryi = ((char*)buf) - ppmMemory; { { if (!((bsize+MAX_LEXEM_SIZE) >= 0)) internalCheckFail("(bsize+MAX_LEXEM_SIZE) >= 0", "yylex.c", 1355);}; ppmMemoryi = ((char*)(((char*)(ppmMemory+ppmMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(ppmMemory+ppmMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - ppmMemory; if (ppmMemoryi+(bsize+MAX_LEXEM_SIZE)*sizeof(char) >= SIZE_ppmMemory) { fatalError(ERR_NO_MEMORY,"ppmMemory", 65); } buf = (char*) (ppmMemory + ppmMemoryi); ppmMemoryi += (bsize+MAX_LEXEM_SIZE)*sizeof(char);};};}; }};
        while (cc<ccfin) {
                cc0 = cc;
                { lex = *((unsigned char*)cc++); lex += 256 * *((unsigned char*)cc++);};
                { if (lex > 438) { if ((lex==439 || lex==446 || lex==444)){ register char *tmpcc,tmpch; hash = 0; for(tmpcc=cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { hash+=tmpch; hash+=(hash<<10); hash^=(hash>>6);}; } { hash+=(hash<<3); hash^=(hash>>11); hash+=(hash<<15);}; tmpcc ++; { GetLexFilePos((pos).file,tmpcc); GetLexNumPos((pos).line,tmpcc); GetLexNumPos((pos).coll,tmpcc);}; cc = tmpcc; } else if (lex == 442) { register char *tmpcc,tmpch; for(tmpcc=cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; { GetLexFilePos((pos).file,tmpcc); GetLexNumPos((pos).line,tmpcc); GetLexNumPos((pos).coll,tmpcc);}; cc = tmpcc; } else if (lex == 443) { { line = *((unsigned char*)cc++); line += 256 * *((unsigned char*)cc++);}; if (0) { if(s_opt.debug) dpnewline(line); cFile.lineNumber += line; } } else if (lex == 440 || lex == 441 || lex == 445 || lex == 447) { { val = *((unsigned char*)cc++); val += 256 * *((unsigned char*)cc++); val += 256 * 256 * *((unsigned char*)cc++); val += 256 * 256 * 256 * *((unsigned char*)cc++);}; } } else if (lex>411 && lex<424) { { GetLexFilePos((pos).file,cc); GetLexNumPos((pos).line,cc); GetLexNumPos((pos).coll,cc);}; } else if (lex == '\n' && (0)) { if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else if (lex<448 && s_tokenHasPosition[lex]) { { GetLexFilePos((pos).file,cc); GetLexNumPos((pos).line,cc); GetLexNumPos((pos).coll,cc);}; } };
                lbcc = bcc;
                memcpy(bcc, cc0, cc-cc0);
                bcc += cc-cc0;
                { if (bcc >= buf+bsize) { bsize += MACRO_UNIT_SIZE; {{ { if (!(((char *)(buf)) + (bsize+MAX_LEXEM_SIZE-MACRO_UNIT_SIZE)*sizeof(char) == ppmMemory + ppmMemoryi)) internalCheckFail("((char *)(buf)) + (bsize+MAX_LEXEM_SIZE-MACRO_UNIT_SIZE)*sizeof(char) == ppmMemory + ppmMemoryi", "yylex.c", 1363);}; ppmMemoryi = ((char*)buf) - ppmMemory; { { if (!((bsize+MAX_LEXEM_SIZE) >= 0)) internalCheckFail("(bsize+MAX_LEXEM_SIZE) >= 0", "yylex.c", 1363);}; ppmMemoryi = ((char*)(((char*)(ppmMemory+ppmMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(ppmMemory+ppmMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - ppmMemory; if (ppmMemoryi+(bsize+MAX_LEXEM_SIZE)*sizeof(char) >= SIZE_ppmMemory) { fatalError(ERR_NO_MEMORY,"ppmMemory", 65); } buf = (char*) (ppmMemory + ppmMemoryi); ppmMemoryi += (bsize+MAX_LEXEM_SIZE)*sizeof(char);};};}; }};
        }
        *albcc = lbcc;
        *abcc = bcc;
        *ancc = ncc;
        *absize = bsize;
}
static void macArgsToString(char *res, struct lexInput *lb) {
        char *cc, *lcc, *bcc;
        int v,h,c,lv,lex;
        S_position pos;
        bcc = res;
        c=0; v=0;
        cc = lb->a;
        while (cc < lb->fin) {
                { lex = *((unsigned char*)cc++); lex += 256 * *((unsigned char*)cc++);};
                lcc = cc;
                { if (lex > 438) { if ((lex==439 || lex==446 || lex==444)){ register char *tmpcc,tmpch; h = 0; for(tmpcc=cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { h+=tmpch; h+=(h<<10); h^=(h>>6);}; } { h+=(h<<3); h^=(h>>11); h+=(h<<15);}; tmpcc ++; { GetLexFilePos((pos).file,tmpcc); GetLexNumPos((pos).line,tmpcc); GetLexNumPos((pos).coll,tmpcc);}; cc = tmpcc; } else if (lex == 442) { register char *tmpcc,tmpch; for(tmpcc=cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; { GetLexFilePos((pos).file,tmpcc); GetLexNumPos((pos).line,tmpcc); GetLexNumPos((pos).coll,tmpcc);}; cc = tmpcc; } else if (lex == 443) { { lv = *((unsigned char*)cc++); lv += 256 * *((unsigned char*)cc++);}; if (c) { if(s_opt.debug) dpnewline(lv); cFile.lineNumber += lv; } } else if (lex == 440 || lex == 441 || lex == 445 || lex == 447) { { v = *((unsigned char*)cc++); v += 256 * *((unsigned char*)cc++); v += 256 * 256 * *((unsigned char*)cc++); v += 256 * 256 * 256 * *((unsigned char*)cc++);}; } } else if (lex>411 && lex<424) { { GetLexFilePos((pos).file,cc); GetLexNumPos((pos).line,cc); GetLexNumPos((pos).coll,cc);}; } else if (lex == '\n' && (c)) { if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else if (lex<448 && s_tokenHasPosition[lex]) { { GetLexFilePos((pos).file,cc); GetLexNumPos((pos).line,cc); GetLexNumPos((pos).coll,cc);}; } };
                if ((lex==439 || lex==446 || lex==444)) {
                        sprintf(bcc, "%s", lcc);
                        bcc+=strlen(bcc);
                } else if (lex==442) {
                        sprintf(bcc,"\"%s\"", lcc);
                        bcc+=strlen(bcc);
                } else if (lex==440) {
                        sprintf(bcc,"%d", v);
                        bcc+=strlen(bcc);
                } else if (lex < 256) {
                        sprintf(bcc,"%c",lex);
                        bcc+=strlen(bcc);
                }
        }
}
static void crMacroBody(S_lexInput *macBody,
                                                S_macroBody *mb,
                                                struct lexInput *actArgs,
                                                int actArgn
                                                ) {
        char *cc,*cc0,*cfin,*bcc,*lbcc;
        char *cc2,*c2fin;
        int i,lex,line,val,len,rsize,bsize;
        S_position pos, hpos;
        unsigned hash;
        char *buf,*buf2,*res;
        val=0;
        bsize = MACRO_UNIT_SIZE;
        {{ { if (!((bsize+MAX_LEXEM_SIZE) >= 0)) internalCheckFail("(bsize+MAX_LEXEM_SIZE) >= 0", "yylex.c", 1418);}; ppmMemoryi = ((char*)(((char*)(ppmMemory+ppmMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(ppmMemory+ppmMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - ppmMemory; if (ppmMemoryi+(bsize+MAX_LEXEM_SIZE)*sizeof(char) >= SIZE_ppmMemory) { fatalError(ERR_NO_MEMORY,"ppmMemory", 65); } buf = (char*) (ppmMemory + ppmMemoryi); ppmMemoryi += (bsize+MAX_LEXEM_SIZE)*sizeof(char);};};
        cc = mb->body;
        cfin = mb->body + mb->size;
        bcc = buf;
        cc0 = NULL; lbcc = NULL;
        while (cc < cfin) {
                cc0 = cc;
                { lex = *((unsigned char*)cc++); lex += 256 * *((unsigned char*)cc++);};
                { if (lex > 438) { if ((lex==439 || lex==446 || lex==444)){ register char *tmpcc,tmpch; hash = 0; for(tmpcc=cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { hash+=tmpch; hash+=(hash<<10); hash^=(hash>>6);}; } { hash+=(hash<<3); hash^=(hash>>11); hash+=(hash<<15);}; tmpcc ++; { GetLexFilePos((pos).file,tmpcc); GetLexNumPos((pos).line,tmpcc); GetLexNumPos((pos).coll,tmpcc);}; cc = tmpcc; } else if (lex == 442) { register char *tmpcc,tmpch; for(tmpcc=cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; { GetLexFilePos((pos).file,tmpcc); GetLexNumPos((pos).line,tmpcc); GetLexNumPos((pos).coll,tmpcc);}; cc = tmpcc; } else if (lex == 443) { { line = *((unsigned char*)cc++); line += 256 * *((unsigned char*)cc++);}; if (0) { if(s_opt.debug) dpnewline(line); cFile.lineNumber += line; } } else if (lex == 440 || lex == 441 || lex == 445 || lex == 447) { { val = *((unsigned char*)cc++); val += 256 * *((unsigned char*)cc++); val += 256 * 256 * *((unsigned char*)cc++); val += 256 * 256 * 256 * *((unsigned char*)cc++);}; } } else if (lex>411 && lex<424) { { GetLexFilePos((pos).file,cc); GetLexNumPos((pos).line,cc); GetLexNumPos((pos).coll,cc);}; } else if (lex == '\n' && (0)) { if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else if (lex<448 && s_tokenHasPosition[lex]) { { GetLexFilePos((pos).file,cc); GetLexNumPos((pos).line,cc); GetLexNumPos((pos).coll,cc);}; } };
                if (lex==425 && lbcc!=NULL && cc<cfin) {
                        collate(&lbcc,&bcc,buf,&bsize,&cc,actArgs);
                } else {
                        lbcc = bcc;
                        memcpy(bcc, cc0, cc-cc0);
                        bcc += cc-cc0;
                }
                { if (bcc >= buf+bsize) { bsize += MACRO_UNIT_SIZE; {{ { if (!(((char *)(buf)) + (bsize+MAX_LEXEM_SIZE-MACRO_UNIT_SIZE)*sizeof(char) == ppmMemory + ppmMemoryi)) internalCheckFail("((char *)(buf)) + (bsize+MAX_LEXEM_SIZE-MACRO_UNIT_SIZE)*sizeof(char) == ppmMemory + ppmMemoryi", "yylex.c", 1434);}; ppmMemoryi = ((char*)buf) - ppmMemory; { { if (!((bsize+MAX_LEXEM_SIZE) >= 0)) internalCheckFail("(bsize+MAX_LEXEM_SIZE) >= 0", "yylex.c", 1434);}; ppmMemoryi = ((char*)(((char*)(ppmMemory+ppmMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(ppmMemory+ppmMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - ppmMemory; if (ppmMemoryi+(bsize+MAX_LEXEM_SIZE)*sizeof(char) >= SIZE_ppmMemory) { fatalError(ERR_NO_MEMORY,"ppmMemory", 65); } buf = (char*) (ppmMemory + ppmMemoryi); ppmMemoryi += (bsize+MAX_LEXEM_SIZE)*sizeof(char);};};}; }};
        }
        {{ { if (!(((char *)(buf)) + (bsize+MAX_LEXEM_SIZE)*sizeof(char) == ppmMemory + ppmMemoryi)) internalCheckFail("((char *)(buf)) + (bsize+MAX_LEXEM_SIZE)*sizeof(char) == ppmMemory + ppmMemoryi", "yylex.c", 1436);}; ppmMemoryi = ((char*)buf) - ppmMemory; { { if (!((bcc-buf) >= 0)) internalCheckFail("(bcc-buf) >= 0", "yylex.c", 1436);}; ppmMemoryi = ((char*)(((char*)(ppmMemory+ppmMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(ppmMemory+ppmMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - ppmMemory; if (ppmMemoryi+(bcc-buf)*sizeof(char) >= SIZE_ppmMemory) { fatalError(ERR_NO_MEMORY,"ppmMemory", 65); } buf = (char*) (ppmMemory + ppmMemoryi); ppmMemoryi += (bcc-buf)*sizeof(char);};};};
        for(i=0;i<actArgn; i++) {
                expandMacroArgument(&actArgs[i]);
        }
        bsize = MACRO_UNIT_SIZE;
        {{ { if (!((bsize+MAX_LEXEM_SIZE) >= 0)) internalCheckFail("(bsize+MAX_LEXEM_SIZE) >= 0", "yylex.c", 1446);}; mbMemoryi = ((char*)(((char*)(mbMemory+mbMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(mbMemory+mbMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - mbMemory; if (mbMemoryi+(bsize+MAX_LEXEM_SIZE)*sizeof(char) >= SIZE_mbMemory) { fatalError(ERR_NO_MEMORY,"mbMemory", 65); } buf2 = (char*) (mbMemory + mbMemoryi); mbMemoryi += (bsize+MAX_LEXEM_SIZE)*sizeof(char);};};
        cc = buf;
        cfin = bcc;
        bcc = buf2;
        while (cc < cfin) {
                cc0 = cc;
                { lex = *((unsigned char*)cc++); lex += 256 * *((unsigned char*)cc++);};
                { if (lex > 438) { if ((lex==439 || lex==446 || lex==444)){ register char *tmpcc,tmpch; hash = 0; for(tmpcc=cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { hash+=tmpch; hash+=(hash<<10); hash^=(hash>>6);}; } { hash+=(hash<<3); hash^=(hash>>11); hash+=(hash<<15);}; tmpcc ++; { GetLexFilePos((hpos).file,tmpcc); GetLexNumPos((hpos).line,tmpcc); GetLexNumPos((hpos).coll,tmpcc);}; cc = tmpcc; } else if (lex == 442) { register char *tmpcc,tmpch; for(tmpcc=cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; { GetLexFilePos((hpos).file,tmpcc); GetLexNumPos((hpos).line,tmpcc); GetLexNumPos((hpos).coll,tmpcc);}; cc = tmpcc; } else if (lex == 443) { { line = *((unsigned char*)cc++); line += 256 * *((unsigned char*)cc++);}; if (0) { if(s_opt.debug) dpnewline(line); cFile.lineNumber += line; } } else if (lex == 440 || lex == 441 || lex == 445 || lex == 447) { { val = *((unsigned char*)cc++); val += 256 * *((unsigned char*)cc++); val += 256 * 256 * *((unsigned char*)cc++); val += 256 * 256 * 256 * *((unsigned char*)cc++);}; } } else if (lex>411 && lex<424) { { GetLexFilePos((hpos).file,cc); GetLexNumPos((hpos).line,cc); GetLexNumPos((hpos).coll,cc);}; } else if (lex == '\n' && (0)) { if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else if (lex<448 && s_tokenHasPosition[lex]) { { GetLexFilePos((hpos).file,cc); GetLexNumPos((hpos).line,cc); GetLexNumPos((hpos).coll,cc);}; } };
                if (lex == 445) {
                        len = actArgs[val].fin - actArgs[val].a;
                        { while (bcc + len >= buf2 + bsize) { bsize += MACRO_UNIT_SIZE; {{ { if (!(((char *)(buf2)) + (bsize+MAX_LEXEM_SIZE-MACRO_UNIT_SIZE)*sizeof(char) == mbMemory + mbMemoryi)) internalCheckFail("((char *)(buf2)) + (bsize+MAX_LEXEM_SIZE-MACRO_UNIT_SIZE)*sizeof(char) == mbMemory + mbMemoryi", "yylex.c", 1456);}; mbMemoryi = ((char*)buf2) - mbMemory; { { if (!((bsize+MAX_LEXEM_SIZE) >= 0)) internalCheckFail("(bsize+MAX_LEXEM_SIZE) >= 0", "yylex.c", 1456);}; mbMemoryi = ((char*)(((char*)(mbMemory+mbMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(mbMemory+mbMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - mbMemory; if (mbMemoryi+(bsize+MAX_LEXEM_SIZE)*sizeof(char) >= SIZE_mbMemory) { fatalError(ERR_NO_MEMORY,"mbMemory", 65); } buf2 = (char*) (mbMemory + mbMemoryi); mbMemoryi += (bsize+MAX_LEXEM_SIZE)*sizeof(char);};};}; }};
                        memcpy(bcc, actArgs[val].a, len);
                        bcc += len;
                } else if (lex=='#' && cc<cfin && ( *((unsigned char*)cc) + 256 * *(((unsigned char*)cc)+1))==445) {
                        { lex = *((unsigned char*)cc++); lex += 256 * *((unsigned char*)cc++);};
                        { if (lex > 438) { if ((lex==439 || lex==446 || lex==444)){ register char *tmpcc,tmpch; hash = 0; for(tmpcc=cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { hash+=tmpch; hash+=(hash<<10); hash^=(hash>>6);}; } { hash+=(hash<<3); hash^=(hash>>11); hash+=(hash<<15);}; tmpcc ++; { GetLexFilePos((pos).file,tmpcc); GetLexNumPos((pos).line,tmpcc); GetLexNumPos((pos).coll,tmpcc);}; cc = tmpcc; } else if (lex == 442) { register char *tmpcc,tmpch; for(tmpcc=cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; { GetLexFilePos((pos).file,tmpcc); GetLexNumPos((pos).line,tmpcc); GetLexNumPos((pos).coll,tmpcc);}; cc = tmpcc; } else if (lex == 443) { { line = *((unsigned char*)cc++); line += 256 * *((unsigned char*)cc++);}; if (0) { if(s_opt.debug) dpnewline(line); cFile.lineNumber += line; } } else if (lex == 440 || lex == 441 || lex == 445 || lex == 447) { { val = *((unsigned char*)cc++); val += 256 * *((unsigned char*)cc++); val += 256 * 256 * *((unsigned char*)cc++); val += 256 * 256 * 256 * *((unsigned char*)cc++);}; } } else if (lex>411 && lex<424) { { GetLexFilePos((pos).file,cc); GetLexNumPos((pos).line,cc); GetLexNumPos((pos).coll,cc);}; } else if (lex == '\n' && (0)) { if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else if (lex<448 && s_tokenHasPosition[lex]) { { GetLexFilePos((pos).file,cc); GetLexNumPos((pos).line,cc); GetLexNumPos((pos).coll,cc);}; } };
                        { if (!(lex == 445)) internalCheckFail("lex == 445", "yylex.c", 1462);};
                        { *(bcc)++ = ((unsigned)(442))%256; *(bcc)++ = ((unsigned)(442))/256;};
                        { while (bcc + MACRO_UNIT_SIZE >= buf2 + bsize) { bsize += MACRO_UNIT_SIZE; {{ { if (!(((char *)(buf2)) + (bsize+MAX_LEXEM_SIZE-MACRO_UNIT_SIZE)*sizeof(char) == mbMemory + mbMemoryi)) internalCheckFail("((char *)(buf2)) + (bsize+MAX_LEXEM_SIZE-MACRO_UNIT_SIZE)*sizeof(char) == mbMemory + mbMemoryi", "yylex.c", 1464);}; mbMemoryi = ((char*)buf2) - mbMemory; { { if (!((bsize+MAX_LEXEM_SIZE) >= 0)) internalCheckFail("(bsize+MAX_LEXEM_SIZE) >= 0", "yylex.c", 1464);}; mbMemoryi = ((char*)(((char*)(mbMemory+mbMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(mbMemory+mbMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - mbMemory; if (mbMemoryi+(bsize+MAX_LEXEM_SIZE)*sizeof(char) >= SIZE_mbMemory) { fatalError(ERR_NO_MEMORY,"mbMemory", 65); } buf2 = (char*) (mbMemory + mbMemoryi); mbMemoryi += (bsize+MAX_LEXEM_SIZE)*sizeof(char);};};}; }};
                        macArgsToString(bcc, &actArgs[val]);
                        len = strlen(bcc)+1;
                        bcc += len;
                        { PutLexFilePos(hpos.file,bcc); PutLexNumPos(hpos.line,bcc); PutLexNumPos(hpos.coll,bcc); };
                        if (len >= MACRO_UNIT_SIZE-15) {
                                error(ERR_INTERNAL,"size of #macro_argument exceeded MACRO_UNIT_SIZE");
                        }
                } else {
                        { while (bcc + (cc0-cc) >= buf2 + bsize) { bsize += MACRO_UNIT_SIZE; {{ { if (!(((char *)(buf2)) + (bsize+MAX_LEXEM_SIZE-MACRO_UNIT_SIZE)*sizeof(char) == mbMemory + mbMemoryi)) internalCheckFail("((char *)(buf2)) + (bsize+MAX_LEXEM_SIZE-MACRO_UNIT_SIZE)*sizeof(char) == mbMemory + mbMemoryi", "yylex.c", 1473);}; mbMemoryi = ((char*)buf2) - mbMemory; { { if (!((bsize+MAX_LEXEM_SIZE) >= 0)) internalCheckFail("(bsize+MAX_LEXEM_SIZE) >= 0", "yylex.c", 1473);}; mbMemoryi = ((char*)(((char*)(mbMemory+mbMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(mbMemory+mbMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - mbMemory; if (mbMemoryi+(bsize+MAX_LEXEM_SIZE)*sizeof(char) >= SIZE_mbMemory) { fatalError(ERR_NO_MEMORY,"mbMemory", 65); } buf2 = (char*) (mbMemory + mbMemoryi); mbMemoryi += (bsize+MAX_LEXEM_SIZE)*sizeof(char);};};}; }};
                        memcpy(bcc, cc0, cc-cc0);
                        bcc += cc-cc0;
                }
                { while (bcc + 0 >= buf2 + bsize) { bsize += MACRO_UNIT_SIZE; {{ { if (!(((char *)(buf2)) + (bsize+MAX_LEXEM_SIZE-MACRO_UNIT_SIZE)*sizeof(char) == mbMemory + mbMemoryi)) internalCheckFail("((char *)(buf2)) + (bsize+MAX_LEXEM_SIZE-MACRO_UNIT_SIZE)*sizeof(char) == mbMemory + mbMemoryi", "yylex.c", 1477);}; mbMemoryi = ((char*)buf2) - mbMemory; { { if (!((bsize+MAX_LEXEM_SIZE) >= 0)) internalCheckFail("(bsize+MAX_LEXEM_SIZE) >= 0", "yylex.c", 1477);}; mbMemoryi = ((char*)(((char*)(mbMemory+mbMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(mbMemory+mbMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - mbMemory; if (mbMemoryi+(bsize+MAX_LEXEM_SIZE)*sizeof(char) >= SIZE_mbMemory) { fatalError(ERR_NO_MEMORY,"mbMemory", 65); } buf2 = (char*) (mbMemory + mbMemoryi); mbMemoryi += (bsize+MAX_LEXEM_SIZE)*sizeof(char);};};}; }};
        }
        {{ { if (!(((char *)(buf2)) + (bsize+MAX_LEXEM_SIZE)*sizeof(char) == mbMemory + mbMemoryi)) internalCheckFail("((char *)(buf2)) + (bsize+MAX_LEXEM_SIZE)*sizeof(char) == mbMemory + mbMemoryi", "yylex.c", 1479);}; mbMemoryi = ((char*)buf2) - mbMemory; { { if (!((bcc-buf2) >= 0)) internalCheckFail("(bcc-buf2) >= 0", "yylex.c", 1479);}; mbMemoryi = ((char*)(((char*)(mbMemory+mbMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(mbMemory+mbMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - mbMemory; if (mbMemoryi+(bcc-buf2)*sizeof(char) >= SIZE_mbMemory) { fatalError(ERR_NO_MEMORY,"mbMemory", 65); } buf2 = (char*) (mbMemory + mbMemoryi); mbMemoryi += (bcc-buf2)*sizeof(char);};};};
        { (macBody)->cc = buf2; (macBody)->fin = bcc; (macBody)->a = buf2; (macBody)->macname = mb->name; (macBody)->margExpFlag = II_MACRO;};
}
static void getActMacroArgument(char *cc, int *llex,
                                                                S_position *parpos,
                                                                S_lexInput *actArg,
                                                                S_macroBody *mb,
                                                                int lastArgument
                                                                ) {
        char *buf,*bcc;
        int i,line,val;
        S_position pos;
        unsigned h;
        int bufsize,actsize,lex,deep;
        lex = *llex;
        bufsize = MACRO_ARG_UNIT_SIZE;
        deep = 0;
        {{ { if (!((bufsize+MAX_LEXEM_SIZE) >= 0)) internalCheckFail("(bufsize+MAX_LEXEM_SIZE) >= 0", "yylex.c", 1514);}; ppmMemoryi = ((char*)(((char*)(ppmMemory+ppmMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(ppmMemory+ppmMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - ppmMemory; if (ppmMemoryi+(bufsize+MAX_LEXEM_SIZE)*sizeof(char) >= SIZE_ppmMemory) { fatalError(ERR_NO_MEMORY,"ppmMemory", 65); } buf = (char*) (ppmMemory + ppmMemoryi); ppmMemoryi += (bufsize+MAX_LEXEM_SIZE)*sizeof(char);};};
        bcc = buf;
        while (((lex != ',' || lastArgument) && lex != ')') || deep > 0) {
                if (lex == '(') deep ++;
                if (lex == ')') deep --;
                for(;cc < cInput.cc; cc++,bcc++) *bcc = *cc;
                if (bcc-buf >= bufsize) {
                        bufsize += MACRO_ARG_UNIT_SIZE;
                        {{ { if (!(((char *)(buf)) + (bufsize+MAX_LEXEM_SIZE-MACRO_ARG_UNIT_SIZE)*sizeof(char) == ppmMemory + ppmMemoryi)) internalCheckFail("((char *)(buf)) + (bufsize+MAX_LEXEM_SIZE-MACRO_ARG_UNIT_SIZE)*sizeof(char) == ppmMemory + ppmMemoryi", "yylex.c", 1527);}; ppmMemoryi = ((char*)buf) - ppmMemory; { { if (!((bufsize+MAX_LEXEM_SIZE) >= 0)) internalCheckFail("(bufsize+MAX_LEXEM_SIZE) >= 0", "yylex.c", 1527);}; ppmMemoryi = ((char*)(((char*)(ppmMemory+ppmMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(ppmMemory+ppmMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - ppmMemory; if (ppmMemoryi+(bufsize+MAX_LEXEM_SIZE)*sizeof(char) >= SIZE_ppmMemory) { fatalError(ERR_NO_MEMORY,"ppmMemory", 65); } buf = (char*) (ppmMemory + ppmMemoryi); ppmMemoryi += (bufsize+MAX_LEXEM_SIZE)*sizeof(char);};};};
                }
                { { while (cInput.cc >= cInput.fin) { char margFlag; margFlag = cInput.margExpFlag; if (macStacki > 0) { if (margFlag == II_MACRO_ARG) goto endOfMacArg; {{ { if (!((cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi)) internalCheckFail("(cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi", "yylex.c", 1530);}; mbMemoryi = ((char*)(cInput.a))-mbMemory;};}; cInput = macStack[--macStacki]; } else if (margFlag == II_NORMAL) { { cFile.lb.cc = cInput.cc;}; getLexBuf(&cFile.lb); if (cFile.lb.cc >= cFile.lb.fin) goto endOfFile; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; } else { s_cache.cc = s_cache.cfin = NULL; cacheInput(); s_cache.lexcc = cFile.lb.cc; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; {}; } } cc = cInput.cc; { lex = *((unsigned char*)cInput.cc++); lex += 256 * *((unsigned char*)cInput.cc++);};}; while (lex == 443 || lex == '\n') { { if (lex > 438) { if ((lex==439 || lex==446 || lex==444)){ register char *tmpcc,tmpch; h = 0; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { h+=tmpch; h+=(h<<10); h^=(h>>6);}; } { h+=(h<<3); h^=(h>>11); h+=(h<<15);}; tmpcc ++; { GetLexFilePos((pos).file,tmpcc); GetLexNumPos((pos).line,tmpcc); GetLexNumPos((pos).coll,tmpcc);}; cInput.cc = tmpcc; } else if (lex == 442) { register char *tmpcc,tmpch; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; { GetLexFilePos((pos).file,tmpcc); GetLexNumPos((pos).line,tmpcc); GetLexNumPos((pos).coll,tmpcc);}; cInput.cc = tmpcc; } else if (lex == 443) { { line = *((unsigned char*)cInput.cc++); line += 256 * *((unsigned char*)cInput.cc++);}; if (macStacki == 0) { if(s_opt.debug) dpnewline(line); cFile.lineNumber += line; } } else if (lex == 440 || lex == 441 || lex == 445 || lex == 447) { { val = *((unsigned char*)cInput.cc++); val += 256 * *((unsigned char*)cInput.cc++); val += 256 * 256 * *((unsigned char*)cInput.cc++); val += 256 * 256 * 256 * *((unsigned char*)cInput.cc++);}; } } else if (lex>411 && lex<424) { { GetLexFilePos((pos).file,cInput.cc); GetLexNumPos((pos).line,cInput.cc); GetLexNumPos((pos).coll,cInput.cc);}; } else if (lex == '\n' && (macStacki == 0)) { if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else if (lex<448 && s_tokenHasPosition[lex]) { { GetLexFilePos((pos).file,cInput.cc); GetLexNumPos((pos).line,cInput.cc); GetLexNumPos((pos).coll,cInput.cc);}; } }; { while (cInput.cc >= cInput.fin) { char margFlag; margFlag = cInput.margExpFlag; if (macStacki > 0) { if (margFlag == II_MACRO_ARG) goto endOfMacArg; {{ { if (!((cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi)) internalCheckFail("(cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi", "yylex.c", 1530);}; mbMemoryi = ((char*)(cInput.a))-mbMemory;};}; cInput = macStack[--macStacki]; } else if (margFlag == II_NORMAL) { { cFile.lb.cc = cInput.cc;}; getLexBuf(&cFile.lb); if (cFile.lb.cc >= cFile.lb.fin) goto endOfFile; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; } else { s_cache.cc = s_cache.cfin = NULL; cacheInput(); s_cache.lexcc = cFile.lb.cc; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; {}; } } cc = cInput.cc; { lex = *((unsigned char*)cInput.cc++); lex += 256 * *((unsigned char*)cInput.cc++);};}; }};
                { if (lex > 438) { if ((lex==439 || lex==446 || lex==444)){ register char *tmpcc,tmpch; h = 0; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { h+=tmpch; h+=(h<<10); h^=(h>>6);}; } { h+=(h<<3); h^=(h>>11); h+=(h<<15);}; tmpcc ++; { GetLexFilePos(((*parpos)).file,tmpcc); GetLexNumPos(((*parpos)).line,tmpcc); GetLexNumPos(((*parpos)).coll,tmpcc);}; cInput.cc = tmpcc; } else if (lex == 442) { register char *tmpcc,tmpch; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; { GetLexFilePos(((*parpos)).file,tmpcc); GetLexNumPos(((*parpos)).line,tmpcc); GetLexNumPos(((*parpos)).coll,tmpcc);}; cInput.cc = tmpcc; } else if (lex == 443) { { line = *((unsigned char*)cInput.cc++); line += 256 * *((unsigned char*)cInput.cc++);}; if (macStacki == 0) { if(s_opt.debug) dpnewline(line); cFile.lineNumber += line; } } else if (lex == 440 || lex == 441 || lex == 445 || lex == 447) { { val = *((unsigned char*)cInput.cc++); val += 256 * *((unsigned char*)cInput.cc++); val += 256 * 256 * *((unsigned char*)cInput.cc++); val += 256 * 256 * 256 * *((unsigned char*)cInput.cc++);}; } } else if (lex>411 && lex<424) { { GetLexFilePos(((*parpos)).file,cInput.cc); GetLexNumPos(((*parpos)).line,cInput.cc); GetLexNumPos(((*parpos)).coll,cInput.cc);}; } else if (lex == '\n' && (macStacki == 0)) { if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else if (lex<448 && s_tokenHasPosition[lex]) { { GetLexFilePos(((*parpos)).file,cInput.cc); GetLexNumPos(((*parpos)).line,cInput.cc); GetLexNumPos(((*parpos)).coll,cInput.cc);}; } };
        }
        if (0) {
endOfFile:;
endOfMacArg:;
                { if (!(s_opt.taskRegime)) internalCheckFail("s_opt.taskRegime", "yylex.c", 1536);};
                if (s_opt.taskRegime!=RegimeEditServer) {
                        warning(ERR_ST,"[getActMacroArgument] unterminated macro call");
                }
        }
        {{ { if (!(((char *)(buf)) + (bufsize+MAX_LEXEM_SIZE)*sizeof(char) == ppmMemory + ppmMemoryi)) internalCheckFail("((char *)(buf)) + (bufsize+MAX_LEXEM_SIZE)*sizeof(char) == ppmMemory + ppmMemoryi", "yylex.c", 1541);}; ppmMemoryi = ((char*)buf) - ppmMemory; { { if (!((bcc-buf) >= 0)) internalCheckFail("(bcc-buf) >= 0", "yylex.c", 1541);}; ppmMemoryi = ((char*)(((char*)(ppmMemory+ppmMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(ppmMemory+ppmMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - ppmMemory; if (ppmMemoryi+(bcc-buf)*sizeof(char) >= SIZE_ppmMemory) { fatalError(ERR_NO_MEMORY,"ppmMemory", 65); } buf = (char*) (ppmMemory + ppmMemoryi); ppmMemoryi += (bcc-buf)*sizeof(char);};};};
        { (actArg)->cc = buf; (actArg)->fin = bcc; (actArg)->a = buf; (actArg)->macname = cInput.macname; (actArg)->margExpFlag = II_NORMAL;};
        *llex = lex;
        return;
}
static struct lexInput *getActualMacroArguments(S_macroBody *mb, S_position *mpos,
                                                                                                S_position *lparpos) {
        char *cc;
        int i,lex,line,val;
        S_position pos, ppb1, ppb2, *parpos1, *parpos2, *tmppp;
        unsigned h;
        int actArgi = 0;
        struct lexInput *actArgs;
        ppb1 = *lparpos;
        ppb2 = *lparpos;
        parpos1 = &ppb1;
        parpos2 = &ppb2;
        {{ { if (!((mb->argn) >= 0)) internalCheckFail("(mb->argn) >= 0", "yylex.c", 1559);}; ppmMemoryi = ((char*)(((char*)(ppmMemory+ppmMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(ppmMemory+ppmMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - ppmMemory; if (ppmMemoryi+(mb->argn)*sizeof(struct lexInput) >= SIZE_ppmMemory) { fatalError(ERR_NO_MEMORY,"ppmMemory", 65); } actArgs = (struct lexInput*) (ppmMemory + ppmMemoryi); ppmMemoryi += (mb->argn)*sizeof(struct lexInput);};};
        { { while (cInput.cc >= cInput.fin) { char margFlag; margFlag = cInput.margExpFlag; if (macStacki > 0) { if (margFlag == II_MACRO_ARG) goto endOfMacArg; {{ { if (!((cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi)) internalCheckFail("(cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi", "yylex.c", 1560);}; mbMemoryi = ((char*)(cInput.a))-mbMemory;};}; cInput = macStack[--macStacki]; } else if (margFlag == II_NORMAL) { { cFile.lb.cc = cInput.cc;}; getLexBuf(&cFile.lb); if (cFile.lb.cc >= cFile.lb.fin) goto endOfFile; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; } else { s_cache.cc = s_cache.cfin = NULL; cacheInput(); s_cache.lexcc = cFile.lb.cc; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; {}; } } cc = cInput.cc; { lex = *((unsigned char*)cInput.cc++); lex += 256 * *((unsigned char*)cInput.cc++);};}; while (lex == 443 || lex == '\n') { { if (lex > 438) { if ((lex==439 || lex==446 || lex==444)){ register char *tmpcc,tmpch; h = 0; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { h+=tmpch; h+=(h<<10); h^=(h>>6);}; } { h+=(h<<3); h^=(h>>11); h+=(h<<15);}; tmpcc ++; { GetLexFilePos((pos).file,tmpcc); GetLexNumPos((pos).line,tmpcc); GetLexNumPos((pos).coll,tmpcc);}; cInput.cc = tmpcc; } else if (lex == 442) { register char *tmpcc,tmpch; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; { GetLexFilePos((pos).file,tmpcc); GetLexNumPos((pos).line,tmpcc); GetLexNumPos((pos).coll,tmpcc);}; cInput.cc = tmpcc; } else if (lex == 443) { { line = *((unsigned char*)cInput.cc++); line += 256 * *((unsigned char*)cInput.cc++);}; if (macStacki == 0) { if(s_opt.debug) dpnewline(line); cFile.lineNumber += line; } } else if (lex == 440 || lex == 441 || lex == 445 || lex == 447) { { val = *((unsigned char*)cInput.cc++); val += 256 * *((unsigned char*)cInput.cc++); val += 256 * 256 * *((unsigned char*)cInput.cc++); val += 256 * 256 * 256 * *((unsigned char*)cInput.cc++);}; } } else if (lex>411 && lex<424) { { GetLexFilePos((pos).file,cInput.cc); GetLexNumPos((pos).line,cInput.cc); GetLexNumPos((pos).coll,cInput.cc);}; } else if (lex == '\n' && (macStacki == 0)) { if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else if (lex<448 && s_tokenHasPosition[lex]) { { GetLexFilePos((pos).file,cInput.cc); GetLexNumPos((pos).line,cInput.cc); GetLexNumPos((pos).coll,cInput.cc);}; } }; { while (cInput.cc >= cInput.fin) { char margFlag; margFlag = cInput.margExpFlag; if (macStacki > 0) { if (margFlag == II_MACRO_ARG) goto endOfMacArg; {{ { if (!((cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi)) internalCheckFail("(cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi", "yylex.c", 1560);}; mbMemoryi = ((char*)(cInput.a))-mbMemory;};}; cInput = macStack[--macStacki]; } else if (margFlag == II_NORMAL) { { cFile.lb.cc = cInput.cc;}; getLexBuf(&cFile.lb); if (cFile.lb.cc >= cFile.lb.fin) goto endOfFile; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; } else { s_cache.cc = s_cache.cfin = NULL; cacheInput(); s_cache.lexcc = cFile.lb.cc; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; {}; } } cc = cInput.cc; { lex = *((unsigned char*)cInput.cc++); lex += 256 * *((unsigned char*)cInput.cc++);};}; }};
        { if (lex > 438) { if ((lex==439 || lex==446 || lex==444)){ register char *tmpcc,tmpch; h = 0; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { h+=tmpch; h+=(h<<10); h^=(h>>6);}; } { h+=(h<<3); h^=(h>>11); h+=(h<<15);}; tmpcc ++; { GetLexFilePos((pos).file,tmpcc); GetLexNumPos((pos).line,tmpcc); GetLexNumPos((pos).coll,tmpcc);}; cInput.cc = tmpcc; } else if (lex == 442) { register char *tmpcc,tmpch; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; { GetLexFilePos((pos).file,tmpcc); GetLexNumPos((pos).line,tmpcc); GetLexNumPos((pos).coll,tmpcc);}; cInput.cc = tmpcc; } else if (lex == 443) { { line = *((unsigned char*)cInput.cc++); line += 256 * *((unsigned char*)cInput.cc++);}; if (macStacki == 0) { if(s_opt.debug) dpnewline(line); cFile.lineNumber += line; } } else if (lex == 440 || lex == 441 || lex == 445 || lex == 447) { { val = *((unsigned char*)cInput.cc++); val += 256 * *((unsigned char*)cInput.cc++); val += 256 * 256 * *((unsigned char*)cInput.cc++); val += 256 * 256 * 256 * *((unsigned char*)cInput.cc++);}; } } else if (lex>411 && lex<424) { { GetLexFilePos((pos).file,cInput.cc); GetLexNumPos((pos).line,cInput.cc); GetLexNumPos((pos).coll,cInput.cc);}; } else if (lex == '\n' && (macStacki == 0)) { if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else if (lex<448 && s_tokenHasPosition[lex]) { { GetLexFilePos((pos).file,cInput.cc); GetLexNumPos((pos).line,cInput.cc); GetLexNumPos((pos).coll,cInput.cc);}; } };
        if (lex == ')') {
                *parpos2 = pos;
                handleMacroUsageParameterPositions(0, mpos, parpos1, parpos2, 1);
        } else {
                for(;;) {
                        tmppp=parpos1; parpos1=parpos2; parpos2=tmppp;
                        getActMacroArgument(cc,&lex, parpos2,
                                                                &actArgs[actArgi],mb,
                                                                actArgi+1==mb->argn);
                        actArgi ++ ;
                        handleMacroUsageParameterPositions(actArgi, mpos, parpos1, parpos2, 0);
                        if (lex != ',' || actArgi >= mb->argn) break;
                        { { while (cInput.cc >= cInput.fin) { char margFlag; margFlag = cInput.margExpFlag; if (macStacki > 0) { if (margFlag == II_MACRO_ARG) goto endOfMacArg; {{ { if (!((cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi)) internalCheckFail("(cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi", "yylex.c", 1574);}; mbMemoryi = ((char*)(cInput.a))-mbMemory;};}; cInput = macStack[--macStacki]; } else if (margFlag == II_NORMAL) { { cFile.lb.cc = cInput.cc;}; getLexBuf(&cFile.lb); if (cFile.lb.cc >= cFile.lb.fin) goto endOfFile; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; } else { s_cache.cc = s_cache.cfin = NULL; cacheInput(); s_cache.lexcc = cFile.lb.cc; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; {}; } } cc = cInput.cc; { lex = *((unsigned char*)cInput.cc++); lex += 256 * *((unsigned char*)cInput.cc++);};}; while (lex == 443 || lex == '\n') { { if (lex > 438) { if ((lex==439 || lex==446 || lex==444)){ register char *tmpcc,tmpch; h = 0; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { h+=tmpch; h+=(h<<10); h^=(h>>6);}; } { h+=(h<<3); h^=(h>>11); h+=(h<<15);}; tmpcc ++; { GetLexFilePos((pos).file,tmpcc); GetLexNumPos((pos).line,tmpcc); GetLexNumPos((pos).coll,tmpcc);}; cInput.cc = tmpcc; } else if (lex == 442) { register char *tmpcc,tmpch; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; { GetLexFilePos((pos).file,tmpcc); GetLexNumPos((pos).line,tmpcc); GetLexNumPos((pos).coll,tmpcc);}; cInput.cc = tmpcc; } else if (lex == 443) { { line = *((unsigned char*)cInput.cc++); line += 256 * *((unsigned char*)cInput.cc++);}; if (macStacki == 0) { if(s_opt.debug) dpnewline(line); cFile.lineNumber += line; } } else if (lex == 440 || lex == 441 || lex == 445 || lex == 447) { { val = *((unsigned char*)cInput.cc++); val += 256 * *((unsigned char*)cInput.cc++); val += 256 * 256 * *((unsigned char*)cInput.cc++); val += 256 * 256 * 256 * *((unsigned char*)cInput.cc++);}; } } else if (lex>411 && lex<424) { { GetLexFilePos((pos).file,cInput.cc); GetLexNumPos((pos).line,cInput.cc); GetLexNumPos((pos).coll,cInput.cc);}; } else if (lex == '\n' && (macStacki == 0)) { if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else if (lex<448 && s_tokenHasPosition[lex]) { { GetLexFilePos((pos).file,cInput.cc); GetLexNumPos((pos).line,cInput.cc); GetLexNumPos((pos).coll,cInput.cc);}; } }; { while (cInput.cc >= cInput.fin) { char margFlag; margFlag = cInput.margExpFlag; if (macStacki > 0) { if (margFlag == II_MACRO_ARG) goto endOfMacArg; {{ { if (!((cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi)) internalCheckFail("(cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi", "yylex.c", 1574);}; mbMemoryi = ((char*)(cInput.a))-mbMemory;};}; cInput = macStack[--macStacki]; } else if (margFlag == II_NORMAL) { { cFile.lb.cc = cInput.cc;}; getLexBuf(&cFile.lb); if (cFile.lb.cc >= cFile.lb.fin) goto endOfFile; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; } else { s_cache.cc = s_cache.cfin = NULL; cacheInput(); s_cache.lexcc = cFile.lb.cc; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; {}; } } cc = cInput.cc; { lex = *((unsigned char*)cInput.cc++); lex += 256 * *((unsigned char*)cInput.cc++);};}; }};
                        { if (lex > 438) { if ((lex==439 || lex==446 || lex==444)){ register char *tmpcc,tmpch; h = 0; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { h+=tmpch; h+=(h<<10); h^=(h>>6);}; } { h+=(h<<3); h^=(h>>11); h+=(h<<15);}; tmpcc ++; { GetLexFilePos((pos).file,tmpcc); GetLexNumPos((pos).line,tmpcc); GetLexNumPos((pos).coll,tmpcc);}; cInput.cc = tmpcc; } else if (lex == 442) { register char *tmpcc,tmpch; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; { GetLexFilePos((pos).file,tmpcc); GetLexNumPos((pos).line,tmpcc); GetLexNumPos((pos).coll,tmpcc);}; cInput.cc = tmpcc; } else if (lex == 443) { { line = *((unsigned char*)cInput.cc++); line += 256 * *((unsigned char*)cInput.cc++);}; if (macStacki == 0) { if(s_opt.debug) dpnewline(line); cFile.lineNumber += line; } } else if (lex == 440 || lex == 441 || lex == 445 || lex == 447) { { val = *((unsigned char*)cInput.cc++); val += 256 * *((unsigned char*)cInput.cc++); val += 256 * 256 * *((unsigned char*)cInput.cc++); val += 256 * 256 * 256 * *((unsigned char*)cInput.cc++);}; } } else if (lex>411 && lex<424) { { GetLexFilePos((pos).file,cInput.cc); GetLexNumPos((pos).line,cInput.cc); GetLexNumPos((pos).coll,cInput.cc);}; } else if (lex == '\n' && (macStacki == 0)) { if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else if (lex<448 && s_tokenHasPosition[lex]) { { GetLexFilePos((pos).file,cInput.cc); GetLexNumPos((pos).line,cInput.cc); GetLexNumPos((pos).coll,cInput.cc);}; } };
                }
        }
        if (actArgi!=0 && actArgi < mb->argn) {
                handleMacroUsageParameterPositions(actArgi, mpos, parpos1, parpos2, 1);
        }
        for(;actArgi < mb->argn; actArgi++) {
                { (&actArgs[actArgi])->cc = NULL; (&actArgs[actArgi])->fin = NULL; (&actArgs[actArgi])->a = NULL; (&actArgs[actArgi])->macname = NULL; (&actArgs[actArgi])->margExpFlag = II_NORMAL;};
        }
        return(actArgs);
endOfMacArg: { if (!(0)) internalCheckFail("0", "yylex.c", 1586);};
endOfFile:
        { if (!(s_opt.taskRegime)) internalCheckFail("s_opt.taskRegime", "yylex.c", 1588);};
        if (s_opt.taskRegime!=RegimeEditServer) {
                warning(ERR_ST,"[getActualMacroArguments] unterminated macro call");
        }
        return(NULL);
}
static int cyclicCall(S_macroBody *mb) {
        struct lexInput *ll;
        char *name;
        int i;
        name = mb->name;
        if (cInput.macname != NULL && !strcmp(name,cInput.macname)) return(1);
        for(i=0; i<macStacki; i++) {
                ll = &macStack[i];
                if (ll->macname != NULL && !strcmp(name,ll->macname)) return(1);
        }
        return(0);
}
static void addMacroBaseUsageRef( S_symbol *mdef) {
        int ii,rr;
        S_symbolRefItem ppp,*memb;
        S_reference *r;
        S_position basePos;
        { (&basePos)->file = s_input_file_number; (&basePos)->line = 0; (&basePos)->coll = 0;};
        { (&ppp.b)->symType = TypeMacro; (&ppp.b)->storage = StorageDefault; (&ppp.b)->scope = ScopeGlobal; (&ppp.b)->accessFlags = mdef->b.accessFlags; (&ppp.b)->category = CatGlobal; (&ppp.b)->htmlWasLn = 0;};
        { (&ppp)->name = mdef->linkName; (&ppp)->fileHash = cxFileHashNumber(mdef->linkName); (&ppp)->vApplClass = s_noneFileIndex; (&ppp)->vFunClass = s_noneFileIndex; (&ppp)->b = ppp.b; (&ppp)->refs = NULL; (&ppp)->next = NULL;};
        rr = refTabIsMember(&s_cxrefTab, &ppp, &ii, &memb);
        r = NULL;
        if (rr) {
                for(r=memb->refs; r!=NULL; r=r->next) {
                        if (r->usage == UsageMacroBaseFileUsage) break;
                }
        }
        if (rr==0 || r==NULL) {
                addCxReference(mdef,&basePos,UsageMacroBaseFileUsage,
                                                          s_noneFileIndex, s_noneFileIndex);
        }
}
static int macroCallExpand(S_symbol *mdef, S_position *mpos) {
        int i,lex,line,val;
        char *ccOrig,*cc,*cc2,*freeBase;
        S_position pos, lparpos;
        unsigned h;
        struct lexInput *actArgs,macInput,*father,macBody;
        S_macroBody *mb;
        ccOrig = cInput.cc;
        mb = mdef->u.mbody;
        if (mb == NULL) return(0);
        if (macStacki == 0) {
                {{mbMemoryi = 0;};};
        }
        if (cyclicCall(mb)) return(0);
        {{ { if (!((0) >= 0)) internalCheckFail("(0) >= 0", "yylex.c", 1654);}; ppmMemoryi = ((char*)(((char*)(ppmMemory+ppmMemoryi))+(STANDARD_ALLIGNEMENT-1-((((unsigned)(ppmMemory+ppmMemoryi))-1) & (STANDARD_ALLIGNEMENT-1))))) - ppmMemory; if (ppmMemoryi+(0)*sizeof(char) >= SIZE_ppmMemory) { fatalError(ERR_NO_MEMORY,"ppmMemory", 65); } freeBase = (char*) (ppmMemory + ppmMemoryi); ppmMemoryi += (0)*sizeof(char);};};
        if (mb->argn >= 0) {
                cc = cInput.cc;
                { { while (cInput.cc >= cInput.fin) { char margFlag; margFlag = cInput.margExpFlag; if (macStacki > 0) { if (margFlag == II_MACRO_ARG) goto endOfMacArg; {{ { if (!((cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi)) internalCheckFail("(cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi", "yylex.c", 1657);}; mbMemoryi = ((char*)(cInput.a))-mbMemory;};}; cInput = macStack[--macStacki]; } else if (margFlag == II_NORMAL) { { cFile.lb.cc = cInput.cc;}; getLexBuf(&cFile.lb); if (cFile.lb.cc >= cFile.lb.fin) goto endOfFile; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; } else { s_cache.cc = s_cache.cfin = NULL; cacheInput(); s_cache.lexcc = cFile.lb.cc; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; {}; } } cc2 = cInput.cc; { lex = *((unsigned char*)cInput.cc++); lex += 256 * *((unsigned char*)cInput.cc++);};}; while (lex == 443 || lex == '\n') { { if (lex > 438) { if ((lex==439 || lex==446 || lex==444)){ register char *tmpcc,tmpch; h = 0; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { h+=tmpch; h+=(h<<10); h^=(h>>6);}; } { h+=(h<<3); h^=(h>>11); h+=(h<<15);}; tmpcc ++; { GetLexFilePos((pos).file,tmpcc); GetLexNumPos((pos).line,tmpcc); GetLexNumPos((pos).coll,tmpcc);}; cInput.cc = tmpcc; } else if (lex == 442) { register char *tmpcc,tmpch; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; { GetLexFilePos((pos).file,tmpcc); GetLexNumPos((pos).line,tmpcc); GetLexNumPos((pos).coll,tmpcc);}; cInput.cc = tmpcc; } else if (lex == 443) { { line = *((unsigned char*)cInput.cc++); line += 256 * *((unsigned char*)cInput.cc++);}; if (macStacki == 0) { if(s_opt.debug) dpnewline(line); cFile.lineNumber += line; } } else if (lex == 440 || lex == 441 || lex == 445 || lex == 447) { { val = *((unsigned char*)cInput.cc++); val += 256 * *((unsigned char*)cInput.cc++); val += 256 * 256 * *((unsigned char*)cInput.cc++); val += 256 * 256 * 256 * *((unsigned char*)cInput.cc++);}; } } else if (lex>411 && lex<424) { { GetLexFilePos((pos).file,cInput.cc); GetLexNumPos((pos).line,cInput.cc); GetLexNumPos((pos).coll,cInput.cc);}; } else if (lex == '\n' && (macStacki == 0)) { if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else if (lex<448 && s_tokenHasPosition[lex]) { { GetLexFilePos((pos).file,cInput.cc); GetLexNumPos((pos).line,cInput.cc); GetLexNumPos((pos).coll,cInput.cc);}; } }; { while (cInput.cc >= cInput.fin) { char margFlag; margFlag = cInput.margExpFlag; if (macStacki > 0) { if (margFlag == II_MACRO_ARG) goto endOfMacArg; {{ { if (!((cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi)) internalCheckFail("(cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi", "yylex.c", 1657);}; mbMemoryi = ((char*)(cInput.a))-mbMemory;};}; cInput = macStack[--macStacki]; } else if (margFlag == II_NORMAL) { { cFile.lb.cc = cInput.cc;}; getLexBuf(&cFile.lb); if (cFile.lb.cc >= cFile.lb.fin) goto endOfFile; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; } else { s_cache.cc = s_cache.cfin = NULL; cacheInput(); s_cache.lexcc = cFile.lb.cc; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; {}; } } cc2 = cInput.cc; { lex = *((unsigned char*)cInput.cc++); lex += 256 * *((unsigned char*)cInput.cc++);};}; }};
                if (lex != '(') {
                        cInput.cc = cc2;
                        return(0);
                }
                { if (lex > 438) { if ((lex==439 || lex==446 || lex==444)){ register char *tmpcc,tmpch; h = 0; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { h+=tmpch; h+=(h<<10); h^=(h>>6);}; } { h+=(h<<3); h^=(h>>11); h+=(h<<15);}; tmpcc ++; { GetLexFilePos((lparpos).file,tmpcc); GetLexNumPos((lparpos).line,tmpcc); GetLexNumPos((lparpos).coll,tmpcc);}; cInput.cc = tmpcc; } else if (lex == 442) { register char *tmpcc,tmpch; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; { GetLexFilePos((lparpos).file,tmpcc); GetLexNumPos((lparpos).line,tmpcc); GetLexNumPos((lparpos).coll,tmpcc);}; cInput.cc = tmpcc; } else if (lex == 443) { { line = *((unsigned char*)cInput.cc++); line += 256 * *((unsigned char*)cInput.cc++);}; if (macStacki == 0) { if(s_opt.debug) dpnewline(line); cFile.lineNumber += line; } } else if (lex == 440 || lex == 441 || lex == 445 || lex == 447) { { val = *((unsigned char*)cInput.cc++); val += 256 * *((unsigned char*)cInput.cc++); val += 256 * 256 * *((unsigned char*)cInput.cc++); val += 256 * 256 * 256 * *((unsigned char*)cInput.cc++);}; } } else if (lex>411 && lex<424) { { GetLexFilePos((lparpos).file,cInput.cc); GetLexNumPos((lparpos).line,cInput.cc); GetLexNumPos((lparpos).coll,cInput.cc);}; } else if (lex == '\n' && (macStacki == 0)) { if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else if (lex<448 && s_tokenHasPosition[lex]) { { GetLexFilePos((lparpos).file,cInput.cc); GetLexNumPos((lparpos).line,cInput.cc); GetLexNumPos((lparpos).coll,cInput.cc);}; } };
                actArgs = getActualMacroArguments(mb, mpos, &lparpos);
        } else {
                actArgs = NULL;
        }
        { if (!(s_opt.taskRegime)) internalCheckFail("s_opt.taskRegime", "yylex.c", 1667);};
        if ((s_opt.taskRegime!=RegimeGenerate)) {
                addCxReference(mdef,mpos,UsageUsed,s_noneFileIndex, s_noneFileIndex);
                if (s_opt.taskRegime == RegimeXref) addMacroBaseUsageRef(mdef);
        }
        crMacroBody(&macBody,mb,actArgs,mb->argn);
        { { if (!(macStacki < MACSTACK_SIZE-1)) internalCheckFail("macStacki < MACSTACK_SIZE-1", "yylex.c", 1674);}; macStack[macStacki++] = cInput; cInput = macBody; cInput.cc = cInput.a; cInput.margExpFlag = II_MACRO;};
        {{ { if (!((freeBase)>=ppmMemory && (freeBase)<= ppmMemory+ppmMemoryi)) internalCheckFail("(freeBase)>=ppmMemory && (freeBase)<= ppmMemory+ppmMemoryi", "yylex.c", 1676);}; ppmMemoryi = ((char*)(freeBase))-ppmMemory;};};
        return(1);
endOfMacArg:
        cInput.cc = ccOrig;
        {{ { if (!((freeBase)>=ppmMemory && (freeBase)<= ppmMemory+ppmMemoryi)) internalCheckFail("(freeBase)>=ppmMemory && (freeBase)<= ppmMemory+ppmMemoryi", "yylex.c", 1682);}; ppmMemoryi = ((char*)(freeBase))-ppmMemory;};};
        return(0);
endOfFile:
        { if (!(s_opt.taskRegime)) internalCheckFail("s_opt.taskRegime", "yylex.c", 1685);};
        if (s_opt.taskRegime!=RegimeEditServer) {
                warning(ERR_ST,"[macroCallExpand] unterminated macro call");
        }
        cInput.cc = ccOrig;
        {{ { if (!((freeBase)>=ppmMemory && (freeBase)<= ppmMemory+ppmMemoryi)) internalCheckFail("(freeBase)>=ppmMemory && (freeBase)<= ppmMemory+ppmMemoryi", "yylex.c", 1690);}; ppmMemoryi = ((char*)(freeBase))-ppmMemory;};};
        return(0);
}
int lexBufDump(struct lexBuf *lb) {
        char *cc;
        int v,h,c,lv,lex;
        S_position pos;
        c=0;
        fprintf(dumpOut,"\nlexbufdump [start] \n"); fflush(dumpOut);
        cc = lb->cc;
        while (cc < lb->fin) {
                { lex = *((unsigned char*)cc++); lex += 256 * *((unsigned char*)cc++);};
                if (lex==439 || lex==446) {
                        fprintf(dumpOut,"%s ",cc);
                } else if (lex==444) {
                        fprintf(dumpOut,"!%s! ",cc);
                } else if (lex < 256) {
                        fprintf(dumpOut,"%c ",lex);fflush(dumpOut);
                } else if (s_tokenName[lex]==NULL){
                        fprintf(dumpOut,"?%d? ",lex);fflush(dumpOut);
                } else {
                        fprintf(dumpOut,"%s ",s_tokenName[lex]);fflush(dumpOut);
                }
                { if (lex > 438) { if ((lex==439 || lex==446 || lex==444)){ register char *tmpcc,tmpch; h = 0; for(tmpcc=cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { h+=tmpch; h+=(h<<10); h^=(h>>6);}; } { h+=(h<<3); h^=(h>>11); h+=(h<<15);}; tmpcc ++; { GetLexFilePos((pos).file,tmpcc); GetLexNumPos((pos).line,tmpcc); GetLexNumPos((pos).coll,tmpcc);}; cc = tmpcc; } else if (lex == 442) { register char *tmpcc,tmpch; for(tmpcc=cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; { GetLexFilePos((pos).file,tmpcc); GetLexNumPos((pos).line,tmpcc); GetLexNumPos((pos).coll,tmpcc);}; cc = tmpcc; } else if (lex == 443) { { lv = *((unsigned char*)cc++); lv += 256 * *((unsigned char*)cc++);}; if (c) { if(s_opt.debug) dpnewline(lv); cFile.lineNumber += lv; } } else if (lex == 440 || lex == 441 || lex == 445 || lex == 447) { { v = *((unsigned char*)cc++); v += 256 * *((unsigned char*)cc++); v += 256 * 256 * *((unsigned char*)cc++); v += 256 * 256 * 256 * *((unsigned char*)cc++);}; } } else if (lex>411 && lex<424) { { GetLexFilePos((pos).file,cc); GetLexNumPos((pos).line,cc); GetLexNumPos((pos).coll,cc);}; } else if (lex == '\n' && (c)) { if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else if (lex<448 && s_tokenHasPosition[lex]) { { GetLexFilePos((pos).file,cc); GetLexNumPos((pos).line,cc); GetLexNumPos((pos).coll,cc);}; } };
        }
        fprintf(dumpOut,"lexbufdump [stop]\n");fflush(dumpOut);
        return(0);
}
int cachedInputPass(int cpoint, char **cfrom) {
        int lex,line,i,val,len,res;
        S_position pos;
        unsigned h,lsize,compsize;
        char *cc,*cto,*ccc;
        { if (!(cpoint > 0)) internalCheckFail("cpoint > 0", "yylex.c", 1728);};
        cto = s_cache.cp[cpoint].lbcc;
        ccc = *cfrom;
        res = 1;
        while (ccc < cto) {
                { while (cInput.cc >= cInput.fin) { char margFlag; margFlag = cInput.margExpFlag; if (macStacki > 0) { if (margFlag == II_MACRO_ARG) goto endOfMacArg; {{ { if (!((cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi)) internalCheckFail("(cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi", "yylex.c", 1733);}; mbMemoryi = ((char*)(cInput.a))-mbMemory;};}; cInput = macStack[--macStacki]; } else if (margFlag == II_NORMAL) { { cFile.lb.cc = cInput.cc;}; getLexBuf(&cFile.lb); if (cFile.lb.cc >= cFile.lb.fin) goto endOfFile; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; } else { s_cache.cc = s_cache.cfin = NULL; cacheInput(); s_cache.lexcc = cFile.lb.cc; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; {}; } } cc = cInput.cc; { lex = *((unsigned char*)cInput.cc++); lex += 256 * *((unsigned char*)cInput.cc++);};};
                { if (lex > 438) { if ((lex==439 || lex==446 || lex==444)){ register char *tmpcc,tmpch; h = 0; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { h+=tmpch; h+=(h<<10); h^=(h>>6);}; } { h+=(h<<3); h^=(h>>11); h+=(h<<15);}; tmpcc ++; { GetLexFilePos((pos).file,tmpcc); GetLexNumPos((pos).line,tmpcc); GetLexNumPos((pos).coll,tmpcc);}; cInput.cc = tmpcc; } else if (lex == 442) { register char *tmpcc,tmpch; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; { GetLexFilePos((pos).file,tmpcc); GetLexNumPos((pos).line,tmpcc); GetLexNumPos((pos).coll,tmpcc);}; cInput.cc = tmpcc; } else if (lex == 443) { { line = *((unsigned char*)cInput.cc++); line += 256 * *((unsigned char*)cInput.cc++);}; if (1) { if(s_opt.debug) dpnewline(line); cFile.lineNumber += line; } } else if (lex == 440 || lex == 441 || lex == 445 || lex == 447) { { val = *((unsigned char*)cInput.cc++); val += 256 * *((unsigned char*)cInput.cc++); val += 256 * 256 * *((unsigned char*)cInput.cc++); val += 256 * 256 * 256 * *((unsigned char*)cInput.cc++);}; } } else if (lex>411 && lex<424) { { GetLexFilePos((pos).file,cInput.cc); GetLexNumPos((pos).line,cInput.cc); GetLexNumPos((pos).coll,cInput.cc);}; } else if (lex == '\n' && (1)) { if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else if (lex<448 && s_tokenHasPosition[lex]) { { GetLexFilePos((pos).file,cInput.cc); GetLexNumPos((pos).line,cInput.cc); GetLexNumPos((pos).coll,cInput.cc);}; } };
                compsize = lsize = cInput.cc-cc;
                if (memcmp(cc, ccc, compsize)) {
                        cInput.cc = cc;
                        res = 0;
                        break;
                }
                if ((lex==439 || lex==446 || lex==444) || (lex>411&&lex<424)) {
                        if (pos.file==s_cxRefPos.file && pos.line >= s_cxRefPos.line) {
                                cInput.cc = cc;
                                res = 0;
                                break;
                        }
                }
                ccc += lsize;
        }
endOfFile:
cantCache:
        { cFile.lb.cc = cInput.cc;};
        *cfrom = ccc;
        return(res);
endOfMacArg:
        { if (!(0)) internalCheckFail("0", "yylex.c", 1757);};
}
static char charText[2]={0,0};
static char constant[50];
static int processCIdent(unsigned hashval, char *id, S_position *idposa) {
        int lex,line,i,val,len;
        S_symbol *sd,*memb;
        memb = NULL;
        for(sd=s_symTab->tab[hashval]; sd!=NULL; sd=sd->next) {
                if (strcmp(sd->name, id) == 0) {
                        if (memb == NULL) memb = sd;
                        { if (sd->b.symType == TypeKeyword) { { uniyylval->idIdent = &s_yyIdentBuf[s_yyIdentBufi]; s_yyIdentBufi ++; s_yyIdentBufi %= (YYBUFFERED_ID_INDEX); { (uniyylval->idIdent)->name = sd->name; (uniyylval->idIdent)->sd = sd; (uniyylval->idIdent)->p = *idposa;}; yytext = sd->name;}; if (s_opt.taskRegime==RegimeHtmlGenerate && s_opt.htmlNoColors==0) { char ttt[TMP_STRING_SIZE]; sprintf(ttt,"%s-%x", sd->name, idposa->file); addTrivialCxReference(ttt, TypeKeyword,StorageDefault, idposa, UsageUsed); } return(sd->u.keyWordVal); }};
                        if (sd->b.symType == TypeDefinedOp && s_ifEvaluation) {
                                return(426);
                        }
                        if (sd->b.symType == TypeDefault) {
                                { uniyylval->idIdent = &s_yyIdentBuf[s_yyIdentBufi]; s_yyIdentBufi ++; s_yyIdentBufi %= (YYBUFFERED_ID_INDEX); { (uniyylval->idIdent)->name = sd->name; (uniyylval->idIdent)->sd = sd; (uniyylval->idIdent)->p = *idposa;}; yytext = sd->name;};
                                if (sd->b.storage == StorageTypedef) {
                                        return(257);
                                } else {
                                        return(439);
                                }
                        }
                }
        }
        if (memb == NULL) id = stackMemoryPushString(id);
        else id = memb->name;
        { uniyylval->idIdent = &s_yyIdentBuf[s_yyIdentBufi]; s_yyIdentBufi ++; s_yyIdentBufi %= (YYBUFFERED_ID_INDEX); { (uniyylval->idIdent)->name = id; (uniyylval->idIdent)->sd = memb; (uniyylval->idIdent)->p = *idposa;}; yytext = id;};
        return(439);
}
static int processJavaIdent(unsigned hashval, char *id, S_position *idposa) {
        int lex,line,i,val,len;
        S_symbol *sd,*memb;
        memb = NULL;
        for(sd=s_symTab->tab[hashval]; sd!=NULL; sd=sd->next) {
                if (strcmp(sd->name, id) == 0) {
                        if (memb == NULL) memb = sd;
                        { if (sd->b.symType == TypeKeyword) { { uniyylval->idIdent = &s_yyIdentBuf[s_yyIdentBufi]; s_yyIdentBufi ++; s_yyIdentBufi %= (YYBUFFERED_ID_INDEX); { (uniyylval->idIdent)->name = sd->name; (uniyylval->idIdent)->sd = sd; (uniyylval->idIdent)->p = *idposa;}; yytext = sd->name;}; if (s_opt.taskRegime==RegimeHtmlGenerate && s_opt.htmlNoColors==0) { char ttt[TMP_STRING_SIZE]; sprintf(ttt,"%s-%x", sd->name, idposa->file); addTrivialCxReference(ttt, TypeKeyword,StorageDefault, idposa, UsageUsed); } return(sd->u.keyWordVal); }};
                        if (sd->b.symType == TypeDefault) {
                                { uniyylval->idIdent = &s_yyIdentBuf[s_yyIdentBufi]; s_yyIdentBufi ++; s_yyIdentBufi %= (YYBUFFERED_ID_INDEX); { (uniyylval->idIdent)->name = sd->name; (uniyylval->idIdent)->sd = sd; (uniyylval->idIdent)->p = *idposa;}; yytext = sd->name;};
                                return(439);
                        }
                }
        }
        if (memb == NULL) id = stackMemoryPushString(id);
        else id = memb->name;
        { uniyylval->idIdent = &s_yyIdentBuf[s_yyIdentBufi]; s_yyIdentBufi ++; s_yyIdentBufi %= (YYBUFFERED_ID_INDEX); { (uniyylval->idIdent)->name = id; (uniyylval->idIdent)->sd = memb; (uniyylval->idIdent)->p = *idposa;}; yytext = id;};
        return(439);
}
static int processCccIdent(unsigned hashval, char *id, S_position *idposa) {
        int lex,line,i,val,len;
        S_symbol *sd,*memb;
        memb = NULL;
        for(sd=s_symTab->tab[hashval]; sd!=NULL; sd=sd->next) {
                if (strcmp(sd->name, id) == 0) {
                        if (memb == NULL) memb = sd;
                        { if (sd->b.symType == TypeKeyword) { { uniyylval->idIdent = &s_yyIdentBuf[s_yyIdentBufi]; s_yyIdentBufi ++; s_yyIdentBufi %= (YYBUFFERED_ID_INDEX); { (uniyylval->idIdent)->name = sd->name; (uniyylval->idIdent)->sd = sd; (uniyylval->idIdent)->p = *idposa;}; yytext = sd->name;}; if (s_opt.taskRegime==RegimeHtmlGenerate && s_opt.htmlNoColors==0) { char ttt[TMP_STRING_SIZE]; sprintf(ttt,"%s-%x", sd->name, idposa->file); addTrivialCxReference(ttt, TypeKeyword,StorageDefault, idposa, UsageUsed); } return(sd->u.keyWordVal); }};
                        if (sd->b.symType == TypeDefinedOp && s_ifEvaluation) {
                                return(426);
                        }
                        break;
                }
        }
        if (memb == NULL) id = stackMemoryPushString(id);
        else id = memb->name;
        { uniyylval->idIdent = &s_yyIdentBuf[s_yyIdentBufi]; s_yyIdentBufi ++; s_yyIdentBufi %= (YYBUFFERED_ID_INDEX); { (uniyylval->idIdent)->name = id; (uniyylval->idIdent)->sd = memb; (uniyylval->idIdent)->p = *idposa;}; yytext = id;};
        return(439);
}
static void actionOnBlockMarker() {
        if (s_opt.cxrefs == OLO_SET_MOVE_TARGET) {
                s_cps.setTargetAnswerClass[0] = 0;
                if (((s_language & (4)) != 0)) {
                        if (s_cp.function == NULL) {
                                if (s_javaStat!=NULL) {
                                        if (s_javaStat->thisClass==NULL) {
                                                sprintf(s_cps.setTargetAnswerClass, " %s", s_javaThisPackageName);
                                        } else {
                                                strcpy(s_cps.setTargetAnswerClass, s_javaStat->thisClass->linkName);
                                        }
                                }
                        }
                }
        } else if (s_opt.cxrefs == OLO_SET_MOVE_CLASS_TARGET) {
                s_cps.moveTargetApproved = 0;
                if (((s_language & (4)) != 0)) {
                        if (s_cp.function == NULL) {
                                if (s_javaStat!=NULL) {
                                        s_cps.moveTargetApproved = 1;
                                }
                        }
                }
        } else if (s_opt.cxrefs == OLO_SET_MOVE_METHOD_TARGET) {
                s_cps.moveTargetApproved = 0;
                if (((s_language & (4)) != 0)) {
                        if (s_cp.function == NULL) {
                                if (s_javaStat!=NULL) {
                                        if (s_javaStat->thisClass!=NULL) {
                                                s_cps.moveTargetApproved = 1;
                                        }
                                }
                        }
                }
        } else if (s_opt.cxrefs == OLO_EXTRACT) {
                extractActionOnBlockMarker();
        } else {
                s_cps.currentPackageAnswer[0] = 0;
                s_cps.currentClassAnswer[0] = 0;
                s_cps.currentSuperClassAnswer[0] = 0;
                if (((s_language & (4)) != 0)) {
                        if (s_javaStat!=NULL) {
                                strcpy(s_cps.currentPackageAnswer, s_javaThisPackageName);
                                if (s_javaStat->thisClass!=NULL) {
                                        { if (!(s_javaStat->thisClass->u.s)) internalCheckFail("s_javaStat->thisClass->u.s", "yylex.c", 1901);};
                                        strcpy(s_cps.currentClassAnswer, s_javaStat->thisClass->linkName);
                                        if (s_javaStat->thisClass->u.s->super!=NULL) {
                                                { if (!(s_javaStat->thisClass->u.s->super->d)) internalCheckFail("s_javaStat->thisClass->u.s->super->d", "yylex.c", 1904);};
                                                strcpy(s_cps.currentSuperClassAnswer, s_javaStat->thisClass->u.s->super->d->linkName);
                                        }
                                }
                        }
                }
                s_cp.parserPassedMarker = 1;
        }
}
int yylex() {
        int lex,line,i,val,len;
        S_position pos,idpos;
        char *cc;
        unsigned h;
 nextYylex:
        { while (cInput.cc >= cInput.fin) { char margFlag; margFlag = cInput.margExpFlag; if (macStacki > 0) { if (margFlag == II_MACRO_ARG) goto endOfMacArg; {{ { if (!((cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi)) internalCheckFail("(cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi", "yylex.c", 1922);}; mbMemoryi = ((char*)(cInput.a))-mbMemory;};}; cInput = macStack[--macStacki]; } else if (margFlag == II_NORMAL) { { cFile.lb.cc = cInput.cc;}; getLexBuf(&cFile.lb); if (cFile.lb.cc >= cFile.lb.fin) goto endOfFile; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; } else { s_cache.cc = s_cache.cfin = NULL; cacheInput(); s_cache.lexcc = cFile.lb.cc; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; {}; } } cc = cInput.cc; { lex = *((unsigned char*)cInput.cc++); lex += 256 * *((unsigned char*)cInput.cc++);};};
 contYylex:
        if (lex < 256) {
                if (lex == '\n') {
                        if (s_ifEvaluation) {
                                cInput.cc = cc;
                        } else {
                                { if (lex > 438) { if ((lex==439 || lex==446 || lex==444)){ register char *tmpcc,tmpch; h = 0; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { h+=tmpch; h+=(h<<10); h^=(h>>6);}; } { h+=(h<<3); h^=(h>>11); h+=(h<<15);}; tmpcc ++; { GetLexFilePos((pos).file,tmpcc); GetLexNumPos((pos).line,tmpcc); GetLexNumPos((pos).coll,tmpcc);}; cInput.cc = tmpcc; } else if (lex == 442) { register char *tmpcc,tmpch; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; { GetLexFilePos((pos).file,tmpcc); GetLexNumPos((pos).line,tmpcc); GetLexNumPos((pos).coll,tmpcc);}; cInput.cc = tmpcc; } else if (lex == 443) { { line = *((unsigned char*)cInput.cc++); line += 256 * *((unsigned char*)cInput.cc++);}; if (macStacki == 0) { if(s_opt.debug) dpnewline(line); cFile.lineNumber += line; } } else if (lex == 440 || lex == 441 || lex == 445 || lex == 447) { { val = *((unsigned char*)cInput.cc++); val += 256 * *((unsigned char*)cInput.cc++); val += 256 * 256 * *((unsigned char*)cInput.cc++); val += 256 * 256 * 256 * *((unsigned char*)cInput.cc++);}; } } else if (lex>411 && lex<424) { { GetLexFilePos((pos).file,cInput.cc); GetLexNumPos((pos).line,cInput.cc); GetLexNumPos((pos).coll,cInput.cc);}; } else if (lex == '\n' && (macStacki == 0)) { if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else if (lex<448 && s_tokenHasPosition[lex]) { { GetLexFilePos((pos).file,cInput.cc); GetLexNumPos((pos).line,cInput.cc); GetLexNumPos((pos).coll,cInput.cc);}; } };
                                for(;;) {
                                        { char *lastlexcc; { while (cInput.cc >= cInput.fin) { char margFlag; margFlag = cInput.margExpFlag; if (macStacki > 0) { if (margFlag == II_MACRO_ARG) goto endOfMacArg; {{ { if (!((cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi)) internalCheckFail("(cInput.a)>=mbMemory && (cInput.a)<= mbMemory+mbMemoryi", "yylex.c", 1931);}; mbMemoryi = ((char*)(cInput.a))-mbMemory;};}; cInput = macStack[--macStacki]; } else if (margFlag == II_NORMAL) { { cFile.lb.cc = cInput.cc;}; getLexBuf(&cFile.lb); if (cFile.lb.cc >= cFile.lb.fin) goto endOfFile; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; } else { s_cache.cc = s_cache.cfin = NULL; cacheInput(); s_cache.lexcc = cFile.lb.cc; { { (&cInput)->cc = cFile.lb.cc; (&cInput)->fin = cFile.lb.fin; (&cInput)->a = cFile.lb.a; (&cInput)->macname = NULL; (&cInput)->margExpFlag = II_NORMAL;};}; {}; } } lastlexcc = cInput.cc; { lex = *((unsigned char*)cInput.cc++); lex += 256 * *((unsigned char*)cInput.cc++);};};};
                                        if (lex<=411 || lex>=424) goto contYylex;
                                        if (processCppConstruct(lex) == 0) goto endOfFile;
                                }
                        }
                } else {
                        { if (lex > 438) { if ((lex==439 || lex==446 || lex==444)){ register char *tmpcc,tmpch; h = 0; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { h+=tmpch; h+=(h<<10); h^=(h>>6);}; } { h+=(h<<3); h^=(h>>11); h+=(h<<15);}; tmpcc ++; { GetLexFilePos((pos).file,tmpcc); GetLexNumPos((pos).line,tmpcc); GetLexNumPos((pos).coll,tmpcc);}; cInput.cc = tmpcc; } else if (lex == 442) { register char *tmpcc,tmpch; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; { GetLexFilePos((pos).file,tmpcc); GetLexNumPos((pos).line,tmpcc); GetLexNumPos((pos).coll,tmpcc);}; cInput.cc = tmpcc; } else if (lex == 443) { { line = *((unsigned char*)cInput.cc++); line += 256 * *((unsigned char*)cInput.cc++);}; if (macStacki == 0) { if(s_opt.debug) dpnewline(line); cFile.lineNumber += line; } } else if (lex == 440 || lex == 441 || lex == 445 || lex == 447) { { val = *((unsigned char*)cInput.cc++); val += 256 * *((unsigned char*)cInput.cc++); val += 256 * 256 * *((unsigned char*)cInput.cc++); val += 256 * 256 * 256 * *((unsigned char*)cInput.cc++);}; } } else if (lex>411 && lex<424) { { GetLexFilePos((pos).file,cInput.cc); GetLexNumPos((pos).line,cInput.cc); GetLexNumPos((pos).coll,cInput.cc);}; } else if (lex == '\n' && (macStacki == 0)) { if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else if (lex<448 && s_tokenHasPosition[lex]) { { GetLexFilePos((pos).file,cInput.cc); GetLexNumPos((pos).line,cInput.cc); GetLexNumPos((pos).coll,cInput.cc);}; } };
                        if (s_tokenHasPosition[lex]) {
                                {uniyylval->position = pos;};
                        }
                }
                yytext = charText;
                charText[0] = lex;
                goto finish;
        }
        if (lex==439 || lex==446) {
                register char *id;
                register unsigned h;
                int ii;
                S_symbol *sd,dd,*memb;
                h = 0;
                id = yytext = cInput.cc;
                { if (lex > 438) { if ((lex==439 || lex==446 || lex==444)){ register char *tmpcc,tmpch; h = 0; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { h+=tmpch; h+=(h<<10); h^=(h>>6);}; } { h+=(h<<3); h^=(h>>11); h+=(h<<15);}; tmpcc ++; { GetLexFilePos((idpos).file,tmpcc); GetLexNumPos((idpos).line,tmpcc); GetLexNumPos((idpos).coll,tmpcc);}; cInput.cc = tmpcc; } else if (lex == 442) { register char *tmpcc,tmpch; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; { GetLexFilePos((idpos).file,tmpcc); GetLexNumPos((idpos).line,tmpcc); GetLexNumPos((idpos).coll,tmpcc);}; cInput.cc = tmpcc; } else if (lex == 443) { { line = *((unsigned char*)cInput.cc++); line += 256 * *((unsigned char*)cInput.cc++);}; if (macStacki == 0) { if(s_opt.debug) dpnewline(line); cFile.lineNumber += line; } } else if (lex == 440 || lex == 441 || lex == 445 || lex == 447) { { val = *((unsigned char*)cInput.cc++); val += 256 * *((unsigned char*)cInput.cc++); val += 256 * 256 * *((unsigned char*)cInput.cc++); val += 256 * 256 * 256 * *((unsigned char*)cInput.cc++);}; } } else if (lex>411 && lex<424) { { GetLexFilePos((idpos).file,cInput.cc); GetLexNumPos((idpos).line,cInput.cc); GetLexNumPos((idpos).coll,cInput.cc);}; } else if (lex == '\n' && (macStacki == 0)) { if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else if (lex<448 && s_tokenHasPosition[lex]) { { GetLexFilePos((idpos).file,cInput.cc); GetLexNumPos((idpos).line,cInput.cc); GetLexNumPos((idpos).coll,cInput.cc);}; } };
                { if (!(s_opt.taskRegime)) internalCheckFail("s_opt.taskRegime", "yylex.c", 1954);};
                if (s_opt.taskRegime == RegimeEditServer) {
                        testCxrefCompletionId(&lex,yytext,&idpos);
                }
                { (&dd.b)->record = 0; (&dd.b)->accessFlags = 0; (&dd.b)->javaSourceLoaded = 0; (&dd.b)->javaFileLoaded = 0; (&dd.b)->symType = TypeMacro; (&dd.b)->storage = StorageNone; (&dd.b)->npointers = 0;};
                { (&dd)->name = yytext; (&dd)->linkName = yytext; (&dd)->pos = s_noPos; (&dd)->b = dd.b; (&dd)->u.mbody = NULL; (&dd)->next = NULL;};
                if ((!((s_language & (4)) != 0))
                        && lex!=446
                        && symTabIsMember(s_symTab,&dd,&ii,&memb)) {
                        id = memb->name;
                        if (macroCallExpand(memb,&idpos)) goto nextYylex;
                }
                h = h % s_symTab->size;
                if(((s_language & (2)) != 0)||((s_language & (8)) != 0)) lex=processCIdent(h,id,&idpos);
                else if (((s_language & (4)) != 0)) lex = processJavaIdent(h, id, &idpos);
                else if (((s_language & (16)) != 0)) lex = processCccIdent(h, id, &idpos);
                else { if (!(0)) internalCheckFail("0", "yylex.c", 1975);};
                goto finish;
        }
        if (lex == 431) {
                actionOnBlockMarker();
                goto nextYylex;
        }
        if (lex < 438) {
                yytext = s_tokenName[lex];
                goto finish;
        }
        if (lex == 443) {
                { if (lex > 438) { if ((lex==439 || lex==446 || lex==444)){ register char *tmpcc,tmpch; h = 0; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { h+=tmpch; h+=(h<<10); h^=(h>>6);}; } { h+=(h<<3); h^=(h>>11); h+=(h<<15);}; tmpcc ++; { GetLexFilePos((pos).file,tmpcc); GetLexNumPos((pos).line,tmpcc); GetLexNumPos((pos).coll,tmpcc);}; cInput.cc = tmpcc; } else if (lex == 442) { register char *tmpcc,tmpch; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; { GetLexFilePos((pos).file,tmpcc); GetLexNumPos((pos).line,tmpcc); GetLexNumPos((pos).coll,tmpcc);}; cInput.cc = tmpcc; } else if (lex == 443) { { line = *((unsigned char*)cInput.cc++); line += 256 * *((unsigned char*)cInput.cc++);}; if (macStacki == 0) { if(s_opt.debug) dpnewline(line); cFile.lineNumber += line; } } else if (lex == 440 || lex == 441 || lex == 445 || lex == 447) { { val = *((unsigned char*)cInput.cc++); val += 256 * *((unsigned char*)cInput.cc++); val += 256 * 256 * *((unsigned char*)cInput.cc++); val += 256 * 256 * 256 * *((unsigned char*)cInput.cc++);}; } } else if (lex>411 && lex<424) { { GetLexFilePos((pos).file,cInput.cc); GetLexNumPos((pos).line,cInput.cc); GetLexNumPos((pos).coll,cInput.cc);}; } else if (lex == '\n' && (macStacki == 0)) { if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else if (lex<448 && s_tokenHasPosition[lex]) { { GetLexFilePos((pos).file,cInput.cc); GetLexNumPos((pos).line,cInput.cc); GetLexNumPos((pos).coll,cInput.cc);}; } };
                goto nextYylex;
        }
        if (lex == 440 || lex == 441) {
                val=0;
                { if (lex > 438) { if ((lex==439 || lex==446 || lex==444)){ register char *tmpcc,tmpch; h = 0; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { h+=tmpch; h+=(h<<10); h^=(h>>6);}; } { h+=(h<<3); h^=(h>>11); h+=(h<<15);}; tmpcc ++; { GetLexFilePos((pos).file,tmpcc); GetLexNumPos((pos).line,tmpcc); GetLexNumPos((pos).coll,tmpcc);}; cInput.cc = tmpcc; } else if (lex == 442) { register char *tmpcc,tmpch; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; { GetLexFilePos((pos).file,tmpcc); GetLexNumPos((pos).line,tmpcc); GetLexNumPos((pos).coll,tmpcc);}; cInput.cc = tmpcc; } else if (lex == 443) { { line = *((unsigned char*)cInput.cc++); line += 256 * *((unsigned char*)cInput.cc++);}; if (macStacki == 0) { if(s_opt.debug) dpnewline(line); cFile.lineNumber += line; } } else if (lex == 440 || lex == 441 || lex == 445 || lex == 447) { { val = *((unsigned char*)cInput.cc++); val += 256 * *((unsigned char*)cInput.cc++); val += 256 * 256 * *((unsigned char*)cInput.cc++); val += 256 * 256 * 256 * *((unsigned char*)cInput.cc++);}; } } else if (lex>411 && lex<424) { { GetLexFilePos((pos).file,cInput.cc); GetLexNumPos((pos).line,cInput.cc); GetLexNumPos((pos).coll,cInput.cc);}; } else if (lex == '\n' && (macStacki == 0)) { if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else if (lex<448 && s_tokenHasPosition[lex]) { { GetLexFilePos((pos).file,cInput.cc); GetLexNumPos((pos).line,cInput.cc); GetLexNumPos((pos).coll,cInput.cc);}; } };
                sprintf(constant,"%d",val);
                uniyylval->integer = val;
                yytext = constant;
                goto finish;
        }
        if (lex == 442) {
                yytext = cInput.cc;
                { if (lex > 438) { if ((lex==439 || lex==446 || lex==444)){ register char *tmpcc,tmpch; h = 0; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { h+=tmpch; h+=(h<<10); h^=(h>>6);}; } { h+=(h<<3); h^=(h>>11); h+=(h<<15);}; tmpcc ++; { GetLexFilePos((pos).file,tmpcc); GetLexNumPos((pos).line,tmpcc); GetLexNumPos((pos).coll,tmpcc);}; cInput.cc = tmpcc; } else if (lex == 442) { register char *tmpcc,tmpch; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; { GetLexFilePos((pos).file,tmpcc); GetLexNumPos((pos).line,tmpcc); GetLexNumPos((pos).coll,tmpcc);}; cInput.cc = tmpcc; } else if (lex == 443) { { line = *((unsigned char*)cInput.cc++); line += 256 * *((unsigned char*)cInput.cc++);}; if (macStacki == 0) { if(s_opt.debug) dpnewline(line); cFile.lineNumber += line; } } else if (lex == 440 || lex == 441 || lex == 445 || lex == 447) { { val = *((unsigned char*)cInput.cc++); val += 256 * *((unsigned char*)cInput.cc++); val += 256 * 256 * *((unsigned char*)cInput.cc++); val += 256 * 256 * 256 * *((unsigned char*)cInput.cc++);}; } } else if (lex>411 && lex<424) { { GetLexFilePos((pos).file,cInput.cc); GetLexNumPos((pos).line,cInput.cc); GetLexNumPos((pos).coll,cInput.cc);}; } else if (lex == '\n' && (macStacki == 0)) { if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else if (lex<448 && s_tokenHasPosition[lex]) { { GetLexFilePos((pos).file,cInput.cc); GetLexNumPos((pos).line,cInput.cc); GetLexNumPos((pos).coll,cInput.cc);}; } };
                {uniyylval->position = pos;};
                goto finish;
        }
        if (lex == 427 || lex == 428) {
                yytext = "'fltp constant'";
                { if (lex > 438) { if ((lex==439 || lex==446 || lex==444)){ register char *tmpcc,tmpch; h = 0; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { h+=tmpch; h+=(h<<10); h^=(h>>6);}; } { h+=(h<<3); h^=(h>>11); h+=(h<<15);}; tmpcc ++; { GetLexFilePos((pos).file,tmpcc); GetLexNumPos((pos).line,tmpcc); GetLexNumPos((pos).coll,tmpcc);}; cInput.cc = tmpcc; } else if (lex == 442) { register char *tmpcc,tmpch; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; { GetLexFilePos((pos).file,tmpcc); GetLexNumPos((pos).line,tmpcc); GetLexNumPos((pos).coll,tmpcc);}; cInput.cc = tmpcc; } else if (lex == 443) { { line = *((unsigned char*)cInput.cc++); line += 256 * *((unsigned char*)cInput.cc++);}; if (macStacki == 0) { if(s_opt.debug) dpnewline(line); cFile.lineNumber += line; } } else if (lex == 440 || lex == 441 || lex == 445 || lex == 447) { { val = *((unsigned char*)cInput.cc++); val += 256 * *((unsigned char*)cInput.cc++); val += 256 * 256 * *((unsigned char*)cInput.cc++); val += 256 * 256 * 256 * *((unsigned char*)cInput.cc++);}; } } else if (lex>411 && lex<424) { { GetLexFilePos((pos).file,cInput.cc); GetLexNumPos((pos).line,cInput.cc); GetLexNumPos((pos).coll,cInput.cc);}; } else if (lex == '\n' && (macStacki == 0)) { if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else if (lex<448 && s_tokenHasPosition[lex]) { { GetLexFilePos((pos).file,cInput.cc); GetLexNumPos((pos).line,cInput.cc); GetLexNumPos((pos).coll,cInput.cc);}; } };
                goto finish;
        }
        if (lex == 447) {
                val=0;
                { if (lex > 438) { if ((lex==439 || lex==446 || lex==444)){ register char *tmpcc,tmpch; h = 0; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { h+=tmpch; h+=(h<<10); h^=(h>>6);}; } { h+=(h<<3); h^=(h>>11); h+=(h<<15);}; tmpcc ++; { GetLexFilePos((pos).file,tmpcc); GetLexNumPos((pos).line,tmpcc); GetLexNumPos((pos).coll,tmpcc);}; cInput.cc = tmpcc; } else if (lex == 442) { register char *tmpcc,tmpch; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; { GetLexFilePos((pos).file,tmpcc); GetLexNumPos((pos).line,tmpcc); GetLexNumPos((pos).coll,tmpcc);}; cInput.cc = tmpcc; } else if (lex == 443) { { line = *((unsigned char*)cInput.cc++); line += 256 * *((unsigned char*)cInput.cc++);}; if (macStacki == 0) { if(s_opt.debug) dpnewline(line); cFile.lineNumber += line; } } else if (lex == 440 || lex == 441 || lex == 445 || lex == 447) { { val = *((unsigned char*)cInput.cc++); val += 256 * *((unsigned char*)cInput.cc++); val += 256 * 256 * *((unsigned char*)cInput.cc++); val += 256 * 256 * 256 * *((unsigned char*)cInput.cc++);}; } } else if (lex>411 && lex<424) { { GetLexFilePos((pos).file,cInput.cc); GetLexNumPos((pos).line,cInput.cc); GetLexNumPos((pos).coll,cInput.cc);}; } else if (lex == '\n' && (macStacki == 0)) { if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else if (lex<448 && s_tokenHasPosition[lex]) { { GetLexFilePos((pos).file,cInput.cc); GetLexNumPos((pos).line,cInput.cc); GetLexNumPos((pos).coll,cInput.cc);}; } };
                sprintf(constant,"'%c'",val);
                uniyylval->integer = val;
                yytext = constant;
                goto finish;
        }
        { if (!(s_opt.taskRegime)) internalCheckFail("s_opt.taskRegime", "yylex.c", 2018);};
        if (s_opt.taskRegime == RegimeEditServer) {
                yytext = cInput.cc;
                { if (lex > 438) { if ((lex==439 || lex==446 || lex==444)){ register char *tmpcc,tmpch; h = 0; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc) { { h+=tmpch; h+=(h<<10); h^=(h>>6);}; } { h+=(h<<3); h^=(h>>11); h+=(h<<15);}; tmpcc ++; { GetLexFilePos((pos).file,tmpcc); GetLexNumPos((pos).line,tmpcc); GetLexNumPos((pos).coll,tmpcc);}; cInput.cc = tmpcc; } else if (lex == 442) { register char *tmpcc,tmpch; for(tmpcc=cInput.cc,tmpch= *tmpcc; tmpch; tmpch = *++tmpcc); tmpcc ++; { GetLexFilePos((pos).file,tmpcc); GetLexNumPos((pos).line,tmpcc); GetLexNumPos((pos).coll,tmpcc);}; cInput.cc = tmpcc; } else if (lex == 443) { { line = *((unsigned char*)cInput.cc++); line += 256 * *((unsigned char*)cInput.cc++);}; if (macStacki == 0) { if(s_opt.debug) dpnewline(line); cFile.lineNumber += line; } } else if (lex == 440 || lex == 441 || lex == 445 || lex == 447) { { val = *((unsigned char*)cInput.cc++); val += 256 * *((unsigned char*)cInput.cc++); val += 256 * 256 * *((unsigned char*)cInput.cc++); val += 256 * 256 * 256 * *((unsigned char*)cInput.cc++);}; } } else if (lex>411 && lex<424) { { GetLexFilePos((pos).file,cInput.cc); GetLexNumPos((pos).line,cInput.cc); GetLexNumPos((pos).coll,cInput.cc);}; } else if (lex == '\n' && (macStacki == 0)) { if (s_opt.debug) dpnewline(1); cFile.lineNumber ++; } else if (lex<448 && s_tokenHasPosition[lex]) { { GetLexFilePos((pos).file,cInput.cc); GetLexNumPos((pos).line,cInput.cc); GetLexNumPos((pos).coll,cInput.cc);}; } };
                if (lex == 444) {
                        testCxrefCompletionId(&lex,yytext,&pos);
                        while (inStacki != 0) popInclude();
                        goto endOfFile;
                }
        }
        goto endOfFile;
 finish:
        { if (s_opt.debug) {fprintf(dumpOut,"%s ",yytext);fflush(dumpOut);}};
        return(lex);
 endOfMacArg:
        { if (!(0)) internalCheckFail("0", "yylex.c", 2040);};
 endOfFile:
        if ((!((s_language & (4)) != 0)) && inStacki != 0) {
                popInclude();
                poseCachePoint(1);
                goto nextYylex;
        }
        return(0);
}
